///////////////////////////////////////////////////
//fantasyrts - Knights of Grumthorr 2 - Version 2.00
//Version 18-Mar-2021 - Matt Lloyd
///////////////////////////////////////////////////
//

﻿////////////////////////////////
//Fantasy RTS Engine - KOG2
//Matt Lloyd 2020/2021
//'Knights of Grumthorr - 2'
//
//1-Oct-2020 - Bug Fix - data/data2 with 'description='
//26-Oct-2020 - Bug Fix - Count Varna 700+ times on skirmish mode in report
//26-Oct-2020 - Enhancements - snow/desert mode, overrides for scenery, multiple factions possible now.
//1-Nov-2020 - Enhancements - override for rgbbk
//1-Nov-2020 - Enhancements - gui.txt file modified for simpler gui arrangement..less cluttered.
//1-Nov-2020 - Release Version 1.0
//24-Feb-2021 - Enhancements - greater modding capability and adjustments to gui things
//25-Feb-2021 - Enhancements - death animation support added, high rate of fire support added.
//25-Feb-2021 - Enhancements - better mod support.
//26-Feb-2021 - Enhancements relating to fog
//28-Feb-2021 - Enhancements - gui link better to missions
//28-Feb-2021 - Enhancements - playable faction specific to missions....
//28-Feb-2021 - Enhancements - added second idle animation
//28-Feb-2021 - Enhancements - more flexible image loading
//28-Feb-2021 - Enhancements - better mod support. 
//28-Feb-2021 - Bug Fix/Enhancements - better resource loading error handling.
//1-Mar-2021 - Enhancements - allow mission choice by name rather than index as well.
//2-Mar-2021 - Enhancements - map details (decor)
//5-Mar-2021 - Release Version 1.1
//7-Mar-2021 - Enhancements - "extraunits=" - to add more units without changing units.txt file
//7-Mar-2021 - Enhancements - new unit characteristics coded in, mob, animosity, hatred, craftsman, planar, slow, woodsman, stupidity, frenzy
//7-Mar-2021 - Bug Fix with decor
//9-Mar-2021 - Enhancements - formations, in-battle ui, 
//10-Mar-2021 - Enhancements - controllable spawners (choose what to build).
//11-Mar-2021 - Enhancements to gui and AI spawners...
//////////////////////////////////////////////////////////
//12-Mar-2021 - Enhancements Officially changed to Version 2.0, KoG2 - grumthorr2 as well.
//12-Mar-2021 - KOG2 maxmission defaults to 36 at the beginning.
//12-Mar-2021 - Planar Bug Fix - Shouldn't be able to build planar units at a builder (design decision)
//12-Mar-2021 - LocalStorage.getitem, LocalStorage.setitem
//12-Mar-2021 - Marked missions as complete or incomplete.
//13-Mar-2021 - Enhancements - Language Localisation Features
//15-Mar-2021 - Enhancements to handle Chinese text. Also shield added for defend units. And a bug fix for missing check on a -1 value for an array index (would never occur though).
//15-Mar-2021 - Bug Fix - Chinese Text was being truncated - this has now been fixed with a user defined variable 'fontwmultiplier' which should be 1 or greater or left unassigned.
//15-Mar-2021 - Bug Fix / Other - Removed Network commands and Bug fix for record=1 flag when quitting and thread running causing a crash..
//16-Mar-2021 - Fix for wmultiplier on Fonts. for ascii only strings.
//16-Mar-2021 - Released to Steam for build verification by Valve.
//17-Mar-2021 - Bug Fix for chinese Text - additional fix for wmultiplier for unicode fonts.
//17-Mar-2021 - Bug fix in TranslateWord returning "" instead of the word at times.
//18-Mar-2021 - Culture Info added ?
//19-Mar-2021 - Enhancement - spellcasters buff friendly units now.
//19-Mar-2021 - Re-Enabled Network Command
//20-Mar-2021 - Enhancement - armour/attack modifier (percentage multiplier) enabled via config file.
//20-Mar-2021 - Graphical Glitch fixed with Unit drawing...
//21-Mar-2021 - Added +/- and unit circles
//21-Mar-2021 - Enhancement - added custom scenarios via level editor to Game.
//21-Mar-2021 - Language Enhancement/Translation
//22-Mar-2021 - Bug Fix - scaling of sprites in Gui due to comma/period difference in region settings.
//22-Mar-2021 - Editor language allowed for, Selection indicator added. Pause with pause key on keyboard.
//23-Mar-2021 - Minor graphical glitch fixed. Trigger enhancements.
//24-Mar-2021 - Updated ALTMODE in Gui.ALTMODE to change more often. Improved Targeting.
//25-Mar-2021 - Threaded music loading....Trigger *ANY, *FRIEND, *ENEMY and CREATE and REMOVE
//26-Mar-2021 - Optimisation added (MAXINDEX)...to units and a few others.
//27-Mar-2021 - Bug Fix....
//Important note about the Bug fix on 27-Mar-2021
//The bug was introduced on 26-Mar-2021 when 'selectingtime' was added to the code
//This has now been altered so that the bug does not occur.
//That means the versions of the game released prior to 26-Mar-2021 were fine
//And now those released after are fine again too.
//27-Mar-2021 - Disabled Zoom. Adjusted WAITSELECTINGTIME from 30 to 6. Added Bullet.MAXINDEX = 0 on change gamestate. tmpbrave added...
//28-Mar-2021 - Translation Class optimised search by sorting based on length of string....(NOT IMPLEMENTED)
//28-Mar-2021 - Building spells in...minimap gui enhanced/bug fix, language reporting...
//30-Mar-2021 - added uid
//1-apr-2021 - tidied up web request. 
//2-apr-2021 - enhanced some graphical features....And After Action 10 minute Replay
//2-apr-2021 - Action Replay added at end of battle. (actually 3-apr, but code changes recorded as 2-Apr)
///////////////////////////////////////////
//7apr2021 - fixed Editor restart
//9apr2021 - new spells...
//11apr2021 - fixed some minor frame+id glitches, added extra altimage handling, some saving of seeds as an attempt to fix replay (didn't work)
//12-16apr2021 - various minor enhancements
//17apr2021 - moved clicker and targeticon into gui section without hardcoding their presence.
//17apr2021 - altered AI//hmultiplier
//18apr2021 - gamestate transitions implemented....fadeout/fadein added.
//19apr2021 - fixed glitch with editor trees...
//20apr2021 - toggle gui panels, auto calculate offy/offx
//24apr2021 - addressed spawner selection bug
//25apr2021 - addressed replay bug with onscreen feature, Translation binary search (in case list gets long)
//26apr2021 - enabled demo mode
//28apr2021 - pathfinding quick pathing added.
//2may2021 - note Matt - eventually ADD the following: Transforming Units, Flying Units including dual ground/air units and Transports. All are possible with simple changes/additions.
//3may2021 Transforming units added but not tested.....Transported units added but not tested also....
//4may2021 - adding flying units....
//6may2021 - added replay MAXLENGTH back in....
//22may2021 resizable window in windowed mode.....
//29may2021 - sprite rotations through directions takes time rather than instant
//29may2021 - multithreaded pathfinding
//2jun2021 - sprite batching in part.....
//12jul2021 - bound demon code added but not tested or used yet.
//28jul2021 - added deathfx code for sound effects....
//2sep2021 - minor addition - allowed shock to be specified in file instead of shocktrooper. Also allowed TITLE set in text file.
//2sep2021 - tech addition (large update) (seems complete sort of)....
//2sep2021 - bug fix - canflyandwalk units fixed...somewhat. transform bug fix also. transporting also works now.
//4sep2021 - bug fix with transporting units.
///////////////////////////////////////////
//9sep2021 - spawners can be constrained.
//10sep2021 - defaultgridw/h, and mission based gridw/h, trigger for chatter image....and audio, 
//10sep2021 - adding individual character names to units in the armies.
//12sep2021 - allow 'exit to mission name' via a trigger
//13sep2021 - bug fix with dead units (if dead animation present)
//14sep2021 - a few changes...
//15sep2021 - need los added
//////////////////////////////////
//Space Squad Began Here
//16sep2021 - NOSHOWABILITY added
//17sep2021 - added menu mini map feature.
//18sep2021 - various additions.
//19sep2021 - bug fix.
//////////////////////////////////
//Everything After 20 Sep Can be Ignored If Desired.
//////////////////////////////////
//6oct2021 - Added Campaign Map Stuff


using System;
using System.Diagnostics;
using System.Threading;
using System.Net; //15mar2021
using System.Net.Sockets;
using System.IO;
using System.Text;//13Mar2021//1apr2021
using System.Runtime.InteropServices;
using SDL2;
using System.Globalization;

namespace fantasyrts
{


///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Config
	{
		public static bool DEBUGCONSOLEMESSAGES = false;
		public static int MATCHSLOWEST = 0;
		public static int EVENTHEMUP = 1;
		public static long SYNCTIME = 300;//12oct2021
		public static long SPEEDCHECKTIME = 3000;//12oct2021
		public static string TAG = "GAME";
		public static string mapdatafile = "";//6oct2021
		public static int DEFAULTRESX = 1600;//23sep2021
		public static int DEFAULTRESY = 900;//23sep2021
		public static int NOUPDATEINDEMOMODE = 0;//18sep2021
		public static int USEDELTATIME = 0;//18sep2021
		public static int delta;//18sep2021
		public static int UNLOCKFRAMERATE = 0;//18sep2021
		public static int AUTOPLAY = 0;//18sep2021
		public static int NOSHOWABILITY = 0;//16sep2021
		public static int OPTIMISEFIRES = 0;//15sep2021
		public static int TILEFOG = 0;//15sep2021
		public static int CLUMP = 0;//15sep2021
		public static int NOREPLAY = 0;//15sep2021
		public static int FASTFRAMECHECK = 0;//14sep2021
		public static bool USETECH = true;//false;//2sep2021
		public static bool THREADEDPATHING = false;//29may2021
		public static bool SLOWROTATE = true;//29may2021
		public static int WINDOWRESIZE = 0;//22may2021
		public static bool ALLOWFLYING = true;//4may2021 //flag while debugging...will set to true later....
		public static bool FREEDEMO = false;
		public static int freedemo = 60 * 60 * 10;//26apr2021
		public static bool AUTOCALCOFFSETS = false;//20apr2021
		public static uint FRAMETIME = 15;//18apr2021
		public static bool BLOCKPRECALC = true;//11apr2021
		public static bool ALLOWREPLAY = true;//2apr2021 
		public static bool GETDATA = false;//1apr2021
		public static string autodetectlang = "";//30mar2021
		public static string uid = "1234";//30mar2021
		public static bool DEBUG = false; //23mar2021 moved up here from below...
		public static bool NOMETRICS = false;//remember to change this appropriately...
		public static bool TRANSLATEGUI = true;//21mar2021
		public static bool USEICONCIRCLES = false;//21mar2021
		public static bool USECOVERFLAG = false;//21mar2021
		public static bool USEFEETCIRCLES = false;//21mar2021
		public static int ARMOURPCT = 100;//20mar2021
		public static int ATTACKPCT = 100;//20mar2021
		public static int HEALTHPCT = 100;//20mar2021
		public static bool useUNICODE = false; //ml15mar2021
		public static bool bestiarychk = false; //5apr2021
		public static bool KOG2 = true;
		public static bool RECORD = false; 
		public static bool STREAMLOAD = true; //28Feb2021
		public static bool STREAMLOADAUDIO = false;//25mar2021
		public static int USEHEIGHTS = 0;
		public static bool DODEBRIEF = true;
		public static bool TESTDEBRIEF = false;
		public static bool USEPATHFILE = false;
		public static int FACTOR = 3; //determines size of armies and so on.....10 seems to be about sufficient for the game to run very well still with lots of units on the map.
		public static int NORMALSPEED = 10;//23mar2021 (not used yet...)
		public static int LOWSPECSPEED = 6;//23mar2021 (not used yet...)
		public static string configfile; //28Feb2021
		public static string guifile;
		public static string campaignfile;
		public static string customcampaignfile;
		public static string unitsfile;
		public static string wordsfile = ""; //13mar2021
		public static string techfile = "";//2sep2021
		public static string defaultfontfile;
		public static int largefontsize;
		public static int smallfontsize;
		public static int normalfontsize;
		public static string audioclickfile;
		public static string offsetfile = "";//20apr2021
		public static bool FINISHEDOFFSETS = false;//20apr2021
		public static string logofile;
		public static string fogfile;
		public static int logowidth;
		public static int logoheight;
		public static int fogwidth;
		public static int fogheight;
		public static int hires = 0;
		public static string custommapfolder;
		public static string usercampaignfolder = "";
		public static string usercampaignfile = "";
		public static string custommapprefix = "custom_";
		public static string skirmishmessage = "Take control of the portals to spawn units.|Eliminate the enemy.";
		public static int FONTALIAS = 4;
		public static long precalcused = 0;
		public static long seekpathused = 0;
		public static long seekpathfailed = 0;
		public static long seekpathsuccess = 0 ;
		public static long maxbmenutime = 0;
		public static long maxumusictime = 0;
		public static long maxmapupdatepostime = 0;
		public static long maxmapcorrecttime = 0;
		public static long maxmaperrors = 0;
		public static long maxunitupdatetime = 0;
		public static long maxbullettime = 0;
		public static long maxbloodtime = 0;
		public static long maxselecttime = 0;
		public static long maxtriggertime = 0;
		public static long maxdrawtime = 0;
		public static long maxanimate = 0;
		public static long maxwalk = 0;
		public static long maxupdate = 0;
		public static long maxatt = 0;
		public static long[] totrtime = new long[600];
		public static long[] totutime = new long[600];
		public static long sumr = 0;
		public static long sumu = 0;
		public static long UTIMELOW = 800;
		public static long RUNNINGSPEED = 0;
		public static long runningspeed = 0;
		public static bool loaded = false;
		public static int loadpct = 0;
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
class Game
{
	public static int trainai = 0;//20oct2021
	public static int difficulty = 0;//20oct2021
	public static int LocalPlayerIndex = -1;//18oct2021
	public static int LocalEnemyIndex = -1;//18oct2021
	public static int spellcast = 0;//18oct2021
	
	public static int winloss = 0;//17oct2021
	public static int battlespeed = 1;//16oct2021
	
	public static void WriteDebug(string txt)
	{
		if(Config.DEBUGCONSOLEMESSAGES)
		{
			string preamble = "";
			try
			{
				StackFrame callstack = new StackFrame(1, true);
				int line = callstack.GetFileLineNumber();
				string method = callstack.GetMethod().Name;
				preamble = "Method:"+method+" Line:"+ line+" Error:";
				txt = preamble + txt;
			}
			catch(Exception e)
			{
				//do nothing
				string junk = e.Message;
			}
			Console.WriteLine(txt);
		}
	}

	public static int throttleframerate = -1;
	
	public static long currentTimeMillis()
	{
		return (long)RenderList.renderframe * 15;
	}

	public static string toasttxt = "";
	public static long toasttime = 0;
	
	public static void newtoast(string txt)
	{
		toasttxt = txt;
		toasttime = Game.currentTimeMillis() + 3500;
	}
	
	public static void drawtoast()
	{
		if(toasttxt==null)
		{
			return;
		}
		if(Game.currentTimeMillis()<toasttime)
		{
			RenderList.drawrect(null,Game.RESOLUTIONX/2 - 400,Game.RESOLUTIONY - 75,800,50,RenderList.getrgb(24,24,32),0);
			RenderList.drawtext(null,Game.RESOLUTIONX/2,Game.RESOLUTIONY - 50,toasttxt,RenderList.getrgb(255,255,255),Game.fonts[Resources.FONT].font,true); 
		}
	}
	
	public static bool battleover = false;
	public static long battleovertime = 0;
	
	
public static string edittriggerstring;
public static string NETTITLE = "grumthorr";
public static string TITLE = "Knights of Grumthorr";
public static string AUTHOR = "Matt Lloyd";
public static string MUSIC = "Eric Matyas, soundimage.org";
public static string YEAR = "2021";
public static string VERSION = "2.00";
public static int VERSIONINT = 200;
public static string VERSIONSTR = "20210928"; //14apr2021(and subsequent)
//
public static bool restart = false;//13mar2021
public static IntPtr renderer;
public static IntPtr window;
public static IntPtr screen; 
public static bool takepicture;
//public int recordframe;
public static bool running = true;
//for screenshots.....
//unsafe takepicture Pointer
//
public static bool EDITOR = false;
public static int EDITED = -1; //7apr2021
public static RenderList[] renderlist;
public static Replay[] replay;//2apr2021
public static Images[] images; 
public static Fonts[] fonts;
public static Audios[] audios;
//public static long killcount; //13mar2021
public static int killcount; //13mar2021
//
public static Map map;
public static Unit[] units;
public static Unit[] templates;
public static Mission[] missions;
public static Tech[] techs;//2sep2021
//public Mission tutorial;
public static int missionid;
public static int nextmissionid;
public static int failedmissionid;
public static Gui[] gui;
public static Bullet[] bullets;
public static Trigger[] triggers;
public static Blood[] blood;
public static Gibbet[] gibbet; //2apr2021
//
//
public static int neutralfog = 0; //26Feb2021
public static int fogoff = 0; //26Feb2021
//
public static int topmissionindex = 0;
public static int previousmissionindex = -1;//2apr2021
public static int chosenmissionindex = -1;
public static int ochosenmissionindex = -1;//17sep2021
public static int maxmission = 1;
public static int overridemaxmission = 0;//13sep2021
public static int countcustoms = 0;
//
public static int SW;
public static int SH;
public static int frame;
public static int gamestartframe;//2apr2021
//
public static  int mx;
public static int my;
public static  int rmx;//21apr2021
public static  int rmy;//21apr2021
public static  int wmx;//21apr2021
public static  int wmy;//21apr2021
public static int RCORNERX;//21apr2021
public static int RCORNERY;//21apr2021
public static int TMPCORNERX;//21apr2021
public static int TMPCORNERY;//21apr2021
public static int omx;
public static int omy;
public static int smx;
public static int smy;
public static int fmx;
public static int fmy;
public static bool mlclick;
public static bool mldown;
public static int minimappressed;
public static bool mrclick;
public static int mlclickframe;
public static bool mrdown;
public static int mwheel;
public static float zoom;
public static int zoomcornerx;
public static int zoomcornery;
public static bool paused;
public static int minimapframe;
public static bool demomode;
public static int checksum;//2apr2021
public static int ordergivenframe;
public static int EXTRAPATHINGTIME = 60 * 4;
public static int leftcontrolkey = 0;
public static int[] numberkeys = new int[10];
public static int[] numberkeysframe = new int[10];
public static bool SPAWNERSELECTED = false; //10mar2021
public static bool NONSPAWNERSELECTED = false;//11mar2021
public static int SPELLCASTERSELECTED = -1;//28mar2021
public static int SPELLCASTERLEVEL = 0;//28mar2021
public static bool SPELLSACTIVE = true;//false;//28mar2021
public static int EDITMODE_TREE = 1;
public static int EDITMODE_ROCK = 2;
public static int EDITMODE_WALL = 3;
public static int EDITMODE_UNIT = 0;
public static int EDITMODE_TRIGGER = 4;
public static int EDITMODE_ENTERTEXT = 5; //from triggers....
public static int EDITMODE_HEIGHT = 6;
public static int EDITMODE;
public static int editgridx;
public static int editgridy;
public static int editindex;
public static string editname;
public static int editkeypressed = 0;
public static int recordkeypressed = 0;
public static int backupkeypressed = 0;
public static string edittriggerString = "";
public static bool editshiftheld = false;
//
public static int FULLSCREEN = 0;
public static int FXVOLUME = 100;
public static int MUSICVOLUME = 100;
public static int oFXVOLUME = 100;
public static int oMUSICVOLUME = 100;
//
public static int RESOLUTIONX;
public static int RESOLUTIONY;
public static int FRAMERATE;
public static bool NODELAY = true;
//
public static int CORNERX = 0;
public static int CORNERY = 0;
public static int oCORNERX = 0;//22sep2021
public static int oCORNERY = 0;//22sep2021
public static int CORNERSPEED = 5;
public static int CORNEREDGEDIST = 50;
public static int LOCKCORNER = 0;
public static int HORIZONTALFORMATION = 0; //14apr2021
public static int VERTICALFORMATION = 0; //14apr2021
//
//
public static int gamestate;
public static int oldgamestate;
public static int newgamestate;
public static int restartgamestate; //26mar2021
public static int selectingtime;//26mar2021
public static int WAITSELECTINGTIME = 6;//26mar2021
public static bool playerready;
public static bool skirmish;
public static bool onscreen;
public static bool victorymessage;
public static bool playingtutorial;
public static int CAT_GAMESTATE_LOGO = 0;
public static int CAT_GAMESTATE_MENU = 10;
public static int CAT_GAMESTATE_NEWCONTINUE = 20;
public static int CAT_GAMESTATE_GAME = 1000;
public static int CAT_GAMESTATE_DEBRIEF = 999;
public static int CAT_GAMESTATE_DEBRIEF2 = 998;
public static int CAT_GAMESTATE_REPLAY = 997; //2apr2021
public static int CAT_GAMESTATE_MATCH_PLAY = 1000;
public static int CAT_GAMESTATE_STARTLEVEL = 1050;
public static int CAT_GAMESTATE_GAMEOVER = 1100;
public static int CAT_GAMESTATE_NEWLEVEL = 1200;
public static int CAT_GAMESTATE_ENDLEVEL = 1300;
public static int CAT_GAMESTATE_GUIMENUS = 10000;
//
public static int PLAYERFACTION = 0;
public static int SKIRMISHENEMYFACTION = 0;
public static int EDITORPFACTION = 0; //22mar2021
public static int EDITOREFACTION = 0; //22mar2021
public static int GAMEENDSTATE = 0;
public static int GAMEENDSTATE_VICTORY = 1;
public static int GAMEENDSTATE_DEFEAT = 2;
public static int MAXFACTIONS = 16;
//
public static int gameovertime;
//
public static int healthbar = -1;
public static int whiteflag = -1;
public static int battleicon = -1;//16oct2021
public static int holyaura = -1;//26sep2021
public static int forceshield = -1;//26sep2021
public static int bladebarrier = -1;//26sep2021
public static int charmperson = -1;//26sep2021
public static int shadowup = -1;//15sep2021
public static int shadowleft = -1;//15sep2021
public static int shadowright = -1;//15sep2021
public static int shadowoffy = -1;//15sep2021
public static int shadowoffx = -1;//15sep2021
public static int shield = -1; //15mar2021
public static int lightning = -1;//28mar2021
public static int whirlwind = -1;//28mar2021
public static int targeticon = -1;//16apr2021
public static int spellball = -1;//12apr2021
public static int clicker = -1;//15apr2021
public static int clickerframe = -1;//15apr2021
public static int clickerrow = 0;//15apr2021
public static int clickerx = 0;//15apr2021
public static int clickery = 0;//15apr2021
public static int BLUEBALL = 0;
public static int GREENBALL = 1;
public static int PURPLEBALL = 2;
public static int ORANGEBALL = 3;
public static int REDBALL = 4;
public static bool audioon;
public static int iconplus = -1;//21mar2021
public static int iconminus = -1;//21mar2021
public static int iconcircles = -1;//21mar2021
public static int groupselected = -1;//21mar2021
public static bool showingselectedicons = false; //22mar2021
public static bool togglepause = false;//22mar2021
public static int mouseoverunitid = -1;
public static bool anyselected = false;//16apr2021
public static int formation = 0;//2apr2021
public static int ai_direction = 0;//17apr2021
public static int[] newtrees;//24apr2021
public static int totalscore = 0;//18sep2021
public static int maxtotalscore = 0;//18sep2021
public static bool scoredirty = true;//18sep2021
public static bool musicdirty = true;//18sep2021
public static int QUALITY = 1;//20sep2021
public static bool LETTERBOX = false;//21sep2021
//
//
public static int GUIHALFRES = 1;//25sep2021
//


//miscellaneous audio files...26sep2021
public static int snd_pickup = 0;
public static int snd_levelup = 0;
public static int snd_battle = 0;
//sound info
public static long snd_battle_time = 0;
public static int snd_battle_channel = 0;

//miscellaneous
public static int gui_founditem = -10010;
public static int gui_charactersheet = -10011;
public static bool debugcheat = false;
public static int debugcount = 0;

public static int gamemode = 0;
public static int MODE_DEPLOY = 0;
public static int MODE_ORDER = 1;
public static int MODE_BATTLE = 2;
public static int MODE_MOVING = 3;
public static int movingtime = 0;
public static int MOVINGLENGTH = 35 * 1;
public static int battletime = 0;
public static int BATTLELENGTH = 75 * 2;
public static int templateindex = -1;
public static int firstcell = -1;
public static int secondcell = -1;
public static int CELLSIDE = -1;
public static int ARCHERS = -1;
public static int BOARDY = 100;//
public static int RESOLVE = 0;
public static string OldEnemyArmy = "Red";
public static string EnemyArmy = "Red";
public static string OldFriendArmy = "Blue";
public static string FriendArmy = "Blue";
public static string PlayerArmy = "Blue"; //for campaign//8oct2021
public static int EnemyIndex = 0;
public static int FriendIndex = 1;
public static int PlayerIndex = FriendIndex;//8oct2021//campaign
public static int MaxArmies = 6;
public static int NOLOAD = 0;
////////CAMPAIGN SINGLE PLAYER STUFF////////8oct2021
public static int numattacks = 0;//8oct2021
public static int numelements = 0;
public static int numenemyelements = 0;
public static int campaignmode = 0;
public static int oldcampaignmode = 0;
public static int oldcampaignmode2 = 0;
public static int campaignattackx = -1;
public static int campaignattacky = -1;
public static int campaignattackprovince = -1;
public static int campaignpcx = -1;
public static int campaignpcy = -1;
public static bool campaignpcclick = false;
public static int CAMPAIGNSTATE = 0;
public static int THINKING = 0;
public static long toolongthinking = 0;
public static int firsttouch = 0;
public static long guitime = 0;
public static int oldboardx = -1;
public static int oldboardy = -1;
public static int oldtemplateindex = 0;
public static int startingnumelements = 5;
public static int LOWONMEMORY = 0;
public static int vsai = 0;
public static string aiscore = "";
public static string multiplayerip = "";
public static int showkeyboard = 0;
public static int attackingplayer = -1;
public static int numfhero = 0;//13oct2021
public static int numehero = 0;//13oct2021
		//

///////////////////Method Definition///////////////
		public Game(IntPtr r) 
		{
			////////////////////////
			//primary initialisation
			gamestate = Game.CAT_GAMESTATE_LOGO;
			renderlist = new RenderList[0];
			images = new Images[0];
			fonts = new Fonts[0];
			audios = new Audios[0];
			replay = new Replay[0];//2apr2021
			newtrees = new int[0];//24apr2021
			renderer = r;
			frame = 0;
			mx = 0;
			my = 0;
			omx = 0;
			omy = 0;
			mlclick = false;
			mldown = false;
			mrclick = false;
			mrdown = false;
			Game.audioon = true;
			//Game.NODELAY = true;
			//start--------------//13mar2021
			units = new Unit[0];
			templates = new Unit[0];
			missions = new Mission[0];
			techs = new Tech[0];//2sep2021
			gui = new Gui[0];
			bullets = new Bullet[0];
			triggers = new Trigger[0];
			blood = new Blood[0];
			topmissionindex = 0;
			chosenmissionindex = 0;
			ochosenmissionindex = -1;//17sep2021
			maxmission = 1;
			countcustoms = 0;
			leftcontrolkey = 0;
			numberkeys = new int[10];
			numberkeysframe = new int[10];
			SPAWNERSELECTED = false; //10mar2021
			NONSPAWNERSELECTED = false;//11mar2021
			healthbar = -1;
			whiteflag = -1;
			battleicon = -1;//16oct2021
			shadowleft = -1;//15sep2021
			shadowup = -1;//15sep2021
			shadowright = -1;//15sep2021
			shadowoffx = -1;//15sep2021
			shadowoffy = -1;//15sep2021
			shield = -1;
			spellball = -1;//12apr2021
			whirlwind = -1;//28mar2021
			targeticon = -1;//16apr2021
			clicker = -1;//15apr2021
			lightning=-1; //28mar2021
			iconplus = -1; //21mar2021
			iconminus = -1; //21mar2021
			iconcircles = -1; //21mar2021
			gamemode = 0;
			MODE_DEPLOY = 0;
			MODE_ORDER = 1;
			MODE_BATTLE = 2;
			MODE_MOVING = 3;
			movingtime = 0;
			MOVINGLENGTH = 35 * 1;
			battletime = 0;
			BATTLELENGTH = 75 * 2;
			templateindex = -1;
			firstcell = -1;
			secondcell = -1;
			CELLSIDE = -1;
			ARCHERS = -1;
			BOARDY = 100;//
			RESOLVE = 0;
			OldEnemyArmy = "Red";
			EnemyArmy = "Red";
			OldFriendArmy = "Blue";
			FriendArmy = "Blue";
			EnemyIndex = 0;
			FriendIndex = 1;
			MaxArmies = 6;
			NOLOAD = 0;

			Resources.blackcat = -1;//18apr2021//minor bug fix
			Map.init();
			//end----------------//13mar2021
			initgame();
		}

///////////////////Method Definition///////////////
		public static void killed(Game game,int i)
		{
			////////////////////////
			//this method handles the elimination of units from the Game.
			//when a unit's hp goes to zero this method ought to be called.
			//it sets the animation mode to the death animation if any exists
			//and handles the removing of the body from the map and so forth
			//start-----------//25Feb2021
			bool gibbets = false;
			if(units[i].isdead<2)
			{
				units[i].isdead=1;
				units[i].hp = units[i].basehp;
				return;
			}
			if(units[i].isdead==2)
			{
				units[i].hp = 0;
				units[i].isdead = 0;
			}
			//start-----------//4may2021
			if(units[i].flightlevel!=-1)
			{
				Map.removeflyer(i,units[i].x,units[i].y,units[i].flightlevel);
				units[i].flightlevel = -1;
			}
			//end-------------//4may2021
			if(units[i].animmode!=Unit.ANIMMODE_DEAD)
			{
				int gb = Functions.rand(0,(Gibbet.GIBMOD + 1));//17sep2021
				//if(units[i].animmodedeadframeend>0)//17sep2021
				if(units[i].animmodedeadframeend>0 && gb <= (Gibbet.GIBMOD + 1)/2)//17sep2021
				{
					units[i].animmode = Unit.ANIMMODE_DEAD;
					return;				
				}
				else//2apr2021
				{
					Gibbet.GIBCOUNTER++;
					if((Gibbet.GIBCOUNTER % Gibbet.GIBMOD)==0)
					{
						Gibbet.makegibbets(game,i);
						gibbets = true;
					}
				}
			}
			else
			{
				if(units[i].animframe < units[i].animmodedeadframeend)
				{
					return;
				}
			}
			//end-------------//25Feb2021
			units[i].playdeathsound(game,i); //28jul2021
			if(units[i].zombie<=0)//14oct2021
			{
				Map.addbones(units[i].x,units[i].y);
			}
			if(units[i].lightningdeath>0)//19oct2021
			{
				Unit.LightningDeath(units[i].x,units[i].y,units[i].lightningdeath);//19oct2021
			}
			Game.templates[units[i].templateid].deaths++;
			Map.removeunit(i,units[i].x,units[i].y);
			if(units[i].retreat==false)
			{
				if(!gibbets)
				{
					Blood.makeblood(game,units[i].x,units[i].y+units[i].offy,(int)Functions.sign(units[i].zombie));
					if(units[i].bossmonster>0)
					{
						for(int j=0;j<4;j++)
						{
							Blood.makeblood(game,units[i].x+(int)Functions.rand(-Map.GRIDW/2,Map.GRIDW/2),units[i].y+units[i].offy+(int)Functions.rand(-Map.GRIDH/2,Map.GRIDH/2),0);
						}
					}
				}
			}
			Game.killcount++;
		}
		private void initgame()
		{
		}

///////////////////Method Definition///////////////
		public static void quit()
		{
			////////////////////////
			//finalisation of the game upon exiting the main loop
			//handles removing all textures and sounds
			
			Game.running = false;
			try//13mar2021 added try catch
			{
				for(int i=0;i<images.Length;i++)
				{
					if(images[i].texture!=IntPtr.Zero && images[i].loaded==true) //28Feb2021
					{
						LocalStorage.setitem("FREE IMAGE:"+images[i].file,"FAILED"); //24mar2021
						SDL.SDL_DestroyTexture(images[i].texture);
						LocalStorage.setitem("FREE IMAGE:"+images[i].file,"SUCCESS"); //24mar2021
					}
				}
				for(int i=0;i<fonts.Length;i++)
				{
					LocalStorage.setitem("FREE FONT:"+fonts[i].file,"FAILED"); //24mar2021
					SDL_ttf.TTF_CloseFont(fonts[i].font);
					LocalStorage.setitem("FREE FONT:"+fonts[i].file,"SUCCESS"); //24mar2021
				}
				for(int i=0;i<audios.Length;i++)
				{
					if(audios[i].audio==IntPtr.Zero)//10sep2021
					{
						continue;//10sep2021
					}
					LocalStorage.setitem("FREE AUDIO:"+audios[i].file,"FAILED"); //24mar2021
					if(audios[i].ismusic)
					{
						SDL_mixer.Mix_FreeMusic(audios[i].audio);
					}
					else
					{
						SDL_mixer.Mix_FreeChunk(audios[i].audio);
					}
					LocalStorage.setitem("FREE AUDIO:"+audios[i].file,"SUCCESS"); //24mar2021
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error on exit:"+e.Message);
				//LocalStorage.WriteLog("Error on exit:"+e.Message);
			}
			try
			{
				NetworkUDP.EXITSIGNAL = 1;
				NetworkUDP.socket.close();
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error:"+e.Message);
			}
		}

///////////////////Method Definition///////////////
		public static void clearkeys()
		{
			////////////////////////
			//reset the key state of the number keys and left control key
			Game.leftcontrolkey = 0;
			for(int i=0;i<10;i++)
			{
				Game.numberkeys[i] = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void getmouse()
		{
			////////////////////////
			//get the mouse coordinates, and the click states
			//and also the drag select coordinates
			uint mouse = SDL.SDL_GetMouseState(out mx,out my);
			mlclick = false;
			mrclick = false;
			//exitclick = false;//2apr2021
			if(mouse==SDL.SDL_BUTTON(SDL.SDL_BUTTON_LEFT))
			{
				mldown = true;
				//exitdown = true;//2apr2021
			}
			else
			{
				if(mldown)
				{
					mlclick = true;
				}
				//if(exitdown)
				//{
				//	exitclick = true;
				//}
				mldown = false;
				//exitdown = false;//2apr2021
			}
			if(mouse==SDL.SDL_BUTTON(SDL.SDL_BUTTON_RIGHT))
			{
				mrdown = true;
			}
			else
			{
				if(mrdown)
				{
					mrclick = true;
				}
				mrdown = false;
			}
			if(SH>0 && SW>0)
			{
				float gxscale =  (float)Game.RESOLUTIONX/ (float)SW;
				float gyscale =  (float)Game.RESOLUTIONY/ (float)SH;
				mx = (int)((float)mx*gxscale);
				my = (int)((float)my*gyscale);
				//exitmx = mx; //2apr2021
				//exitmy = my; //2apr2021
				rmx = mx; //21apr2021
				rmy = my; //21apr2021
				wmx = mx; //21apr2021
				wmy = my; //21apr2021
			}
			if(mldown==false)
			{
				smx = mx;
				smy = my;
			}
			else
			{
				fmx = mx;
				fmy = my;
			}	
			//if(!Replay.PLAYBACK)
			//{
			//	exitclick = false;
			//	exitdown = false;
			//}
		}
	}
	//
	//start-------------//28Feb2021

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class StreamResources
	{
		public static int TOLERANCE = 60 * 5;
		public static int SHORTTOLERANCE = 60 * 5;
		public static int LONGTOLERANCE = 60 * 60;
		public static int STARTTOLERANCE = 60 * 15;
		public static bool threadrunning = false;//25mar2021
		public static Audios audio = null;
		
///////////////////Method Definition///////////////
		public static void streamloadhelper(Game game)
		{
			////////////////////////
			//handles loading of resources during the game
			//and also freeing the resources
			//manages them so that we do not hog memory with
			//graphics that are unecessarily being kept when not in use for long periods
			if(!Config.STREAMLOAD)
			{
				return;
			}
			//start------------//25mar2021
			if(threadrunning==false && Config.STREAMLOADAUDIO==true)
			{
				for(int i=0;i<Game.audios.Length;i++)
				{
					if(Game.audios[i].audio==IntPtr.Zero && Game.audios[i].ismusic==true)
					{
						threadrunning = true;
						audio = Game.audios[i];
						Thread thread = new Thread(new ThreadStart(ThreadFunction));
						thread.Start();	
						break;
					}
				}
			}
			//end--------------//25mar2021
			for(int i=0;i<Game.images.Length;i++)
			{
				//start-----//18apr2021
				//if(i==Resources.blackcat)
				//{
				//	continue;
				//}
				//end-------//18apr2021
				if(Game.images[i].texture!=IntPtr.Zero)
				{
					Game.images[i].okloaded = true;
				}
				if(Game.frame - Game.images[i].drawframe > TOLERANCE)// && Game.frame > STARTTOLERANCE)
				{
					//if(Game.gamestate!=Game.CAT_GAMESTATE_GAME)//2apr2021
					if(Game.gamestate!=Game.CAT_GAMESTATE_GAME && Game.gamestate!=Game.CAT_GAMESTATE_REPLAY)//2apr2021
					{
						Resources.FreeImage(game,i);
					}
				}
				else
				{
					if(Game.images[i].loaded == false && Game.images[i].texture==IntPtr.Zero && (Game.images[i].okloaded==true || Game.images[i].neverloaded==true))
					{
						Game.images[i].texture = SDL_image.IMG_LoadTexture(Game.renderer,Game.images[i].file);
						if(Game.images[i].texture!=IntPtr.Zero)
						{
							Game.images[i].loaded = true;
							Game.images[i].okloaded = true;
							Game.images[i].neverloaded = false;
							LocalStorage.setitem("FILE LOAD:"+Game.images[i].file,"LOADED");//24mar2021
						}
						else //24mar2021
						{
							LocalStorage.setitem("FILE LOAD:"+Game.images[i].file,"FAILED TO LOAD");//24mar2021
						}
					}
				}
			}
		}
		private static void ThreadFunction()
		{
			if(audio.file!="" && audio.file!=null)//28Feb2021
			{
				audio.audio = SDL_mixer.Mix_LoadMUS(audio.file);
			}
			if(audio.audio==IntPtr.Zero)
			{
				Game.WriteDebug("Could Not Load Music:"+audio.file+". Error:"+SDL.SDL_GetError());
				Network.reporterror("MusicLoadFailure:"+audio.file,false);//15mar2021
				LocalStorage.setitem("FILE LOAD:"+audio.file,"FAILED TO LOAD"); //24mar2021
			}
			else //24mar2021
			{
				LocalStorage.setitem("FILE LOAD:"+audio.file,"LOADED"); //24mar2021
			}
			threadrunning = false;
		}
	}
	//end---------------//28Feb2021

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Resources
	{
		//
		//put all resource names in here.....
		public static int LOGO = 0;
		public static int FONT = 0;
		public static int SMALLFONT = 0;
		public static int LARGEFONT = 0;
		public static int FOG = 0;
		public static int CLICK = 0;
		public static int blackcat = -1;
		//public static int loadingbk = -1; //27mar2021
		//public static int loadingbar = -1;//27mar2021
		//temporarily do this
		//start-------------//28Feb2021

///////////////////Method Definition///////////////
		public static bool readbool(string data)
		{
			////////////////////////
			//takes a string that contains 'true' or 'false' and returns a bool value
			//string is form left identifier=right value
			//swapped if statements around 12sep2021
			if(data.Substring(data.IndexOf("=") + 1)=="false")//this was below the other if block earlier//12sep2021
			{
				return false;
			}
			else
			{
				if(data.Substring(data.IndexOf("=") + 1)=="true")
				{
					return true;
				}
			}
			int i;
			Int32.TryParse(data.Substring(data.IndexOf("=") + 1),out i);
			if(i<=0)
			{
				return false;
			}
			else
			{
				if(i>0)
				{
					return true;
				}
			}
			return false; //have to return something by default...so make it false by default....
		}
		//end---------------//28Feb2021

///////////////////Method Definition///////////////
		public static uint readuint(string data)//2apr2021
		{
			uint i;
			UInt32.TryParse(data.Substring(data.IndexOf("=")+1),out i);
			return i;
		
		}
		
///////////////////Method Definition///////////////
		public static int readint(string data)
		{
			//takes a string that contains an int, with no commas or period symbols
			//and converts to an integer.
			//string is of form left identifier=right value
			int i;
			Int32.TryParse(data.Substring(data.IndexOf("=") + 1),out i);
			return i;
		}

///////////////////Method Definition///////////////
		public static float readfloat(string data)
		{
			//takes a string in 100.01 format (ie one hundred point oh-one)
			//and returns the float value
			//string is of form left identifier=right value
			
			float i;
			try
			{
				System.Globalization.NumberStyles style = System.Globalization.NumberStyles.AllowDecimalPoint; //22mar2021
				CultureInfo culture = CultureInfo.CreateSpecificCulture("en-US"); //22mar2021
				if(!Single.TryParse(data.Substring(data.IndexOf("=") + 1),style,culture,out i)) //22mar2021
				{
					Game.WriteDebug("Error reading float:"+data);
					i = 1.0f;
					LocalStorage.setitem("READ FLOAT:"+readstring(data),"FAILED 1");//24mar2021
				}
				else
				{
					LocalStorage.setitem("READ FLOAT:"+readstring(data),"SUCCESS");//24mar2021
				}
			}
			catch(Exception e)
			{
				i = 1f;
				Game.WriteDebug("Error reading float:"+e.Message);
				LocalStorage.setitem("READ FLOAT:"+readstring(data),"FAILED 2");//24mar2021
			}
			return i;
		}

///////////////////Method Definition///////////////
		public static string readstring(string data)
		{
			//simply returns a string from a line that looks like x=abc
			//ie left identifier=right value
			return data.Substring(data.IndexOf("=") + 1);
		}
	
///////////////////Method Definition///////////////
		public static void AssignOffsets(Game game,string file)//20apr2021
		{
			if(file=="")
			{
				return;
			}
			try
			{
				string[] data = System.IO.File.ReadAllLines(file);
				for(int i=0;i<data.Length;i++)
				{
					if(data[i].IndexOf("=")>0)
					{
						switch(data[i].Substring(0,data[i].IndexOf("=")))
						{
							case "image":
								string value = readstring(data[i]);
								string[] values = value.Split(",");
								if(values!=null)
								{
									if(values.Length==3)
									{
										string tmpname = values[0];
										int offx = 0;
										int offy = 0;
										Int32.TryParse(values[1],out offx);
										Int32.TryParse(values[2],out offy);
										for(int j=0;j<Game.templates.Length;j++)
										{
											if(Game.templates[j].catfile==tmpname)
											{
												Game.templates[j].offx = offx;
												Game.templates[j].offy = offy;
												Game.templates[j].autocalcedoffsets = true;
											}
										}
									}
								}
							break;
						}
					}
				}
			}
			catch(Exception e)
			{
				string msg = e.Message;
			}
		}
		
		
///////////////////Method Definition///////////////
		public static void LoadGui(Game game, string file)
		{
			////////////////////////
			//load the gui elements into the Game.gui array
			//so that we can reference them later on
			int alti = 0;//11apr2021
			try
			{
				string[] data = System.IO.File.ReadAllLines(file);//13mar2021
				//string[] data = System.IO.File.ReadAllLines(file,System.Text.Encoding.UTF8);//13mar2021
				int count = 0;
				for(int i=0;i<data.Length;i++)
				{
					if(data[i].IndexOf("=")>0)
					{
						switch(data[i].Substring(0,data[i].IndexOf("=")))
						{
							case "newgui":
							count++;
							break;
						}
					}
				}
				if(count>0)
				{
					Game.gui = new Gui[count];
					int id = -1;
					int cw = 0;
					int ch = 0;
					int nw = 0;
					int nh = 0;
					int factionindex = 0;//16oct2021
					int fontsize = 0;
					string fontfile = "";
					for(int i=0;i<data.Length;i++)
					{
						if(data[i].IndexOf("=")>0)
						{
							switch(data[i].Substring(0,data[i].IndexOf("=")))
							{
								case "newgui":
								id++;
								Game.gui[id] = new Gui(game);
								Game.gui[id].reset(game,id);
								alti = 0;//11apr2021
								break;
								case "factionindex"://16oct2021
								factionindex%=Game.MaxArmies;
								Game.gui[id].factionindex[factionindex] = readint(data[i]);
								factionindex++;
								break;
								case "leftjustify"://16oct2021
								Game.gui[id].leftjustify = readint(data[i]);
								break;
								case "type":
								Game.gui[id].type = readint(data[i]);	
								break;
								case "screenname":
								Game.gui[id].screenname = readstring(data[i]);
								break;
								case "missionindex":
								Game.gui[id].missionindex = readint(data[i]);
								break;
								case "index": //28mar2021
								Game.gui[id].index = readint(data[i]); //28mar2021
								break;//28mar2021
								case "techlinkid"://2sep2021
								Game.gui[id].index = readint(data[i]);//2sep2021
								break;//2sep2021
								//start-------------//28Feb2021
								case "missionname":
								Game.gui[id].missionname = readstring(data[i]);
								break;
								//end---------------//28Feb2021
								case "topindexzero": //24Feb2021
								Game.gui[id].topindexzero = (int)Functions.abs(Functions.sign(readint(data[i])));//24Feb2021
								break;//24Feb2021
								case "link":
								Game.gui[id].link = readstring(data[i]);
								break;
								case "command":
								Game.gui[id].command = readstring(data[i]);
								break;
								case "title":
								Game.gui[id].title = readstring(data[i]);
								if(Config.TRANSLATEGUI)//21mar2021
								{
									Game.gui[id].title = Translation.TranslateWord(Game.gui[id].title,false);
								}
								break;
								case "tooltip":
								Game.gui[id].tooltip = readstring(data[i]);
								if(Config.TRANSLATEGUI)//21mar2021
								{
									Game.gui[id].tooltip = Translation.TranslateWord(Game.gui[id].tooltip,false);
								}
								break;
								case "action":
								Game.gui[id].action = readint(data[i]);
								break;
								case "hidden":
								Game.gui[id].hidden = readint(data[i]);
								break;
								case "backgroundrect":
									string[] tmpbk = readstring(data[i]).Split(",");
									if(tmpbk.Length==7)
									{
										int rx = 0;
										int ry = 0;
										int rw = 0;
										int rh = 0;
										int rgb_r = 0;
										int rgb_b = 0;
										int rgb_g = 0;
										Int32.TryParse(tmpbk[0],out rx);
										Int32.TryParse(tmpbk[1],out ry);
										Int32.TryParse(tmpbk[2],out rw);
										Int32.TryParse(tmpbk[3],out rh);
										Int32.TryParse(tmpbk[4],out rgb_r);
										Int32.TryParse(tmpbk[5],out rgb_g);
										Int32.TryParse(tmpbk[6],out rgb_b);
										Game.gui[id].backgroundrect = true;
										Game.gui[id].backgroundrectcoords[0] = rx;
										Game.gui[id].backgroundrectcoords[1] = ry;
										Game.gui[id].backgroundrectcoords[2] = rw;
										Game.gui[id].backgroundrectcoords[3] = rh;
										Game.gui[id].backgroundrectcolor[0] = (byte)rgb_r;
										Game.gui[id].backgroundrectcolor[1] = (byte)rgb_g;
										Game.gui[id].backgroundrectcolor[2] = (byte)rgb_b;
									}
								break;
								//start-------------//11mar2021
								case "horizontal":
								Game.gui[id].horizontal = readint(data[i]);
								break;
								case "vertical":
								Game.gui[id].vertical = readint(data[i]);
								break;
								//end---------------//11mar2021
								case "triggerlink":
								Game.gui[id].triggerlink = readint(data[i]);
								break;
								case "mission":
								Game.gui[id].mission = readint(data[i]);
								break;
								case "gamestate":
								Game.gui[id].gamestate = 10000 + readint(data[i]);
								break;
								case "nextscreenname":
								Game.gui[id].nextscreenname = readstring(data[i]);
								break;
								case "nextgamestate":
								Game.gui[id].nextgamestate = 10000 + readint(data[i]);
								break;
								case "x":
								Game.gui[id].x = readint(data[i]);
								break;
								case "y":
								Game.gui[id].y = readint(data[i]);
								break;
								case "w":
								Game.gui[id].w = readint(data[i]);
								break;
								case "h":
								Game.gui[id].h = readint(data[i]);
								break;
								case "cw":
								cw = readint(data[i]);
								break;
								case "ch":
								ch = readint(data[i]);
								break;
								case "nw":
								nw = readint(data[i]);
								break;
								case "nh":
								nh = readint(data[i]);
								break;
								case "altimage":
								//11apr2021 - modified to be an array
								if(alti>4)
								{
									continue;
								}
								Game.gui[id].altimagefile[alti] = readstring(data[i]);
								bool found = false;
								for(int j=0;j<id;j++)
								{
									for(int k=0;k<alti+1;k++)
									{
										if(Game.gui[j].altimagefile[alti]==Game.gui[id].altimagefile[k])
										{
											found = true;
											Game.gui[id].altimage[alti] = Game.gui[j].altimage[k];
											break;
										}
									}
								}
								for(int j=0;j<id;j++)
								{
									for(int k=0;k<alti+1;k++)
									{
										if(Game.gui[j].imagefile==Game.gui[id].altimagefile[k])
										{
											found = true;
											Game.gui[id].altimage[alti] = Game.gui[j].image;
											break;
										}
									}
								}
								if(!found){Game.gui[id].altimage[alti] = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);}
								alti++;
								break;
								case "image":
								Game.gui[id].imagefile = readstring(data[i]);
								found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.gui[j].imagefile==Game.gui[id].imagefile)
									{
										found = true;
										Game.gui[id].image = Game.gui[j].image;
										break;
									}
								}
								if(!found){Game.gui[id].image = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);}
								Game.gui[id].tmpimage = Game.gui[id].image; //30apr2021
								break;
								case "scale":
								Game.gui[id].scale = readfloat(data[i]);
								break;
								case "font":
								fontfile = readstring(data[i]);
								Game.gui[id].fontfile = fontfile;
								break;
								case "ptsize":
								fontsize = readint(data[i]);
								Game.gui[id].fontsize = fontsize;// * Config.FONTALIAS;
								break;
								case "loadfont":
								found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.gui[j].fontfile==Game.gui[id].fontfile && Game.gui[j].fontsize==Game.gui[id].fontsize)
									{
										found = true;
										Game.gui[id].font = Game.gui[j].font;
										break;
									}
								}
								if(!found)
								{
									if(fontfile!="" && fontsize>0)
									{
										Game.gui[id].font = Resources.LoadFont(game,fontfile,fontsize);
									}
								}
								fontfile = "";
								fontsize = 0;
								break;
							}
						}
					}
				}
				LocalStorage.setitem("FILE LOAD:"+file,"SUCCESS");//24mar2021
			}
			catch(Exception e)
			{
				Game.WriteDebug("403:"+e.Message);
				LocalStorage.setitem("FILE LOAD:"+file,"FAILED");//24mar2021
			}
		}

///////////////////Method Definition///////////////
		public static string[] processextraunits() //7mar2021
		{
			////////////////////////
			//in the config files we can have multiple lines indicating
			//multiple files for creatures and so forth
			//this method handles getting this data before we create all our
			//templates in LoadTemplates
			string[] data = new string[0];
			try
			{
				string[] config = System.IO.File.ReadAllLines(Config.configfile);
				for(int i=0;i<config.Length;i++)
				{
					if(config[i].IndexOf("=")>0)
					{
						switch(config[i].Substring(0,config[i].IndexOf("=")))
						{
							case "extraunits":
							try
							{
								string filename = readstring(config[i]);
								string[] data2 = System.IO.File.ReadAllLines(filename);
								if(data2!=null && data2.Length>0)
								{
									int ii = data.Length;
									Array.Resize<string>(ref data,data.Length + data2.Length);
									for(int j=0;j<data2.Length;j++)
									{
										data[ii + j] = data2[j];
									}				
								}
							}
							catch(Exception f)
							{
								Game.WriteDebug("Error:"+f.Message);
							}
							break;
						}
					}
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error:"+e.Message);
			}
			return data;
		}
		
///////////////////Method Definition///////////////
		public static void LoadTech(Game game, string file) //2sep2021
		{
			////////////////////////
			//load all the tech templates
			//that we will use in the Game.
			try
			{
				string[] data = System.IO.File.ReadAllLines(file);
				int count = 0;
				for(int i=0;i<data.Length;i++)
				{
					if(data[i].IndexOf("=")>0)
					{
						switch(data[i].Substring(0,data[i].IndexOf("=")))
						{
							case "newtech":
							count++;
							break;							
						}
					}
				}
				if(count>0)
				{
					Game.techs = new Tech[count];
					int id = -1;
					for(int i=0;i<data.Length;i++)
					{
						//Unit Template.....
						if(data[i].IndexOf("=")>0)
						{
							switch(data[i].Substring(0,data[i].IndexOf("=")))
							{
								case "newtech":
								id++;
								Game.techs[id] = new Tech();
								Game.techs[id].reset(game,id,false);
								Game.techs[id].name = readstring(data[i]);
								Game.techs[id].description = readstring(data[i]).Split("|");
								count++;
								break;	
								case "description":
								Game.techs[id].description = readstring(data[i]).Split("|");
								break;
								case "tooltip":
								Game.techs[id].tooltip = readstring(data[i]);
								break;
								case "displayname":
								Game.techs[id].displayname = readstring(data[i]);
								break;
								case "cellwidth":
								Game.techs[id].cw = readint(data[i]);
								break;
								case "cellheight":
								Game.techs[id].ch = readint(data[i]);
								break;
								case "cellswide":
								Game.techs[id].nw = readint(data[i]);
								break;
								case "cellshigh":
								Game.techs[id].nh = readint(data[i]);
								break;
								//start----------//23sep2021
								case "salecellwidth":
								Game.techs[id].scw = readint(data[i]);
								break;
								case "salecellheight":
								Game.techs[id].sch = readint(data[i]);
								break;
								case	 "salecellswide":
								Game.techs[id].snw = readint(data[i]);
								break;
								case "salecellshigh":
								Game.techs[id].snh = readint(data[i]);
								break;
								//end----------//23sep2021
							
								case "effectname":
								Game.techs[id].effectname = readstring(data[i]);
								break;
								case "effectint":
								Game.techs[id].effectint = readint(data[i]);
								break;
								case "parseeffect": //needed to parse the effect name and apply the effect int as required....
								Tech.parseeffect(game,id);
								break;
								case "researchtime":
								Game.techs[id].researchtime = 60 * readint(data[i]); //multiply by frames per second....
								break;
								case "image":
								Game.techs[id].imgfile = readstring(data[i]);
								bool found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.techs[j].imgfile==Game.techs[id].imgfile)
									{
										found = true;
										Game.techs[id].img = Game.techs[j].img;
										break;
									}
								}
								if(!found)
								{
									Game.techs[id].img = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,Game.techs[id].cw,Game.techs[id].ch,Game.techs[id].nw,Game.techs[id].nh);
								}
								break;
								case "frame":
								Game.techs[id].imgframe = readint(data[i]);
								break;
								//start----------//23sep2021
								case "saleimage"://23sep2021
								Game.techs[id].saleimgfile = readstring(data[i]);
								found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.techs[j].saleimgfile==(Game.techs[id].saleimgfile))
									{
										found = true;
										Game.techs[id].saleimg = Game.techs[j].saleimg;
										break;
									}
								}
								if(!found)
								{
									Game.techs[id].saleimg = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,Game.techs[id].scw,Game.techs[id].sch,Game.techs[id].snw,Game.techs[id].snh);
								}
								break;
								case "techclass":
								Game.techs[id].techclass = readstring(data[i]);
								break;
								case "saleframe":
								Game.techs[id].saleimgframe = readint(data[i]);
								break;
								//end------------//23sep2021
								case "guilinkid":
								Game.techs[id].guilinkid = readint(data[i]);
								break;
								case "faction":
								Game.techs[id].faction = readint(data[i]);
								break;
								//start----------//23sep2021
								case "goldcost":
								Game.techs[id].goldcost = readint(data[i]);
								break;
								case "unlimited":
								Game.techs[id].unlimited = readint(data[i]);
								break;
								case "purchaseguilink":
								Game.techs[id].purchaseguilink = readint(data[i]);
								break;
								case "temporary":
								Game.techs[id].temporary = readint(data[i]);	
								break;
								case "manacost":
								Game.techs[id].manacost = readint(data[i]);
								break;
								case "attackaction":
								Game.techs[id].attackaction = readint(data[i]);	
								break;
								case "guiactionid":
								Game.techs[id].guiactionid = readint(data[i]);
								break;
								//end------------//23sep2021

							}
						}
					}
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug("222:"+e.Message);
				LocalStorage.setitem("FILE LOAD:"+file,"FAILED");//24mar2021
			}
		}
///////////////////Method Definition///////////////
		public static void LoadTemplates(Game game, string file)
		{
			////////////////////////
			//load all the creature/unit templates
			//that we will use in the Game.
			try
			{
				string[] data = System.IO.File.ReadAllLines(file);
				//start-------------//7mar2021
				string[] data2 = processextraunits();
				if(data2!=null && data2.Length>0)
				{
					int ii = data.Length;
					Array.Resize<string>(ref data,data.Length + data2.Length);
					for(int i=0;i<data2.Length;i++)
					{
						data[ii + i] = data2[i];
					}
				}
				//end---------------//7mar2021
				int count = 0;
				for(int i=0;i<data.Length;i++)
				{
					//Unit Template.....
					if(data[i].IndexOf("=")>0)
					{
						switch(data[i].Substring(0,data[i].IndexOf("=")))
						{
							case "newtemplate":
							count++;
							break;							
						}
					}
				}
				if(count>0)
				{
					Game.templates = new Unit[count];
					int id = -1;
					int cw = 0;
					int ch = 0;
					int nw = 0;
					int nh = 0;
					for(int i=0;i<data.Length;i++)
					{
						//Unit Template.....
						if(data[i].IndexOf("=")>0)
						{
							switch(data[i].Substring(0,data[i].IndexOf("=")))
							{
								case "newtemplate":
								id++;
								Game.templates[id] = new Unit(game);
								Game.templates[id].reset(game,id);
								Game.templates[id].name = readstring(data[i]);
								Game.templates[id].description = readstring(data[i]).Split("|");
								Game.templates[id].charactername = "";//10sep2021 default it to blank to start with....
								Game.templates[id].displaycharactername = 0;//10sep2021
								count++;
								break;	
								//start--------------//13mar2021
								case "displayname":
								Game.templates[id].displayname = readstring(data[i]);
								//start-----------------//20mar2021
								if(Game.templates[id].description[0]==Game.templates[id].name)
								{
									Game.templates[id].description[0] = readstring(data[i]);
								}
								//end-------------------//20mar2021
								break;
								//end----------------//13mar2021
								case "faction":
								Game.templates[id].faction = readint(data[i]);
								break;
								case "cellwidth":
								cw = readint(data[i]);
								Game.templates[id].cw = cw;
								break;
								case "cellheight":
								ch = readint(data[i]);
								Game.templates[id].ch = ch;
								break;
								case "frameswide":
								nw = readint(data[i]);
								break;
								case "frameshigh":
								nh = readint(data[i]);
								break;
								//9apr2021 hires stuff
								case "hires":
								if(Config.hires==0) //can switch it off if we wish....
								{
									continue;
								}
								Game.templates[id].cathiresfile = readstring(data[i]);
								bool found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.templates[j].cathiresfile==Game.templates[id].cathiresfile)
									{
										found = true;
										Game.templates[id].cathires = Game.templates[j].cathires;
										break;
									}
								}
								if(!found)
								{
									//9apr2021 observe - double the resolution, otherwise the same....
									//"hires=filename" should appear in the txt file immediately following the original 'image=' line....
									Game.templates[id].cathires = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw * 2,ch * 2,nw,nh);
								}
								break;
								case "image":
								Game.templates[id].catfile = readstring(data[i]);
								found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.templates[j].catfile==Game.templates[id].catfile)
									{
										found = true;
										Game.templates[id].cat = Game.templates[j].cat;
										break;
									}
								}
								if(!found)
								{
									Game.templates[id].cat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
									Game.templates[id].offxa = new int[nw*nh]; //20apr2021
									Game.templates[id].offya = new int[nw*nh]; //20apr2021
								}
								break;
								case "dropshadow"://25sep2021
								Game.templates[id].dropshadow = readint(data[i]);
								break;
								case "enemyimage":
								Game.templates[id].ecatfile = readstring(data[i]);
								found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.templates[j].ecatfile==Game.templates[id].ecatfile)
									{
										found = true;
										Game.templates[id].ecat = Game.templates[j].ecat;
										break;
									}
								}
								if(!found)
								{
									Game.templates[id].ecat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								}
								break;
								case "friendlyimage":
								Game.templates[id].fcatfile = readstring(data[i]);
								found = false;
								for(int j=0;j<id;j++)
								{
									if(Game.templates[j].fcatfile==Game.templates[id].fcatfile)
									{
										found = true;
										Game.templates[id].fcat = Game.templates[j].fcat;
										break;
									}
								}
								if(!found)
								{
									Game.templates[id].fcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								}
								break;
								case "controlpoint":
								Game.templates[id].controlpoint = readint(data[i]);
								break;
								case "framesperdirn":
								Game.templates[id].framesperdirn = readint(data[i]);
								break;
								case "nodirn":
								Game.templates[id].nodirn = readint(data[i]);
								break;
								case "offy":
								Game.templates[id].offy = readint(data[i]);
								break;
								case "controlmode"://24sep2021
								Game.templates[id].controlmode = readstring(data[i]);
								break;
								case "mirror":
								if(readint(data[i])==1)
								{
									Game.templates[id].mirrorleftright = true;
								}
								break;
								case "description":
								Game.templates[id].description = readstring(data[i]).Split("|");
								break;
								case "basehp":
								//Game.templates[id].basehp = readint(data[i]);//20mar2021
								Game.templates[id].basehp = readint(data[i]) * Config.HEALTHPCT / 100;//20mar2021
								//round to the nearest 5 points
								Game.templates[id].basehp += (5 - (Game.templates[id].basehp % 5)) * Functions.sign(Game.templates[id].basehp % 5);//20mar2021
								Game.templates[id].hp = Game.templates[id].basehp;
								break;
								//start----------------//23sep2021
								case "basemana":
									Game.templates[id].basemana = readint(data[i]);
									Game.templates[id].mana = readint(data[i]);
								break;
								case "manarate":
									Game.templates[id].manarate = readint(data[i]);
								break;
								case "attacklimit"://23sep2021
								Game.templates[id].guiattackdisplaylimit = readint(data[i]);
								break;
								case "gold"://23sep2021
								Game.templates[id].gold = readint(data[i]);//23sep2021	
								break;
								case "canpickup"://23sep2021
								Game.templates[id].canpickup = readint(data[i]);//23sep2021	
								break;
								//end------------------//23sep2021
								case "armour":
								//Game.templates[id].armour = readint(data[i]); //20mar2021
								Game.templates[id].armour = readint(data[i]) * Config.ARMOURPCT / 100;//20mar2021
								break;
								case "damage":
								//Game.templates[id].damage = readint(data[i]);//20mar2021
								Game.templates[id].damage = readint(data[i]) * Config.ATTACKPCT / 100;//20mar2021
								break;
								//start--------------//2sep2021
								case "guilinkid":
								Game.templates[id].techguilinkid = readint(data[i]);
								break;
								case "researchneeded":
								Game.templates[id].unresearchedbydefault = readint(data[i]);
								break;
								//end----------------//2sep2021
								case "firebullet":
								Game.templates[id].firebullet = readint(data[i]);
								break;
								case "range":
								Game.templates[id].firerange = readint(data[i]);
								break;
								case "needlos"://15sep2021
								Game.templates[id].needlos = readint(data[i]);
								break;
								case "damage2":
								//Game.templates[id].damage2 = readint(data[i]);//20mar2021
								Game.templates[id].damage2 = readint(data[i]) * Config.ATTACKPCT / 100;//20mar2021
								break;
								case "range2":
								Game.templates[id].firerange2 = readint(data[i]);
								break;
								case "splash"://2sep2021
								Game.templates[id].splash = readint(data[i]);
								break;
								case "levelxp":
								Game.templates[id].levelxp = readint(data[i]);
								break;
								case "xpvalue":
								Game.templates[id].xpvalue = readint(data[i]);
								break;
								case "prefermobiletargets"://18sep2021
								Game.templates[id].prefermobiletargets = readint(data[i]);
								break;
								case "spellcaster":
								Game.templates[id].spellcaster = readint(data[i]);
								break;
								case "notabuffer": //15apr2021
								Game.templates[id].notabuffer = readint(data[i]);
								break;
								case "extragibbet"://18sep2021
								Game.templates[id].extragibbet = readint(data[i]);
								break;
								case "firespell":
								Game.templates[id].firespell = readint(data[i]);
								break;
								case "points"://17sep2021
								Game.templates[id].points = readint(data[i]);
								break;
								case "powerspell":
								Game.templates[id].powerspell = readint(data[i]);
								break;
								case "healer":
								Game.templates[id].healer = readint(data[i]);
								break;
								case "zombiemaster":
								Game.templates[id].zombiemaster = readint(data[i]);
								break;
								case "banishment": //12mar2021
								Game.templates[id].banish = readint(data[i]);
								break;
								case "dustcloud":
								Game.templates[id].dustcloud = readint(data[i]);
								break;
								case "timid":
								Game.templates[id].timid = readint(data[i]);
								break;
								case "dodge"://21oct2021
								Game.templates[id].dodge = readint(data[i]);
								break;
								case "hitandrun":
								Game.templates[id].hitandrun = readint(data[i]);
								break;
								case "buildpenalty": //20mar2021
								Game.templates[id].buildpenalty = readint(data[i]);//20mar2021
								break;//20mar2021
								case "brave":
								Game.templates[id].brave = readint(data[i]);
								break;
								//start-----------//01apr2021
								case "spellability":
								Game.templates[id].spellability = readint(data[i]);
								break;
								case "ping"://16sep2021
								Game.templates[id].ping = readint(data[i]);
								break;
								case "spelldefense": //magic resistance....
								Game.templates[id].spelldefense = readint(data[i]);
								break;
								//start--------------//4may2021
								case "canfly":
								Game.templates[id].canfly = readint(data[i]);
								break;
								case "canflyandwalk":
								Game.templates[id].canflyandwalk = readint(data[i]);
								break;
								case "canattackair":
								Game.templates[id].canattackair = readint(data[i]);
								break;
								//end----------------//4may2021
								//start--------------//3may2021
								case "magicrelease": //for getting out of transports
								Game.templates[id].magicrelease = readint(data[i]);
								if(Game.templates[id].magicrelease>0)
								{
									Game.templates[id].magicrelease = Unit.MAGICRELEASE;
								}
								break;
								case "magictransform": //for transforming into a different unit
								Game.templates[id].magictransform = readint(data[i]);
								if(Game.templates[id].magictransform>0)
								{
									Game.templates[id].magictransform = Unit.MAGICTRANSFORM;
								}
								break;
								case "transforminto":
								Game.templates[id].transforminto = readstring(data[i]);
								break;
								case "transformrequires":
								Game.templates[id].transformrequires = readstring(data[i]); //pipe separated list of entries....
								//currently we don't have any requirements...
								break;
								case "transportcapacity":
								Game.templates[id].transportcapacity = readint(data[i]);
								if(Game.templates[id].transportcapacity>0)
								{
									Game.templates[id].transportarray = new int[Game.templates[id].transportcapacity];
								}
								break;
								case "transportsize":
								Game.templates[id].transportsize = readint(data[i]);
								break;
								//end----------------//3may2021
								//start--------------//9apr2021
								case "magicsummoner":
								Game.templates[id].magiczombiemaster = readint(data[i]);
								if(Game.templates[id].magiczombiemaster>0)
								{
									Game.templates[id].magiczombiemaster = Unit.MAGICZOMBIEMASTER;
								}
								break;
								case "magiczombiemaster"://redundant version alias
								Game.templates[id].magiczombiemaster = readint(data[i]);
								if(Game.templates[id].magiczombiemaster>0)
								{
									Game.templates[id].magiczombiemaster = Unit.MAGICZOMBIEMASTER;
								}
								break;
								case "magicleader":
								Game.templates[id].magicleader = readint(data[i]);
								if(Game.templates[id].magicleader>0)
								{
									Game.templates[id].magicleader = Unit.MAGICLEADER;
								}
								break;
								//end----------------//9apr2021
								case "magicfrenzy":
								Game.templates[id].magicfrenzy = readint(data[i]);
								if(Game.templates[id].magicfrenzy>0)
								{
									Game.templates[id].magicfrenzy = Unit.MAGICFRENZY;
								}
								break;
								case "magicdoom":
								Game.templates[id].magicdoom = readint(data[i]);
								if(Game.templates[id].magicdoom>0)
								{
									Game.templates[id].magicdoom = Unit.MAGICDOOM;
								}
								break;
								case "magicdefense":
								Game.templates[id].magicdef = readint(data[i]);
								if(Game.templates[id].magicdef>0)
								{
									Game.templates[id].magicdef = Unit.MAGICDEF;
								}
								break;
								case "magicdef": //redundancy
								Game.templates[id].magicdef = readint(data[i]);
								if(Game.templates[id].magicdef>0)
								{
									Game.templates[id].magicdef = Unit.MAGICDEF;
								}
								break;
								//end-------------//01apr2021
								//start---------------//28mar2021
								case "magicweb":
								Game.templates[id].magicweb = readint(data[i]);
								if(Game.templates[id].magicweb>0)
								{
									Game.templates[id].magicweb = Unit.MAGICWEB;
								}
								break;
								case "magicgas":
								Game.templates[id].magicgas = readint(data[i]);
								if(Game.templates[id].magicgas>0)
								{
									Game.templates[id].magicgas = Unit.MAGICGAS;
								}
								break;
								case "magichaste":
								Game.templates[id].magichaste = readint(data[i]);
								if(Game.templates[id].magichaste>0)
								{
									Game.templates[id].magichaste = Unit.MAGICHASTE;
								}
								break;
								case "magicfear":
								Game.templates[id].magicfear = readint(data[i]);
								if(Game.templates[id].magicfear>0)
								{
									Game.templates[id].magicfear = Unit.MAGICFEAR;
								}
								break;
								case "magicshield":
								Game.templates[id].magicshield = readint(data[i]);
								if(Game.templates[id].magicshield>0)
								{
									Game.templates[id].magicshield = Unit.MAGICSHIELD;
								}
								break;
								case "magicstorm":
								Game.templates[id].magicstorm = readint(data[i]);
								if(Game.templates[id].magicstorm>0)
								{
									Game.templates[id].magicstorm = Unit.MAGICSTORM;
								}
								break;
								case "magicsword":
								Game.templates[id].magicsword = readint(data[i]);
								if(Game.templates[id].magicsword>0)
								{
									Game.templates[id].magicsword = Unit.MAGICSWORD;
								}
								break;
								case "magicstealth":
								Game.templates[id].magicstealth = readint(data[i]);
								if(Game.templates[id].magicstealth>0)
								{
									Game.templates[id].magicstealth = Unit.MAGICSTEALTH;
								}
								break;
								case "magicplant":
								Game.templates[id].magicplant = readint(data[i]);
								if(Game.templates[id].magicplant>0)
								{
									Game.templates[id].magicplant = Unit.MAGICPLANT;
								}
								break;
								case "magicwind":
								Game.templates[id].magicwind = readint(data[i]);
								if(Game.templates[id].magicwind>0)
								{
									Game.templates[id].magicwind = Unit.MAGICWIND;
								}
								break;
								//end-----------------//28mar2021
								case "highfirerate": //25Feb2021
								Game.templates[id].highfirerate = readint(data[i]);
								break;
								//start-------------//7mar2021
								case "mob": 
								Game.templates[id].mob = readint(data[i]);
								break;
								case "lightningdeath"://19oct2021
								Game.templates[id].lightningdeath = readint(data[i]);
								break;
								case "hatred": 
								Game.templates[id].hatred = readint(data[i]);
								break;
								case "craftsman": 
								Game.templates[id].craftsman = readint(data[i]);
								break;
								case "planar": 
								Game.templates[id].planar = readint(data[i]);
								break;
								case "slow": 
								Game.templates[id].slow = readint(data[i]);
								break;
								case "woodsman": 
								Game.templates[id].woodsman = readint(data[i]);
								break;
								case "stupid": 
								Game.templates[id].stupid = readint(data[i]);
								break;
								case "frenzy": 
								Game.templates[id].frenzy = readint(data[i]);
								break;
								//end---------------//7mar2021
								case "shocktroops":
								Game.templates[id].shock = readint(data[i]);
								break;
								case "shock": //2sep2021
								Game.templates[id].shock = readint(data[i]);//2sep2021
								break;//2sep2021
								case "stealth":
								Game.templates[id].stealth = readint(data[i]);
								break;
								case "damagex":
								Game.templates[id].damagex = readint(data[i]);
								break;
								case "fearsome":
								Game.templates[id].fearsome = readint(data[i]);
								break;
								case "hasleader"://21oct2021
								Game.templates[id].hasleader = readint(data[i]);
								break;
								case "leader":
								Game.templates[id].leader = readint(data[i]);
								break;
								case "scale"://25sep2021
								Game.templates[id].scale = readfloat(data[i]);
								break;
								case "bounddemon"://12jul2021
								Game.templates[id].bounddemon = readint(data[i]);
								break;
								case "spawner":
								Game.templates[id].spawner = readstring(data[i]);
								Game.templates[id].spawnerconstraint = "*";
								break;
								case "spawnerconstraint": //9sep2021
								Game.templates[id].spawnerconstraint = readstring(data[i]);
								break;
								case "spawnercount":
								Game.templates[id].spawnercount = readint(data[i]);
								break;
								case "spawnertime":
								Game.templates[id].spawnertime = readint(data[i]);
								break;
								case "bossmonster":
								Game.templates[id].bossmonster = readint(data[i]);
								break;
								case "flammable":
								Game.templates[id].flammable = readint(data[i]);
								break;
								case "regeneration":
								Game.templates[id].regeneration = readint(data[i]);
								break;
								case "zombie":
								Game.templates[id].zombie = readint(data[i]);
								break;
								case "evilfire":
								Game.templates[id].firespell = - readint(data[i]);
								break;
								case "sacrificial":
								Game.templates[id].sacrificial = readint(data[i]);
								break;
								case "cansacrifice": 
								Game.templates[id].cansacrifice = readint(data[i]);
								break;
								case "animosity":
								Game.templates[id].animosity = readint(data[i]);
								break;
								//start-----------//25Feb2021
								case "deadframestart":
								Game.templates[id].animmodedeadframestart = readint(data[i]);
								break;
								case "deadframeend":
								Game.templates[id].animmodedeadframeend = readint(data[i]);
								break;
								//end-------------//25Feb2021
								//start-------------//28Feb2021
								case "idle2framestart":
								Game.templates[id].animmodeidle2framestart = readint(data[i]);
								break;
								case "idle2frameend":
								Game.templates[id].animmodeidle2frameend = readint(data[i]);
								break;
								//end---------------//28Feb2021
								case "idleframestart":
								Game.templates[id].animmodeidleframestart = readint(data[i]);
								break;
								case "idleframeend":
								Game.templates[id].animmodeidleframeend = readint(data[i]);
								break;
								case "walkframestart":
								Game.templates[id].animmodewalkframestart = readint(data[i]);
								break;
								case "walkframeend":
								Game.templates[id].animmodewalkframeend = readint(data[i]);
								break;
								//2sep2021 bug fix
								case "flyframestart":
								Game.templates[id].animmodeflyframestart = readint(data[i]);
								break;
								case "flyframeend":
								Game.templates[id].animmodeflyframeend = readint(data[i]);
								break;
								//end 2sep2021
								case "att1framestart":
								Game.templates[id].animmodeattframestart = readint(data[i]);
								break;
								case "att1frameend":
								Game.templates[id].animmodeattframeend = readint(data[i]);
								break;
								case "att2framestart":
								Game.templates[id].animmodeatt2framestart = readint(data[i]);
								break;
								case "att2frameend":
								Game.templates[id].animmodeatt2frameend = readint(data[i]);
								break;
								case "walkspeed":
								Game.templates[id].walkspeed = readint(data[i]);
								Game.templates[id].origwalkspeed = readint(data[i]);//7oct2021
								break;
								case "animspeed":
								Game.templates[id].animspeed = (7 * readint(data[i])) / 4;//29sep2021
								break;
								case "targetfx":
								for(int a=0;a<Game.templates[id].targetfx.Length;a++)
								{
									if(Game.templates[id].targetfx[a]==-1)
									{
										Game.templates[id].targetfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								case "magicfx":
								for(int a=0;a<Game.templates[id].magicfx.Length;a++)
								{
									if(Game.templates[id].magicfx[a]==-1)
									{
										Game.templates[id].magicfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								case "impactfx":
								for(int a=0;a<Game.templates[id].impactfx.Length;a++)
								{
									if(Game.templates[id].impactfx[a]==-1)
									{
										Game.templates[id].impactfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								case "selectfx":
								for(int a=0;a<Game.templates[id].selectfx.Length;a++)
								{
									if(Game.templates[id].selectfx[a]==-1)
									{
										Game.templates[id].selectfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								case "ackfx":
								for(int a=0;a<Game.templates[id].ackfx.Length;a++)
								{
									if(Game.templates[id].ackfx[a]==-1)
									{
										Game.templates[id].ackfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								case "attackfx":
								for(int a=0;a<Game.templates[id].attackfx.Length;a++)
								{
									if(Game.templates[id].attackfx[a]==-1)
									{
										Game.templates[id].attackfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								case "deathfx": //28jul2021
								for(int a=0;a<Game.templates[id].deathfx.Length;a++)
								{
									if(Game.templates[id].deathfx[a]==-1)
									{
										Game.templates[id].deathfx[a] = Resources.LoadAudio(game,readstring(data[i]),false);
										break;
									}
								}
								break;
								
							}
						}
					}
					//start-----------------//22mar2021
					//in the event we don't set the displayname we can always look it up in the translation table..in case we have it there...makes it easier sometimes.
					for(int i=0;i<Game.templates.Length;i++)
					{
						if(Game.templates[i].displayname=="")
						{
							Game.templates[i].displayname = Translation.TranslateWord(Game.templates[i].name,false);
						}
					}
					//end-------------------//22mar2021
				}
				LocalStorage.setitem("FILE LOAD:"+file,"SUCCESS");//24mar2021
			}
			catch(Exception e)
			{
				Game.WriteDebug("569:"+e.Message);
				LocalStorage.setitem("FILE LOAD:"+file,"FAILED");//24mar2021
			}
		}

///////////////////Method Definition///////////////
		public static bool comparecustomversions()
		{
			//compare the custom usercampaign.txt file with the one in the 
			//install directory. This is so that we can make a copy in the user'sacrificial
			//local area for them to play around with
			int userversion = 0;
			int gameversion = 1;
			try
			{
				string[] datag = System.IO.File.ReadAllLines(Config.customcampaignfile);
				for(int i=0;i<datag.Length;i++)
				{
					if(datag[i].IndexOf("=")>0)
					{
						switch(datag[i].Substring(0,datag[i].IndexOf("=")))
						{
							case "version":
							gameversion = readint(datag[i]);
							break;
						}
					}
				}
			}
			catch(Exception e)
			{
				string msg0 = e.Message;
			}
			try
			{
				string[] datau = System.IO.File.ReadAllLines(Config.usercampaignfile);
				for(int i=0;i<datau.Length;i++)
				{
					if(datau[i].IndexOf("=")>0)
					{
						switch(datau[i].Substring(0,datau[i].IndexOf("=")))
						{
							case "version":
							userversion = readint(datau[i]);
							break;
						}
					}
				}
			}
			catch(Exception e)
			{
				string msg1 = e.Message;
			}
			if(userversion<gameversion)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

///////////////////Method Definition///////////////
		public static bool custommissionvalid(Game game,string[] data2,int i) //24Feb2021
		{
			//verify if the mission loaded by LoadCampaign is a valid mission
			//checks factions and existence of units
			bool anyplayers = false;
			int pfaction = Unit.HUMAN; //28Feb2021
			for(int j=i+1;j<data2.Length;j++)
			{
				if(data2[j].IndexOf("=")>0)
				{
					if(data2[j].Substring(0,data2[j].IndexOf("="))=="mission")
					{
						break;
					}
					//start-------------//28Feb2021
					if(data2[j].Substring(0,data2[j].IndexOf("="))=="playerfaction")
					{
						pfaction = Resources.readint(data2[j]);
					}
					//end---------------//28Feb2021
					if(data2[j].Substring(0,data2[j].IndexOf("="))=="unit")
					{
						string[] unitlist = readstring(data2[j]).Split(",");
						string unitname = unitlist[0];
						bool found = false;
						for(int k=0;k<Game.templates.Length;k++)
						{
							if(unitname==Game.templates[k].name)
							{
								//if(Game.templates[k].faction==Unit.HUMAN) //28Feb2021
								if(Game.templates[k].faction==pfaction)//28Feb2021
								{
									anyplayers = true;
								}
								found = true;
								break;
							}
						}
						if(!found)
						{
							return false;
						}
					}
				}
			}
			if(!anyplayers)
			{
				return false;
			}
			return true;
		}

///////////////////Method Definition///////////////
		public static void LoadCampaign(Game game,string file)
		{
			////////////////////////
			//load the Campaign files including both custom and core campaigns.
			string errline = "";
			int toomanytrees = 0;
			int toomanyrocks = 0;
			int toomanywalls = 0;
			bool getnewversion = comparecustomversions();
			try
			{
				string[] data = System.IO.File.ReadAllLines(file);
				string[] data2 = new string[0];
				try
				{
					data2 = System.IO.File.ReadAllLines(Config.usercampaignfile);
					LocalStorage.setitem("FILE LOAD:"+Config.usercampaignfile,"SUCCESS");
				}
				catch(Exception gge)
				{
					Game.WriteDebug(gge.Message);
					LocalStorage.setitem("FILE LOAD:"+Config.usercampaignfile,"FAILED");
				}
				if(data2.Length<=0 || getnewversion==true)
				{
					data2 = System.IO.File.ReadAllLines(Config.customcampaignfile);	
					try
					{
						string txt = "";
						for(int i=0;i<data2.Length;i++)
						{
							txt+=data2[i]+Environment.NewLine;
						}
						System.IO.File.WriteAllText(Config.usercampaignfile,txt);
					}
					catch(Exception ffe)
					{
						Game.WriteDebug(ffe.Message);
					}
				}
				int cw = 0;
				int ch = 0;
				int nw = 0;
				int nh = 0;
				int offy = 0;
				int countmissions = 0;
				int countcustoms = 0;
				for(int d=0;d<Map.deadcell.Length;d++)
				{
					Map.deadcell[d] = -1;
				}
				for(int i=0;i<data2.Length;i++)
				{
					errline = data2[i];
					if(data2[i].IndexOf("=")>0)
					{
						switch(data2[i].Substring(0,data2[i].IndexOf("=")))
						{
							case "mission":
							//check mission valid....24Feb2021
							if(custommissionvalid(game,data2,i))//24Feb2021
							{
								countcustoms++;
								LocalStorage.setitem("CUSTOM MISSION:"+readstring(data2[i]),"SUCCESS");//24mar2021
							}
							else //17mar21
							{
								Game.WriteDebug("Error with custom map:"+readstring(data2[i]));
								//LocalStorage.WriteLog("Error with custom map:"+readstring(data2[i]));
								LocalStorage.setitem("CUSTOM MISSION:"+readstring(data2[i]),"FAIL");//24mar2021
							}
							break;
						}
					}
				}
				int id = -1;
				int countunits = 0;
				int unitid = -1;
				Game.countcustoms = countcustoms;
				//Game.WriteDebug("Count Customs:"+countcustoms);
				for(int i=0;i<data.Length;i++)
				{
					//Unit Template.....
					errline = data[i];
					if(data[i].IndexOf("=")>0)
					{
						switch(data[i].Substring(0,data[i].IndexOf("=")))
						{
							case "shield": //15mar2021
								Game.shield = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "spellball"://12apr2021
								Game.spellball = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "whirlwind"://28mar2021
								Game.whirlwind = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "lightning"://28mar2021
								Game.lightning = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "whiteflag":
								Game.whiteflag = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "battleicon"://16oct2021
								Game.battleicon = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							//start-------------//15sep2021
							case "shadowup":
								Game.shadowup = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "shadowleft":
								Game.shadowleft = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "shadowright":
								Game.shadowright = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "shadowoffx":
								Game.shadowoffx = Resources.readint(data[i]);
							break;
							case "shadowoffy":
								Game.shadowoffy = Resources.readint(data[i]);
							break;
							//end---------------//15sep2021
							//start-----------------//21mar2021
							case "plus":
								Game.iconplus = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "minus":
								Game.iconminus = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "circles":
								//110,110,13,1 - standard
								Game.iconcircles = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							//end-------------------//21mar2021
							case "healthbar":
								Game.healthbar = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "cw":
								cw = readint(data[i]);
							break;
							case "ch":
								ch = readint(data[i]);
							break;
							case "nw":
								nw = readint(data[i]);
							break;
							case "nh":
								nh = readint(data[i]);
							break;
							case "offy":
								offy = readint(data[i]);
							break;
							case "menumusic":
								string[] tmpmenumusic = readstring(data[i]).Split(",");
								if(tmpmenumusic.Length==2)
								{
									string menumusicfile = tmpmenumusic[0];
									int menuduration = -1;
									Int32.TryParse(tmpmenumusic[1],out menuduration);
									if(menuduration!=-1)
									{
										Map.menumusicfile = menumusicfile;//25mar2021
										Map.menumusic = Resources.LoadAudio(game,menumusicfile,true);
										Map.menumusicplaying = -1;
									}
								}
							break;
							case "musictrack":
								string[] tmpmusic = readstring(data[i]).Split(",");
								if(tmpmusic.Length==2)
								{
									string musfile = tmpmusic[0];
									int duration = -1;
									Int32.TryParse(tmpmusic[1],out duration);
									if(duration!=-1)
									{
										if(Map.musictrack==null)
										{
											Map.musictrack = new int[Map.MAXMUSIC];
											Map.musicduration = new int[Map.MAXMUSIC];
											Map.musictrackfile = new string[Map.MAXMUSIC];//25mar2021
											for(int m=0;m<Map.musictrack.Length;m++)
											{
												Map.musictrack[m]=-1;
												Map.musicduration[m]=-1;
												Map.musictrackfile[m]=""; //25mar2021
											}
											Map.musicplaying = -1;
											Map.musicstartframe = -1;
										}
										for(int m=0;m<Map.musictrack.Length;m++)
										{
											if(Map.musictrack[m]==-1)
											{
												Map.musictrackfile[m] = musfile;//25mar2021
												Map.musictrack[m] = Resources.LoadAudio(game,musfile,true);
												if(Map.musictrack[m]!=-1)
												{
													Map.musicduration[m] = duration;
												}
												break;
											}
										}
									}
								}
							break;
							case "dead":
								for(int d=0;d<Map.deadcell.Length;d++)
								{
									if(Map.deadcell[d]==-1)
									{
										Map.deadcell[d] = readint(data[i]);
									}
								}
							break;
							//start-------------//20oct2021
							case "hillgrass":
								Map.hillgrass = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "hilldesert":
								Map.hilldesert = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							case "hillsnow":
							Map.hillsnow = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
							break;
							//end---------------//20oct2021
							case "environment_ground":
								Map.tilecat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								Map.tileframes = nw * nh;
								Map.grasstilecat = Map.tilecat;//7oct2021
								Map.snowtilecat = Resources.LoadAnimImage(game,"media/environment/snow.png",Game.renderer,cw,ch,nw,nh);//7oct2021
								Map.deserttilecat = Resources.LoadAnimImage(game,"media/environment/grounddesert.png",Game.renderer,cw,ch,nw,nh);//7oct2021
							break;
							case "environment_trees":
								Map.treecat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								Map.grasstreecat = Map.treecat;//7oct2021
								Map.snowtreecat = Resources.LoadAnimImage(game,"media/environment/treessnow.png",Game.renderer,cw,ch,nw,nh);//7oct2021
								Map.deserttreecat = Resources.LoadAnimImage(game,"media/environment/treesdesert.png",Game.renderer,cw,ch,nw,nh);//7oct2021
								Map.treeframes = nw * nh;
								Map.treeoffsety = offy;
							break;
							//start--------------//2mar2021
							case "environment_decor":
								Map.decorcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								Map.decorframes = nw * nh;
								Map.decoroffsety = offy;
							break;
							//end----------------//2mar2021
							case "environment_rocks":
								Map.rockcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								Map.rockframes = nw * nh;
								Map.rockoffsety = offy;
							break;
							case "environment_walls":
								Map.wallcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								Map.wallframes = nw * nh;
								Map.walloffsety = offy;
							break;
							case "environment_fire":
								Map.firecat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
								Map.fireframes = nw * nh;
							break;
							case "mission":
								countmissions++;
							break;
						}
					}
				}
				if(countmissions>0 || countcustoms>0)
				{
					Game.missions = new Mission[countmissions+countcustoms];
					Game.overridemaxmission = countmissions;//13sep2021
					int countobjectives = 0;
					int objective = -1;
					for(int i=0;i<data.Length;i++)
					{
						//Unit Template.....
						errline = data[i];
						if(data[i].IndexOf("=")>0)
						{
							switch(data[i].Substring(0,data[i].IndexOf("=")))
							{
								case "mission":
								id++;
								Game.missions[id] = new Mission();
								Game.missions[id].name = readstring(data[i]);
								Game.missions[id].custom = false;
								Game.missions[id].gridw = Map.DEFAULTGRIDW;//10sep2021
								Game.missions[id].gridh = Map.DEFAULTGRIDH;//10sep2021
								toomanytrees = 0;
								toomanyrocks = 0;
								toomanywalls = 0;
								countunits = 0;
								for(int j=i+1;j<data.Length;j++)
								{
									if(data[j].IndexOf("=")>0)
									{
										if(data[j].Substring(0,data[j].IndexOf("="))=="unit")
										{
											countunits++;
										}
										if(data[j].Substring(0,data[j].IndexOf("="))=="mission")
										{
											break;
										}
										if(data[j].Substring(0,data[j].IndexOf("="))=="tutorial")
										{
											break;
										}
										if(data[j].Substring(0,data[j].IndexOf("="))=="objective")
										{
											countobjectives++;
										}
									}
								}
								if(countunits>0)
								{
									Game.missions[id].units = new Unit[countunits];
									unitid = -1;
								}
								if(countobjectives>0)
								{
									Game.missions[id].objectives = new string[countobjectives];
								}
								break;
								//26oct2020 start
								case "cw":
									cw = readint(data[i]);
								break;
								case "ch":
									ch = readint(data[i]);
								break;
								case "nw":
									nw = readint(data[i]);
								break;
								case "nh":
									nh = readint(data[i]);
								break;
								case "offy":
									offy = readint(data[i]);
								break;
								//start-----------------//10sep2021
								case "gridw":
								Game.missions[id].gridw = readint(data[i]);
								break;
								case "gridh":
								Game.missions[id].gridh = readint(data[i]);
								break;
								//end-------------------//10sep2021
								//1nov2020 start
								case "override_bk_red":
								Game.missions[id].overridergbbk = true;
								Game.missions[id].overridergbbk_r = readint(data[i]);
								break;
								case "override_bk_green":
								Game.missions[id].overridergbbk = true;
								Game.missions[id].overridergbbk_g = readint(data[i]);
								break;
								case "override_bk_blue":
								Game.missions[id].overridergbbk = true;
								Game.missions[id].overridergbbk_b = readint(data[i]);
								break;
								//1nov2020 end
								case "override_ground":
									Game.missions[id].tilecat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].tileframes = nw * nh;
									if(readstring(data[i]).IndexOf("snow")>0)
									{
										Game.missions[id].issnow = true;
									}
									if(readstring(data[i]).IndexOf("desert")>0)
									{
										Game.missions[id].isdesert = true;
									}
								break;
								//start--------------//2mar2021
								case "override_decor":
									Game.missions[id].decorcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].decorframes = nw * nh;
									Game.missions[id].decoroffsety = offy;
								break;
								//end----------------//2mar2021
								case "override_trees":
									Game.missions[id].treecat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].treeframes = nw * nh;
									Game.missions[id].treeoffsety = offy;
								break;
								case "override_rocks":
									Game.missions[id].rockcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].rockframes = nw * nh;
									Game.missions[id].rockoffsety = offy;
								break;
								case "override_walls":
									Game.missions[id].wallcat = Resources.LoadAnimImage(game,readstring(data[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].wallframes = nw * nh;
									Game.missions[id].walloffsety = offy;
								break;
								//26oct2020 end
								case "nextmissionid":
									Game.missions[id].nextmissionid = readint(data[i]);
								break;
								case "debrief":
									Game.missions[id].debrief = readint(data[i]);
								break;
								case "failedmissionid":
									Game.missions[id].failedmissionid = readint(data[i]);
								break;
								case "floorpattern"://16sep2021
								Game.missions[id].floorpattern = readint(data[i]);
								break;
								//start--------------//1mar2021
								case "nextmissionname":
									Game.missions[id].nextmissionname = readstring(data[i]);
								break;
								case "failedmissionname":
									Game.missions[id].failedmissionname = readstring(data[i]);
								break;
								case "indoor"://23sep2021
								Game.missions[id].indoor = readint(data[i]);	
								break;
								//end----------------//1mar2021
								case "demo":
									Game.missions[id].demo = readint(data[i]);
								break;
								case "flavourtext"://18sep2021
									Game.missions[id].flavourtext = readstring(data[i]);
								break;
								//start-----------//26Feb2021
								case "fogoff":
									Game.missions[id].fogoff = readint(data[i]);
								break;
								case "neutralfog":
									Game.missions[id].neutralfog = readint(data[i]);
								break;
								//end-------------//26Feb2021
								//start-------------//28Feb2021
								case "playerfaction":
									Game.missions[id].playerfaction = readint(data[i]);
								break;
								case "enemyfaction":
									Game.missions[id].skirmishenemyfaction = readint(data[i]);
								break;
								case "unlocked":
									Game.missions[id].alwaysunlocked = readint(data[i]);
								break;
								//end---------------//28Feb2021
								//start--------------//1mar2021
								case "lockcorner":
									Game.missions[id].lockcorner = readint(data[i]);
								break;
								//end----------------//1mar2021
								case "corner":
									string[] tmpcorner = readstring(data[i]).Split(",");
									if(tmpcorner.Length==2)
									{
										Int32.TryParse(tmpcorner[0],out Game.missions[id].cornerx);
										Int32.TryParse(tmpcorner[1],out Game.missions[id].cornery);
									}
								break;
								case "seed":
									Game.missions[id].seed = readint(data[i]);
								break;
								case "skirmish":
									Game.missions[id].skirmish = readint(data[i]);
								break;
								case "description":
									if(Game.missions[id].description[0] == "")
									{
										Game.missions[id].description[0] = readstring(data[i]);
									}
									else
									{
										if(Game.missions[id].description[1] == "")
										{
											Game.missions[id].description[1] = readstring(data[i]);
										}
										else
										{
											Game.missions[id].description[2] = readstring(data[i]);
										}
									}
								break;
								case "mapgen":
									Game.missions[id].mapgen = 1;
								break;
								case "ai":
									Game.missions[id].ai = readint(data[i]);
								break;
								case "istutorial":
									Game.missions[id].istutorial = readint(data[i]);
								break;
								case "toomanytrees":
									toomanytrees=1;
								break;
								case "toomanyrocks":
									toomanyrocks=1;
								break;
								case "toomanywalls":
									toomanywalls = 1;
								break;
								//start--------------//2mar2021
								case "decor":
								if(id>=0)
								{
									string[] tmpdecor = readstring(data[i]).Split(",");
									Game.missions[id].decorimage = new int[tmpdecor.Length];
									for(int j=0;j<tmpdecor.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmpdecor[j],out tt);
										Game.missions[id].decorimage[j] = tt;
									}
								}
								break;
								//end----------------//2mar2021
								case "trees":
								if(id>=0)
								{
									string[] tmptrees = readstring(data[i]).Split(",");
									Game.missions[id].treeimage = new int[tmptrees.Length];
									for(int j=0;j<tmptrees.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmptrees[j],out tt);
										if(toomanytrees>0)
										{
											if(j % 3<2)
											{
												continue;
											}
										}
										Game.missions[id].treeimage[j] = tt;
									}
								}
								break;
								case "walls":
								if(id>=0)
								{
									string[] tmpwalls = readstring(data[i]).Split(",");
									Game.missions[id].wallimage = new int[tmpwalls.Length];
									for(int j=0;j<tmpwalls.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmpwalls[j],out tt);
										if(toomanywalls==1)
										{
											if((Functions.rand(0,1000) % 4)>0)
											{
												continue;
											}
										}
										Game.missions[id].wallimage[j] = tt;
									}
								}
								break;
								case "rocks":
								if(id>=0)
								{
									string[] tmprocks = readstring(data[i]).Split(",");
									Game.missions[id].rockimage = new int[tmprocks.Length];
									for(int j=0;j<tmprocks.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmprocks[j],out tt);
										if(toomanyrocks>0)
										{
											if(j % 3<2)
											{
												continue;
											}
										}
										Game.missions[id].rockimage[j] = tt;
									}
								}
								break;
								//start-----------//20oct2021
								case "grasshill":
									if(id>=0)
									{
										string[] tmpghill = readstring(data[i]).Split(",");
										Game.missions[id].ghill = new int[tmpghill.Length];
										for(int j=0;j<tmpghill.Length;j++)
										{
											int tt = -1;
											Int32.TryParse(tmpghill[j],out tt);
											Game.missions[id].ghill[j] = tt;
										}
									}
								break;
								case "deserthill":
									if(id>=0)
									{
										string[] tmpdhill = readstring(data[i]).Split(",");
										Game.missions[id].dhill = new int[tmpdhill.Length];
										for(int j=0;j<tmpdhill.Length;j++)
										{
											int tt = -1;
											Int32.TryParse(tmpdhill[j],out tt);
											Game.missions[id].dhill[j] = tt;
										}
									}
								break;
								case "snowhill":
									if(id>=0)
									{
										string[] tmpshill = readstring(data[i]).Split(",");
										Game.missions[id].shill = new int[tmpshill.Length];
										for(int j=0;j<tmpshill.Length;j++)
										{
											int tt = -1;
											Int32.TryParse(tmpshill[j],out tt);
											Game.missions[id].shill[j] = tt;
										}
									}
								break;
								//end------------//20oct2021
								case "setfire":
								if(id>=0)
								{
									string[] tmpfire = readstring(data[i]).Split(",");
									if(tmpfire.Length==2)
									{
										Game.missions[id].campfirex = -1;
										Game.missions[id].campfirey = -1;
										Int32.TryParse(tmpfire[0],out Game.missions[id].campfirex);
										Int32.TryParse(tmpfire[1],out Game.missions[id].campfirey);
									}
								}
								break;
								case "objective":
									objective++;
									Game.missions[id].objectives[objective] = readstring(data[i]);
								break;
								case "showkills":
									Game.missions[id].showkills = readint(data[i]);
								break;
								case "unit":
									string[] unitlist = readstring(data[i]).Split(",");
									if(unitlist.Length==3)
									{
										bool success1 = true;
										bool success2 = true;
										string name = unitlist[0];
										int x = 0;
										int y = 0;
										if(unitlist[1]=="random")
										{
											x = Functions.rand(Map.GRIDW * 35,Map.GRIDW*65);
											success1 = true;
										}
										else
										{
											success1 = Int32.TryParse(unitlist[1],out x);
										}
										if(unitlist[2]=="random")
										{
											y = Functions.rand(Map.GRIDH * 35,Map.GRIDH*65);
											success2 = true;
										}
										else
										{
											success2 = Int32.TryParse(unitlist[2],out y);
										}
										if(success1 && success2)
										{
											unitid++;
											Game.missions[id].units[unitid] = new Unit(game);
											Game.missions[id].units[unitid].x = x;
											Game.missions[id].units[unitid].y = y;
											Game.missions[id].units[unitid].name = name;
										}
									}
								break;
								//start--------------//10sep2021
								case "unitname"://unit name must immediately follow the unit that was just created....
								if(Game.missions[id].units!=null)
								{
									if(unitid<Game.missions[id].units.Length && unitid>=0)
									{
										Game.missions[id].units[unitid].charactername = readstring(data[i]);
									}
								}
								break;
								case "displayunitname"://unit name must immediately follow the unit that was just created....
								if(Game.missions[id].units!=null)
								{
									if(unitid<Game.missions[id].units.Length && unitid>=0)
									{
										Game.missions[id].units[unitid].displaycharactername = readint(data[i]);
									}
								}
								break;
								//end----------------//10sep2021
								case "trigger":
								//type,num,comparator,name,xx,yy,ww,hh
								//type == 1 Victory
								//type == 2 Defeat
								//comparator == 0 equal
								//comparator == -1 less than
								//comparator == 1 greater than
									if(id>=0)
									{
										string[] trigger = readstring(data[i]).Split(",");
										if(trigger.Length==8)
										{
											int typ = 0;
											int num = 0;
											int comp = 0;
											Int32.TryParse(trigger[0],out typ);
											Int32.TryParse(trigger[1],out num);
											Int32.TryParse(trigger[2],out comp);
											int xx = 0;
											int yy = 0;
											int ww = 0;
											int hh = 0;
											Int32.TryParse(trigger[4],out xx);
											Int32.TryParse(trigger[5],out yy);
											Int32.TryParse(trigger[6],out ww);
											Int32.TryParse(trigger[7],out hh);
											Game.missions[id].createtrigger(typ,num,comp,trigger[3].Replace("^",","),xx,yy,ww,hh);
										}
									}
								break;
							}
						}
					}
					//
					//customs
					bool validblock = true; //24Feb2021
					for(int i=0;i<data2.Length;i++)
					{
						//Unit Template.....
						errline = data2[i];
						if(data2[i].IndexOf("=")>0)
						{
							if((data2[i].Substring(0,data2[i].IndexOf("="))=="mission")) //24Feb2021
							{//24Feb2021
								validblock = true;//24Feb2021
							}//24Feb2021
							if(!validblock)//24Feb2021
							{//24Feb2021
								continue;//24Feb2021
							}//24Feb2021
							switch(data2[i].Substring(0,data2[i].IndexOf("=")))
							{
								case "mission":
								validblock = true; //24Feb2021
								if(!custommissionvalid(game,data2,i))//24Feb2021
								{//24Feb2021
									validblock = false;
									continue;
								}//24Feb2021
								id++;
								Game.missions[id] = new Mission();
								Game.missions[id].name = readstring(data2[i]);
								Game.missions[id].custom = true;
								Game.missions[id].gridw = Map.DEFAULTGRIDW;//10sep2021
								Game.missions[id].gridh = Map.DEFAULTGRIDH;//10sep2021
								toomanytrees = 0;
								toomanyrocks = 0;
								countunits = 0;
								for(int j=i+1;j<data2.Length;j++)
								{
									if(data2[j].IndexOf("=")>0)
									{
										if(data2[j].Substring(0,data2[j].IndexOf("="))=="unit")
										{
											countunits++;
										}
										if(data2[j].Substring(0,data2[j].IndexOf("="))=="mission")
										{
											break;
										}
										if(data2[j].Substring(0,data2[j].IndexOf("="))=="tutorial")
										{
											break;
										}
										if(data2[j].Substring(0,data2[j].IndexOf("="))=="objective")
										{
											countobjectives++;
										}
									}
								}
								if(countunits>0)
								{
									Game.missions[id].units = new Unit[countunits];
									unitid = -1;
								}
								if(countobjectives>0)
								{
									Game.missions[id].objectives = new string[countobjectives];
								}
								break;
								//26oct2020 start
								case "cw":
									cw = readint(data2[i]);
								break;
								case "ch":
									ch = readint(data2[i]);
								break;
								case "nw":
									nw = readint(data2[i]);
								break;
								case "nh":
									nh = readint(data2[i]);
								break;
								case "offy":
									offy = readint(data2[i]);
								break;
								//start-----------------//10sep2021
								case "gridw":
								Game.missions[id].gridw = readint(data2[i]);
								break;
								case "gridh":
								Game.missions[id].gridh = readint(data2[i]);
								break;
								//end-------------------//10sep2021
								//1nov2020 start
								case "override_bk_red":
								Game.missions[id].overridergbbk = true;
								Game.missions[id].overridergbbk_r = readint(data2[i]);
								break;
								case "override_bk_green":
								Game.missions[id].overridergbbk = true;
								Game.missions[id].overridergbbk_g = readint(data2[i]);
								break;
								case "override_bk_blue":
								Game.missions[id].overridergbbk = true;
								Game.missions[id].overridergbbk_b = readint(data2[i]);
								break;
								//1nov2020 end
								case "override_ground":
									Game.missions[id].tilecat = Resources.LoadAnimImage(game,readstring(data2[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].tileframes = nw * nh;
									if(readstring(data2[i]).IndexOf("snow")>0)
									{
										Game.missions[id].issnow = true;
									}
									if(readstring(data2[i]).IndexOf("desert")>0)
									{
										Game.missions[id].isdesert = true;
									}
								break;
								case "override_trees":
									Game.missions[id].treecat = Resources.LoadAnimImage(game,readstring(data2[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].treeframes = nw * nh;
									Game.missions[id].treeoffsety = offy;
								break;
								//start--------------//2mar2021
								case "override_decor":
									Game.missions[id].decorcat = Resources.LoadAnimImage(game,readstring(data2[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].decorframes = nw * nh;
									Game.missions[id].decoroffsety = offy;
								break;
								//end----------------//2mar2021
								case "override_rocks":
									Game.missions[id].rockcat = Resources.LoadAnimImage(game,readstring(data2[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].rockframes = nw * nh;
									Game.missions[id].rockoffsety = offy;
								break;
								case "override_walls":
									Game.missions[id].wallcat = Resources.LoadAnimImage(game,readstring(data2[i]),Game.renderer,cw,ch,nw,nh);
									Game.missions[id].wallframes = nw * nh;
									Game.missions[id].walloffsety = offy;
								break;
								//26oct2020 end
								case "nextmissionid":
									Game.missions[id].nextmissionid = readint(data2[i]);
								break;
								case "debrief":
									Game.missions[id].debrief = readint(data2[i]);
								break;
								case "failedmissionid":
									Game.missions[id].failedmissionid = readint(data2[i]);
								break;
								//start--------------//1mar2021
								case "nextmissionname":
									Game.missions[id].nextmissionname = readstring(data2[i]);
								break;
								case "failedmissionname":
									Game.missions[id].failedmissionname = readstring(data2[i]);
								break;
								//end----------------//1mar2021
								case "demo":
									Game.missions[id].demo = 0;//readint(data2[i]);
								break;
								//start-----------//26Feb2021
								case "fogoff":
									Game.missions[id].fogoff = readint(data2[i]);
								break;
								case "neutralfog":
									Game.missions[id].neutralfog = readint(data2[i]);
								break;
								//end-------------//26Feb2021
								//start-------------//28Feb2021
								case "playerfaction":
									Game.missions[id].playerfaction = readint(data2[i]);
								break;
								case "enemyfaction":
									Game.missions[id].skirmishenemyfaction = readint(data2[i]);
								break;
								case "flavourtext"://18sep2021
									Game.missions[id].flavourtext = readstring(data2[i]);
								break;
								case "floorpattern"://16sep2021
									Game.missions[id].floorpattern = readint(data2[i]);
								break;
								case "unlocked":
									Game.missions[id].alwaysunlocked = readint(data2[i]);
								break;
								//end---------------//28Feb2021
								//start--------------//1mar2021
								case "lockcorner":
									Game.missions[id].lockcorner = readint(data2[i]);
								break;
								//end----------------//1mar2021
								case "corner":
									string[] tmpcorner = readstring(data2[i]).Split(",");
									if(tmpcorner.Length==2)
									{
										Int32.TryParse(tmpcorner[0],out Game.missions[id].cornerx);
										Int32.TryParse(tmpcorner[1],out Game.missions[id].cornery);
									}
								break;
								case "seed":
									Game.missions[id].seed = readint(data2[i]);
								break;
								case "skirmish":
									Game.missions[id].skirmish = readint(data2[i]);
								break;
								case "indoor"://23sep2021
								Game.missions[id].indoor = readint(data2[i]);	
								break;
								case "mapgen":
									Game.missions[id].mapgen = 1;
								break;
								case "ai":
									Game.missions[id].ai = readint(data2[i]);
								break;
								case "description":
									if(Game.missions[id].description[0] == "")
									{
										//Game.missions[id].description[0] = readstring(data2[i]);//21mar2021
										Game.missions[id].description[0] = Translation.TranslateWord(readstring(data2[i]),false);//21mar2021
									}
									else
									{
										if(Game.missions[id].description[1] == "")
										{
											//Game.missions[id].description[1] = readstring(data2[i]);//22mar2021
											Game.missions[id].description[1] = Translation.TranslateWord(readstring(data2[i]),false);//22mar2021
										}
										else
										{
											//Game.missions[id].description[2] = readstring(data2[i]);//22mar2021
											Game.missions[id].description[2] = Translation.TranslateWord(readstring(data2[i]),false);//22mar2021
										}
									}
								break;
								case "istutorial":
									Game.missions[id].istutorial = 0;//readint(data[i]);
								break;
								//start--------------//2mar2021
								case "decor":
								if(id>=0)
								{
									string[] tmpdecor = readstring(data2[i]).Split(",");
									Game.missions[id].decorimage = new int[tmpdecor.Length];
									for(int j=0;j<tmpdecor.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmpdecor[j],out tt);
										Game.missions[id].decorimage[j] = tt;
									}
								}
								break;
								//end----------------//2mar2021
								case "trees":
								if(id>=0)
								{
									string[] tmptrees = readstring(data2[i]).Split(",");
									Game.missions[id].treeimage = new int[tmptrees.Length];
									for(int j=0;j<tmptrees.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmptrees[j],out tt);
										Game.missions[id].treeimage[j] = tt;
									}
								}
								break;
								case "walls":
								if(id>=0)
								{
									string[] tmpwalls = readstring(data2[i]).Split(",");
									Game.missions[id].wallimage = new int[tmpwalls.Length];
									for(int j=0;j<tmpwalls.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmpwalls[j],out tt);
										Game.missions[id].wallimage[j] = tt;
									}
								}
								break;
								case "rocks":
								if(id>=0)
								{
									string[] tmprocks = readstring(data2[i]).Split(",");
									Game.missions[id].rockimage = new int[tmprocks.Length];
									for(int j=0;j<tmprocks.Length;j++)
									{
										int tt = -1;
										Int32.TryParse(tmprocks[j],out tt);
										Game.missions[id].rockimage[j] = tt;
									}
								}
								break;
								case "setfire":
								if(id>=0)
								{
									string[] tmpfire = readstring(data2[i]).Split(",");
									if(tmpfire.Length==2)
									{
										Game.missions[id].campfirex = -1;
										Game.missions[id].campfirey = -1;
										Int32.TryParse(tmpfire[0],out Game.missions[id].campfirex);
										Int32.TryParse(tmpfire[1],out Game.missions[id].campfirey);
									}
								}
								break;
								case "objective":
									objective++;
									//Game.missions[id].objectives[objective] = readstring(data2[i]);//22mar2021
									Game.missions[id].objectives[objective] = Translation.TranslateWord(readstring(data2[i]),false);//22mar2021
								break;
								case "showkills":
									Game.missions[id].showkills = readint(data2[i]);
								break;
								case "unit":
									string[] unitlist = readstring(data2[i]).Split(",");
									if(unitlist.Length==3)
									{
										bool success1 = true;
										bool success2 = true;
										string name = unitlist[0];
										int x = 0;
										int y = 0;
										if(unitlist[1]=="random")
										{
											x = Functions.rand(Map.GRIDW * 35,Map.GRIDW*65);
											success1 = true;
										}
										else
										{
											success1 = Int32.TryParse(unitlist[1],out x);
										}
										if(unitlist[2]=="random")
										{
											y = Functions.rand(Map.GRIDH * 35,Map.GRIDH*65);
											success2 = true;
										}
										else
										{
											success2 = Int32.TryParse(unitlist[2],out y);
										}
										if(success1 && success2)
										{
											unitid++;
											Game.missions[id].units[unitid] = new Unit(game);
											Game.missions[id].units[unitid].x = x;
											Game.missions[id].units[unitid].y = y;
											Game.missions[id].units[unitid].name = name;
										}
									}
								break;
								//start--------------//10sep2021
								case "unitname"://unit name must immediately follow the unit that was just created....
								if(Game.missions[id].units!=null)
								{
									if(unitid<Game.missions[id].units.Length && unitid>=0)
									{
										Game.missions[id].units[unitid].charactername = readstring(data2[i]);
									}
								}
								break;
								case "displayunitname":
								if(Game.missions[id].units!=null)
								{
									if(unitid<Game.missions[id].units.Length && unitid>=0)
									{
										Game.missions[id].units[unitid].displaycharactername = readint(data2[i]);
									}
								}
								break;
								//end----------------//10sep2021
								case "trigger":
								//type,num,comparator,name,xx,yy,ww,hh
								//type == 1 Victory
								//type == 2 Defeat
								//comparator == 0 equal
								//comparator == -1 less than
								//comparator == 1 greater than
									if(id>=0)
									{
										string[] trigger = readstring(data2[i]).Split(",");
										if(trigger.Length==8)
										{
											int typ = 0;
											int num = 0;
											int comp = 0;
											Int32.TryParse(trigger[0],out typ);
											Int32.TryParse(trigger[1],out num);
											Int32.TryParse(trigger[2],out comp);
											int xx = 0;
											int yy = 0;
											int ww = 0;
											int hh = 0;
											Int32.TryParse(trigger[4],out xx);
											Int32.TryParse(trigger[5],out yy);
											Int32.TryParse(trigger[6],out ww);
											Int32.TryParse(trigger[7],out hh);
											Game.missions[id].createtrigger(typ,num,comp,trigger[3].Replace("^",","),xx,yy,ww,hh);
										}
									}
								break;
							}
						}
					}
				}
				LocalStorage.setitem("FILE LOAD:"+file,"SUCCESS");//24mar2021
			}
			catch(Exception e)
			{
				Game.WriteDebug("766:"+"Error in file on line containing:"+errline+" "+e.Message);
				//LocalStorage.WriteLog("766:"+"Error in file on line containing:"+errline+" "+e.Message);
				LocalStorage.setitem("FILE LOAD:"+file,"FAILED");//24mar2021
			}
		}

///////////////////Method Definition///////////////
		public static int LoadFont(Game game,string file,int ptsize)
		{
			////////////////////////
			//Load a font in the game for use
			Fonts f = new Fonts();
			//ptsize*=Config.FONTALIAS;
			if(file!="" && file!=null)//28Feb2021
			{
				if(ptsize>=20)
				{
					f.font = SDL_ttf.TTF_OpenFont(file,ptsize*Config.FONTALIAS);
				}
				else
				{
					f.font = SDL_ttf.TTF_OpenFont(file,ptsize);
				}
			}
			if(f.font==IntPtr.Zero)
			{
				Game.WriteDebug("Could Not Open Font:"+file+". Error:"+SDL.SDL_GetError());
				Network.reporterror("FontLoadFailure:"+file,false);//15mar2021
				LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD");
			}
			else
			{
				LocalStorage.setitem("FILE LOAD:"+file,"LOADED");
			}
			int i = Game.fonts.Length;
			Array.Resize<Fonts>(ref Game.fonts,i+1);
			f.file = file;//24mar2021
			Game.fonts[i] = f;
			Game.fonts[i].font = f.font;
			Game.fonts[i].ptsize = ptsize;
			i++;
			return i - 1;
		}
		//

///////////////////Method Definition///////////////
		public static int LoadAudio(Game game,string file,bool music)
		{
			////////////////////////
			//Load an Audio file of .wav type
			for(int j=0;j<Game.audios.Length;j++)
			{
				if(Game.audios[j].file==file)
				{
					return j;
				}
			}
			Audios a = new Audios();
			a.loop = music;
			a.file = file; //25mar2021
			if(music)
			{
				if(!Config.STREAMLOADAUDIO)//25mar2021
				{
					if(file!="" && file!=null)//28Feb2021
					{
						a.audio = SDL_mixer.Mix_LoadMUS(file);
					}
					if(a.audio==IntPtr.Zero)
					{
						Game.WriteDebug("Could Not Load Music:"+file+". Error:"+SDL.SDL_GetError());
						Network.reporterror("MusicLoadFailure:"+file,false);//15mar2021
						LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD"); //24mar2021
					}
					else //24mar2021
					{
						LocalStorage.setitem("FILE LOAD:"+file,"LOADED"); //24mar2021
					}
				}
				else
				{
					//do nothing yet...
				}
				a.ismusic = true;
			}
			else
			{
				if(file!="" && file!=null)//28Feb2021
				{
					a.audio = SDL_mixer.Mix_LoadWAV(file);
				}
				if(a.audio==IntPtr.Zero)
				{
					Game.WriteDebug("Could Not Load Sound:"+file+". Error:"+SDL.SDL_GetError());
					Network.reporterror("SoundLoadFailure:"+file,false);//15mar2021
					LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD"); //24mar2021
				}
				else//24mar2021
				{
					LocalStorage.setitem("FILE LOAD:"+file,"LOADED"); //24mar2021
				}
			
			}
			int i = Game.audios.Length;
			Array.Resize<Audios>(ref Game.audios,i+1);
			Game.audios[i] = a;
			Game.audios[i].index = i;
			Game.audios[i].loop = music;
			Game.audios[i].volume = 1;
			Game.audios[i].file = file;
			i++;
			return i - 1;
		}
		//
		//start-------------//28Feb2021

///////////////////Method Definition///////////////
		public static void StreamImage(Game game,int i)
		{
			////////////////////////
			//not used
			//used after an image is released...and we want to reload it in Game....in a separate thread.
			if(i>=0 && i<Game.images.Length)
			{
				if(Game.images[i].loaded==false && Game.images[i].stream==false)
				{
					if(Game.images[i].texture==IntPtr.Zero)
					{
						Game.images[i].stream = true;
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static bool FreeImage(Game game,int i)
		{
			////////////////////////
			//frees images from memory
			if(i>=0 && i<Game.images.Length)
			{
				if(Game.images[i].texture!=IntPtr.Zero && Game.images[i].loaded==true)
				{
					LocalStorage.setitem("FREE IMAGE:"+Game.images[i].file,"FAILED"); //24mar2021
					SDL.SDL_DestroyTexture(Game.images[i].texture);
					LocalStorage.setitem("FREE IMAGE:"+Game.images[i].file,"SUCCESS"); //24mar2021
					Game.images[i].loaded = false;
					Game.images[i].texture = IntPtr.Zero;
					return true;
				}
			}
			return false;
		}
		//end---------------//28Feb2021
		//

///////////////////Method Definition///////////////
		public static int LoadImage(Game game,string file,IntPtr renderer,int w,int h) //note the slight change.....added w and h as can't work out how to do it otherwise....
		{
			////////////////////////
			//Load an image of the form .png or .jpg into memory
			bool loaded = false;//28Feb2021
			for(int j=0;j<Game.images.Length;j++)//26oct2020
			{
				if(Game.images[j].file==file)
				{
					//start-------------//28Feb2021
					if(Game.images[j].loaded==false) //assumes the image was loaded once before successfully, cleared out and needs to be loaded again.....
					{
						Game.images[j].texture = SDL_image.IMG_LoadTexture(renderer,file);
						if(Game.images[j].texture==IntPtr.Zero)
						{
							Game.WriteDebug("Could Not Load Texture:"+file+". Error:"+SDL.SDL_GetError());
							Network.reporterror("TextureLoadFailure:"+file,false);//15mar2021
							LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD");//24mar2021
						}
						else
						{
							Game.images[j].loaded = true;
							LocalStorage.setitem("FILE LOAD:"+file,"LOADED"); //24mar2021
						}
					}
					//end---------------//28Feb2021
					return j;
				}
			}
			Images img = new Images();
			if(!Config.STREAMLOAD) //28Feb2021
			{
				if(file!="" && file!=null)//28Feb2021
				{
					img.texture = SDL_image.IMG_LoadTexture(renderer,file);
				}
				if(img.texture==IntPtr.Zero)
				{
					Game.WriteDebug("Could Not Load Texture:"+file+". Error:"+SDL.SDL_GetError());
					Network.reporterror("TextureLoadFailure:"+file,false);//15mar2021
					LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD");//24mar2021
				}
				else
				{
					loaded = true;
					LocalStorage.setitem("FILE LOAD:"+file,"LOADED");//24mar2021
				}
			}
			int i = Game.images.Length;
			Array.Resize<Images>(ref Game.images,i+1);
			Game.images[i] = img;
			Game.images[i].file = file;//26oct2020
			Game.images[i].texture = img.texture;
			Game.images[i].anim = false;
			Game.images[i].index = i;
			Game.images[i].cwx = w;//??
			Game.images[i].chy = h;//??
			Game.images[i].chn = 1;
			Game.images[i].cwn = 1;
			Game.images[i].stream = Config.STREAMLOAD;//28Feb2021
			Game.images[i].loaded = loaded; ///28Feb2021
			Game.images[i].okloaded = loaded; //28Feb2021
			Game.images[i].neverloaded = !loaded; //28Feb2021
			i++;
			return i - 1;
		}
		//

///////////////////Method Definition///////////////
		public static int LoadAnimImage(Game game,string file,IntPtr renderer,int cellwidth, int cellheight, int cellswide, int cellshigh)
		{
			////////////////////////
			//Load an animated image of the form .png or .jpg into memory
			bool loaded = false; //28Feb2021
			for(int j=0;j<Game.images.Length;j++)//26oct2020
			{
				if(Game.images[j].file==file)
				{
					//start-------------//28Feb2021
					if(Game.images[j].loaded==false) //assumes the image was loaded once before successfully, cleared out and needs to be loaded again.....
					{
						Game.images[j].texture = SDL_image.IMG_LoadTexture(renderer,file);
						if(Game.images[j].texture==IntPtr.Zero)
						{
							Game.WriteDebug("Could Not Load Texture:"+file+". Error:"+SDL.SDL_GetError());
							Network.reporterror("TextureLoadFailure:"+file,false);//15mar2021
							LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD");//24mar2021
						}
						else
						{
							Game.images[j].loaded = true;
							LocalStorage.setitem("FILE LOAD:"+file,"LOADED");//24mar2021
						}
					}
					//end---------------//28Feb2021
					return j;
				}
			}
			Images img = new Images();
			if(!Config.STREAMLOAD) //28Feb2021
			{
				if(file!="" && file!=null) //28Feb2021
				{
					img.texture = SDL_image.IMG_LoadTexture(renderer,file);
				}
				if(img.texture==IntPtr.Zero)
				{
					Game.WriteDebug("Could Not Load Texture:"+file+". Error:"+SDL.SDL_GetError());
					Network.reporterror("TextureLoadFailure:"+file,false);//15mar2021
					LocalStorage.setitem("FILE LOAD:"+file,"FAILED TO LOAD");//24mar2021
				}
				else
				{
					loaded = true;
					LocalStorage.setitem("FILE LOAD:"+file,"LOADED");//24mar2021
				}
			}
			int i = Game.images.Length;
			Array.Resize<Images>(ref Game.images,i+1);
			Game.images[i] = img;
			Game.images[i].file = file;//26oct2020
			Game.images[i].texture = img.texture;
			Game.images[i].anim = true;
			Game.images[i].index = i;
			Game.images[i].cwx = cellwidth;
			Game.images[i].chy = cellheight;
			Game.images[i].chn = cellshigh;
			Game.images[i].cwn = cellswide;
			Game.images[i].stream = Config.STREAMLOAD;//28Feb2021
			Game.images[i].loaded = loaded;//28Feb2021
			Game.images[i].okloaded = loaded; //28Feb2021
			Game.images[i].neverloaded = !loaded; //28Feb2021
			i++;
			return i - 1;
		}
	}
	//

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Fonts
	{
		public IntPtr font;
		public int ptsize;
		public static int WMULTIPLIER = 1; //15mar2021
		public static int HMULTIPLIER = 1; //17apr2021
		public string file;

///////////////////Method Definition///////////////
		public Fonts()
		{
			file = "";
		}
	}
	//

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Audios
	{
		public int index;
		public bool loop;
		public int volume;
		//
		public IntPtr audio;
		public bool ismusic;
		public bool ispaused;
		public int[] channel;
		public static int maxchannels = 8;
		public string file;
		public int previousmusicchannel;
		public int currentmusicchannel;
		//
		//

///////////////////Method Definition///////////////
		public Audios()
		{
			loop = false;
			volume = 1;
			index = 0;
			ismusic = false;
			channel = new int[Audios.maxchannels];
			ispaused = false;
			file = "";//25mar2021
		}
		//

///////////////////Method Definition///////////////
		public static int playsound(Audios a,int vol)
		{
			////////////////////////
			//play an audio clip at a specified volume from 0 to 100
			if(!Game.audioon)
			{
				return -1;
			}
			if(!a.ismusic)
			{
				//start-------------//10sep2021
				//in case we freed at a certain point.....
				//in the Game....
				if(a.audio==IntPtr.Zero)
				{
					if(a.file!=null)
					{
						if(a.file!="")
						{
							a.audio = SDL_mixer.Mix_LoadWAV(a.file);
						}
					}
				}
				//end---------------//10sep2021
				int i = SDL_mixer.Mix_PlayChannel(-1,a.audio,0);
				SDL_mixer.Mix_Volume(i,vol);
				return i;
			}
			return -1;
		}

///////////////////Method Definition///////////////
		public static void playmusic(Audios a,int vol,bool loop)
		{
			//play a music clip at a specified volume from 0 to 100, and perhaps loop it
			if(!Game.audioon)
			{
				return;
			}
			if(a.ismusic)
			{
				if(a.ispaused)
				{
					SDL_mixer.Mix_ResumeMusic();
					a.ispaused = false;
				}
				else
				{
					int i = SDL_mixer.Mix_PlayMusic(a.audio,-1);
					SDL_mixer.Mix_VolumeMusic(vol);
					a.previousmusicchannel = a.currentmusicchannel;
					a.currentmusicchannel = i;
					a.ispaused = false;
				}
			}
		}

///////////////////Method Definition///////////////
		public static void FreeAudio(Audios a)//10sep2021
		{
			//alias for freeaudio(Audios a)
			freeaudio(a);
		}
///////////////////Method Definition///////////////
		public static void freeaudio(Audios a)//10sep2021
		{
			if(a.ismusic)
			{
				return;
			}
			try
			{
				SDL_mixer.Mix_FreeChunk(a.audio);
				LocalStorage.setitem("FREE AUDIO:"+a.file,"SUCCESS"); //24mar2021
				a.audio = IntPtr.Zero;
			}
			catch(Exception e)
			{
				string txt = e.Message;
			}
		}
///////////////////Method Definition///////////////
		public static void stopchannel(int i)//10sep2021
		{
			try
			{
				SDL_mixer.Mix_HaltChannel(i);
			}
			catch(Exception e)
			{
				string txt = e.Message;
			}
		}
///////////////////Method Definition///////////////
		public static void pauseaudio(Audios a)
		{
			//pause an audio music track that is playing
			//and stop all other audio at the same time.
			if(a.ismusic)
			{
				SDL_mixer.Mix_PauseMusic();
				a.ispaused = true;
			}
			else
			{
			}
			SDL_mixer.Mix_HaltChannel(-1);
		}

///////////////////Method Definition///////////////
		public static void resumemusic(Audios a)
		{
			//resume a music track that is paused.
			if(!Game.audioon)
			{
				return;
			}
			if(a.ismusic)
			{
				SDL_mixer.Mix_ResumeMusic();
				a.ispaused = false;
			}
		}
	}
	//

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Images
	{
		public IntPtr texture;
		public int index;
		public bool anim;
		public int cwx;
		public int chy;
		public int chn;
		public int cwn;
		public string file; //26oct2020
		public bool loaded;//28Feb2021
		public bool stream; //28Feb2021
		public int drawframe; //28Feb2021
		public bool okloaded; //28Feb2021
		public bool neverloaded; //28Feb2021

///////////////////Method Definition///////////////
		public Images()
		{
		}

///////////////////Method Definition///////////////
		public Images(int i,bool a,int cw, int ch, int xn, int yn)
		{
			index = i;
			anim = a;
			cwx = cw;
			chy = ch;
			cwn = xn;
			chn = yn;
			loaded = false;//28Feb2021
			okloaded = false; //28Feb2021
			stream = Config.STREAMLOAD; //28Feb2021
			neverloaded = true;//28Feb2021
		}
	}
	//

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class RenderList
	{
		//
		public static int renderframe = 0;
		public static int transitionmode = -1; //18apr2021
		public static int HALFTRANSIT = 30;//18apr2021
		public static int TRANSITIONRATE = 3;//18apr2021//21oct2021 changed to 3 from 1...
		public static int STARTTRANSITION = 60;//18apr2021
		public static int screenshake = 0;
		public static bool IGNOREZOOM;
		public static int RENDERMODE = 0;
		public static int RENDERMODE_POOL = 0;
		public static int RENDERMODE_NONPOOL = 1;
		public IntPtr texture;
		public bool istext;
		public bool isrect;
		public bool isline;
		public bool filled;
		public int x;
		public int y;
		public int w;
		public int h;
		public int blend;
		public int index;
		public int frame;
		public uint color;
		public float sx;
		public float sy;
		public bool flipx;
		public bool flipy;
		public float alpha;
		public float angle;
		public string text;
		public IntPtr font;
		public int fontindex;//2apr2021//7apr2021
		public bool drawn;
		public bool centre;
		public bool ignorezoom;
		public bool ignorefontalias;
		//
		public static int renderi = 0;
		public static int maxrenderi = 0;
		//
		public static int offsetx = 0;
		public static int offsety = 0;
		//
		public static bool threadrunning = false;
		public static int recordframe = 0;
		public static IntPtr screenshotsurface;

		//start--------------//2apr2021
		public bool subimage;
		public int subx;
		public int suby;
		public int subw;
		public int subh;
		//end----------------//2apr2021
		
///////////////////Method Definition///////////////
		public static void init()
		{
			//RenderList has an init function that is called once before drawing
			renderi = 0;
			maxrenderi = 0;
		}

///////////////////Method Definition///////////////
		public static bool CaptureThread(IntPtr screenshotsurface)
		{
			//Separate thread used for capturing screenshots
			//screenshot is captured in the main thread
			//but the file is saved in a secondary thread to
			//prevent performance hits
			//if we had a faster hard drive we could capture movies this way..!
			if(threadrunning)
			{
				return false;
			}
			threadrunning = true;
			RenderList.screenshotsurface = screenshotsurface;
			Thread thread = new Thread(new ThreadStart(ThreadFunction));
			thread.Start();	
			return true;
		}

///////////////////Method Definition///////////////
		private static void ThreadFunction()
		{
			//screenshot saving thread
			recordframe++;
			//SDL.SDL_SaveBMP(screenshotsurface,"media/screenshots/img_"+Functions.zstr(recordframe,6)+".bmp");
			try //13mar2021 - try catch block added....
			{
			SDL_image.IMG_SavePNG(screenshotsurface,"media/screenshots/img_"+Functions.zstr(recordframe,6)+".png");	
			}
			catch(Exception e)
			{
				Game.WriteDebug("Thread Error Taking Screenshot:"+e.Message);
			}
			try
			{
				SDL.SDL_FreeSurface(screenshotsurface);
			}
			catch(Exception e)
			{
				string msg = e.Message;
			}
			threadrunning = false;
		}

///////////////////Method Definition///////////////
		public RenderList()
		{
			drawn = false;	
			text = "";
			font = IntPtr.Zero;
			texture = IntPtr.Zero;
			centre = false;
			ignorezoom = true;
			ignorefontalias = false;
			subimage = false;//2apr2021
			subx = 0;
			suby = 0;
			subw = 0;
			subh = 0;
		}

///////////////////Method Definition///////////////
		public static void render(Game game)
		{
			////////////////////////
			//Core Render function that is called in the game
			//Takes all the drawimage/drawrect/drawtext calls that were stored
			//in an array and draws them one after the other
			//start------//15mar2021
			bool chinese = false;
			renderframe++;
			Functions.saveseed(Functions.seed);
			if(Translation.GetLanguage()=="chinesesimplified")
			{
				chinese = true;
			}
			if(Config.useUNICODE)
			{
				chinese = true;
			}
			//end--------//15mar2021
			SDL.SDL_Rect src;
			SDL.SDL_Rect dst;
			int SW = 0;
			int SH = 0;
			SDL.SDL_GetRendererOutputSize(Game.renderer,out SW,out SH);
			Game.SW = SW;
			Game.SH = SH;
			float gxscale = 1f;
			float gyscale = 1f;
			for(int i=0;i<RenderList.renderi;i++)
			{
				//start----//19apr2021
				int origx = Game.renderlist[i].x;
				int origy = Game.renderlist[i].y;
				float origsx = Game.renderlist[i].sx;
				float origsy = Game.renderlist[i].sy;
				int origw = Game.renderlist[i].w;
				int origh = Game.renderlist[i].h;
				//end------//19apr2021
				gxscale = (float)SW / (float)Game.RESOLUTIONX;
				gyscale = (float)SH / (float)Game.RESOLUTIONY;
				Game.renderlist[i].x+=RenderList.offsetx;
				Game.renderlist[i].y+=RenderList.offsety;
				if(Game.renderlist[i].ignorezoom==false)
				{
					Game.renderlist[i].x = Convert.ToInt32((float)Game.renderlist[i].x*gxscale*Game.zoom) + Game.zoomcornerx;
					Game.renderlist[i].y = Convert.ToInt32((float)Game.renderlist[i].y*gyscale*Game.zoom) + Game.zoomcornery;
					Game.renderlist[i].sx = ((float)Game.renderlist[i].sx*gxscale*Game.zoom);
					Game.renderlist[i].sy = ((float)Game.renderlist[i].sy*gyscale*Game.zoom);
					Game.renderlist[i].w = Convert.ToInt32((float)Game.renderlist[i].w*gxscale*Game.zoom);
					Game.renderlist[i].h = Convert.ToInt32((float)Game.renderlist[i].h*gyscale*Game.zoom);	
				}
				else
				{
					Game.renderlist[i].x = Convert.ToInt32((float)Game.renderlist[i].x*gxscale);
					Game.renderlist[i].y = Convert.ToInt32((float)Game.renderlist[i].y*gyscale);
					Game.renderlist[i].sx = ((float)Game.renderlist[i].sx*gxscale);
					Game.renderlist[i].sy = ((float)Game.renderlist[i].sy*gyscale);
					Game.renderlist[i].w = Convert.ToInt32((float)Game.renderlist[i].w*gxscale);
					Game.renderlist[i].h = Convert.ToInt32((float)Game.renderlist[i].h*gyscale);
				}
				if(screenshake>0)
				{
					screenshake--;
					int offsetx=(int)(gxscale*(float)(Functions.rand(0,screenshake+1)-screenshake/2));
					int offsety=(int)(gyscale*(float)(Functions.rand(0,screenshake+1)-screenshake/2));
					Game.renderlist[i].x+=offsetx;
					Game.renderlist[i].y+=offsety;
				}
				//
				if(Game.renderlist[i].sx<0)
				{
					Game.renderlist[i].sx*=-1;
					Game.renderlist[i].flipx = true;
				}
				else
				{
					Game.renderlist[i].flipx = false;
				}
				if(Game.renderlist[i].sy<0)
				{
					Game.renderlist[i].sy*=-1;
					Game.renderlist[i].flipy = true;
				}
				else
				{
					Game.renderlist[i].flipy = false;
				}
				SDL.SDL_SetRenderDrawColor(Game.renderer,RenderList.getcomponents(Game.renderlist[i].color)[1],RenderList.getcomponents(Game.renderlist[i].color)[2],RenderList.getcomponents(Game.renderlist[i].color)[3],RenderList.getcomponents(Game.renderlist[i].color)[0]);
				if(Game.renderlist[i].isrect)
				{
					dst.x = Game.renderlist[i].x;
					dst.y = Game.renderlist[i].y;
					dst.w = Game.renderlist[i].w;
					dst.h = Game.renderlist[i].h;
					if(Game.renderlist[i].filled)
					{
						SDL.SDL_RenderFillRect(Game.renderer,ref dst);
					}
					else
					{
						SDL.SDL_RenderDrawRect(Game.renderer,ref dst);
					}
				}
				if(Game.renderlist[i].isline)
				{
					SDL.SDL_RenderDrawLine(Game.renderer,Game.renderlist[i].x,Game.renderlist[i].y,Game.renderlist[i].x+Game.renderlist[i].w,Game.renderlist[i].y+Game.renderlist[i].h);
				}
				if(Game.renderlist[i].istext)
				{
					SDL.SDL_Color color;
					color.r = RenderList.getcomponents(Game.renderlist[i].color)[1];
					color.g = RenderList.getcomponents(Game.renderlist[i].color)[2];
					color.b = RenderList.getcomponents(Game.renderlist[i].color)[3];
					color.a = (byte)Convert.ToInt32(255f * Game.renderlist[i].alpha);
					IntPtr text_surface;
					if(!chinese) //15mar2021
					{
						text_surface = SDL_ttf.TTF_RenderText_Solid(Game.renderlist[i].font,Game.renderlist[i].text,color); 
					}
					else
					{
						text_surface = SDL_ttf.TTF_RenderUNICODE_Solid(Game.renderlist[i].font,Game.renderlist[i].text,color);  //15mar2021
					}
					dst.x = Game.renderlist[i].x;
					dst.y = Game.renderlist[i].y;
					if(!chinese) //15mar2021
					{
						SDL_ttf.TTF_SizeText(Game.renderlist[i].font,Game.renderlist[i].text,out dst.w,out dst.h);
					}
					else
					{
						SDL_ttf.TTF_SizeText(Game.renderlist[i].font,Game.renderlist[i].text,out dst.w,out dst.h);
						if(!Translation.AllAscii(Game.renderlist[i].text)) //16mar2021
						{
							//dst.w*=Fonts.WMULTIPLIER;//17mar2021
							if(Game.renderlist[i].text!=null)//17mar2021
							{
								if(Game.renderlist[i].text.Length>0)
								{
									dst.w*=(int)System.Math.Ceiling((double)((float)Fonts.WMULTIPLIER * (float)Translation.CountNonAscii(Game.renderlist[i].text)) / (float)Game.renderlist[i].text.Length); //Huh!?//17mar2021
									dst.h*=(int)System.Math.Ceiling((double)((float)Fonts.HMULTIPLIER * (float)Translation.CountNonAscii(Game.renderlist[i].text)) / (float)Game.renderlist[i].text.Length);//17apr2021
								}
							}
						}
					}
					src.x = 0;
					src.y = 0;
					src.w = dst.w;
					src.h = dst.h;
					if(Game.renderlist[i].ignorefontalias)
					{
						dst.w = Convert.ToInt32((float)dst.w*Game.renderlist[i].sx);
						dst.h = Convert.ToInt32((float)dst.h*Game.renderlist[i].sy);
					}
					else
					{
						dst.w = Convert.ToInt32((float)dst.w*Game.renderlist[i].sx)/Config.FONTALIAS;
						dst.h = Convert.ToInt32((float)dst.h*Game.renderlist[i].sy)/Config.FONTALIAS;
					}
					if(Game.renderlist[i].centre)
					{
						dst.x-=dst.w/2;
						dst.y-=dst.h/2;
					}
					IntPtr tex = SDL.SDL_CreateTextureFromSurface(Game.renderer,text_surface);
					//SDL.SDL_SetTextureScaleMode(tex,SDL.SDL_ScaleMode.SDL_ScaleModeNearest); //already commented out a while ago
					SDL.SDL_FreeSurface(text_surface);
					SDL.SDL_RenderCopyEx(Game.renderer,tex,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);
					SDL.SDL_DestroyTexture(tex);
				}
				SDL.SDL_SetRenderDrawColor(Game.renderer,0,0,0,0);
				if(Game.renderlist[i].texture!=IntPtr.Zero)
				{
					SDL.SDL_SetTextureAlphaMod(Game.renderlist[i].texture,Convert.ToByte(255.0f*Game.renderlist[i].alpha));	
					switch(Game.renderlist[i].blend)
					{
						case 0:
						SDL.SDL_SetTextureBlendMode(Game.renderlist[i].texture,SDL.SDL_BlendMode.SDL_BLENDMODE_BLEND);
						break;
						case 1:
						SDL.SDL_SetTextureBlendMode(Game.renderlist[i].texture,SDL.SDL_BlendMode.SDL_BLENDMODE_ADD);
						break;
					}
					//start--------------//2apr2021
					if(Game.renderlist[i].subimage)
					{
						src.x = Game.renderlist[i].subx;
						src.y = Game.renderlist[i].suby;
						src.w = Game.renderlist[i].subw;
						src.h = Game.renderlist[i].subh;
						dst.x = Game.renderlist[i].x;
						dst.y = Game.renderlist[i].y;
						dst.w = Convert.ToInt32(Game.renderlist[i].subw * Game.renderlist[i].sx);
						dst.h = Convert.ToInt32(Game.renderlist[i].subh * Game.renderlist[i].sy);
						dst.x -= dst.w/2;
						dst.y -= dst.h/2;
						//SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);
						if(Game.renderlist[i].flipx && Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_HORIZONTAL | SDL.SDL_RendererFlip.SDL_FLIP_VERTICAL);
						}
						if(Game.renderlist[i].flipx && !Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_HORIZONTAL);
						}
						if(!Game.renderlist[i].flipx && Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_VERTICAL);
						}
						if(!Game.renderlist[i].flipx && !Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);	
						}
						continue;
					}
					//end----------------//2apr2021
					if(Game.images[Game.renderlist[i].index].anim)
					{
						src.x = Game.images[Game.renderlist[i].index].cwx * (Game.renderlist[i].frame % Game.images[Game.renderlist[i].index].cwn);
						src.y = Game.images[Game.renderlist[i].index].chy * ((Game.renderlist[i].frame - (Game.renderlist[i].frame % Game.images[Game.renderlist[i].index].cwn))/Game.images[Game.renderlist[i].index].cwn);
						src.w = Game.images[Game.renderlist[i].index].cwx;
						src.h = Game.images[Game.renderlist[i].index].chy;
						dst.x = Game.renderlist[i].x;
						dst.y = Game.renderlist[i].y;
						dst.w = Convert.ToInt32(src.w * Game.renderlist[i].sx);
						dst.h = Convert.ToInt32(src.h * Game.renderlist[i].sy);
						dst.x -= dst.w/2;
						dst.y -= dst.h/2;
						if(Game.renderlist[i].flipx && Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_HORIZONTAL | SDL.SDL_RendererFlip.SDL_FLIP_VERTICAL);
						}
						if(Game.renderlist[i].flipx && !Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_HORIZONTAL);
						}
						if(!Game.renderlist[i].flipx && Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_VERTICAL);
						}
						if(!Game.renderlist[i].flipx && !Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);	
						}
					}
					else
					{
						src.x = 0;
						src.y = 0;
						src.w = Game.images[Game.renderlist[i].index].cwx;
						src.h = Game.images[Game.renderlist[i].index].chy;
						dst.x = Game.renderlist[i].x;
						dst.y = Game.renderlist[i].y;
						dst.w = Convert.ToInt32(Game.images[Game.renderlist[i].index].cwx * Game.renderlist[i].sx);
						dst.h = Convert.ToInt32(Game.images[Game.renderlist[i].index].chy * Game.renderlist[i].sy);
						dst.x -= dst.w/2;
						dst.y -= dst.h/2;
						//SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);
						if(Game.renderlist[i].flipx && Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_HORIZONTAL | SDL.SDL_RendererFlip.SDL_FLIP_VERTICAL);
						}
						if(Game.renderlist[i].flipx && !Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_HORIZONTAL);
						}
						if(!Game.renderlist[i].flipx && Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_VERTICAL);
						}
						if(!Game.renderlist[i].flipx && !Game.renderlist[i].flipy)
						{
							SDL.SDL_RenderCopyEx(Game.renderer,Game.renderlist[i].texture,ref src,ref dst,Convert.ToDouble(Game.renderlist[i].angle),IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);	
						}
					}
				}
				//start----//19apr2021
				Game.renderlist[i].x = origx;
				Game.renderlist[i].y = origy;
				Game.renderlist[i].sx = origsx;
				Game.renderlist[i].sy = origsy;
				Game.renderlist[i].w = origw;
				Game.renderlist[i].h = origh;
				//end------//19apr2021
			}		
			if(RenderList.renderi>RenderList.maxrenderi)
			{
				RenderList.maxrenderi = RenderList.renderi;
			}
			//start-----//18apr2021
			if(transitionmode>=0)
			{
				//byte alpha = 255;
				int alpha = 255;
				if(transitionmode < HALFTRANSIT)
				{
					RenderList.renderi = 0;
					//alpha = (byte)(transitionmode * 8);
					alpha = transitionmode * 8;
				}
				else
				{
					//alpha = (byte)((60 - transitionmode) * 8);
					alpha = (60 - transitionmode) * 8;
				}
				src.x = 0;
				src.y = 0;
				src.w = 1;
				src.h = 1;
				dst.x = 0;
				dst.y = 0;
				dst.w = SW;
				dst.h = SH;
				//if(Resources.blackcat!=-1)
				//{
					//SDL.SDL_SetRenderDrawColor(Game.renderer,(byte)(255-alpha),(byte)(255-alpha),(byte)(255-alpha),(byte)255);
					SDL.SDL_SetRenderDrawBlendMode(Game.renderer,SDL.SDL_BlendMode.SDL_BLENDMODE_BLEND);
					SDL.SDL_SetRenderDrawColor(Game.renderer,0,0,0,(byte)alpha);
					//SDL.SDL_SetRenderDrawBlendMode(Game.renderer,SDL.SDL_BlendMode.SDL_BLENDMODE_MUL);
					//SDL.SDL_SetTextureAlphaMod(Game.images[Resources.blackcat].texture,alpha);	
					//SDL.SDL_SetTextureBlendMode(Game.images[Resources.blackcat].texture,SDL.SDL_BlendMode.SDL_BLENDMODE_BLEND);
					//SDL.SDL_RenderCopyEx(Game.renderer,Game.images[Resources.blackcat].texture,ref src,ref dst,0,IntPtr.Zero,SDL.SDL_RendererFlip.SDL_FLIP_NONE);	
					SDL.SDL_RenderFillRect(Game.renderer,ref dst);
					SDL.SDL_SetRenderDrawBlendMode(Game.renderer,SDL.SDL_BlendMode.SDL_BLENDMODE_NONE);
					SDL.SDL_SetRenderDrawColor(Game.renderer,0,0,0,0);
					
					
				//}
				transitionmode-=TRANSITIONRATE;
				Functions.restoreseed();
				return;
				//in other words don't clear the drawing list
				//so that we can draw over the top of it in some way
				//such as a black fade out screen......
			}
			else
			{
				transitionmode = -1;//21oct2021
			}
			//end-------//18apr2021
			RenderList.renderi = 0;
			Functions.restoreseed();
		}
		//draw an image

///////////////////Method Definition///////////////
		public static void drawimage(Game game,IntPtr img,int x,int y,float angle,float scalex,float scaley,int framenumber,int blend,bool istext,float alpha,int celltype)
		{
			//draw an image on the screen 
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//RenderList r = new RenderList();
			//
			r.texture = img;
			r.x = x;
			r.y = y;
			r.w = 0;
			r.h = 0;
			r.isline = false;
			r.color = 0;
			r.alpha = alpha;
			r.angle = angle;
			r.sx = scalex;
			r.sy = scaley;
			r.frame = framenumber;
			r.blend = blend;
			r.istext = false;
			r.isrect = false;
			r.filled = false;
			r.index = celltype;
			//start-------------//28Feb2021
			if(celltype >= 0 && celltype < Game.images.Length)
			{
				Game.images[celltype].drawframe = Game.frame;
			}
			//end---------------//28Feb2021
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}
		//

///////////////////Method Definition///////////////
		public static void drawanimimage(Game game,IntPtr img,int x,int y,float angle,float scalex,float scaley,int framenumber,int blend,bool istext,float alpha,int index)
		{
			//draw an animated image on the screen
			//can be used as an alternative to drawimage, but they are mostly identical now.
			//RenderList r = new RenderList();
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//
			r.texture = img;
			r.x = x;
			r.y = y;
			r.w = 0;
			r.h = 0;
			r.isline = false;
			r.color = 0;
			r.alpha = alpha;
			r.angle = angle;
			r.sx = scalex;
			r.sy = scaley;
			r.frame = framenumber;
			r.blend = blend;
			r.istext = false;
			r.isrect = false;
			r.filled = false;
			r.index = index;
			//start-------------//28Feb2021
			if(index >= 0 && index < Game.images.Length)
			{
				Game.images[index].drawframe = Game.frame;
			}
			//end---------------//28Feb2021
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}

///////////////////Method Definition///////////////
		public static void drawsubimage(Game game,IntPtr img,int x,int y,float angle,float scalex,float scaley,int framenumber,int blend,bool istext,float alpha,int celltype,int ssx,int ssy,int ssw,int ssh)//2apr2021
		{
			//draw an image on the screen 
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//RenderList r = new RenderList();
			//
			r.subimage = true;//2apr2021
			r.subx = ssx;//2apr2021
			r.suby = ssy;//2apr2021
			r.subw = ssw;//2apr2021
			r.subh = ssh;//2apr2021
			r.texture = img;
			r.x = x;
			r.y = y;
			r.w = 0;
			r.h = 0;
			r.isline = false;
			r.color = 0;
			r.alpha = alpha;
			r.angle = angle;
			r.sx = scalex;
			r.sy = scaley;
			r.frame = framenumber;
			r.blend = blend;
			r.istext = false;
			r.isrect = false;
			r.filled = false;
			r.index = celltype;
			//start-------------//28Feb2021
			if(celltype >= 0 && celltype < Game.images.Length)
			{
				Game.images[celltype].drawframe = Game.frame;
			}
			//end---------------//28Feb2021
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}
		//

		//draw primitives

///////////////////Method Definition///////////////
		public static void drawrect(Game game,int x,int y,int w,int h,uint color,int blend)
		{
			//draw a filled rect on the screen
			//RenderList r = new RenderList();
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//
			r.texture = IntPtr.Zero;
			r.x = x;
			r.y = y;
			r.w = w;
			r.h = h;
			r.isline = false;
			r.color = color;
			r.alpha = 1;
			r.angle = 0;
			r.sx = 1;
			r.sy = 1;
			r.frame = 0;
			r.blend = blend;
			r.istext = false;
			r.isrect = true;
			r.filled = true;
			r.index = 0;
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}

///////////////////Method Definition///////////////
		public static void drawunfilledrect(Game game,int x,int y,int w,int h,uint color,int blend)
		{
			//draw an unfilled rect on the screen
			//RenderList r = new RenderList();
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//
			r.texture = IntPtr.Zero;
			r.x = x;
			r.y = y;
			r.w = w;
			r.h = h;
			r.isline = false;
			r.color = color;
			r.alpha = 1;
			r.angle = 0;
			r.sx = 1;
			r.sy = 1;
			r.frame = 0;
			r.blend = blend;
			r.istext = false;
			r.isrect = true;
			r.filled = false;
			r.index = 0;
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}

///////////////////Method Definition///////////////
		public static void drawline(Game game,int sx,int sy,int fx,int fy,uint color,int blend)
		{
			//draw a solid line on the screen
			//can also draw points.
			//RenderList r = new RenderList();
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//
			r.texture = IntPtr.Zero;
			r.x = sx;
			r.y = sy;
			r.w = fx - sx;//(int)Functions.abs(fx - sx);//16oct2021
			r.h = fy - sy;//(int)Functions.abs(fy - sy);//16oct2021
			if(fx<sx)
			{
				sx = fx;
			}
			if(fy<sy)
			{
				sy = fy;
			}
			r.isline = true;
			r.color = color;
			r.alpha = 1;
			r.angle = 0;
			r.sx = 1;
			r.sy = 1;
			r.frame = 0;
			r.blend = blend;
			r.istext = false;
			r.isrect = false;
			r.filled = false;
			r.index = 0;
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}
		//draw text
///////////////////Method Definition///////////////
		public static void drawtext(Game game,int x,int y,string text,uint color,IntPtr font,bool centre)
		{
			//draw text with a certain font on the screen
			//RenderList r = new RenderList();
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//
			r.texture = IntPtr.Zero;
			r.x = x;
			r.y = y;
			r.w = 0;
			r.h = 0;
			r.isline = false;
			r.color = color;
			r.alpha = 1;
			r.angle = 0;
			r.sx = 1;
			r.sy = 1;
			r.frame = 0;
			r.blend = 0;
			r.istext = true;
			r.isrect = false;
			r.filled = false;
			r.index = 0;
			r.text = text;
			r.font = font;
			r.ignorefontalias = false;
			if(font==Game.fonts[Resources.SMALLFONT].font)
			{
				if(Game.fonts[Resources.SMALLFONT].ptsize<20)
				{
					r.ignorefontalias = true;
				}
				r.fontindex = Resources.SMALLFONT;//7apr2021
			}
			if(font==Game.fonts[Resources.FONT].font)
			{
				if(Game.fonts[Resources.FONT].ptsize<20)
				{
					r.ignorefontalias = true;
				}
				r.fontindex = Resources.FONT;//7apr2021
			}
			if(font==Game.fonts[Resources.LARGEFONT].font)
			{
				if(Game.fonts[Resources.LARGEFONT].ptsize<20)
				{
					r.ignorefontalias = true;
				}
				r.fontindex = Resources.LARGEFONT;//7apr2021
			}
			r.centre = centre;
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}

///////////////////Method Definition///////////////
		public static void drawtext(Game game,IntPtr font,int x,int y,float angle,float scalex,float scaley,bool centre,int blend,string text,float alpha,uint color)
		{
			//alternative drawtext command
			//RenderList r = new RenderList();
			RenderList r;
			if(RenderList.renderi<Game.renderlist.Length && RENDERMODE==RENDERMODE_POOL)
			{
				r = Game.renderlist[RenderList.renderi];
				r.drawn = false;	
				r.text = "";
				r.font = IntPtr.Zero;
				r.texture = IntPtr.Zero;
				r.centre = false;
				r.ignorezoom = true;
				r.ignorefontalias = false;
				r.subimage = false;//2apr2021
			}
			else
			{
				r = new RenderList();
			}
			//
			r.texture = IntPtr.Zero;
			r.x = x;
			r.y = y;
			r.w = 0;
			r.h = 0;
			r.isline = false;
			r.color = color;
			r.alpha = alpha;
			r.angle = angle;
			r.sx = scalex;
			r.sy = scaley;
			r.frame = 0;
			r.blend = blend;
			r.istext = true;
			r.isrect = false;
			r.filled = false;
			r.index = 0;
			r.text = text;
			r.font = font;
			r.ignorefontalias = false;
			if(font==Game.fonts[Resources.SMALLFONT].font)
			{
				if(Game.fonts[Resources.SMALLFONT].ptsize<20)
				{
					r.ignorefontalias = true;
				}
				r.fontindex = Resources.SMALLFONT;//7apr2021
			}
			if(font==Game.fonts[Resources.FONT].font)
			{
				if(Game.fonts[Resources.FONT].ptsize<20)
				{
					r.ignorefontalias = true;
				}
				r.fontindex = Resources.FONT;//7apr2021
			}
			if(font==Game.fonts[Resources.LARGEFONT].font)
			{
				if(Game.fonts[Resources.LARGEFONT].ptsize<20)
				{
					r.ignorefontalias = true;
				}
				r.fontindex = Resources.LARGEFONT;//7apr2021
			}
			r.centre = centre;
			if(RenderList.renderi>=RenderList.maxrenderi)
			{
				Array.Resize<RenderList>(ref Game.renderlist,Game.renderlist.Length + 1);
			}
			Game.renderlist[RenderList.renderi] = r;
			Game.renderlist[RenderList.renderi].ignorezoom = IGNOREZOOM;
			RenderList.renderi++;
		}
		//rgb helper functions.

///////////////////Method Definition///////////////
		//public static int getrgb(int r,int g, int b)
		//{
		//	return (int)(255 << 24 | (byte)r << 16 | (byte)g << 8 | (byte)b);
		//}
		
		public static uint getrgb(int r, int g, int b)
		{
			//return the rgb value by its components
			return (uint)(255 << 24 | (byte)r << 16 | (byte)g << 8 | (byte)b);
		}

///////////////////Method Definition///////////////
		public static uint getrgb(byte r,byte g, byte b)
		{
			//return the rgb value by its components
			return (uint)(255 << 24 | r << 16 | g << 8 | b);
		}

///////////////////Method Definition///////////////
		public static byte[] getcomponents(uint argb)
		{
			//get the components of an argb colour and return an array of alpha, red, green, blue as a bunch of byte values
			byte[] rgbarray = {0,0,0,0};
			rgbarray[0] = (byte)((argb >> 24) & (255));
			rgbarray[1] = (byte)((argb >> 16) & (255));
			rgbarray[2] = (byte)((argb >> 8) & 255);
			rgbarray[3] = (byte)((argb & 255));
			return rgbarray;
		}
	}
	//
	

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Network
	{
		//Network.url = "https://www.mattiesgames.com/metrics/metric.php?game="+Game.NETTITLE+"&event=[your event here]&value="[your value here];
		//Network.httpget(Network.url);
		public static string url = "";
		public static string errorreport = "";	
		public static string ERRORURL = "https://www.mattiesgames.com/metrics/metric.php?game=grumthorr&event=errorlog&value=error:";

///////////////////Method Definition///////////////
		private static void ThreadFunction()
		{
			//send a network message to a website
			//typically used for sending metrics
			//or such. return values are ignored
			if(Network.url=="")
			{
				return;
			}
			try
			{
				HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Network.url);
				request.Timeout = 10000;
				HttpWebResponse response = (HttpWebResponse)request.GetResponse();
				//start---//1apr2021
				Stream stream = response.GetResponseStream();
				Encoding encode = System.Text.Encoding.GetEncoding("utf-8");
				StreamReader read = new StreamReader(stream,encode);
				Char[] chararray = new Char[256];
				if(Config.GETDATA)
				{
					int count = read.Read(chararray,0,256);
					while(count>0)
					{
						String str = new String(chararray,0,count);
						//Game.WriteDebug(str);
						count = read.Read(chararray,0,256);
					}
				}
				response.Close();//1apr2021
				read.Close();
				//end---//1apr2021
			}
			catch(Exception e)
			{
				string message = (e.Message);
			}
		}

///////////////////Method Definition///////////////
		private static void ErrorFunction()
		{
			//send error information to a location
			//should the game have an error on intialisation
			Network.url = Network.ERRORURL+Network.errorreport;
			try
			{
				HttpWebRequest request = (HttpWebRequest)WebRequest.Create(Network.url);
				request.Timeout = 10000;
				HttpWebResponse response = (HttpWebResponse)request.GetResponse();
				//start---//1apr2021
				Stream stream = response.GetResponseStream(); 
				Encoding encode = System.Text.Encoding.GetEncoding("utf-8");
				StreamReader read = new StreamReader(stream,encode);
				Char[] chararray = new Char[256];
				int count = read.Read(chararray,0,256);
				if(Config.GETDATA)
				{
					while(count>0)
					{
						String str = new String(chararray,0,count);
						//Game.WriteDebug(str);
						count = read.Read(chararray,0,256);
					}
				}
				response.Close();//1apr2021
				read.Close();
				//end---//1apr2021
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
			}
			Network.url = "";
		}

///////////////////Method Definition///////////////
		public static void httpget(string u)
		{
			//basic function for performing a http get operation
			//runs in a separate thread
			if(Config.NOMETRICS)
			{
				return;
			}
			Network.url = u;
			try
			{
			Thread thread = new Thread(new ThreadStart(ThreadFunction));
			thread.Start();
			}
			catch(Exception e)
			{
				string message = e.Message;
			}
		}

///////////////////Method Definition///////////////
		public static void reporterror(bool send)
		{
			//report an error in intialisation of the game
			if(Network.errorreport=="")
			{
				return;
			}
			if(send)
			{
				Network.errorreport+="endoferrors";
				Thread thread = new Thread(new ThreadStart(ErrorFunction));
				thread.Start();
			}
		}

///////////////////Method Definition///////////////
		public static void reporterror(string report,bool send)
		{
			//alternative reporting of an error method
			Network.errorreport+=report+":";
			if(send)
			{
				Network.errorreport+="endoferrors";
				Thread thread = new Thread(new ThreadStart(ErrorFunction));
				thread.Start();
			}
		}
	}
	

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Functions
	{
		public static int oseed = 12345678;
		public static int seed = 12345678;
		public static int[] seeds = new int[0];
		//
///////////////////Method Definition///////////////
		public static string ClockTime(int seconds)
		{
			int mins = (seconds - (seconds % 60)) / 60;
			int secs = seconds % 60;
			return zstr(mins,2) + ":" + zstr(secs,2);
		}
		
///////////////////Method Definition///////////////
		public static string zstr(int i,int n)
		{
			//return an integer number such as 123 as 00123, 
			//i = the number
			//n = the number of digits to use
			string s = "" + i;
			while(s.Length<n)
			{
				s = "0" + s;
			}
			return s;
		}

///////////////////Method Definition///////////////
		public static void saveseed() //11apr2021
		{
			oseed = seed;
			Array.Resize(ref seeds,seeds.Length + 1); //11apr2021
			seeds[seeds.Length - 1] = seed;//11apr2021
		}
		
///////////////////Method Definition///////////////
		public static void saveseed(int s)
		{
			//save the random number seed for later use
			oseed = seed;
			seed = s;
			Array.Resize(ref seeds,seeds.Length + 1);//11apr2021
			seeds[seeds.Length - 1] = s;//11apr2021
		}

///////////////////Method Definition///////////////
		public static void restoreseed()
		{
			//restore the random number seed which was saved earlier
			//seed = oseed;//11apr2021
			if(seeds.Length>0)//11apr2021
			{
				seed = seeds[seeds.Length - 1];//11apr2021
				Array.Resize(ref seeds,seeds.Length -1);//11apr2021
			}
			else//11apr2021
			{
				seed = oseed;//11apr2021
				Game.WriteDebug("Warning:Seeds Out of Sync");//11apr2021
			}
		}

///////////////////Method Definition///////////////
		public static float abs(float value)
		{
			//absolute value
			if(value<0)
			{
				return -1* value;
			}
			return value;
		}

///////////////////Method Definition///////////////
		public static int Rand(int min,int max)
		{
			//random number generator
			return min + Convert.ToInt32(random()*(double)(max-min));
		}		
		//

///////////////////Method Definition///////////////
		public static int Sign(float value)
		{
			//return the sign positive or negative of the number, or zero
			if(value>0){return 1;}
			if(value<0){return -1;}
			return 0;	
		}
		//

///////////////////Method Definition///////////////
		public static int rand(int min,int max)
		{
			//random number generator
			return Rand(min,max);
		}
		//

///////////////////Method Definition///////////////
		public static int sign(float value)
		{
			//alias of Sign
			return Sign(value);
		}
		//

///////////////////Method Definition///////////////
		public static double random()
		{
			//pseudo random number generator
			Functions.seed = ((89723453 * Functions.seed + 42854321) % 1000000);
			double r = ((double)Functions.seed / 1000000.0);
			if(r<0)
			{
				r*=-1.0;
			}
			return r;
		}
		/*

///////////////////Method Definition///////////////
		public static float calcangle(float x, float y) 
		{
		//	return Math.atan2(y, x) ;
		}
		//
		*/

///////////////////Method Definition///////////////
		public static int isox(int x,int y,int w)
		{
			//isometric calculation
			//pass in the grid square and return a location in screen coordinates 
			return (w/2) * (1 + x - y);
		}
		//

///////////////////Method Definition///////////////
		public static int isoy(int x,int y,int w)
		{
			//isometric calculation
			//pass in the grid square and return a location in screen coordinates 
			return (w/4) * (1 + y + x);
		}
		//

///////////////////Method Definition///////////////
		public static int screentoisox(int sx,int sy,int w,int offsetx,int offsety)
		{
			//isometric calculation
			//pass in screen coordinates and convert to iso x grid
			sx-=offsetx;
			sy-=offsety;
			return Convert.ToInt32((((float)sx + 2f * (float)sy)/(float)w) - 1f);
		}
		//

///////////////////Method Definition///////////////
		public static int screentoisoy(int sx,int sy,int w,int offsetx,int offsety)
		{
			//isometric calculation
			//pass in screen coordinates and convert to iso y grid
			sx-=offsetx;
			sy-=offsety;
			return Convert.ToInt32((2f*(float)sy - (float)sx)/(float)w);
		}
	}
	//

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
    class Program
    {
		//game specific stuff here
		//
		//RTS Components
		//
		public static bool quit = false;
///////////////////Method Definition///////////////
		static void Main(string[] args)
        {
			if(args!=null)
			{
				if(args.Length>0)
				{
					if(args[0] == "-editor")
					{
						Game.EDITOR = true;
					}
					if(args[0] == "-trainai")//20oct2021
					{
						Game.trainai = 1;
						Game.difficulty = 1;
					}
					else
					{
						Game.trainai = 0;
					}
				}
			}
			//init(); //13mar2021
			//start--------------//13mar2021
			Game.restart = true;
			Game.restartgamestate = -1;//26mar2021
			while(Game.restart)
			{
				Game.restart = false;
				init();
			}
			//end----------------//13mar2021
        }

///////////////////Method Definition///////////////
		//static void checkconfig() //28Feb2021

///////////////////Method Definition///////////////
		static bool checkconfig() //28Feb2021
		{
			//Game initialisation - check the config file
			//and setup initial parameters including the filenames and paths
			//to check for all the various game components
			//language also set here
			//start-------------//12mar2021
			Config.useUNICODE = false; //15mar2021
			if(Config.KOG2)
			{
				Game.NETTITLE = "grumthorr2";
				Game.TITLE = "Knights of Grumthorr 2";
			}
			//end---------------//12mar2021
			//25Feb2021 - altered order of try/catch statements...config file read first.
			string folder = "";
			string folderu = "";
			string folderd = "";
			//start-------------//28Feb2021
			Config.configfile = "media/txt/config.txt"; //28Feb2021
			try
			{
				string[] cdata = System.IO.File.ReadAllLines("media/txt/init.txt");
				for(int i=0;i<cdata.Length;i++)
				{
					if(cdata[i].IndexOf("=")>0)
					{
						switch(cdata[i].Substring(0,cdata[i].IndexOf("=")))
						{
							case "config":
							Config.configfile = Resources.readstring(cdata[i]);
							break;
						}
					}
				}
			}
			catch(Exception e)
			{
				//do nothing
				Game.WriteDebug("Warning - Error reading init.txt:"+e.Message);
				Config.configfile = "media/txt/config.txt"; //28Feb2021
			}
			//end---------------//28Feb2021
			try
			{
				//string[] data = System.IO.File.ReadAllLines("media/txt/config.txt"); //28Feb2021
				string[] data = System.IO.File.ReadAllLines(Config.configfile); //28Feb2021
				for(int i=0;i<data.Length;i++)
				{
					if(data[i].IndexOf("=")>0)
					{
						switch(data[i].Substring(0,data[i].IndexOf("=")))
						{
							case "debug"://13oct2021
							if(Resources.readstring(data[i])=="1")
							{
								Config.DEBUGCONSOLEMESSAGES = true;
							}
							break;
							case "mapdata"://6oct2021
							Config.mapdatafile = Resources.readstring(data[i]);
							break;
							case "resolutionx"://23sep2021
							Config.DEFAULTRESX = Resources.readint(data[i]);
							break;
							case "resolutiony"://23sep2021
							Config.DEFAULTRESY = Resources.readint(data[i]);
							break;
							case "fastframecheck"://14sep2021
							Config.FASTFRAMECHECK = Resources.readint(data[i]);//14sep2021
							break;
							case "usedelta"://18sep2021
							Config.USEDELTATIME = Resources.readint(data[i]);//18sep2021
							break;
							case "noupdateindemomode"://18sep2021
							Config.NOUPDATEINDEMOMODE = Resources.readint(data[i]);//18sep2021
							break;
							case "maxfps"://18sep2021
							Config.UNLOCKFRAMERATE = Resources.readint(data[i]);//18sep2021
							break;
							case "autoplay"://18sep2021
							Config.AUTOPLAY = Resources.readint(data[i]);//18sep2021
							break;
							case "noshowability"://16sep2021
							Config.NOSHOWABILITY = Resources.readint(data[i]);//16sep2021
							break;
							case "optimisefires"://15sep2021
							Config.OPTIMISEFIRES = Resources.readint(data[i]);//15sep2021
							break;
							case "clump"://15sep2021
							Config.CLUMP = Resources.readint(data[i]);//15sep2021
							break;
							case "fudgefactor"://20sep2012
							Config.FACTOR = Resources.readint(data[i]);
							if(Config.FACTOR<1)
							{
								Config.FACTOR=1;
							}
							if(Config.FACTOR>10000)
							{
								Config.FACTOR = 10000;
							}
							break;
							case "tilefog"://15sep2021
							Config.TILEFOG = Resources.readint(data[i]);//15sep2021
							break;
							case "noreplay"://15sep2021
							Config.NOREPLAY = Resources.readint(data[i]);//15sep2021
							break;
							case "gridw"://10sep2021
							Map.DEFAULTGRIDW = Resources.readint(data[i]);//10sep2021
							break;//10sep2021
							case "gridh"://10sep2021
							Map.DEFAULTGRIDH = Resources.readint(data[i]);//10sep2021
							break;//10sep2021
							case "VER"://16apr2021
							Game.VERSIONSTR = Resources.readstring(data[i]);//16apr2021
							break;
							case "NETTITLE": //25Feb2021
							Game.NETTITLE = Resources.readstring(data[i]);//25Feb2021;
							break;//25Feb2021
							case "TITLE"://2sep2021
							Game.TITLE = Resources.readstring(data[i]);//2sep2021
							break;//2sep2021
							case "PATHTHREADING"://29may2021
							if(Resources.readint(data[i])>0 && Environment.ProcessorCount>=4)
							{
								Config.THREADEDPATHING = true;
							}
							else
							{
								Config.THREADEDPATHING = false;
							}
							break;
							case "KEYFRAME": //21apr2021
							Replay.KEYFRAME = Resources.readint(data[i]);
							if(Replay.KEYFRAME<1)
							{
								Replay.KEYFRAME = 1;
							}
							break;
							//start-----------------//21mar2021
							case "usecoverflag":
							if(Resources.readstring(data[i])=="1")
							{
								Config.USECOVERFLAG = true;
							}
							if(Resources.readstring(data[i])=="0")
							{
								Config.USECOVERFLAG = false;
							}
							break;
							case "usefeetcircles":
							if(Resources.readstring(data[i])=="1")
							{
								Config.USEFEETCIRCLES = true;
							}
							if(Resources.readstring(data[i])=="0")
							{
								Config.USEFEETCIRCLES = false;
							}
							break;
							case "translategui":
							if(Resources.readstring(data[i])=="1")
							{
								Config.TRANSLATEGUI = true;
							}
							if(Resources.readstring(data[i])=="0")
							{
								Config.TRANSLATEGUI = false;
							}
							break;
							case "useiconcircles":
							if(Resources.readstring(data[i])=="1")
							{
								Config.USEICONCIRCLES = true;
							}
							if(Resources.readstring(data[i])=="0")
							{
								Config.USEICONCIRCLES = false;
							}
							break;
							//end-------------------//21mar2021
							case "fullscreen":
							Game.FULLSCREEN = Resources.readint(data[i]);
							break;
							case "resize"://22may2021
							Config.WINDOWRESIZE = Resources.readint(data[i]);//22may2021
							break;//22may2021
							case "hires"://10apr2021
							Config.hires = Resources.readint(data[i]);//10apr202
							break;//10apr2021
							case "musicvolume":
							Game.MUSICVOLUME = Resources.readint(data[i]);
							Game.oMUSICVOLUME = Game.MUSICVOLUME;
							if(Game.EDITOR)
							{
								Game.MUSICVOLUME = 0;
							}
							break;
							//start--------------//13mar2021
							case "words":
							Config.wordsfile = Resources.readstring(data[i]);
							break;
							//end----------------//13mar2021
							case "fxvolume":
							Game.FXVOLUME = Resources.readint(data[i]);
							Game.oFXVOLUME = Game.FXVOLUME;
							break;
							case "guifile":
							Config.guifile = Resources.readstring(data[i]);
							break;
							case "fontalias":
							Config.FONTALIAS = Resources.readint(data[i]);
							if(Config.FONTALIAS<1)
							{
								Config.FONTALIAS = 1;
							}
							break;
							//start-----------------//20mar2021
							case "healthmod":
							Config.HEALTHPCT = Resources.readint(data[i]);
							break;
							case "armourmod":
							Config.ARMOURPCT = Resources.readint(data[i]);
							break;
							case "attackmod":
							Config.ATTACKPCT = Resources.readint(data[i]);
							break;
							//end-------------------//20mar2021
							case "campaignfile":
							Config.campaignfile = Resources.readstring(data[i]);
							break;
							case "skirmishmessage":
							Config.skirmishmessage = Resources.readstring(data[i]);
							break;
							case "customcampaignfile":
							Config.customcampaignfile = Resources.readstring(data[i]);
							break;
							case "unitsfile":
							Config.unitsfile = Resources.readstring(data[i]);
							break;
							case "techfile": //2sep2021
							Config.techfile = Resources.readstring(data[i]);//2sep2021
							break;//2sep2021
							case "defaultfontfile":
							Config.defaultfontfile = Resources.readstring(data[i]);
							break;
							case "normalfontsize":
							Config.normalfontsize = Resources.readint(data[i]);// * Config.FONTALIAS;
							break;
							case "smallfontsize":
							Config.smallfontsize = Resources.readint(data[i]);// * Config.FONTALIAS;
							break;
							case "largefontsize":
							Config.largefontsize = Resources.readint(data[i]);// * Config.FONTALIAS;
							break;
							case "audioclickfile":
							Config.audioclickfile = Resources.readstring(data[i]);
							break;
							case "offsetfile"://20apr2021
							Config.offsetfile = Resources.readstring(data[i]);//20apr2021
							break;
							case "DOCALCOFFSETS"://20apr2021
							if(Resources.readint(data[i])==1)
							{
								Config.AUTOCALCOFFSETS = true;
							}
							else
							{
								Config.AUTOCALCOFFSETS = false;
							}
							break;
							case "logofile":
							Config.logofile = Resources.readstring(data[i]);
							break;
							case "fogfile":
							Config.fogfile = Resources.readstring(data[i]);
							break;
							case "logowidth":
							Config.logowidth = Resources.readint(data[i]);
							break;
							case "logoheight":
							Config.logoheight = Resources.readint(data[i]);
							break;
							case "fogwidth":
							Config.fogwidth = Resources.readint(data[i]);
							break;
							case "fogheight":
							Config.fogheight = Resources.readint(data[i]);
							break;
							case "record": //13mar2021
							if(Resources.readint(data[i])==1)
							{
								Config.RECORD = true;
							}
							break;
							case "useunicode": //15mar2021
								if(Resources.readint(data[i])==1)
								{
									Config.useUNICODE = true;
								}
								if(Resources.readint(data[i])==0)
								{
									Config.useUNICODE = false;
								}
							break;
						}
					}
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error reading config.txt:"+e.Message);
				return false; //28Feb2021
			}
			try
			{
				folderd = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)+"\\"+Game.NETTITLE;
				if(!Directory.Exists(folderd))
				{
					Directory.CreateDirectory(folderd);
				}
			}
			catch(Exception e)
			{
				string message = e.Message;
			}
			try
			{
				string[] datad = System.IO.File.ReadAllLines(folderd+"\\nometrics.txt");
				if(datad.Length>0)
				{
					Config.NOMETRICS = true;
				}
			}
			catch(Exception e)
			{
				string mm = e.Message;
			}
			try
			{
				folderu = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)+"\\"+Game.NETTITLE+"\\usercampaign";
				if(!Directory.Exists(folderu))
				{
					Directory.CreateDirectory(folderu);
				}
				if(Directory.Exists(folderu))
				{
					Config.usercampaignfolder = folderu;
					Config.usercampaignfile = folderu + "\\usercampaign.txt";
				}
			}
			catch(Exception e)
			{
				string message = e.Message;
			}
			try
			{
				folder = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)+"\\"+Game.NETTITLE+"\\custommaps";
				if(!Directory.Exists(folder))
				{
					Directory.CreateDirectory(folder);
				}
				if(Directory.Exists(folder))
				{
					Config.custommapfolder = folder;
				}
			}
			catch(Exception e)
			{
				string message = e.Message;
			}
			if(Game.EDITOR)
			{
				Game.FULLSCREEN = 0;
			}
			LocalStorage.init();//12mar2021
			//LocalStorage.WriteLog("Begin");
			LocalStorage.finalise();//13mar2021
			applyprefs();
			return true; //28Feb2021
		}

///////////////////Method Definition///////////////
		static void applyprefs() //12mar2021
		{
			//start---------------//30mar2021
			if(LocalStorage.getitem("uid")!="")
			{
				Config.uid = LocalStorage.getitem("uid");
			}
			else
			{
				long milliseconds = DateTimeOffset.Now.ToUnixTimeMilliseconds();
				Config.uid = ""+milliseconds;
				LocalStorage.setitem("uid",Config.uid);
			}
			//end-----------------//30mar2021
			//apply preferences and language settings
			Fonts.WMULTIPLIER = 1;//15mar2021
			Fonts.HMULTIPLIER = 1;//17apr2021
			if(LocalStorage.getitem("sfx")=="off")
			{
				Game.oFXVOLUME = Game.FXVOLUME;
				Game.FXVOLUME = 0;
			}
			if(LocalStorage.getitem("music")=="off")
			{
				Game.oMUSICVOLUME = Game.MUSICVOLUME;
				Game.MUSICVOLUME = 0;
			}
			//start------------//17apr2021
			if(LocalStorage.getitem("hires")=="0")
			{
				Config.hires = 0;
			}
			if(LocalStorage.getitem("hires")=="1")
			{
				Config.hires = 1;
			}
			if(LocalStorage.getitem("fullscreen")=="0")
			{
				Game.FULLSCREEN = 0;
			}
			if(LocalStorage.getitem("fullscreen")=="1")
			{
				Game.FULLSCREEN = 1;
			}
			//end--------------//17apr2021
			//start--------------//13mar2021
			string language = Translation.GetLanguage();
			//start------------------//18mar2021
			if(language=="")
			{
				try
				{
					string langcode = CultureInfo.CurrentUICulture.Name;
					switch(langcode.Substring(0,2))
					{
						case "en": //English
							language = "english";
						break;
						case "de": //German
							language = "german";
						break;
						case "fr": //French
							language = "french";
						break;
						case "es": //Spanish
							language = "spanish";
						break;
						case "zh": //Chinese
							if(langcode=="zh-CN")
							{
								language = "chinesesimplified";
							}
						break;
						case "tr": //Turkish//22mar2021
							language = "turkish";
						break;
						case "ru": //Russian
							language = "russian";
						break;
						case "ro": //Romanian //21mar2021
							language = "romanian";
						break;
					}
					if(language!="")
					{
						Game.WriteDebug("Language Found and Chosen:"+language);
						//LocalStorage.WriteLog("Language Found and Chosen:"+language);
						Config.autodetectlang = language;//30mar2021
					}
					else
					{
						Game.WriteDebug("Possible language not supported");
						//LocalStorage.WriteLog("Possible language not supported");
					}
				}
				catch(Exception e)
				{
					Game.WriteDebug("Error getting UI Language:"+e.Message);
					//LocalStorage.WriteLog("Error getting UI Language:"+e.Message);
				}
			}
			//end--------------------//18mar2021
			if(language!="")
			{
				string altconfigfile = Config.configfile + language;
				try
				{
					string[] data = System.IO.File.ReadAllLines(altconfigfile); //28Feb2021
					for(int i=0;i<data.Length;i++)
					{
						if(data[i].IndexOf("=")>0)
						{
							switch(data[i].Substring(0,data[i].IndexOf("=")))
							{
								case "foreignnumbers":
								Translation.init(Resources.readstring(data[i]));
								break;
								//start--------------//13mar2021
								case "words":
								Config.wordsfile = Resources.readstring(data[i]);
								break;
								//end----------------//13mar2021
//								case "NETTITLE": //25Feb2021
//								Game.NETTITLE = Resources.readstring(data[i]);//25Feb2021;
//								break;//25Feb2021
//								case "fullscreen":
//								Game.FULLSCREEN = Resources.readint(data[i]);
//								break;
//								case "musicvolume":
//								Game.MUSICVOLUME = Resources.readint(data[i]);
//								Game.oMUSICVOLUME = Game.MUSICVOLUME;
//								if(Game.EDITOR)
//								{
//									Game.MUSICVOLUME = 0;
//								}
//								break;
//								case "fxvolume":
//								Game.FXVOLUME = Resources.readint(data[i]);
//								Game.oFXVOLUME = Game.FXVOLUME;
//								break;
								case "guifile":
								Config.guifile = Resources.readstring(data[i]);
								break;
								case "fontalias":
								Config.FONTALIAS = Resources.readint(data[i]);
								if(Config.FONTALIAS<1)
								{
									Config.FONTALIAS = 1;
								}
								break;
								case "mapdata"://6oct2021
								Config.mapdatafile = Resources.readstring(data[i]);
								break;
								case "resolutionx"://23sep2021
								Config.DEFAULTRESX = Resources.readint(data[i]);
								break;
								case "resolutiony"://23sep2021
								Config.DEFAULTRESY = Resources.readint(data[i]);
								break;
								case "fastframecheck"://14sep2021
								Config.FASTFRAMECHECK = Resources.readint(data[i]);//14sep2021
								break;
								case "noreplay"://15sep2021
								Config.NOREPLAY = Resources.readint(data[i]);//15sep2021
								break;
								case "noupdateindemomode"://18sep2021
								Config.NOUPDATEINDEMOMODE = Resources.readint(data[i]);//18sep2021
								break;
								case "usedelta"://18sep2021
								Config.USEDELTATIME = Resources.readint(data[i]);//18sep2021
								break;
								case "maxfps"://18sep2021
								Config.UNLOCKFRAMERATE = Resources.readint(data[i]);//18sep2021
								break;
								case "autoplay"://18sep2021
								Config.AUTOPLAY = Resources.readint(data[i]);//18sep2021
								break;
								case "noshowability"://16sep2021
								Config.NOSHOWABILITY = Resources.readint(data[i]);//16sep2021
								break;
								case "optimisefires"://15sep2021
								Config.OPTIMISEFIRES = Resources.readint(data[i]);//15sep2021
								break;
								case "fudgefactor"://20sep2012
								Config.FACTOR = Resources.readint(data[i]);
								if(Config.FACTOR<1)
								{
									Config.FACTOR=1;
								}
								if(Config.FACTOR>10000)
								{
									Config.FACTOR = 10000;
								}
								break;
								case "clump"://15sep2021
								Config.CLUMP = Resources.readint(data[i]);//15sep2021
								break;
								case "tilefog"://15sep2021
								Config.TILEFOG = Resources.readint(data[i]);//15sep2021
								break;
								case "campaignfile":
								Config.campaignfile = Resources.readstring(data[i]);
								break;
								case "skirmishmessage":
								Config.skirmishmessage = Resources.readstring(data[i]);
								break;
								case "customcampaignfile":
								Config.customcampaignfile = Resources.readstring(data[i]);
								break;
								case "unitsfile":
								Config.unitsfile = Resources.readstring(data[i]);
								break;
								case "gridw"://10sep2021
								Map.DEFAULTGRIDW = Resources.readint(data[i]);//10sep2021
								break;//10sep2021
								case "gridh"://10sep2021
								Map.DEFAULTGRIDH = Resources.readint(data[i]);//10sep2021
								break;//10sep2021
								case "techfile"://2sep2021
								Config.techfile = Resources.readstring(data[i]);//2sep2021
								break;//2sep2021
								case "defaultfontfile":
								Config.defaultfontfile = Resources.readstring(data[i]);
								break;
								case "normalfontsize":
								Config.normalfontsize = Resources.readint(data[i]);// * Config.FONTALIAS;
								break;
								case "smallfontsize":
								Config.smallfontsize = Resources.readint(data[i]);// * Config.FONTALIAS;
								break;
								case "largefontsize":
								Config.largefontsize = Resources.readint(data[i]);// * Config.FONTALIAS;
								break;
								case "fonthmultiplier"://17apr2021
								Fonts.HMULTIPLIER = Resources.readint(data[i]);
								if(Fonts.HMULTIPLIER<1)
								{
									Fonts.HMULTIPLIER = 1;
								}
								break;
								case "fontwmultiplier": //15mar2021
								Fonts.WMULTIPLIER = Resources.readint(data[i]);
								if(Fonts.WMULTIPLIER<1)
								{
									Fonts.WMULTIPLIER = 1;
								}
								break;
								case "offsetfile"://20apr2021
								Config.offsetfile = Resources.readstring(data[i]);//20apr2021
								break;
								case "audioclickfile":
								Config.audioclickfile = Resources.readstring(data[i]);
								break;
//								case "logofile":
//								Config.logofile = Resources.readstring(data[i]);
//								break;
//								case "fogfile":
//								Config.fogfile = Resources.readstring(data[i]);
//								break;
//								case "logowidth":
//								Config.logowidth = Resources.readint(data[i]);
//								break;
//								case "logoheight":
//								Config.logoheight = Resources.readint(data[i]);
//								break;
//								case "fogwidth":
//								Config.fogwidth = Resources.readint(data[i]);
//								break;
//								case "fogheight":
//								Config.fogheight = Resources.readint(data[i]);
//								break;
//								case "record": //13mar2021
//								if(Resources.readint(data[i])==1)
//								{
//									Config.RECORD = true;
//								}
//								break;
								case "translategui": //21mar2021
								if(Resources.readstring(data[i])=="1")
								{
									Config.TRANSLATEGUI = true;
								}
								if(Resources.readstring(data[i])=="0")
								{
									Config.TRANSLATEGUI = false;
								}
								break;
							
								case "useunicode": //15mar2021
								if(Resources.readint(data[i])==1)
								{
									Config.useUNICODE = true;
								}
								if(Resources.readint(data[i])==0)
								{
									Config.useUNICODE = false;
								}
								break;
							}
						}
					}
					Config.configfile = altconfigfile;
				}
				catch(Exception e)
				{
					Game.WriteDebug("Error reading language config.txt:"+e.Message);
					//LocalStorage.WriteLog("Error reading language config.txt:"+e.Message);
					return;
				}
			}
			if(Config.wordsfile!="")
			{
				Translation.CollectWords();
			}
			//end----------------//13mar2021
		}

///////////////////Method Definition///////////////
		static void init()
		{
			//core window initialisation routine
			RenderList.init(); //13mar2021
			Game.RESOLUTIONX = 1600;
			Game.RESOLUTIONY = 900;
			//start-------------//28Feb2021
			//checkconfig(); 
			if(!checkconfig())
			{
				return;
			}
			Game.RESOLUTIONX = Config.DEFAULTRESX;//25sep2021
			Game.RESOLUTIONY = Config.DEFAULTRESY;//25sep2021
			
			//end---------------//28Feb2021
			SDL.SDL_SetHint(SDL.SDL_HINT_WINDOWS_DISABLE_THREAD_NAMING, "1");
			if(SDL.SDL_Init(SDL.SDL_INIT_VIDEO | SDL.SDL_INIT_AUDIO)<0)
			{
				Game.WriteDebug("Could Not Initialise Window. Error:"+SDL.SDL_GetError());
				Network.reporterror("WindowOpenFailure",true);//15mar2021
				return;
			}
			var window = IntPtr.Zero;
			switch(Game.FULLSCREEN)
			{
				case 0:
					//window = SDL.SDL_CreateWindow(Game.TITLE,SDL.SDL_WINDOWPOS_CENTERED,SDL.SDL_WINDOWPOS_CENTERED,Game.RESOLUTIONX,Game.RESOLUTIONY,SDL.SDL_WindowFlags.SDL_WINDOW_MAXIMIZED); //22may2021
					//window = SDL.SDL_CreateWindow(Game.TITLE,SDL.SDL_WINDOWPOS_CENTERED,SDL.SDL_WINDOWPOS_CENTERED,Game.RESOLUTIONX,Game.RESOLUTIONY,SDL.SDL_WindowFlags.SDL_WINDOW_RESIZABLE); //22may2021
					//start---------//22may2021
					if(Config.WINDOWRESIZE==0)
					{
						window = SDL.SDL_CreateWindow(Game.TITLE,SDL.SDL_WINDOWPOS_CENTERED,SDL.SDL_WINDOWPOS_CENTERED,Game.RESOLUTIONX,Game.RESOLUTIONY,SDL.SDL_WindowFlags.SDL_WINDOW_MAXIMIZED); //22may2021
					}
					else
					{
						window = SDL.SDL_CreateWindow(Game.TITLE,SDL.SDL_WINDOWPOS_CENTERED,SDL.SDL_WINDOWPOS_CENTERED,Game.RESOLUTIONX,Game.RESOLUTIONY,SDL.SDL_WindowFlags.SDL_WINDOW_RESIZABLE); //22may2021
					}
					//end----------//22may2021
				break;
				case 1:
					window = SDL.SDL_CreateWindow(Game.TITLE,SDL.SDL_WINDOWPOS_CENTERED,SDL.SDL_WINDOWPOS_CENTERED,Game.RESOLUTIONX,Game.RESOLUTIONY,SDL.SDL_WindowFlags.SDL_WINDOW_FULLSCREEN);
				break;
			}
			if(window == IntPtr.Zero)
			{
				Game.WriteDebug("Could Not Create Window. Error:"+SDL.SDL_GetError());
				Network.reporterror("WindowOpenFailure",true);//15mar2021
				SDL.SDL_Quit();
				return;
			}
			SDL_image.IMG_Init(SDL_image.IMG_InitFlags.IMG_INIT_JPG | SDL_image.IMG_InitFlags.IMG_INIT_PNG);
			SDL_ttf.TTF_Init();
			//
			var renderer = IntPtr.Zero;
			renderer = SDL.SDL_CreateRenderer(window,-1,SDL.SDL_RendererFlags.SDL_RENDERER_ACCELERATED);
			//
			if(SDL_mixer.Mix_Init(SDL_mixer.MIX_InitFlags.MIX_INIT_MP3)<0)
			{
				Game.WriteDebug("Could Not Initialise Audio Mixer. Error:"+SDL.SDL_GetError());
				Network.reporterror("MixerOpenFailure",false);//15mar2021
			}
			if(SDL_mixer.Mix_OpenAudio(SDL_mixer.MIX_DEFAULT_FREQUENCY,SDL_mixer.MIX_DEFAULT_FORMAT,8,1024)<0)
			{
				Game.WriteDebug("Could Not Open Audio Mixer. Error:"+SDL.SDL_GetError());
				Network.reporterror("MixerOpenFailure",false);//15mar2021
			}
			game(window,renderer);
			LocalStorage.finalise();//12mar2021
			//
			SDL_mixer.Mix_CloseAudio();
			SDL_mixer.Mix_Quit();
			//
			SDL_ttf.TTF_Quit();
			SDL_image.IMG_Quit();
			SDL.SDL_DestroyRenderer(renderer);
			SDL.SDL_DestroyWindow(window);
			SDL.SDL_Quit();
		}

///////////////////Method Definition///////////////
		static void loadprogress(Game game, string txt)
		{
			//not used
			RenderList.drawtext(game,800,400,txt,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);
		}

///////////////////Method Definition///////////////
		static void resourceload(Game game)
		{
			//load all resources for the game here
			//call this prior to entering the main game loop
			//Resources.loadingbk = Resources.LoadAnimImage(game,"media/gui/loading.png",Game.renderer,648,100,1,1);//27mar2021
			//Resources.loadingbar = Resources.LoadAnimImage(game,"media/gui/loadinglight.png",Game.renderer,8,100,81,1);//27mar2021
			Resources.blackcat = Resources.LoadAnimImage(game,"media/gui/black.png",Game.renderer,64,64,1,1);
			Resources.LOGO = Resources.LoadAnimImage(game,Config.logofile,Game.renderer,Config.logowidth,Config.logoheight,1,1);
			Resources.FOG = Resources.LoadAnimImage(game,Config.fogfile,Game.renderer,Config.fogwidth,Config.fogheight,1,1);
			Resources.FONT = Resources.LoadFont(game,Config.defaultfontfile,Config.normalfontsize);
			Resources.SMALLFONT = Resources.LoadFont(game,Config.defaultfontfile,Config.smallfontsize);
			Resources.LARGEFONT = Resources.LoadFont(game,Config.defaultfontfile,Config.largefontsize);
			Resources.LoadGui(game,Config.guifile);
			Resources.LoadTemplates(game,Config.unitsfile);
			Resources.LoadCampaign(game,Config.campaignfile);
			Resources.LoadTech(game,Config.techfile);//2sep2021
			Gui.matchcampaign(game); //28Feb2021
			Resources.CLICK = Resources.LoadAudio(game,Config.audioclickfile,false);
			Resources.AssignOffsets(game,Config.offsetfile);//20apr2021
			CampaignMap.ReadMapData(Config.mapdatafile);//6oct2021
			Research.Load();//21oct2021
			NetworkUDP.WriteMultiplayerFile();//13oct2021
			//Game.clicker = Resources.LoadAnimImage(game,"media/gui/clicker.png",Game.renderer,32,32,8,2);//15apr2021
			//Game.targeticon = Resources.LoadAnimImage(game,"media/gui/targeticon.png",Game.renderer,64,64,1,1);//16apr2021
		}

		//static void drawloadingbar(Game game,int w,int pct,int offy) //27mar2021
		//{
		//	if(Resources.loadingbk!=-1 && Resources.loadingbar!=-1)
		//	{
		//		int f = (pct * Game.images[Resources.loadingbar].cwn) / 100;
		//		for(int i=0;i<f;i++)
		//		{
		//			RenderList.drawanimimage(game,Game.images[Resources.loadingbar].texture,Game.RESOLUTIONX/2 - (w/2) + i * Game.images[Resources.loadingbar].cwx,offy + Game.RESOLUTIONY/2,0,1,1,i,0,false,1,Resources.loadingbar);
		//		}
		//		RenderList.drawanimimage(game,Game.images[Resources.loadingbk].texture,Game.RESOLUTIONX/2,offy + Game.RESOLUTIONY/2,0,1,1,0,0,false,1,Resources.loadingbk);
		//	}
		//}
		
///////////////////Method Definition///////////////
		static void render(Game game,IntPtr window)
		{
			//core render method
			//clears the screen buffer, draws to it, then flips it into view
			SDL.SDL_RenderClear(Game.renderer);
			RenderList.render(game);	
			SDL.SDL_RenderPresent(Game.renderer);
		}

///////////////////Method Definition///////////////
		static void drawlogo(Game game)
		{
			//draw game logo at start of game
			int fr = Game.frame;// - 100;//27mar2021
			float sx = 1f;
			float sy = 1f;
			//27mar2021
			//sx = (0.01f+(float)Game.frame / 100f);
			//sy = (0.01f+(float)Game.frame / 100f);
			//float alpha = 0.01f + (float)Game.frame / 100f;
			sx = (0.01f+(float)fr / 100f);
			sy = (0.01f+(float)fr / 100f);
			float alpha = 0.01f + (float)fr / 100f;
			if(alpha>1)
			{
				alpha = 1f;
			}
			if(sx>1)
			{
				sx = 1f;
			}
			if(sy>1)
			{
				sy = 1f;
			}
			RenderList.drawimage(game,Game.images[Resources.LOGO].texture,Game.RESOLUTIONX/2,Game.RESOLUTIONY/2,0,1,1,0,0,false,alpha,Resources.LOGO);
			//if(Game.frame>180)27mar2021
			if(fr>180)//27mar2021
			{
				Game.gamestate=Game.CAT_GAMESTATE_MENU;
				Config.loaded = false;
				Config.loadpct = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void skirmishmission(Game game)
		{
			//setup the skirmish mission settings
			/////////////////////////////
			//unit positions and types..
					Game.fogoff = 0; //26Feb2021
					Game.neutralfog = 0; //26Feb2021
					Game.LOCKCORNER = 0;//1mar2021
					Game.skirmish = true;
					Game.zoom = 0;
					Game.mwheel = 0;
					Game.playingtutorial = false;
					Game.victorymessage = true;
					cleardeaths(game);
					int id = 0;
					int tmpid = -1;
					int jjj = - 1;
					for(int i=0;i<Unit.MAXUNITS;i++)
					{
						Game.units[i] = new Unit(game);
					}
					//remove some of the woods, rocks and walls
					for(int i=0;i<Map.treeimage.Length;i++)
					{
						if(Functions.rand(0,1000)<750)
						{
							Map.treeimage[i] = -1;
						}
					}
					for(int i=0;i<Map.rockimage.Length;i++)
					{
						if(Functions.rand(0,1000)<750)
						{
							Map.rockimage[i] = -1;
						}
					}
					for(int i=0;i<Map.wallimage.Length;i++)
					{
						if(Functions.rand(0,1000)<750)
						{
							Map.wallimage[i] = -1;
						}
					}
					//setup control points
					int cpoint = (4 + (Functions.rand(0,1000) % 10));
					for(int i=0;i<cpoint;i++)
					{
						int xx = (int)Functions.rand(0,10000) % Map.MAXX;
						int yy = (int)Functions.rand(0,10000) % Map.MAXY;
						if(xx>=0 && yy>=0 && xx<Map.MAXX && yy<Map.MAXY)
						{
							for(int j=0;j<Game.templates.Length;j++)
							{
								if(Game.templates[j].controlpoint==1)
								{
									jjj++;
									Game.units[jjj].createunitatxy(game,jjj,Game.templates[j],xx * Map.GRIDW,yy * Map.GRIDH);
									break;
								}
							}
						}
					}
					int maxj = 10;
					for(int y=80;y<95;y++)
					{
						for(int i=0;i<Game.templates.Length;i++)
						{
							if(Game.templates[i].faction==Game.PLAYERFACTION)
							{
								if(Game.templates[i].walkspeed>0)
								{
									id++;
								}
							}
						}
						if(id>0)
						{
							id = 1 + (Functions.rand(1,1000) % id);
							for(int i=0;i<Game.templates.Length;i++)
							{
								if(Game.templates[i].faction==Game.PLAYERFACTION)
								{
									if(Game.templates[i].walkspeed>0)
									{
										id--;
										if(id<=0)
										{
											tmpid = i;
											break;
										}
									}
								}
							}
						}
						if(tmpid>=0)
						{
							for(int x=40;x<60;x++)
							{
								Map.treeimage[x + y * Map.MAXX] = -1;
								Map.rockimage[x + y * Map.MAXX] = -1;
								Map.wallimage[x + y * Map.MAXX] = -1;
								if(Functions.rand(0,100)<20 && Map.passable(x * Map.GRIDW, y * Map.GRIDH)==true && maxj>0)
								{
									jjj++;
									if(jjj<Game.units.Length)
									{   
										Game.units[jjj].createunitatxy(game,jjj,Game.templates[tmpid],x * Map.GRIDW,y * Map.GRIDH);
										Game.units[jjj].orderframe = 300;
										Game.CORNERX = Game.units[jjj].x - Game.RESOLUTIONX/2;
										Game.CORNERY = Game.units[jjj].y - Game.RESOLUTIONY/2;
										maxj--;
									}
								}
							}
						}
					}
					maxj = 10;
					//enemy units
					for(int y=5;y<20;y++)
					{
						for(int i=0;i<Game.templates.Length;i++)
						{
							if(Game.templates[i].faction!=Game.PLAYERFACTION && Game.templates[i].faction!=Unit.NULLFACTION)
							{
								if(Game.templates[i].walkspeed>0)
								{
									id++;
								}
							}
						}
						if(id>0)
						{
							id = 1 + (Functions.rand(1,1000) % id);
							for(int i=0;i<Game.templates.Length;i++)
							{
								if(Game.templates[i].faction!=Game.PLAYERFACTION && Game.templates[i].faction!=Unit.NULLFACTION)
								{
									if(Game.templates[i].walkspeed>0)
									{
										id--;
										if(id<=0)
										{
											tmpid = i;
											break;
										}
									}
								}
							}
						}
						if(tmpid>=0)
						{
							int aa = Functions.rand(10,79);
							int bb = aa + 20;
							for(int x=aa;x<bb;x++)
							{
								Map.treeimage[x + y * Map.MAXX] = -1;
								Map.rockimage[x + y * Map.MAXX] = -1;
								Map.wallimage[x + y * Map.MAXX] = -1;
								if(Functions.rand(0,100)<20 && jjj<Game.units.Length && Map.passable(x * Map.GRIDW, y * Map.GRIDH)==true && maxj>0)
								{
									Game.units[jjj].createunitatxy(game,jjj,Game.templates[tmpid],x * Map.GRIDW,y * Map.GRIDH);
									Game.units[jjj].ai = Unit.AI_EXTRAASSAULT;
									Game.units[jjj].orderframe = 300;
									jjj++;
									maxj--;
								}
							}
						}
					}
					//copy the triggers.....
					for(int i=0;i<Game.triggers.Length;i++)
					{
						Game.triggers[i] = new Trigger();
					}
					Trigger.number = 0;
					id = 0;
					bool found = false;
					for(int i=0;i<Game.templates.Length;i++)
					{
						if(Game.templates[i].faction==Game.PLAYERFACTION && Game.templates[i].walkspeed>0  && Game.templates[i].faction!=Unit.NULLFACTION)
						{
							string enemyunitname = Game.templates[i].name;
							found = false;
							for(int j=0;j<Game.units.Length;j++)
							{
								if(Game.units[j].name==enemyunitname && Game.units[j].hp>0)
								{
									found = true;
								}
							}
							if(found)
							{
								Game.triggers[id] = new Trigger(game,Trigger.TYPE_OR_DEFEAT,0,0,enemyunitname,0 ,0,100, 100);
								id++;						
							}
						}
						if(Game.templates[i].faction!=Game.PLAYERFACTION && Game.templates[i].walkspeed>0 && Game.templates[i].faction!=Unit.NULLFACTION)
						{
							string unitname = Game.templates[i].name;
							found = false;
							for(int j=0;j<Game.units.Length;j++)
							{
								if(Game.units[j].name==unitname && Game.units[j].hp>0)
								{
									found = true;
								}
							}
							if(found)
							{
								Game.triggers[id] = new Trigger(game,Trigger.TYPE_VICTORY,0,0,unitname,0 ,0,100, 100);
								id++;
							}
						}
					}
					Game.triggers[id] = new Trigger(game,Trigger.TYPE_CHATTER,((int)Functions.rand(0,1000)%20),1,Config.skirmishmessage,300,780,0,0);
					Game.GAMEENDSTATE = 0;
					Game.gameovertime = 0;
					Game.paused = false;
		}

///////////////////Method Definition///////////////
		public static void testdebrief(Game game)
		{
			//debugging only
			for(int i=0;i<Game.templates.Length;i++)
			{
				Game.templates[i].prevdeaths = (int) Functions.rand(10,100);
				Game.templates[i].prevkills =  (int) Functions.rand(10,100);
				Game.templates[i].prevcreates = (int) Functions.rand(10,100);
				Game.templates[i].deaths = 0;
				Game.templates[i].kills = 0;
				Game.templates[i].creates = 0;
				Game.templates[i].dispcreates = 0;
				Game.templates[i].dispdeaths = 0;
				Game.templates[i].dispkills = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void cleardeaths(Game game)
		{
			//clear all deaths and counts before and after a mission starts - a reset procedure
			for(int i=0;i<Game.templates.Length;i++)
			{
				Game.templates[i].prevdeaths = Game.templates[i].deaths;
				Game.templates[i].prevkills = Game.templates[i].kills;
				Game.templates[i].prevcreates = Game.templates[i].creates;
				Game.templates[i].deaths = 0;
				Game.templates[i].kills = 0;
				Game.templates[i].creates = 0;
				Game.templates[i].dispcreates = 0;
				Game.templates[i].dispdeaths = 0;
				Game.templates[i].dispkills = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void setupeditor(Game game)
		{
			//setup the editor for first use
			//clear the trees etc from the map
			for(int i=0;i<Map.treeimage.Length;i++)
			{
				Map.treeimage[i] = -1;
				Map.decorimage[i] = -1; //2mar2021
			}
			for(int i=0;i<Map.rockimage.Length;i++)
			{
				Map.rockimage[i] = -1;
			}
			for(int i=0;i<Map.wallimage.Length;i++)
			{
				Map.wallimage[i] = -1;
			}
			for(int i=0;i<Unit.MAXUNITS;i++)
			{
				Game.units[i] = new Unit(game);
			}
			for(int i=0;i<Game.triggers.Length;i++)
			{
				Game.triggers[i] = new Trigger();
			}
			Functions.saveseed(Functions.seed);
			Game.zoom = 0;
			Game.mwheel = 0;
			Game.playerready = false;
			Game.playingtutorial = false;
			Game.skirmish = false;
			Game.victorymessage = false;
			cleardeaths(game);
			Game.playingtutorial = false;
			Game.GAMEENDSTATE = 0;
			Game.gameovertime = 0;
			Game.paused = false;
			Map.adddecor();//2mar2021
			Map.marktreepos(game);
			Game.nextmissionid = -1;
			Game.failedmissionid = -1;
			Game.fogoff = 0; //26Feb2021
			Game.neutralfog = 0; //26Feb2021
			Game.LOCKCORNER = 0;//1mar2021
		}

///////////////////Method Definition///////////////
		public static void setupbackdrop(Game game)
		{
			//setup the backdrop for the game window
			//to display a demo screen
			//of some sort based on a game mission cinematic or such
			int mission = 0;
			for(int i=0;i<Game.missions.Length;i++)
			{
				if(Game.missions[i].demo>0)
				{
					mission = i;
					break;
				}
			}
			setupmission(game,mission,1);
			Game.playingtutorial = false;
		}

///////////////////Method Definition///////////////
		public static void setupmission(Game game,int mission,int tutorial)
		{
			Beacon.Init();//19oct2021
			Beacon.enabled = 1;//20oct2021
			//start---------//18oct2021
			Game.LocalPlayerIndex = Game.FriendIndex;
			Game.LocalEnemyIndex = Game.EnemyIndex;
			Game.spellcast = 0;
			Map.overriderain = false;
			if(Game.vsai<=0)
			{
				if(NetworkUDP.Ready())
				{
					if(NetworkUDP.isserver)
					{
						Game.LocalPlayerIndex = Game.FriendIndex;
						Game.LocalEnemyIndex = Game.EnemyIndex;
					}
					else
					{
						Game.LocalPlayerIndex = Game.EnemyIndex;
						Game.LocalEnemyIndex = Game.FriendIndex;
					}
				}
			}
			//end------------//18oct2021
			Game.spellcast = 0;//18oct2021
			Game.winloss = 0;//17oct2021
			Game.battlespeed = 1;//16oct2021
			Functions.saveseed();
			//apply all mission settings prior to starting the mission
			//start--------//17sep2021
			bool minimap = false;
			if(tutorial==99)
			{
				minimap = true;
				tutorial = 2;
			}
			//end----------//17sep2021
			MapThread.complete = false;//29may2021
			if(!Replay.PLAYBACK)//2apr2021
			{
				Game.gamestartframe = Game.frame;//2apr2021
			}
			Tech.resetall(game);//2sep2021
			if(mission==1)//24sep2021
			{
				Tech.unpurchase(game);
			}
			Config.precalcused = 0;
			Config.seekpathfailed = 0;
			Config.seekpathsuccess = 0;
			Config.seekpathused = 0;
			Game.fogoff = 0; //26Feb2021
			Game.neutralfog = 0; //26Feb2021
			Game.LOCKCORNER = 0; //1mar2021
			Game.zoom = 0;
			Game.mwheel = 0;
			Game.playerready = false;
			Game.playingtutorial = false;
			Game.skirmish = false;
			Game.victorymessage = false;
			cleardeaths(game);
			string folder = "";
			try
			{
				folder = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)+"/"+Game.NETTITLE;
				if(!Directory.Exists(folder))
				{
					Directory.CreateDirectory(folder);
				}
			}
			catch(Exception e)
			{
				string message = e.Message;
			}
			if(mission<0 && mission!=-999 && tutorial==0)
			{
				try
				{
					string[] savegame = System.IO.File.ReadAllLines(folder+"/"+"savegame.txt");
					if(savegame.Length>0)
					{
						Int32.TryParse(savegame[0],out mission);
					}
				}
				catch(Exception e)
				{
					Game.WriteDebug(e.Message);
				}
			}
			if(mission<0 && mission!=-999 && tutorial==0)
			{
				mission = 0;
			}
			if(mission>0 && mission!=-999 && tutorial==0 && tutorial!=2)
			{
				if(mission>Game.maxmission)
				{
					Game.maxmission = mission;
					try
					{
						System.IO.File.WriteAllText(folder+"/"+"savegame.txt",""+mission);
					}
					catch(Exception e)
					{
						Game.WriteDebug(e.Message);
					}
				}
			}
			if(Game.missions.Length>0 && mission!=-999)
			{
				if(mission>=0 && mission<Game.missions.Length)
				{
					//map layout...
					if(Game.missions[mission].istutorial>0)
					{
						Game.playingtutorial = true;
					}
					Game.missionid = mission;
					Map.loadpath(mission); //try and get the precalced path.....
					Game.nextmissionid = Game.missions[mission].nextmissionid;
					Game.failedmissionid = Game.missions[mission].failedmissionid;
					//start--------------//1mar2021
					if(Game.missions[mission].nextmissionname!="")
					{
						for(int mi=0;mi<Game.missions.Length;mi++)
						{
							if(Game.missions[mi].name==Game.missions[mission].nextmissionname)
							{
								Game.nextmissionid = mi;
								break;
							}
						}
					}
					if(Game.missions[mission].failedmissionname!="")
					{
						for(int mi=0;mi<Game.missions.Length;mi++)
						{
							if(Game.missions[mi].name==Game.missions[mission].failedmissionname)
							{
								Game.failedmissionid = mi;
								break;
							}
						}
					}
					//start--------------//10sep2021
					Map.GRIDW = Game.missions[mission].gridw;
					Map.GRIDH = Game.missions[mission].gridh;
					//start--------------//18sep2021
					Map.FOGW = (160 * Map.GRIDW) / 32;
					Map.FOGH = (160 * Map.GRIDH) / 32;
					Map.FOGSCALE = (float)Map.GRIDW / 32f;
					if(Map.FOGSCALE<=0)
					{
						Map.FOGSCALE = 1f;
					}
					//end----------------//18sep2021
					//end----------------//10sep2021
					//end----------------//1mar2021
									//start---------------//7oct2021
				//funky weather thingy......
				Map.tilecat = Map.grasstilecat;
				Map.treecat = Map.grasstreecat;
				Map.weather = Map.WEATHERNORMAL;
				if(Map.snowtilecat>0 && Map.deserttilecat>0)
				{
					try
					{
						//final string weatherdate = DateFormat.format("yyyy-MM-dd", Game.currentTimeMillis()).toString();
						int dayofmonth = 15;
						//try
						//{
							//dayofmonth = Integer.decode(weatherdate.Substring(8, 10));
						//}
						//catch(Exception f)
						//{
							//do nothing....
						//}
						int randomweather = Functions.rand(0,1000) % 100;
						if(Game.chosenmissionindex==1)//FINAL VICTORY//17oct2021
						{
							dayofmonth = 1;
							randomweather=50;
						}
						if(Game.chosenmissionindex==2)//FINAL Defeat//17oct2021
						{
							dayofmonth = 1;
							randomweather = 5;
						}
						if(dayofmonth<10)
						{
							//winter (cold and dark)
							if(randomweather<30)
							{
								Map.tilecat = Map.snowtilecat;
								if(randomweather<15)
								{
									Map.treecat = Map.snowtreecat;
								}
								Map.weather = Map.WEATHERCOLD;
							}
							if(randomweather>90)
							{
								Map.tilecat = Map.deserttilecat;
								if(randomweather>95)
								{
									Map.treecat = Map.deserttreecat;
								}
								Map.weather = Map.WEATHERHOT;
							}
						}
						if(dayofmonth>20)
						{
							//summer (hot and dry)
							if(randomweather<10)
							{
								Map.tilecat = Map.snowtilecat;
								if(randomweather<5)
								{
									Map.treecat = Map.snowtreecat;
								}
								Map.weather = Map.WEATHERCOLD;
							}
							if(randomweather>70)
							{
								Map.tilecat = Map.deserttilecat;
								if(randomweather>85)
								{
									Map.treecat = Map.deserttreecat;
								}
								Map.weather = Map.WEATHERHOT;
							}
						}
						if(dayofmonth>=10 && dayofmonth<=20)
						{
							//temperate
							if(randomweather<15)
							{
								Map.tilecat = Map.snowtilecat;
								Map.treecat = Map.snowtreecat;
								Map.weather = Map.WEATHERCOLD;
							}
							if(randomweather>85)
							{
								Map.tilecat = Map.deserttilecat;
								Map.treecat = Map.deserttreecat;
								Map.weather = Map.WEATHERHOT;
							}
						}
					}
					catch(Exception e)
					{
						Game.WriteDebug("Error:"+e.Message);
					}
				}
				//end-----------------//7oct2021
				//start---------------//14oct2021
				if(Game.campaignmode>0)
				{
					if(Game.campaignattackprovince!=-1)
					{
						if(Functions.rand(0,100)<85)
						{
							int provinceweather = CampaignMap.provinceweather[Game.campaignattackprovince];
							if(provinceweather==Map.WEATHERCOLD || provinceweather==Map.WEATHERHOT)
							{
								Map.weather = provinceweather;
							}
							if(Map.weather==Map.WEATHERCOLD)
							{
								Map.tilecat = Map.snowtilecat;
								Map.treecat = Map.snowtreecat;
								Map.weather = Map.WEATHERCOLD;
							}
							if(Map.weather==Map.WEATHERHOT)
							{
								Map.tilecat = Map.deserttilecat;
								Map.treecat = Map.deserttreecat;
								Map.weather = Map.WEATHERHOT;
							}
						}
					}
				}
				//end-----------------//14oct2021
				
					Map.indoor = Game.missions[mission].indoor;//23sep2021
					Game.CORNERX = Game.missions[mission].cornerx;
					Game.CORNERY = Game.missions[mission].cornery;
					Game.fogoff = Functions.sign(Game.missions[mission].fogoff); //26Feb2021
					Game.neutralfog = Functions.sign(Game.missions[mission].neutralfog); //26Feb2021
					Game.LOCKCORNER = Game.missions[mission].lockcorner; //1mar2021
					//4apr2021 added network command in here
					//
					//if(Game.missions[mission].name!="demo") //5apr2021//17sep2021
					if(Game.missions[mission].name!="demo" && minimap==false) //5apr2021//17sep2021
					{
						try
						{
							Network.url = "https://www.mattiesgames.com/metrics/metric.php?game=kog2mission&event="+Game.missions[mission].name.Replace(" ","_")+"&value=1&uid="+Config.uid;//30mar2021
							Network.httpget(Network.url);
						}
						catch(Exception e)
						{
							string message = e.Message;
						}
					}
					//
					//
					//start-------------//28Feb2021
					Game.PLAYERFACTION = Game.missions[mission].playerfaction;
					Game.SKIRMISHENEMYFACTION = Game.missions[mission].skirmishenemyfaction;
					//end---------------//28Feb2021
					if(Game.missions[mission].skirmish==1)
					{
						Game.skirmish = true;
					}
					for(int i=0;i<Map.treeimage.Length;i++)
					{
						Map.treeimage[i] = -1;
						Map.decorimage[i] = -1; //2mar2021
					}
					for(int i=0;i<Map.rockimage.Length;i++)
					{
						Map.rockimage[i] = -1;
					}
					for(int i=0;i<Map.wallimage.Length;i++)
					{
						Map.wallimage[i] = -1;
						Map.hillimage[i] = 0;//20oct2021
					}
					
					//start--------------//2mar2021
					Map.odecorframes = Map.decorframes;//15mar2021
					Map.decorframes = Game.missions[mission].decorframes;//15mar2021
					if(Game.missions[mission].decorimage!=null)//17sep2021
					if(Game.missions[mission].decorimage!=null && minimap==false)//17sep2021
					{
						for(int i=0;i<Game.missions[mission].decorimage.Length;i++)
						{
							if(Game.missions[mission].decorframes > 0) //26oct2020 
							{
								Map.decorimage[Game.missions[mission].decorimage[i]] = Functions.rand(0,1000) % Game.missions[mission].decorframes;//8;
							}
							else
							{
								if(Map.decorframes>0)//19sep2021 bugfix
								{
									Map.decorimage[Game.missions[mission].decorimage[i]] = Functions.rand(0,1000) % Map.decorframes;//8;
								}
							}
							//Game.WriteDebug("Index:"+Game.missions[mission].treeimage[i]+ " Value:"+Map.treeimage[Game.missions[mission].treeimage[i]]);
						}
					}
					//end----------------//2mar2021
					Map.missiontreeframes = Map.treeframes;//28mar2021
					if(Game.missions[mission].treeimage!=null)
					{
						for(int i=0;i<Game.missions[mission].treeimage.Length;i++)
						{
							if(Game.missions[mission].treeframes > 0) //26oct2020 
							{
								Map.treeimage[Game.missions[mission].treeimage[i]] = Functions.rand(0,1000) % Game.missions[mission].treeframes;//8;
								Map.missiontreeframes = Game.missions[mission].treeframes;
							}
							else
							{
								Map.treeimage[Game.missions[mission].treeimage[i]] = Functions.rand(0,1000) % Map.treeframes;//8;
							}
							//Game.WriteDebug("Index:"+Game.missions[mission].treeimage[i]+ " Value:"+Map.treeimage[Game.missions[mission].treeimage[i]]);
						}
					}
					if(Game.missions[mission].rockimage!=null)
					{
						for(int i=0;i<Game.missions[mission].rockimage.Length;i++)
						{
							if(Game.missions[mission].rockframes > 0) //26oct2020
							{
								Map.rockimage[Game.missions[mission].rockimage[i]] = Functions.rand(0,1000) % Game.missions[mission].rockframes;//4;
							}
							else
							{						
								Map.rockimage[Game.missions[mission].rockimage[i]] = Functions.rand(0,1000) % Map.rockframes;//4;
							}
						}
					}
					if(Game.missions[mission].wallimage!=null)
					{
						for(int i=0;i<Game.missions[mission].wallimage.Length;i++)
						{
							if(Game.missions[mission].wallframes> 0) //26oct2020
							{
								Map.wallimage[Game.missions[mission].wallimage[i]] = Functions.rand(0,1000) % Game.missions[mission].wallframes;//;
							}
							else
							{
								Map.wallimage[Game.missions[mission].wallimage[i]] = Functions.rand(0,1000) % Map.wallframes;//;
							}
						}
					}
					//start--------//16sep2021
					//if(Game.missions[mission].floorpattern>0)//17sep2021
					if(Game.missions[mission].floorpattern>0 && minimap==false)//17sep2021
					{
						int mainfloor = 0;//25sep2021
						int secondaryfloor = 0;//25sep2021
						int thirdfloor = 0;//25sep2021
						bool other = false;//25sep2021
						int its = 0;
						int row1 = 0;
						int row2 = 0;
						int row3 = 0;
						int[] assigned = new int[Map.MAXX * Map.MAXY];
						if(Game.missions[mission].floorpattern==2 && Map.tileframes>4)//25sep2021
						{
							for(int x=1;x<Map.MAXX - 1;x++)
							{
								for(int y=1;y<Map.MAXY - 1;y++)
								{
									if(assigned[x + y * Map.MAXX]==1)
									{
										continue;
									}
									if((x % 8==0 && y % 8==0) || (x==1 && y==1))
									{
										row1 = Functions.rand(0,1000) % (Map.tileframes / 4);
										row2 = Functions.rand(0,1000) % (Map.tileframes / 4);
										row3 = Functions.rand(0,1000) % (Map.tileframes / 4);
										mainfloor = row1 * 4 + (Functions.rand(0,1000) % 3);//25sep2021
										secondaryfloor = row2 * 4 + (Functions.rand(0,1000) % 3);//25sep2021
										thirdfloor = row3 * 4 + (Functions.rand(0,1000) % 3);//25sep2021
										
										if(mainfloor<0)
										{
											mainfloor = 0;
										}
										if(secondaryfloor<0)
										{
											secondaryfloor = 0;
										}
										if(thirdfloor<0)
										{
											thirdfloor = 0;
										}
										its = 0;
										while(secondaryfloor == mainfloor || secondaryfloor<0)
										{
											its++;
											secondaryfloor = Functions.rand(0,1000) % Map.tileframes;//25sep2021
											if(its>100)
											{
												break;
											}
										}
										its = 0;
										while(thirdfloor == mainfloor || thirdfloor<0 || thirdfloor == secondaryfloor)
										{
											its++;
											thirdfloor = Functions.rand(0,1000) % Map.tileframes;//25sep2021
											if(its>100)
											{
												break;
											}
										}
									}
									Map.tileimage[x + y * Map.MAXX] = mainfloor;
									if(Map.wallimage[x + y * Map.MAXX] != -1)
									{
										for(int ix=x-1;ix<x+2;ix++)
										{
											for(int iy=y-1;iy<y+2;iy++)
											{
												if(ix>=0 && iy>=0 && ix<Map.MAXX - 1 && iy<Map.MAXY -1)
												{
													if(assigned[ix + iy * Map.MAXX]==0)
													{
														Map.tileimage[ix + iy * Map.MAXX] = thirdfloor;
														assigned[ix + iy * Map.MAXX] = 1;
													}
												}
											}
										}
									}
									if(x % 8 == 0 && y % 8 == 0)
									{
										if(x>4 && y>4 && x<Map.MAXX - 4 && y < Map.MAXY - 4)
										{
											for(int ix=x-1;ix<x+2;ix++)
											{
												for(int iy=y-1;iy<y+2;iy++)
												{
													if(assigned[ix + iy * Map.MAXX]==0 && (Map.wallimage[(ix - 2) + iy * Map.MAXX]!=-1 || Map.wallimage[(ix + 1) + iy * Map.MAXX]!=-1))
													{
														Map.tileimage[ix + iy * Map.MAXX] = secondaryfloor;
														assigned[ix + iy * Map.MAXX] = 1;
													}
												}
											}
										}
									}
								}
							}
							for(int x=0;x<Map.MAXX - 1;x++)
							{
								for(int y=0;y<Map.MAXY - 1;y++)
								{
									if(assigned[x + y * Map.MAXX]==0)
									{
										Map.tileimage[x + y * Map.MAXX] = mainfloor;
									}
								}
							}
						}
						if(Game.missions[mission].floorpattern==1 && Map.tileframes>3)
						{
							mainfloor = Functions.rand(0,1000) % 3;//25sep2021
							secondaryfloor = Functions.rand(0,1000) % 3;//25sep2021
							if(mainfloor<0)
							{
								mainfloor = 0;
							}
							if(secondaryfloor<0)
							{
								secondaryfloor = 0;
								if(secondaryfloor == mainfloor)
								{
									secondaryfloor = 1;
								}
							}
							for(int a=0;a<10;a++)
							{
								if(secondaryfloor==mainfloor)
								{
									secondaryfloor = Functions.rand(0,1000) % 3;
								}
								else
								{
									break;
								}
							}
							thirdfloor = 0;//25sep2021
							if(mainfloor==0 || secondaryfloor==0)
							{
								thirdfloor = 1;
							}
							if(mainfloor==1 || secondaryfloor==1)
							{
								thirdfloor = 2;
							}
							
							for(int x=1;x<Map.MAXX-1;x++)
							{
								for(int y=1;y<Map.MAXY-1;y++)
								{
									Map.tileimage[x + y * Map.MAXX] = mainfloor;
									if(Map.wallimage[x + y * Map.MAXX]!=-1)
									{
										Map.tileimage[(x) + (y) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x - 1) + (y) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x + 1) + (y) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x) + (y - 1) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x - 1) + (y - 1) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x + 1) + (y - 1) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x) + (y + 1) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x - 1) + (y + 1) * Map.MAXX] = secondaryfloor;
										Map.tileimage[(x + 1) + (y + 1) * Map.MAXX] = secondaryfloor;
									}
								}
							}
							for(int x=3;x<Map.MAXX-3;x++)
							{
								for(int y=3;y<Map.MAXY-3;y++)
								{
									if(Map.tileimage[x + y * Map.MAXX]==mainfloor)
									{
										other = false;
										for(int xx=x-1;xx<=x+1;xx++)
										{
											for(int yy=y-1;yy<=y+1;yy++)
											{
												if(Map.tileimage[xx + yy * Map.MAXX]==secondaryfloor)
												{
													other = true;
													break;
												}
											}
											if(other)
											{
												break;
											}
										}
										if(!other)
										{
											Map.tileimage[x + y * Map.MAXX] = thirdfloor;
										}
									}
								}
							}
						}
					}
					//end----------//16sep2021
					if(Game.missions[mission].mapgen>0)
					{
						Functions.saveseed(Game.missions[mission].seed);
						Map.generate(game);
						Functions.restoreseed();
					}
					Functions.restoreseed();
					//15oct2021 added this block
					//if(Game.campaignmode>0)//17oct2021
					if(Game.campaignmode>0 && Game.chosenmissionindex<1)//17oct2021
					{
						CampaignMap.CreateMap(Game.campaignattackprovince);
					}
					else
					{
						CampaignMap.CreateMap(-1);
					}
					Map.SetUpHills();//20oct2021
					//unit positions and types..
					for(int i=0;i<Unit.MAXUNITS;i++)
					{
						Game.units[i] = new Unit(game);
					}
					if(Game.missions[mission].units!=null)
					{
						for(int i=0;i<Game.missions[mission].units.Length;i++)
						{
							if(i>=Unit.MAXUNITS)
							{
								continue;
							}
							for(int j=0;j<Game.templates.Length;j++)
							{
								if(Game.templates[j].name==Game.missions[mission].units[i].name)
								{
									Game.units[i].createunitatxy(game,i,Game.templates[j],Game.missions[mission].units[i].x,Game.missions[mission].units[i].y);
									Game.units[i].ai = Game.missions[mission].ai;
									//start---------------------//10sep2021
									Game.units[i].charactername = Game.missions[mission].units[i].charactername; //is going to be either "" or have a value.
									Game.units[i].displaycharactername = Game.missions[mission].units[i].displaycharactername; 
									//end-----------------------//10sep2021
									if(Game.units[i].faction!=Game.PLAYERFACTION)
									{
										Game.victorymessage = true;
										if(Game.missions[mission].demo>0)
										{
											if(Game.units[i].faction!=Unit.HUMAN)
											{
												Game.units[i].hp=0;
											}
										}
									}
									break;
								}
							}
						}
					}
					//copy the triggers.....
					for(int i=0;i<Game.triggers.Length;i++)
					{
						Game.triggers[i] = new Trigger();
					}
					Trigger.number = 0;
					if(Game.missions[mission].triggers!=null)
					{
						for(int i=0;i<Game.missions[mission].triggers.Length;i++)
						{
							if(i>=Game.triggers.Length)
							{
								continue;
							}
							Game.triggers[i] = new Trigger(game,Game.missions[mission].triggers[i].type,Game.missions[mission].triggers[i].comparator,Game.missions[mission].triggers[i].n,Game.missions[mission].triggers[i].unitname,Game.missions[mission].triggers[i].x , Game.missions[mission].triggers[i].y, Game.missions[mission].triggers[i].fx, Game.missions[mission].triggers[i].fy);
							if(Game.triggers[i].unitname!=null)//7oct2021
							{
								int qq = Functions.rand(0,10);
								if(Game.triggers[i].unitname==("WEATHER"))
								{
									if(Map.weather==Map.WEATHERHOT)
									{
										Game.triggers[i].unitname = "It is a hot day sir.|The troops will tire more quickly.";
										if(qq==0)
										{
											Game.triggers[i].unitname = "The hot weather will weaken our armoured soldiers";
										}
										if(qq==1)
										{
											Game.triggers[i].unitname = "The terrible heat makes it hard to fight in.";
										}
									}
									if(Map.weather==Map.WEATHERCOLD)
									{
										Game.triggers[i].unitname = "It is a cold and blustery day. The army will march slower.|Our arrows will not travel as far.";
										if(qq==0)
										{
											Game.triggers[i].unitname = "The Wintry weather will affect both their troops and ours.";
										}
										if(qq==1)
										{
											Game.triggers[i].unitname = "The cold weather will impact our fighting ability.";
										}
										if(qq==2)
										{
											Game.triggers[i].unitname = "The snow and ice will make it harder to fight in.";
										}
									}
									if(Map.weather==Map.WEATHERNORMAL)
									{
										Game.triggers[i].unitname = "It is a fine day for battle dear General.";
										if(qq==0)
										{
											Game.triggers[i].unitname = "The weather is good for fighting.";
										}
										if(qq==1)
										{
											Game.triggers[i].unitname = "A clear day.";
										}
									}
								}
								
								if(Game.triggers[i].unitname==("WON"))
								{
									Game.triggers[i].unitname = "We won the battle! The enemy is scattered|to the four winds.";
									if(qq==1)
									{
										Game.triggers[i].unitname = "The day is ours. Our enemies are crushed before us!";
									}
									if(qq==2)
									{
										Game.triggers[i].unitname = "They flee from our army - we have won!";
									}
									if(qq==3)
									{
										Game.triggers[i].unitname = "Victory is ours!";
									}
									if(qq==4)
									{
										Game.triggers[i].unitname = "We stand victorious General!";
									}
									if(qq==5)
									{
										Game.triggers[i].unitname = "Our army has defeated the enemy!";
									}
									//////Log.i(Config.TAG,"Trigger:"+Game.triggers[i].unitname);
								}
								if(Game.triggers[i].unitname==("LOST"))
								{
									Game.triggers[i].unitname = "All is lost! Our troops have routed|and been destroyed.";
									if(qq==0)
									{
										Game.triggers[i].unitname = "We have lost the battle General. Our armies flee in terror.";
									}
									if(qq==1)
									{
										Game.triggers[i].unitname = "The day is lost!|Our forces have been destroyed.";
									}
									if(qq==2)
									{
										Game.triggers[i].unitname = "A terrible loss for our forces General.";
									}
									if(qq==3)
									{
										Game.triggers[i].unitname = "The bitter taste of defeat is in our mouths.|We lost this one.";
									}
									//////Log.i(Config.TAG,"Trigger:"+Game.triggers[i].unitname);
								}
								if(Game.LETTERBOX==true && (Game.triggers[i].type==3 || Game.triggers[i].type==4))
								{
									Game.triggers[i].x = Game.triggers[i].fx;
									Game.triggers[i].y = Game.triggers[i].fy;
								}
							}
						}
					}
					if(Game.missions[mission].campfirex!=-1)
					{
						Map.setonfire(Game.missions[mission].campfirex,Game.missions[mission].campfirey,true);
					}
					Game.GAMEENDSTATE = 0;
					Game.gameovertime = 0;
					Game.paused = false;
					Map.adddecor();//2mar2021
					Map.marktreepos(game);
				}
			}
		}

///////////////////Method Definition///////////////
		public static void resetlevel(Game game)
		{
			//reset procedure
			//temporary
			Game.GAMEENDSTATE = 0;
			Game.gameovertime = 0;
			Game.zoom = 1;
			//start--------//2apr2021
			Game.gibbet = new Gibbet[Gibbet.MAXGIBBET];
			for(int i=0;i<Gibbet.MAXGIBBET;i++)
			{
				Game.gibbet[i] = new Gibbet();
			}
			//end----------//2apr2021
			Game.blood = new Blood[Blood.MAXBLOOD];
			for(int i=0;i<Blood.MAXBLOOD;i++)
			{
				Game.blood[i] = new Blood();
			}
			Game.bullets = new Bullet[Bullet.MAXBULLET];
			for(int i=0;i<Bullet.MAXBULLET;i++)
			{
				Game.bullets[i] = new Bullet();
			}
			Bullet.nextfree = 0;
			Game.units = new Unit[Unit.MAXUNITS];
			for(int i=0;i<Game.units.Length;i++)
			{
				Game.units[i] = new Unit(game);
				Game.units[i].createunitatxy(game,i,Game.templates[0],Functions.rand(100,Game.RESOLUTIONX-100),Functions.rand(100,Game.RESOLUTIONY-100));
				Game.units[i].hp-=Functions.rand(5,55);
			}
			Game.CORNERX = 0;
			Game.CORNERY = 0;
			Game.triggers = new Trigger[Trigger.MAXTRIGGER];
			for(int i=0;i<Trigger.MAXTRIGGER;i++)
			{
				Game.triggers[i] = new Trigger();
			}
		}

///////////////////Method Definition///////////////
		public static void resetgame(Game game)
		{
			//reset procedure
			//RTS
			//temporary
			Game.map = new Map();
			Game.zoom = 1f;
			Game.killcount = 0;
			Game.gibbet = new Gibbet[Gibbet.MAXGIBBET];//2apr2021
			//start--------------------//2apr2021
			Gibbet.MAXINDEX = 0;
			//Blood.MAXINDEX = 0;
			Bullet.MAXINDEX = 0;
			Bullet.nextfree = 0;
			Unit.MAXINDEX = 0;
			//end----------------------//2apr2021
			for(int i=0;i<Gibbet.MAXGIBBET;i++)
			{
				Game.gibbet[i] = new Gibbet();
			}
			
			Game.blood = new Blood[Blood.MAXBLOOD];
			for(int i=0;i<Blood.MAXBLOOD;i++)
			{
				Game.blood[i] = new Blood();
			}
			Game.bullets = new Bullet[Bullet.MAXBULLET];
			for(int i=0;i<Bullet.MAXBULLET;i++)
			{
				Game.bullets[i] = new Bullet();
			}
			Game.triggers = new Trigger[Trigger.MAXTRIGGER];
			for(int i=0;i<Trigger.MAXTRIGGER;i++)
			{
				Game.triggers[i] = new Trigger();
			}
			Map.generate(game);
			//Game.templates = new Unit[1];
			//Game.templates[0] = new Unit(game);
			//Game.templates[0].reset(game,0);
			//Unit.debugtemplate(Game.templates[0]);
			Game.units = new Unit[Unit.MAXUNITS];
			for(int i=0;i<Game.units.Length;i++)
			{
				Game.units[i] = new Unit(game);
				Game.units[i].createunitatxy(game,i,Game.templates[0],Functions.rand(100,Game.RESOLUTIONX-100),Functions.rand(100,Game.RESOLUTIONY-100));
				Game.units[i].hp-=Functions.rand(5,55);
			}
			Game.GAMEENDSTATE = 0;
			Game.gameovertime = 0;
		}

///////////////////Method Definition///////////////
		static void resetunits(Game game)
		{
			//not used
		}

///////////////////Method Definition///////////////
		static void guimenus(Game game)
		{
			//manage the gui
			RenderList.IGNOREZOOM = true;
			if(Game.mlclick || Game.mrclick) //15apr2021
			{
				if(Game.gamestate==Game.CAT_GAMESTATE_GAME)
				{
					Game.clickerframe = 0;
					Game.clickerx = Game.mx;
					Game.clickery = Game.my;
				}
			}
			int gstate = Game.gamestate;//30apr2021
			//Research.Enhance();//21oct2021
			Gui.updateall(game);
			//Research.Revert();//21oct2021
			Gui.drawall(game);
			
			if(gstate!=Game.gamestate)//30apr2021
			{
				Gui.updatealtimages(game);
			}
			if(Game.togglepause)//12apr2021
			{
				RenderList.drawtext(game,Game.RESOLUTIONX/2,Game.RESOLUTIONY - 100,Translation.TranslateWord("Paused",false),RenderList.getrgb(255,255,200),Game.fonts[Resources.LARGEFONT].font,true);
			}
			if(Game.gamestate!=Game.CAT_GAMESTATE_GAME && Game.gamestate!=Game.CAT_GAMESTATE_REPLAY)//3jun2021
			{
				RenderList.drawtext(game,Game.RESOLUTIONX - 100,Game.RESOLUTIONY - 20,Translation.TranslateWord("Ver:",false)+Game.VERSIONSTR,RenderList.getrgb(255,255,200),Game.fonts[Resources.SMALLFONT].font,true);//3jun2021
			}
			//if(Game.clicker!=-1)//15apr2021//17apr2021 commented out and removed inside part.
			//{
			//}
			if(Game.targeticon!=-1)//16apr2021
			{
				if(Game.mouseoverunitid!=-1)
				{
					if(Game.anyselected)
					{
						int i = Game.mouseoverunitid;
						if(Game.units[i].faction==Game.SKIRMISHENEMYFACTION && Game.units[i].hp>0)
						{
							//draw the target icon......
							float ss = 0.2f*(float)Math.Sin((float)Game.frame/20f);
							RenderList.drawanimimage(game,Game.images[Game.targeticon].texture,Game.mx,Game.my,0,0.4f+ss,0.4f+ss,0,0,false,1f,Game.targeticon);
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		static void basemenus(Game game)
		{
			//part of core update loop
			if(Game.gamestate==Game.CAT_GAMESTATE_MENU)
			{
				Game.skirmish = false;
				Config.loaded = true;
				if(Game.mlclick==true || Game.frame>5)
				{
					if(Config.loaded)
					{
						Game.gamestate=Game.CAT_GAMESTATE_NEWCONTINUE;
					}
					if(Config.TESTDEBRIEF)
					{
						Game.gamestate=Game.CAT_GAMESTATE_DEBRIEF2;
						testdebrief(game);
					}
					//Audios.playsound(Game.audios[Resources.CAT_AUDIO_CLICK],1f);
					//level = Game.LEVEL1;
				}
				/*
				if(!Config.loaded)
				{
					if((Game.frame % 20)==0)
					{
						Config.loadpct+=(int)Functions.rand(5,25);
					}
					if(Config.loadpct>100)
					{
						Config.loaded = true;
						Config.loadpct = 100;
					}
					RenderList.drawtext(game,800,800,"Loading..."+Config.loadpct+"%",RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);
				}
				*/
				return;
			}
			if(Game.gamestate==Game.CAT_GAMESTATE_NEWCONTINUE)
			{
					resetgame(game);
					//Audios.playsound(Game.audios[Resources.CAT_AUDIO_CLICK],1f);
					//level = Game.LEVEL1;
					//newlevelframe = 200;
					if(Game.EDITOR)
					{
						Game.gamestate = Game.CAT_GAMESTATE_GAME;
						Game.map = new Map();
						Program.setupeditor(game);
						Game.PLAYERFACTION = Unit.HUMAN;
					}
					else
					{
						Game.gamestate = Game.CAT_GAMESTATE_GUIMENUS;
						Game.map = new Map();
						Program.setupbackdrop(game);
						Game.demomode = true;
						Game.PLAYERFACTION = Unit.HUMAN;
						if(Game.trainai>0)
						{
							Game.chosenmissionindex = 0;
							Game.campaignmode = 0;//8oct2021
							if(Game.chosenmissionindex!=-1)
							{
								Map.levelseed = Functions.seed;//2apr2021
								Program.resetgame(game);//2apr2021
								Game.PLAYERFACTION = Unit.HUMAN;
								Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
								Game.gamestate = Game.CAT_GAMESTATE_GAME;
								Program.cleardeaths(game);
								Game.map = new Map();
								Program.setupmission(game,Game.chosenmissionindex,2);
								Map.adddecor();//2mar2021
								Map.marktreepos(game);
								Map.levelseed2 = Functions.seed;//2apr2021
								//remove all units....
								for(int nid=0;nid<Game.units.Length;nid++)
								{
									Game.units[nid].hp = 0;
									Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
									Game.units[nid].reset(null,nid);
								}
								//Map.removeallbones();
								Game.gamemode = 0;//DEPLOY
								Game.RESOLVE = 0;
								Game.PLAYERFACTION = 6;//7oct2021
								Game.SKIRMISHENEMYFACTION = 5;//7oct2021
								Game.numelements = CampaignMap.NumElements(-1);
								Game.numenemyelements = CampaignMap.NumElements(-1);
								Game.vsai = 1 + Functions.rand(0,1000) % Unit.NUMAISCRIPTS;
								Game.vsai = Unit.GetSecondMostPowerfulAi();
							}	
						}
					}
					return;
			}
			if(Game.gamestate==Game.CAT_GAMESTATE_STARTLEVEL)
			{
				//temporary
				Game.gamestate = Game.CAT_GAMESTATE_GAME;
			}
		}
		/*

///////////////////Method Definition///////////////
		static void drawcreditsinfo(Game game)
		{
			string[] consoletext = new string[3];
			consoletext[0] = "Art, Design, Development, Programming";
			consoletext[1] = Game.AUTHOR + " " + Game.YEAR;
			consoletext[2] = "Music by Eric Matyas, soundimage.org";
			int a = 3;
			for(int i=0;i<a;i++)
			{
				RenderList.drawtext(game,Game.RESOLUTIONX/2,Game.RESOLUTIONY - 45 + i * 16,consoletext[i],RenderList.getrgb(255,255,255),Game.fonts[Resources.SMALLFONT].font,true);
			}
		}
		*/

///////////////////Method Definition///////////////
		static void handlezoom(Game game)
		{
			//handle the zoom in the game map to scale things
			//correctly
			if(Game.EDITOR)
			{
				return;
			}
			if(Game.mwheel<0)
			{
				Game.zoom -= 0.25f;
			}
			if(Game.mwheel>0)
			{
				Game.zoom += 0.25f;
			}
			Game.mwheel = 0;
			if(Game.zoom>4)
			{
				Game.zoom = 4;
			}
			if(Game.zoom<1)
			{
				Game.zoom = 1;
			}
			Game.zoom = 1;//27mar2021 // no more zoom.....?
			Game.zoomcornerx = (int)(-1f * (float)(Game.RESOLUTIONX/2)*(Game.zoom - 1));
			Game.zoomcornery = (int)(-1f * (float)(Game.RESOLUTIONY/2)*(Game.zoom - 1));
		}

///////////////////Method Definition///////////////
		static void handleedit(Game game)
		{
			//handle editing the map in the editor
			if(Game.frame % 200==0)
			{
				Map.marktreepos(game);
			}
			for(int i=0;i<Game.gui.Length;i++)
			{
				if(Game.gui[i].type==Gui.TYPE_MINIMAP)
				{
					if(Game.gui[i].mouseover)
					{
						return;
					}				
				}
			}
			Game.zoom = 1;
			int dirn = Functions.sign(Game.mwheel);
			Game.mwheel = 0;
			Game.editgridx = (Game.CORNERX + Game.mx)/ Map.GRIDW;
			Game.editgridy = (Game.CORNERY + Game.my)/ Map.GRIDH;
			if(Game.EDITMODE==Game.EDITMODE_TRIGGER || Game.EDITMODE==Game.EDITMODE_ENTERTEXT)
			{
				//Game.editname = "TRIGGERS"; //22mar2021
				Game.editname = Translation.TranslateWord("TRIGGERS",false);
				if(Game.EDITMODE==Game.EDITMODE_ENTERTEXT)
				{
					TriggerHelper.constructorstring(game,false,false,0);
					TriggerHelper.gettext(game);
				}
				else
				{
					TriggerHelper.constructorstring(game,Game.mlclick,Game.mrclick,dirn);
				}
			}
			if(Game.EDITMODE==Game.EDITMODE_ROCK)
			{
				//Game.editname = "ROCKS";//22mar2021
				Game.editname = Translation.TranslateWord("ROCKS",false);//22mar2021
				if(Game.mldown)
				{
					Map.rockimage[Game.editgridx + Game.editgridy * Map.MAXX] = 0;	
				}
				if(Game.mrdown)
				{
					Map.rockimage[Game.editgridx + Game.editgridy * Map.MAXX] = Map.VACANT;
				}
			}
			if(Game.EDITMODE==Game.EDITMODE_TREE)
			{
				//Game.editname = "TREES";//22mar2021
				Game.editname = Translation.TranslateWord("TREES",false);//22mar2021
				if(Game.mldown)
				{
					Map.treeimage[Game.editgridx + Game.editgridy * Map.MAXX] = 0;	
				}
				if(Game.mrdown)
				{
					Map.treeimage[Game.editgridx + Game.editgridy * Map.MAXX] = Map.VACANT;
				}
			}
			if(Game.EDITMODE==Game.EDITMODE_WALL)
			{
				//Game.editname = "WALLS";//22mar2021
				Game.editname = Translation.TranslateWord("WALLS",false);//22mar2021
				if(Game.mldown)
				{
					Map.wallimage[Game.editgridx + Game.editgridy * Map.MAXX] = 0;	
				}
				if(Game.mrdown)
				{
					Map.wallimage[Game.editgridx + Game.editgridy * Map.MAXX] = Map.VACANT;
				}
			}
			if(Game.EDITMODE==Game.EDITMODE_HEIGHT && Config.USEHEIGHTS>0)
			{
				//Game.editname = "HEIGHT";//22mar2021
				Game.editname = Translation.TranslateWord("HEIGHT",false);//22mar2021
				if(Game.mldown)
				{
					//Map.heightmap[Game.editgridx + Game.editgridy * Map.MAXX]--;	
					Map.pushmap(Game.editgridx * Map.GRIDW,Game.editgridy * Map.GRIDH,-1);
				}
				if(Game.mrdown)
				{
					//Map.heightmap[Game.editgridx + Game.editgridy * Map.MAXX]++;
					Map.pushmap(Game.editgridx * Map.GRIDW,Game.editgridy * Map.GRIDH,+1);
				}
			}
			if(Game.EDITMODE==Game.EDITMODE_UNIT)
			{
				if(dirn>0)
				{
					Game.editindex++;
				}
				if(dirn<0)
				{
					Game.editindex--;
				}
				if(Game.editindex<0)
				{
					Game.editindex = Game.templates.Length - 1;
				}
				if(Game.editindex>Game.templates.Length - 1)
				{
					Game.editindex = 0;
				}
				//Game.editname = Game.templates[Game.editindex].name + " Faction:"+Game.templates[Game.editindex].faction;//22mar2021
				Game.editname = Game.templates[Game.editindex].dname() + " " + Translation.TranslateWord("Faction:",false)+Game.templates[Game.editindex].faction;
				if(Game.mldown)
				{
					for(int k=0;k<Game.units.Length;k++)
					{
						if(Game.units[k].hp<=0)
						{
							Game.units[k].createunitatxy(game,k,Game.templates[Game.editindex],Game.editgridx * Map.GRIDW,Game.editgridy * Map.GRIDH);	
							break;
						}
					}
				}
				if(Game.mrdown)
				{
					int nid = Map.cellunit(Game.editgridx * Map.GRIDW,Game.editgridy * Map.GRIDH);
					if(nid!=-1)
					{
						Map.removeunit(nid,Game.editgridx * Map.GRIDW,Game.editgridy * Map.GRIDH);
						Game.units[nid].hp=0;
					}
				}
			}
		}

///////////////////Method Definition///////////////
		static void handlegroupselection(Game game)
		{
			//handle selecting groups and assigning groups
			bool found = false;
			int sumx = 0;
			int sumy = 0;
			int count = 0;
			for(int i=0;i<10;i++)
			{
				if(Game.numberkeys[i]!=0)
				{
					//for(int j=0;j<Game.units.Length;j++)//26mar2021
					for(int j=0;j<=Unit.MAXINDEX;j++)//26mar2021
					{
						if(Game.units[j].hp>0 && Game.units[j].faction==Game.PLAYERFACTION && Game.leftcontrolkey>0 && Game.units[j].selected>Unit.SELECTIONNONE)
						{
							if(!found)
							{
								found = true;
								//for(int k=0;k<Game.units.Length;k++)//26mar2021
								for(int k=0;k<=Unit.MAXINDEX;k++)//26mar2021
								{
									if(Game.units[k].groupid==i)
									{
										Game.units[k].groupid = -1;
									}
								}
							}
							Game.units[j].groupid = i;
						}
						if(Game.units[j].hp>0 && Game.units[j].faction==Game.PLAYERFACTION && Game.units[j].groupid==i && Game.leftcontrolkey==0)
						{
							if(!found)
							{
								//for(int k=0;k<Game.units.Length;k++)//26mar2021
								for(int k=0;k<=Unit.MAXINDEX;k++)//26mar2021
								{
									Game.units[k].selected=Unit.SELECTIONNONE;
								}
								found = true;
							}
							Game.units[j].selected=Unit.SELECTIONFROZEN;
							count++;
							sumx+=Game.units[j].x;
							sumy+=Game.units[j].y;
							if(Game.numberkeys[i]>1)
							{
								Game.CORNERX = (sumx / count) - Game.RESOLUTIONX/2;
								Game.CORNERY = (sumy / count) - Game.RESOLUTIONY/2;
								if(Game.CORNERX<0)
								{
									Game.CORNERX = 0;
								}
								if(Game.CORNERY<0)
								{
									Game.CORNERY = 0;
								}
								if(Game.CORNERX > Map.MAXX*Map.GRIDW - Game.RESOLUTIONX)
								{
									Game.CORNERX = Map.MAXX*Map.GRIDW - Game.RESOLUTIONX;
								}
								if(Game.CORNERY > Map.MAXY*Map.GRIDH - Game.RESOLUTIONY)
								{
									Game.CORNERY = Map.MAXY*Map.GRIDH - Game.RESOLUTIONY;
								}	
								for(int k=0;k<10;k++)
								{
									Game.numberkeys[k]=0;
								}
							}
						}
					}
					if(Game.frame > Game.numberkeysframe[i]+15)
					{
						Game.numberkeys[i] = 0;
					}
				}
			}
		}

///////////////////Method Definition///////////////
		static void updatestats(Game game)
		{
			//update the display statistics at the debriefing
			for(int i=0;i<Game.templates.Length;i++)
			{
				if(Game.templates[i].dispdeaths<Game.templates[i].prevdeaths)
				{
					Game.templates[i].dispdeaths++;
					return;
				}
				if(Game.templates[i].dispkills<Game.templates[i].prevkills)
				{
					Game.templates[i].dispkills++;
					return;
				}
				if(Game.templates[i].dispcreates<Game.templates[i].prevcreates)
				{
					Game.templates[i].dispcreates++;
					return;
				}
			}
		}

///////////////////Method Definition///////////////
		static void drawdebriefbk(Game game)
		{
			//draw the debriefing screen
			int iiline = 0;
			int ofaction = -1;
			int yb = 125;
			uint color = RenderList.getrgb(255,255,222);
			//13mar2021 - need translations! Grr.
			//RenderList.drawtext(game,500,yb + (-1) * Game.fonts[Resources.FONT].ptsize,"Unit",color,Game.fonts[Resources.FONT].font,false);
			//RenderList.drawtext(game,700,yb + (-1) * Game.fonts[Resources.FONT].ptsize,"Created",color,Game.fonts[Resources.FONT].font,false);
			//RenderList.drawtext(game,900,yb + (-1) * Game.fonts[Resources.FONT].ptsize,"Kills",color,Game.fonts[Resources.FONT].font,false);
			//RenderList.drawtext(game,1100,yb + (-1) * Game.fonts[Resources.FONT].ptsize,"Deaths",color,Game.fonts[Resources.FONT].font,false);
			//12apr2021 changed 500 to 300 here.....
			RenderList.drawtext(game,400,yb + (-1) * Game.fonts[Resources.FONT].ptsize,Translation.TranslateWord("Unit",false),color,Game.fonts[Resources.FONT].font,false);
			RenderList.drawtext(game,700,yb + (-1) * Game.fonts[Resources.FONT].ptsize,Translation.TranslateWord("Created",false),color,Game.fonts[Resources.FONT].font,false);
			RenderList.drawtext(game,900,yb + (-1) * Game.fonts[Resources.FONT].ptsize,Translation.TranslateWord("Kills",false),color,Game.fonts[Resources.FONT].font,false);
			RenderList.drawtext(game,1100,yb + (-1) * Game.fonts[Resources.FONT].ptsize,Translation.TranslateWord("Deaths",false),color,Game.fonts[Resources.FONT].font,false);
			for(int i=0;i<Game.templates.Length;i++)
			{
				if(Game.templates[i].faction==Unit.NULLFACTION && Game.templates[i].walkspeed<=0)
				{
					continue;
				}
				if(Game.templates[i].prevcreates>0 || Game.templates[i].prevkills>0 || Game.templates[i].prevdeaths>0)
				{
					color = RenderList.getrgb(255,255,200);
					if(Game.templates[i].faction!=Game.PLAYERFACTION)
					{
						color = RenderList.getrgb(255,200,200);
					}
					if(Game.templates[i].faction==Unit.NULLFACTION)
					{
						color = RenderList.getrgb(200,200,200);
					}
					iiline++;
					if(Game.templates[i].faction!=ofaction)
					{
						ofaction = Game.templates[i].faction;
						iiline++;
						RenderList.drawtext(game,800,yb + iiline * Game.fonts[Resources.FONT].ptsize,"----------------------------------------------------------------------------",RenderList.getrgb(200,200,200),Game.fonts[Resources.FONT].font,true);
						iiline++;
					}
					//RenderList.drawtext(game,500,yb + iiline * Game.fonts[Resources.FONT].ptsize,Game.templates[i].name,color,Game.fonts[Resources.FONT].font,false); //13mar2021
					//RenderList.drawtext(game,700,yb + iiline * Game.fonts[Resources.FONT].ptsize,""+Game.templates[i].dispcreates,color,Game.fonts[Resources.FONT].font,false);//13mar2021
					//RenderList.drawtext(game,900,yb + iiline * Game.fonts[Resources.FONT].ptsize,""+Game.templates[i].dispkills,color,Game.fonts[Resources.FONT].font,false);//13mar2021
					//RenderList.drawtext(game,1100,yb + iiline * Game.fonts[Resources.FONT].ptsize,""+Game.templates[i].dispdeaths,color,Game.fonts[Resources.FONT].font,false);//13mar2021
					RenderList.drawtext(game,400,yb + iiline * Game.fonts[Resources.FONT].ptsize,Game.templates[i].dname(),color,Game.fonts[Resources.FONT].font,false); //13mar2021
					RenderList.drawtext(game,700,yb + iiline * Game.fonts[Resources.FONT].ptsize,""+Translation.TranslateNumber(Game.templates[i].dispcreates),color,Game.fonts[Resources.FONT].font,false);//13mar2021
					RenderList.drawtext(game,900,yb + iiline * Game.fonts[Resources.FONT].ptsize,""+Translation.TranslateNumber(Game.templates[i].dispkills),color,Game.fonts[Resources.FONT].font,false);//13mar2021
					RenderList.drawtext(game,1100,yb + iiline * Game.fonts[Resources.FONT].ptsize,""+Translation.TranslateNumber(Game.templates[i].dispdeaths),color,Game.fonts[Resources.FONT].font,false);//13mar2021
					updatestats(game);
				}
			}	
		}

///////////////////Method Definition///////////////
		static void update(Game game)
		{
			//core game update routine
			//handles all updates
			if(!NetworkUDP.Ready())//9oct2021
			{
				//NetworkUDP.InitAsServer();//done in TryMultiplayer
			}
			else
			{
				NetworkUDP.HandleComms();
			}
			Stopwatch utimer = new Stopwatch();
			utimer.Start();
			long bmenutime = 0;
			long umusictime = 0;
			long mapupdatepostime = 0;
			long mapcorrecttime = 0;
			long unitupdatetime = 0;
			long bullettime = 0;
			long bloodtime = 0;
			long selecttime = 0;
			long triggertime = 0;
			long drawtime = 0;
			Game.newtrees = new int[0];//24apr2021
			//int dieroll = Functions.rand(0,100);//2apr2021
			//start---------------------//20apr2021
			if(Config.AUTOCALCOFFSETS==true && Config.FINISHEDOFFSETS==false)
			{
				for(int i=0;i<Game.templates.Length;i++)
				{
					if(Game.templates[i].autocalcedoffsets==false)
					{
						Unit.AutoCalcOffsets(game,i);
						if(Game.templates[i].autocalcedoffsets)
						{
							break;
						}
						if(i==Game.templates.Length - 1)
						{
							Config.FINISHEDOFFSETS = true;
						}
					}
				}
				if(Config.FINISHEDOFFSETS)
				{
					Unit.WriteOffsets(game,Config.offsetfile);
				}
			}
			//end-----------------------//20apr2021
			//start---------------//26mar2021
			if(Game.selectingtime>0)
			{
				Game.selectingtime--;
			}
			//end-----------------//26mar2021
			if(Game.gamestate==Game.CAT_GAMESTATE_LOGO)
			{
				//if(Game.frame<100) //27mar2021
				//{
					//drawloadingbar(game,648,Game.frame,300);
					//return;
				//}
				drawlogo(game);
				return;
			}
			//END RTS
			//
			bmenutime = utimer.ElapsedMilliseconds;
			basemenus(game);
			bmenutime = Math.Abs(utimer.ElapsedMilliseconds - bmenutime);
			umusictime = utimer.ElapsedMilliseconds;
			Map.updatemusic(game);
			umusictime = Math.Abs(utimer.ElapsedMilliseconds - umusictime);
			if(Game.gamestate==Game.CAT_GAMESTATE_GAME)
			{
				if(Game.editkeypressed==10)
				{
					Game.editkeypressed=11;
					Game.EDITOR = true;
					//start----------//5apr2021
					try
					{
						Network.url = "https://www.mattiesgames.com/metrics/metric.php?game=kog2mission&event=editor&value=1&uid="+Config.uid;//30mar2021
						Network.httpget(Network.url);
					}
					catch(Exception e)
					{
						string message = e.Message;
					}
					//end-----------//5apr2021
					Game.EDITORPFACTION = Game.PLAYERFACTION; //22mar2021
					Game.EDITOREFACTION = Game.SKIRMISHENEMYFACTION; //22mar2021
					Functions.saveseed(Functions.seed);
					Game.zoom = 0;
					Game.mwheel = 0;
					Game.playerready = false;
					Game.playingtutorial = false;
					Game.skirmish = false;
					Game.victorymessage = false;
					cleardeaths(game);
					Game.playingtutorial = false;
					Game.GAMEENDSTATE = 0;
					Game.gameovertime = 0;
					Game.paused = false;
					Map.adddecor();//2mar2021
					Map.marktreepos(game);
					return;
				}
				if(Game.EDITOR)
				{
					if(Game.backupkeypressed>=10)
					{
						Game.backupkeypressed = 0;
						try
						{
							System.Diagnostics.Process.Start(@"restoreall.bat");
							Game.WriteDebug("Original Settings Restored");
						}
						catch(Exception eee)
						{
							Game.WriteDebug(eee.Message);
						}
					}
				}
				else
				{
					Game.backupkeypressed = 0;
				}
				Game.demomode = false;
				mapupdatepostime = Math.Abs(utimer.ElapsedMilliseconds);
				Map.updatepos(ref game);
				mapupdatepostime = Math.Abs(utimer.ElapsedMilliseconds - mapupdatepostime);
				if((Game.frame % 121)==0 && Config.RUNNINGSPEED<90)
				{
					mapcorrecttime = utimer.ElapsedMilliseconds;
					Map.correct(game);
					mapcorrecttime = Math.Abs(utimer.ElapsedMilliseconds - mapcorrecttime);
				}
				unitupdatetime = utimer.ElapsedMilliseconds;
				if(Game.trainai>0)//20oct2021
				{
					Game.battlespeed = 10;
				}
				if(Game.winloss!=0)//17oct2021
				{
					Game.battlespeed = 1;
				}
				Beacon.ClickBeacon();//19oct2021
				//Research.Enhance();//21oct2021
				for(int b=0;b<Game.battlespeed;b++)//16oct2021
				{
					if(!Game.togglepause)//22mar2021
					{
						if(b>0)//16oct2021
						{
							Game.frame++;
						}
						if(Game.throttleframerate>0 && Game.throttleframerate < Config.UNLOCKFRAMERATE && Config.MATCHSLOWEST==1)
						{
							//only update units every OTHER frame..or such....
							int howoften = Config.UNLOCKFRAMERATE / Game.throttleframerate;
							if(Game.frame % howoften==0)
							{
								Beacon.UpdateBeacons();//19oct2021
								Unit.updateall(game); //this is where optimisation will make the most difference....
							}
						}
						else
						{
							Beacon.UpdateBeacons();//19oct2021
							Unit.updateall(game); //this is where optimisation will make the most difference....
						}
						Tech.updateall(game);//2sep2021
					}
				}
				//Research.Revert();//21oct2021
				unitupdatetime = Math.Abs(utimer.ElapsedMilliseconds - unitupdatetime);
				if(!Game.EDITOR)
				{
					if(!Game.togglepause)//22mar2021
					{
						bullettime = utimer.ElapsedMilliseconds;
						Bullet.updateall(game);
						bullettime = Math.Abs(utimer.ElapsedMilliseconds - bullettime);
						bloodtime = utimer.ElapsedMilliseconds;
						Blood.updateall(game);
						bloodtime = Math.Abs(utimer.ElapsedMilliseconds - bloodtime);
						Gibbet.updateall(game);//2apr2021
					}
					handlezoom(game);
				}
				else
				{
					handleedit(game);
					Game.recordkeypressed = 0;
				}
				RenderList.IGNOREZOOM = false;
				drawtime = utimer.ElapsedMilliseconds;
				Game.mouseoverunitid = -1; //24mar2021
				Unit.drawall(game);
				if(!Game.EDITOR)
				{
					Bullet.drawall(game);
					Blood.drawall(game);
					Gibbet.drawall(game);//2apr2021
					Beacon.DrawBeacons();//19oct2021
					Map.drawrain(game);
				}
				else
				{
					//13mar2021 editor not translated yet.....
					if(Game.editname!="")
					{
						RenderList.drawtext(game,Game.mx,Game.my,Game.editname+","+Game.editgridx+","+Game.editgridy,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);
					}
					//RenderList.drawtext(game,0,800,"w-Wall Mode,r-Rock Mode,t-Tree Mode,u-Unit Mode,x-Triggers,o-Map File,c-Campaign File,Left Mouse Place, Right Mouse Remove",RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);//22mar2021
					RenderList.drawtext(game,0,800,Translation.TranslateWord("w-Wall Mode,r-Rock Mode,t-Tree Mode,u-Unit Mode,x-Triggers,o-Map File,c-Campaign File,Left Mouse Place, Right Mouse Remove",false),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);//22mar2021
					if(Config.USEHEIGHTS>0)
					{
						//RenderList.drawtext(game,0,830,"h-Height Mode",RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);/22mar2021
						RenderList.drawtext(game,0,830,Translation.TranslateWord("h-Height Mode",false),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);//22mar2021
					}
					//RenderList.drawtext(game,0,860,"Map Saved In:"+Config.custommapfolder,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);//22mar2021
					RenderList.drawtext(game,0,860,Translation.TranslateWord("Map Saved In:",false)+Config.custommapfolder,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);//22mar2021
					if(Game.EDITMODE==Game.EDITMODE_TRIGGER || Game.EDITMODE==Game.EDITMODE_ENTERTEXT)
					{
						RenderList.drawtext(game,0,700,TriggerHelper.constructorstring(game,false,false,0),RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);
						//RenderList.drawtext(game,0,750,"INFO: You will have to edit the triggers in a text file for some features.",RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);//22mar2021
						RenderList.drawtext(game,0,750,Translation.TranslateWord("INFO: You will have to edit the triggers in a text file for some features.",false),RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);//22mar2021
						if(Game.EDITMODE==Game.EDITMODE_ENTERTEXT)
						{
							if(Game.edittriggerstring.Length>0)
							{
								if(Game.frame % 60 < 30)
								{
									RenderList.drawtext(game,0,725,Game.edittriggerstring+"__",RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);
								}
								else
								{
									RenderList.drawtext(game,0,725,Game.edittriggerstring,RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);
								}
							}
							else
							{
								if(Game.frame % 60 < 30)
								{
									//RenderList.drawtext(game,0,725,"[CHATTER]__",RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);//22mar2021
									RenderList.drawtext(game,0,725,Translation.TranslateWord("[CHATTER]__",false),RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);//22mar2021
								}
								else
								{
									//RenderList.drawtext(game,0,725,"[CHATTER]",RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);//22mar2021
									RenderList.drawtext(game,0,725,Translation.TranslateWord("[CHATTER]",false),RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);//22mar2021
								}
							}
						}
						for(int i=0;i<TriggerHelper.triggers.Length;i++)
						{
							if(TriggerHelper.triggers!=null)
							{
								RenderList.drawtext(game,0,15 + i * 20,TriggerHelper.triggers[i],RenderList.getrgb(32,32,32),Game.fonts[Resources.SMALLFONT].font,false);
							}
						}
					}
				}
				RenderList.IGNOREZOOM = true;
				drawtime = Math.Abs(utimer.ElapsedMilliseconds - drawtime);
				selecttime = utimer.ElapsedMilliseconds;
				//if(Game.mldown && !Game.paused)//22mar2021
				Game.TMPCORNERX = Game.CORNERX;//21apr2021
				Game.TMPCORNERY = Game.CORNERY;//21apr2021
				if(Replay.IsPlaying())//21apr2021
				{
					Game.CORNERX = Game.RCORNERX;
					Game.CORNERY = Game.RCORNERY;
				}
				if(Game.mldown && !Game.paused && !Game.togglepause)//22mar2021
				{
					int x = Game.smx;
					int y = Game.smy;
					int w = (int)Functions.abs(Game.fmx - Game.smx);
					int h = (int)Functions.abs(Game.fmy - Game.smy);
					if(x > Game.fmx)
					{
						x = Game.fmx;
					}
					if(y > Game.fmy)
					{
						y = Game.fmy;
					}
					//start---------------//26mar2021
					if(Functions.abs(w)>10 || Functions.abs(h)>10)
					{
						Game.selectingtime = Game.WAITSELECTINGTIME;
					}
					//end-----------------//26mar2021
					//21apr2021 added diffx stuff
					int diffx = Game.CORNERX - Game.TMPCORNERX;
					int diffy = Game.CORNERY - Game.TMPCORNERY;
					RenderList.drawunfilledrect(game,diffx + x - 1,diffy + y - 1,w,h,RenderList.getrgb(24,170,24),0);
					RenderList.drawunfilledrect(game,diffx + x + 1,diffy + y + 1,w,h,RenderList.getrgb(24,170,24),0);
					RenderList.drawunfilledrect(game,diffx + x,diffy + y,w,h,RenderList.getrgb(32,255,32),0);
					int mmx = (int)((float)(x - Game.RESOLUTIONX/2)/Game.zoom) + Game.CORNERX + Game.RESOLUTIONX/2;
					int mmy = (int)((float)(y - Game.RESOLUTIONY/2)/Game.zoom) + Game.CORNERY + Game.RESOLUTIONY/2;
					int mmw = (int)((float)w / Game.zoom);
					int mmh = (int)((float)h / Game.zoom);
					Unit.select(game,mmx,mmy,mmw,mmh);
				}
				//if(Game.mlclick && !Game.paused)//22mar2021
				if(Game.mlclick && !Game.paused && !Game.togglepause)//22mar2021
				{
					//freeze selection until a command is chosen....
					if(Unit.noneselected(game))
					{
						//Unit.selectone(game);
						int mmx = (int)((float)(Game.mx - Game.RESOLUTIONX/2)/Game.zoom) + Game.CORNERX + Game.RESOLUTIONX/2;
						int mmy = (int)((float)(Game.my - Game.RESOLUTIONY/2)/Game.zoom) + Game.CORNERY + Game.RESOLUTIONY/2;
						Unit.select(game,mmx,mmy,-1,-1);
					}
					Unit.freezeselect(game);
				}
				//if(Game.mrclick && !Game.paused)//22mar2021
				if(Game.mrclick && !Game.paused && !Game.togglepause)//22mar2021
				{
					Unit.issueorder(game);
					//Unit.deselect(game);
				}
				if(Unit.CRPG>0)//25sep2021
				{
						if(Game.mlclick && !Game.paused && !Game.togglepause)
						{
							Unit.issueorder(game);
						}
				}
				if(!Game.togglepause)//22mar2021
				{
					handlegroupselection(game);
				}
				selecttime = Math.Abs(utimer.ElapsedMilliseconds - selecttime);
				Game.CORNERX = Game.TMPCORNERX;//21apr2021
				Game.CORNERY = Game.TMPCORNERY;//21apr2021
			}
			else
			{
				if(Game.demomode)
				{
					RenderList.IGNOREZOOM = true;//18sep2021
					if(Config.NOUPDATEINDEMOMODE==0)//18sep2021
					{
						Map.updatepos(ref game);
						if((Game.frame % 121)==0)
						{
							Map.correct(game);
							Map.setonfire(1940,2580,true);
						}
						Unit.updateall(game);
						Tech.updateall(game);//2sep2021
						Bullet.updateall(game);
						Blood.updateall(game);
						Gibbet.updateall(game);//2apr2021
						//RenderList.IGNOREZOOM = true;//18sep2021
						Unit.drawall(game);
						Bullet.drawall(game);
						Blood.drawall(game);
						Gibbet.drawall(game);//2apr2021
					}
					Game.editkeypressed = 0; //22mar2021
					//RenderList.drawtext(game,1400,845,"Version"+Game.VERSION,RenderList.getrgb(255,255,200),Game.fonts[Resources.SMALLFONT].font,false);
					//RenderList.drawtext(game,1400,860,Game.AUTHOR+" "+Game.YEAR,RenderList.getrgb(255,255,200),Game.fonts[Resources.SMALLFONT].font,false);
					//RenderList.drawtext(game,1400,875,Game.MUSIC,RenderList.getrgb(255,255,200),Game.fonts[Resources.SMALLFONT].font,false);
				}
			}
			//Research.Enhance();//21oct2021
			handleboard(game);
			//Research.Revert();//21oct2021
			//Gui.statustext = "Raining:"+Map.raining + " SpellCast:"+Game.spellcast;
			//start----------//8oct2021
			Game.campaignpcclick = false;//8oct2021
			int omode = Game.campaignmode;
			if(Game.campaignmode>0 && Game.campaignmode<Game.MaxArmies+1)//8oct2021
			{
				for(int g=0;g<Game.gui.Length;g++)
				{
					if(Game.gui[g].link==("gamebattle"))
					{
						Game.gui[g].hidden = 1;
					}
				}
				if(Game.campaignmode!=Game.PlayerIndex+1)
				{
					//count our provinces....
					Game.THINKING = 1;
					if(CampaignMap.EmptyProvincesExist())
					{
						Game.campaignpcclick = true;
						Game.campaignpcx = Functions.rand(0,10000) % Game.RESOLUTIONX;
						Game.campaignpcy = Functions.rand(0,10000) % Game.RESOLUTIONY;
					}
					else
					{
						if(CampaignMap.MyProvinceCount(Game.campaignmode-1)>0)
						{
							Game.campaignpcclick = true;
							Game.campaignpcx = Functions.rand(0,10000) % Game.RESOLUTIONX;
							Game.campaignpcy = Functions.rand(0,10000) % Game.RESOLUTIONY;
						}
						else
						{
							Game.campaignmode++;
							Game.campaignmode%=(Game.MaxArmies + 1);
							if(Game.campaignmode==Game.MaxArmies)
							{
								CampaignMap.EndTurn();
							}
							if(Game.campaignmode==0){Game.campaignmode++;}
						}
					}
					if(Game.currentTimeMillis()>Game.toolongthinking)
					{
						Game.campaignmode++;
						Game.campaignmode%=(Game.MaxArmies + 1);
						if(Game.campaignmode==Game.MaxArmies)
						{
							CampaignMap.EndTurn();
						}
						if(Game.campaignmode==0){Game.campaignmode++;}
					}
				}
				else
				{
					Game.toolongthinking = Game.currentTimeMillis() + 4000;
					Game.THINKING = 0;
				}
			}
			if(omode!=Game.campaignmode || Game.gamestate!=Game.CAMPAIGNSTATE)
			{
				Game.toolongthinking = Game.currentTimeMillis() + 4000;
			}
			//end--------//8oct2021
			guimenus(game);
			if(Game.gamestate==Game.CAT_GAMESTATE_GAME)
			{
				if(Game.RESOLVE<=0)//7oct2021 weather stuff.....
				{
					if(Map.weather==Map.WEATHERCOLD)
					{
						RenderList.drawtext(game,Game.RESOLUTIONX - 200,Game.RESOLUTIONY - 50,"Very Cold Weather",RenderList.getrgb(24,24,32),Game.fonts[Resources.FONT].font,true);
					}
					if(Map.weather==Map.WEATHERHOT)
					{
						RenderList.drawtext(game,Game.RESOLUTIONX - 200,Game.RESOLUTIONY - 50,"Very Hot Weather",RenderList.getrgb(24,24,32),Game.fonts[Resources.FONT].font,true);
					}
				}
			}
			if(Replay.PLAYBACK)//2apr2021
			{
				if(Replay.CHECKSUMBROKEN!=-1)
				{
					RenderList.drawtext(game,30,870,"err:"+Replay.CHECKSUMBROKEN,RenderList.getrgb(255,255,200),Game.fonts[Resources.SMALLFONT].font,false);
				}
				
			}
			if(Game.gamestate==Game.CAT_GAMESTATE_DEBRIEF || Game.gamestate==Game.CAT_GAMESTATE_DEBRIEF2)
			{
				drawdebriefbk(game);
			}
			//if(Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.EDITOR==false)//18apr2021
			if(Game.oldgamestate==Game.CAT_GAMESTATE_GAME && Game.EDITOR==false)//18apr2021
			{
				triggertime = utimer.ElapsedMilliseconds;
				if(!Game.togglepause)//22mar2021
				{
					Trigger.updateall(game);
				}
				if(Game.onscreen==false && Game.GAMEENDSTATE==0)
				{
				//	RenderList.drawtext(game,Game.RESOLUTIONX/2,3*Game.RESOLUTIONY/4,"Double Click To Find Units",RenderList.getrgb(200,200,180),Game.fonts[Resources.FONT].font,true);
				}
				if(Game.missions!=null) //&& Game.skirmish==false)
				{
					if(Game.missionid>=0 && Game.missionid<Game.missions.Length)
					{
						if(Game.missions[Game.missionid].objectives!=null)
						{
							int j = 0;
							for(int i=0;i<Game.missions[Game.missionid].objectives.Length;i++)
							{
								if(Game.missions[Game.missionid].objectives[i]!=null)
								{
									RenderList.drawtext(game,40,40 + (j * Game.fonts[Resources.SMALLFONT].ptsize * 2),Game.missions[Game.missionid].objectives[i],RenderList.getrgb(200,200,180),Game.fonts[Resources.SMALLFONT].font,false);
									j++;
								}
							}
							if(Game.missions[Game.missionid].showkills>0)
							{
								//RenderList.drawtext(game,40,40 + (j * Game.fonts[Resources.SMALLFONT].ptsize * 2),"Kills:"+Game.killcount,RenderList.getrgb(200,200,180),Game.fonts[Resources.SMALLFONT].font,false);//13mar2021
								RenderList.drawtext(game,40,40 + (j * Game.fonts[Resources.SMALLFONT].ptsize * 2),Translation.TranslateWord("Kills",false)+":"+Translation.TranslateNumber(Game.killcount),RenderList.getrgb(200,200,180),Game.fonts[Resources.SMALLFONT].font,false);//13mar2021
							}
						}
					}
				}
				triggertime = Math.Abs(utimer.ElapsedMilliseconds - triggertime);
			}
			if(Game.GAMEENDSTATE!=0 && Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.EDITOR==false)
			{
				Game.gameovertime--;
				Game.togglepause=false;//22mar2021
				if(Game.GAMEENDSTATE==Game.GAMEENDSTATE_VICTORY)
				{
					if(Game.victorymessage)
					{
						//RenderList.drawtext(game,Game.RESOLUTIONX/2,Game.RESOLUTIONY/2,"Victory",RenderList.getrgb(200,200,180),Game.fonts[Resources.FONT].font,true);
					}
					else
					{
						Game.gameovertime=1;
					}
				}
				else
				{
					//RenderList.drawtext(game,Game.RESOLUTIONX/2,Game.RESOLUTIONY/2,"Defeat",RenderList.getrgb(200,200,180),Game.fonts[Resources.FONT].font,true);	
				}			
				if(Game.gameovertime==1)
				{
					Blood.clearall(game);//29oct2020
					Bullet.clearall(game);//29oct2020
					Gibbet.clearall(game);//2apr2021
					Map.savepath(Game.missionid);
					//start-------------//12mar2021
					//if(Game.missionid>=0 && Game.missionid < Game.missions.Length && Game.missions!=null && Game.GAMEENDSTATE==Game.GAMEENDSTATE_VICTORY && Game.skirmish==false && Game.playingtutorial==false)//4apr2021
					if(Game.missionid>=0 && Game.missionid < Game.missions.Length && Game.missions!=null && Game.GAMEENDSTATE==Game.GAMEENDSTATE_VICTORY && Game.skirmish==false && Game.playingtutorial==false && Replay.PLAYBACK==false)//4apr2021
					{
						LocalStorage.setitem("mission"+Game.missionid,"Complete");
						Unit.SaveScore(game,Game.missionid);//17sep2021
					}
					//end---------------//12mar2021
					if(Game.GAMEENDSTATE==Game.GAMEENDSTATE_DEFEAT || Game.nextmissionid==-1 || Game.skirmish==true || Game.playingtutorial==true)
					{
						Game.gamestate = Game.CAT_GAMESTATE_MENU;
						Game.skirmish = false;
						if(Game.GAMEENDSTATE==Game.GAMEENDSTATE_DEFEAT && Game.failedmissionid!=-1)
						{
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							if(Game.missionid>=0 && Game.missionid < Game.missions.Length && Game.missions!=null && Config.DODEBRIEF==true)
							{
								if(Game.missions[Game.missionid].debrief==1)
								{
								//	Game.gamestate = Game.CAT_GAMESTATE_DEBRIEF;
									Game.gamestate = Game.CAT_GAMESTATE_MENU;
									//start-------------//28Feb2021
									Game.PLAYERFACTION = Game.missions[Game.missionid].playerfaction;
									Game.SKIRMISHENEMYFACTION = Game.missions[Game.missionid].skirmishenemyfaction;
									//end---------------//28Feb2021
								}
							}
							Game.map = new Map();
							Program.setupmission(game,Game.failedmissionid,0);
						}
						else
						{
							//Game.gamestate = Game.CAT_GAMESTATE_DEBRIEF2;
							Game.gamestate = Game.CAT_GAMESTATE_MENU;
							cleardeaths(game);
						}
					}
					else
					{
						Game.PLAYERFACTION = Unit.HUMAN;
						Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
						Game.gamestate = Game.CAT_GAMESTATE_GAME;
						if(Game.missionid>=0 && Game.missionid < Game.missions.Length && Game.missions!=null && Config.DODEBRIEF==true)
						{
							if(Game.missions[Game.missionid].debrief==1)
							{
								//Game.gamestate = Game.CAT_GAMESTATE_DEBRIEF;
								Game.gamestate = Game.CAT_GAMESTATE_MENU;
								//start-------------//28Feb2021
								Game.PLAYERFACTION = Game.missions[Game.missionid].playerfaction;
								Game.SKIRMISHENEMYFACTION = Game.missions[Game.missionid].skirmishenemyfaction;
								//end---------------//28Feb2021
							}
						}
						Game.map = new Map();
						Program.setupmission(game,Game.nextmissionid,0);
					}
				}
			}
			utimer.Reset();
			if(bmenutime > Config.maxbmenutime || Game.frame % 300 == 0)
			{
				Config.maxbmenutime = bmenutime;
			}
			if(umusictime > Config.maxumusictime || Game.frame % 300 == 0)
			{
				Config.maxumusictime = umusictime;
			}
			if(mapupdatepostime > Config.maxmapupdatepostime || Game.frame % 300 == 0)
			{
				Config.maxmapupdatepostime = mapupdatepostime;
			}
			if(mapcorrecttime > Config.maxmapcorrecttime || Game.frame % 300 == 0)
			{
				Config.maxmapcorrecttime = mapcorrecttime;
			}
			if(unitupdatetime > Config.maxunitupdatetime || Game.frame % 300 == 0)
			{
				Config.maxunitupdatetime = unitupdatetime;
			}
			if(bullettime > Config.maxbullettime || Game.frame % 300 == 0)
			{
				Config.maxbullettime = bullettime;
			}
			if(bloodtime > Config.maxbloodtime || Game.frame % 300 == 0)
			{
				Config.maxbloodtime = bloodtime;
			}
			if(selecttime > Config.maxselecttime || Game.frame % 300 == 0)
			{
				Config.maxselecttime = selecttime;
			}
			if(triggertime > Config.maxtriggertime || Game.frame % 300 == 0)
			{
				Config.maxtriggertime = triggertime;
			}
			if(drawtime > Config.maxdrawtime || Game.frame % 300 == 0)
			{
				Config.maxdrawtime = drawtime;
			}
			Game.drawtoast();
		}

///////////////////Method Definition///////////////
static void getsavedcampaign(Game game)
	{
		String playerarmy = LocalStorage.getitem("PlayerArmy");
		int playerindex = 1;
		try
		{
			//playerindex = Integer.decode(LocalStorage.getitem("PlayerIndex"));
			Int32.TryParse(LocalStorage.getitem("PlayerIndex"),out playerindex);
		}
		catch(Exception e)
		{
			//do nothing.....
			Game.WriteDebug("Error:"+e.Message);
		}
		if(playerarmy!=(Game.PlayerArmy))
		{
			if(playerindex!=Game.PlayerIndex)
			{
				////Resources.//LoadNewArmy(Game.FriendArmy, playerarmy);
				Game.OldFriendArmy = Game.FriendArmy;
				Game.PlayerIndex = playerindex;
				Game.FriendIndex = playerindex;
				Game.PlayerArmy = playerarmy;
				Game.FriendArmy = playerarmy;
				for(int g=0;g<Game.gui.Length;g++)
				{
					if(Game.gui[g].link==("friend"))
					{
						Game.gui[g].index = Game.FriendIndex;
					}
				}
				if(Game.EnemyIndex==playerindex)
				{
					Game.EnemyIndex++;
					Game.EnemyIndex%=Game.MaxArmies;
					Game.OldEnemyArmy = Game.EnemyArmy;
					switch(Game.EnemyIndex)
					{
					case 0:
						Game.EnemyArmy = "Red";
						break;
					case 1:
						Game.EnemyArmy = "Blue";
						break;
					case 2: 
						Game.EnemyArmy = "Skeleton";
						break;
					case 3:
						Game.EnemyArmy = "Realm";
						break;
					case 4:
						Game.EnemyArmy = "Evil";
						break;
					case 5:
						Game.EnemyArmy = "Fiend";
						break;
					}
					////Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
				}
				for(int t=0;t<Game.templates.Length;t++)
				{
					if(Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
					{
						Game.templates[t].faction = 6;
					}
					if(Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
					{
						Game.templates[t].faction = 5;
					}
				}
				for(int g=0;g<Game.gui.Length;g++)
				{
					if(Game.gui[g].link==("enemy"))
					{
						Game.gui[g].index = Game.EnemyIndex;
					}
				}
			}
		}
	}
	///////////////////Method Definition///////////////
		static void updateaudio(Game game)
		{
			//manages the audio playing
			for(int i=0;i<Game.audios.Length;i++)
			{
				if(Game.audioon)
				{
					if(Game.audios[i].ismusic)
					{
						if(Map.musicplaying!=-1)
						{
							//Audios.playmusic(Game.audios[Map.musictrack[Map.musicplaying]],1,true);
							break;
						}
					}
				}
				else
				{
					Audios.pauseaudio(Game.audios[i]);
				}
			}
		}

///////////////////Method Definition///////////////
		static void toggleaudio(Game game,int x,int y)
		{
			//manages toggling audio on or off
			if(Game.mlclick)
			{
				if(Game.mx>=x - 40 && Game.mx<=x + 40)
				{
					if(Game.my>=y - 25 && Game.my<=y + 25)
					{
						Game.mlclick = false;
						Game.mldown = false;
						Game.audioon = !Game.audioon;
						updateaudio(game);
						//Audios.playsound(Game.audios[Resources.CAT_AUDIO_CLICK],1f);
					}
				}
			}
		}

///////////////////Method Definition///////////////
		static void getmaxmission(Game game)
		{
			//get the value of the max mission in terms of locked campaign maps
			//currently we ignore this mostly.
			string folder = "";
			try
			{
				folder = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)+"/"+Game.NETTITLE;
				if(!Directory.Exists(folder))
				{
					Directory.CreateDirectory(folder);
				}
				string[] savegame = System.IO.File.ReadAllLines(folder+"/"+"savegame.txt");
				if(savegame.Length>0)
				{
					Int32.TryParse(savegame[0],out Game.maxmission);
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
			}
			if(Config.KOG2) //12mar2021
			{
				Game.maxmission = 36; 
			}
			if(Game.maxmission > Game.overridemaxmission)//13sep2021
			{
				Game.maxmission = Game.overridemaxmission;//13sep2021
			}
		}

///////////////////Method Definition///////////////
		static void game(IntPtr window,IntPtr renderer)
		{
			//contains core game loop
			//perform initialisation of loading resource calls
			//and then enters core game loop
			Game game = new Game(renderer);
			Game.takepicture = false;
			Game.window = window;
			Game.screen = SDL.SDL_GetWindowSurface(window);
			Stopwatch gametimer = new Stopwatch();
			SDL.SDL_Event e;
			SDL.SDL_MouseMotionEvent m;
			m.x = 0;
			m.y = 0;
			bool quit = false;
			Map.menumusic = -1;
			Map.menumusicplaying = -1;
			resourceload(game);
			getsavedcampaign(game);
			getmaxmission(game);
			Network.reporterror(true);//15mar2021
			updateaudio(game);
			gametimer.Start();
			if(!Config.FREEDEMO)//26apr2021
			{
				Config.freedemo = 0;
			}
			if(Config.freedemo>0)//26apr2021
			{
				Game.VERSIONSTR = "0001";
			}
			Config.FASTFRAMECHECK++;//14sep2021
			if(Config.FASTFRAMECHECK>1)//14sep2021
			{
				Config.FASTFRAMECHECK = 2;//14sep2021
			}
			if(Config.FASTFRAMECHECK<1)//14sep2021
			{
				Config.FASTFRAMECHECK = 1;//14sep2021
			}
			switch(Config.FASTFRAMECHECK)//14sep2021
			{
				case 1:
				Unit.ORDERTIME = 300;
				break;
				case 2:
				Unit.ORDERTIME = 100;
				break;
			}
			//26mar2021 commented out the if statement and surrounds//calling network command each time now....
			//string playedonce = LocalStorage.getitem("start"); //19mar2021 
			//if(playedonce!="1") //19mar2021 (and inside)
			//{
				//Network.url = "https://www.mattiesgames.com/metrics/launch.php?game=grumthorr";//15mar2021//30mar2021
				Network.url = "https://www.mattiesgames.com/metrics/launch.php?game=grumthorr&uid="+Config.uid+"&version="+Game.VERSIONSTR;//30mar2021//14apr2021 added version string....
				Network.httpget(Network.url);//15mar2021
			//	LocalStorage.setitem("start","1");
			//	LocalStorage.finalise();
			//}
			resetgame(game);
			long maxutime = 0;
			long maxrtime = 0;
			//while(!quit)//15mar2021
			//start---------------//26mar2021
			if(Game.restartgamestate!=-1)
			{
				Game.gamestate = Game.restartgamestate;
				if(Game.gamestate!=Game.CAT_GAMESTATE_GAME)//7apr2021
				{
					Game.map = new Map();//7apr2021
					Program.setupbackdrop(game);//7apr2021
					Game.demomode = true;//7apr2021
				}					
			}
			//end-----------------//26mar2021
			//start----------//5apr2021
			if(Game.EDITOR)
			{
				try
				{
					Network.url = "https://www.mattiesgames.com/metrics/metric.php?game=kog2mission&event=editor&value=1&uid="+Config.uid;//30mar2021
					Network.httpget(Network.url);
				}
				catch(Exception ffe)
				{
					string message = ffe.Message;
				}
			}
			//end-----------//5apr2021
			bool usedelta = false;//18sep2021
			if(Config.USEDELTATIME>0)//18sep2021
			{
				usedelta = true;//18sep2021
			}
			Config.delta = 100;//18sep2021
			while(quit==false || RenderList.threadrunning==true)//15mar2021
			{
				//start--------//18sep2021
				if(Config.UNLOCKFRAMERATE>0)
				{
					Config.FRAMETIME = 1000 / (uint)Config.UNLOCKFRAMERATE;
				}
				if(usedelta && Game.FRAMERATE>0)// && deltafps>0)
				{
					if(Config.UNLOCKFRAMERATE>0)
					{
						Config.delta = (100 * Config.UNLOCKFRAMERATE) / Game.FRAMERATE;
						if(Config.delta < 100)
						{
							Config.delta = 100;
						}
						if(NetworkUDP.Ready() && Game.gamestate == Game.CAT_GAMESTATE_GAME)//12oct2021
						{
							if(NetworkUDP.otherpcspeed < Game.FRAMERATE && NetworkUDP.otherpcspeed>0)
							{
								//other PC is slower than our framerate.....
								//and is slower than the target frame rate....
								//this is ALMOST NEVER going to be the case for the mobile devices compared to a pc....
								
								//put a delay in to slow us down.....
								//but don't slow down to their framerate, stay above it.....
								//
								uint targetframetime = (uint)(1000 / NetworkUDP.otherpcspeed);
								uint ourframetime = (uint)(1000 / Game.FRAMERATE);
								
								//get the average......a weighted average......
								uint avgtimebetweentwo = (targetframetime * 3 + ourframetime * 2)/5;
								//and insert a delay.....
								if(avgtimebetweentwo > ourframetime)
								{
									Game.throttleframerate = 1000 / (int)avgtimebetweentwo;
								}
								//Game.newtoast("Other PC Speed:"+NetworkUDP.otherpcspeed);
							}
						}
						if(Config.delta > 500)
						{
							Config.delta = 500;
						}
					}
					else
					{
						Config.delta = 100;
					}
				}
				else
				{
					Config.delta = 100;
				}
				//end-----//18sep2021
				if(Game.EDITOR)//22mar2021
				{
					Game.togglepause = false;
				}
				//start-------------//28Feb2021
				StreamResources.streamloadhelper(game); 
				//if(Game.gamestate==Game.CAT_GAMESTATE_GAME) //2apr2021
				if(Game.gamestate==Game.CAT_GAMESTATE_GAME || Game.gamestate==Game.CAT_GAMESTATE_REPLAY)//2apr2021
				{
					StreamResources.TOLERANCE = StreamResources.LONGTOLERANCE;
				}
				else
				{
					StreamResources.TOLERANCE = StreamResources.SHORTTOLERANCE;
					Game.togglepause = false;//22mar2021
				}
				//end---------------//28Feb2021
				//start------------//29may2021
				if(Game.oldgamestate==Game.CAT_GAMESTATE_GAME || Game.oldgamestate==Game.CAT_GAMESTATE_REPLAY)//29may2021
				{
					if(Config.THREADEDPATHING)//29may2021
					{
						MapThread.init();//29may2021
					}
				}
				//end--------------//29may2021
				if(!Game.togglepause)//12apr2021
				{
					Game.frame++;
				}
				Game.getmouse();
				Game.formation = 0;//2apr2021
				if(Game.mldown) //14apr2021
				{
					Game.HORIZONTALFORMATION = 0;
					Game.VERTICALFORMATION = 0;
				}
				int k = -1;
				while(SDL.SDL_PollEvent(out e) != 0)
				{
					switch(e.type)
					{
						case SDL.SDL_EventType.SDL_QUIT:
							quit = true;
							break;
						case SDL.SDL_EventType.SDL_KEYDOWN:
							switch(e.key.keysym.sym)
							{
								case SDL.SDL_Keycode.SDLK_BACKSPACE:
								if(Game.EDITMODE==Game.EDITMODE_ENTERTEXT && Game.EDITOR==true)
								{
									if(Game.edittriggerstring.Length>0 && (Game.frame % 20 < 10))
									{
										Game.edittriggerstring = Game.edittriggerstring.Substring(0,Game.edittriggerstring.Length-1);
									}
								}
								break;
								//start--------------------//2apr2021
								case SDL.SDL_Keycode.SDLK_ESCAPE:
									if(Replay.PLAYBACK && Replay.FRAME>0)
									{
										Replay.FRAME = Game.replay[0].mx.Length + 100; //cheap and nasty way of getting out of it.....
									}
								break;
								//end----------------------//2apr2021
								case SDL.SDL_Keycode.SDLK_LSHIFT:
									Game.editshiftheld = true;
								break;
								case SDL.SDL_Keycode.SDLK_RSHIFT:
									Game.editshiftheld = true;
								break;
								case SDL.SDL_Keycode.SDLK_LCTRL:
									Game.leftcontrolkey = 1;
								break;
								case SDL.SDL_Keycode.SDLK_0:
									k = 0;
								break;
								case SDL.SDL_Keycode.SDLK_1:
									k = 1;
								break;
								case SDL.SDL_Keycode.SDLK_2:
									k = 2;
								break;
								case SDL.SDL_Keycode.SDLK_3:
									k = 3;
								break;
								case SDL.SDL_Keycode.SDLK_4:
									k = 4;
								break;
								case SDL.SDL_Keycode.SDLK_5:
									k = 5;
								break;
								case SDL.SDL_Keycode.SDLK_6:
									k = 6;
								break;
								case SDL.SDL_Keycode.SDLK_7:
									k = 7;
								break;
								case SDL.SDL_Keycode.SDLK_8:
									k = 8;
								break;
								case SDL.SDL_Keycode.SDLK_9:
									k = 9;
								break;
							}
							if(k!=-1 && Game.leftcontrolkey>0)
							{
								Game.numberkeys[k]=1;
							}
						break;
						case SDL.SDL_EventType.SDL_KEYUP:
							if(e.key.keysym.sym==SDL.SDL_Keycode.SDLK_PRINTSCREEN)
							{
								Game.takepicture = true;
							}
							if(e.key.keysym.sym==SDL.SDL_Keycode.SDLK_TAB)
							{
								if(RenderList.RENDERMODE==RenderList.RENDERMODE_POOL)
								{
									RenderList.RENDERMODE=RenderList.RENDERMODE_NONPOOL;
								}
								else
								{
									RenderList.RENDERMODE=RenderList.RENDERMODE_POOL;
								}
							}
							if(e.key.keysym.sym==SDL.SDL_Keycode.SDLK_LSHIFT)
							{
								Game.editshiftheld = false;
							}
							if(e.key.keysym.sym==SDL.SDL_Keycode.SDLK_RSHIFT)
							{
								Game.editshiftheld = false;
							}
							if(e.key.keysym.sym==SDL.SDL_Keycode.SDLK_BACKQUOTE)
							{
								//Config.DEBUG = !Config.DEBUG;
							}
							if(Game.EDITOR)
							{
								if(Game.EDITMODE!=Game.EDITMODE_ENTERTEXT)
								{
									switch(e.key.keysym.sym)
									{
										case SDL.SDL_Keycode.SDLK_b:
										Game.backupkeypressed++;
										break;
										case SDL.SDL_Keycode.SDLK_h:
										if(Config.USEHEIGHTS>0)
										{
											Game.EDITMODE = Game.EDITMODE_HEIGHT;
										}
										break;
										case SDL.SDL_Keycode.SDLK_w:
										Game.EDITMODE = Game.EDITMODE_WALL;
										break;
										case SDL.SDL_Keycode.SDLK_r:
										Game.EDITMODE = Game.EDITMODE_ROCK;
										break;
										case SDL.SDL_Keycode.SDLK_t:
										Game.EDITMODE = Game.EDITMODE_TREE;
										break;
										case SDL.SDL_Keycode.SDLK_u:
										Game.EDITMODE = Game.EDITMODE_UNIT;
										break;
										case SDL.SDL_Keycode.SDLK_x:
										Game.EDITMODE = Game.EDITMODE_TRIGGER;
										break;
										case SDL.SDL_Keycode.SDLK_o:
										Map.OPENMAP = true;
										Map.savemap(game);
										Map.OPENMAP = false;
										break;
										case SDL.SDL_Keycode.SDLK_c:
										Map.opencampaign(game);
										break;
									}
								}
								else
								{
									switch(e.key.keysym.sym)
									{
										case SDL.SDL_Keycode.SDLK_RETURN:
										Game.edittriggerstring+="|";
										break;
										case SDL.SDL_Keycode.SDLK_ESCAPE:
										Game.EDITMODE = Game.EDITMODE_TRIGGER;
										break;
										case SDL.SDL_Keycode.SDLK_BACKSPACE:
										if(Game.edittriggerstring.Length>0)
										{
											Game.edittriggerstring = Game.edittriggerstring.Substring(0,Game.edittriggerstring.Length-1);
										}
										break;
									}
									if(e.key.keysym.sym!= SDL.SDL_Keycode.SDLK_RETURN && e.key.keysym.sym!= SDL.SDL_Keycode.SDLK_BACKSPACE)
									{
										try
										{
											string mychar = (string)SDL.SDL_GetKeyName(e.key.keysym.sym);
											if(mychar.Length==1)
											{
												mychar = mychar.ToLower();
												if(Game.editshiftheld)
												{
													mychar = mychar.ToUpper();
													if(mychar=="1")
													{
														mychar = "!";
													}
													if(mychar=="2")
													{
														mychar = "@";
													}
													if(mychar=="3")
													{
														mychar = "#";
													}
													if(mychar=="4")
													{
														mychar = "$";
													}
													if(mychar=="5")
													{
														mychar = "%";
													}
													if(mychar=="6")
													{
														mychar = "^";
													}
													if(mychar=="7")
													{
														mychar = "&";
													}
													if(mychar=="8")
													{
														mychar = "*";
													}
													if(mychar=="9")
													{
														mychar = "(";
													}
													if(mychar=="0")
													{
														mychar = ")";
													}
													if(mychar=="-")
													{
														mychar = "_";
													}
													if(mychar=="=")
													{
														mychar = "+";
													}
													if(mychar=="\\")
													{
														mychar = "|";
													}
													if(mychar=="/")
													{
														mychar = "?";
													}
													if(mychar==";")
													{
														mychar = ":";
													}
													if(mychar=="[")
													{
														mychar = "{";
													}
													if(mychar=="]")
													{
														mychar = "}";	
													}
													if(mychar==",")
													{
														mychar = "<";
													}
													if(mychar==".")
													{
														mychar = ">";
													}
												}
												Game.edittriggerstring+=mychar;	
											}
											if(mychar.ToUpper()=="SPACE")
											{
												Game.edittriggerstring+=" ";
											}
										}
										catch(Exception f)
										{
											string message = f.Message;
										}
									}
								}
							}
							else
							{
								if(!Replay.PLAYBACK)//2apr2021
								{
									switch(e.key.keysym.sym)
									{
										case SDL.SDL_Keycode.SDLK_LCTRL:
										Game.leftcontrolkey = 0;
										break;
										//start-----------------//22mar2021
										case SDL.SDL_Keycode.SDLK_PAUSE:
											if(Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.EDITOR==false)
											{
												Game.togglepause = !Game.togglepause;
											}
										break;
										//end-------------------//22mar2021
										case SDL.SDL_Keycode.SDLK_e:
											Game.editkeypressed++;
										break;
										/* //9mar2021
										case SDL.SDL_Keycode.SDLK_r:
											Game.recordkeypressed++;
											if(Game.recordkeypressed>9)
											{
												//Config.RECORD = !Config.RECORD;
												Game.recordkeypressed = 0;
											}
										break;
										*/ //9mar2021
										//start-------------//9mar2021
										case SDL.SDL_Keycode.SDLK_o: //OPEN FORMATION
											Unit.Formation(game,Gui.ACTION_OPEN);
											Game.formation = Gui.ACTION_OPEN;//2apr2021
										break;
										case SDL.SDL_Keycode.SDLK_c: //CLOSE FORMATION
											Unit.Formation(game,Gui.ACTION_CLOSE);
											Game.formation = Gui.ACTION_CLOSE;//2apr2021
										break;
										case SDL.SDL_Keycode.SDLK_r: // RALLY FORMATION
											Unit.Formation(game,Gui.ACTION_RALLY);
											Game.formation = Gui.ACTION_RALLY;//2apr2021
										break;
										case SDL.SDL_Keycode.SDLK_v: // VERTICAL LINE FORMATION
											Unit.Formation(game,Gui.ACTION_LINEV);
											Game.formation = Gui.ACTION_LINEV;//2apr2021
										break;
										case SDL.SDL_Keycode.SDLK_h: // HORIZONTAL LINE FORMATION
											Unit.Formation(game,Gui.ACTION_LINEH);
											Game.formation = Gui.ACTION_LINEH;//2apr2021
										break;
										case SDL.SDL_Keycode.SDLK_d: // DEFEND FORMATION
											Unit.Formation(game,Gui.ACTION_DEFEND);
											Game.formation = Gui.ACTION_DEFEND;//2apr2021
										break;
										case SDL.SDL_Keycode.SDLK_a: // ENGAGE FORMATION
											Unit.Formation(game,Gui.ACTION_ENGAGE);
											Game.formation = Gui.ACTION_ENGAGE;//2apr2021
										break;
										//end---------------//9mar2021
										case SDL.SDL_Keycode.SDLK_0:
										k = 0;
										break;
										case SDL.SDL_Keycode.SDLK_1:
										k = 1;
										break;
										case SDL.SDL_Keycode.SDLK_2:
										k = 2;
										break;
										case SDL.SDL_Keycode.SDLK_3:
										k = 3;
										break;
										case SDL.SDL_Keycode.SDLK_4:
										k = 4;
										break;
										case SDL.SDL_Keycode.SDLK_5:
										k = 5;
										break;
										case SDL.SDL_Keycode.SDLK_6:
										k = 6;
										break;
										case SDL.SDL_Keycode.SDLK_7:
										k = 7;
										break;
										case SDL.SDL_Keycode.SDLK_8:
										k = 8;
										break;
										case SDL.SDL_Keycode.SDLK_9:
										k = 9;
										break;
									}
									if(k!=-1 && Game.leftcontrolkey==0)
									{
										Game.numberkeys[k]++;
										if(Game.frame - Game.numberkeysframe[k]<=15)
										{
											Game.numberkeys[k]++;
										}
										Game.numberkeysframe[k] = Game.frame;
									}
								}//2apr2021
							}
							break;
						case SDL.SDL_EventType.SDL_MOUSEWHEEL:
							Game.mwheel = e.wheel.y;
						break;
					}
				}
				long utime = gametimer.ElapsedMilliseconds;
				Game.oldgamestate = Game.gamestate;
				if(Config.ALLOWREPLAY )//2apr2021
				{
					if(Replay.PLAYBACK)
					{
						//playback begins on frame 2
						Replay.PlayReplay(game,Replay.FRAME); //sets mouse and other values....
						Replay.FRAME++;
					}
					if(Replay.RECORD)
					{
						//recording begins on frame 2
						Replay.RecordReplay(game); //mouse and running speeds etc will be set by now....as well as seeds....
					}
				}
				if(RenderList.transitionmode<RenderList.HALFTRANSIT)//18apr2021
				{
					int cmode = Game.campaignmode;
					if(cmode>0)
					{
						Research.Enhance();//21oct2021
					}
					update(game);
					if(cmode>0)
					{
						Research.Revert();//21oct2021
						Research.UpdateResearch();//21oct2021 outside of main update loop......
					}
				}
				//start-----//18apr2021
				if(RenderList.transitionmode==RenderList.HALFTRANSIT)
				{
					//Functions.saveseed(Functions.seed);
					//if((Functions.Rand(0,100) % 10)<7)
					//{
					//	Gui.ALTMODE = !Gui.ALTMODE; 
					//}
					//Functions.restoreseed();
				}
				//end-------//18apr2021
				if(Config.freedemo>0)//26apr2021
				{
					Config.freedemo--;
					if(Config.freedemo==60*10)
					{
						Game.gamestate = 10000 + 888;
					}
					if(Config.freedemo<=1)
					{
						quit = true;
						Game.restart = false;
					}
					RenderList.drawtext(game,800,850,"Demo Time Remaining:"+Functions.ClockTime(Config.freedemo / 60),RenderList.getrgb(220,220,180),Game.fonts[Resources.FONT].font,true);
				}
			
				Game.newgamestate = Game.gamestate;
				//start-------------//12mar2021
				if(Game.gamestate!=Game.oldgamestate)
				{
					Game.togglepause = false;//19oct2021
					//if(RenderList.transitionmode<0 && Game.FULLSCREEN>0){RenderList.transitionmode = RenderList.STARTTRANSITION;}//18apr2021//19apr2021
					if(RenderList.transitionmode<0){RenderList.transitionmode = RenderList.STARTTRANSITION;}//18apr2021//19apr2021
					if(Game.EDITED>0) //7apr2021
					{//7apr2021
						Game.restart = true;//7apr2021
						Game.EDITED = -1;
					}//7apr2021
					if(Game.chosenmissionindex!=-1)
					{
						Game.previousmissionindex = Game.chosenmissionindex;
					}
					Game.chosenmissionindex = 0;
					Unit.MAXINDEX = 0;//26mar2021
					Bullet.MAXINDEX = 0;//27mar2021
					//moved elsewhere....//18apr2021//maybenot?
					//Functions.saveseed(Functions.seed);//2apr2021
					//if((Functions.Rand(0,100) % 10)<7) //24mar2021
					//{
					//	Gui.ALTMODE = !Gui.ALTMODE; //24mar2021
					//}
					//Functions.restoreseed();//2apr2021
					//start--------------//2apr2021
					if(Config.ALLOWREPLAY)
					{
						if(Game.gamestate==Game.CAT_GAMESTATE_GAME && Replay.PLAYBACK==false)
						{
							//this occurs on frame 1
							Replay.Init(game);
							Replay.StartRecordReplay(game,0);
						}
						if(Game.oldgamestate==Game.CAT_GAMESTATE_GAME)
						{
							Replay.EndRecord(game);
						}
						if(Game.gamestate==Game.CAT_GAMESTATE_REPLAY)
						{
							//this occurs on frame 1
							Replay.PrepareToPlay(game);
							//Trigger.updateall(game); //to keep in line with the standard path taken through the game code.//18apr2021 commented out....
						}
					}
					else
					{
						Replay.RECORD = false;
						Replay.PLAYBACK = false;
					}
					//end----------------//2apr2021
				}
				utime-=gametimer.ElapsedMilliseconds;
				long rtime = gametimer.ElapsedMilliseconds;
				long sumr = 0;
				long sumu = 0;
				for(int i=0;i<Config.totrtime.Length;i++)
				{
					sumr+=Config.totrtime[i];
					sumu+=Config.totutime[i];
				}
				Config.sumu = sumu;
				Config.sumr = sumr;
				Config.RUNNINGSPEED = ((sumu + sumr)*100)/10000;
				Config.runningspeed = Config.RUNNINGSPEED;//redundancy//2apr2021
				if(Config.DEBUG)
				{
					if(Config.NOMETRICS)
					{
						//RenderList.drawtext(game,800,25,"NOMETRICS",RenderList.getrgb(50,100,255),Game.fonts[Resources.FONT].font,true);
					}
					RenderList.drawtext(game,800,50,"Utime:"+Math.Abs(maxutime)+" Rtime:"+Math.Abs(maxrtime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					if(sumu+sumr > 9000)
					{
						RenderList.drawtext(game,800,100,"WARNING:"+((sumu+sumr)*100/10000)+"%",RenderList.getrgb(255,32,32),Game.fonts[Resources.FONT].font,true);
					}
					else
					{
						RenderList.drawtext(game,800,100,((sumu+sumr)*100/10000)+"%",RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					}
					if(RenderList.RENDERMODE==RenderList.RENDERMODE_POOL)
					{
						RenderList.drawtext(game,800,75,"POOL Tot U:"+Math.Abs(sumu)+" Tot R:"+Math.Abs(sumr),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					}
					else
					{
						RenderList.drawtext(game,800,75,"NON POOL Tot U:"+Math.Abs(sumu)+" Tot R:"+Math.Abs(sumr),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					}
					//RenderList.drawtext(game,800,100,"bmenutime:"+Math.Abs(Config.maxbmenutime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,125,"bullettime:"+Math.Abs(Config.maxbullettime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					RenderList.drawtext(game,800,150,"drawtime:"+Math.Abs(Config.maxdrawtime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,175,"correcttime:"+Math.Abs(Config.maxmapcorrecttime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,200,"mappostime:"+Math.Abs(Config.maxmapupdatepostime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,225,"selecttime:"+Math.Abs(Config.maxselecttime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,250,"triggertime:"+Math.Abs(Config.maxtriggertime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,275,"unitupdatetime:"+Math.Abs(Config.maxunitupdatetime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,300,"musictime:"+Math.Abs(Config.maxumusictime),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,75,"animatetime:"+Math.Abs(Config.maxanimate),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,100,"updatetime:"+Math.Abs(Config.maxupdate),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,125,"attacktime:"+Math.Abs(Config.maxatt),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//this is where the optimisation can be found....
					//RenderList.drawtext(game,800,325,"walktime:"+Math.Abs(Config.maxwalk),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					RenderList.drawtext(game,800,350,"MAXINDEX:"+Unit.MAXINDEX,RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,400,"precalcused:"+Math.Abs(Config.precalcused),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,425,"seekpathused:"+Math.Abs(Config.seekpathused),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,450,"seekpathsuccess:"+Math.Abs(Config.seekpathsuccess),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,475,"seekpathfailed:"+Math.Abs(Config.seekpathfailed),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
					//RenderList.drawtext(game,800,500,"maperrors:"+Math.Abs(Config.maxmaperrors),RenderList.getrgb(180,180,180),Game.fonts[Resources.FONT].font,true);
				}
				//if(Game.transitionframe!=Game.TRANSITIONTIME)
				//{
					if(Game.restart)//13apr2021
					{
						RenderList.drawrect(game,0,0,Game.RESOLUTIONX,Game.RESOLUTIONY,RenderList.getrgb(1,1,1),0);
						RenderList.drawtext(game,Game.RESOLUTIONX/2,Game.RESOLUTIONY/2,Translation.TranslateWord("Please Wait",false),RenderList.getrgb(180,180,180),Game.fonts[Resources.LARGEFONT].font,true);
					}
					render(game,window);
				//}
				Game.mlclick = false;//19oct2021
				Game.mrclick = false;//19oct2021
				if(Game.takepicture || (Game.frame >1 && (Game.frame % 120)==0 && Config.RECORD==true && Config.totrtime[(Game.frame - 1) % 600]<20))
				{	
					if(Config.RECORD)
					{
						if(RenderList.recordframe>60*60)
						{
							Config.RECORD = false;
							Game.recordkeypressed = 0;
						}
					}
					bool taken = false;
					SDL.SDL_Rect rect = new SDL.SDL_Rect();
					rect.x = 0;
					rect.y = 0;
					rect.w = Game.SW;
					rect.h = Game.SH;
					IntPtr surface = SDL.SDL_CreateRGBSurfaceWithFormat(SDL.SDL_RLEACCEL,Game.SW,Game.SH,32,SDL.SDL_PIXELFORMAT_ARGB8888);		
					try
					{
						//WARNING - NOT SURE IF I'M DOING THIS QUITE CORRECTLY. FOR MEMORY SAFETY.
						unsafe
						{
							SDL.SDL_Surface * sur = (SDL.SDL_Surface *)surface;
							SDL.SDL_RenderReadPixels(Game.renderer,ref rect,SDL.SDL_PIXELFORMAT_ARGB8888,sur->pixels,sur->pitch);
							//free the * sur reference
						}
						taken = RenderList.CaptureThread(surface);
					}
					catch(Exception ggg)
					{
						string msg = ggg.Message;
					}
					if(!taken)
					{
						try
						{
							SDL.SDL_FreeSurface(surface);
						}
						catch(Exception ggg)
						{
							string msg = ggg.Message;
						}	
					}					
					Game.takepicture = false;
				}
				rtime-=gametimer.ElapsedMilliseconds;
				utime = Math.Abs(utime);
				rtime = Math.Abs(rtime);
				Config.totrtime[Game.frame % 600]=rtime;
				Config.totutime[Game.frame % 600]=utime;
				if(utime>maxutime || Game.frame % 300== 0)
				{
					maxutime = utime;
				}
				if(rtime > maxrtime || Game.frame % 300 == 0)
				{
					maxrtime = rtime;
				}
				if(Game.gamestate<0)
				{
					quit = true;
				}
				//while(gametimer.ElapsedMilliseconds<14)//26mar2021
				while(gametimer.ElapsedMilliseconds<Config.FRAMETIME-1 && gametimer.ElapsedMilliseconds>=0)//26mar2021
				{
					//if(Game.NODELAY){SDL.SDL_Delay(1);}//26mar2021
					SDL.SDL_Delay(Config.FRAMETIME - Convert.ToUInt32(gametimer.ElapsedMilliseconds));//26mar2021
				}
				Game.FRAMERATE = Convert.ToInt32(1000.0 / gametimer.ElapsedMilliseconds);
				gametimer.Reset();
				gametimer.Start();
				//26mar2021 uncommented this block out
				//if(Game.frame % (60*60)==0 && Game.frame > 0)//15mar2021//15sep2021
				if(Game.frame % (60*60)==0 && Game.frame > 0 && Game.togglepause==false)//15mar2021//15sep2021
				{//15mar2021
					//Network.url = "https://www.mattiesgames.com/metrics/timespent.php?game=grumthorr";//15mar2021//30mar2021
					Network.url = "https://www.mattiesgames.com/metrics/timespent.php?game=grumthorr&uid="+Config.uid;//30mar2021
					Network.httpget(Network.url);//15mar2021
				}//15mar2021
				//start--------------//13mar2021
				//if(Game.restart)//15mar2021
				if(Game.restart==true && RenderList.threadrunning==false)//15mar2021
				{
					//if(Game.gamestate!=Game.CAT_GAMESTATE_GAME)//7apr2021
					//{
						quit = true;
					//}
					//Game.restart = false; //13mar2021 - bugger.
				}
				//end----------------//13mar2021
			}
			MapThread.quit = true;//29may2021
			gametimer.Stop();
			Game.quit();
			//Network.url = "https://www.mattiesgames.com/metrics/metric.php?game="+Game.NETTITLE+"&event=maxmission&value="+Game.maxmission;//15mar2021
			//Network.httpget(Network.url);//15mar2021
			Game.restartgamestate = Game.gamestate; //26mar2021
			//start---------------//28mar2021
			if(Game.restart==false)
			{
				string langlang = LocalStorage.getitem("language");
				if(langlang=="")
				{
					langlang = "english";
					if(Config.autodetectlang!="")//30mar2021
					{
						langlang = Config.autodetectlang;
					}
				}
				int gtime = (Game.frame / (60*60));
				//Network.url = "https://www.mattiesgames.com/metrics/metric.php?game=grumthorr&event="+langlang+"&value="+gtime;//15mar2021//30mar2021
				Network.url = "https://www.mattiesgames.com/metrics/metric.php?game=grumthorr&event="+langlang+"&value="+gtime+"&uid="+Config.uid;//30mar2021
				Network.httpget(Network.url);
			}
			//end-----------------//28mar2021
		}
		
		/////////
		public static void handleboard(Game game)
		{
			if(Gui.firstunit==1)
			{
				Gui.firstunit++;
				if(NetworkUDP.isserver && Game.vsai<=0)
				{
					if(Map.weather==Map.WEATHERNORMAL)
					{
						NetworkUDP.communicate(NetworkUDP.MAPNORMAL, null);
						Map.SetUpHills();//20oct2021
					}
					if(Map.weather==Map.WEATHERCOLD)
					{
						NetworkUDP.communicate(NetworkUDP.MAPSNOW, null);
						Map.SetUpHills();//20oct2021
					}
					if(Map.weather==Map.WEATHERHOT)
					{
						NetworkUDP.communicate(NetworkUDP.MAPDESERT, null);
						Map.SetUpHills();//20oct2021
					}
				}
			}
			if(Game.RESOLVE<=0)
			{
				Game.battleover = false;
				Game.battleovertime = 0;
				Unit.battlejoined = 0;//14oct2021
			}
			if(Game.RESOLVE>0)
			{
				Gui.firstunit = 0;
				int f5 = 0;
				int f6 = 0;
				for(int i=0;i<Game.units.Length;i++)
				{
					if(Game.units[i].hp>0)
					{
						if(Game.units[i].faction==5)
						{
							f5++;
						}
						if(Game.units[i].faction==6)
						{
							f6++;
						}
						if(f5>0 && f6>0)
						{
							break;
						}
					}
				}
				if(f5==0 || f6==0)
				{
					Game.winloss = 1;//17oct2021
					if(Game.battleovertime==0)
					{
						Game.battleovertime = Game.currentTimeMillis() + 5000;
						int mm = 0;
						for(int i=0;i<Game.units.Length;i++)//14oct2021
						{
							
							if(Game.units[i].hp>0)
							{
								mm++;
								Game.units[i].tx = Game.RESOLUTIONX/2 - 400 + (mm % 15) * Map.GRIDW * 2;
								Game.units[i].ty = Game.RESOLUTIONY/2 - 250 + ((mm - (mm % 15)) / 15) * Map.GRIDH * 2;
								Game.units[i].tmptx = Game.units[i].tx;
								Game.units[i].tmpty = Game.units[i].ty;
								Game.units[i].tmptattempts = 0;
								Game.units[i].firetargeti = -1;
							}
						}
					}
					else
					{
						if(Game.battleovertime<Game.currentTimeMillis())
						{
							Game.battleover = true;
						}
					}
					
				}
				
				if(NetworkUDP.isserver && Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.GAMEENDSTATE!=Game.GAMEENDSTATE_VICTORY && Game.GAMEENDSTATE!=Game.GAMEENDSTATE_DEFEAT && Game.vsai<=0 && Game.battleover==false)
				//if(NetworkUDP.isserver && Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.vsai<=0)
				{
					if(Game.currentTimeMillis()>NetworkUDP.lastsync)
					{
						NetworkUDP.lastsync = Game.currentTimeMillis() + Config.SYNCTIME; //on PC do more often.....
						NetworkUDP.communicate(NetworkUDP.SYNC, null);
					}
					if(Game.currentTimeMillis()>NetworkUDP.lastspeedcheck)
					{
						NetworkUDP.lastspeedcheck = Game.currentTimeMillis() + Config.SPEEDCHECKTIME;
						NetworkUDP.communicate(NetworkUDP.UPDATESPEED,null);
					}
				}
				if(Game.RESOLVE==1)
				{
					//Game.frame = 10000; //reset game frame
					//Functions.seed = 7573823;//reset random number seed
					
					///////////////////
					//start---------13oct2021
					//13oct2021 add heroes on to map at this point......
					int its = 0;
					int count = 0;
					int index = 0;
					
					//start-----------//18oct2021
					if(Game.vsai>0)
					{
						//ai should try and cast a spell.....
						if(Functions.rand(0,1000) < 800)
						{
							Spells.SpellAction(Game.EnemyIndex,(int)Functions.abs(Functions.rand(0,1000)) % 3);
						}
					}
					//end-------------//18oct2021
					
					while(Game.numfhero>0)
					{
						Game.numfhero--;
						//Game.units[i].createunitatxy(game, i, Game.templates[Game.units[i].templateid], x, y))
						count = 0;
						index = 0;
						for(int t=0;t<Game.templates.Length;t++)
						{
							if(Game.templates[t].bossmonster>0)
							{
								if(Game.templates[t].name.IndexOf("hero")>=0 && Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
								{
									count++;
								}
							}
						}
						if(count>0)
						{
							index = 1 + (Functions.rand(0,1000) % count);
							for(int t=0;t<Game.templates.Length;t++)
							{
								if(Game.templates[t].bossmonster>0)
								{
									if(Game.templates[t].name.IndexOf("hero")>=0 && Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
									{
										index--;
										if(index<=0)
										{
											for(int i=0;i<Game.units.Length;i++)
											{
												if(Game.units[i].hp<=0)
												{
													int y = Game.BOARDY * 6;
													int x = Game.RESOLUTIONX/4 + Functions.Rand(0,10000) % (Game.RESOLUTIONX/2);
													Game.units[i].createunitatxy(game, i, Game.templates[t], x, y);
													break;
												}
											}
											break;
										}
									}
								}
							}
							
						}
						its++;
						if(its>16)
						{
							break;
						}
					}
					its = 0;
					while(Game.numehero>0)
					{
						Game.numehero--;
						count = 0;
						index = 0;
						for(int t=0;t<Game.templates.Length;t++)
						{
							if(Game.templates[t].bossmonster>0)
							{
								if(Game.templates[t].name.IndexOf("hero")>=0  && Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
								{
									count++;
								}
							}
						}
						if(count>0)
						{
							index = 1 + (Functions.rand(0,1000) % count);
							for(int t=0;t<Game.templates.Length;t++)
							{
								if(Game.templates[t].bossmonster>0)
								{
									if(Game.templates[t].name.IndexOf("hero")>=0  && Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
									{
										index--;
										if(index<=0)
										{
											for(int i=0;i<Game.units.Length;i++)
											{
												if(Game.units[i].hp<=0)
												{
													int y = Game.BOARDY * 2;
													int x = Game.RESOLUTIONX/4 + Functions.Rand(0,10000) % (Game.RESOLUTIONX/2);
													Game.units[i].createunitatxy(game, i, Game.templates[t], x, y);
													break;
												}
											}
											break;
										}
									}
								}
							}
						}
						its++;
						if(its>16)
						{
							break;
						}
						
					}
					////////////////////////
					//end----------//13oct2021
					for(int trig=0;trig<Game.triggers.Length;trig++)
					{
						if(Game.triggers[trig].unitname!=null)
						{
							if(Game.triggers[trig].unitname==("RANDOMEVENT"))
							{
								Trigger.RandomEvent(trig);
							}
						}
					}

					for(int i=0;i<Game.units.Length;i++)
					{
						if(Game.units[i].hp>0)
						{
							Game.units[i].faction = Game.templates[Game.units[i].templateid].faction;
							if(Game.units[i].faction!=5 && Game.units[i].faction!=6)
							{
								if(Game.units[i].y < Game.RESOLUTIONY/2)
								{
									Game.units[i].faction = 5;//Red
								}
								else
								{
									Game.units[i].faction = 6;//Blue
								}
							}
							
							Game.units[i].walkspeed = Game.templates[Game.units[i].templateid].walkspeed;
							if(Game.units[i].walkspeed<=0)
							{
								if(Game.templates[Game.units[i].templateid].origwalkspeed>0)//7oct2021
								{
									Game.units[i].walkspeed = Game.templates[Game.units[i].templateid].origwalkspeed;//7oct2021
								}
								else
								{
									Game.units[i].walkspeed=2;//bug fix//6oct2021
								}
							}
							
							Game.units[i].ai = Unit.AI_ASSAULT;
							//if(Config.SYNCON>0)
							//{	
								Game.units[i].animmode = Unit.ANIMMODE_IDLE;
								Game.units[i].dirn = i % 8;
								Game.units[i].animframe = Game.units[i].animmodeidleframestart + (i % 4);
								if(Game.units[i].animframe > Game.units[i].animmodeidleframeend)
								{
									Game.units[i].animframe = Game.units[i].animmodeidleframestart;
								}
							//}
						}
					}
					Game.RESOLVE = 2;
				}
				return;
			}
			if(Game.movingtime>0)
			{
				Game.movingtime--;
				if(Game.movingtime<=0)
				{
					for(int i=0;i<Game.units.Length;i++)
					{
						int boardx = Game.units[i].x / 160;
						int boardy = Game.units[i].y / Game.BOARDY;
						if((Game.units[i].boardx!=boardx || Game.units[i].boardy!=boardy) && Game.units[i].hp>0)
						{
							
							//remove the unit...
							int oldhp = Game.units[i].hp;
							int oldfrenzy = Game.units[i].frenzy;
							int oldx = Game.units[i].x;
							int oldy = Game.units[i].y;
							Game.units[i].hp=0;
							Map.removeunit(i, Game.units[i].x,Game.units[i].y);
							//then recreate it....
							//in the board area.....
							bool placed = false;
							for(int x=Game.units[i].boardx * 160;x<Game.units[i].boardx * 160 + 160;x+=Map.GRIDW/4)
							{
								for(int y=Game.units[i].boardy * Game.BOARDY;y<Game.units[i].boardy * Game.BOARDY + Game.BOARDY;y+=Map.GRIDH/4)
								{
									Game.units[i].reset(game, i);
									if(Game.units[i].createunitatxy(game, i, Game.templates[Game.units[i].templateid], x, y))
									{
										Game.units[i].hp = oldhp;
										Game.units[i].frenzy = oldfrenzy;
										placed = true;
									}
									if(placed)
									{
										break;
									}
								}
								if(placed)
								{
									break;
								}
							}
							if(!placed)
							{
								if(Game.units[i].createunitatxy(game, i, Game.templates[Game.units[i].templateid], oldx,oldy ))
								{
									Game.units[i].hp = oldhp;
									Game.units[i].frenzy = oldfrenzy;
									placed = true;
								}
							}
						}
					}
					Game.gamemode = Game.MODE_ORDER;
					Game.firstcell = -1;
					Game.secondcell = -1;
					Game.CELLSIDE = -1;
				}
				else
				{
					bool okay = true;
					for(int i=0;i<Game.units.Length;i++)
					{
						int boardx = Game.units[i].x / 160;
						int boardy = Game.units[i].y / Game.BOARDY;
						if(Game.units[i].boardx!=boardx || Game.units[i].boardy!=boardy && Game.units[i].hp>0)
						{
							okay = false;
						}
					}
					if(okay)
					{
						Game.gamemode = Game.MODE_ORDER;
						Game.firstcell = -1;
						Game.secondcell = -1;
						Game.CELLSIDE = -1;
						Game.movingtime=0;
					}
				}
			}
			if(Game.battletime>0)
			{
				Game.battletime--;
				if(Game.battletime<=0)
				{
					for(int i=0;i<Game.units.Length;i++)
					{
						Game.units[i].faction = Unit.NULLFACTION;
						int oldhp = Game.units[i].hp;
						int oldfrenzy = Game.units[i].frenzy;
						Game.units[i].hp = 0;
						Map.removeunit(i, Game.units[i].x, Game.units[i].y);
						bool placed = false;
						if(oldhp>0)
						{
							for(int x=Game.units[i].boardx * 160;x<Game.units[i].boardx * 160 + 160;x+=Map.GRIDW/4)
							{
								for(int y=Game.units[i].boardy * Game.BOARDY;y<Game.units[i].boardy * Game.BOARDY + Game.BOARDY;y+=Map.GRIDH/4)
								{
									
									int nid = i;
									int nx = Game.units[i].boardx * 160 + (nid % 4) * 32 + 10;
									int ny = Game.units[i].boardy * Game.BOARDY + (((nid - (nid % 4))/4) % 2) * 32 + 5;
									Game.units[i].reset(game, i);
									if(Game.units[i].createunitatxy(game, i, Game.templates[Game.units[i].templateid], nx, ny))
									{
										Game.units[i].hp = oldhp;
										Game.units[i].frenzy = oldfrenzy;
										placed = true;
									}
									if(placed)
									{
										break;
									}
								}
								if(placed)
								{
									break;
								}
							}
						}
					}
					Game.gamemode = Game.MODE_ORDER;
					Game.firstcell = -1;
					Game.secondcell = -1;
					Game.CELLSIDE = -1;
					//////////////clean up/////////////////
					if(Game.movingtime<=0 && Game.battletime<=0)
					{
						//cleanup.....
						
						int[] faction5count = new int[90];
						int[] faction6count = new int[90];
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].hp>0)
							{
								Game.units[i].walkspeed = Game.templates[Game.units[i].templateid].walkspeed;
								int boardi = Game.units[i].x/160 + (Game.units[i].y/Game.BOARDY)*10;
								if(Game.units[i].boardi!=boardi)
								{
									Game.units[i].hp = 0;
									Map.removeunit(i,Game.units[i].x,Game.units[i].y);
									Game.units[i].reset(game,i);
								}
								if(boardi>=0 && boardi<90)
								{
									if(Game.units[i].faction==5)
									{
										faction5count[boardi]++;
									}
									if(Game.units[i].faction==6)
									{
										faction6count[boardi]++;
									}
								}
								else
								{
									Game.units[i].hp = 0;
									Map.removeunit(i,Game.units[i].x,Game.units[i].y);
								}
							}
						}
						for(int b=0;b<90;b++)
						{
							if(faction5count[b]>0 && faction6count[b]>0)
							{
								//can't share the same square....
								if(faction5count[b]<faction6count[b])
								{
									for(int i=0;i<Game.units.Length;i++)
									{
										if(Game.units[i].hp>0 && Game.units[i].faction==5)
										{
											int boardi = Game.units[i].x/160 + (Game.units[i].y/Game.BOARDY)*10;
											if(b==boardi)
											{
												Game.units[i].hp=0;
												Map.removeunit(i,Game.units[i].x,Game.units[i].y);
												Game.units[i].reset(game,i);
											}
										}
									}
								}
								else
								{
									if(faction5count[b]==faction6count[b])
									{
										for(int i=0;i<Game.units.Length;i++)
										{
												int boardi = Game.units[i].x/160 + (Game.units[i].y/Game.BOARDY)*10;
												if(b==boardi)
												{
													Game.units[i].hp=0;
													Map.removeunit(i,Game.units[i].x,Game.units[i].y);
													Game.units[i].reset(game,i);
												}
										
										}	
									}
									else
									{
										for(int i=0;i<Game.units.Length;i++)
										{
											if(Game.units[i].hp>0 && Game.units[i].faction==6)
											{
												int boardi = Game.units[i].x/160 + (Game.units[i].y/Game.BOARDY)*10;
												if(b==boardi)
												{
													Game.units[i].hp=0;
													Map.removeunit(i,Game.units[i].x,Game.units[i].y);
													Game.units[i].reset(game,i);
												}
											}
										}	
									}
								}
							}
						}
					}
				}
				else
				{
					int faction5 = 0;
					int faction6 = 0;
					for(int i=0;i<Game.units.Length;i++)
					{
						if(Game.units[i].hp>0)
						{
							if(Game.units[i].faction==5)
							{
								faction5++;
							}
							if(Game.units[i].faction==6)
							{
								faction6++;
							}
						}
					}
					if(faction5==0 || faction6==0)
					{
						Game.gamemode = Game.MODE_ORDER;
						Game.firstcell = -1;
						Game.secondcell = -1;
						Game.CELLSIDE = -1;
						Game.battletime = 0;
						for(int i=0;i<Game.units.Length;i++)
						{
							Game.units[i].faction = Unit.NULLFACTION;
							int oldhp = Game.units[i].hp;
							int oldfrenzy = Game.units[i].frenzy;
							Game.units[i].hp = 0;
							Map.removeunit(i, Game.units[i].x, Game.units[i].y);
							bool placed = false;
							if(oldhp>0)
							{
								for(int x=Game.units[i].boardx * 160;x<Game.units[i].boardx * 160 + 160;x+=Map.GRIDW/4)
								{
									for(int y=Game.units[i].boardy * Game.BOARDY;y<Game.units[i].boardy * Game.BOARDY + Game.BOARDY;y+=Map.GRIDH/4)
									{
										int nid = i;
										int nx = Game.units[i].boardx * 160 + (nid % 4) * 32 + 10;
										int ny = Game.units[i].boardy * Game.BOARDY + (((nid - (nid % 4))/4) % 2) * 32 + 5;
										Game.units[i].reset(game, i);
										if(Game.units[i].createunitatxy(game, i, Game.templates[Game.units[i].templateid], nx, ny))
										{
											Game.units[i].hp = oldhp;
											Game.units[i].frenzy = oldfrenzy;
											placed = true;
										}
										if(placed)
										{
											break;
										}
									}
									if(placed)
									{
										break;
									}
								}
							}
						}
					}
				}
			}
		}
		
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Tech //2sep2021
	{
		public static bool TECHUNITSELECTED = false;
		public static int TECHUNITIDSELECTED = -1;
		public static int COMPLETEDTIME = 60 * 5; //time to show on screen the 'completed' message for....
		public static int COMPLETEDID = -1;
		//
		public static int ADDSUBTRACT = 0;
		public static int TARGETUID = -1;
		//
		public string name;
		public string techclass;//23sep2021
		public string displayname;
		public string[] description;
		public string tooltip;
		public int guilinkid;
		public int id;
		public int faction;
		//
		public int researchtime; //number of seconds to count down from
		public int timeleft; //initialised to -1
		public int researched; //reset at beginning of mission.
		public int completedtime;//
		public int researching;
		public int unlimited;//23sep2021
		//
		public int goldcost;//23sep2021
		public int purchased;//23sep2021
		public int purchaseguilink;//23sep2021
		public int temporary;//23sep2021
		public int temporarytime;//23sep2021
		public int TEMPORARYTIME = 90;//23sep2021
		public int attackaction;//23sep2021
		public int guiactionid;//23sep2021
		public int selectedtopurchase;//23sep2021
		public int manacost;//23sep2021
	
		public int img; //icon image
		public int imgframe; //frame in image if multiple cells...
		public string imgfile; //image file
		public int saleimg;//saleimage//23sep2021
		public string saleimgfile;//image file//23sep2021
		public int saleimgframe;//23sep2021
	
		public int scw; //cell width//23sep2021
		public int sch; //cell height//23sep2021
		public int snw; //number wide//23sep2021
		public int snh; //number high//23sep2021
	
		public int cw; //cell width
		public int ch; //cell height
		public int nw; //number wide
		public int nh; //number high
		//
		public string effectname; //pipe separated list of items....
		public int effectint;// if value is a buff of sorts....
		//
		public static string ENABLEUNIT = "EU_";
		public static string BUFFMOVE = "BM_";
		public static string BUFFATT = "BA_";
		public static string BUFFDEF = "BD_";
		public static string BUFFHP = "BH_";
		public static string BUFFABILITY = "BZ_"; 
		//
		public int[] unittemplatesenabled;
		public int[] unittemplatesmove;
		public int[] unittemplatesatt;
		public int[] unittemplatesdef;
		public int[] unittemplateshp;
		public string[] unittemplatesability;
		//
		//example effect name string:
		//effectname = EU_Hero Skeleton
		//would enable the Hero Skeleton to be built.
		//effectname = BA_Hero Skeleton|BD_Hero Skeleton
		//effectint = 1
		//would buff Hero Skeletons' Att and Def by +1 point permanently.
		
		public static string MV = "MV";
		public static string BA = "BA";
		public static string BD = "BD";
		public static string BH = "BH";
		public static string BZ = "BZ";
		
		///////////////////Method Definition///////////////
		public static int PercentComplete(Game game,int id)
		{
			if(!Config.USETECH)
			{
				return 100;
			}
			if(Game.techs[id].timeleft<0)
			{
				return 0;
			}
			if(Game.techs[id].timeleft==0)
			{
				return 100;
			}
			if(Game.techs[id].researchtime<=0)
			{
				return 100;
			}
			return ((Game.techs[id].researchtime - Game.techs[id].timeleft) * 100) / Game.techs[id].researchtime;
		}
		
		///////////////////Method Definition///////////////
		public static void StartResearch(Game game,int techid,int faction)
		{
			if(!Config.USETECH)
			{
				return;
			}
			for(int i=0;i<Game.techs.Length;i++)
			{
				if(faction==Game.techs[i].faction)
				{
					Game.techs[i].researching = 0;
				}
			}
			Game.techs[techid].researching = 1;
			if(Game.techs[techid].timeleft<0)
			{
				Game.techs[techid].timeleft = Game.techs[techid].researchtime;
			}
		}
		///////////////////Method Definition///////////////
		public static int AddUnitUpgradeBuff(Game game,int templateid,string type)
		{
			if(!Config.USETECH)
			{
				return 0;
			}
			for(int i=0;i<Game.techs.Length;i++)
			{
				if(Game.techs[i].researched>0)
				{
					if(Game.techs[i].unittemplatesmove!=null && type==Tech.MV)
					{
						for(int j=0;j<Game.techs[i].unittemplatesmove.Length;j++)
						{
							if(Game.techs[i].unittemplatesmove[j]==templateid)
							{
								return Game.techs[i].effectint;
							}
						}
					}
					if(Game.techs[i].unittemplatesatt!=null && type==Tech.BA)
					{
						for(int j=0;j<Game.techs[i].unittemplatesatt.Length;j++)
						{
							if(Game.techs[i].unittemplatesatt[j]==templateid)
							{
								return Game.techs[i].effectint;
							}
						}
					}
					if(Game.techs[i].unittemplatesdef!=null && type==Tech.BD)
					{
						for(int j=0;j<Game.techs[i].unittemplatesdef.Length;j++)
						{
							if(Game.techs[i].unittemplatesdef[j]==templateid)
							{
								return Game.techs[i].effectint;
							}
						}
					}
					if(Game.techs[i].unittemplateshp!=null && type==Tech.BH)
					{
						for(int j=0;j<Game.techs[i].unittemplateshp.Length;j++)
						{
							if(Game.techs[i].unittemplateshp[j]==templateid)
							{
								return Game.techs[i].effectint;
							}
						}
					}
					if(Game.techs[i].unittemplatesability!=null && type==Tech.BZ && TARGETUID!=-1 && ADDSUBTRACT!=0)
					{
						for(int j=0;j<Game.techs[i].unittemplatesability.Length-2;j+=2)
						{
							if(Game.techs[i].unittemplatesability[j]==Game.templates[templateid].name)
							{
								AlterUnitAbility(game,Game.techs[i].unittemplatesability[j + 1],TARGETUID,ADDSUBTRACT);
								return 0;
							}
						}
					}
				}
			}
			return 0;
		}
		
		///////////////////Method Definition///////////////
		public static void AlterUnitAbility(Game game,string ability,int id,int value)
		{
			//add to this list as time goes on....as more abilities come to light.....
			bool redomagic = false;
			switch(ability)
			{
				case "needlos"://15sep2021
				Game.units[id].needlos+=value;
				break;
				case "range":
				Game.units[id].firerange+=value;
				break;
				case "damage2":
				Game.units[id].damage2+=value;
				break;
				case "splash":
				Game.units[id].splash+=value;
				break;
				case "range2":
				Game.units[id].firerange2+=value;
				break;
				case "prefermobiletargets"://18sep2021
				Game.units[id].prefermobiletargets+=value;
				break;
				case "spellcaster":
				Game.units[id].spellcaster+=value;
				break;
				case "notabuffer": //15apr2021
				Game.units[id].notabuffer+=value;
				break;
				case "extragibbet"://18sep2021
				Game.units[id].extragibbet+=value;
				break;
				case "firespell":
				Game.units[id].firespell+=value;
				break;
				case "powerspell":
				Game.units[id].powerspell+=value;
				break;
				case "healer":
				Game.units[id].healer+=value;
				break;
				case "zombiemaster":
				Game.units[id].zombiemaster+=value;
				break;
				case "banishment": //12mar2021
				Game.units[id].banish+=value;
				break;
				case "timid":
				Game.units[id].timid+=value;
				break;
				case "hitandrun":
				Game.units[id].hitandrun+=value;
				break;
				case "buildpenalty": //20mar2021
				Game.units[id].buildpenalty+=value;
				break;//20mar2021
				case "brave":
				Game.units[id].brave+=value;
				break;
				//start-----------//01apr2021
				case "spellability":
				Game.units[id].spellability+=value;
				break;
				case "ping"://16sep2021
				Game.units[id].ping+=value;
				break;
				case "spelldefense": //magic resistance....
				Game.units[id].spelldefense+=value;
				break;
				//start--------------//4may2021
				case "canfly":
				Game.units[id].canfly+=value;
				break;
				case "canflyandwalk":
				Game.units[id].canflyandwalk+=value;
				break;
				case "canattackair":
				Game.units[id].canattackair+=value;
				break;
				//end----------------//4may2021
				//start--------------//3may2021
				case "magicrelease": //for getting out of transports
				Game.units[id].magicrelease +=value;
				redomagic = true;
				if(Game.units[id].magicrelease>0)
				{
					Game.units[id].magicrelease = Unit.MAGICRELEASE;
				}
				else
				{
					Game.units[id].magicrelease = 0;
				}
				break;
				case "magictransform": //for transforming into a different unit
				redomagic = true;
				Game.units[id].magictransform +=value;
				if(Game.units[id].magictransform>0)
				{
					Game.units[id].magictransform = Unit.MAGICTRANSFORM;
				}
				else
				{
					Game.units[id].magictransform = 0;
				}
				break;
				case "magicsummoner":
				redomagic = true;
				Game.units[id].magiczombiemaster+=value;
				if(Game.units[id].magiczombiemaster>0)
				{
					Game.units[id].magiczombiemaster = Unit.MAGICZOMBIEMASTER;
				}
				else
				{
					Game.units[id].magiczombiemaster = 0;
				}
				break;
				case "magiczombiemaster"://redundant version alias
				redomagic = true;
				Game.units[id].magiczombiemaster+=value;
				if(Game.units[id].magiczombiemaster>0)
				{
					Game.units[id].magiczombiemaster = Unit.MAGICZOMBIEMASTER;
				}
				else
				{
					Game.units[id].magiczombiemaster = 0;
				}
				break;
				case "magicleader":
				Game.units[id].magicleader+=value;
				redomagic = true;
				if(Game.units[id].magicleader>0)
				{
					Game.units[id].magicleader = Unit.MAGICLEADER;
				}
				else
				{
					Game.units[id].magicleader = 0;
				}
				break;
				//end----------------//9apr2021
				case "magicfrenzy":
				Game.units[id].magicfrenzy+=value;
				redomagic = true;
				if(Game.units[id].magicfrenzy>0)
				{
					Game.units[id].magicfrenzy = Unit.MAGICFRENZY;
				}
				else
				{
					Game.units[id].magicfrenzy = 0;
				}
				break;
				case "magicdoom":
				Game.units[id].magicdoom+=value;
				redomagic = true;
				if(Game.units[id].magicdoom>0)
				{
					Game.units[id].magicdoom = Unit.MAGICDOOM;
				}
				else
				{
					Game.units[id].magicdoom = 0;
				}
				break;
				case "magicdefense":
				Game.units[id].magicdef+=value;
				redomagic = true;
				if(Game.units[id].magicdef>0)
				{
					Game.units[id].magicdef = Unit.MAGICDEF;
				}
				else
				{
					Game.units[id].magicdef = 0;
				}
				break;
				case "magicdef": //redundancy
				Game.units[id].magicdef+=value;
				redomagic = true;
				if(Game.units[id].magicdef>0)
				{
					Game.units[id].magicdef = Unit.MAGICDEF;
				}
				else
				{
					Game.units[id].magicdef = 0;
				}
				break;
				//end-------------//01apr2021
				//start---------------//28mar2021
				case "magicweb":
				Game.units[id].magicweb+=value;
				redomagic = true;
				if(Game.units[id].magicweb>0)
				{
					Game.units[id].magicweb = Unit.MAGICWEB;
				}
				else
				{
					Game.units[id].magicweb = 0;
				}
				break;
				case "magicgas":
				redomagic = true;
				Game.units[id].magicgas+=value;
				if(Game.units[id].magicgas>0)
				{
					Game.units[id].magicgas = Unit.MAGICGAS;
				}
				else
				{
					Game.units[id].magicgas = 0;
				}
				break;
				case "magichaste":
				redomagic = true;
				Game.units[id].magichaste+=value;
				if(Game.units[id].magichaste>0)
				{
					Game.units[id].magichaste = Unit.MAGICHASTE;
				}
				else
				{
					Game.units[id].magichaste = 0;
				}
				break;
				case "magicfear":
				redomagic = true;
				Game.units[id].magicfear+=value;
				if(Game.units[id].magicfear>0)
				{
					Game.units[id].magicfear = Unit.MAGICFEAR;
				}
				else
				{
					Game.units[id].magicfear = 0;
				}
				break;
				case "magicshield":
				redomagic = true;
				Game.units[id].magicshield+=value;
				if(Game.units[id].magicshield>0)
				{
					Game.units[id].magicshield = Unit.MAGICSHIELD;
				}
				else
				{
					Game.units[id].magicshield = 0;
				}
				break;
				case "magicstorm":
				redomagic = true;
				Game.units[id].magicstorm+=value;
				if(Game.units[id].magicstorm>0)
				{
					Game.units[id].magicstorm = Unit.MAGICSTORM;
				}
				else
				{
					Game.units[id].magicstorm = 0;
				}
				break;
				case "magicsword":
				redomagic = true;
				Game.units[id].magicsword += value;
				if(Game.units[id].magicsword>0)
				{
					Game.units[id].magicsword = Unit.MAGICSWORD;
				}
				else
				{
					Game.units[id].magicsword = 0;
				}
				break;
				case "magicstealth":
				redomagic = true;
				Game.units[id].magicstealth += value;
				if(Game.units[id].magicstealth>0)
				{
					Game.units[id].magicstealth = Unit.MAGICSTEALTH;
				}
				else
				{
					Game.units[id].magicstealth = 0;
				}
				break;
				case "magicplant":
				redomagic = true;
				Game.units[id].magicplant += value;
				if(Game.units[id].magicplant>0)
				{
					Game.units[id].magicplant = Unit.MAGICPLANT;
				}
				else
				{
					Game.units[id].magicplant = 0;
				}
				break;
				case "magicwind":
				redomagic = true;
				Game.units[id].magicwind += value;
				if(Game.units[id].magicwind>0)
				{
					Game.units[id].magicwind = Unit.MAGICWIND;
				}
				else
				{
					Game.units[id].magicwind = 0;
				}
				break;
				//end-----------------//28mar2021
				case "highfirerate": //25Feb2021
				Game.units[id].highfirerate += value;
				break;
				//start-------------//7mar2021
				case "mob": 
				Game.units[id].mob += value;
				break;
				case "hatred": 
				Game.units[id].hatred += value;
				break;
				case "craftsman": 
				Game.units[id].craftsman += value;
				break;
				case "planar": 
				Game.units[id].planar += value;
				break;
				case "slow": 
				Game.units[id].slow += value;
				break;
				case "woodsman": 
				Game.units[id].woodsman += value;
				break;
				case "stupid": 
				Game.units[id].stupid += value;
				break;
				case "frenzy": 
				Game.units[id].frenzy  += value;
				break;
				//end---------------//7mar2021
				case "shocktroops":
				Game.units[id].shock  += value;
				break;
				case "shock": //2sep2021
				Game.units[id].shock  += value;
				break;//2sep2021
				case "stealth":
				Game.units[id].stealth  += value;
				break;
				case "damagex":
				Game.units[id].damagex  += value;
				break;
				case "fearsome":
				Game.units[id].fearsome  += value;
				break;
				case "leader":
				Game.units[id].leader  += value;
				break;
				case "bounddemon"://12jul2021
				Game.units[id].bounddemon  += value;
				break;
				case "bossmonster":
				Game.units[id].bossmonster  += value;
				break;
				case "flammable":
				Game.units[id].flammable  += value;
				break;
				case "regeneration":
				Game.units[id].regeneration  += value;
				break;
				case "zombie":
				Game.units[id].zombie  += value;
				break;
				case "evilfire":
				Game.units[id].firespell  -= value;
				break;
				case "sacrificial":
				Game.units[id].sacrificial  += value;
				break;
				case "cansacrifice": 
				Game.units[id].cansacrifice  += value;
				break;
				case "animosity":
				Game.units[id].animosity  += value;
				break;
			}
			if(redomagic)
			{
				Game.units[id].magicarray = new int[17];
				int m = 0;
				if(Game.units[id].magicrelease>0)//3may2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magicrelease;
					m++;
				}
				if(Game.units[id].magictransform>0)//3may2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magictransform;
					m++;
				}
				//start--------------//9apr2021
				if(Game.units[id].magicleader>0)//01apr2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magicleader;
					m++;
				}
				if(Game.units[id].magiczombiemaster>0)//01apr2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magiczombiemaster;
					m++;
				}
				//end----------------//9apr2021
				if(Game.units[id].magicdoom>0)//01apr2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magicdoom;
					m++;
				}
				if(Game.units[id].magicdef>0)//01apr2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magicdef;
					m++;
				}
				if(Game.units[id].magicfrenzy>0)//01apr2021
				{
					Game.units[id].magicarray[m] = Game.units[id].magicfrenzy;
					m++;
				}
				if(Game.units[id].magicweb>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicweb;
					m++;
				}
				
				if(Game.units[id].magicfear>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicfear;
					m++;
				}
				if(Game.units[id].magicgas>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicgas;
					m++;
				}
				if(Game.units[id].magichaste>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magichaste;
					m++;
				}
				if(Game.units[id].magicplant>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicplant;
					m++;
				}
				if(Game.units[id].magicshield>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicshield;
					m++;
				}
				if(Game.units[id].magicstealth>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicstealth;
					m++;
				}
				if(Game.units[id].magicstorm>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicstorm;
					m++;
				}
				if(Game.units[id].magicsword>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicsword;
					m++;
				}
				if(Game.units[id].magicwind>0)
				{
					Game.units[id].magicarray[m] = Game.units[id].magicwind;
					m++;
				}
			}
		}
		
		///////////////////Method Definition///////////////
		public static bool IsUnitEnabled(Game game,int templateid)
		{
			if(!Config.USETECH)
			{
				return true;
			}
			for(int i=0;i<Game.techs.Length;i++)
			{
				if(Game.techs[i].researched>0)
				{
					if(Game.techs[i].unittemplatesenabled!=null)
					{
						for(int j=0;j<Game.techs[i].unittemplatesenabled.Length;j++)
						{
							if(Game.techs[i].unittemplatesenabled[j]==templateid)
							{
								return true;
							}
						}
					}
				}
			}
			return false;
		}
		///////////////////Method Definition///////////////
		public static void parseeffect(Game game,int id)
		{
			string effect = Game.techs[id].effectname;
			string[] effects = effect.Split("|");
			if(effects!=null)
			{
				for(int i=0;i<effects.Length;i++)
				{
					string[] etype = effects[i].Split("_");
					if(etype!=null)
					{
						if(etype.Length==2)
						{
							switch(etype[0])
							{
								case "EU":
								Array.Resize(ref Game.techs[id].unittemplatesenabled,Game.techs[id].unittemplatesenabled.Length + 1);
								Game.techs[id].unittemplatesenabled[Game.techs[id].unittemplatesenabled.Length - 1] = Unit.findtemplatebyname(game,etype[1]);
								break;
								case "BM":
								Array.Resize(ref Game.techs[id].unittemplatesmove,Game.techs[id].unittemplatesmove.Length + 1);
								Game.techs[id].unittemplatesmove[Game.techs[id].unittemplatesmove.Length - 1] = Unit.findtemplatebyname(game,etype[1]);
								break;
								case "BA":
								Array.Resize(ref Game.techs[id].unittemplatesatt,Game.techs[id].unittemplatesatt.Length + 1);
								Game.techs[id].unittemplatesatt[Game.techs[id].unittemplatesatt.Length - 1] = Unit.findtemplatebyname(game,etype[1]);
								break;
								case "BD":
								Array.Resize(ref Game.techs[id].unittemplatesdef,Game.techs[id].unittemplatesdef.Length + 1);
								Game.techs[id].unittemplatesdef[Game.techs[id].unittemplatesdef.Length - 1] = Unit.findtemplatebyname(game,etype[1]);
								break;
								case "BH":
								Array.Resize(ref Game.techs[id].unittemplateshp,Game.techs[id].unittemplateshp.Length + 1);
								Game.techs[id].unittemplateshp[Game.techs[id].unittemplateshp.Length - 1] = Unit.findtemplatebyname(game,etype[1]);
								break;
							}
						}
						if(etype.Length==3)
						{
							switch(etype[0])
							{
								case "BZ":
								Array.Resize(ref Game.techs[id].unittemplatesability,Game.techs[id].unittemplatesability.Length + 2);
								Game.techs[id].unittemplatesability[Game.techs[id].unittemplatesability.Length - 2] = etype[1];
								Game.techs[id].unittemplatesability[Game.techs[id].unittemplatesability.Length - 1] = etype[2];
								break;
							}
						}
					}
				}
			}
			
		}
		
		///////////////////Method Definition///////////////
		public Tech()
		{
				name = "";
				displayname = "";
				techclass = "";//23sep2021
				purchaseguilink = -1;//23sep2021
				guiactionid = -1;//23sep2021
				description = new string[3];
				description[0] = "";
				description[1] = "";
				description[2] = "";
				unittemplatesenabled = new int[0];
				unittemplatesatt = new int[0];
				unittemplatesdef = new int[0];
				unittemplateshp = new int[0];
				unittemplatesmove = new int[0];
				unittemplatesability = new string[0];
				researching = 0;
				tooltip = "";
				guilinkid = -1;
				researchtime = 0;
				completedtime = -1;
				timeleft = -1;
				researched = 0;
				img = -1;
				imgframe = 0;
				imgfile = "";
				cw = 0;
				ch = 0;
				nw = 1;
				nh = 1;
				effectname = "";
				effectint = 0;
				id = -1;
		}
		
		///////////////////Method Definition///////////////
		public void reset(Game game,int id,bool missionstart)
		{
			if(!missionstart)
			{
				Game.techs[id].name = "";
				Game.techs[id].displayname = "";
				Game.techs[id].techclass = "";//23sep2021
				Game.techs[id].purchaseguilink =-1;//23sep2021
				Game.techs[id].guiactionid = -1;//23sep2021
				Game.techs[id].description = new string[3];
				Game.techs[id].description[0] = "";
				Game.techs[id].description[1] = "";
				Game.techs[id].description[2] = "";
				Game.techs[id].tooltip = "";
				Game.techs[id].guilinkid = -1;
				Game.techs[id].researchtime = 0;
				Game.techs[id].timeleft = -1;
				Game.techs[id].researched = 0;
				Game.techs[id].completedtime = -1;
				Game.techs[id].img = -1;
				Game.techs[id].imgframe = 0;
				Game.techs[id].imgfile = "";
				Game.techs[id].cw = 0;
				Game.techs[id].ch = 0;
				Game.techs[id].nw = 1;
				Game.techs[id].nh = 1;
				Game.techs[id].effectname = "";
				Game.techs[id].effectint = 0;
				Game.techs[id].id = id;
				Game.techs[id].unittemplatesenabled = new int[0];
				Game.techs[id].unittemplatesatt = new int[0];
				Game.techs[id].unittemplatesdef = new int[0];
				Game.techs[id].unittemplateshp = new int[0];
				Game.techs[id].unittemplatesmove = new int[0];
				Game.techs[id].unittemplatesability = new string[0];
				Game.techs[id].researching = 0;
			}
			else
			{
				TECHUNITSELECTED = false;
				TECHUNITIDSELECTED = -1;
				TARGETUID = -1;
				ADDSUBTRACT = 0;
				Game.techs[id].timeleft = -1;
				Game.techs[id].researched = 0;
				Game.techs[id].completedtime = -1;
				Game.techs[id].researching = 0;
			}
		}
		
		public static void updateall(Game game)
		{
			if(!Config.USETECH)
			{
				return;
			}
			for(int i=0;i<Game.techs.Length;i++)
			{
				Game.techs[i].update(game);
			}
			if((Game.frame % 179)==0)
			{
				//every 3 seconds....the AI will try and learn a new tech....
				//if it is not already researching one.....
				for(int i=0;i<Game.techs.Length;i++)
				{
					if(Game.techs[i].faction!=Game.PLAYERFACTION)
					{
						if(Game.techs[i].timeleft<0)
						{
							//not researched...and not the player faction, nor currently researching....
							//therefore.....
							//check that we have the necessary unit in the game to research it....
							for(int u=0;u<Unit.MAXINDEX;u++)
							{
								if(Game.units[u].hp>0 && Game.units[u].faction==Game.techs[i].faction && Game.units[u].techguilinkid==Game.techs[i].guilinkid)
								{
									Tech.StartResearch(game,i,Game.techs[i].faction);
									break;
								}
							}
						}
					}
				}
			}
		}
		
		public static void unpurchase(Game game)//24sep2021
		{
			if(!Config.USETECH)
			{
				return;
			}
			for(int i=0;i<Game.techs.Length;i++)
			{
				Game.techs[i].purchased = 0;
			}
			for(int i=0;i<Game.gui.Length;i++)
			{
				if(Game.gui[i].command.IndexOf("attackaction")>=0)
				{
					Game.gui[i].action = Gui.ACTION_NONE;
				}
			}
		}
		
		public static void resetall(Game game)
		{
			if(!Config.USETECH)
			{
				return;
			}
			for(int i=0;i<Game.techs.Length;i++)
			{
				Game.techs[i].reset(game,i,true);
			}
		}
		
		///////////////////Method Definition///////////////
		public void update(Game game)
		{
			//start-----------//23sep2021
			if(goldcost>0 && purchased<=0)
			{
				timeleft = -1;
				completedtime = -1;
				researched = -1;
				researching = 0;
				return;
			}
			if(temporary>0 && attackaction>0)
			{
				//player is using this tech to perform an attack.....
				//therefore
				if(temporarytime>0)
				{
					temporarytime--;
					researched = 1;
					completedtime = COMPLETEDTIME;
					timeleft = 0;
					researching = 0;
					//pick a firetargeti value......
					Unit.SelectNearestTarget(game,Unit.GetPlayer(game));//24sep2021
				}
				else
				{
					timeleft = -1;
					completedtime = -1;
					researched = -1;
					researching = 0;
				}
				return;
			}
			//end-------------//23sep2021
			if(timeleft==0)
			{
				researched = 1;
				completedtime = COMPLETEDTIME;
			}
			if(timeleft>0 && researching>0)
			{
				timeleft--;
			}
			if(completedtime>0)
			{
				completedtime--;
				COMPLETEDID = id;
			}
			else
			{
				COMPLETEDID = -1;
			}
		}
		//start----------23sep2021
	public static int GetTechIdFromAction(Game game,int guiactionid)
	{
		if(!Config.USETECH)
		{
			return -1;
		}
		if(Game.techs==null)
		{
			return -1;
		}
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				return i;
			}
		}
		return -1;
	}
	//
	public static int ChooseTechForEmptySlot(Game game)
	{
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].purchased>0 && Game.techs[i].attackaction>0)
			{
				bool found = false;
				for(int g=0;g<Game.gui.Length;g++)
				{
					if(Game.gui[g].action==Game.techs[i].guiactionid && Game.gui[g].command.IndexOf("attackaction")>=0)
					{
						//don't overwrite existing if filling an empty slot....
						found = true;
						break;
					}
				}
				if(found)
				{
					continue;
				}
				return Game.techs[i].guiactionid;
			}
		}
		return Gui.ACTION_NONE;
	}

	//
	public static int GoldCost(Game game,int id)
	{
		if(!Config.USETECH)
		{
			return -1;
		}
		return Game.techs[id].goldcost;
	}

	public static int GoldCostGui(Game game,int action)
	{
		if(!Config.USETECH)
		{
			return 0;
		}
		for(int i=0;i<Game.techs.Length;i++)
		{
			//Game.WriteDebug("Costs:"+Game.techs[i].displayname+" "+Game.techs[i].goldcost+ " actionid:"+action+" tech action:"+Game.techs[i].guiactionid);
			if(action==Game.techs[i].guiactionid)
			{
				return Game.techs[i].goldcost;
			}
		}
		return 0;
	}
	
	public static int SelectFromGuiToPurchase(Game game,int gid)
	{
		if(!Config.USETECH)
		{
			return 0;
		}
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].purchaseguilink==gid)
			{
				return SelectToPurchase(game,i);
			}
		}
		return 0;
	}
	
	public static int SelectToPurchase(Game game, int id)
	{
		if(!Config.USETECH)
		{
			return 0;
		}
		if(id<0 || id>=Game.techs.Length)
		{
			return 0;
		}
		if(Game.techs[id].purchased>0)
		{
			return 0;
		}
		if(Game.techs[id].goldcost<=0)
		{
			return 0;
		}
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].goldcost>0)
			{
				Game.techs[i].selectedtopurchase = 0;
			}
		}
		Game.techs[id].selectedtopurchase = 1;
		if(Game.techs[id].unlimited>0)
		{
			Game.techs[id].selectedtopurchase = -1;
		}
		return Game.techs[id].selectedtopurchase;
	}
	
	public static int PurchaseGuiSelected(Game game)
	{
		int limit = 0;
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].selectedtopurchase!=0)
			{
				Tech.Purchase(game, i);
				limit = Game.techs[i].selectedtopurchase;
			}
		}
		//Game.WriteDebug("limit:"+limit);
		return limit;
	}
	
	public static void Purchase(Game game,int id)
	{
		if(!Config.USETECH)
		{
			return;
		}
		if(Game.units==null)
		{
			return;
		}
		if(Game.techs[id].purchased>0)
		{
			return;
		}
		for(int j=0;j<Game.units.Length;j++)
		{
			if(Game.units[j].faction==Game.PLAYERFACTION && Game.units[j].hp>0 && Game.units[j].gold>=Game.techs[id].goldcost)
			{
				Game.units[j].gold-=Game.techs[id].goldcost;
				if(Game.techs[id].name=="healthpotion")
				{
					Game.units[j].healthpotions++;
					break;
				}
				if(Game.techs[id].name=="manapotion")
				{
					Game.units[j].manapotions++;
					break;
				}
				if(Game.techs[id].name=="bothpotion")
				{
					Game.units[j].bothpotions++;
					break;
				}
				
				Game.techs[id].purchased=1;
				Game.techs[id].researched = -1;
				Game.techs[id].completedtime = -1;
				Game.techs[id].timeleft = -1;
				Game.techs[id].researching = 0;
				break;
			}
		}
	}

	public static void DrinkPotion(Game game,int pid,string type)
	{
		if(type=="health")
		{
			if(Game.units[pid].healthpotions>0)
			{
				Game.units[pid].healthpotions--;
				Game.units[pid].hp+=PotionStrength(game,"healthpotion");
				if(Game.units[pid].hp>Game.units[pid].basehp)
				{
					Game.units[pid].hp = Game.units[pid].basehp;
				}
			}
		}
		if(type=="mana")
		{
			if(Game.units[pid].manapotions>0)
			{
				Game.units[pid].manapotions--;
				Game.units[pid].mana+=PotionStrength(game,"manapotion");
				if(Game.units[pid].mana>Game.units[pid].basemana)
				{
					Game.units[pid].mana = Game.units[pid].basemana;
				}
			}
		}
		if(type=="both")
		{
			if(Game.units[pid].bothpotions>0)
			{
				Game.units[pid].bothpotions--;
				Game.units[pid].hp+=PotionStrength(game,"bothpotion");
				if(Game.units[pid].hp>Game.units[pid].basehp)
				{
					Game.units[pid].hp = Game.units[pid].basehp;
				}
				Game.units[pid].mana+=PotionStrength(game,"bothpotion");
				if(Game.units[pid].mana>Game.units[pid].basemana)
				{
					Game.units[pid].mana = Game.units[pid].basemana;
				}
			}
		}
	}
	
	public static int PotionStrength(Game game,string type)
	{
		if(!Config.USETECH)
		{
			return 0;
		}
		if(Game.techs==null)
		{
			return 0;
		}
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].name==type)
			{
				return Game.techs[i].effectint;
			}
		}
		return 0;
	}
	
	public static int GetImage(Game game,int guiactionid)
	{
		if(!Config.USETECH)
		{
			return -1;
		}
		if(Game.techs==null)
		{
			return -1;
		}
		
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				return Game.techs[i].img;
			}
		}
		return -1;
	}
	//
	public static int GetImageIndex(Game game,int guiactionid)
	{
		if(!Config.USETECH)
		{
			return -1;
		}
		if(Game.techs==null)
		{
			return -1;
		}
		
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				return Game.techs[i].imgframe;
			}
		}
		return -1;
	}
	
	public static int GetSaleImage(Game game,int guiactionid)
	{
		if(!Config.USETECH)
		{
			return -1;
		}
		if(Game.techs==null)
		{
			return -1;
		}
		
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				return Game.techs[i].saleimg;
			}
		}
		
		return -1;
	}
	
	public static int GetSaleImageIndex(Game game,int guiactionid)
	{
		if(!Config.USETECH)
		{
			return -1;
		}
		if(Game.techs==null)
		{
			return -1;
		}
		
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				return Game.techs[i].saleimgframe;
			}
		}
		
		return -1;
	}
	
	public static string[] GetDescription(Game game,int guiactionid)
	{
		string[] desc = new string[10];
		for(int i=0;i<10;i++)
		{
			desc[i] = "";
		}
		if(!Config.USETECH)
		{
			return desc;
		}
		if(Game.techs==null)
		{
			return desc;
		}
		
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				for(int k=0;k<Game.techs[i].description.Length;k++)
				{
					desc[k] = Game.techs[i].description[k];
				}
			}
		}
		return desc;
	}
	
	public static bool IsActionPurchased(Game game,int guiactionid)
	{
		if(!Config.USETECH)
		{
			return false;
		}
		if(Game.techs==null)
		{
			return false;
		}
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==guiactionid)
			{
				if(Game.techs[i].purchased>0)
				{
					return true;
				}
			}
		}
		return false;
	}
	
	public static void ActivateAttack(Game game,int id)
	{
		if(!Config.USETECH)
		{
			return;
		}
		if(Game.techs==null)
		{
			return;
		}
		int pid = Unit.GetPlayer(game);
		if(pid==-1)
		{
			return;
		}
		//Game.WriteDebug("Attack Button Pressed");
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(Game.techs[i].guiactionid==id)
			{
				if(Game.techs[i].attackaction>0)
				{
					if(Game.units[pid].mana>=Game.techs[i].manacost)
					{
						Game.units[pid].mana-=Game.techs[i].manacost;
					}
					else
					{
						return;
					}
					if(Game.techs[i].temporary>0)
					{
						Game.techs[i].temporarytime = Game.techs[i].TEMPORARYTIME;
					}
					//the player will activate this option.....
					if(Game.units[pid].animmode!=Unit.ANIMMODE_ATTACK && Game.units[pid].animmode!=Unit.ANIMMODE_ATTACK2 && Game.units[pid].animmode!=Unit.ANIMMODE_ATTACK3)
					{
						Game.units[pid].firetargeti = -1; //reset the player's attack choice....
						Game.units[pid].orderframe = 0;
						Game.techs[i].update(game);
					}
				}
			}
		}
	}
	
	public static void RemoveItemFromStore(Game game,int g)
	{
		if(!Config.USETECH)
		{
			return;
		}
		if(Game.techs==null)
		{
			return;
		}
		if(Game.gui==null)
		{
			return;
		}
		if(g<0 || g>Game.gui.Length)
		{
			return;
		}
		Game.gui[g].action = Gui.ACTION_NONE;
	}
	
	public static void ChooseItemForStore(Game game,int g,string name,int mincost,int maxcost)
	{
		if(!Config.USETECH)
		{
			return;
		}
		if(Game.techs==null)
		{
			return;
		}
		if(Game.gui==null)
		{
			return;
		}
		if(g<0 || g>=Game.gui.Length)
		{
			return;
		}
		if(Game.gui[g].command.IndexOf("buydescription")>=0)
		{
			return;
		}
		int count = 0;
		int index = 0;
		//Game.WriteDebug("Choose Item For Store:"+name);
		for(int i=0;i<Game.techs.Length;i++)
		{
			if(mincost!=-1)
			{
				if(Game.techs[i].goldcost<mincost || Game.techs[i].goldcost>maxcost)
				{
					continue;
				}
			}
			if(Game.techs[i].name==name)
			{
				Game.gui[g].action = Game.techs[i].guiactionid;
				break;
			}
			if(Game.techs[i].techclass==name)
			{
				count++;
			}
		}
		//Game.WriteDebug("Item Count:"+count);
		if(count>0)
		{
			index = Functions.rand(0,1000);
			if(index<0)
			{
				index*=-1;
			}
			index%=count;
			index++;
			//Game.WriteDebug("Item Index:"+index);
			for(int i=0;i<Game.techs.Length;i++)
			{
				if(mincost!=-1)
				{
					if(Game.techs[i].goldcost<mincost || Game.techs[i].goldcost>maxcost)
					{
						continue;
					}
				}
				if(Game.techs[i].techclass==name)
				{
					index--;
					if(index<=0)
					{
						Game.gui[g].action = Game.techs[i].guiactionid;
						break;
					}
				}
			}
			
		}
		//Game.WriteDebug("Gui Item Action Buy ID:"+Game.gui[g].action);
	}
	
	//end----23sep2021
	}
	
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Units //21apr2021
	{
		public Unit[] unit;
		
		public Units(Game game)
		{
			unit = new Unit[Unit.MAXUNITS];
			for(int i=0;i<unit.Length;i++)
			{
				unit[i] = new Unit(game);
				unit[i].reset(game,i);
				//blank canvas.....
			}
		}
		
	}
	
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Unit
	{
		public static int HASLEADER = 0;//21oct2021
		public static int NUMAISCRIPTS = 13;
		public int dist10framesago = 0;//15oct2021
		public static int battlejoined = 0;//14oct2021
		public static int WALKMOD = 2;//14oct2021
		public static int WALKRATE = 1;//14oct2021
		public static int COLDIST = (Map.GRIDW * 2) / 3;//14oct2021
		
		public int pohp;
		public int originaltemplateid;
		public int wassummoned;
		public int forceshield;
		public int holyaura;
		public int charmperson;
		public int bladebarrier;
		public static int XQUOTIENT = 1;//9oct2021
		public static int XDIVISOR = 1;//9oct2021
		//the ratio of XDIVISOR/XQUOTIENT determines how likely the unit is to go for enemies that lay on the vertical between them...higher ratio means more likely to go for vertical enemies

		public int boardx = -1;
		public int boardy = -1;
		public int boardi = -1;

		public static int ODD = 0;
		public static int countfighting = 0;		
		
		public int isdead;
		public static bool COPYUNIT = false;//21apr2021
		public static int SPELLCHECK = 5;
		public static int GUARDRANGE = 150;
		public static int MAXWALKHEIGHTDIFF = 16;
		public static int CONTROLRATE = 5;
		public static int MAXUNITS = 200 * Config.FACTOR;
		public static int MAXINDEX = 0; //26mar2021
		public static int MAXDEPTH = 20;
		public static int MAXPATHFIND = 50;
		public static int PRECALCLIMIT = 10;
		public static int RETREATDEATH = 60 * 10;
		public static int PATHSTEP = 1;
		public static int MAXBUFFATT = 20;
		public static int MAXDEADTIME = 60;
		public int[] checkedgrid;
		public static int[] circles = null;//2jun2021
		public static int circlesmax = 0;//2jun2021
		//
		public static int DIRN_DOWN = 0;
		public static int DIRN_DOWNLEFT = 1;
		public static int DIRN_LEFT = 2;
		public static int DIRN_UPLEFT = 3;
		public static int DIRN_UP = 4;
		public static int DIRN_UPRIGHT = 5;
		public static int DIRN_RIGHT = 6;
		public static int DIRN_DOWNRIGHT = 7;
		public int dirn;
		public int odirn;
		public int displaydirn; //29may2021
		public static int DIRNDELAY = 10;
		public int dirntime;
		public int timesincelastpath;
		public int framesleft;//9sep2021
		public bool mirrorleftright;
		public float scale;//25sep2021
		public string controlmode;//24sep2021
		public static int CRPG = 0;//25sep2021
		public int offy;
		public int offx;//20apr2021
		public int[] offxa;//20apr2021
		public int[] offya;//20apr2021
		public bool autocalcedoffsets;//20apr2021
		//
		public string name;
		public string displayname; //13mar2021
		public string charactername;//10sep2021
		public int displaycharactername;//10sep2021
		//
		public static int HUMAN = 1;
		public static int UNDEAD = 2;
		public static int DEMON = 3;
		public static int REBELHUMAN = 5;
		public static int NULLFACTION = 99;
		public static int UNDEADWALKRATE = 1;
		public static int ANIMOSITY = 101; //7mar2021
		//start-----//3may2021
		//transporting units 
		public int transportcapacity;
		public int transportsize;
		public int[] transportarray;
		public int transportedbyid;
		//end------//3may2021
		public int faction;
		public int team;
		public int id;
		public int templateid;
		public int deaths;
		public int kills;
		public int dieonce;//13sep2021
		public int creates;
		public int prevdeaths;
		public int prevcreates;
		public int prevkills;
		public int dispdeaths;
		public int dispkills;
		public int dispcreates;
		public int groupid;
		public int aiselectframe;//17apr2021
		public int basemana;//23sep2021
		public int mana;//23sep2021
		public int manarate;//23sep2021
		public int healthpotions;//23sep2021
		public int manapotions;//23sep2021
		public int bothpotions;//23sep2021
		public int gold;//23sep2021
		public int canpickup;//23sep2021
		public int guiattackdisplaylimit;//23sep2021
	
		//
		public int cat; //sprite atlas resource
		public int cathires;//sprite atlas resource double resolution....//9apr2021
		public int dropshadow;//25sep2021
		public string catfile;
		public string cathiresfile;//9arp2021
		public int framesperdirn;//
		public int nodirn;
		public int cw;
		public int ch;
		public static int AI_DEFAULT = 0;
		public static int AI_ASSAULT = 1;
		public static int AI_EXTRAASSAULT = 2;
		public static int RALLYCHANCE = 100; //out of 1000 - checked once per second while off screen.....
		public static int RALLYORDERCHANCE = 50; //9mar2021
		public int ai;
		//
		public bool infog;
		public bool retreat;
		public int retreatframe;
		public int livecount; //9mar2021
		public int olivecount; //9mar2021
		public int livecountframe;//9mar2021
		public int selectioncount; //22mar2021
		//
		//game stats
		public string[] description;
		public int basehp;
		public int hp;
		public int timedead;
		public int armour;
		public int damage;
		public int walkspeed;
		public int tmpwalkspeed;
		public int spellwalkspeed;//18oct2021
		public int origwalkspeed;//7oct2021
		public int firetargeti;
		public int firerange;
		public int needlos;//15sep2021
		public int firerange2;
		public int damage2;
		public int splash; //2sep2021
		public int levelxp;
		public int xpvalue;
		public int xp;
		public int spellcaster;
		public int prefermobiletargets;//18sep2021
		public int notabuffer; //15apr2021
		public int dustcloud;
		public int firespell;
		public int extragibbet;//18sep2021
		public int powerspell;
		public int healer;
		public int zombiemaster;
		public int banish; //12mar2021
		public int timid;
		public int hitandrun;
		public int dodge;//21oct2021
		public int brave;
		public int points;//17sep2021
		public int misfire; //28mar2021
		public int buildpenalty; //20mar2021
		public int spelldefense; //01apr2021
		public int spellability; //01apr2021
		public int ping; //16sep2021
		public int redping;//17sep2021
		//start-------//3may2021
		public int magictransform;
		public string transforminto;
		public string transformrequires;
		public static int MAGICTRANSFORM = 3025;
		public static int MAGICRELEASE = 3026;
		public int magicrelease;
		//end---------//3may2021
		//start---------------//28mar2021
		public int magicfear;
		public int magicgas;
		public int magichaste;
		public int magicplant;
		public int magicshield;
		public int magicstealth;
		public int magicstorm;
		public int magicsword;
		public int magicwind;
		public int magicweb;
		public int magicdef;//01apr2021
		public int magicdoom;//01apr2021
		public int magicfrenzy;//01apr2021
		public int magiczombiemaster;//9apr2021
		public int magicleader;//9apr2021
		public int[] magicarray;
		public static int MAGICFEAR = 3010;
		public static int MAGICGAS = 3011;
		public static int MAGICHASTE = 3012;
		public static int MAGICPLANT = 3013;
		public static int MAGICSHIELD = 3014;
		public static int MAGICSTEALTH = 3015;
		public static int MAGICSTORM = 3016;
		public static int MAGICSWORD = 3017;
		public static int MAGICWIND = 3018;
		public static int MAGICWEB = 3019;//29mar2021
		public static int MAGICDEF = 3020;//01apr2021
		public static int MAGICDOOM = 3021;//01apr2021
		public static int MAGICFRENZY = 3022;//01apr2021
		public static int MAGICZOMBIEMASTER = 3023;//9apr2021
		public static int MAGICLEADER = 3024;//9apr2021
		public bool casting;
		//end-----------------//28mar2021
		//start-------------//7mar2021
		public int mob;
		public int lightningdeath;//19oct2021
		public int hatred;
		public int craftsman;
		public int planar;
		public int slow;
		public int woodsman;
		public int stupid;
		public int frenzy;
		//end---------------//7mar2021
		public int shock;
		public bool shocked;
		public int stealth;
		public int damagex;
		public int fearsome;
		public int leader;
		public int hasleader;//21oct2021
		public int bounddemon; //12jul2021
		public int highfirerate; //25Feb2021
		//public int fearful;
		public int bossmonster;
		public int flammable;
		public int ecat;
		public int fcat;
		public string ecatfile;
		public string fcatfile;
		public int controlpoint;
		public int controller;
		public int regeneration;
		public int zombie;
		public int sacrificial;
		public int cansacrifice;
		public int animosity;
		public int firebullet;
		public string spawner;
		public string spawnerconstraint; //9sep2021
		public string displayspawner; //13mar2021
		public int spawnertime;
		public int spawnercount;
		//
		//
		public bool buffed; //21mar2021
		public bool cursed; //21mar2021
		public int defendx; //9mar2021
		public int defendy; //9mar2021
		public int formationx;//14apr2021
		public int formationy;//14apr2021
		public int x;
		public int y;
		public int height;
		
		//flight stuff
		public int flightlevel;//4may2021
		public int canfly;//4may2021
		public int canflyandwalk;//4may2021
		public int canattackair;//4may2021
		//end of flight stuff
		
		public int tx;
		public int ty;
		public static int ORDERTIME = 300;
		public int orderframe;
		public int tmptx;
		public int tmpty;
		public int tmptframe;
		public int tmptattempts;
		public float angle;
		//
		public static int ANIMMODE_IDLE = 0;
		public static int ANIMMODE_WALK = 1;
		public static int ANIMMODE_ATTACK = 2;
		//
		public static int ANIMMODE_ATTACK2 = 3;
		public static int ANIMMODE_ATTACK3 = 4;
		public static int ANIMMODE_CAST = 3;
		public static int ANIMMODE_SPECIAL = 3;
		public static int ANIMMODE_SPECIAL2 = 4;
		public static int ANIMMODE_DEAD = 99; //25Feb2021
		public static int ANIMMODE_IDLE2 = 100; //28Feb2021
		public static int ANIMMODE_FLY = 10;//4may2021
		public static int ANIMMODE_FLYATTACK = 11;//4may2021
		//
		public int oanimmode;
		public int animmode;
		public int animrest;
		public int animframe;
		public int animspeed;
		public int animtime;//29sep2021
		//
		public int animmodeidleframestart;
		public int animmodeidleframeend;
		public int animmodeidle2framestart; //28Feb2021
		public int animmodeidle2frameend; //28Feb2021
		public int animmodewalkframestart;
		public int animmodewalkframeend;
		public int animmodeattframestart;
		public int animmodeattframeend;
		public int animmodeatt2framestart;
		public int animmodeatt2frameend;
		public int animmodeatt3framestart;
		public int animmodeatt3frameend;
		public int animmodedeadframestart; //25Feb2021
		public int animmodedeadframeend;	//25Feb2021
		public int animmodeflyframestart;//4may2021
		public int animmodeflyframeend;//4may2021
		public int animmodeflyattackframestart;//4may2021
		public int animmodeflyattackframeend;//4may2021
		
		//
		public bool drawn;
		//
		public static int SELECTIONSTART = 1;
		public static int SELECTIONFROZEN = 2;
		public static int SELECTIONENEMY = -1;
		public static int SELECTIONNONE = 0;
		public int selected;
		public int selectedframe;
		/////////////////////////////
		//Audio
		public bool onscreen;
		public bool ronscreen; //replay onscreen value - 25apr2021
		public int[] impactfx;
		public int[] attackfx;
		public int[] deathfx; //28jul2021
		public int[] targetfx;
		public int[] magicfx;
		public int[] ackfx;
		public int[] selectfx;
		/////////////////////////////
		//Tech
		//start----------------//2sep2021
		public int techguilinkid;
		public int unresearchedbydefault;
		//end------------------//2sep2021

		
///////////////////Method Definition///////////////
		public static void SelectNearestTarget(Game game,int id)//24sep2021
		{
			if(id<0 || id>=Game.units.Length)//25sep2021
			{
				return;
			}
			int target = -1;
			int mindist = 9999;
			int dist = 0;
			int[] searched = new int[Map.MAXX * Map.MAXY];
			//Game.WriteDebug("Selecting Nearest");
			for(int c=1;c<10;c++)
			{
				if(c > 1 + (Game.units[id].firerange / Map.GRIDW))
				{
					continue;
				}
				for(int cx=Game.units[id].x / Map.GRIDW - c;cx<=Game.units[id].x / Map.GRIDW + c;cx++)
				{
					for(int cy=Game.units[id].y / Map.GRIDH - c;cy<=Game.units[id].y / Map.GRIDH + c ;cy++)
					{
						if(cx>=0 && cx<Map.MAXX && cy>=0 && cy<Map.MAXY)
						{
							if(searched[cx + cy * Map.MAXX]==1)
							{
								continue;
							}
							searched[cx + cy * Map.MAXX] = 1;
						}
						else
						{
							continue;
						}
						target = Map.cellunit(cx * Map.GRIDW,cy * Map.GRIDH);
						if(target!=-1)
						{
							if(Game.units[target].hp>0 && Game.units[target].faction!=Game.units[id].faction && Game.units[target].faction!=Unit.NULLFACTION)
							{
								dist = (int)(Functions.abs(cx - Game.units[id].x / Map.MAXX) + Functions.abs(cy - Game.units[id].y / Map.MAXY));
								if(dist < mindist )
								{
									if(Game.units[id].needlos>0)//15sep2021
									{
										if(los(game,id,target))
										{
											mindist = dist;
											Game.units[id].firetargeti = target;
											//Game.WriteDebug("Selecting Nearest:"+Game.units[target].dname());
										}
									}
									else//15sep2021
									{
										mindist = dist;
										Game.units[id].firetargeti = target;
										//Game.WriteDebug("Selecting Nearest:"+Game.units[target].dname());
									}
								}
							}
						}
					}
				}
				if(Game.units[id].firetargeti!=-1)
				{
					break;
				}
			}
		}
		
///////////////////Method Definition///////////////		
		public static int PlayerGold(Game game)//23sep2021
		{
			if(Game.units==null)
			{
				return 0;
			}
			int gold = 0;
			for(int i=0;i<Game.units.Length;i++)
			{
				if(Game.units[i].faction==Game.PLAYERFACTION && Game.units[i].hp>0)
				{
					if(Game.units[i].gold>0)
					{
						gold+=Game.units[i].gold;
					}
				}
			}
			return gold;
		}

///////////////////Method Definition///////////////		
		public static int GetPlayer(Game game)//23sep2021
		{
			if(game==null)
			{
				return -1;
			}
			if(Game.units==null)
			{
				return -1;
			}
			for(int i=0;i<Game.units.Length;i++)
			{
				if(Game.units[i].faction==Game.PLAYERFACTION && Game.units[i].hp>0)
				{
					return i;
				}
			}
			return -1;
		}
		
///////////////////Method Definition///////////////		
		public static void SaveScore(Game game,int mid)//17sep2021
		{
			int count = 0;
			for(int i=0;i<Game.units.Length;i++)
			{
				if(Game.templates[Game.units[i].templateid].walkspeed>0 && Game.units[i].hp>0 && Game.units[i].faction==Game.PLAYERFACTION)
				{
					count+=Game.units[i].points;
				}
			}
			LocalStorage.setitem("missionscore"+mid,""+count);
			Game.scoredirty = true;//18sep2021
		}
		
///////////////////Method Definition///////////////
		public static bool SpawnerCanBuild(Game game,string constraint,int tid)//9sep2021
		{
			if(constraint=="*")
			{
				return true;
			}
			string[] constraints = constraint.Split("|");
			if(constraints==null)
			{
				return false;
			}
			if(constraints.Length==0)
			{
				return false;
			}
			for(int i=0;i<constraints.Length;i++)
			{
				if(constraints[i]==Game.templates[tid].name)
				{
					return true;
				}
			}
			return false;
		}
		
///////////////////Method Definition///////////////
		public static bool TransportingUnits(Game game,int i)//3may2021
		{
			if(Game.units[i].transportarray==null)
			{
				return false;
			}
			if(Game.units[i].transportcapacity>0)
			{
				for(int k=0;k<Game.units[i].transportarray.Length;k++)
				{
					if(Game.units[i].transportarray[k]!=-1)
					{
						return true;
					}
				}
			}
			return false;
		}

///////////////////Method Definition///////////////
		public static void GetInTransport(Game game,int i,int j)//3may2021
		{
			//i = transport
			//j = non transport
			if(Game.units[i].transportarray==null)
			{
				return;
			}
			if(Game.units[i].hp<=0 || Game.units[j].hp<=0)
			{
				return;
			}
			if(Game.units[i].transportcapacity<=0)
			{
				return;
			}
			if(Game.units[j].canfly>0)//4may2021
			{
				return;
			}
			if(Game.units[j].flightlevel!=-1)//4may2021
			{
				return;
			}
			//if our distance is further than 2 grid squares then disallow as well
			if(Functions.abs(Game.units[i].x - Game.units[j].x)>Map.GRIDW * 2 || Functions.abs(Game.units[i].y - Game.units[j].y)>Map.GRIDH *2)
			{
				return;
			}
			int numinside = 0;
			for(int k=0;k<Game.units[i].transportarray.Length;k++)
			{
				int nid = Game.units[i].transportarray[k];
				if(nid!=-1)
				{
					numinside+=Game.units[nid].transportsize;
				}
			}
			if(numinside>=Game.units[i].transportcapacity)
			{
				return;
			}
			for(int k=0;k<Game.units[i].transportarray.Length;k++)
			{
				int nid = Game.units[i].transportarray[k];
				if(nid==-1)
				{
					if(Map.removeunit(j,Game.units[j].x,Game.units[j].y))
					{
						Game.units[i].transportarray[k] = j;
						Game.units[j].transportedbyid = i;
						break;
					}
				}
			}
		}
		
///////////////////Method Definition///////////////
		public static void DeployUnits(Game game,int i)//3may2021
		{
			//i is the transporter unit
			//we might take more than one frame....especially if it is crowded around us....
			//
			if(Game.units[i].transportarray==null)
			{
				return;
			}
			if(Game.units[i].transportcapacity>0)
			{
				for(int k=0;k<Game.units[i].transportarray.Length;k++)
				{
					if(Game.units[i].transportarray[k]!=-1)
					{
						int nid = Game.units[i].transportarray[k];
						if(Game.units[nid].hp>0)
						{
							if(Game.units[nid].transportedbyid==i)
							{
								//try and drop us out of the transport......
								bool foundspot = false;
								for(int x=Game.units[i].x - Map.GRIDW * 2;x<=Game.units[i].x + Map.GRIDW * 2;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * 2;y<=Game.units[i].y + Map.GRIDH * 2;y+=Map.GRIDH)
									{
										if(Map.cellunit(x,y)==Map.VACANT)
										{
											foundspot = true;
											if(Map.insertunit(nid,x,y))
											{
												Game.units[nid].x = x;
												Game.units[nid].y = y;
												Game.units[nid].tx = x;
												Game.units[nid].ty = y;
												Game.units[nid].tmptx = x;
												Game.units[nid].tmpty = y;
												Game.units[nid].firetargeti = -1;
												Game.units[nid].transportedbyid = -1;
												Game.units[i].transportarray[k] = -1;
											}
											break;
										}
									}
									if(foundspot)
									{
										break;
									}
								}
							}
						}
					}				
				}
			}
		}

///////////////////Method Definition///////////////
		public static void CorrectTransport(Game game,int i)//3may2021
		{
			if(Game.units[i].transportcapacity>0)
			{
				//go through any units inside.....and check they're alive.....
				if(Game.units[i].transportarray==null)
				{
					return;
				}
				for(int k=0;k<Game.units[i].transportarray.Length;k++)
				{
					int nid = Game.units[i].transportarray[k];
					if(nid!=-1)
					{
						if(Game.units[nid].hp<=0)
						{
							Game.units[nid].transportedbyid = -1;
							Game.units[i].transportarray[k] = -1;
						}
					}
				}			
			}
			else
			{
				//if have a transport....
				if(Game.units[i].transportedbyid!=-1)
				{
					//if it is dead?
					int nid = Game.units[i].transportedbyid;
					if(Game.units[nid].transportcapacity<=0)
					{
						//cannot be? we cannot be inside a non transport
						//if this occurs we've really messed up.....
						return;
					}
					if(Game.units[nid].hp<=0)
					{
						//our transport is dead.....therefore.....
						//deploy us........
						Unit.DeployUnits(game,nid);
						return;
					}
					//if we are not in its list?
					bool found = false;
					for(int k=0;k<Game.units[nid].transportarray.Length;k++)
					{
						int jid = Game.units[nid].transportarray[k];
						if(jid==i)
						{
							found = true;
						}
					}
					if(found==false)
					{
						//error we are not in their list.....
						//?? we've messed up here too
						//set our hitpoints to zero......
						//and remove us from the map if we can....
						Game.units[i].hp = 0;
						Map.removeunit(i,Game.units[i].x,Game.units[i].y);
					}
				}
			}
		}
		
///////////////////Method Definition///////////////
		public static bool CanTransform(Game game,int i) //3may2021
		{
			bool okay = true;
			string req = Game.units[i].transformrequires;
			string[] reqarray = req.Split("|");
			if(req!="")
			{
				//various requirements not yet determined....
				//pipe separated list of requirements of format:
				//type|qty|type|qty|type|qty
				//which all have to be met to return a true value for the method
			}
			return okay;
		}
		
///////////////////Method Definition///////////////
		public string dname() //13mar2021
		{
			//used for displaying the appropriate unit name in the game
			//which is either the displayname, or the actual name or a blank
			if(charactername!=null)//10sep2021
			{
				if(charactername!="")//10sep2021
				{
					return charactername;//10sep2021
				}
			}
			if(displayname==null)
			{
				return name;
			}
			if(displayname=="")
			{
				return name;
			}
			if(name==null)
			{
				return "";
			}
			return displayname;
		}
		//start-------------//10mar2021

		public static void WriteOffsets(Game game,string file)
		{
			Config.AUTOCALCOFFSETS = false;
			try
			{
				string txt = "";
				for(int i=0;i<Game.templates.Length;i++)
				{
					if(Game.templates[i].autocalcedoffsets==true)
					{
						txt+="image="+Game.templates[i].catfile+","+Game.templates[i].offx+","+Game.templates[i].offy+Environment.NewLine;
					}
				}
				System.IO.File.WriteAllText(file,txt);	
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
			}
		}
		
///////////////////Method Definition///////////////
		public unsafe static void AutoCalcOffsets(Game game,int i)//20apr2021
		{
			if(i>=0 && i<Game.templates.Length)
			{
				//calculate the offset x and y positions for the creature......we already put in the text file...but this is more accurate....
				//we only do one of these per frame since it could take some time.....if we did them all at once....
				//we might have to use pointers...again.......
				int pixelcount = 0;
				int fully = 0;
				int offx = 0;
				int offy = 0;
				int sumx = 0;
				int sumy = 0;
				if(Game.templates[i].cat!=-1 && Game.templates[i].hp>0 && Game.templates[i].walkspeed>0)
				{
					if(Game.images[Game.templates[i].cat].texture!=IntPtr.Zero)
					{
						try
						{
							int w = Game.images[Game.templates[i].cat].cwx;
							int h = Game.images[Game.templates[i].cat].chy;
							IntPtr surface = SDL_image.IMG_Load(Game.images[Game.templates[i].cat].file);
							Game.templates[i].autocalcedoffsets=true;
							SDL.SDL_Surface * sur = (SDL.SDL_Surface *)surface;
							int frame = 0;
							while(frame < Game.images[Game.templates[i].cat].cwn * Game.images[Game.templates[i].cat].chn)
							{
								int pointer = 0;
								int cellx = frame % Game.images[Game.templates[i].cat].cwn;
								int celly = (frame - cellx) / Game.images[Game.templates[i].cat].cwn;
								int sx = cellx * Game.images[Game.templates[i].cat].cwx;
								int sy = celly * Game.images[Game.templates[i].cat].chy;
								pointer = 4 * (sy*sur->pitch + sx);
								for(int y=0;y<h;y++)
								{
									for(int x=0;x<w;x++)
									{
										byte alphapixel = Marshal.ReadByte(sur->pixels,pointer + x * 4);
										byte lastpixel = Marshal.ReadByte(sur->pixels,pointer + x * 4 + 3);
										if(alphapixel>0 && lastpixel>0)
										{
											pixelcount++;
											sumx+=x;
											sumy+=y;
											fully=y;
										}
									}
									pointer+=sur->pitch;
								}
								
								if(pixelcount>0)
								{
									offx =  (w/2) - (sumx/pixelcount);
									offy =  - (h / 2) + 3 * (h - fully) / 2 + (h - fully) / 2 + (fully - sumy/pixelcount)/2;
									Game.templates[i].offxa[frame] = offx;
									Game.templates[i].offya[frame] = offy;
									Game.templates[i].offx+=offx;
									Game.templates[i].offy+=offy;
									//Game.templates[i].autocalcedoffsets = true;
									//Game.WriteDebug("Offx:"+offx+" offy:"+offy+" file:"+Game.templates[i].catfile+" frame:"+frame);
									sumx = 0;
									sumy = 0;
									pixelcount = 0;
									offx = 0;
									offy = 0;
									fully = 0;
								}
								frame++;
							}
							if(frame>0)
							{
								Game.templates[i].offx/=frame;
								Game.templates[i].offy/=frame;
							}
							SDL.SDL_FreeSurface(surface);
						}
						catch(Exception e)
						{
							string msg = e.Message;
							Game.WriteDebug(e.Message);
						}
					}
				}
			}
		}
		
///////////////////Method Definition///////////////
		public int percentagespawn(Game game)
		{
			//used for showing the build progress at construction buildings
			//(Game.frame+id)%(framecheck*spawnertime)==0)
			int framecheck = 60;
			if(Config.RUNNINGSPEED>90)
			{
				framecheck = 80;
			}
			if(Config.RUNNINGSPEED>110)
			{
				framecheck = 90;
			}
			framecheck/=Config.FASTFRAMECHECK;//14sep2021
			int curframe = Game.frame + id;
			int fulltime = framecheck * spawnertime;
			if(fulltime==0)
			{
				return 0;
			}
			int startframe = (curframe - (curframe % fulltime));
			//int framesleft = fulltime - (curframe % fulltime);//9sep2021
			int pct = (100 * (fulltime - framesleft)) / fulltime;
			if(pct>100)
			{
				pct = 100;
			}
			if(pct<0)
			{
				pct = 0;
			}
			return pct;
		}

///////////////////Method Definition///////////////
		public static int CalculateSpawnerTime(Game game,int tid)
		{
			//calculate the time to spawn this unit
			//kind of like a points cost for units in time
			int minvalue = 3;
			int maxvalue = 15;
			int value = minvalue;
			int firerate = Game.templates[tid].highfirerate+1;
			if(firerate>2)
			{
				firerate = 2;
			}
			if(firerate<2)
			{
				firerate = 1;
			}
			int tmpvalue = minvalue + Game.templates[tid].basehp * (1 + Game.templates[tid].armour / 2 + (Game.templates[tid].damage / 3 + Game.templates[tid].damage2 / 3) * (firerate)) / 60;
			//start-----------------//20mar2021
			tmpvalue += Game.templates[tid].firebullet * 3; //20mar2021 - add 3 seconds to missile troops....
			tmpvalue += Game.templates[tid].brave * 2; //20mar2021 - add 2 seconds to brave troops...
			tmpvalue -= Functions.sign(Game.templates[tid].stupid) * 2; //deduct 2 seconds from stupid troops
			tmpvalue -= Functions.sign(Game.templates[tid].timid) * 3; //deduct 3 seconds from timid troops
			tmpvalue += Functions.sign(Game.templates[tid].shock) * 2; //add 2 seconds to shock troops
			tmpvalue += Functions.sign(Game.templates[tid].damagex) * 2; //add 2 seconds to damagex troops
			tmpvalue -= Functions.sign(Game.templates[tid].hitandrun)  * 2; //deduct 2 seconds from skirmishers
			tmpvalue += Functions.sign(Game.templates[tid].craftsman) * 2; //add 3 seconds to craftsman
			tmpvalue += Functions.sign(Game.templates[tid].frenzy) * 2;//add 2 seconds to frenzy
			tmpvalue += Functions.sign(Game.templates[tid].regeneration) * 3; //add 3 seconds for regeneration
			tmpvalue += Functions.sign(Game.templates[tid].fearsome) * 2; //add 2 seconds to fearsome
			tmpvalue += Functions.sign(Game.templates[tid].woodsman) * 2; //add 2 seconds for woodsman
			tmpvalue += Functions.sign(Game.templates[tid].banish) * 4; //add 4 seconds for banishment....
			tmpvalue += Functions.sign(Game.templates[tid].splash) * 6; //add 6 seconds for splash damage//2sep2021
			tmpvalue += Game.templates[tid].buildpenalty;//special factor to adjust for some troops.....
			//
			if(tmpvalue < minvalue)
			{
				tmpvalue = minvalue;
			}
			//end-------------------//20mar2021
			if(tmpvalue > value)
			{
				value = tmpvalue;
			}
			if(value > maxvalue)
			{
				value = maxvalue;
			}
			return value;
		}
		//end---------------//10mar2021
		//start-------------//9mar2021

///////////////////Method Definition///////////////
		public static void SpellCast(Game game,int spellid,int sfaction)//28mar2021
		{
			//find our spellcasters......
			bool soundplayed = false;
			Functions.saveseed(Functions.seed);
			for(int i=0;i<=Unit.MAXINDEX;i++)
			{
				//if(Game.units[i].hp>0 && Game.units[i].faction==sfaction && Game.units[i].spellcaster>0 && ((Game.units[i].selected!=Unit.SELECTIONNONE && sfaction==Game.PLAYERFACTION && Game.SPELLCASTERSELECTED==i) || (sfaction!=Game.PLAYERFACTION && Game.units[i].casting==true)))//13oct2021
				if(Game.units[i].hp>0 && Game.units[i].faction==sfaction && Game.units[i].spellcaster>0 && (Game.units[i].casting==true))//13oct2021
				{
					//this is one of our casters.
					Game.units[i].casting = false;
					if(!soundplayed)
					{
						Game.units[i].playmagicsound(game,i);
						soundplayed = true;
					}
					int spell = spellid;// - Gui.ACTION_SPELL_START;
					//a value from 0 to 8
					//as there are 9 different spells in the game (maximum)
					//of varying level....
					/*
					spells are: (in no particular order)
					magicfear
					magicgas
					magichaste
					magicplant
					magicshield
					magicstealth
					magicstorm
					magicsword
					magicwind
					*/
					for(int m=0;m<Game.units[i].magicarray.Length;m++)
					{
						if(spell==Game.units[i].magicarray[m])
						{
							//cancel the spell - one use only.....
							Game.units[i].magicarray[m] = -1 * Game.units[i].magicarray[m];
							//start------//3may2021
							if(spell==Unit.MAGICRELEASE)
							{
								//for units being transported.....
								if(Unit.TransportingUnits(game,i))
								{
									//deploy units outside the transport.......
									Unit.DeployUnits(game,i);	
								}
								else
								{
									Game.units[i].magicarray[m] = -1 * Game.units[i].magicarray[m];
								}
							}
							if(spell==Unit.MAGICTRANSFORM)
							{
								if(!Unit.CanTransform(game,i))
								{
									Game.units[i].magicarray[m] = -1 * Game.units[i].magicarray[m]; //don't cast spell....and hence don't grey it out......
									continue;
								}
								int nid = i;
								int oldhpfrac = (100 * Game.units[i].hp) / Game.units[i].basehp;
								if(oldhpfrac>100)
								{
									oldhpfrac = 100;
								}
								int oldx = Game.units[i].x;
								int oldy = Game.units[i].y;
								int ztmp = -1;
								for(int tid=0;tid<Game.templates.Length;tid++)
								{
									if(Game.templates[tid].name==Game.units[i].transforminto)
									{
										ztmp = tid;
										break;
									}
								}
								if(ztmp!=-1)
								{
									//assume all requirements are met to transform if here.....
									Game.units[i].hp = 0;
									Map.removeunit(i,Game.units[i].x,Game.units[i].y);
									Game.units[i].createunitatxy(game,i,Game.templates[ztmp],oldx,oldy);
									Game.units[i].hp = (Game.units[i].basehp * oldhpfrac) / 100;
									if(Game.units[i].hp<1)
									{
										Game.units[i].hp = 1;
									}
									Game.units[i].x = oldx;
									Game.units[i].y = oldy;
								}
							}
							//end--------//3may2021
							//start------//01apr2021
							if(spell==Unit.MAGICDEF)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(Game.units[i].notabuffer>0 && nid!=i)//15apr2021
										{
											continue;
										}
										if(nid!=-1)
										{
											if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0)
											{
												Game.units[nid].spelldefense++;
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[i].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GREENSPELL);
											}
										}
									}
								}
							}
							//start--------------//9apr2021
							if(spell==Unit.MAGICLEADER)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(Game.units[i].notabuffer>0 && nid!=i)//15apr2021
										{
											continue;
										}
										if(nid!=-1)
										{
											if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0)
											{
												Game.units[nid].leader+=2;
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[i].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GREENSPELL);
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICZOMBIEMASTER)
							{
								int nid = Map.cellunit(Game.units[i].x,Game.units[i].y); //ie ourselves....
								if(nid!=-1)
								{
									if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].zombiemaster>0)
									{
										Game.units[nid].zombiemaster+=5;
										if(Game.units[nid].zombiemaster>10)
										{
											Game.units[nid].zombiemaster=10;
										}
									}
								}
							}
							//end----------------//9apr2021
							if(spell==Unit.MAGICDOOM)
							{
								//hmm....what is this spell? some kind of 'inverse healing maybe?' for the undead? and chaos?
								
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=-1)
										{
											if(Game.units[nid].spelldefense>0)//01apr2021
											{
												continue;
											}
											if(Game.units[nid].hp>0 && Game.units[nid].walkspeed>0)
											{
												if(Functions.rand(0,1000)<750)
												{
													Game.units[nid].hp-=Game.units[i].spellcaster;
													if(Game.units[nid].onscreen)
													{
														Functions.saveseed();//25apr2021
														if(Functions.rand(0,100)<25)
														{
															Game.units[nid].playvictimhitsound(game,nid);
														}
														Functions.restoreseed();//25apr2021
													}
													Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[i].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.REDSPELL);
													if(Game.units[nid].hp<=0)//20mar2021
													{
														Game.killed(game,nid);
														Game.templates[Game.units[i].templateid].kills++;
													}						
													Game.units[i].hp+=Game.units[i].spellcaster;
													if(Game.units[i].hp>Game.units[i].basehp)
													{
														Game.units[i].hp = Game.units[i].basehp;
													}
													
												}
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICFRENZY)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(Game.units[i].notabuffer>0 && nid!=i)//15apr2021
										{
											continue;
										}
										if(nid!=-1)
										{
											if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].damage>0)
											{
												Game.units[nid].frenzy+=3;
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[i].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GREENSPELL);
											}
										}
									}
								}
							}
							//end--------//01apr2021
							if(spell==Unit.MAGICFEAR)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=-1)
										{
											if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].walkspeed>0)
											{
												if(Game.units[nid].spelldefense>0)//01apr2021
												{
													continue;
												}
												if(Functions.rand(0,1000)<500)
												{
													Game.units[nid].timid = 1;
													Game.units[nid].retreat = true;
													Game.units[nid].retreatframe = Game.frame + Unit.RETREATDEATH;
													Game.units[nid].orderframe = Unit.ORDERTIME;
													Game.units[nid].firetargeti = -1;
													Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.REDSPELL);
												}
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICGAS)
							{
								int fires = 0;
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 5;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 5;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 5;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 5;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=-1)
										{
											if(Game.units[nid].spelldefense>0)//01apr2021
											{
												continue;
											}
											if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0)
											{
												Map.setonfire(x,y,false);
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[i].offy,x,y,Bullet.FIRESPELL);
												fires++;
											}
										}
										if(fires>Game.units[i].spellcaster*3)
										{
											break;
										}
									}
									if(fires>Game.units[i].spellcaster*3)
									{
										break;
									}
								}
							}
							if(spell==Unit.MAGICWEB)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=-1)
										{
											if(Game.units[nid].spelldefense>0)
											{
												continue;
											}
											if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].walkspeed>0)
											{
												Game.units[nid].walkspeed--; //maximum walk speed....
												//if(Game.units[nid].walkspeed<1)
												//{
												//	Game.units[nid].walkspeed=1;
												//}
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.REDSPELL);
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICHASTE)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(Game.units[i].notabuffer>0 && nid!=i)//15apr2021
										{
											continue;
										}
										if(nid!=-1)
										{
											if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].walkspeed>0)
											{
												Game.units[nid].walkspeed++; //maximum walk speed....
												if(Game.units[nid].walkspeed>3)
												{
													Game.units[nid].walkspeed=3;
												}
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GREENSPELL);
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICPLANT)//24apr2021
							//if(spell==Unit.MAGICPLANT && Replay.IsPlaying()==false)//24apr2021
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 4;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 4;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 4;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 4;y+=Map.GRIDH)
									{
										//plant trees......
										if(Map.cellunit(x,y)!=Map.VACANT)//24apr2021
										{
											continue;//24apr2021
										}
										if(((x-Game.units[i].x)*(x-Game.units[i].x)+(y-Game.units[i].y)*(y-Game.units[i].y))<(Map.GRIDW*Map.GRIDW*8*8))
										{
											if(Functions.rand(0,1000)<200)
											{
												Map.planttree(x,y);
											}
										}
										else
										{
											if(((x-Game.units[i].x)*(x-Game.units[i].x)+(y-Game.units[i].y)*(y-Game.units[i].y))<(Map.GRIDW*Map.GRIDW*10*10))
											{
												if(Functions.rand(0,1000)<100)
												{
													Map.planttree(x,y);
												}
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICSHIELD)
							{
								//add +2 to all friendly units within spellcaster * 3 grid squares to their DEF values....
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(Game.units[i].notabuffer>0 && nid!=i)//15apr2021
										{
											continue;
										}
										if(nid!=-1)
										{
											if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0)
											{
												if(Game.units[nid].armour<4)
												{
													Game.units[nid].armour++;
												}
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GREENSPELL);
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICSTEALTH)
							{
								//set ourselves to stealthy.....
								Game.units[i].stealth=1;
							}
							if(spell==Unit.MAGICSTORM)
							{
								int storms = Game.units[i].spellcaster * 5;
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 5;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 5;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 5;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 5;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=-1)
										{
											if(Game.units[nid].spelldefense>0)//01apr2021
											{
												continue;
											}
											if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].walkspeed>0)
											{
												if(Functions.rand(0,1000)<250)
												{
													//do damage.....
													storms--;
													Game.units[nid].hp-=Game.units[i].spellcaster * 5;
													if(Game.units[nid].onscreen)
													{
														Functions.saveseed();//25apr2021
														if(Functions.rand(0,100)<25)
														{
															Game.units[nid].playvictimhitsound(game,nid);
														}
														Functions.restoreseed();//25apr2021
													}
													//if(Game.units[firetargeti].hp<=0) //20mar2021
													Functions.saveseed();//11apr2021
													int qqq = Functions.rand(0,1000);
													if(storms==Game.units[i].spellcaster*5 - 1 || qqq<200)//11apr2021 qqq
													{
														Functions.restoreseed();//11apr2021
														Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.LIGHTNINGSPELL);
													}
													else
													{
														Functions.restoreseed();//11apr2021
													}
													Map.setonfire(x,y,false);
													if(Game.units[nid].hp<=0)//20mar2021
													{
														Game.killed(game,nid);
														Game.templates[Game.units[i].templateid].kills++;
													}						
													
												}
											}
										}
										if(storms<=0)
										{
											break;
										}
									}
									if(storms<=0)
									{
										break;
									}
								}
							}
							if(spell==Unit.MAGICSWORD)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(Game.units[i].notabuffer>0 && nid!=i)//15apr2021
										{
											continue;
										}
										if(nid!=-1)
										{
											if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].damage>0)
											{
												if(Game.units[nid].damage<10)
												{
													Game.units[nid].damage++;
												}
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GREENSPELL);
											}
										}
									}
								}
							}
							if(spell==Unit.MAGICWIND)
							{
								for(int x=Game.units[i].x - Map.GRIDW * Game.units[i].spellcaster * 3;x<=Game.units[i].x + Map.GRIDW * Game.units[i].spellcaster * 3;x+=Map.GRIDW)
								{
									for(int y=Game.units[i].y - Map.GRIDH * Game.units[i].spellcaster * 3;y<=Game.units[i].y + Map.GRIDH * Game.units[i].spellcaster * 3;y+=Map.GRIDH)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=-1)
										{
											if(Game.units[nid].spelldefense>0)//01apr2021
											{
												continue;
											}
											if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].walkspeed>0 && Game.units[nid].firebullet>0)
											{
												Game.units[nid].misfire++;
												Bullet.createbullet(game,Game.units[i].x,Game.units[i].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.GOODSPELL);
											}
										}
									}
								}
							}
						}
					}
				}
			}
			Functions.restoreseed();
		}
		
///////////////////Method Definition///////////////
		public static void LightningDeath(int x,int y,int strikes)//19oct2021
		{
			for(int gx=x - Map.GRIDW * strikes;gx<=x + Map.GRIDW * strikes;gx+=Map.GRIDW)
			{
				for(int gy=y - Map.GRIDH * strikes;gy<=x + Map.GRIDH * strikes;gy+=Map.GRIDH)
				{
					int nid = Map.cellunit(gx,gy);
					if(nid!=Map.VACANT)
					{
						//unit loses 25% of their basehp
						//50% if it is raining......
						//and we create a lightning blast at the centre of the square....
						int ohp = Game.units[nid].hp;
						Game.units[nid].hp -= Game.units[nid].basehp / 4;
						if(Map.israining)
						{
							Game.units[nid].hp -= Game.units[nid].basehp / 4;
						}
						if(ohp>0 && Game.units[nid].hp<=0)
						{
							Game.killed(null,nid);
						}
						Bullet.createbullet(null,x,y,gx,gy,Bullet.LIGHTNINGSPELL);
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void Formation(Game game,int formation)
		{
			//apply a formation to the selected units
			//formation comes from Gui....
			int centrex = -1;
			int centrey = -1;
			int count = 0;
			int sumx = 0;
			int sumy = 0;
			int diffx = 0;
			int diffy = 0;
			int index = 0;
			int leadercount = 0;
			int paniccount = 0;
			int timidcount = 0;
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			Game.HORIZONTALFORMATION = 0; //14apr2021
			Game.VERTICALFORMATION = 0; //14apr2021
			bool isai = false;//17apr2021
			if(formation<0)//17apr2021
			{
				formation*=-1;
				isai = true;
			}
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0 && Game.units[i].walkspeed>0 && ((Game.units[i].faction==Game.PLAYERFACTION && Game.units[i].selected!=Unit.SELECTIONNONE) || (Game.units[i].faction!=Game.PLAYERFACTION && isai==true && Game.units[i].aiselectframe==Game.frame)))
				{
					count++;
					sumx+=Game.units[i].x;
					sumy+=Game.units[i].y;
					centrex=sumx/count;
					centrey=sumy/count;
					if(Game.units[i].retreat)
					{
						paniccount++;
					}
					if(Game.units[i].leader>0)
					{
						leadercount++;
					}
					if(Game.units[i].timid>0)
					{
						timidcount++;
					}
				}
			}
			if(centrex==-1)
			{
				return;
			}
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			Functions.saveseed(Functions.seed);
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0 && Game.units[i].walkspeed>0 && Game.units[i].faction==Game.PLAYERFACTION && Game.units[i].selected!=Unit.SELECTIONNONE)
				{
					index++;
					diffx = Game.units[i].x - centrex;
					diffy = Game.units[i].y - centrey;
					if(formation!=Gui.ACTION_RALLY)
					{
						Game.units[i].defendx = -1;
						Game.units[i].defendy = -1;
						Game.units[i].orderframe = Unit.ORDERTIME;
						Game.units[i].firetargeti = -1;
						Game.units[i].tmptattempts = 0;
						Game.ordergivenframe = Game.frame;
					}
					if(formation==Gui.ACTION_CLOSE)
					{
						Game.units[i].tx = Game.units[i].x - diffx / 2;
						Game.units[i].ty = Game.units[i].y - diffy / 2;
					}
					if(formation==Gui.ACTION_DEFEND)
					{
						Game.units[i].defendx = Game.units[i].x;
						Game.units[i].defendy = Game.units[i].y;
					}
					if(formation==Gui.ACTION_ENGAGE)
					{
						Game.units[i].defendx = -1;
						Game.units[i].defendy = -1;
					}
					if(formation==Gui.ACTION_LINEH)
					{
						Game.units[i].tx = centrex + (index - count/2) * Map.GRIDW;
						Game.units[i].ty = centrey;
						Game.HORIZONTALFORMATION++; //14apr2021
						Game.units[i].formationx = Game.units[i].tx - centrex;//14apr2021
						Game.units[i].formationy = Game.units[i].ty - centrey;//14apr2021
					}
					if(formation==Gui.ACTION_LINEV)
					{
						Game.VERTICALFORMATION++; //14apr2021
						Game.units[i].tx = centrex;
						Game.units[i].ty = centrey + (index - count/2) * Map.GRIDH;
						Game.units[i].formationx = Game.units[i].tx - centrex;//14apr2021
						Game.units[i].formationy = Game.units[i].ty - centrey;//14apr2021
					}
					if(formation==Gui.ACTION_RALLY)
					{
						int dieroll = Functions.rand(0,100) - paniccount * 3 - timidcount + leadercount * 25;
						if(dieroll > RALLYORDERCHANCE)
						{
							Game.units[i].retreat = false;
							Game.units[i].retreatframe = 0;
							Game.units[i].timid = 0;
						}
					}
					if(formation==Gui.ACTION_OPEN)
					{
						Game.units[i].tx = Game.units[i].x + diffx;
						Game.units[i].ty = Game.units[i].y + diffy;
					}
				}
			}
			Functions.restoreseed();
		}
		//end---------------//9mar2021

///////////////////Method Definition///////////////
		public static int gettemplate(Game game,int index,int step,int depth)
		{
			//used for the bestiary going forwards and backwards through the list
			depth++;
			int its = 0;
			if(depth>Game.templates.Length + 2)
			{
				return 0;
			}
			index+=step;
			if(index>=Game.templates.Length)
			{
				index = 0;
			}
			if(index<0)
			{
				index = Game.templates.Length - 1;
			}
			if(step>0)
			{
				while(Game.templates[index].faction==Unit.NULLFACTION)
				{
					index++;
					index%=Game.templates.Length;
					its++;
					if(its>10000)
					{
						break;
					}
				}
			}
			if(step<0)
			{
				while(Game.templates[index].faction==Unit.NULLFACTION)
				{
					index--;
					if(index<0)
					{
						index = Game.templates.Length - 1;
					}
					index%=Game.templates.Length;
					its++;
					if(its>10000)
					{
						break;
					}
				}
			}
			return index;
		}

///////////////////Method Definition///////////////
		public static int findtemplatebyname(Game game,string name) //2sep2021
		{
			for(int i=0;i<Game.templates.Length;i++)
			{
				if(name==Game.templates[i].name)
				{
					return i;
				}
			}
			return -1;
		}
		
///////////////////Method Definition///////////////
		public static string[] gettemplatetext(Game game, int uid)
		{
			//used for displaying the informational text about a creature/unit
			string[] uline = new string[4];
			int j = 0;
			for(int i=0;i<4;i++)
			{
				uline[i] = "";
			}
			//13mar2021 lots of translation stuff goes in here.....
			if(Game.templates[uid].stealth>0)
			{
				uline[j] = Translation.TranslateWord("stealth",false);//"Stealth";
			}
			if(Game.templates[uid].healer>0)
			{
				uline[j]+= " "+Translation.TranslateWord("heal",false);//" Heal";
			}
			if(Game.templates[uid].regeneration>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("regeneration",false);//Regeneration";
			}
			if(Game.templates[uid].firespell>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("firespell",false);//Flames";
			}
			if(Game.templates[uid].zombiemaster>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("zombiemaster",false);//
			}
			if(Game.templates[uid].banish>0) //12mar2021
			{
				uline[j]+=" "+ Translation.TranslateWord("banishment",false);//
			}
			if(Game.templates[uid].damagex>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("damagex",false);//
			}
			if(Game.templates[uid].retreat)
			{
				uline[j]+=" "+Translation.TranslateWord("panic",false);//" PANIC!";
			}
			if(Game.templates[uid].timid>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("timid",false);//
			}
			if(Game.templates[uid].hitandrun>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("hitandrun",false);//
			}
			//if(Game.templates[uid].brave>0)//7mar2021
			if(Game.templates[uid].brave>0 && Game.templates[uid].mob<=0 && Game.templates[uid].hatred<=0)//7mar2021
			{
				uline[j]+=" "+ Translation.TranslateWord("brave",false);//
			}
			//start-------------//7mar2021
			if(Game.templates[uid].mob>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("mob",false);//
			}
			if(Game.templates[uid].hatred>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("hatred",false);//
			}
			if(Game.templates[uid].craftsman>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("craftsman",false);//
			}
			if(Game.templates[uid].planar>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("planar",false);//
			}
			if(Game.templates[uid].animosity>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("animosity",false);//
			}
			if(Game.templates[uid].slow>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("slow",false);//
			}
			if(Game.templates[uid].woodsman>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("woodsman",false);//
			}
			if(Game.templates[uid].stupid>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("stupid",false);//
			}
			if(Game.templates[uid].frenzy>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("frenzy",false);//
			}
			//end---------------//7mar2021
			//start-----------//25Feb2021
			if(Game.templates[uid].highfirerate>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("highfirerate",false);//
			}
			//end-------------//25Feb2021
			if(Game.templates[uid].shock>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("shocktroops",false);//
			}
			if(Game.templates[uid].fearsome>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("fearsome",false);//
			}
			if(Game.templates[uid].leader>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("leader",false);//
			}
			//start---------------//12jul2021
			if(Game.templates[uid].bounddemon>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("bounddemon",false);//
			}
			//end-----------------//12jul2021
			if(Game.templates[uid].firerange2>0)
			{
				uline[j]+=" "+ Translation.TranslateWord("damage2",false);//
				j++;
				uline[j]+=" "+ Translation.TranslateWord("secondary damage",false)+" "+Game.templates[uid].damage2;
			}
			if(Game.templates[uid].splash>0) //2sep2021
			{
				uline[j]+=" "+ Translation.TranslateWord("splash",false);
			}
			for(int i=0;i<4;i++)
			{
				uline[i] = uline[i].Trim();
			}
			return uline;
		}

///////////////////Method Definition///////////////
		public static string[] getunittext(Game game,int uid)
		{
			//used for displaying informational text about a game unit or creature
			string[] uline = new string[4];
			for(int i=0;i<4;i++)
			{
				uline[i] = "";
			}
			uline[0] = Game.units[uid].dname();//13mar2021
			//13mar2021 lots of translation stuff going on here...
			int j = 1;
			string bhp = ""+Game.units[uid].basehp;
			if(Game.units[uid].basehp>5000)
			{
				bhp = " "+ Translation.TranslateWord("NA",true);//;
			}
			uline[j] = Translation.TranslateWord("basehp",true)+":"+bhp+" "+Translation.TranslateWord("walkspeed",true)+":"+Game.units[uid].walkspeed;
			j++;
			uline[j] = Translation.TranslateWord("damage",true)+":"+Game.units[uid].damage + " " + Translation.TranslateWord("armour",true)+":"+Game.units[uid].armour;
			if(Game.units[uid].armour>10000)
			{
				uline[j] = "";//"Att:(NA) Def:(NA)";
			}
			j++;
			if(Game.units[uid].stealth>0)
			{
				uline[j] = Translation.TranslateWord("stealth",true);//"Stealth";
			}
			if(Game.units[uid].healer>0)
			{
				uline[j]+=" "+Translation.TranslateWord("heal",true);//Heal";
			}
			if(Game.units[uid].regeneration>0)
			{
				uline[j]+=" "+Translation.TranslateWord("regeneration",true);//" Regen.";
			}
			if(Game.units[uid].firespell>0)
			{
				uline[j]+=" "+Translation.TranslateWord("firespell",true);//" Flames";
			}
			if(Game.units[uid].zombiemaster>0)
			{
				uline[j]+=" "+Translation.TranslateWord("zombiemaster",true);//" Summoner";
			}
			if(Game.units[uid].banish>0) //12mar2021
			{
				uline[j]+=" "+Translation.TranslateWord("banishment",true);//" Banishment";
			}
			if(Game.units[uid].damagex>0)
			{
				uline[j]+=" "+Translation.TranslateWord("damagex",true);//" Ignore Def";
			}
			if(Game.units[uid].retreat)
			{
				uline[j]+=" "+Translation.TranslateWord("panic",true);//" PANIC!";
			}
			if(Game.units[uid].timid>0)
			{
				uline[j]+=" "+Translation.TranslateWord("timid",true);//" Timid";
			}
			if(Game.units[uid].hitandrun>0)
			{
				uline[j]+=" "+Translation.TranslateWord("hitandrun",true);//;
			}
			//if(Game.units[uid].brave>0)//7mar2021
			if(Game.units[uid].brave>0 && Game.units[uid].mob<=0 && Game.units[uid].hatred<=0)//7mar2021
			{
				uline[j]+=" "+Translation.TranslateWord("brave",true);//" Brave";
			}
			//start-------------//7mar2021
			if(Game.units[uid].mob>0)
			{
				uline[j]+=" "+Translation.TranslateWord("mob",true);//" Mob";
			}
			if(Game.units[uid].hatred>0)
			{
				uline[j]+=" "+Translation.TranslateWord("hatred",true);//" Hatred";
			}
			if(Game.units[uid].craftsman>0)
			{
				uline[j]+=" "+Translation.TranslateWord("craftsman",true);//" Craftsman";
			}
			if(Game.units[uid].planar>0)
			{
				uline[j]+=" "+Translation.TranslateWord("planar",true);//" Planar";
			}
			if(Game.units[uid].animosity>0)
			{
				uline[j]+=" "+Translation.TranslateWord("animosity",true);//" Animosity";
			}
			if(Game.units[uid].slow>0)
			{
				uline[j]+=" "+Translation.TranslateWord("slow",true);//" Shambling";
			}
			if(Game.units[uid].woodsman>0)
			{
				uline[j]+=" "+Translation.TranslateWord("woodsman",true);//" Woodsman";
			}
			if(Game.units[uid].stupid>0)
			{
				uline[j]+=" "+Translation.TranslateWord("stupid",true);//" Stupid";
			}
			if(Game.units[uid].frenzy>0)
			{
				uline[j]+=" "+Translation.TranslateWord("frenzy",true);//" Frenzy";
			}
			//end---------------//7mar2021
			//start-----------//25Feb2021
			if(Game.units[uid].highfirerate>1) //NOTE special > 1....it changes from 0 to 1 and 1 to 2 in the actionattack method.
			{
				uline[j]+=" "+Translation.TranslateWord("highfirerate",true);//" Fast Shot";
			}
			//end-------------//25Feb2021
			if(Game.units[uid].shock>0)
			{
				uline[j]+=" "+Translation.TranslateWord("shocktroops",true);//" Shock";
			}
			if(Game.units[uid].fearsome>0)
			{
				uline[j]+=" "+Translation.TranslateWord("fearsome",true);//" Fearsome";
			}
			if(Game.units[uid].leader>0)
			{
				uline[j]+=" "+Translation.TranslateWord("leader",true);//" Leader";
			}
			//start---------------//12jul2021
			if(Game.units[uid].bounddemon>0)
			{
				uline[j]+=" "+Translation.TranslateWord("bounddemon",true);//Bound Demon
			}
			//end-----------------//12jul2021
			if(Game.units[uid].firerange2>0)
			{
				uline[j]+=" "+Translation.TranslateWord("damage2",true);//" Multi Att";
			}
			if(Game.units[uid].splash>0)//2sep2021
			{
				uline[j]+= " " + Translation.TranslateWord("splash",true);//Splash Damage
			}
			for(int i=0;i<4;i++)
			{
				uline[i] = uline[i].Trim();
			}
			return uline;
		}

///////////////////Method Definition///////////////
		public void checkxp(Game game)
		{
			//not used
			if(xp>=levelxp && levelxp>0)
			{
				//level up......
				xp = 0;
			}
		}

///////////////////Method Definition///////////////
		public void playattacksound(Game game, int i)
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play the sound when a unit makes an attack, melee or ranged
			int count = 0;
			for(int a=0;a<Game.units[i].attackfx.Length;a++)
			{
				if(Game.units[i].attackfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].attackfx.Length;a++)
				{
					if(Game.units[i].attackfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].attackfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void playselectsound(Game game, int i)
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play this sound when a unit is selected
			int count = 0;
			for(int a=0;a<Game.units[i].selectfx.Length;a++)
			{
				if(Game.units[i].selectfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].selectfx.Length;a++)
				{
					if(Game.units[i].selectfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].selectfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void playtargetchosensound(Game game, int i)
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play this sound when a unit finds a target to attack
			int count = 0;
			for(int a=0;a<Game.units[i].targetfx.Length;a++)
			{
				if(Game.units[i].targetfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].targetfx.Length;a++)
				{
					if(Game.units[i].targetfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].targetfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void playmagicsound(Game game,int i)
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play this sound when a unit casts a magic spell
			int count = 0;
			for(int a=0;a<Game.units[i].magicfx.Length;a++)
			{
				if(Game.units[i].magicfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].magicfx.Length;a++)
				{
					if(Game.units[i].magicfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].magicfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void playacknowledgesound(Game game,int i)
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play this sound when a unit is given an order
			int count = 0;
			for(int a=0;a<Game.units[i].ackfx.Length;a++)
			{
				if(Game.units[i].ackfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].ackfx.Length;a++)
				{
					if(Game.units[i].ackfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].ackfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void playdeathsound(Game game,int i) //28jul2021
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play this sound when a unit is given an order
			int count = 0;
			for(int a=0;a<Game.units[i].deathfx.Length;a++)
			{
				if(Game.units[i].deathfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].deathfx.Length;a++)
				{
					if(Game.units[i].deathfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].deathfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

		///////////////////Method Definition///////////////
		public void playvictimhitsound(Game game,int i)
		{
			if(Game.demomode)//17sep2021
			{
				return;
			}
			//play this sound when the unit is struck by something
			int count = 0;
			for(int a=0;a<Game.units[i].impactfx.Length;a++)
			{
				if(Game.units[i].impactfx[a]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				count = 1 + (Functions.rand(0,1000)%count);
				for(int a=0;a<Game.units[i].impactfx.Length;a++)
				{
					if(Game.units[i].impactfx[a]!=-1)
					{
						count--;
						if(count<=0)
						{
							Audios.playsound(Game.audios[Game.units[i].impactfx[a]],Game.FXVOLUME);
							break;
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void shocktarget(Game game,int tid)
		{
			//used when a shock trooper hits another unit, to determine if they flee etc
			if(Game.units[tid].shocked && fearsome<=0)
			{
				return;
			}
			//27mar2021 units without 'brave' are slightly braver against shock and fear than they were before....
			//start---------------//27mar2021
			int countfriend = Map.countfactionneighbours(game,Game.units[tid].x,Game.units[tid].y,Game.units[tid].faction);
			int tmpbrave = 0;
			if(countfriend>=3) 
			{
				//in other words if we have at least two buddies next to us....we're a little braver....
				//it also lessens the ability of single shock troops from terrorising whole armies....
				tmpbrave = 1;
			}
			//end-----------------//27mar2021
			//if(Game.units[tid].brave>0)//27mar2021
			if(Game.units[tid].brave>0 || tmpbrave>0)//27mar2021
			{
				if(Functions.rand(0,1000)<850)
				{
					return;
				}
			}
			Game.units[tid].shocked = true;
			if(Functions.rand(0,1000)<500)
			{
				Game.units[tid].timid=1;
			}
			if(Functions.rand(0,1000)<500)
			{
				Game.units[tid].firetargeti = -1;
			}
			if(Functions.rand(0,1000)<100)
			{
				Game.units[tid].retreat = true;
				Game.units[tid].retreatframe = Game.frame + (60 * 20);
				//Game.units[tid].tx = Game.units[tid].x + (int)(Functions.rand(-500,500));
				//Game.units[tid].ty = Game.units[tid].y + (int)(Functions.rand(-500,500));
				//Game.units[tid].tmptx = Game.units[tid].tx;
				//Game.units[tid].tmpty = Game.units[tid].ty;
				//Game.units[tid].orderframe = Unit.ORDERTIME;
			}
		}

///////////////////Method Definition///////////////
		public void actionattack(Game game)
		{
			//base attack method that handles the whole process of
			//attacking other units
			//basic attack
			//
			//
			//
			int framecheck = 60;
			if(Config.RUNNINGSPEED>90)
			{
				framecheck = 80;
			}
			if(Config.RUNNINGSPEED>110)
			{
				framecheck = 90;
			}
			framecheck/=Config.FASTFRAMECHECK;//14sep2021
			if(hp <= 0)
			{
				return;
			}
			//start-----------//25Feb2021
			if(highfirerate>0)
			{
				if(highfirerate>2)
				{
					highfirerate = 2;
				}
			}
			else
			{
				highfirerate = 1;
			}
			//end-------------//25Feb2021
			if(faction==Unit.NULLFACTION && walkspeed>0)
			{
			}
			if(faction==Unit.NULLFACTION && spawnercount<=0)
			{
				return;
			}
			bool closerange = false;
			int griddist = firerange / Map.GRIDW;
			int griddist2 = firerange2 / Map.GRIDW;
			if(griddist2==0)
			{
				griddist2 = griddist;
			}
			if(firerange2>firerange)
			{
				griddist = firerange2 / Map.GRIDW;
			}
			//start----------//20oct2021
			//if we are on a hill and we are a ranged unit...we get a grid dist which is 
			//2 extra grid squares above normal.......
			if(firebullet>0 && Map.ishill(x,y)==true)
			{
				griddist+=2;
			}
			//end------------//20oct2021
			if(Map.weather==Map.WEATHERCOLD)//7oct2021
			{
				//missile weapons are blown around more in the cold wet weather.....not good for firing arrows.....
				if(firebullet>0)
				{
					griddist*=2;
					griddist/=3;
					griddist2*=2;
					griddist2/=3;
					if(griddist<2)
					{
						griddist = 2;
					}
					if(griddist2<2)
					{
						griddist2 = 2;
					}
					//if(griddist<(Map.GRIDW*3)/2)
					//{
	//					griddist = (Map.GRIDW*3)/2;
					//}
					//if(griddist2<(Map.GRIDW*3)/2)
					//{
	//					griddist2 = (Map.GRIDW*3)/2;
		//			}
				}
			}
			int myx = x / Map.GRIDW;
			int myy = y / Map.GRIDH;
			int enemyx = 0;
			int enemyy = 0;
			int ztmp = -1;
			//if(spawnercount>0 && (Game.frame+id)%(framecheck*spawnertime)==0)//9sep2021
			if(framesleft>0)//9sep2021
			{
				framesleft--;
			}
			if(spawnercount>0 && framesleft==0)//9sep2021
			{
				//if(orderframe>0)
				//{
					//return;
				//}
				framesleft = spawnertime * framecheck;//9sep2021
				for(int j=0;j<Game.templates.Length;j++)
				{
					if(Game.templates[j].name==spawner)
					{
						ztmp = j;
						break;
					}
				}
				if(ztmp!=-1)
				{
					for(int dd=1;dd<4;dd++)
					{
						for(int ex=myx - dd;ex<=myx+dd;ex++)
						{
							for(int ey=myy - dd;ey<=myy + dd;ey++)
							{
								int eid = Map.cellunit(ex*Map.GRIDW,ey*Map.GRIDH);
								if(eid==Map.VACANT)
								{
									//nothing in the cell......
									for(int k=0;k<Game.units.Length;k++)
									{
										if(Game.units[k].hp<=0)
										{
											Game.units[k].createunitatxy(game,k,Game.templates[ztmp],ex * Map.GRIDW,ey * Map.GRIDH);
											Game.units[k].ai = Unit.AI_ASSAULT;
											spawnercount--;
											if(k>Unit.MAXINDEX)
											{
												Unit.MAXINDEX = k;//11apr2021
											}
											return;
										}
									}
								}
							}
						}
					}
				}
				return;
			}
			//start-------------//12mar2021
			if(banish>0 && (Game.frame + id)%(framecheck * 10)==1 && firetargeti!=-1)
			{
				if(orderframe>0)
				{
					return;
				}
				int rr1 = 4;
				bool banished = false;
				//Functions.saveseed();//11apr2021
				for(int ex=myx - rr1;ex<=myx+rr1;ex++)
				{
					for(int ey=myy - rr1;ey<=myy + rr1;ey++)
					{
						int eid1 = Map.cellunit(ex*Map.GRIDW,ey*Map.GRIDH);
						if(eid1!=-1)
						{
							if(Game.units[eid1].zombie>0 && Game.units[eid1].hp>0 && Game.units[eid1].faction!=faction)
							{	
								//this unit killed it..... 
								//d100 check to see if we banish it.....
								if(Functions.rand(0,100+Game.units[eid1].zombie*10)<banish)
								{
									Game.units[eid1].hp=0;
									if(levelxp>0)
									{
										xp+=Game.units[eid1].xpvalue;
										checkxp(game);
									}
									//do death effect.....
									Game.killed(game,eid1);
									Game.templates[templateid].kills++;
									banished = true;
									if(animmode != ANIMMODE_ATTACK)
									{	
										animmode = ANIMMODE_ATTACK;
										animframe = animmodeattframestart;
									}
								}
							}
						}
					}
				}
				//Functions.restoreseed();//11apr2021
				//Functions.saveseed();//11apr2021
				Functions.saveseed();//25apr2021
				if(Functions.rand(0,100)<30 && onscreen==true && banished==true)
				{
					playmagicsound(game,id);
				}
				//Functions.restoreseed();//11apr2021
				Functions.restoreseed();//25apr2021
			}
			//end---------------//12mar2021
			//
			/*Explaining framecheck and Game.frame + id mod....
			///in a second there are 60 frames.
			//if we take the Game.frame and divide it by 60 at any point it will return a remainder of between 0 and 59.
			//if...if we take the Game.frame and add the index or the id of the array element to it, and then do so we will also get a value between 0 and 59.
			//Basically - the size of our framecheck determines the value is being between 0 and framecheck-1
			//By putting the id into 'Game.frame + id' into our mod check...then we ensure that
			//we only check certain units every nth frame...
			*/
			if(zombiemaster>0 && ((Game.frame + id)%(framecheck*10)==0) && firetargeti!=-1)
			{
				if(orderframe>0)
				{
					return;
				}
				int maxzombie = 0;
				for(int j=0;j<Game.templates.Length;j++)
				{
					if(Game.templates[j].zombie<=zombiemaster && Game.templates[j].zombie>0 && Game.templates[j].faction==faction)
					{
						//Game.units[i].createunitatxy(game,i,Game.templates[j],Game.missions[mission].units[i].x,Game.missions[mission].units[i].y);
						if(Game.templates[j].zombie > maxzombie)
						{
							ztmp = j;
							maxzombie = Game.templates[j].zombie;
						//break;
						}
					}
				}
				if(ztmp!=-1)
				{
					int rr = 1;
					//if(Game.skirmish)
					//{
						rr = 4;
					//}
					int mzombiemaster = zombiemaster;//9apr2021
					if(mzombiemaster>4)//9apr2021
					{
						mzombiemaster = 4;//9apr2021
					}
					for(int ex=myx - rr*mzombiemaster*2/maxzombie;ex<=myx+rr*mzombiemaster*2/maxzombie;ex++)
					{
						for(int ey=myy - rr*mzombiemaster*2/maxzombie;ey<=myy + rr*mzombiemaster*2/maxzombie;ey++)
						{
							int eid = Map.cellunit(ex*Map.GRIDW,ey*Map.GRIDH);
							if(eid==-1)
							{
								//nothing in the cell......
								//must have bones in skirmish mode.....
								//if(Game.skirmish==true)
								//{
									if(!Map.dobonesexist(ex * Map.GRIDW, ey*Map.GRIDH))
									{
										continue;
									}
								//}
								for(int k=0;k<Game.units.Length;k++)
								{
									if(Game.units[k].hp<=0)
									{
										Game.units[k].createunitatxy(game,k,Game.templates[ztmp],ex * Map.GRIDW,ey * Map.GRIDH);
										if(NetworkUDP.isserver)
										{
											Game.units[k].wassummoned = 1;
										}
										Map.removebones(ex * Map.GRIDW, ey * Map.GRIDH);
										Blood.makeblood(game,Game.units[k].x,Game.units[k].y+Game.units[k].offy,1);
										if(k>Unit.MAXINDEX) //11apr2021
										{
											Unit.MAXINDEX = k;
										}
										break;
									}
								}
							}
						}
					}
					//Functions.saveseed();//11apr2021
					Functions.saveseed();//25apr2021
					if(Functions.rand(0,100)<30 && onscreen==true)
					{
						playmagicsound(game,id);
					}
					Functions.restoreseed();//25apr2021
					//Functions.restoreseed();//11apr2021
				}
				return;
			}
			//start------------//19mar2021
			if(spellcaster>0)
			{
				if(orderframe>0)
				{
					return;
				}
				//start---------------//28mar2021
				if((Game.frame + id + 30)%framecheck*SPELLCHECK==0 && Game.SPELLSACTIVE==true)
				{
					//if(faction!=Game.PLAYERFACTION)//13oct2021
					//{
						//if(onscreen) //replace with ronscreen from replay......25apr2021
						if((onscreen==true && Replay.IsPlaying()==false) || (ronscreen==true && Replay.IsPlaying()==true)) //replace with ronscreen from replay......25apr2021
						{
							//we're an ai unit on screen......about to cast a magic spell.....
							if(firetargeti!=-1)
							{
								//and we have a target....
								//Functions.saveseed();//11apr2021
								int magicspell = (int)Functions.abs(Functions.rand(0,1000)) % 9;
								if(magicarray[magicspell]>0)
								{
									//yep we've got a spell ready....
									if(casting==false)
									{
										//////
										orderframe = Unit.ORDERTIME;
										casting = true;
										Unit.SpellCast(game,magicarray[magicspell],faction);
										casting = false;
									}
								}
								//Functions.restoreseed();//11apr2021
							}
						}
					//}
					//13oct2021 - we will jump out of this as we don't want the other spell stuff to fire......
					//not the best method but it works.....
					return;//13oct2021
				}
				//end-----------------//28mar2021
				if((Game.frame + id)%framecheck*SPELLCHECK==0 && notabuffer==0) //once per six seconds....
				{
					//pick a random location within firerange units.....
					//Functions.saveseed();//11apr2021
					int rndx = (int)Functions.rand(x - firerange,x + firerange);
					int rndy = (int)Functions.rand(y - firerange,y + firerange);
					int rndid = Map.cellunit(rndx,rndy);
					bool rbuffed = false;
					if(rndid!=-1)
					{
						int ddx = 0;
						int ddy = 0;
						if(Game.units[rndid].faction!=faction && rndid!=id && Game.units[rndid].hp>0 && Game.units[rndid].armour>0 && Game.units[rndid].walkspeed>0) //curse an enemy
						{
							//we should buff it....if it is performing animmode==ANIMMODE_ATTACK
							if(Game.units[rndid].animmode==ANIMMODE_ATTACK && Game.units[rndid].armour>0)
							{
								Game.units[rndid].armour-=spellcaster;
								Game.units[rndid].cursed = true; //21mar2021
								if(Game.units[rndid].armour<0)
								{
									Game.units[rndid].armour=0;
								}
								rbuffed = true;
								//fire a green ball of flame at the friendly unit.....
								Bullet.createbullet(game,x,y+offy,Game.units[rndid].x,Game.units[rndid].y+Game.units[rndid].offy,Bullet.REDSPELL);
								if(animmode != ANIMMODE_ATTACK)
								{
									animmode = ANIMMODE_ATTACK;
									animframe = animmodeattframestart;
								}
							}
							ddx = Functions.sign(rndx - x);
							ddy = Functions.sign(rndy - y);
							odirn = dirn;
							if(dirntime>0)
							{
								dirntime--;
							}
							if(dirntime<=0)
							{
								dirntime = Unit.DIRNDELAY;
								if(ddx==0)
								{
									if(ddy>0)
									{
										dirn = DIRN_DOWN;
									}
									else
									{
										dirn = DIRN_UP;
									}
								}
								if(ddy==0)
								{
									if(ddx>0)
									{
										dirn = DIRN_RIGHT;
									}
									else
									{
										dirn = DIRN_LEFT;
									}
								}
								if(ddx!=0 && ddy!=0)
								{
									if(ddx==-1 && ddy==-1)
									{
										dirn = DIRN_UPLEFT;
									}
									if(ddx==-1 && ddy==1)
									{
										dirn = DIRN_DOWNLEFT;
									}
									if(ddx==1 && ddy==-1)
									{
										dirn = DIRN_UPRIGHT;
									}
									if(ddx==1 && ddy==1)
									{
										dirn = DIRN_DOWNRIGHT;
									}
								}
							}
						
						}
						if(Game.units[rndid].faction==faction && rndid!=id && Game.units[rndid].hp>0 && Game.units[rndid].damage>0 && Game.units[rndid].walkspeed>0) //buff a friend.....
						{
							//unit is alive and part of our faction.....
							//therefore.....
							//we should buff it....if it is performing animmode==ANIMMODE_ATTACK
							if(Game.units[rndid].animmode==ANIMMODE_ATTACK && Game.units[rndid].damage<MAXBUFFATT)
							{
								Game.units[rndid].damage+=spellcaster;
								Game.units[rndid].buffed = true;//21mar2021
								rbuffed = true;
								//fire a green ball of flame at the friendly unit.....
								Bullet.createbullet(game,x,y+offy,Game.units[rndid].x,Game.units[rndid].y+Game.units[rndid].offy,Bullet.GREENSPELL);
								if(animmode != ANIMMODE_ATTACK)
								{
									animmode = ANIMMODE_ATTACK;
									animframe = animmodeattframestart;
								}
							}
							ddx = Functions.sign(rndx - x);
							ddy = Functions.sign(rndy - y);
							odirn = dirn;
							if(dirntime>0)
							{
								dirntime--;
							}
							if(dirntime<=0)
							{
								dirntime = Unit.DIRNDELAY;
								if(ddx==0)
								{
									if(ddy>0)
									{
										dirn = DIRN_DOWN;
									}
									else
									{
										dirn = DIRN_UP;
									}
								}
								if(ddy==0)
								{
									if(ddx>0)
									{
										dirn = DIRN_RIGHT;
									}
									else
									{
										dirn = DIRN_LEFT;
									}
								}
								if(ddx!=0 && ddy!=0)
								{
									if(ddx==-1 && ddy==-1)
									{
										dirn = DIRN_UPLEFT;
									}
									if(ddx==-1 && ddy==1)
									{
										dirn = DIRN_DOWNLEFT;
									}
									if(ddx==1 && ddy==-1)
									{
										dirn = DIRN_UPRIGHT;
									}
									if(ddx==1 && ddy==1)
									{
										dirn = DIRN_DOWNRIGHT;
									}
								}
							}
						}
					}
					//Functions.restoreseed();//11apr2021
					if(rbuffed)
					{
						return;
					}
				}
			}
			//end--------------//19mar2021
			if(healer>0)
			{
				if(orderframe>0)
				{
					return;
				}
				bool bounddemonhelped = false; //12jul2021
				if((Game.frame + id)%framecheck==0)
				{
					//bool madeeffect = false;
					for(int ex=myx - healer*2;ex<=myx+healer*2;ex++)
					{
						for(int ey=myy - healer*2;ey<=myy + healer*2;ey++)
						{
							int eid = Map.cellunit(ex*Map.GRIDW,ey*Map.GRIDH);
							if(eid!=-1)
							{
								//start-------------------------//12jul2021
								if(Game.units[eid].faction==faction && eid!=id && Game.units[eid].bounddemon<Game.templates[Game.units[eid].templateid].bounddemon && Game.units[eid].bounddemon>1 && Game.units[eid].hp>0 && bounddemonhelped == false)
								{
									Game.units[eid].bounddemon+=1;
									//magic users with healing can prevent bound demons from turning against everyone.....the more you have the better.....
									bounddemonhelped = true;
								}
								//end---------------------------//12jul2021
								if(Game.units[eid].faction==faction && eid!=id && Game.units[eid].hp<Game.units[eid].basehp && Game.units[eid].hp>0)
								{
									//ie friend in adjacent or near adjacent square
									//with less than full health.....
									Game.units[eid].hp+=healer;
									//Blood.makeblood(game,Game.units[eid].x,Game.units[eid].y,1);
									//if(!madeeffect)
									//{
										//Blood.makeblood(game,x,y,1);
									//	madeeffect = true;
									//}
									if(Game.units[eid].hp>Game.units[eid].basehp)
									{
										Game.units[eid].hp=Game.units[eid].basehp;
									}
									if(animmode != ANIMMODE_ATTACK)
									{
										animmode = ANIMMODE_ATTACK;
										animframe = animmodeattframestart;
									}
									int ddx = Functions.sign(ex - myx);
									int ddy = Functions.sign(ey - myy);
									odirn = dirn;
									if(dirntime>0)
									{
										dirntime--;
									}
									if(dirntime<=0)
									{
										dirntime = Unit.DIRNDELAY;
										if(ddx==0)
										{
											if(ddy>0)
											{
												dirn = DIRN_DOWN;
											}
											else
											{
												dirn = DIRN_UP;
											}
										}
										if(ddy==0)
										{
											if(ddx>0)
											{
												dirn = DIRN_RIGHT;
											}
											else
											{
												dirn = DIRN_LEFT;
											}
										}
										if(ddx!=0 && ddy!=0)
										{
											if(ddx==-1 && ddy==-1)
											{
												dirn = DIRN_UPLEFT;
											}
											if(ddx==-1 && ddy==1)
											{
												dirn = DIRN_DOWNLEFT;
											}
											if(ddx==1 && ddy==-1)
											{
												dirn = DIRN_UPRIGHT;
											}
											if(ddx==1 && ddy==1)
											{
												dirn = DIRN_DOWNRIGHT;
											}
										}
									}
								}
							}
						}
					}
				}
				if(firebullet==0){return;}
			}
			if(firetargeti!=-1)
			{
				//current target
				if(Game.units[firetargeti].hp > 0)
				{
					//check if we are in range.......
					enemyx = Game.units[firetargeti].x / Map.GRIDW;
					enemyy = Game.units[firetargeti].y / Map.GRIDH;
					//if(Functions.abs(myx - enemyx)<= griddist && Functions.abs(myy - enemyy)<= griddist)//6oct2021
					if(Functions.abs(myx - enemyx)<= griddist && Functions.abs(myy - enemyy)<= griddist && retreat==false)//6oct2021
					{
						//we can attack
						if(Functions.abs(myx - enemyx)<= griddist && Functions.abs(myy - enemyy)<= griddist2)
						{
							closerange = true;
						}
						if(closerange)
						{
							if(animmode != ANIMMODE_ATTACK)
							{
								animmode = ANIMMODE_ATTACK;
								animframe = animmodeattframestart;
							}
						}
						else
						{
							if(animmode != ANIMMODE_ATTACK2)
							{
								animmode = ANIMMODE_ATTACK2;
								animframe = animmodeatt2framestart;
							}	
						}
						int ddx = Functions.sign(enemyx - myx);
						int ddy = Functions.sign(enemyy - myy);
						odirn = dirn;
						if(dirntime>0)
						{
							dirntime--;
						}
						if(dirntime<=0)
						{
							dirntime = Unit.DIRNDELAY;
							if(ddx==0)
							{
								if(ddy>0)
								{
									dirn = DIRN_DOWN;
								}
								else
								{
									dirn = DIRN_UP;
								}
							}
							if(ddy==0)
							{
								if(ddx>0)
								{
									dirn = DIRN_RIGHT;
								}
								else
								{
									dirn = DIRN_LEFT;
								}
							}
							if(ddx!=0 && ddy!=0)
							{
								if(ddx==-1 && ddy==-1)
								{
									dirn = DIRN_UPLEFT;
								}
								if(ddx==-1 && ddy==1)
								{
									dirn = DIRN_DOWNLEFT;
								}
								if(ddx==1 && ddy==-1)
								{
									dirn = DIRN_UPRIGHT;
								}
								if(ddx==1 && ddy==1)
								{
									dirn = DIRN_DOWNRIGHT;
								}
							}
						}
						//if((Game.frame + id) % framecheck==0) //25Feb2021
						if((Game.frame + id) % (framecheck/highfirerate)==0)//25Feb2021
						{
							//once per second attack.....
							//Game.WriteDebug("attacking -have at you!");
							int actualdamage = damage - Game.units[firetargeti].armour;
							//if we are up hill of our opponent get a 25% point bonus to raw damage
							//start------------//20oct2021
							if(Map.ishill(x,y) && !Map.ishill(Game.units[firetargeti].x,Game.units[firetargeti].y))
							{
								if(firebullet<=0)//melee combat
								{
									actualdamage+= damage/4;
								}
							}
							//end--------------//20oct2021
							
							if((Game.frame + id) % WALKMOD>=WALKRATE && firebullet>0)
							{
								actualdamage/=2;
							}
							//start----------//5apr2021
							//Functions.saveseed();//11apr2021
							if(banish>0 && Game.units[firetargeti].zombie>0)
							{
								if(Functions.rand(0,100+Game.units[firetargeti].zombie*10)<banish)
								{
									actualdamage = actualdamage * 4; //+300% damage when a successful banish attack against a zombie creature (summoned)
								}
							}
							if(banish>0 && Game.units[firetargeti].planar>0)
							{
								if(Functions.rand(0,100)<banish)
								{
									actualdamage = actualdamage * 7; //+600% damage when a successful banish attack against a zombie creature (summoned)
								}
							}
							//Functions.restoreseed();//11apr2021
							//end------------//5apr2021
							//start-------------//7mar2021
							if(frenzy>0)
							{
								frenzy--;
								actualdamage+=damage;
							}
							if(Map.weather==Map.WEATHERHOT)//7oct2021
							{
								if(frenzy>0)//in hot weather frenzy doesn't last as long as ferocious units tire more quickly....
								{
									frenzy--;
								}
							}
						
							//end---------------//7mar2021
							if(!closerange && damage2>0)
							{
								actualdamage = damage2 - Game.units[firetargeti].armour;
							}
							//if(damagex>0)//7mar2021
							if(damagex>0 && Game.units[firetargeti].craftsman<=0)//7mar2021
							{
								actualdamage+=Game.units[firetargeti].armour; //ignores enemy armour.....
							}
							if(firespell>0 || Game.units[firetargeti].flammable>0)
							{
								Map.setonfire(Game.units[firetargeti].x,Game.units[firetargeti].y,false);
							}
							int extradamage = 0;
							if(powerspell>0)
							{
								if((Game.frame + id) % (framecheck*powerspell)==0)
								{
									extradamage = powerspell;
									actualdamage += extradamage;
								}
							}
							if(shock>0)
							{
								//Functions.saveseed();//11apr2021
								shocktarget(game,firetargeti);
								//Functions.restoreseed();//11apr2021
							}
							//start-------------//7mar2021
							if(Game.units[firetargeti].woodsman>0)
							{
								if(Map.nearobstacle(Game.units[firetargeti].x,Game.units[firetargeti].y))
								{
									actualdamage/=2;
								}
							}
							//end---------------//7mar2021
							if(Map.israining)//15oct2021
							{
								misfire = 1;
							}
							else
							{
								misfire = 0;
							}
							if(firebullet==1 || closerange==false)
							{
								if(extradamage!=0)
								{
									Bullet.createbullet(game,x,y+offy,Game.units[firetargeti].x,Game.units[firetargeti].y+Game.units[firetargeti].offy,powerspell);
								}
								else
								{
									Bullet.createbullet(game,x,y+offy,Game.units[firetargeti].x,Game.units[firetargeti].y+Game.units[firetargeti].offy,firespell);
								}
								//if the target is near woods or other obstacles....then....
								if(Map.nearobstacle(Game.units[firetargeti].x,Game.units[firetargeti].y) || misfire>0)
								{
									actualdamage/=2;
								}
							}
							//Functions.saveseed();//11apr2021
							if(actualdamage<1)
							{
								if(Functions.rand(0,100)<50) //20mar2021
								{
									actualdamage = 0; //20mar2021
								}
								else
								{
									actualdamage = 1;
								}
							}
							if(Game.templates[Game.units[firetargeti].templateid].dodge>1)//21oct2021
							{
								Game.units[firetargeti].dodge++;
								Game.units[firetargeti].dodge%=Game.templates[Game.units[firetargeti].templateid].dodge;
								if(Game.units[firetargeti].dodge==0)
								{
									actualdamage = 0;
								}
							}
							if(splash>0 && actualdamage>0)//2sep2021
							{
								int splashdamage = actualdamage / 2;
								if(splashdamage<=0)
								{
									splashdamage = 1;
								}
								for(int splashx = Game.units[firetargeti].x - Map.GRIDW*splash;splashx<=Game.units[firetargeti].x + Map.GRIDW*splash;splashx+=Map.GRIDW)
								{
									for(int splashy = Game.units[firetargeti].y - Map.GRIDH*splash;splashy<=Game.units[firetargeti].y + Map.GRIDH*splash;splashy+=Map.GRIDH)
									{
										if(Map.cellunit(splashx,splashy)!=Map.VACANT)
										{
											int splashi = Map.cellunit(splashx,splashy);
											if(splashi!=firetargeti)
											{
												Game.units[splashi].hp-=splashdamage;
												if(Game.units[splashi].hp<=0)
												{
													Game.templates[templateid].kills++;
													Game.killed(game,splashi);
													if(extragibbet>0)//18sep2021
													{
														Gibbet.makegibbets(game,splashi);//18sep2021
													}
												}
											}
										}
									}
								}
							}
							Game.units[firetargeti].hp-=actualdamage;
							if(onscreen)
							{
								Functions.saveseed();//25apr2021
								if(Functions.rand(0,100)<25)
								{
									playattacksound(game,id);
								}
								if(Functions.rand(0,100)<25)
								{
									playvictimhitsound(game,firetargeti);
								}
								Functions.restoreseed();//25apr2021
							}
							//Functions.restoreseed();//11apr2021
							//if(Game.units[firetargeti].hp<=0) //20mar2021
							if(Game.units[firetargeti].hp<=0 && actualdamage>0)//20mar2021
							{
								//this unit killed it.....
								if(levelxp>0)
								{
									xp+=Game.units[firetargeti].xpvalue;
									checkxp(game);
								}
								//do death effect.....
								Game.killed(game,firetargeti);
								Game.templates[templateid].kills++;
								if(extragibbet>0)//18sep2021
								{
									Gibbet.makegibbets(game,firetargeti);//18sep2021
								}
								firetargeti = -1;
							}
							if(controlmode=="crpg")//24sep2021
							{
								firetargeti = -1;//deselect target after we've hit them....
								
							}
							if(hitandrun>0)
							{
								//Functions.saveseed();//11apr2021
								if(Functions.rand(0,1000)<150)
								{
									//start-------//15mar2021
									if(firetargeti!=-1)
									{
										tmptattempts = 0;
										tx =  x + (Game.RESOLUTIONX / 3) * (int)Functions.sign(x - Game.units[firetargeti].x);
										ty =  y + (Game.RESOLUTIONY / 3) * (int)Functions.sign(y - Game.units[firetargeti].y);
										tmptx = tx;
										tmpty = ty;
									}
									//end---------//15mar2021
									firetargeti = -1;
									orderframe = 180;//15mar2021
									//retreat = true;//15mar2021
									//retreatframe = Game.frame + Unit.RETREATDEATH;//15mar2021
								}
								//Functions.restoreseed();//11apr2021
							}
						}
					}
					else
					{
						//we should move towards the target
						tx = Game.units[firetargeti].x;
						ty = Game.units[firetargeti].y;
						int adjustx = (((Game.frame + id)/60) % 3) - 1;//15oct2021
						if(Functions.abs(ty-y) > Map.GRIDH * 4)//15oct2021
						{
							tx += adjustx * Map.GRIDW * 4;//15oct2021
						}
						tmptattempts = 0;
						if(retreat)
						{
							tx =  x + Game.RESOLUTIONX * (int)Functions.sign(x - Game.units[firetargeti].x);
							ty =  y + Game.RESOLUTIONY * (int)Functions.sign(y - Game.units[firetargeti].y);
						}
						//if(faction!=Game.PLAYERFACTION && orderframe<=0)//6oct2021
						if(orderframe<=0 && retreat==true)//6oct2021
						{
							firetargeti = -1;
						}
						if(Game.frame % 10==0)//15oct2021
						{
							dist10framesago = (int)(Functions.abs(tx/Map.GRIDW - x/Map.GRIDW) + Functions.abs(ty/Map.GRIDH - y/Map.GRIDH));
						}
						if(Game.frame % 10>=8)//15oct2021
						{
							int distnow = (int)(Functions.abs(tx/Map.GRIDW - x/Map.GRIDW) + Functions.abs(ty/Map.GRIDH - y/Map.GRIDH));
							if(Functions.abs(dist10framesago - distnow)<=2)
							{
								//ie we haven't gotten any closer......
								firetargeti = -1;
							}
						}
						
					}
				}
				else
				{
					firetargeti = -1;
				}
			}
			else
			{
				//no current target
				//find one.....
				if(orderframe>0)
				{
					return;
				}
				if(faction!=Game.PLAYERFACTION && Game.playingtutorial==true)
				{
					return;
				}
				if(controlmode=="crpg")//24sep2021
				{
					return;
				}
				
				if((Game.frame + id) % 3>0)//23oct2021
				{
					return;
				}
			
				//start-----------------------//4may2021
				if(flightlevel!=-1)
				{
					//flying units cannot attack unless they have an anim mode for flying attacks....
					//unless they have an animmodeflyattackframestart!=0
					if(animmodeflyattackframestart==0 && animmodeflyattackframeend==0)
					{
						return;
					}
				}
				//end-------------------------//4may2021
				//start-------------//7mar2021
				if(stupid>0)
				{
					//Functions.saveseed();//11apr2021
					if(stupid>=100)
					{
						stupid=99;
					}
					//if(Functions.rand(0,100)<stupid)//27mar2021
					int qqq0 = Functions.rand(0,100);//11apr2021
					if(qqq0<stupid || ((Game.frame + id) % 101)<stupid)//27mar2021
					{
						return;
					}
				}
				//end---------------//7mar2021
				int aidist = 12;
				//if(ai>=AI_ASSAULT && faction!=Game.PLAYERFACTION && Game.playerready==true)//18sep2021
				//if(ai>=AI_ASSAULT && (faction!=Game.PLAYERFACTION || Config.AUTOPLAY>0) && Game.playerready==true)//18sep2021
				//
				if(Game.RESOLVE>0)
				{
					aidist = 100;
				}
				//}
				//if(Game.skirmish==true && ai>0 && faction!=Game.PLAYERFACTION)//27mar2021//18sep2021
				//if(Game.skirmish==true && ai>0 && (faction!=Game.PLAYERFACTION || Config.AUTOPLAY>0))//27mar2021//18sep2021
				//{
					//aidist = Map.MAXX + Map.MAXY + 10; //27mar2021
				//}
				aidist = 50 + 25 + 10;//23oct2021
				int rangeblock = 1 + ((Game.frame + id) % aidist);
				if(rangeblock>aidist)
				{
					rangeblock = aidist;
				}
				//start-------------//7mar2021
				if(slow>0)
				{
					rangeblock/=2;
				}
				//end---------------//7mar2021
				if(rangeblock<1)
				{
					rangeblock = 1;
				}
				//up to 12 squares away......
				if(stealth>0)
				{
					if (rangeblock>4)
					{
						rangeblock = 1 + (rangeblock % 4);
					}
				}
				int target = -1;
				int mindist = 9999;
				int dist = 0;
				int fl = (Game.frame + id) % Map.FLIGHTLEVELS;//4may2021
				for(int cx=myx - rangeblock;cx<=myx + rangeblock;cx++)
				{
					int cyy = myy - rangeblock;
					target = Map.cellunit(cx * Map.GRIDW,cyy * Map.GRIDH);
					if(target!=-1)
					{
						if(Game.units[target].x / Map.GRIDW == cx && Game.units[target].y / Map.GRIDH == cyy)
						{
							if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
							{
								dist = (int)(Functions.abs(cx - myx) + Functions.abs(cyy - myy));
								if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
								{
									//75% more likely to choose a mobile target....
									dist*=3;
									dist/=4;
									//and they get a 10% higher rating for every point of 'extra speed' they have.....
									//noting that walkspeed is only between 1 and 3 and never as high as 10.
									dist*=(10 - Game.units[target].walkspeed);
									dist/=10;
								}
								if(dist < mindist && dist < (rangeblock + 2) * Map.GRIDW)
								{
									if(needlos>0)//15sep2021
									{
										if(los(game,id,target))
										{
											mindist = dist;
											firetargeti = target;
										}
									}
									else//15sep2021
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}
						}
						target = -1;
					}
					//start---------------------//4may2021
					if(canattackair>0)
					{
						cyy = myy - rangeblock;
						target = Map.cellflyer(cx * Map.GRIDW,cyy * Map.GRIDH,fl);
						if(target!=-1)
						{
							if(Game.units[target].x / Map.GRIDW == cx && Game.units[target].y / Map.GRIDH == cyy)
							{
								if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
								{
									dist = (int)(Functions.abs(cx - myx) + Functions.abs(cyy - myy));
									if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
									{
										//75% more likely to choose a mobile target....
										dist*=3;
										dist/=4;
										//and they get a 10% higher rating for every point of 'extra speed' they have.....
										//noting that walkspeed is only between 1 and 3 and never as high as 10.
										dist*=(10 - Game.units[target].walkspeed);
										dist/=10;
									}
									if(dist < mindist && dist < (rangeblock + 2) * Map.GRIDW)
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}
							target = -1;
						}
						cyy = myy + rangeblock;
						target = Map.cellflyer(cx * Map.GRIDW,cyy * Map.GRIDH,fl);
						if(target!=-1)
						{
							if(Game.units[target].x / Map.GRIDW == cx && Game.units[target].y / Map.GRIDH == cyy)
							{
								if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
								{
									dist = (int)(Functions.abs(cx - myx) + Functions.abs(cyy - myy));
									if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
									{
										//75% more likely to choose a mobile target....
										dist*=3;
										dist/=4;
										//and they get a 10% higher rating for every point of 'extra speed' they have.....
										//noting that walkspeed is only between 1 and 3 and never as high as 10.
										dist*=(10 - Game.units[target].walkspeed);
										dist/=10;
									}
									if(dist < mindist && dist < (rangeblock + 2) * Map.GRIDW)
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}
							target = -1;
						}
					}
					//end-----------------------//4may2021
					cyy = myy + rangeblock;
					target = Map.cellunit(cx * Map.GRIDW,cyy * Map.GRIDH);
					if(target!=-1)
					{
						if(Game.units[target].x / Map.GRIDW == cx && Game.units[target].y / Map.GRIDH == cyy)
						{
							if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
							{
								dist = (int)(Functions.abs(cx - myx) + Functions.abs(cyy - myy));
								if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
								{
									//75% more likely to choose a mobile target....
									dist*=3;
									dist/=4;
									//and they get a 10% higher rating for every point of 'extra speed' they have.....
									//noting that walkspeed is only between 1 and 3 and never as high as 10.
									dist*=(10 - Game.units[target].walkspeed);
									dist/=10;
								}
								if(dist < mindist  && dist < (rangeblock + 2) * Map.GRIDW)
								{
									if(needlos>0)//15sep2021
									{
										if(los(game,id,target))
										{
											mindist = dist;
											firetargeti = target;
										}
									}
									else//15sep2021
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}
						}
					}
					target = -1;
				}
				for(int cy=myy - rangeblock;cy<=myy + rangeblock;cy++)
				{
					int cxx = myx - rangeblock;
					target = Map.cellunit(cxx * Map.GRIDW,cy * Map.GRIDH);
					if(target!=-1)
					{
						if(Game.units[target].x / Map.GRIDW == cxx && Game.units[target].y / Map.GRIDH == cy)
						{
							if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
							{
								dist = (int)(Functions.abs(cxx - myx) + Functions.abs(cy - myy));
								if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
								{
									//75% more likely to choose a mobile target....
									dist*=3;
									dist/=4;
									//and they get a 10% higher rating for every point of 'extra speed' they have.....
									//noting that walkspeed is only between 1 and 3 and never as high as 10.
									dist*=(10 - Game.units[target].walkspeed);
									dist/=10;
								}
								if(dist < mindist  && dist < (rangeblock + 2) * Map.GRIDW)
								{
									if(needlos>0)//15sep2021
									{
										if(los(game,id,target))
										{
											mindist = dist;
											firetargeti = target;
										}
									}
									else//15sep2021
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}
						}
						target = -1;						
					}
					//start-----------------------//4may2021
					if(canattackair>0)
					{
						cxx = myx - rangeblock;
						target = Map.cellflyer(cxx * Map.GRIDW,cy * Map.GRIDH,fl);
						if(target!=-1)
						{
							if(Game.units[target].x / Map.GRIDW == cxx && Game.units[target].y / Map.GRIDH == cy)
							{
								if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
								{
									dist = (int)(Functions.abs(cxx - myx) + Functions.abs(cy - myy));
									if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
									{
										//75% more likely to choose a mobile target....
										dist*=3;
										dist/=4;
										//and they get a 10% higher rating for every point of 'extra speed' they have.....
										//noting that walkspeed is only between 1 and 3 and never as high as 10.
										dist*=(10 - Game.units[target].walkspeed);
										dist/=10;
									}
									if(dist < mindist  && dist < (rangeblock + 2) * Map.GRIDW)
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}						
						}
						target = -1;
						cxx = myx + rangeblock;
						target = Map.cellflyer(cxx * Map.GRIDW,cy * Map.GRIDH,fl);
						if(target!=-1)
						{
							if(Game.units[target].x / Map.GRIDW == cxx && Game.units[target].y / Map.GRIDH == cy)
							{
								if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
								{
									dist = (int)(Functions.abs(cxx - myx) + Functions.abs(cy - myy));
									if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
									{
										//75% more likely to choose a mobile target....
										dist*=3;
										dist/=4;
										//and they get a 10% higher rating for every point of 'extra speed' they have.....
										//noting that walkspeed is only between 1 and 3 and never as high as 10.
										dist*=(10 - Game.units[target].walkspeed);
										dist/=10;
									}
									if(dist < mindist  && dist < (rangeblock + 2) * Map.GRIDW)
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}						
						}
						target = -1;
					}
					//end-------------------------//4may2021
					cxx = myx + rangeblock;
					target = Map.cellunit(cxx * Map.GRIDW,cy * Map.GRIDH);
					if(target!=-1)
					{
						if(Game.units[target].x / Map.GRIDW == cxx && Game.units[target].y / Map.GRIDH == cy)
						{
							if(Game.units[target].hp>0 && Game.units[target].faction!=faction && Game.units[target].faction!=Unit.NULLFACTION)
							{
								dist = (int)(Functions.abs(cxx - myx) + Functions.abs(cy - myy));
								if(Game.units[target].walkspeed>0 && prefermobiletargets>0)//18sep2021
								{
									//75% more likely to choose a mobile target....
									dist*=3;
									dist/=4;
									//and they get a 10% higher rating for every point of 'extra speed' they have.....
									//noting that walkspeed is only between 1 and 3 and never as high as 10.
									dist*=(10 - Game.units[target].walkspeed);
									dist/=10;
								}
								if(dist < mindist  && dist < (rangeblock + 2) * Map.GRIDW)
								{
									if(needlos>0)//15sep2021
									{
										if(los(game,id,target))
										{
											mindist = dist;
											firetargeti = target;
										}
									}
									else//15sep2021
									{
										mindist = dist;
										firetargeti = target;
									}
								}
							}
						}						
					}
					target = -1;
				}
				if(firetargeti!=-1)
				{
					if(Game.units[firetargeti].stealth>0)
					{
						//stealthy units are harder to target...unless they are themselves attacking......
						if(Game.units[firetargeti].animmode<=ANIMMODE_WALK)
						{
							//cannot be targeted.....
							//unless they are within 2 grid squares....
							if(Functions.abs(x-Game.units[firetargeti].x)>=Map.GRIDW*3 || Functions.abs(y - Game.units[firetargeti].y)>=Map.GRIDH*3)
							{
								firetargeti = -1;
								orderframe = 1;
								tx = x;
								ty = y;
								tmptx = x;
								tmpty = y;
							}
						}
					}
				}
				//if(faction!=Game.PLAYERFACTION && firetargeti!=-1)//13oct2021
				if(firetargeti!=-1)//13oct2021
				{
					orderframe = 60;
				}
				if(firetargeti!=-1 && rangeblock>=4 && onscreen==true)
				{
					//Functions.saveseed();//11apr2021
					Functions.saveseed();//25apr2021
					if(Functions.rand(0,100)<20 && faction==Game.PLAYERFACTION)
					{
						playtargetchosensound(game,id);
					}
					if(Functions.rand(0,100)<5 && faction!=Game.PLAYERFACTION)
					{
						playtargetchosensound(game,id);
					}
					Functions.restoreseed();//25apr2021
					//Functions.restoreseed();//11apr2021
				}
			}
		}

///////////////////Method Definition///////////////
		public static bool los(Game game,int id,int target)
		{
			int sx = Game.units[id].x / Map.GRIDW;
			int sy = Game.units[id].y / Map.GRIDH;
			int fx = Game.units[target].x / Map.GRIDW;
			int fy = Game.units[target].y / Map.GRIDH;
			if(sx>=0 && sx<Map.MAXX && sy>=0 && sy<Map.MAXY && fx>=0 && fx<Map.MAXX && fy>=0 && fy<Map.MAXY)
			{
				if(Map.losmap[sx,sy,fx,fy]==1)
				{
					return true;
				}
				if(Map.losmap[sx,sy,fx,fy]==2)
				{
					return false;
				}
			}
			else
			{
				return false;
			}
			int vecdx = fx - sx;
			int vecdy = fy - sy;
			int lvecdx = vecdx;
			int lvecdy = vecdy;
			if(lvecdx<0)
			{
				lvecdx*=-1;
			}
			if(lvecdy<0)
			{
				lvecdy*=-1;
			}
			int length = lvecdx + lvecdy;
			if(length<=4)
			{
				return true;
			}
			for(int i=0;i<length - 1;i++)
			{
				int x = sx + (vecdx * i) / length;
				int y = sy + (vecdy * i) / length;
				if(!Map.passable(x * Map.GRIDW,y * Map.GRIDH))
				{
					Map.losmap[sx,sy,fx,fy] = 2;
					return false;
				}
				if(x==fx && y==fy)
				{
					break;
				}
			}
			Map.losmap[sx,sy,fx,fy] = 1;
			return true;
		}
		
///////////////////Method Definition///////////////
		public static void debugtemplate(Unit unit)
		{
			//debug only
			unit.faction = HUMAN;
			unit.team = 0;
			//unit.cat = Resources.CAT_KNIGHT;
			unit.framesperdirn = 8;
			unit.basehp = 1;
			unit.hp = 1;
			unit.animmodeidleframestart = 0;
			unit.animmodeidleframeend = 0;
			unit.animmodewalkframeend = 7;
			unit.animmodewalkframestart = 0;
			unit.walkspeed = 2;
			unit.animspeed = 6;
		}

///////////////////Method Definition///////////////
		public Unit(Game game)
		{
			if(circles==null)//2jun2021
			{
				circles = new int[MAXUNITS];//2jun2021
				for(int i=0;i<MAXUNITS;i++)//2jun2021
				{
					circles[i] = -1; //2jun2021
				}
			}
			description = new string[1];//19oct2021
			description[0] = "";//19oct2021
			spellwalkspeed = 0;//18oct2021
			name = "";//18oct2021
			isdead = 0;
			boardx = -1;
			boardy = -1;
			boardi = -1;
			scale = 1;
			prefermobiletargets=0;//18sep2021
			lightningdeath = 0;//19oct2021
			charactername = "";//10sep2021
			ping = 0;//17sep2021
			redping = -1;//17sep2021
			displaycharactername = 0;//10sep2021
			gold = -1;//23sep2021
			canpickup = 0;//23sep2021
			guiattackdisplaylimit = 0;//23sep2021
		
			//start-----------//4may2021
			canfly = 0;
			canflyandwalk = 0;
			flightlevel = -1;
			canattackair = 0;
			//end------------//4may2021
			//
			aiselectframe = 0;//21apr2021
			casting = false; //28mar2021
			misfire = 0;//28mar2021
			magicarray = new int[17];//28mar2021
			timedead = MAXDEADTIME;//25mar2021
			cursed = false; //21mar2021
			buffed = false; //21mar2021
			defendx = -1; //9mar2021
			defendy = -1; //9mar2021
			checkedgrid = new int[4];
			shocked = false;
			groupid = -1;
			controller = -1;
			controlpoint = 0;
			retreat = false;
			onscreen = false;
			mirrorleftright = true;
			controlmode = "";//24sep2021
			firetargeti = -1;
			cat = -1;
			cathires = -1;//9apr2021
			dropshadow=0;//25sep2021
			spawnertime = 10;
			spawner = "";
			spawnerconstraint = "*";//9sep2021
			transforminto = "";//3may2021
			transformrequires = "";//3may2021
			displayspawner = "";//13mar2021
			transportsize = 1;//3may2021
			transportcapacity = 0;//3may2021
			transportarray = new int[0];//3may2021
			transportedbyid = -1;//4may2021
			impactfx = new int[5];
			attackfx = new int[3];
			targetfx = new int[3];
			magicfx = new int[3];
			ackfx = new int[5];
			deathfx = new int[5]; //28jul2021
			selectfx = new int[5];
			offxa = new int[100];
			offya = new int[100];
			for(int i=0;i<impactfx.Length;i++)
			{
				impactfx[i] = -1;
			}
			for(int i=0;i<attackfx.Length;i++)
			{
				attackfx[i] = -1;
			}
			for(int i=0;i<targetfx.Length;i++)
			{
				targetfx[i] = -1;
			}
			for(int i=0;i<magicfx.Length;i++)
			{
				magicfx[i] = -1;
			}
			for(int i=0;i<ackfx.Length;i++)
			{
				ackfx[i] = -1;
			}
			for(int i=0;i<selectfx.Length;i++)
			{
				selectfx[i] = -1;
			}
			for(int i=0;i<deathfx.Length;i++)//28jul2021
			{
				deathfx[i] = -1;
			}
			
		}

///////////////////Method Definition///////////////
		public static int countselected(Game game)
		{
			//as title
			int count = 0;
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0)
				{
					if(Game.units[i].selected==Unit.SELECTIONFROZEN)
					{
						count++;
					}
				}
			}
			return count;
		}

///////////////////Method Definition///////////////
		public static void issueorder(Game game,int gx, int gy)
		{
			//issue a move or attack order
			bool ordered = false;
			int j = -1;
			int scount = countselected(game);
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0)
				{
					if(Game.units[i].selected==Unit.SELECTIONFROZEN)
					{
						Game.units[i].tx = gx;
						Game.units[i].ty = gy;
						if(Game.HORIZONTALFORMATION>0 || Game.VERTICALFORMATION>0)//14apr2021
						{
							Game.units[i].tx+=Game.units[i].formationx;
							Game.units[i].ty+=Game.units[i].formationy;
						}
						else
						{
							Game.units[i].formationx = 0;
							Game.units[i].formationy = 0;
						}
						Game.units[i].orderframe = Unit.ORDERTIME;
						Game.units[i].firetargeti = -1;
						Game.units[i].tmptattempts = 0;
						Game.units[i].defendx = -1; //12mar2021
						Game.units[i].defendy = -1; //12mar2021
						Game.ordergivenframe = Game.frame;
						ordered = true;
						j = i;
						//12mar2021 - added a radius of 1 grid square around it....
						int nid = Map.cellunit(Game.units[i].tx,Game.units[i].ty);
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx - Map.GRIDW,Game.units[i].ty);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx + Map.GRIDW,Game.units[i].ty);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx + Map.GRIDW,Game.units[i].ty - Map.GRIDH);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx + Map.GRIDW,Game.units[i].ty + Map.GRIDH);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						//start--------//24mar2021
						//if(Game.mouseoverunitid!=-1)//4sep2021
						if(nid!=-1)//4sep2021
						{
							//nid = Game.mouseoverunitid;//4sep2021
							//check if we should get in the transport...if it is a transport....
							if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].transportcapacity>0 && Game.units[i].transportsize<Game.units[nid].transportcapacity)//3may2021
							{
								Unit.GetInTransport(game,nid,i);//3may2021
							}
						}
						//end----------//24mar2021
						if(nid!=-1 && !Game.EDITOR)
						{
							if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].faction!=Unit.NULLFACTION)
							{
								Game.units[i].firetargeti = nid;
								Game.units[i].orderframe = 0;
								Game.clickerrow = 1;//15apr2021
							}
						}
						//if(scount > 1 && Game.VERTICALFORMATION==0 && Game.HORIZONTALFORMATION==0)//14apr2021//15sep2021
						if(scount > 1 && Game.VERTICALFORMATION==0 && Game.HORIZONTALFORMATION==0 && Config.CLUMP==0)//14apr2021//15sep2021
						{
							Game.units[i].tx = gx + (int)Functions.rand(-Map.GRIDW*4,Map.GRIDW*4);
							Game.units[i].ty = gy + (int)Functions.rand(-Map.GRIDH*4,Map.GRIDH*4);
						}
					}
				}
			}
			if(ordered)
			{
				Game.units[j].playacknowledgesound(game,j);
			}
		}

///////////////////Method Definition///////////////
		public static void issueorder(Game game)
		{
			//issue a move or attack order
			bool ordered = false;
			int j = -1;
			int scount = countselected(game);
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0)
				{
					if(Game.units[i].selected==Unit.SELECTIONFROZEN)
					{
						//zoom stuff
						Game.units[i].tx = Game.CORNERX + (Game.RESOLUTIONX/2) + (int)(((float)(Game.mx) - (float)Game.RESOLUTIONX/2)/Game.zoom);
						Game.units[i].ty = Game.CORNERY + (Game.RESOLUTIONY/2) + (int)(((float)(Game.my) - (float)Game.RESOLUTIONY/2)/Game.zoom);
						Game.units[i].orderframe = Unit.ORDERTIME;
						Game.units[i].firetargeti = -1;
						Game.units[i].tmptattempts = 0;
						Game.units[i].defendx = -1; //12mar2021
						Game.units[i].defendy = -1; //12mar2021
						if(Game.HORIZONTALFORMATION>0 || Game.VERTICALFORMATION>0)//14apr2021
						{
							Game.units[i].tx+=Game.units[i].formationx;
							Game.units[i].ty+=Game.units[i].formationy;
						}
						else
						{
							Game.units[i].formationx = 0;
							Game.units[i].formationy = 0;
						}
						
						ordered = true;
						Game.ordergivenframe = Game.frame;
						j = i;
						int nid = Map.cellunit(Game.units[i].tx,Game.units[i].ty);
						//12mar2021 added these 1 grid cell checker...
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx - Map.GRIDW,Game.units[i].ty);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx + Map.GRIDW,Game.units[i].ty);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx + Map.GRIDW,Game.units[i].ty - Map.GRIDH);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						if(nid==-1)
						{
							nid = Map.cellunit(Game.units[i].tx + Map.GRIDW,Game.units[i].ty + Map.GRIDH);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.units[i].faction)
								{
									nid = -1;
								}
							}
						}
						//start--------//24mar2021
						//if(Game.mouseoverunitid!=-1)//4sep2021
						if(nid!=-1)//4sep2021
						{
							//nid = Game.mouseoverunitid;//4sep2021
							//check if we should get in the transport...if it is a transport....
							if(Game.units[nid].faction==Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].transportcapacity>0 && Game.units[i].transportsize<Game.units[nid].transportcapacity)//3may2021
							{
								Unit.GetInTransport(game,nid,i);//3may2021
							}
						}
						//end----------//24mar2021
						if(nid!=-1 && !Game.EDITOR)
						{
							if(Game.units[nid].faction!=Game.units[i].faction && Game.units[nid].hp>0 && Game.units[nid].faction!=Unit.NULLFACTION)
							{
								Game.units[i].firetargeti = nid;
								Game.units[i].orderframe = 0;
								Game.clickerrow = 1;//15apr2021
							}
						}
						//if(scount > 1)
						//if(scount > 1 && Game.VERTICALFORMATION==0 && Game.HORIZONTALFORMATION==0)//14apr2021//15sep2021
						if(scount > 1 && Game.VERTICALFORMATION==0 && Game.HORIZONTALFORMATION==0 && Config.CLUMP==0)//14apr2021//15sep2021
						{
							Game.units[i].tx+= (int)Functions.rand(-Map.GRIDW*4,Map.GRIDW*4);
							Game.units[i].ty+= (int)Functions.rand(-Map.GRIDH*4,Map.GRIDH*4);
						}
					}
				}
			}
			if(ordered)
			{
				Game.units[j].playacknowledgesound(game,j);
			}
		}

///////////////////Method Definition///////////////
		public static void deselect(Game game)
		{
			//deselect all units
			if(Game.frame - Game.minimapframe>5)
			{
				//for(int i=0;i<Game.units.Length;i++)//26mar2021
				for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
				{
					if(Game.units[i].selected!=Unit.SELECTIONNONE)
					{
						Game.units[i].selected=Unit.SELECTIONNONE;
					}			
				}
			}
		}

///////////////////Method Definition///////////////
		public static void selectone(Game game)
		{
			//select a single unit
			if(Game.frame - Game.minimapframe <= 5)
			{
				return;
			}
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0 && (Game.units[i].faction==Game.PLAYERFACTION || Game.EDITOR==true))
				{
					//if(Game.units[i].faction==PLAYERFACTION)
					//{
					//zoom stuff
					int mmx = (int)((float)(Game.mx - Game.RESOLUTIONX/2)/Game.zoom) + Game.CORNERX + Game.RESOLUTIONX/2;
					int mmy = (int)((float)(Game.my - Game.RESOLUTIONY/2)/Game.zoom) + Game.CORNERY + Game.RESOLUTIONY/2;
					if(mmx < Game.units[i].x + (Game.units[i].cw/2)/Game.zoom && mmx > Game.units[i].x - (Game.units[i].cw/2)/Game.zoom)
					{
						if(mmy < Game.units[i].y + (Game.units[i].ch/2)/Game.zoom + (Game.units[i].offy)/Game.zoom && mmy > Game.units[i].y - (Game.units[i].ch/2 + Game.units[i].offy)/Game.zoom)
						{
							if(Game.frame - Game.units[i].selectedframe < 15)
							{
								//select all of the same type.....
								//for(int j=0;j<Game.units.Length;j++)//26mar2021
								for(int j=0;j<=Unit.MAXINDEX;j++)//26mar2021
								{
									Game.units[j].selected = Unit.SELECTIONNONE;
									if(Game.units[j].hp>0 && Game.units[j].name==Game.units[i].name)
									{
										Game.units[j].selected = Unit.SELECTIONSTART;
									}
								}
							}
							Game.units[i].selected = Unit.SELECTIONSTART;
							Game.units[i].selectedframe = Game.frame;
							//Game.selectingtime = Game.WAITSELECTINGTIME;//26mar2021
							return;
						}
					}
					//}
				}
			}
		}

///////////////////Method Definition///////////////
		public static bool noneselected(Game game)
		{
			//check if no units are selected
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0)
				{
					if(Game.units[i].selected!=Unit.SELECTIONNONE)
					{
						return false;
					}
				}
			}
			return true;
		}

///////////////////Method Definition///////////////
		public static void freezeselect(Game game)
		{
			//take units that have been drag selected and
			//mark them as properly selected
			bool selected = false;
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].hp>0)
				{
					if(Game.units[i].selected==Unit.SELECTIONSTART)
					{
						Game.units[i].selected=Unit.SELECTIONFROZEN;
						if(!selected)
						{
							selected = true;
							Game.units[i].playselectsound(game,i);
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void select(Game game,int x, int y, int w, int h)
		{
			//select the units at this location
			//zoom stuff
			bool anyselected = false;
			bool selectsingle = false;
			int ww = 0;
			int hh = 0;
			if(w==-1 && h==-1)
			{
				w = 40 ;//* (int)Game.zoom;
				h = 40 ;//* (int)Game.zoom;
				selectsingle = true;
				ww = w;
				hh = h;
			}
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].transportedbyid!=-1)//4may2021 //bugfix
				{
					continue;
				}
				if(Game.units[i].hp>0 && (Game.units[i].faction==Game.PLAYERFACTION || Game.EDITOR==true))
				{
					//if(Game.units[i].faction==PLAYERFACTION)
					//{
					//if(x + Game.CORNERX<Game.units[i].x	&& x + Game.CORNERX + w > Game.units[i].x)
					//if(x - ww <Game.units[i].x	&& x  + w > Game.units[i].x)//26mar2021 
					if((x - ww <Game.units[i].x	&& x  + w > Game.units[i].x) || (i == Game.mouseoverunitid && selectsingle==true))//26mar2021
					{
						//if(y + Game.CORNERY < Game.units[i].y + Game.units[i].offy && y + Game.CORNERY + h > Game.units[i].y + Game.units[i].offy)
						//if(y - hh < Game.units[i].y + Game.units[i].offy/Game.zoom && y + h > Game.units[i].y + Game.units[i].offy/Game.zoom)//26mar2021
						if((y - hh < Game.units[i].y + Game.units[i].offy/Game.zoom && y + h > Game.units[i].y + Game.units[i].offy/Game.zoom) || (i == Game.mouseoverunitid && selectsingle==true))//26mar2021
						{
							anyselected = true;
							if(selectsingle)
							{
								if(Game.frame - Game.units[i].selectedframe < 15)
								{
									//select all of the same type.....
									//for(int j=0;j<Game.units.Length;j++)//26mar2021
									for(int j=0;j<=Unit.MAXINDEX;j++)//26mar2021
									{
										Game.units[j].selected = Unit.SELECTIONNONE;
										if(Game.units[j].hp>0 && Game.units[j].name==Game.units[i].name)
										{
											Game.units[j].selected = Unit.SELECTIONSTART;
										}
									}
								}
								else
								{
									//28mar2021 check
									for(int j=0;j<=Unit.MAXINDEX;j++)//26mar2021
									{
										Game.units[j].selected = Unit.SELECTIONNONE;
									}
								}
							}
							Game.units[i].selected = Unit.SELECTIONSTART;
							Game.units[i].selectedframe = Game.frame;
							//Game.selectingtime = Game.WAITSELECTINGTIME;//26mar2021
							if(selectsingle)
							{
								break;
							}
						}
					}
					//}
				}
			}
			//start-------------//9mar2021
			//this block prevents units from being deselected when an icon in the gui is clicked upon
			//eg - if you are clicking the selection icons you don't want everything to become unselected 
			//because you've left clicked somewhere on the screen!
			for(int i=0;i<Game.gui.Length;i++)
			{
				if(Game.gui[i].action>=Gui.ACTION_FORMATIONSTART && Game.gui[i].action<=Gui.ACTION_FORMATIONEND && Game.gui[i].mouseover==true)
				{
					return; //looks okay
				}
				//start-------------//10mar2021
				if(Game.gui[i].triggerlink==Gui.LINK_SPAWNER_ICON && Game.gui[i].mouseover==true && (Game.SPAWNERSELECTED==true || Game.NONSPAWNERSELECTED==true))//11mar2021
				{
					return; //looks okay
				}
				//end---------------//10mar2021
				//start-------------//2sep2021
				if(Game.gui[i].triggerlink==Gui.LINK_TECH_ICON && Game.gui[i].mouseover==true && (Game.SPAWNERSELECTED==true || Game.NONSPAWNERSELECTED==true || Tech.TECHUNITSELECTED == true))//11mar2021
				{
					return; //looks okay
				}
				//end---------------//2sep2021
				//start-----------------//22mar2021
				if(Game.showingselectedicons==true && Game.gui[i].triggerlink==Gui.LINK_SELECTED_ICONS && Game.gui[i].mouseover==true)
				{
					return;//looks okay
				}
				//end-------------------//22mar2021
				//start---------------//28mar2021
				if(Game.SPELLCASTERSELECTED!=-1 && Game.gui[i].action>=Gui.ACTION_SPELL_START && Game.gui[i].action<=Gui.ACTION_SPELL_END && Game.gui[i].mouseover==true)
				{
					return;//looks okay
				}
				//end-----------------//28mar2021
			}
			//end---------------//9mar2021
			if(!anyselected)
			{
				Unit.deselect(game);
				//and check if any enemy are selected......
				//for(int i=0;i<Game.units.Length;i++)//26mar2021
				for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
				{
					if(Game.units[i].hp>0 && (Game.units[i].faction!=Game.PLAYERFACTION))
					{
						if(x - ww <Game.units[i].x	&& x  + w > Game.units[i].x)
						{
							if(y - hh < Game.units[i].y + Game.units[i].offy/Game.zoom && y + h > Game.units[i].y + Game.units[i].offy/Game.zoom)
							{
								Game.units[i].selected = Unit.SELECTIONENEMY;
								break;
							}
						}
						//}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void deselectall(Game game)
		{
			//as title
			if(Game.frame - Game.minimapframe > 5)
			{
				//for(int i=0;i<Game.units.Length;i++)//26mar2021
				for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
				{
					Game.units[i].selected = Unit.SELECTIONNONE;
				}
			}
		}

///////////////////Method Definition///////////////
		public void draw(Game game)
		{
			//draw the unit - individual unit draw
			float alpha = 1f;//2apr2021
			float prevalpha = 0f;//14oct2021
			if(stealth>0)
			{
				alpha = 0.7f + 0.25f * (float)Math.Sin((float)Game.frame/20);
			}
			int tmpprevframe = prevanimframe;
			int tmpanimframe = animframe;
			onscreen = true;
			if(faction==NULLFACTION || nodirn==1) //scenery...special scenery...
			{
				if(walkspeed<=0)
				{
					dirn = 0;
					animmode = ANIMMODE_IDLE;
				}
			}
			if(hp <= 0)
			{
				if(animmode!=ANIMMODE_DEAD)//13sep2021
				{
					return;
				}
			}
			//start-----------------//21mar2021
			//circles are offset too wrongly.....
			//if(Config.USEICONCIRCLES==true && Config.USEFEETCIRCLES==true)//20apr2021
			//2jun2021 removed whole next section and moved it elsewhere...where circlesmax is used....
			/*
			if(Config.USEFEETCIRCLES && Game.templates[templateid].walkspeed>0)//20apr2021
			{
				//offx added 20apr2021
				if(selected!=Unit.SELECTIONNONE)
				{
					if(Game.iconcircles!=-1)
					{
						float cc = 0.8f;
						int cw0 = cw;
						int ch0 = ch;
						if(cw0<70)
						{
							cw0 = 70;
						}
						if(ch0<85)
						{
							ch0 = 85;
						}
						if(faction==Game.PLAYERFACTION)
						{
							//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,0,0,false,1f,Game.iconcircles);	
							//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,0,1,false,0.25f,Game.iconcircles);	
							RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX,height + y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,0,0,false,1f,Game.iconcircles);	
							RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX,height + y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,0,1,false,0.25f,Game.iconcircles);	
						}
						else
						{
							//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,1,0,false,1f,Game.iconcircles);	
							//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,1,1,false,0.25f,Game.iconcircles);	
							RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX,height + y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,1,0,false,1f,Game.iconcircles);	
							RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX,height + y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,1,1,false,0.25f,Game.iconcircles);	
						}
					}
				}
			}
			*/
			//start-------------//24mar2021
			//if(Game.mx > x-Game.CORNERX - cw/2 && Game.mx < x - Game.CORNERX + cw/2 && Game.my > y - Game.CORNERX + offy - ch/2 && Game.my < y - Game.CORNERY + offy + ch/2)//26mar2021
			if(Game.mx > x-Game.CORNERX - cw/4 && Game.mx < x - Game.CORNERX + cw/4 && Game.my > y - Game.CORNERY + offy - ch/4 && Game.my < y - Game.CORNERY + offy + ch/4 && Game.zoom==1)//26mar2021
			{
				//24apr2021 addressed potential mouseoverunitid being corrupt
				if(hp>0)//24apr2021
				{
					Game.mouseoverunitid = id;
				}
			}
			//end---------------//24mar2021
			//end-------------------//21mar2021
			if(cat==-1) //show coloured rectangles if there are no graphics yet...
			{
				byte tr = 32;
				byte tg = 200;
				byte tb = 32;
				if(faction!=Game.PLAYERFACTION)
				{
					tr = 200;
					tg = 32;
				}
				RenderList.drawrect(game,x - Game.CORNERX - cw/2,height + y - Game.CORNERY - ch/2+offy,cw,ch,RenderList.getrgb(tr,tg,tb),0);
				//RenderList.drawtext(game,x - Game.CORNERX - cw/2,height + y - Game.CORNERY - ch+offy,name,RenderList.getrgb(200,200,180),Game.fonts[Resources.SMALLFONT].font,true);//13mar2021
				RenderList.drawtext(game,x - Game.CORNERX - cw/2,height + y - Game.CORNERY - ch+offy,dname(),RenderList.getrgb(200,200,180),Game.fonts[Resources.SMALLFONT].font,true);//13mar2021
			}
			else
			{
				if(mirrorleftright && (dirn==DIRN_DOWNRIGHT || dirn==DIRN_RIGHT || dirn==DIRN_UPRIGHT))
				{
					int tmpdirn = dirn;
					if(dirn==DIRN_DOWNRIGHT)
					{
						tmpdirn = DIRN_DOWNLEFT;
					}
					if(dirn==DIRN_RIGHT)
					{
						tmpdirn = DIRN_LEFT;
					}
					if(dirn==DIRN_UPRIGHT)
					{
						tmpdirn = DIRN_UPLEFT;
					}
					//2apr2021 added alpha
					//9apr2021 cathires
					//20apr2021 added offx
					if(dropshadow>0)//25sep2021
					{
						RenderList.drawrect(game,offx + x - Game.CORNERX + (int)(scale * cw/2) - cw/14,height + y - Game.CORNERY + offy + (int)(scale * ch * 8) / 10,(int)(scale * cw/7),(int)(scale * ch/10),RenderList.getrgb(10,10,10),0);
					}
					if(cathires!=-1)
					{
						//25sep2021 added scale
						if(prevalpha>0)
						{
							RenderList.drawimage(game,Game.images[cathires].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,-0.5f * scale,0.5f * scale,tmpdirn * framesperdirn + tmpprevframe,0,false,prevalpha,cathires);	
						}
						RenderList.drawimage(game,Game.images[cathires].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,-0.5f * scale,0.5f * scale,tmpdirn * framesperdirn + tmpanimframe,0,false,alpha,cathires);	
					}
					else
					{
						//25sep2021 added scale
						if(prevalpha>0)
						{
							RenderList.drawimage(game,Game.images[cat].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,-1f * scale,1f * scale,tmpdirn * framesperdirn + tmpprevframe,0,false,prevalpha,cat);	
						}
						RenderList.drawimage(game,Game.images[cat].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,-1f * scale,1f * scale,tmpdirn * framesperdirn + tmpanimframe,0,false,alpha,cat);	
					}
					
				}
				else
				{
					if(controlpoint==1)
					{
						//20apr2021 added offx
						if(controller==Game.PLAYERFACTION)
						{
							//25sep2012 added scale
							RenderList.drawimage(game,Game.images[fcat].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,1f * scale,1f * scale,dirn * framesperdirn + tmpanimframe,0,false,1f,fcat);	
						}
						if(controller==Game.SKIRMISHENEMYFACTION)
						{
							//25sep2012 added scale
							RenderList.drawimage(game,Game.images[ecat].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,1f * scale,1f * scale,dirn * framesperdirn + tmpanimframe,0,false,1f,ecat);	
						}
						if(controller!=Game.PLAYERFACTION && controller!=Game.SKIRMISHENEMYFACTION)
						{
							//9apr2021 hires stuff
							//20apr2021 added offx
							if(cathires!=-1)
							{
								//25sep2012 added scale
								RenderList.drawimage(game,Game.images[cathires].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,0.5f * scale,0.5f * scale,dirn * framesperdirn + tmpanimframe,0,false,1f,cathires);	
							}
							else
							{
								//25sep2012 added scale
								RenderList.drawimage(game,Game.images[cat].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY+offy,0,1f * scale,1f * scale,dirn * framesperdirn + tmpanimframe,0,false,1f,cat);	
							}
							
						}
					}
					else
					{
						//2apr2021 added alpha
						//9apr2021 added hires
						//20apr2021 added offx
						if(cathires!=-1)
						{
							//25sep2012 added scale
							if(prevalpha>0)
							{
								RenderList.drawimage(game,Game.images[cathires].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY+offy,0,0.5f * scale,0.5f * scale,dirn * framesperdirn + tmpprevframe,0,false,prevalpha,cathires);	
							}
							RenderList.drawimage(game,Game.images[cathires].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY+offy,0,0.5f * scale,0.5f * scale,dirn * framesperdirn + tmpanimframe,0,false,alpha,cathires);	
						}
						else
						{
							
							if(prevalpha>0)
							{
							RenderList.drawimage(game,Game.images[cat].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY+offy,0,1f * scale,1f * scale,dirn * framesperdirn + tmpprevframe,0,false,prevalpha,cat);	
							}
							//25sep2012 added scale
							RenderList.drawimage(game,Game.images[cat].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY+offy,0,1f * scale,1f * scale,dirn * framesperdirn + tmpanimframe,0,false,alpha,cat);	
						}
					}
				}
			}
			if(Unit.CRPG>0)//25sep2021
			{
				if(faction==Game.SKIRMISHENEMYFACTION && hp>0)
				{
					drawhealthbar(game);
				}
			}
			//25sep2021 removed this again....
			
			//2jun2021 altered this section and moved it elsewhere....
			//if(selected!=Unit.SELECTIONNONE || (bossmonster>0 && Game.skirmish==false))
			//{
				//if(Game.templates[templateid].walkspeed<=0 || selected==Unit.SELECTIONNONE) //2jun2021 - this is to account for the fact that SOME of these won't be drawn in the other section....
				//{
				//	drawhealthbar(game);
				//}
			//}
			//if(retreat)//15mar2021
			//20apr2021 added offx
			if(retreat==true && Game.whiteflag!=-1)//15mar2021
			{
				RenderList.drawimage(game,Game.images[Game.whiteflag].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,1f,1f,tmpanimframe % 3,0,false,1f,Game.whiteflag);	
			}
			if((defendx!=-1 || defendy!=-1) && Game.shield!=-1)//15mar2021
			{
				RenderList.drawimage(game,Game.images[Game.shield].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,1f,1f,0,0,false,1f,Game.shield);	
			}
			if(buffed && Game.iconplus!=-1) //21mar2021
			{
				RenderList.drawimage(game,Game.images[Game.iconplus].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,1f,1f,0,0,false,1f,Game.iconplus);	
			}
			if((cursed==true || misfire!=0) && Game.iconminus!=-1)
			{
				RenderList.drawimage(game,Game.images[Game.iconminus].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY+offy,0,1f,1f,0,0,false,1f,Game.iconminus);	
			}
			//start-----------------//21mar2021
			//20apr2021 added offx
			if(Config.USEICONCIRCLES)
			{
				if(Game.iconcircles!=-1 && Game.groupselected==groupid)
				{
					if(groupid>=0 && groupid<=9)
					{
						//25sep2012 added scale
						RenderList.drawimage(game,Game.images[Game.iconcircles].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY + offy,0,0.5f * scale,0.5f * scale,2 + groupid,0,false,1f,Game.iconcircles);	
					}
				}
				if(Config.USECOVERFLAG)
				{
					if(Game.iconcircles!=-1 && Game.gamestate==Game.CAT_GAMESTATE_GAME)
					{
						if(Map.nearobstacle(x,y))
						{
							//coverindicator
							RenderList.drawimage(game,Game.images[Game.iconcircles].texture,offx + x-Game.CORNERX,height + y-Game.CORNERY + offy,0,0.5f,0.5f,12,0,false,1f,Game.iconcircles);	
						}
					}
				}
			}
			//end-------------------//21mar2021
			//20apr2021 added offx
			if(Game.EDITOR)
			{
				//RenderList.drawtext(game,x - Game.CORNERX,height + y - Game.CORNERY + offy,name+","+(x/Map.GRIDW)+","+(y/Map.GRIDH),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//13mar2021
				RenderList.drawtext(game,x - Game.CORNERX + offx,height + y - Game.CORNERY + offy,dname()+","+Translation.TranslateNumber(x/Map.GRIDW)+","+Translation.TranslateNumber(y/Map.GRIDH),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//13mar2021
			}
			else//10sep2021
			{
				if(displaycharactername>0)
				{
					RenderList.drawtext(game,x - Game.CORNERX + offx,height + y - Game.CORNERY + offy - ch/2,dname(),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//13mar2021					
				}
			}
			//if(spawner!="" && spawnercount>0) //11mar2021//13mar2021
			//start--------------//13mar2021
			if(displayspawner=="")
			{
				displayspawner = spawner;
			}
			//end----------------//13mar2021
			if(displayspawner!="" && spawnercount>0) //11mar2021//13mar2021
			{
				//todo 13mar2021
				//RenderList.drawtext(game,x - Game.CORNERX,height + y - Game.CORNERY + offy,spawner,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//13mar2021
				//RenderList.drawtext(game,x - Game.CORNERX + offx,height + y - Game.CORNERY + offy,displayspawner,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//13mar2021//24apr2021
				RenderList.drawtext(game,x - Game.CORNERX + offx,height + y - Game.CORNERY + offy,displayspawner + " " +Translation.TranslateNumber(spawnercount),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//24apr2021
				RenderList.drawunfilledrect(game,offx + x - Game.CORNERX - 1 - 50,height + y - Game.CORNERY + offy - Game.fonts[Resources.FONT].ptsize * 2 - 1,100,4,RenderList.getrgb(180,180,200),0);
				RenderList.drawrect(game,offx + x - Game.CORNERX - 50,height + y - Game.CORNERY + offy - Game.fonts[Resources.FONT].ptsize * 2,percentagespawn(game),2,RenderList.getrgb(32,255,255),0);
			}
			//start-----------//12jul2021
			if(bounddemon>1)
			{
				RenderList.drawtext(game,x - Game.CORNERX + offx,height + y - Game.CORNERY + offy," " +Translation.TranslateNumber(bounddemon),RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,true);//24apr2021
			}
			if(bounddemon==1)
			{
				RenderList.drawtext(game,x - Game.CORNERX + offx,height + y - Game.CORNERY + offy,Translation.TranslateWord("!",false) ,RenderList.getrgb(255,155,100),Game.fonts[Resources.FONT].font,true);//24apr2021
			}
			//end-------------//12jul2021
			drawn = true;
		}

///////////////////Method Definition///////////////
		public void drawhealthbar(Game game)
		{
			//draw the unit's health bar
			int pct = ((10 * hp) / basehp) - 1;
			if (pct<0)
			{
				pct = 0;
			}
			if(pct>5)
			{
				pct = 5;
			}
			//20apr2021 added offx
			RenderList.drawanimimage(game,Game.images[Game.healthbar].texture,offx + x - Game.CORNERX,height + y - Game.CORNERY - ch/2 + offy,0,1f,1f,pct,0,false,1f,Game.healthbar);
			//int pct = (cw * hp) / basehp;
			/*
			RenderList.drawrect(game,x - Game.CORNERX - cw/2,y - Game.CORNERY - ch/2+offy,cw,3,RenderList.getrgb(255,32,32),0);
			if(bossmonster>0 && Game.skirmish==false)
			{
				RenderList.drawrect(game,x - Game.CORNERX - cw/2,y - Game.CORNERY - ch/2+offy,pct,3,RenderList.getrgb(255,255,32),0);
			}
			else
			{
				RenderList.drawrect(game,x - Game.CORNERX - cw/2,y - Game.CORNERY - ch/2+offy,pct,3,RenderList.getrgb(32,255,32),0);
			}
			*/
			/*
			for(int i=pct;i<cw;i+=4)
			{
				RenderList.drawrect(game,x - Game.CORNERX - cw/2+i,y - Game.CORNERY - ch/2+offy,3,3,RenderList.getrgb(255,32,32),0);
			}
			for(int i=0;i<pct;i+=4)
			{
				if(bossmonster>0 && Game.skirmish==false)
				{
					RenderList.drawrect(game,x - Game.CORNERX - cw/2+i,y - Game.CORNERY - ch/2+offy,3,3,RenderList.getrgb(255,255,32),0);
				}
				else
				{
					RenderList.drawrect(game,x - Game.CORNERX - cw/2+i,y - Game.CORNERY - ch/2+offy,3,3,RenderList.getrgb(32,255,32),0);
				}
			}
			*/
		}

///////////////////Method Definition///////////////
		public void managecontrolpoint(Game game)
		{
			//manage a control point - a type of infinite spawner
			//that is controlled by whoever is closest
			if(Game.EDITOR)
			{
				return;
			}
			int framecheck = 60;
			if(Config.RUNNINGSPEED > 90)
			{
				framecheck = 80;
			}
			if(Config.RUNNINGSPEED > 110)
			{
				framecheck = 90;
			}
			framecheck/=Config.FASTFRAMECHECK;//14sep2021
			int gx = x / Map.GRIDW;
			int gy = y / Map.GRIDH;
			int gdist = firerange / Map.GRIDW;
			int countfriends = 0;
			int countenemies = 0;
			bool emptyslot = false;
			int[] countfaction = new int[Game.MAXFACTIONS]; //26oct2020
			int highest = 0;
			int highestfaction = 0;
			if((Game.frame + id) % framecheck==11)
			{
				//every second update the control points......
				for(int xx=gx-gdist;xx<=gx+gdist;xx++)
				{
					for(int yy=gy-gdist;yy<=gy+gdist;yy++)
					{
						if(xx>=0 && yy>=0 && xx<Map.MAXX && yy<Map.MAXY)
						{
							int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
							if(nid!=-1)
							{
								if(Game.units[nid].faction==Game.PLAYERFACTION)
								{
									countfriends++;
								}
								if(Game.units[nid].faction==Game.SKIRMISHENEMYFACTION)
								{
									countenemies++;
								}
								if(Game.units[nid].faction>=0 && Game.units[nid].faction<Game.MAXFACTIONS)//26oct2020
								{
									countfaction[Game.units[nid].faction]++;
									if(countfaction[Game.units[nid].faction]>highest)
									{
										highest = countfaction[Game.units[nid].faction];
										highestfaction = Game.units[nid].faction;
									}
								}
							}
						}
					}
				}
				if(countfriends>countenemies)
				{
					controller = Game.PLAYERFACTION;
				}
				if(countfriends<countenemies)
				{
					controller = Game.SKIRMISHENEMYFACTION;
				}
				if(highest>0) //26oct2020
				{
					controller = highestfaction;
				}
			}
			if((Game.frame + id)%(framecheck * Unit.CONTROLRATE)==29 && (controller==Game.PLAYERFACTION || controller==Game.SKIRMISHENEMYFACTION || highest>0))
			{
				//spawn a new unit....chosen how?
				for(int gdist2=1;gdist2<=gdist;gdist2++)
				{
					for(int xx=gx-gdist2;xx<=gx+gdist2;xx++)
					{
						for(int yy=gy-gdist2;yy<=gy+gdist2;yy++)
						{
							if(xx>=0 && yy>=0 && xx<Map.MAXX && yy<Map.MAXY)
							{
								int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
								if(nid==-1)
								{
										emptyslot = true;
										controllerspawn(game,xx,yy);
										break;
								}
							}
						}
						if(emptyslot)
						{
							break;
						}
					}
					if(emptyslot)
					{
						break;
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public void controllerspawn(Game game, int xx, int yy)
		{
			//spawn units from the controller
			//how to pick a unit?
			//randomly chosen?
			int count = 0;
			int index = 0;
			for(int j=0;j<Game.templates.Length;j++)
			{
				if(Game.templates[j].faction==controller && Game.templates[j].walkspeed>0 && Game.templates[j].bossmonster==0)
				{
					count++;
				}
			}
			if(count>0)
			{
				index = 1 + ((int)Functions.rand(0,10000) % count);
				for(int j=0;j<Game.templates.Length;j++)
				{
					if(Game.templates[j].faction==controller && Game.templates[j].walkspeed>0 && Game.templates[j].bossmonster==0)
					{
						index--;
						if(index<=0)
						{
							for(int k=0;k<Game.units.Length;k++)
							{
								if(Game.units[k].hp<=0)
								{
									Game.units[k].createunitatxy(game,k,Game.templates[j],xx * Map.GRIDW,yy * Map.GRIDH);
									Blood.makeblood(game,Game.units[k].x,Game.units[k].y+Game.units[k].offy,Blood.BLOODSPAWNER+faction);
									if(k>Unit.MAXINDEX)//11apr2021
									{
										Unit.MAXINDEX = k;
									}
									break;
								}
							}
							break;
						}
					}
				}
			}
		}
///////////////////Method Definition///////////////
		public void fademagic(Game game)//28mar2021
		{
			//if armour, damage, misfire, etc are in play....
			//then gradually reduce them back to their standard levels....
			int framecheck = 60;
			if(Config.RUNNINGSPEED>90)
			{
				framecheck = 80;
			}
			if(Config.RUNNINGSPEED>110)
			{
				framecheck = 90;
			}
			framecheck/=Config.FASTFRAMECHECK;//14sep2021
			int plusorminus = 0;
			if(Config.USETECH) //2sep2021
			{
				walkspeed-=Tech.AddUnitUpgradeBuff(game,templateid,Tech.MV);
				damage-=Tech.AddUnitUpgradeBuff(game,templateid,Tech.BA);
				armour-=Tech.AddUnitUpgradeBuff(game,templateid,Tech.BD);
				Tech.TARGETUID = id;
				Tech.ADDSUBTRACT = -1;
				Tech.AddUnitUpgradeBuff(game,templateid,Tech.BZ);
			}
			plusorminus-=Functions.sign(Game.templates[templateid].walkspeed-walkspeed);
			plusorminus-=Functions.sign(Game.templates[templateid].damage-damage);
			plusorminus-=Functions.sign(Game.templates[templateid].armour-armour);
			plusorminus-=Functions.sign(Game.templates[templateid].spelldefense-spelldefense);//01apr2021
			plusorminus-=Functions.sign(Game.templates[templateid].frenzy-frenzy);//01apr2021
			plusorminus-=Functions.sign(Game.templates[templateid].leader-leader);//09apr2021
			plusorminus-=Functions.sign(Game.templates[templateid].zombiemaster-zombiemaster);//09apr2021
			if(misfire>0)
			{
				plusorminus--;
			}
			if(plusorminus>0)
			{
				buffed = true;
				cursed = false;
			}
			if(plusorminus<0)
			{
				cursed = true;
				buffed = false;
			}
			if(plusorminus==0)
			{
				cursed = false;
				buffed = false;
			}
			if(((Game.frame + id)%(framecheck*20))==0)
			{
				//every 6 seconds......
				bool anydiff = false;
				if(misfire>0)
				{
					//plusorminus--;
					misfire--;
					anydiff = true;
					cursed = true;
				}
				if(Game.templates[templateid].frenzy!=frenzy)//01apr2021
				{
					anydiff = true;
					frenzy+=Functions.sign(Game.templates[templateid].frenzy-frenzy);
				}
				if(Game.templates[templateid].spelldefense!=spelldefense)//01apr2021
				{
					anydiff = true;
					spelldefense+=Functions.sign(Game.templates[templateid].spelldefense-spelldefense);
				}
				if(Game.templates[templateid].walkspeed!=walkspeed)
				{
					anydiff = true;
					walkspeed+=Functions.sign(Game.templates[templateid].walkspeed-walkspeed);
					
				}
				if(Game.templates[templateid].damage!=damage)
				{
					anydiff = true;
					damage+=Functions.sign(Game.templates[templateid].damage-damage);
					
				}
				if(Game.templates[templateid].armour!=armour)
				{
					anydiff = true;
					armour+=Functions.sign(Game.templates[templateid].armour-armour);
					
				}
				//start--------------//9apr2021
				if(Game.templates[templateid].leader!=leader)
				{
					anydiff = true;
					leader+=Functions.sign(Game.templates[templateid].leader-leader);
					
				}
				if(Game.templates[templateid].zombiemaster!=zombiemaster)
				{
					anydiff = true;
					zombiemaster+=Functions.sign(Game.templates[templateid].zombiemaster-zombiemaster);
					
				}
				//end----------------//9apr2021
				if(!anydiff)
				{
					cursed = false;
					buffed = false;
				}
			}
			if(Config.USETECH) //2sep2021
			{
				walkspeed+=Tech.AddUnitUpgradeBuff(game,templateid,Tech.MV);
				damage+=Tech.AddUnitUpgradeBuff(game,templateid,Tech.BA);
				armour+=Tech.AddUnitUpgradeBuff(game,templateid,Tech.BD);
				Tech.TARGETUID = id;
				Tech.ADDSUBTRACT = 1;
				Tech.AddUnitUpgradeBuff(game,templateid,Tech.BZ);
			}
		}
		
///////////////////Method Definition///////////////
		public void update(Game game)
		{
			//core unit update method
			//correction for offx/offy
			if(retreat)
			{
				if(walkspeed<=0)
				{
					retreat = false;
					timid = 0;
					retreatframe = Game.frame + RETREATDEATH;
				}
				if(x>Game.CORNERX + Game.RESOLUTIONX + 100 || y>Game.CORNERY + Game.RESOLUTIONY + 100)
				{
					if(isdead==0){hp = 0;}
					if(isdead==0){isdead = 1;}
				}
			}
			if(Game.RESOLVE>0)//6oct2021 bug fix?
			{
				if(faction==Unit.NULLFACTION)
				{
					if(Game.templates[templateid].faction!=Unit.NULLFACTION)
					{
						faction = Game.templates[templateid].faction;
					}
				}
			}
		
			if(Game.templates[templateid].autocalcedoffsets==true && autocalcedoffsets==false)//20apr2021
			{
				offx = Game.templates[templateid].offx;
				offy = Game.templates[templateid].offy;
				autocalcedoffsets = true;
			}
			if(Game.frame - Game.gamestartframe<10)//2apr2021
			{
				return;
			}
			int framecheck = 60;
			if(hp>0)
			{
				timedead = 0;//25mar2021
				height = Map.getheight(x,y);
				Game.templates[templateid].livecount++;//9mar2021
				if(faction==Game.PLAYERFACTION && selected!=SELECTIONNONE && walkspeed>0)//22mar2021
				{
					Game.templates[templateid].selectioncount++;
				}
			}
			else
			{
				timedead++; //25mar2021
				if(faction==Game.PLAYERFACTION)//17sep2021
				{
					if(points>0) //space squad uses this....
					{
						if(redping<0)
						{
							redping=120;
						}
					}
				}
			}
			fademagic(game);
			if(firetargeti!=-1)//22mar2021
			{
				//this fixes a bug where because units replace so fast, sometimes
				//a creature dies, then the pool reuses it but the other creatures
				//still have it as their firetargeti which causes them to 
				//chase after their own guys.....occasionally.
				if(Game.units[firetargeti].faction==faction)
				{
					firetargeti = -1;
				}
			}
			if(faction==Game.PLAYERFACTION)//24sep2021
			{
				if(controlmode=="crpg")//24sep2021
				{
					Unit.CRPG = 1;//25sep2021
					Game.CORNERX = x - Game.RESOLUTIONX/2;
					Game.CORNERY = y - Game.RESOLUTIONY/2;
					
					if(Game.CORNERX<0)
					{
						Game.CORNERX = 0;
					}
					if(Game.CORNERY<0)
					{
						Game.CORNERY = 0;
					}
					if(Game.CORNERX>Map.MAXX * Map.GRIDW - Game.RESOLUTIONX)
					{
						Game.CORNERX = Map.MAXX * Map.GRIDW - Game.RESOLUTIONX;
					}
					if(Game.CORNERY>Map.MAXY * Map.GRIDH - Game.RESOLUTIONY)
					{
						Game.CORNERY = Map.MAXY * Map.GRIDH - Game.RESOLUTIONY;
					}
					if(selected==Unit.SELECTIONNONE){selected = Unit.SELECTIONSTART;selectedframe = Game.frame;}
				}
			}
			if(groupid>=0 && groupid<=9 && selected!=SELECTIONNONE)//21mar2021
			{
				Game.groupselected = groupid;
			}
			if(Config.RUNNINGSPEED>90)
			{
				framecheck = 80;
			}
			if(Config.RUNNINGSPEED>110)
			{
				framecheck = 90;
			}
			framecheck/=Config.FASTFRAMECHECK;//14sep2021
			if(controlpoint==1)
			{
				managecontrolpoint(game);
				return;
			}
			//start-------------//7mar2021
			int enemyfaction = Game.PLAYERFACTION;
			if(faction==Game.PLAYERFACTION)
			{
				enemyfaction = Game.SKIRMISHENEMYFACTION;
			}
			if(mob>0)
			{
				int countfriend = Map.countfactionneighbours(game,x,y,faction);
				int countenemy = Map.countfactionneighbours(game,x,y,enemyfaction);
				if(countfriend>countenemy)
				{
					brave = 1;
				}
				else
				{
					brave = 0;
				}
			}
			if(basemana>0)//23sep2021
			{
				if(mana<basemana)
				{
					if(manarate>0)
					{
						if(Game.frame % framecheck == 0)
						{
							mana++;
						}
					}
				}
			}
			if(hatred>0)
			{
				if(hatred==enemyfaction)
				{
					brave = 1;
				}
			}
			if(planar>0 && Game.EDITOR==false && hp>0)
			{
				//if(animmode==ANIMMODE_IDLE)
				//{
					if((Game.frame+id) % 60==0)//11apr2021 added +id
					{
						//Functions.saveseed();//11apr2021
						if(Functions.rand(0,100)<planar)
						{
							hp--;
						}
						//Functions.restoreseed();//11apr2021
					}				
				//}
			}
			if(misfire>0 && Game.whirlwind!=-1)//28mar2021
			{
				int ggxx = x / Map.GRIDW;
				int ggyy = y / Map.GRIDH;
				if((ggxx + ggyy)%Blood.WHIRLWINDGRID==0)
				{
					Blood.makeblood(game,x,y,Blood.WHIRLWINDSPELL);
				}
			}
			if(animosity>0 && Game.EDITOR==false && hp>0)
			{
				if(animmode==ANIMMODE_IDLE)
				{
					if((Game.frame + id) % 60==0)//11apr2021 added +id
					{
						if(id%animosity==0)
						{
							//not sure about this one yet....
							//Functions.saveseed();//11apr2021
							if(Functions.rand(0,100)<10)
							{
								animosity = 0;
								faction = Unit.ANIMOSITY;
							}
							//Functions.restoreseed();//11apr2021
						}
					}
				}
			}
			//end---------------//7mar2021
			//if(fearsome > 0 || leader > 0)//12jul2021
			if(fearsome > 0 || leader > 0 || bounddemon > 0) //12jul2021
			{
				retreat = false;
				retreatframe = Game.frame + Unit.RETREATDEATH;
				timid = 0;
			}
			//start---------------//12jul2021
			if(bounddemon > 1)
			{
				if((Game.frame + id) % framecheck==0) //28jul21 - brought into line from being '60'.
				{
					bounddemon--;
				}
				if(bounddemon==1)
				{
					//alter the faction to a faction not in the game, but not neutral....
					faction = (Game.PLAYERFACTION + Game.SKIRMISHENEMYFACTION); //should be good enough....to do the job...
					selected = Unit.SELECTIONNONE; //13jul2021 bug fix potentially.
				}
			}
			//end-----------------//12jul2021
			if(brave > 0 && retreat==true)
			{
				if((Game.frame + id) % 60 == 0)//11apr2021
				{
					//Functions.saveseed();//11apr2021
					if(Functions.rand(0,1000)<Unit.RALLYCHANCE)
					{
						retreat = false;
						retreatframe = Game.frame + Unit.RETREATDEATH;
						timid = 0;
					}
					//Functions.restoreseed();//11apr2021
				}
			}
			if(hitandrun > 0 && retreat==true)
			{
				if((Game.frame+id) % framecheck == 0)
				{
					int qqq1 = Functions.rand(0,1000);
					int qqq2 = Functions.rand(0,1000);
					int qqq3 = Functions.rand(0,1000);
					if(qqq1<Unit.RALLYCHANCE || qqq2<Unit.RALLYCHANCE || qqq3<Unit.RALLYCHANCE)
					{
						//three chances to rally if a hit and run unit.....
						retreat = false;
						retreatframe = 0;
					}
					
				}
			}
			//start---------------//28mar2021
			if((Game.frame + id)%(framecheck*15)==1)
			{
				for(int m=0;m<magicarray.Length;m++)
				{
					if(magicarray[m]<0)
					{
						magicarray[m]*=-1;
						break;
					}
				}
			}
			//end-----------------//28mar2021
			//start---------------//2sep2021
			if(selected!=SELECTIONNONE && faction==Game.PLAYERFACTION && techguilinkid>0)
			{
				Tech.TECHUNITSELECTED = true;
				Tech.TECHUNITIDSELECTED = id;
			}
			//end-----------------//2sep2021
			//start-------------//10mar2021
			if(selected!=SELECTIONNONE && faction==Game.PLAYERFACTION && spawner!="")
			{
				Game.SPAWNERSELECTED = true;
			}
			if(selected!=SELECTIONNONE && spawner=="") //11mar2021
			{
				Game.NONSPAWNERSELECTED = true; //11mar2021
			}
			//start-------------//11mar2021
			if(spawner!="" && faction!=Game.PLAYERFACTION)
			{
				if(((Game.frame + id) % (framecheck*10))==2)//9sep2021
				if(((Game.frame + id) % (framecheck*10))==2 && framesleft<=0)//9sep2021
				{
					//AI spawners randomly choose a new thing to spawn.....
					int randomspawncount = 0;
					int randomspawnindex = 0;
					int ttid = -1;
					int maxkill = 0;
					int maxkill2 = 0;
					int ktid = -1;
					Game.ai_direction++;//17apr2021
					if((Game.ai_direction % 10)<5)//17apr2021 - altered AI to make it a bit more weird.......unpredictable but still following a logical course of action.
					{
						maxkill = 999999;
						maxkill2 = 0;
						for(int tid=0;tid<Game.templates.Length;tid++)
						{
							if(!Unit.SpawnerCanBuild(game,spawnerconstraint,tid))//9sep2021
							{
								continue;
							}
							if(faction==Game.templates[tid].faction && Game.templates[tid].walkspeed>0 && Game.templates[tid].bossmonster<=0 && Game.templates[tid].leader<=0 && Game.templates[tid].planar<=0)
							{
								randomspawncount++;
								if(Game.templates[tid].kills < maxkill)
								{
									maxkill = Game.templates[tid].kills;
									ktid = tid;
								}
							}
						}
						//get the second highest value....not the first highest value...
						//Functions.saveseed();//11apr2021
						if(Functions.rand(0,100)<25)
						{
							for(int tid=0;tid<Game.templates.Length;tid++)
							{
								if(!Unit.SpawnerCanBuild(game,spawnerconstraint,tid))//9sep2021
								{
									continue;
								}
								if(faction==Game.templates[tid].faction && Game.templates[tid].walkspeed>0 && Game.templates[tid].bossmonster<=0 && Game.templates[tid].leader<=0 && Game.templates[tid].planar<=0)
								{
									if(Game.templates[tid].kills > maxkill2)// && Game.templates[tid].kills < maxkill)
									{
										maxkill2 = Game.templates[tid].kills;
										ktid = tid;
									}
								}
							}
						}
						//Functions.restoreseed();//11apr2021
						if(randomspawncount>0)
						{
							Functions.saveseed();//11apr2021
							int qqq4 = Functions.rand(0,100);//11apr2021
							if(ktid==-1 || (qqq4 < 10 && ktid!=-1))
							{
								Functions.restoreseed();//11apr2021
								randomspawnindex = 1 + (Functions.rand(0,1000) % randomspawncount);
								for(int tid=0;tid<Game.templates.Length;tid++)
								{
									if(!Unit.SpawnerCanBuild(game,spawnerconstraint,tid))//9sep2021
									{
										continue;
									}
									if(faction==Game.templates[tid].faction && Game.templates[tid].walkspeed>0 && Game.templates[tid].bossmonster<=0 && Game.templates[tid].leader<=0 && Game.templates[tid].planar<=0)
									{
										randomspawnindex--;
										if(randomspawnindex<=0)
										{
											ttid = tid;
											break;
										}
									}
								}
							}
							else
							{
								ttid = ktid;
								Functions.restoreseed();//11apr2021
							}
							if(ttid!=-1)
							{
								spawner = Game.templates[ttid].name;
								displayspawner = Game.templates[ttid].dname(); //13mar2021
								spawnertime = Unit.CalculateSpawnerTime(game,ttid);
								framesleft = framecheck * spawnertime;//9sep2021
								if(spawnercount<10)
								{
									//spawnercount++;//12mar2021
									spawnercount+=3;//12mar2021 //to guarantee it keeps on producing and doesn't slow down with time.....
								}
								if(spawnercount<=0)
								{
									spawnercount=1;
								}
							}
							//Functions.restoreseed();//11apr2021
						}
					}
					else
					{
						for(int tid=0;tid<Game.templates.Length;tid++)
						{
							if(!Unit.SpawnerCanBuild(game,spawnerconstraint,tid))//9sep2021
							{
								continue;
							}
							if(faction==Game.templates[tid].faction && Game.templates[tid].walkspeed>0 && Game.templates[tid].bossmonster<=0 && Game.templates[tid].leader<=0 && Game.templates[tid].planar<=0)
							{
								randomspawncount++;
								if(Game.templates[tid].kills > maxkill)
								{
									maxkill = Game.templates[tid].kills;
									ktid = tid;
								}
							}
						}
						//get the second highest value....not the first highest value...
						//Functions.saveseed();//11apr2021
						if(Functions.rand(0,100)<25)
						{
							for(int tid=0;tid<Game.templates.Length;tid++)
							{
								if(!Unit.SpawnerCanBuild(game,spawnerconstraint,tid))//9sep2021
								{
									continue;
								}
								if(faction==Game.templates[tid].faction && Game.templates[tid].walkspeed>0 && Game.templates[tid].bossmonster<=0 && Game.templates[tid].leader<=0 && Game.templates[tid].planar<=0)
								{
									if(Game.templates[tid].kills > maxkill2 && Game.templates[tid].kills < maxkill)
									{
										maxkill2 = Game.templates[tid].kills;
										ktid = tid;
									}
								}
							}
						}
						//Functions.restoreseed();//11apr2021
						if(randomspawncount>0)
						{
							Functions.saveseed();//11apr2021
							int qqq4 = Functions.rand(0,100);//11apr2021
							if(ktid==-1 || (qqq4 < 10 && ktid!=-1))
							{
								Functions.restoreseed();//11apr2021
								randomspawnindex = 1 + (Functions.rand(0,1000) % randomspawncount);
								for(int tid=0;tid<Game.templates.Length;tid++)
								{
									if(!Unit.SpawnerCanBuild(game,spawnerconstraint,tid))//9sep2021
									{
										continue;
									}
									if(faction==Game.templates[tid].faction && Game.templates[tid].walkspeed>0 && Game.templates[tid].bossmonster<=0 && Game.templates[tid].leader<=0 && Game.templates[tid].planar<=0)
									{
										randomspawnindex--;
										if(randomspawnindex<=0)
										{
											ttid = tid;
											break;
										}
									}
								}
							}
							else
							{
								ttid = ktid;
								Functions.restoreseed();//11apr2021
							}
							if(ttid!=-1)
							{
								spawner = Game.templates[ttid].name;
								displayspawner = Game.templates[ttid].dname(); //13mar2021
								spawnertime = Unit.CalculateSpawnerTime(game,ttid);
								framesleft = framecheck * spawnertime;//9sep2021
								if(spawnercount<10)
								{
									//spawnercount++;//12mar2021
									spawnercount+=3;//12mar2021 //to guarantee it keeps on producing and doesn't slow down with time.....
								}
								if(spawnercount<=0)
								{
									spawnercount=1;
								}
							}
							//Functions.restoreseed();//11apr2021
						}
					}
				}
			}
			//end---------------//11mar2021
			//end---------------//10mar2021
			if(selected!=SELECTIONNONE && faction!=Game.PLAYERFACTION && (Game.frame + id) % 15==3)
			{
				//correct this if necessary
				//for(int i=0;i<Game.units.Length;i++) //26mar2021
				for(int i=0;i<=MAXINDEX;i++) //26mar2021
				{
					if(Game.units[i].selected!=SELECTIONNONE && faction==Game.PLAYERFACTION)
					{
						selected=SELECTIONNONE;
						break;
					}
				}
			}
			if(Replay.IsPlaying())//25apr2021
			{
				if(retreat==true && Game.frame > retreatframe && ronscreen==false)
				{
					if(hp>0)
					{
						Game.killed(game,id);
					}
					hp=0;
				}
			}
			else//25apr2021
			{
				if(retreat==true && Game.frame > retreatframe && onscreen==false)
				{
					if(hp>0)
					{
						Game.killed(game,id);
					}
					hp=0;
				}
			}
			if(Replay.IsPlaying())//25apr2021
			{
				if(retreat==true && Game.frame <= retreatframe && ronscreen==false)
				{
					//rallying chance?
					if((Game.frame + id) % framecheck == 0)
					{
						//Functions.saveseed();//11apr2021
						Functions.saveseed();//25apr2021
						if(Functions.rand(0,1000)<Unit.RALLYCHANCE)
						{
							retreat = false;
							retreatframe = 0;
						}
						Functions.restoreseed();//25apr2021
						//Functions.restoreseed();//11apr2021
					}
				}
				
			}
			else
			{
				if(retreat==true && Game.frame <= retreatframe && onscreen==false)
				{
					//rallying chance?
					if((Game.frame + id) % framecheck == 0)
					{
						//Functions.saveseed();//11apr2021
						Functions.saveseed();//25apr2021
						if(Functions.rand(0,1000)<Unit.RALLYCHANCE)
						{
							retreat = false;
							retreatframe = 0;
						}
						Functions.restoreseed();//25apr2021
						//Functions.restoreseed();//11apr2021
					}
				}
			}
			if(Replay.IsPlaying())//25apr2021
			{
				if(retreatframe>0 && ronscreen==true)
				{
					retreatframe++;
				}
			}
			else
			{
				if(retreatframe>0 && onscreen==true)
				{
					retreatframe++;
				}
			}
			//start-------------//4may2021
			if(hp<=0 && flightlevel!=-1)
			{
				int nid = Map.cellflyer(x,y,flightlevel);
				if(nid==id)
				{
					Map.removeflyer(id,x,y,flightlevel);
				}
				return;
			}
			//end---------------//4may2021
			if(hp <= 0)
			{
				int nid = Map.cellunit(x,y);
				if(nid==id)
				{
					if(animmode!=ANIMMODE_DEAD)//13sep2021 (just the if block)
					{
						Map.removeunit(id,x,y);
					}
				}
				return;
			}
			//flying 4may2021
			//
			if(flightlevel!=-1)//4may2021
			{
				if(x > Game.CORNERX - Map.GRIDW*2 && x < Game.CORNERX + Game.RESOLUTIONX + Map.GRIDW*2 && y > Game.CORNERY - Map.GRIDH * 2 && y < Game.CORNERY + Game.RESOLUTIONY + Map.GRIDH * 2)
				{
					Array.Resize(ref Map.flightlist,Map.flightlist.Length + 1);
					Map.flightlist[Map.flightlist.Length - 1] = id;
				}	
			}
			//end flying
			
			if(timid>0)
			{
				if((Game.frame + id) % (2 * framecheck)==0)
				{
					//Functions.saveseed();//11apr2021
					int dieroll = Functions.rand(0,100);
					int pcthp = hp * 100 / basehp;
					if(dieroll>pcthp)
					{
						retreat = true;
						retreatframe = Game.frame + Unit.RETREATDEATH;
					}
					//Functions.restoreseed();//11apr2021
				}
			}
			if(faction==Game.PLAYERFACTION)
			{
				infog = false;
			}
			else
			{
				if(Game.EDITOR)
				{
					infog = false;
				}			
			}
			//start-------------//9mar2021
			if(defendx!=-1 && defendy!=-1)
			{
				if(((Game.frame+id) % 180)==11)
				{
					tx = defendx;
					ty = defendy;
					tmptx = tx;//12mar2021
					tmpty = ty;//12mar2021
					if(Functions.abs(x - tx)>Unit.GUARDRANGE && Functions.abs(y - ty)>Unit.GUARDRANGE)//12mar2021
					{
						firetargeti = -1;//12mar2021
						orderframe = Unit.ORDERTIME; //12mar2021
						tmptattempts = 0; //12mar2021
					}
				}
			}
			//end---------------//9mar2021
			//start-------------//14oct2021
			if(frenzy<=0 && firebullet<=0 && battlejoined==0)//23oct2021 added battlejoined
			{
				int numberofenemyarchers = 0;
				int numberoffriendlyarchers = 0;
				int numberofattacksgoingon = 0;
				for(int i=0;i<Game.units.Length;i++)
				{
					if(Game.units[i].hp>0 && Game.units[i].firebullet>0)
					{
						if(Game.units[i].faction==faction)
						{
							numberoffriendlyarchers++;
						}
						else
						{
							numberofenemyarchers++;
						}
					}
					if(Game.units[i].hp>0 && Game.units[i].firebullet<=0 && Game.units[i].animmode==Unit.ANIMMODE_ATTACK)
					{
						numberofattacksgoingon++;
						battlejoined=1;
					}
				}
				//added = to this to fix a slight bug.....
				if(numberofenemyarchers >= (numberoffriendlyarchers * 3) / 2)//18oct2021
				{
					//attack as normal
				}
				else
				{
					//potentially don't attack......
					//if we've not yet engaged...then don't......
					if(numberofattacksgoingon<=0 && battlejoined==0)
					{
						if(Functions.rand(0,1000)<990)
						{
							firetargeti = -1;
							tx = x;
							ty = y;
							tmptx = x;
							tmpty = y;
						}
					}
				}
			}
			//end---------------//14oct2021
			//start-------------//14oct2021
			/*
			if(boardi!=-1)
			{
				//try and stay near our group....
				//that we were deployed with....
				if((Game.frame + id)%50==0 && retreat==false)
				{
					//scan the map for our friends.....
					for(int gx=0;gx<Game.RESOLUTIONX;gx+=Map.GRIDW)
					{
						for(int gy=0;gy<Game.RESOLUTIONY;gy+=Map.GRIDH)
						{
							int nid = Map.cellunit(gx,gy);
							if(nid!=Map.VACANT)
							{
								if(Game.units[nid].hp>0 && Game.units[nid].faction==faction && Game.units[nid].boardi==boardi && Game.units[nid].retreat==false)
								{
									//one of our squad mates....
									float gdist = Functions.abs(Game.units[nid].x - x) + Functions.abs(Game.units[nid].y - y);
									if(gdist > Map.GRIDW * 10) //more than 10 cells away from us in steps....that's equivalent to a third of the way down the screen effectively...
									{
										tx = Game.units[nid].x;
										ty = Game.units[nid].y;
										tmptx = tx;
										tmpty = ty;
										tmptattempts = 0 ;
										firetargeti = -1;
										orderframe = 25; //  a small number.....
									}
								}
							}
						}
					}
				}
			}
			*/
			//end---------------//14oct2021
			if(tmptframe>0)
			{
				tmptframe--;
			}
			else
			{
				tmptx = tx;
				tmpty = ty;
				if(Game.gamestate==Game.CAT_GAMESTATE_GAME && ((Game.frame + id)%30)==19){quickpathfind(x,y,tx,ty);}//28apr2021
			}
			//26oct2020
			//if(faction==Game.SKIRMISHENEMYFACTION && Game.skirmish==true)
			if(faction!=Game.PLAYERFACTION && Game.skirmish==true && faction!=Unit.NULLFACTION)
			{
				//Functions.saveseed();//11apr2021
				int cpoint = ((int)Functions.rand(0,10000) % 1000);
				if(firetargeti==-1)
				{
					if(orderframe<=0)
					{
						if((Game.frame + id)%framecheck==13)
						{
							//for(int i=0;i<Game.units.Length;i++)//26mar2021
							for(int i=0;i<=MAXINDEX;i++)//26mar2021
							{
								if(Game.units[i].controlpoint==1 && cpoint < 250)
								{
									//26oct2020
									//if(Game.units[i].controller!=Game.SKIRMISHENEMYFACTION) 
									if(Game.units[i].controller==Game.PLAYERFACTION || Game.units[i].controller!=faction)	
									{
										tx = Game.units[i].x;
										ty = Game.units[i].y;
										orderframe = Unit.ORDERTIME;
										firetargeti	= -1;
										tmptattempts = 0;
										break;
									}
								}
							}
						}
					}
				}
				//Functions.restoreseed();//11apr2021
			}
			if(orderframe>0)
			{
				orderframe--;
			}
			if(hp<basehp && regeneration>0 && ((Game.frame+id) % framecheck)==0)
			{
				hp+=regeneration;
				if(hp>basehp)
				{
					hp = basehp;
				}
			}
			//if(Map.isonfire(x,y))//4may2021
			if(Map.isonfire(x,y) && flightlevel==-1)//4may2021
			{
				if((Game.frame + id) % framecheck==0 && firespell==0)
				{
					//take damage....
					if(hp>0)//25Feb2021
					{
						hp--;
						if(hp<=0)
						{
							Game.killed(game,id);
						}
					}//25Feb2021
				}
			}
			drawn = false;
			if(Game.demomode)
			{
				if((Game.frame + id) % (framecheck*20)==0)
				{
						tx = x + 500 * (int)Functions.sign(1600 - x);
						ty = y;
						orderframe = Unit.ORDERTIME;
						firetargeti = -1;
						tmptattempts = 0;
				}
			}
			if(Game.RESOLVE>0)//17oct2021
			{
				if(Game.chosenmissionindex==1)//victory
				{
					if(faction==5)
					{
						retreat = true;
					}
					else
					{
						retreat = false;
					}
				}
				if(Game.chosenmissionindex==2)//defeat
				{
					if(faction==6)
					{
						retreat = true;
					}
					else
					{
						retreat = false;
					}
				}
			}
		}

		
		
///////////////////Method Definition///////////////
		public static void updateall(Game game)
		{
			//method that handles updating all units in game during gameplay
			Game.groupselected = -1;//21mar2021
			Game.anyselected = false;//16apr2021
			bool friendlyselected = false;//20apr2021
			int enemyselected = -1;//20apr2021
			Stopwatch utimer = new Stopwatch();
			utimer.Start();
			long atime = 0;
			long utime = 0;
			long atttime = 0;
			long wtime = 0;
			long ttime = 0;
			Game.SPAWNERSELECTED = false; //10mar2021
			Game.NONSPAWNERSELECTED = false;//11mar2021
			Tech.TECHUNITSELECTED = false;//2sep2021
			Tech.TECHUNITIDSELECTED = -1;//2sep2021
			//start-------------//9mar2021
			Map.flightlist = new int[0];//4may2021
			Unit.circlesmax = 0;//2jun2021
			for(int i=0;i<Game.templates.Length;i++)
			{
				if(Game.templates[i].livecount!=Game.templates[i].olivecount)
				{
					Game.templates[i].livecountframe = 45;
				}
				else
				{
					if(Game.templates[i].livecountframe>0)
					{
						Game.templates[i].livecountframe--;
					}
				}
				Game.templates[i].olivecount = Game.templates[i].livecount;
				Game.templates[i].livecount = 0;
				Game.templates[i].selectioncount = 0;//22mar2021
			}
			//end---------------//9mar2021
			//start---------------//26mar2021
			if(Game.units[MAXINDEX].hp<=0 && Game.units[MAXINDEX].timedead>MAXDEADTIME && MAXINDEX>0)
			{
				MAXINDEX--;
			}
			//end-----------------//26mar2021
			Game.checksum = 0;//2apr2021
			for(int i=0;i<Game.units.Length;i++)
			{
				//23oct2021 made same as mobile version
				if(Game.units[i].isdead==0 && Game.units[i].hp<=0)//23oct2021
				{
					//for performance.
					continue;
				}
				//start---------------//26mar2021
				if((Game.units[i].hp>0 || Game.units[i].timedead<MAXDEADTIME) && i>MAXINDEX)
				{
					MAXINDEX = i;
				}
				if(Game.units[i].selected!=Unit.SELECTIONNONE && Game.units[i].hp>0 && Game.units[i].walkspeed>0 && Game.units[i].faction==Game.PLAYERFACTION)//16apr2021
				{
					Game.anyselected = true;
					friendlyselected = true;//20apr2021
				}
				if(Game.units[i].selected!=Unit.SELECTIONNONE && Game.units[i].faction!=Game.PLAYERFACTION)
				{
					enemyselected = i;
				}
				Game.checksum+=Game.units[i].hp+Game.units[i].x+Game.units[i].y;//2apr2021
				if(Game.units[i].hp<=0) //24apr2021
				{
					Game.units[i].selected = Unit.SELECTIONNONE;
				}
				//end-----------------//26mar2021
				Unit.CorrectTransport(game,i);//3may2021///in case stuff goes wrong..it shouldn't though......
				if(Game.units[i].transportedbyid!=-1)//3may2021
				{
					Game.units[i].onscreen = false;
					Game.units[i].ronscreen = false;
					continue;
					//we don't want to update units that are inside transports...they should do nothing.....
					//until they are out of the transport.....
				}
				//start-------------//2jun2021
				if((Game.units[i].boardx + Game.units[i].boardy * 10)==Game.firstcell && Game.units[i].hp>0)
				{
					Unit.circles[Unit.circlesmax] = i;
					Unit.circlesmax++;
					if(Unit.circlesmax>=MAXUNITS) //should never be needed
					{
						Unit.circlesmax=MAXUNITS - 1;
					}
				}
				//end---------------//2jun2021
				//start-------------//2sep2021
				if(Config.USETECH)
				{
					Game.units[i].walkspeed+=Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.MV);
					Game.units[i].damage+=Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.BA);
					Game.units[i].armour+=Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.BD);
					Tech.TARGETUID = i;
					Tech.ADDSUBTRACT = 1;
					Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.BZ);
				}
				//end---------------//2sep2021
				Beacon.ApplyBeaconPull(i);//19oct2021
				ttime = utimer.ElapsedMilliseconds;
				Game.units[i].animate(game);//includes flying as of 4may2021
				atime+= Math.Abs(utimer.ElapsedMilliseconds - ttime);
				ttime = utimer.ElapsedMilliseconds;
				Game.units[i].update(game);
				utime+= Math.Abs(utimer.ElapsedMilliseconds - ttime);
				if(!Game.EDITOR)
				{
					ttime = utimer.ElapsedMilliseconds;
					Game.units[i].actionattack(game);
					atttime+= Math.Abs(utimer.ElapsedMilliseconds - ttime);
				}
				ttime = utimer.ElapsedMilliseconds;
				//Game.units[i].walk(game,Game.units[i].tmptx - Game.units[i].x,Game.units[i].tmpty - Game.units[i].y);
				Game.units[i].tmpwalkspeed = Game.units[i].walkspeed;//7oct2021
				if(Game.units[i].spellwalkspeed>0)//18oct2021
				{
					Game.units[i].tmpwalkspeed = Game.units[i].spellwalkspeed;
				}
				//start---------//14oct2021
				if(!Map.israining)
				{
					if(Game.units[i].retreat)
					{
						Game.units[i].walkspeed = Game.units[i].tmpwalkspeed + 1;
					}
					if(Game.units[i].firetargeti!=-1 && Game.units[i].retreat==false && Game.units[i].frenzy>0)
					{
						float gdist = Functions.abs(Game.units[i].x - Game.units[Game.units[i].firetargeti].x) + Functions.abs(Game.units[i].y - Game.units[Game.units[i].firetargeti].y);
						if(gdist < Map.GRIDW * 4)
						{
							if(Game.units[i].tmpwalkspeed==3)
							{
								Game.units[i].walkspeed = 4;
							}
							if(Game.units[i].tmpwalkspeed==2)
							{
								Game.units[i].walkspeed = 3;
							}
						}
					}
				}
				//end---------//14oct2021
				if(Map.weather==Map.WEATHERCOLD)//7oct2021 weather effects.....
				{
					if(Game.units[i].walkspeed==2)
					{
						if(Game.units[i].leader<=0 && Game.units[i].brave<=0)
						{
							Game.units[i].walkspeed = 1;
						}
					}
					if(Game.units[i].walkspeed>2)
					{
						Game.units[i].walkspeed=2;
					}
				}
				if(Map.weather==Map.WEATHERHOT)
				{
					if(Game.units[i].armour>=9)//heavily armoured units slow down....tire in the heat
					{
						Game.units[i].walkspeed--;
						if(Game.units[i].walkspeed<1)
						{
							Game.units[i].walkspeed=1;
						}
					}
				}
				Game.units[i].walk(game,Game.units[i].tmptx - Game.units[i].x,Game.units[i].tmpty - Game.units[i].y);
				//Game.units[i].walkspeed = Game.units[i].tmpwalkspeed;//7oct2021//20oct2021
				
				if(Config.USEDELTATIME>0)//18sep2021
				{
					if(Config.delta > 150)
					{
						int ndelta = (Config.delta - (Config.delta % 100)) / 100;
						for(int nd=0;nd<ndelta;nd++)
						{
							Game.units[i].walk(game,Game.units[i].tmptx - Game.units[i].x,Game.units[i].tmpty - Game.units[i].y);
						}
					}
				}
				Game.units[i].walkspeed = Game.units[i].tmpwalkspeed;//7oct2021//20oct2021
			
				wtime+= Math.Abs(utimer.ElapsedMilliseconds - ttime);
				Game.units[i].onscreen = false;
				Game.units[i].ronscreen = false;//25apr2021
				//start-------------//2sep2021
				if(Config.USETECH)
				{
					Game.units[i].walkspeed-=Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.MV);
					Game.units[i].damage-=Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.BA);
					Game.units[i].armour-=Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.BD);
					Tech.TARGETUID = i;
					Tech.ADDSUBTRACT = -1;
					Tech.AddUnitUpgradeBuff(game,Game.units[i].templateid,Tech.BZ);
				}
				//end---------------//2sep2021
			}
			for(int i=0;i<Game.units.Length;i++)
			{
				if(Game.units[i].isdead>0)
				{
					Game.units[i].isdead=2;
					Game.units[i].hp=0;
					Game.killed(game, i);
				}
			}
			if(enemyselected!=-1 && friendlyselected==true)//20apr2021
			{
				Game.units[enemyselected].selected=Unit.SELECTIONNONE;
			}
			utimer.Reset();
			if(atime > Config.maxanimate || Game.frame % 300==0)
			{
				Config.maxanimate = atime;
			}
			if(utime > Config.maxupdate || Game.frame % 300 == 0)
			{
				Config.maxupdate = utime;
			}
			if(atttime > Config.maxatt || Game.frame % 300 == 0)
			{
				Config.maxatt = atttime;
			}
			if(wtime > Config.maxwalk || Game.frame % 300 == 0)
			{
				Config.maxwalk = wtime;
			}
		}

///////////////////Method Definition///////////////
		public static void drawall(Game game)
		{
			//draw all units on the screen currently
			//draw in sorted order......down the screen from low y to high y
			if(Map.issnow)
			{
				RenderList.drawrect(game,0,0,Game.RESOLUTIONX,Game.RESOLUTIONY,RenderList.getrgb(182,191,180),0);
			}
			if(Map.isdesert)
			{
				RenderList.drawrect(game,0,0,Game.RESOLUTIONX,Game.RESOLUTIONY,RenderList.getrgb(109,96,37),0);
			}
			if(Map.isrgbbk) //1nov2020
			{
				RenderList.drawrect(game,0,0,Game.RESOLUTIONX,Game.RESOLUTIONY,RenderList.getrgb(Map.isrgbbk_r,Map.isrgbbk_g,Map.isrgbbk_b),0);
			}
			if(Map.isdesert==false && Map.issnow==false && Map.isrgbbk==false)
			{
				RenderList.drawrect(game,0,0,Game.RESOLUTIONX,Game.RESOLUTIONY,RenderList.getrgb(103,105,63),0);
			}
			Map.dirtymap = true;//20sep2021
			//start----------------//20oct2021
			for(int y=Game.CORNERY/Map.GRIDH - 2;y<(Game.CORNERY+Game.RESOLUTIONY)/Map.GRIDH + 2;y++)
			{
				for(int x=Game.CORNERX/Map.GRIDW - 2;x<(Game.CORNERX+Game.RESOLUTIONX)/Map.GRIDW + 2;x++)
				{
					if(Map.TileFog(game,x,y)==0)//15sep2021
					{
						Map.draw(game,x*Map.GRIDW,y*Map.GRIDH,-1); //the ground contents...if any.....
					}
				}
			}
			if(Map.hillson>0)
			{
				if(Map.weather==Map.WEATHERCOLD && Map.hillsnow!=-1)
				{
					RenderList.drawimage(null,Game.images[Map.hillsnow].texture,800,450,0,1,1,0,0,false,1f,Map.hillsnow);	
				}
				if(Map.weather==Map.WEATHERHOT && Map.hilldesert!=-1)
				{
					RenderList.drawimage(null,Game.images[Map.hilldesert].texture,800,450,0,1,1,0,0,false,1f,Map.hilldesert);	
				}
				if(Map.weather==Map.WEATHERNORMAL && Map.hillgrass!=-1)
				{
					RenderList.drawimage(null,Game.images[Map.hillgrass].texture,800,450,0,1,1,0,0,false,1f,Map.hillgrass);	
				}
			}
			//end------------------//20oct2021
			for(int y=Game.CORNERY/Map.GRIDH - 2;y<(Game.CORNERY+Game.RESOLUTIONY)/Map.GRIDH + 2;y++)
			{
				for(int x=Game.CORNERX/Map.GRIDW - 2;x<(Game.CORNERX+Game.RESOLUTIONX)/Map.GRIDW + 2;x++)
				{
					if(Map.TileFog(game,x,y)==0)//15sep2021
					{
						Map.draw(game,x*Map.GRIDW,y*Map.GRIDH,0); //the ground contents...if any.....
					}
				}
			}
			//start---------------------------//18sep2021
			for(int y=Game.CORNERY/Map.GRIDH - 2;y<(Game.CORNERY+Game.RESOLUTIONY)/Map.GRIDH + 2;y++)
			{
				for(int x=Game.CORNERX/Map.GRIDW - 2;x<(Game.CORNERX+Game.RESOLUTIONX)/Map.GRIDW + 2;x++)
				{
					if(Map.TileFog(game,x,y)==0)//15sep2021
					{
						Map.draw(game,x*Map.GRIDW,y*Map.GRIDH,Map.DECOR); //the ground contents...if any.....
					}
				}
			}
			//end-----------------------------//18sep2021
			//start------------//25apr2021
			if(Replay.IsPlaying())
			{
					Game.TMPCORNERX = Game.CORNERX;
					Game.TMPCORNERY = Game.CORNERY;
					Game.CORNERX = Game.RCORNERX;
					Game.CORNERY = Game.RCORNERY;
					for(int y=Game.CORNERY/Map.GRIDH - 2;y<(Game.CORNERY+Game.RESOLUTIONY)/Map.GRIDH + 4;y++)
					{
						for(int x=Game.CORNERX/Map.GRIDW - 2;x<(Game.CORNERX+Game.RESOLUTIONX)/Map.GRIDW + 2;x++)
						{
							int id = Map.cellunit(x*Map.GRIDW,y*Map.GRIDH);
							if(id!=-1)
							{ 
								//if the unit is drawn then onscreen would have been true....
								//so we need to set ronscreen to true as well.....
								Game.units[id].ronscreen = true;
							}
						}
					}			
					Game.CORNERX = Game.TMPCORNERX;
					Game.CORNERY = Game.TMPCORNERY;
			}
			//end--------------//25apr2021
			//start------------------------//2jun2021
			for(int i=0;i<Unit.circlesmax;i++)
			{
				//draw unit circles....
				int id = Unit.circles[i];
				if(id!=-1)
				{
					if(Game.units[id].x < Game.CORNERX - Map.GRIDW * 2 || Game.units[id].x > Game.CORNERX + Game.RESOLUTIONX + Map.GRIDW * 2 || Game.units[id].y < Game.CORNERY - Map.GRIDH * 2 || Game.units[id].y > Game.CORNERY + Game.RESOLUTIONY + Map.GRIDH * 2)
					{
						continue;
					}
					if(Config.USEFEETCIRCLES)
					{
						{
							if(Game.iconcircles!=-1)
							{
								float cc = 0.8f;
								int cw0 = Game.units[id].cw;
								int ch0 = Game.units[id].ch;
								if(cw0<70)
								{
									cw0 = 70;
								}
								if(ch0<85)
								{
									ch0 = 85;
								}
								if(Game.units[id].faction==Game.PLAYERFACTION)
								{
									//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,0,0,false,1f,Game.iconcircles);	
									//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,0,1,false,0.25f,Game.iconcircles);	
									RenderList.drawimage(game,Game.images[Game.iconcircles].texture,Game.units[id].x-Game.CORNERX,Game.units[id].height + Game.units[id].y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,0,0,false,1f,Game.iconcircles);	
									RenderList.drawimage(game,Game.images[Game.iconcircles].texture,Game.units[id].x-Game.CORNERX,Game.units[id].height + Game.units[id].y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,0,1,false,0.25f,Game.iconcircles);	
								}
								else
								{
									//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,1,0,false,1f,Game.iconcircles);	
									//RenderList.drawimage(game,Game.images[Game.iconcircles].texture,x-Game.CORNERX + offx,height + y-Game.CORNERY + offy,0,cc * cw / Game.images[Game.iconcircles].cwx,cc * ch / Game.images[Game.iconcircles].chy,1,1,false,0.25f,Game.iconcircles);	
									RenderList.drawimage(game,Game.images[Game.iconcircles].texture,Game.units[id].x-Game.CORNERX,Game.units[id].height + Game.units[id].y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,1,0,false,1f,Game.iconcircles);	
									RenderList.drawimage(game,Game.images[Game.iconcircles].texture,Game.units[id].x-Game.CORNERX,Game.units[id].height + Game.units[id].y-Game.CORNERY,0,cc * cw0 / Game.images[Game.iconcircles].cwx,cc * ch0 / Game.images[Game.iconcircles].chy,1,1,false,0.25f,Game.iconcircles);	
								}
							}
				
						}
					}
				}
			}
			//end--------------------------//2jun2021
			for(int y=Game.CORNERY/Map.GRIDH - 2;y<(Game.CORNERY+Game.RESOLUTIONY)/Map.GRIDH + 4;y++)
			{
				for(int x=Game.CORNERX/Map.GRIDW - 2;x<(Game.CORNERX+Game.RESOLUTIONX)/Map.GRIDW + 2;x++)
				{
					if(Map.TileFog(game,x,y)==0)//15sep2021
					{
						Map.draw(game,x*Map.GRIDW,y*Map.GRIDH,1); //the ground contents...if any.....
					}
					else//15sep2021
					{
							continue;
					}
					int id = Map.cellunit(x*Map.GRIDW,y*Map.GRIDH);
					if(id!=-1)
					{
						//start-----------------//20mar2021
						//Game.units[id].draw(game);	
						//some overdraw but that is fine.....
						int savedirn = Game.units[id].dirn; //29may2021
						if(Config.SLOWROTATE)//29may2021
						{
							if(Game.units[id].walkspeed>1)//20oct2021
							{
								Game.units[id].dirn = Game.units[id].displaydirn;//29may2021
							}
						}
						int lid = Map.cellunit((x-1)*Map.GRIDW,y*Map.GRIDH);
						int rid = Map.cellunit((x+1)*Map.GRIDW,y*Map.GRIDH);
						if(lid!=-1)// && rid==-1)
						{
							//left of us is occupied and right of us is not....
							if(Game.units[lid].y > Game.units[id].y)
							{
								Game.units[id].draw(game);	
								Game.units[lid].draw(game);	
							}
							else
							{
								Game.units[id].draw(game);	
							}
						}
						else
						{
							Game.units[id].draw(game);	
						}
						if(Game.mouseoverunitid==id)
						{
							Game.units[id].drawhealthbar(game);
						}
						Game.units[id].dirn = savedirn; //29may2021
						/*
						if(lid==-1 && rid!=-1)
						{
							//left of us is empty and right of us is not
							if(Game.units[rid].y <= Game.units[id].y)
							{
								//draw nothing....
							}
							else
							{
								Game.units[id].draw(game);	
							}
						}
						if(lid!=-1 && rid!=-1)
						{
							//neither left nor right are empty....
							if(Game.units[lid].y > Game.units[id].y)
							{
								Game.units[id].draw(game);	
								Game.units[lid].draw(game);	
							}
							else
							{
								//this will be slightly incorrect.....
								//if(Game.units[rid].y <= Game.units[id].y)
								//{
									
								//}
								//else
								//{
									Game.units[id].draw(game);		//some overdraw will occur.....
								//}
							}
						}
						*/
						//end-------------------//20mar2021
						
					}
				}
			}
			if(Config.ALLOWFLYING)//4may2021
			{
				for(int f=0;f<Map.flightlist.Length;f++)
				{
					int nid = Map.flightlist[f];
					if(nid!=-1)
					{
						if(Config.TILEFOG>0)//15sep2021
						{
							if(!Map.TileVisible(Game.units[nid].x,Game.units[nid].y))
							{
								continue;
							}
						}
						int savedirn = Game.units[nid].dirn;//29may2021
						if(Config.SLOWROTATE)//29may2021
						{
							if(Game.units[nid].walkspeed>1)//20oct2021
							{
								Game.units[nid].dirn = Game.units[nid].displaydirn;//29may2021
							}
						}
						Game.units[nid].draw(game);//
						Game.units[nid].dirn = savedirn; //29may2021
					}
				}
			}
			//start------------------------//2jun2021
			for(int i=0;i<Unit.circlesmax;i++)
			{
				int id = Unit.circles[i];
				if(id!=-1)
				{
					if(Game.units[id].x < Game.CORNERX - Map.GRIDW * 2 || Game.units[id].x > Game.CORNERX + Game.RESOLUTIONX + Map.GRIDW * 2 || Game.units[id].y < Game.CORNERY - Map.GRIDH * 2 || Game.units[id].y > Game.CORNERY + Game.RESOLUTIONY + Map.GRIDH * 2)
					{
						continue;
					}
					//Game.units[id].drawhealthbar(game);
				}
				Unit.circles[i] = -1; //reset afterwards.....
			}
			//end--------------------------//2jun2021
			if(!Game.EDITOR)
			{
				Map.fogdraw(game);
			}
		}

///////////////////Method Definition///////////////
		public void reset(Game game,int i)
		{		
			//initialisation
			if(circles==null)//2jun2021
			{
				circles = new int[MAXUNITS];//2jun2021
				for(int j=0;j<MAXUNITS;j++)//2jun2021
				{
					circles[j] = -1; //2jun2021
				}
			}
			spellwalkspeed = 0;//18oct2021
			
			isdead = 0;
			boardx = -1;
			boardy = -1;
			boardi = -1;
			lightningdeath = 0;//19oct2021
			scale = 1;//25sep2021
			prefermobiletargets=0;//18sep2021
			charactername = "";//10sep2021
			ping = 0;//17sep2021
			redping = -1;//17sep2021
			displaycharactername = 0;//10sep2021
			casting = false;//28mar2021
			cursed = false; //21mar2021
			buffed = false; //21mar2021
			flightlevel = -1;//4may2021
			gold = -1;//23sep2021
			canpickup = 0;//23sep2021
			guiattackdisplaylimit = 0;//23sep2021
			misfire = 0;//28mar2021
			timedead = MAXDEADTIME; //25mar2021
			retreatframe = 0;
			retreat = false;
			defendx = -1; //9mar2021
			defendy = -1; //9mar2021
			id = i;
			selected = Unit.SELECTIONNONE;
			drawn = false;
			dirn = (Functions.rand(0,100) % 8);
			firetargeti = -1;
			groupid = -1;
			transforminto = "";//3may2021
			transformrequires = "";//3may2021
			transportcapacity = 0;//3may2021
			transportsize = 1;//3may2021
			transportedbyid = -1;//4may2021
			controlmode = "";//24sep2021
			x = 0;
			y = 0;
			tx = x;
			ty = y;
			tmptx = -1;
			tmpty = -1;
			xp = 0;
			tmptframe = 0;
			angle = 0;
			oanimmode = -1;
			animmode = ANIMMODE_IDLE;
			animrest = 0;
			animframe = animmodeidleframestart;
			spawner = "";
			spawnerconstraint = "*";//9sep2021
			displayspawner = "";
			//magicarray = new int[9];
			//almost always followed by createunitatxy which
			//populates all the template values
			//and hence we don't need to initialise them here.
		}

///////////////////Method Definition///////////////
		public bool createunitatxy(Game game,int id,Unit template,int x, int y)
		{
			//create a unit at this position from a specific template
			if(Config.EVENTHEMUP>0 && Game.RESOLVE<=0 && Game.gamestate==Game.CAT_GAMESTATE_GAME)//eg during deployment only....
			{
				if(y>Game.RESOLUTIONY/2)
				{
					for(int j=0;j<Game.units.Length-2;j+=2)
					{
						if(Game.units[j].hp<=0)
						{
							id = j;
							break;
						}
					}
				}
				else
				{
					for(int j=1;j<Game.units.Length-2;j+=2)
					{
						if(Game.units[j].hp<=0)
						{
							id = j;
							break;
						}
					}
					
				}
			}
			if(Map.cellunit(x,y)==Map.VACANT && Map.passable(x,y)==true)
			{
				reset(game,id);
				Unit.copyunitstats(template,ref Game.units[id]);
				if(HASLEADER>0)//21oct2021
				{
					Game.units[id].leader = 1;
				}
				HASLEADER = 0;//21oct2021
				Game.units[id].x = x;
				Game.units[id].y = y;
				Game.units[id].tx = x;
				Game.units[id].ty = y;
				Game.units[id].tmptx = x;
				Game.units[id].tmpty = y;
				Game.units[id].dieonce = -1;//13sep2021
				Game.units[id].boardx = x / 160;
				Game.units[id].boardy = y / Game.BOARDY;
				Game.units[id].boardi = (x / 160)  + (y / Game.BOARDY) * 10;
				Game.units[id].originaltemplateid = template.id; //for server......
				if(Game.RESOLVE<1)
				{
					Game.units[id].faction = Unit.NULLFACTION;
				}
				if(Game.units[id].name.IndexOf("hero")>=0  && Game.templates[template.id].name.IndexOf(Game.FriendArmy)>=0)//13oct2021
				{
					Game.templates[Game.units[id].templateid].faction = 6;
					Game.units[id].faction = 6;
				}
				if(Game.units[id].name.IndexOf("hero")>=0  && Game.templates[template.id].name.IndexOf(Game.EnemyArmy)>=0)//13oct2021
				{
					Game.templates[Game.units[id].templateid].faction = 5;
					Game.units[id].faction = 5;
				}
				
				Game.units[id].animmode = Unit.ANIMMODE_IDLE;
				if(Map.insertunit(id,x,y))
				{
					Game.templates[template.id].creates++;
				}
				if(id>Unit.MAXINDEX)//11apr2021
				{
					Unit.MAXINDEX = id;
				}
				//start---------------//2sep2021
				if(Config.USETECH)
				{
					Game.units[id].hp+=Tech.AddUnitUpgradeBuff(game,template.id,Tech.BH);
					Game.units[id].basehp+=Tech.AddUnitUpgradeBuff(game,template.id,Tech.BH);
				}
				//end-----------------//2sep2021
				//start---------------//14sep2021
				if(Game.units[id].canfly>0)
				{
					if(Map.cellflyer(Game.units[id].x,Game.units[id].y,Map.FLIGHTLEVELS - 1)==-1)
					{
						Map.removeunit(id,Game.units[id].x,Game.units[id].y);
						Game.units[id].flightlevel = Map.insertflyer(id,Game.units[id].x,Game.units[id].y);
						Game.units[id].animmode = ANIMMODE_FLY;
						Game.units[id].retreat = false;
						Game.units[id].retreatframe = 0;
						Game.units[id].tmptattempts = 0;
						Game.units[id].tmptframe = 0;
						if(Game.units[id].flightlevel==-1)
						{
							Game.units[id].hp = 0; //bugger - we don't really want this to happen though....so we will prevent it through other means....
						}
					}
				}
				//end-----------------//14sep2021
				return true;
			}
			HASLEADER = 0;//21oct2021
			return false;
		}

///////////////////Method Definition///////////////

		public int prevanimframe = 0;
		
		
		public void walk(Game game,int dx,int dy)
		{
			//walk or move the unit about the map handling collisions
			if(hp <= 0)
			{
				return;
			}
			if((Game.frame + id) % WALKMOD>=WALKRATE)//14oct2021
			{
				return;
			}
			if(Functions.abs(tmptx-x)<=walkspeed+2)
			{
				tmptx = x;
				dx = 0;
			}
			if(Functions.abs(tmpty-y)<=walkspeed+2)
			{
				tmpty = y;
				dy = 0;
			}
			if(dx==0 && dy==0)
			{
				if(animmode==ANIMMODE_WALK)
				{
					animmode = ANIMMODE_IDLE;
				}
				//tmptattempts = 0;
				return;
			}
			int ddx = Functions.sign(dx);
			int ddy = Functions.sign(dy);
			odirn = dirn;
			if(dirntime>0)
			{
				dirntime--;
			}
			if(dirntime<=0)
			{
				dirntime = Unit.DIRNDELAY;
				if(ddx==0 && ddy==-1)
				{
					//up
					dirn = DIRN_UP;
				}
				if(ddx==1 && ddy==-1)
				{
					//upright
					dirn = DIRN_UPRIGHT;
				}
				if(ddx==1 && ddy==0)
				{
					//right
					dirn = DIRN_RIGHT;
				}
				if(ddx==1 && ddy==1)
				{
					//downright
					dirn = DIRN_DOWNRIGHT;
				}
				if(ddx==0 && ddy==1)
				{
					//down
					dirn = DIRN_DOWN;
				}
				if(ddx==-1 && ddy==1)
				{
					//downleft
					dirn = DIRN_DOWNLEFT;
				}
				if(ddx==-1 && ddy==0)
				{
					//left
					dirn = DIRN_LEFT;
				}
				if(ddx==-1 && ddy==-1)
				{
					//upleft
					dirn = DIRN_UPLEFT;
				}
			}
			if(animrest>0)
			{
				animrest--;
			}
			if(animrest>0 || animmode>ANIMMODE_WALK)
			{
				if(animmode!=ANIMMODE_FLY) //2sep2021
				{
					return;
				}
			}
			if(faction==Unit.UNDEAD) //?huh?26oct2020
			{
				if(Game.frame % Unit.UNDEADWALKRATE!=0)
				{
					return;
				}
			}
			//check if there is another unit here......
			//we really should do this with a maparray rather than cycling through everything.....
			
			//start---------//20oct2021
			//check if going up hill.....if so move slower if we are speed > 2
			int hx = x + ddx * Map.GRIDW;
			int hy = y + ddy * Map.GRIDH;
			if(Map.ishill(hx,hy) && !Map.ishill(x,y))
			{
				//going up hill......
				if(walkspeed>1)
				{
					walkspeed=1;
				}
			}
			if(Map.ishill(x,y) && !Map.ishill(hx,hy))
			{
				if(walkspeed<3)
				{
					walkspeed=3;
				}
			}
			//end--------//20oct2021
			
			int nx = x + ddx*walkspeed;
			int ny = y + ddy*walkspeed;
			
			int nid2 = Map.cellunit(x + ddx * Map.GRIDW,y + ddy * Map.GRIDH);//14oct2021
			if(nid2!=Map.VACANT && nid2 != id)//14oct2021
			{
				int x2 = Game.units[nid2].x;//14oct2021
				int y2 = Game.units[nid2].y;//14oct2021
				if(Functions.abs(x-x2)<COLDIST && Functions.abs(y-y2)<COLDIST)//14oct2021
				{
					return;	
				}
			}
			
			//int nnx = x + ddx * (walkspeed + Map.GRIDW);//21apr2021
			//int nny = y + ddy * (walkspeed + Map.GRIDH);//21apr2021
			int nid = Map.cellunit(nx,ny);
			//start-----------------------//4may2021
			//flying
			if(Config.ALLOWFLYING)
			{
				if(flightlevel!=-1)
				{
					animmode = ANIMMODE_FLY;
					if(Map.cellflyer(nx,ny,Map.FLIGHTLEVELS - 1)==-1)
					{
						bool movedgrid = false;//2sep2021
						if(nx/Map.GRIDW!=x/Map.GRIDW || ny/Map.GRIDH!=y/Map.GRIDH)//2sep2021
						{
							movedgrid = true;
							Map.removeflyer(id,x,y,flightlevel);
						}
						x+=ddx*walkspeed;
						y+=ddy*walkspeed;
						if(movedgrid)//2sep2021
						{
							flightlevel = Map.insertflyer(id,x,y);
						}
						if(flightlevel==-1)
						{
							hp = 0; //bugger - we don't really want this to happen though....so we will prevent it through other means....
							return;
						}
					}
					if(canflyandwalk>0)
					{
						//should we return to ground?
						if(Map.passable(nx,ny) && nid==Map.VACANT)
						{
							Map.removeflyer(id,x,y,flightlevel);
							flightlevel = -1;
							//good! we've returned to Earth...
							animmode = ANIMMODE_WALK;
							//will insert into map cell in a moment....
						}
					}
				}
				else
				{
					//we are not flying currently.....
					//but....should we try to?
					if(canflyandwalk>0)
					{
						if(!Map.passable(nx,ny))
						{
							if(Map.cellflyer(nx,ny,Map.FLIGHTLEVELS - 1)==-1)
							{
								Map.removeunit(id,x,y);
								x+=ddx*walkspeed;
								y+=ddy*walkspeed;
								flightlevel = Map.insertflyer(id,x,y);
								animmode = ANIMMODE_FLY;
								retreat = false;
								//retreatframe = 0;//2sep2021
								tmptattempts = 0;
								tmptframe = 0;
								if(flightlevel==-1)
								{
									hp = 0; //bugger - we don't really want this to happen though....so we will prevent it through other means....
								}
							}
							if(flightlevel!=-1)
							{
								return; //we are off the ground....
							}
						}
					}
					else
					{
						if(canfly>0) //in case we are a flying unit at the beginning of our Game...and we for some reason have started on the ground......
						{
							if(Map.cellflyer(nx,ny,Map.FLIGHTLEVELS - 1)==-1)
							{
								Map.removeunit(id,x,y);
								x+=ddx*walkspeed;
								y+=ddy*walkspeed;
								flightlevel = Map.insertflyer(id,x,y);
								animmode = ANIMMODE_FLY;
								retreat = false;
								retreatframe = 0;
								tmptattempts = 0;
								tmptframe = 0;
								if(flightlevel==-1)
								{
									hp = 0; //bugger - we don't really want this to happen though....so we will prevent it through other means....
								}
							}
							if(flightlevel!=-1)
							{
								return; //we are off the ground....
							}
						}
					}
				}
			}
			//end-------------------------//4may2021
			if((nid==id || nid==Map.VACANT) && Map.passable(nx,ny) && Map.heightdiff2(height,x,y)<Unit.MAXWALKHEIGHTDIFF)//21apr2021
			//if((nid==id || nid==Map.VACANT) && Map.passable(nx,ny) && Map.passable(nnx,nny) && Map.heightdiff2(height,x,y)<Unit.MAXWALKHEIGHTDIFF)//21apr2021
			{
				Map.removeunit(id,x,y);
				int ogx = x / Map.GRIDW;
				int ogy = y / Map.GRIDH;
				x+=ddx*walkspeed;
				y+=ddy*walkspeed;
				animmode = ANIMMODE_WALK;
				Map.insertunit(id,x,y);
				int ngx = x / Map.GRIDW;
				int ngy = y / Map.GRIDH;
				//if(ogx!=ngx || ogy!=ngy)
				//{
					//square must have been vacant.....
					//we should do a pathing check
					if(Game.frame % Unit.MAXUNITS==id)
					{
						if(checkedgrid[0]!=x || checkedgrid[1]!=y || checkedgrid[2]!=tx || checkedgrid[3]!=ty)
						{
							Unit.PATHSTEP = 2;
							//this sets tmptx and tmpty 
							Functions.saveseed();//11apr2021
							pathfind(game,x,y,tx,ty,id);
							Functions.restoreseed();//11apr2021
							checkedgrid[0] = x;
							checkedgrid[1] = y;
							checkedgrid[2] = tx;
							checkedgrid[3] = ty;
							Unit.PATHSTEP = 1;
							tmptframe = 0; //we're not actually blocked...we're just making our life easier...
							tmptattempts--;
						}
					}
				//}
				if(dustcloud>0)
				{
					//Blood.makeblood(game,x,y,Blood.DUSTCLOUD);
				}
			}
			else
			{
				//try and walk around the obstacle......
				//tx = x + Functions.rand(-100,100);
				//ty = y + Functions.rand(-100,100);
				//animmode = ANIMMODE_IDLE;
				//tmptframe = 120;
				//tmptx = x + Functions.rand(-100,100);
				//tmpty = y + Functions.rand(-100,100);
				//NEED TO OPTIMISE PATH FINDING.
				animmode = ANIMMODE_WALK;
				if((Game.frame + id) % 10==0)
				{
					bool freesquare = checkfreeadjacent(game,id);
					//if we are surrounded - eg such as when all enemies are around us, then no point checking to path find.....
					if(freesquare)
					{
						Functions.saveseed();//11apr2021
						pathfind(game,x,y,tx,ty,id); // only path find a short way to where we are going....
						Functions.restoreseed();//11apr2021
						//animmode = ANIMMODE_WALK;
						if(tmptattempts > MAXPATHFIND)
						{
							tx = x;
							ty = y;
							tmptx = x;
							tmpty = y;
							tmptattempts = 0;
						}
						if(tmptattempts>4 && Functions.abs(tx-x)<4 &&  Functions.abs(ty-y)<4)
						{
							tx = x;
							ty = y;
							tmptx = x;
							tmpty = y;
							tmptattempts = 0;
						}
					}
				}
				if(nid!=id && nid!=Map.VACANT)
				{
					//start---------//23sep2021
					//currently only gold can be picked up...
					if(Game.units[nid].canpickup>0)
					{
						if(faction==Game.PLAYERFACTION)
						{
							gold+=Game.units[nid].gold;
							Game.units[nid].gold = 0;
							Game.units[nid].hp=0;
							Map.removeunit(nid, Game.units[nid].x, Game.units[nid].y);
							//play sound?
							return;
						}
					}
					//end-----------//23sep2021
					if(Game.units[nid].faction!=faction && Game.units[nid].faction!=Unit.NULLFACTION)
					{
						//we've bumped into an enemy......
						if(orderframe<=0)
						{
							firetargeti = nid;
						}
						//if we are a shock unit
						if(shock>0 || fearsome>0)
						{
							//Functions.saveseed();//11apr2021
							shocktarget(game,nid);
							//Functions.restoreseed();//11apr2021
						}
					}
					if(Game.units[nid].faction==faction)
					{
						if(leader > 0)
						{
							Game.units[nid].timid = 0;
							Game.units[nid].retreat = false;
							Game.units[nid].retreatframe = Game.frame + Unit.RETREATDEATH;
						}
						//start-----------//13oct2021
						if(Game.units[nid].bossmonster>0)
						{
							int tdx = 10 * walkspeed * Functions.sign(x - Game.units[nid].x);
							int tdy = 10 * walkspeed * Functions.sign(y - Game.units[nid].y);
							//walk away from the boss monster if we an...he is a friendly hero..give him space....
							tmptx = Game.units[nid].x + tdx;
							tmpty = Game.units[nid].y + tdy;
							//this may not work....there may be too much going on that pushes the unit away from stuff.....
							firetargeti = -1; //bugger it may as well do this....why? because it kind of ensures we don't just press in against the hero
							orderframe = 30;//and this means we won't override it too soon......
							tmptattempts = 0;
						}
						//end-------------//13oct2021
					}
					if(timid==1 && Game.units[nid].timid==0 && Game.units[nid].faction==faction)
					{
						//Functions.saveseed();//11apr2021
						if(Functions.rand(0,1000)<200)
						{
							Game.units[nid].timid = 1;
						}
						//Functions.restoreseed();//11apr2021
					}
					if(Game.units[nid].faction==faction && retreat==true)
					{
						if(Game.units[nid].timid==0)
						{
							Game.units[nid].timid=1;
						}
						if(Game.units[nid].retreat==false)
						{
							//Functions.saveseed();//11apr2021
							if(Functions.rand(0,1000)<200)
							{
								Game.units[nid].retreat = true;
								Game.units[nid].retreatframe = Game.frame + Unit.RETREATDEATH;
							}
							//Functions.restoreseed();//11apr2021
							//start---------------//27mar2021
							//there should be a chance for us ourselves to rally if we collide with a friend who is not 
							//panicking....
							//commented out currently until ready to test happily as I need a break from this...
							//if(Game.units[nid].retreat==false)
							//{
							//	//so if we didn't spread panic ourselves....
							//	//then there's a chance we might rally...
							//	if(Functions.rand(0,1000)<200)
							//	{
							//		retreat = false;
							//		retreatframe = 0;
							//	}
							//	//and if we're not fleeing now...there's a chance we might no longer be timid too..
							//	if(Game.templates[templateid].timid<=0 && retreat==false)
							//	{
							//		timid = 0;
							//	}
							//}
							//end-----------------//27mar2021
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public bool checkfreeadjacent(Game game, int id)
		{
			//check that the position moving to is empty
			int gx = Game.units[id].x / Map.GRIDW;
			int gy = Game.units[id].y / Map.GRIDH;
			if(gx>=0 && gy>=0 && gx<Map.MAXX && gy<Map.MAXY)
			{
				if(Map.cellunit((gx*Map.GRIDW),((gy + 1)*Map.GRIDH))==Map.VACANT && Map.passable((gx * Map.GRIDW),(gy + 1) * Map.GRIDH)==true && Map.heightdiff2(Game.units[id].height,(gx)*Map.GRIDW,(gy + 1)*Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
				{
					return true;
				}
				if(Map.cellunit((gx*Map.GRIDW),((gy - 1)*Map.GRIDH))==Map.VACANT && Map.passable(gx * Map.GRIDW,(gy - 1) * Map.GRIDH)==true && Map.heightdiff2(Game.units[id].height,(gx)*Map.GRIDW,(gy - 1)*Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
				{
					return true;
				}
				if(Map.cellunit(((gx - 1)*Map.GRIDW),((gy)*Map.GRIDH))==Map.VACANT && Map.passable((gx - 1) * Map.GRIDW,(gy) * Map.GRIDH)==true && Map.heightdiff2(Game.units[id].height,(gx - 1)*Map.GRIDW,(gy)*Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
				{
					return true;
				}
				if(Map.cellunit(((gx + 1)*Map.GRIDW),((gy)*Map.GRIDH))==Map.VACANT && Map.passable((gx + 1) * Map.GRIDW,(gy) * Map.GRIDH)==true && Map.heightdiff2(Game.units[id].height,(gx + 1)*Map.GRIDW,(gy)*Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
				{
					return true;
				}
			}
			return false;
		}

///////////////////Method Definition///////////////
		public static int seekpath(int sx,int sy,int fx,int fy,int dirn,int depth,int id)
		{
			//path finding
			//optimise
			if(depth==0)
			{
				Map.resetpathmap();
			}
			if(depth > MAXDEPTH)
			{
				return -1;
			}
			if(sx==fx && sy==fy)
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" met target.");
				return depth;
			}
			if(!Map.ignoreunits)
			{
				int nid = Map.cellunit(sx * Map.GRIDW,sy * Map.GRIDH);
				if(nid!=Map.VACANT && nid!=id)
				{
					//Game.WriteDebug("Cell Not VACANT:"+nid);
					return -1;
				}
			}
			//okay.....
			if(!Map.passable(sx * Map.GRIDW,sy * Map.GRIDH))
			{
				//Game.WriteDebug("Not Passable");
				return -1;
			}
			int pi = sx + sy * Map.MAXX;
			if(pi<0 || pi>=Map.pathmap.Length)
			{
				//Game.WriteDebug("OUTSIDE BOUNDS");
				return -1;
			}
			if(depth==0)
			{
				Map.pathmap[pi] = Map.PATHINIT;
			}
			if(Map.pathmap[pi]==0)
			{
				//we haven't tested this square yet
				Map.pathmap[pi] = depth;
			}
			else
			{
				//we've already tested this square....
				if(depth < Map.pathmap[pi] || depth==0 || Map.pathmap[pi]==0)
				{
					Map.pathmap[pi] = depth;
				}
				else
				{
					return -1;
				}
			}
			int leftdir = -1;
			int rightdir = -1;
			int updir = -1;
			int downdir = -1;
			int mindepth = Map.PATHINIT;
			int direction = -1;
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx - 1) * Map.GRIDW,(sy) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				leftdir = seekpath(sx - 1,sy,fx,fy,0,depth + 1,id);
			}
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx + 1) * Map.GRIDW,(sy) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				rightdir = seekpath(sx + 1,sy,fx,fy,0,depth + 1,id);
			}
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx) * Map.GRIDW,(sy - 1) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				updir = seekpath(sx,sy - 1,fx,fy,0,depth + 1,id);
			}
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx) * Map.GRIDW,(sy + 1) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				downdir = seekpath(sx,sy + 1,fx,fy,0,depth + 1,id);
			}
			if(leftdir!=-1 && leftdir<mindepth)
			{
				mindepth = leftdir;
				direction = DIRN_LEFT;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" LEFT.");
			}
			if(rightdir!=-1 && rightdir<mindepth)
			{
				mindepth = rightdir;
				direction = DIRN_RIGHT;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" RIGHT.");
			}
			if(updir!=-1 && updir<mindepth)
			{
				mindepth = updir;
				direction = DIRN_UP;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" UP.");
			}
			if(downdir!=-1 && downdir<mindepth)
			{
				mindepth = downdir;
				direction = DIRN_DOWN;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" DOWN.");
			}
			if(depth==0)
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" GO:"+direction);
				return direction;
			}
			else
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" MINDEPTH:"+mindepth);
				return mindepth;
			}
		}
/*

///////////////////Method Definition///////////////
		public static int seekpath(int sx,int sy,int fx,int fy,int dirn,int depth,int id)
		{
			//optimise
			if(depth==0)
			{
				Map.resetpathmap();
			}
			if(depth > MAXDEPTH)
			{
				return -1;
			}
			if(sx==fx && sy==fy)
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" met target.");
				return depth;
			}
			if(!Map.ignoreunits)
			{
				int nid = Map.cellunit(sx * Map.GRIDW,sy * Map.GRIDH);
				if(nid!=Map.VACANT && nid!=id)
				{
					//Game.WriteDebug("Cell Not VACANT:"+nid);
					return -1;
				}
			}
			//okay.....
			if(!Map.passable(sx * Map.GRIDW,sy * Map.GRIDH))
			{
				//Game.WriteDebug("Not Passable");
				return -1;
			}
			int pi = sx + sy * Map.MAXX;
			if(pi<0 || pi>=Map.pathmap.Length)
			{
				//Game.WriteDebug("OUTSIDE BOUNDS");
				return -1;
			}
			if(depth==0)
			{
				Map.pathmap[pi] = 0;
			}
			if(Map.pathmap[pi]==Map.PATHINIT)
			{
				//we haven't tested this square yet
				Map.pathmap[pi] = depth;
			}
			else
			{
				//we've already tested this square....
				if(depth < Map.pathmap[pi] || depth==0)
				{
					Map.pathmap[pi] = depth;
				}
				else
				{
					return -1;
				}
			}
			int leftdir = -1;
			int rightdir = -1;
			int updir = -1;
			int downdir = -1;
			int mindepth = Map.PATHINIT;
			int direction = -1;
			leftdir = seekpath(sx - 1,sy,fx,fy,0,depth + 1,id);
			rightdir = seekpath(sx + 1,sy,fx,fy,0,depth + 1,id);
			updir = seekpath(sx,sy - 1,fx,fy,0,depth + 1,id);
			downdir = seekpath(sx,sy + 1,fx,fy,0,depth + 1,id);
			if(leftdir!=-1 && leftdir<mindepth)
			{
				mindepth = leftdir;
				direction = DIRN_LEFT;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" LEFT.");
			}
			if(rightdir!=-1 && rightdir<mindepth)
			{
				mindepth = rightdir;
				direction = DIRN_RIGHT;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" RIGHT.");
			}
			if(updir!=-1 && updir<mindepth)
			{
				mindepth = updir;
				direction = DIRN_UP;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" UP.");
			}
			if(downdir!=-1 && downdir<mindepth)
			{
				mindepth = downdir;
				direction = DIRN_DOWN;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" DOWN.");
			}
			if(depth==0)
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" GO:"+direction);
				return direction;
			}
			else
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" MINDEPTH:"+mindepth);
				return mindepth;
			}
		}
		*/
///////////////////Method Definition///////////////
		public bool quickpathfind(int sx,int sy,int fx, int fy)//28apr2021
		{
			return false;
		}
		
///////////////////Method Definition///////////////
		public void pathfind(Game game, int x, int y, int tx, int ty,int id)
		{
			//more path finding
			//uses a modified Djikstra algorithm.
			//NEED TO OPTIMISE
			int ttx = tx;
			int tty = ty;
			int oMAXDEPTH = Unit.MAXDEPTH;
			if(selected==Unit.SELECTIONFROZEN && Game.frame < Game.ordergivenframe + Game.EXTRAPATHINGTIME && Game.frame < timesincelastpath + Game.EXTRAPATHINGTIME)
			{
				Unit.MAXDEPTH*=2;
			}
			timesincelastpath = Game.frame;
			if(Functions.abs(tx-x)>Unit.MAXDEPTH)
			{
				ttx = x + Functions.sign(tx - x) * (Unit.MAXDEPTH/2) * Map.GRIDW;
			}
			else
			{
				ttx = x +  Functions.rand(-4,4) * Map.GRIDW;
			}
			if(Functions.abs(ty-y)>Unit.MAXDEPTH)
			{
				tty = y + Functions.sign(ty - y) * (Unit.MAXDEPTH/2) * Map.GRIDH;
			}
			else
			{
				tty = y + Functions.rand(-4,4) * Map.GRIDH;
			}
			if(Functions.abs(tx-x)+Functions.abs(ty-y)<oMAXDEPTH/2)
			{
				Unit.MAXDEPTH = oMAXDEPTH / 2;
			}
			if(Functions.abs(tx-x)+Functions.abs(ty-y)<oMAXDEPTH/3)
			{
				Unit.MAXDEPTH = oMAXDEPTH / 3;
			}
			ttx = tx;
			tty = ty;
			int sx = 0;
			int sy = 0;
			int fx = 0;
			int fy = 0;
			int godirn = -1;
			float dist = Functions.abs(ttx-x)/Map.GRIDW + Functions.abs(tty-y)/Map.GRIDH;
			if(tmptattempts<Unit.PRECALCLIMIT)
			{
				sx = x / Map.GRIDW;
				sy = y / Map.GRIDH;
				fx = tx / Map.GRIDW;
				fy = ty / Map.GRIDH;
				if(sx>=0 && fx>=0 && sy>=0 && fy>=0 && sx<Map.MAXX && sy<Map.MAXY && fx<Map.MAXX && fy<Map.MAXY)
				{
					godirn = Map.precalcedpaths[sx,sy,fx,fy];
					if(godirn==Map.NOTCHECKED)
					{
						godirn = -1;
					}
					else
					{
						Config.precalcused++;
						if(godirn!=-1)
						{
							Config.seekpathsuccess++;
						}
					}
				}
			}
			if(dist < Unit.MAXDEPTH && godirn==-1) //no point checking our pathfinding routine if we are too far away....
			//or rather only check if we can actually reach with our current maxdepth.....otherwise pointless.
			{
				godirn = seekpath(x / Map.GRIDW,y / Map.GRIDH,ttx / Map.GRIDW,tty / Map.GRIDH,0,0,id);
				Config.seekpathused++;
				if(godirn==-1)
				{
					sx = x / Map.GRIDW;
					sy = y / Map.GRIDH;
					fx = tx / Map.GRIDW;
					fy = ty / Map.GRIDH;
					Config.seekpathfailed++;
					if(sx>=0 && fx>=0 && sy>=0 && fy>=0 && sx<Map.MAXX && sy<Map.MAXY && fx<Map.MAXX && fy<Map.MAXY)
					{
						godirn = Map.precalcedpaths[sx,sy,fx,fy];
						if(godirn==Map.NOTCHECKED)
						{
							godirn = -1;
						}
						else
						{
							Config.precalcused++;
						}
					}
				}
				else
				{
					Config.seekpathsuccess++;
					sx = x / Map.GRIDW;
					sy = y / Map.GRIDH;
					fx = tx / Map.GRIDW;
					fy = ty / Map.GRIDH;
					if(sx>=0 && fx>=0 && sy>=0 && fy>=0 && sx<Map.MAXX && sy<Map.MAXY && fx<Map.MAXX && fy<Map.MAXY)
					{
						if(Map.precalcedpaths[sx,sy,fx,fy]==Map.NOTCHECKED)
						{
							Map.precalcedpaths[sx,sy,fx,fy] = godirn;
						}
					}
				}
			}
			Unit.MAXDEPTH = oMAXDEPTH;
			tmptframe = 15;
			tmptattempts++;
			switch(godirn)
			{
				case 0:
				tmptx = x;
				//tmpty = y + 8 * Map.GRIDH;
				tmpty = y + Unit.PATHSTEP * Map.GRIDH;
				//Game.WriteDebug("Go Down");
				break;
				case 1:
				tmptx = x - 5 * Map.GRIDW;
				tmpty = y + 5 * Map.GRIDH;
				break;
				case 7:
				tmptx = x + 5 * Map.GRIDW;
				tmpty = y + 5 * Map.GRIDH;
				break;
				//tmptx = x - 8 * Map.GRIDW;
				case 2:
				tmptx = x - Unit.PATHSTEP * Map.GRIDW;
				tmpty = y;
				//Game.WriteDebug("Go Left");
				break;
				case 6:
				//tmptx = x + 8 * Map.GRIDW;
				tmptx = x + Unit.PATHSTEP * Map.GRIDW;
				tmpty = y;
				//Game.WriteDebug("Go Right");
				break;
				case 4:
				tmptx = x;
				//tmpty = y - 8 * Map.GRIDH;
				tmpty = y - Unit.PATHSTEP * Map.GRIDH;
				//Game.WriteDebug("Go Up");
				break;
				case 3:
				tmptx = x - 5 * Map.GRIDW;
				tmpty = y - 5 * Map.GRIDH;
				break;
				case 5:
				tmptx = x + 5 * Map.GRIDW;
				tmpty = y - 5 * Map.GRIDH;
				break;
				case -1:
					tmptx = x + Functions.rand(-100,100);
					tmpty = y + Functions.rand(-100,100);
					if(tmptattempts==Unit.MAXPATHFIND/2 || tmptattempts==3*Unit.MAXPATHFIND/4 || (tmptattempts % 10)==0)
					{
						tx+=Functions.rand(-100,100);
						ty+=Functions.rand(-100,100);
						tmptx = tx;
						tmpty = ty;
					}
				break;
			}
		}

///////////////////Method Definition///////////////
		public void animate(Game game)
		{
			//animation method
			//handles all animation of units
			int oframe = animframe;
			int prevanimframe = animframe;//14oct2021
			if(animspeed<=0)
			{
				return;
			}
			//Functions.saveseed();//11apr2021
			animtime--;//29sep2021
			if(animmode==ANIMMODE_WALK)
			{
				//if(Game.frame % animspeed==0)//29sep2021
				animtime--;
				if(animtime<=0)//29sep2021
				{
					animframe++;	
				}
			}
			else
			{
				//if(Game.frame % (animspeed*2)==0)//29sep2021
				if(animtime<=0)//29sep2021
				{
					animframe++;	
				}
			}
			if(animtime<=0)//29sep2021
			{
				animtime = animspeed;//29sep2021
			}
			//start------------//29may2021
			if((Game.frame % animspeed==0))
			{
				int diffdirn = displaydirn - dirn;
				if(Functions.abs(diffdirn)<4)
				{
					if(dirn<displaydirn)
					{
						displaydirn--;
						if(displaydirn<0)
						{
							displaydirn+=8;
						}
					}
					else
					{
						if(displaydirn!=dirn)
						{
						displaydirn++;
						}
					}
					displaydirn%=8;
				}
				else
				{
					if(dirn<displaydirn)
					{
						displaydirn++;
					}
					else
					{
						if(dirn!=displaydirn)
						{
							displaydirn--;
							if(displaydirn<0)
							{
								displaydirn+=8;
							}
						}
					}
					displaydirn%=8;
				}
			}
			//end--------------//29may2021
			if(animmode==ANIMMODE_ATTACK || animmode==ANIMMODE_ATTACK2 || animmode==ANIMMODE_ATTACK3)
			{
				if(animmode!=oanimmode)
				{
					if(animmode==ANIMMODE_ATTACK)
					{
						animframe = animmodeattframestart;
					}
					if(animmode==ANIMMODE_ATTACK2)
					{
						animframe = animmodeatt2framestart;
					}
					if(animmode==ANIMMODE_ATTACK3)
					{
						animframe = animmodeatt3framestart;
					}
				}
				else
				{
					if(animmode==ANIMMODE_ATTACK)
					{
						if(animframe>animmodeattframeend)
						{
							//change back to idle....
							animmode = ANIMMODE_IDLE;
							animframe = animmodeidleframestart;
							animrest = 30; // half a second....
						}
					}
					if(animmode==ANIMMODE_ATTACK2)
					{
						if(animframe>animmodeatt2frameend)
						{
							//change back to idle....
							animmode = ANIMMODE_IDLE;
							animframe = animmodeidleframestart;
							animrest = 30; // half a second....
						}
					}
					if(animmode==ANIMMODE_ATTACK3)
					{
						if(animframe>animmodeatt3frameend)
						{
							//change back to idle....
							animmode = ANIMMODE_IDLE;
							animframe = animmodeidleframestart;
							animrest = 30; // half a second....
						}
					}
				}
			}
			//start-----------//4may2021
			if(animmode==ANIMMODE_FLYATTACK)
			{
				if(animmode!=oanimmode)
				{
					if(animmode==ANIMMODE_FLYATTACK)
					{
						animframe = animmodeflyattackframestart;
					}
				}
				else
				{
					if(animmode==ANIMMODE_FLYATTACK)
					{
						if(animframe>animmodeflyattackframeend)
						{
							//change back to idle....
							animmode = ANIMMODE_FLY;
							animframe = animmodeflyframestart;
							animrest = 30; // half a second....
						}
					}
				}
			}				
			//end------------//4may2021
			//start-------------//28Feb2021
			if(animmode==ANIMMODE_IDLE2)
			{
				if(animframe>animmodeidle2frameend)
				{
					animframe = animmodeidleframestart;
					animmode = ANIMMODE_IDLE;
				}
				if(animframe<animmodeidle2framestart)
				{
					animframe = animmodeidle2framestart;
				}
				if((Game.frame + id) % (60 * 5)==0)
				{
					if(Functions.rand(0,100)<10)
					{
						dirn = Functions.rand(0,100) % 8;
					}
				}
			}
			//end---------------//28Feb2021
			if(animmode==ANIMMODE_IDLE)
			{
				if(animframe>animmodeidleframeend)
				{
					animframe = animmodeidleframestart;
				}
				if(animframe<animmodeidleframestart)
				{
					animframe = animmodeidleframestart;
				}
				if((Game.frame + id) % (60 * 5)==0)
				{
					//start-------------//28Feb2021
					if(Functions.rand(0,100)<30)
					{
						if(animmodeidle2framestart!=0 || animmodeidle2frameend!=0)
						{
							animframe = animmodeidle2framestart;
							animmode = ANIMMODE_IDLE2;
						}
					}
					//end---------------//28Feb2021
					if(Functions.rand(0,100)<10)
					{
						dirn = Functions.rand(0,100) % 8;
					}
				}
			}
			//start-------------//4may2021
			if(animmode==ANIMMODE_FLY)
			{
				if(animframe>animmodeflyframeend)
				{
					animframe = animmodeflyframestart;
				}
				if(animframe<animmodeflyframestart)
				{
					animframe = animmodeflyframestart;
				}
			}
			//end---------------//4may2021
			if(animmode==ANIMMODE_WALK)
			{
				if(animmode!=oanimmode || animframe>animmodewalkframeend)
				{
					animframe = animmodewalkframestart;
				}
			}
			//Functions.restoreseed();//11apr2021
			//start-----------//25Feb2021
			if(animmode==ANIMMODE_DEAD)
			{
				if(animmode!=oanimmode)
				{
					animframe = animmodedeadframestart;
				}
				if(animframe>animmodedeadframeend)
				{
					animframe = animmodedeadframeend;
					if(hp<=0 && dieonce<=(animmodedeadframeend - animmodedeadframestart))//13sep2021 added dieonce
					{
						if(dieonce==animmodedeadframeend - animmodedeadframestart){Game.killed(game,id);}//13sep2021 around die once block.
						dieonce++;//13sep2021
					}
				}
			}
			//end-------------//25Feb2021
			if(animmode!=oanimmode)
			{
				oanimmode = animmode;
			}
		}

///////////////////Method Definition///////////////
		public static void copyunitstats(Unit input,ref Unit output)
		{
			//copy a unit template from the base template
			//to the in game unit
			//typically used when creating new units
			//start-----------------//21mar2021
			if(Unit.COPYUNIT)
			{
				output.x = input.x;
				output.y = input.y;
				output.tx = input.tx;
				output.ty = input.ty;
				output.tmptx = input.tmptx;
				output.tmpty = input.tmpty;
				output.dirn = input.dirn;
				output.odirn = input.odirn;
				output.dirntime = input.dirntime;
				output.retreat = input.retreat;
				output.retreatframe = input.retreatframe;
				output.infog = input.infog;
				output.buffed = input.buffed;
				output.cursed = input.cursed;
				output.defendx = input.defendx;
				output.defendy = input.defendy;
				output.formationx = input.formationx;
				output.formationy = input.formationy;
				output.height = input.height;
				output.orderframe = input.orderframe;
				output.tmptframe = input.tmptframe;
				output.tmptattempts = input.tmptattempts;
				output.angle = input.angle;
				output.oanimmode = input.oanimmode;
				output.animmode = input.animmode;
				output.animrest = input.animrest;
				output.animframe = input.animframe;
				output.animspeed = input.animspeed;
				output.drawn = input.drawn;
				output.selected = input.selected;
				output.selectedframe = input.selectedframe;
				output.onscreen = input.onscreen;
				output.ronscreen = input.ronscreen;//25apr2021
				output.transportedbyid = input.transportedbyid; //4may2021
				output.bounddemon = input.bounddemon; //12jul2021
			}
			output.scale = input.scale;//25sep2021
			//end---------------------//21apr2021
			output.transportsize = input.transportsize;//3may2021
			output.transportcapacity = input.transportcapacity;//3may2021
			if(output.transportcapacity>0)//3may2021
			{
				output.transportarray = new int[output.transportcapacity];//3may2021
				for(int t=0;t<output.transportcapacity;t++) //4sep2021
				{
					output.transportarray[t] = -1;//4sep2021
				}
			}
			else
			{
				output.transportarray = new int[0];//3may2021
			}
			if(Unit.COPYUNIT)//3may2021
			{
				if(input.transportarray!=null && output.transportarray!=null)
				{
					if(output.transportarray.Length>0 && input.transportarray.Length>0)
					{
						for(int k=0;k<input.transportarray.Length;k++)
						{
							output.transportarray[k] = input.transportarray[k];
						}
					}
				}
			}
			output.basehp = input.basehp;
			output.basemana = input.basemana;//23sep2021
			output.mana = input.mana;//23sep2021
			output.manarate = input.manarate;//23sep2021
			output.healthpotions = input.healthpotions;//23sep2021
			output.manapotions = input.manapotions;//23sep2021
			output.bothpotions = input.bothpotions;//23sep2021
			output.unresearchedbydefault = input.unresearchedbydefault;//2sep2021
			output.gold = input.gold;//23sep2021
			output.canpickup = input.canpickup;//23sep2021
			output.techguilinkid = input.techguilinkid;//2sep2021
			output.hp = input.hp;
			output.misfire = 0;//28mar2021
			output.displayname = input.displayname; //13mar2021
			output.charactername = input.charactername;//10sep2021 //technically shouldn't be here because character name is set per mission not per unit in the unit file...
			output.displaycharactername = input.displaycharactername;//10sep2021
			output.damage = input.damage;
			output.damage2 = input.damage2;
			output.splash = input.splash;//2sep2021
			output.firerange2 = input.firerange2;
			output.needlos = input.needlos;//15sep2021
			output.bounddemon = input.bounddemon; //12jul2021
			output.armour = input.armour;
			output.firerange = input.firerange;
			output.firebullet = input.firebullet;
			output.healer = input.healer;
			output.spellcaster = input.spellcaster;
			output.prefermobiletargets = input.prefermobiletargets;//18sep2021
			output.lightningdeath = input.lightningdeath;//19oct2021
			output.notabuffer = input.notabuffer; //15apr2021
			output.firespell = input.firespell;
			output.extragibbet = input.extragibbet;//18sep2021
			output.powerspell = input.powerspell;
			output.points = input.points; //17sep2021
			output.zombiemaster = input.zombiemaster;
			output.banish = input.banish; //12mar2021
			output.dustcloud = input.dustcloud;
			output.timid = input.timid;
			output.mirrorleftright = input.mirrorleftright;//24sep2021
			output.controlmode = input.controlmode;//24sep2021
			output.guiattackdisplaylimit = input.guiattackdisplaylimit; //23sep2021
			output.hitandrun = input.hitandrun;
			output.dodge = input.dodge;//21oct2021
			output.brave = input.brave;
			//start-----//3may2021
			output.transforminto = input.transforminto;
			output.transformrequires = input.transformrequires;
			output.magictransform = input.magictransform;
			output.magicrelease = input.magicrelease;
			//end-------//3may2021
			//start---------------//01apr2021
			output.spellability = input.spellability;
			output.ping = input.ping;//16sep2021
			output.redping = input.redping;//17sep2021
			output.spelldefense = input.spelldefense;
			output.magicdef = input.magicdef;
			output.magicdoom = input.magicdoom;
			output.magicfrenzy = input.magicfrenzy;
			//end-----------------//01apr2021
			//start--------------//9apr2021
			output.magicleader = input.magicleader;
			output.magiczombiemaster = input.magiczombiemaster;
			//end----------------//9apr2021
			//start---------------//28mar2021
			output.magicgas = input.magicgas;
			output.magicweb = input.magicweb;
			output.magichaste = input.magichaste;
			output.magicfear = input.magicfear;
			output.magicplant = input.magicplant;
			output.magicsword = input.magicsword;
			output.magicstorm = input.magicstorm;
			output.magicwind = input.magicwind;
			output.magicstealth = input.magicstealth;
			output.magicshield = input.magicshield;
			output.magicarray = new int[17];
			int m = 0;
			if(output.magicrelease>0)//3may2021
			{
				output.magicarray[m] = output.magicrelease;
				m++;
			}
			if(output.magictransform>0)//3may2021
			{
				output.magicarray[m] = output.magictransform;
				m++;
			}
			//start--------------//9apr2021
			if(output.magicleader>0)//01apr2021
			{
				output.magicarray[m] = output.magicleader;
				m++;
			}
			if(output.magiczombiemaster>0)//01apr2021
			{
				output.magicarray[m] = output.magiczombiemaster;
				m++;
			}
			//end----------------//9apr2021
			if(output.magicdoom>0)//01apr2021
			{
				output.magicarray[m] = output.magicdoom;
				m++;
			}
			if(output.magicdef>0)//01apr2021
			{
				output.magicarray[m] = output.magicdef;
				m++;
			}
			if(output.magicfrenzy>0)//01apr2021
			{
				output.magicarray[m] = output.magicfrenzy;
				m++;
			}
			if(output.magicweb>0)
			{
				output.magicarray[m] = output.magicweb;
				m++;
			}
			
			if(output.magicfear>0)
			{
				output.magicarray[m] = output.magicfear;
				m++;
			}
			if(output.magicgas>0)
			{
				output.magicarray[m] = output.magicgas;
				m++;
			}
			if(output.magichaste>0)
			{
				output.magicarray[m] = output.magichaste;
				m++;
			}
			if(output.magicplant>0)
			{
				output.magicarray[m] = output.magicplant;
				m++;
			}
			if(output.magicshield>0)
			{
				output.magicarray[m] = output.magicshield;
				m++;
			}
			if(output.magicstealth>0)
			{
				output.magicarray[m] = output.magicstealth;
				m++;
			}
			if(output.magicstorm>0)
			{
				output.magicarray[m] = output.magicstorm;
				m++;
			}
			if(output.magicsword>0)
			{
				output.magicarray[m] = output.magicsword;
				m++;
			}
			if(output.magicwind>0)
			{
				output.magicarray[m] = output.magicwind;
				m++;
			}
			//start-----//21apr2021
			if(Unit.COPYUNIT)
			{
				for(int m2=0;m2<output.magicarray.Length;m2++)
				{
					output.magicarray[m2] = input.magicarray[m2];
				}
			}
			//end-------//21apr2021
			//end-----------------//28mar2021
			output.buildpenalty = input.buildpenalty;//20mar2021
			//start-------------//7mar2021
			output.mob = input.mob;
			output.lightningdeath = input.lightningdeath;//19oct2021
			output.hatred = input.hatred;
			output.craftsman = input.craftsman;
			output.planar = input.planar;
			output.slow = input.slow;
			output.canpickup = input.canpickup;//23sep2021
			output.woodsman = input.woodsman;
			output.stupid = input.stupid;
			output.frenzy = input.frenzy;
			//end---------------//7mar2021
			output.highfirerate = input.highfirerate; //25Feb2021
			output.shock = input.shock;
			output.stealth = input.stealth;
			output.damagex = input.damagex;
			output.fearsome = input.fearsome;
			output.leader = input.leader;
			output.hasleader = input.hasleader;//21oct2021
			output.spawner = input.spawner;
			output.framesleft = input.framesleft;//9sep2021
			output.spawnerconstraint = input.spawnerconstraint;//9sep2021
			output.spawnertime = input.spawnertime;
			output.spawnercount = input.spawnercount;
			output.ai = input.ai;
			output.bossmonster = input.bossmonster;
			output.flammable = input.flammable;
			output.ecat = input.ecat;
			output.fcat = input.fcat;
			output.ecatfile = input.ecatfile;
			output.fcatfile = input.fcatfile;
			output.controlpoint = input.controlpoint;
			output.regeneration = input.regeneration;
			output.zombie = input.zombie;
			output.sacrificial = input.sacrificial;
			output.cansacrifice = input.cansacrifice;
			output.levelxp = input.levelxp;
			output.xpvalue = input.xpvalue;
			output.name = input.name;
			output.faction = input.faction;
			output.cat = input.cat;
			output.cathiresfile = input.cathiresfile; //9apr2021
			output.cathires = input.cathires;//9apr2021
			output.damage = input.damage;
			output.armour = input.armour;
			output.gold = input.gold;//23sep2021
			output.canpickup = input.canpickup;//23sep2021
			output.walkspeed = input.walkspeed;
			output.animspeed = input.animspeed;
			output.offy = input.offy;
			output.offx = input.offx; //20apr2021
			output.framesperdirn = input.framesperdirn;
			output.nodirn = input.nodirn;
			output.animmodedeadframestart = input.animmodedeadframestart; //25Feb2021
			output.animmodedeadframeend = input.animmodedeadframeend; //25Feb2021
			output.animmodeidleframestart = input.animmodeidleframestart;
			output.animmodeidleframeend = input.animmodeidleframeend;
			output.animmodeidle2framestart = input.animmodeidle2framestart; //28Feb2021
			output.animmodeidle2frameend = input.animmodeidle2frameend; //28Feb2021
			output.animmodewalkframestart = input.animmodewalkframestart;
			output.animmodewalkframeend = input.animmodewalkframeend;
			output.animmodeattframestart = input.animmodeattframestart;
			output.animmodeattframeend = input.animmodeattframeend;
			output.animmodeatt2framestart = input.animmodeatt2framestart;
			output.animmodeatt2frameend = input.animmodeatt2frameend;
			output.animmodeatt3framestart = input.animmodeatt3framestart;
			output.animmodeatt3frameend = input.animmodeatt3frameend;
			//start--------------//4may2021
			output.canattackair = input.canattackair;
			output.canfly = input.canfly;
			output.canflyandwalk = input.canflyandwalk;
			output.animmodeflyattackframeend = input.animmodeflyattackframeend;
			output.animmodeflyattackframestart = input.animmodeflyattackframestart;
			output.animmodeflyframeend = input.animmodeflyframeend;
			output.animmodeflyframestart = input.animmodeflyframestart;
			output.flightlevel = input.flightlevel;
			//end----------------//4may2021
			output.cw = input.cw;
			output.ch = input.ch;
			output.templateid = input.id; 
			if(Unit.COPYUNIT)//21apr2021
			{
				output.templateid = input.templateid;
			}
			for(int i=0;i<input.impactfx.Length;i++)
			{
				output.impactfx[i] = input.impactfx[i];
			}
			for(int i=0;i<input.attackfx.Length;i++)
			{
				output.attackfx[i] = input.attackfx[i];
			}
			for(int i=0;i<input.targetfx.Length;i++)
			{
				output.targetfx[i] = input.targetfx[i];
			}
			for(int i=0;i<input.magicfx.Length;i++)
			{
				output.magicfx[i] = input.magicfx[i];
			}
			for(int i=0;i<input.ackfx.Length;i++)
			{
				output.ackfx[i] = input.ackfx[i];
			}
			for(int i=0;i<input.selectfx.Length;i++)
			{
				output.selectfx[i] = input.selectfx[i];
			}
			for(int i=0;i<input.deathfx.Length;i++) //28jul2021
			{
				output.deathfx[i] = input.deathfx[i];
			}
		}
	
		///////////////////Method Definition///////////////
		public static int GetSecondMostPowerfulAi()
		{
			int level = 1;
			int maxscore = -9999;
			
			for(int i=1;i<Unit.NUMAISCRIPTS;i++)
			{
				int aiscore = 0;
				try
				{
					//aiscore = Integer.decode(LocalStorage.getitem("ai_"+i));
					Int32.TryParse(LocalStorage.getitem("ai_"+i),out aiscore);
				}
				catch(Exception e)
				{
					Game.WriteDebug("Error:"+e.Message);
				}
				if(aiscore>maxscore)
				{
					maxscore = aiscore;
					level = i;
				}
			}
			int score2 = -9999;
			for(int i=1;i<Unit.NUMAISCRIPTS;i++)
			{
				int aiscore = 0;
				try
				{
					Int32.TryParse(LocalStorage.getitem("ai_"+i),out aiscore);
				}
				catch(Exception e)
				{
					Game.WriteDebug("Error:"+e.Message);
				}
				if(aiscore>score2 && aiscore<maxscore)
				{
					score2 = aiscore;
					level = i;
				}
			}
			if(Functions.rand(0,100)<50)
			{
				level = 1 +  Functions.rand(0,100) % Unit.NUMAISCRIPTS;
				if(level<0)
				{
					level = 1;
				}
			}
			//start------------//20oct2021
			if(Game.difficulty==1) //Easy - pick a random AI script
			{
				level = 1 +  Functions.rand(0,100) % Unit.NUMAISCRIPTS;
				if(level<0)
				{
					level = 1;
				}
			}
			if(Game.difficulty==2) //Easiest - pick the worst of the AI scripts
			{
				int score3 = 9999;
				int minscore = 9999;
				for(int i=1;i<Unit.NUMAISCRIPTS;i++)
				{
					int aiscore = 0;
					try
					{
						Int32.TryParse(LocalStorage.getitem("ai_"+i),out aiscore);
					}
					catch(Exception e)
					{
						Game.WriteDebug("Error:"+e.Message);
					}
					if(aiscore<score3 && aiscore<minscore)
					{
						score3 = aiscore;
						minscore = aiscore;
						level = i;
					}
				}
				if(Functions.rand(0,100)<50)
				{
					level = 1 +  Functions.rand(0,100) % Unit.NUMAISCRIPTS;
					if(level<0)
					{
						level = 1;
					}
				}
			}
			//end--------------//20oct2021
			return level;
		}
		///////////////////Method Definition///////////////
		public static bool AiDeploy(int templateid,int boardx, int boardy, int p)
		{
			//////////////////////
			int isleader = Game.templates[templateid].leader;
			int isbrave = Game.templates[templateid].brave;
			int istimid = Game.templates[templateid].timid;
			int isarmoured = Functions.sign(Game.templates[templateid].armour - 9);
			int isranged = Game.templates[templateid].firebullet;
			int isimpact = Functions.sign(Game.templates[templateid].frenzy);
			int isnumerous = Functions.sign(Game.templates[templateid].points - 8);
			int iscentral = 1 - Functions.sign(Functions.abs(boardx - 5)/2);
			int isflank = Functions.sign(Functions.abs(boardx - 5)/2);
			int isfront = boardy;
			int isrear = 1 - boardy;
			int isfast = Functions.sign(Game.templates[templateid].walkspeed - 2);
			int isslow = Functions.sign(2 - Game.templates[templateid].walkspeed);
			//random number.....
			//deploy style.......
			switch(1 + Game.vsai % Unit.NUMAISCRIPTS)
			{
					case 13:
					if(isarmoured>0)
					{
						if(isfront>0)
						{
							break;
						}
					}
					if(isimpact>0)
					{
						if(iscentral>0)
						{
							if(isrear>0)
							{
								break;
							}
						}
					}
					break;
					case 12:
					if(isleader>0)
					{
						if(isfront>0)
						{
							if(isflank>0)
							{
								break;
							}
						}
					}
					if(isranged>0)
					{
						if(isrear>0)
						{
							break;
						}
					}
					if(isarmoured>0)
					{
						if(isfront>0)
						{
							break;
						}
					}
					break;
					case 11:
					if(isnumerous>0)
					{
						if(istimid<=0)
						{
							if(iscentral>0)
							{
								break;
							}
						}
					}
					if(isleader>0)
					{
						if(iscentral>0)
						{
							break;
						}
					}
					break;
					case 10:
					if(isfast>0)
					{
						if(iscentral>0)
						{
							break;
						}
					}
					if(isslow>0)
					{
						if(isrear>0)
						{
							break;
						}
						if(isflank>0)
						{
							break;
						}
					}
					break;
					case 9:
					if(isbrave>0)
					{
						if(isfront>0)
						{
							break;
						}
					}
					if(isranged>0)
					{
						if(isflank>0)
						{
							break;
						}
					}
					if(iscentral>0)
					{
						if(isfast>0)
						{
							break;
						}
					}
					break;
					case 8:
					if(isranged>0)
					{
						if(iscentral>0)
						{
							break;
						}
					}
					if(isnumerous>0)
					{
						if(isflank>0)
						{
							break;
						}
					}
					if(isleader>0)
					{
						if(isrear>0)
						{
							if(isflank>0)
							{
								break;
							}
						}
					}
					break;
					case 7:
					if(isarmoured>0)
					{
						if(isfront>0)
						{
							break;
						}
					}
					if(isarmoured<=0)
					{
						if(isrear>0)
						{
							break;
						}
					}
					if(isleader>0)
					{
						if(isrear>0)
						{
							break;
						}
					}
					break;
					case 6:
					if(isimpact>0)
					{
						if(isarmoured>0)
						{
							if(iscentral>0)
							{
								break;
							}
						}
					}
					if(isflank>0)
					{
						if(isrear>0)
						{
							if(isfast>0)
							{
								break;
							}
						}
					}
					if(isnumerous>0)
					{
						if(iscentral>0)
						{
							if(isrear>0)
							{
								break;
							}
						}
					}
					break;
		
				case 4:
				//single line at the front
				//ranged units on the wings at the back
				if(isranged>0)
				{
					if(isrear>0)
					{
						if(isflank>0)
						{
							return true;
						}
					}
				}
				if(isfront>0 && isranged<=0)
				{
					return true;
				}
				break;
			case 3:
				//numerous units in the centre
				//slow units in the centre
				//leaders on the wings
				//timid units on the wings
				if(isleader>0)
				{
					if(isflank>0)
					{
						return true;
					}
				}
				if(istimid>0)
				{
					if(isflank>0)
					{
						return true;
					}
				}
				if(iscentral>0)
				{
					if(isslow>0)
					{
						return true;
					}
					if(isnumerous>0)
					{
						return true;
					}
				}
				break;
				case 2:
				//Arrows at the back
				//Impact at the front
				//Leaders in the Centre
				if(isranged>0)
				{
					if(isrear>0)
					{
						return true;
					}
				}
				if(isimpact>0)
				{
					if(isfront>0)
					{
						return true;
					}
				}
				if(isleader>0)
				{
					if(iscentral>0)
					{
						return true;
					}
				}
				break;
				case 1:
				//Leaders at the front and centre
				//impact units on the wings
				//armoured units at the back
				//brave units at the centre
				if(isarmoured>0)
				{
					if(isrear>0)
					{
						return true;
					}
				}
				if(iscentral>0)
				{
					if(isbrave>0)
					{
						return true;
					}
				}
				if(isflank>0)
				{
					if(isimpact>0)
					{
						return true;
					}
				}
				if(isleader>0)
				{
					if(isfront>0 && iscentral>0)
					{
						return true;
					}
				}
				break;
				case 5:
				//Centre Dominated By Leaders At The Back and Numerous or Armoured at the Front
				//Flanks Dominated By Fast Units
				if(iscentral>0)
				{
					if(isleader>0)
					{
						if(isrear>0)
						{
							return true;
						}
					}
					if(isarmoured>0)
					{
						if(isfront>0)
						{
							return true;
						}
					}
				}
				if(isflank>0)
				{
					if(isfast>0)
					{
						return true;
					}
				}
				break;
			}
			return false;
		}
	
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class CampaignMap //6oct2021
	{
		public static int maxprovince = 16;
		public static int provincecount = 0;
		public static int maxx = 120;
		public static int maxy = 90;
		public static int gridw = 10;
		public static int gridh = 10;
		public static int[] provincedata = new int[maxx * maxy];
		public static int[] provincebattle = new int[maxx * maxy];//16oct2021
		public static int[] provinceowner = new int[16];
		public static int[] provincearmy = new int[16];
		public static int[] provincearmystrength = new int[16];
		public static int[] provincetolerance = new int[16];
		public static int[] provincehero = new int[16];//13oct2021
		public static int[] provinceweather = new int[16];//14oct2021
		public static int[] provinceterrain = new int[16];//15oct2021
		
		//15oct2021 terrain types
		public static int FOREST = 1;
		public static int MOUNTAINS = 2;
		public static int FORESTMOUNTAINS = 3;
		public static int PLAINS = 0;
		
		public static int seed = 0;
		
		public static int[] team = new int[6];
		
		public static int selectedprovince = -1;
		
		public static int turn = 0;

		public static bool Victory()//17oct2021
		{
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]!=Game.PlayerIndex)
				{
					return false;
				}
			}
			return true;
		}
		
		public static bool Defeat()//17oct2021
		{
			int count = 0;
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==Game.PlayerIndex)
				{
					return false;
				}
				if(provinceowner[i]>=0 && provinceowner[i]<Game.MaxArmies)
				{
					count++;
				}
			}
			if(count>0)
			{
				return true;
			}
			return false;
		}
		
		public static void DrawCells(int offx,int offy)//16oct2021
		{
			//go through each cell and find if the cell is a province or not....that is owned....
			for(int x=0;x<maxx;x++)
			{
				for(int y=0;y<maxy;y++)
				{
					int i = x + y * maxx;
					if(provincedata[i]!=-1)
					{
						int p = provincedata[i];
						if(p<0 || p>=maxprovince)
						{
							continue;
						}
						if(provinceowner[p]!=Game.MaxArmies)
						{
							//owned by someone.....
							uint color = 0;
							switch(provinceowner[p])
							{
								case 0:
									//Red
									color = RenderList.getrgb(200,64,32);
								break;
								case 1:
									//Blue
									color = RenderList.getrgb(32,64,200);
								break;
								case 2:
									//Green
									color = RenderList.getrgb(48,200,48);
								break;
								case 3:
									//Yellow
									color = RenderList.getrgb(200,200,48);
								break;
								case 4:
									//Purple
									color = RenderList.getrgb(200,48,200);
								break;
								case 5:
									//Orange
									color = RenderList.getrgb(200,172,48);
								break;
							}
							if(color==0)
							{
								continue;
							}
							int leftcell = 0;
							int rightcell = 0;
							int topcell = 0;
							int bottomcell = 0;
							if(x>0)
							{
								if(provincedata[(x - 1) + (y) * maxx]==-1)
								{
									leftcell = 1;
								}
							}
							if(x<maxx-1)
							{
								if(provincedata[(x + 1) + (y) * maxx]==-1)
								{
									rightcell = 1;
								}
							}
							if(y>0)
							{
								if(provincedata[(x) + (y - 1) * maxx]==-1)
								{
									topcell = 1;
								}
							}
							if(y<maxy-1)
							{
								if(provincedata[(x) + (y + 1) * maxx]==-1)
								{
									bottomcell = 1;
								}
							}
							//if(leftcell>0 || rightcell>0 || topcell>0 || bottomcell>0)
							//{
								//we want to paint this one.....
								//
								//
								//if(leftcell>0 && rightcell>0)
								//{
								//	RenderList.drawrect(null,offx + x * gridw,offy + y * gridh,gridw,gridh,color,0);
								//}
								//if(topcell>0 && bottomcell>0)
								//{
									//RenderList.drawrect(null,offx + x * gridw,offy + y * gridh,gridw,gridh,color,1);
									RenderList.drawline(null,offx + x * gridw, offy + y * gridh,offx + x * gridw + gridw, offy + y * gridh + gridh,color,0);
									RenderList.drawline(null,offx + x * gridw, offy + y * gridh + gridh,offx + x * gridw + gridw, offy + y * gridh,color,0);
								//}
								if(leftcell>0 && rightcell<=0 && topcell>0)
								{
									//we curve up and to the right
									//DrawRoundedCorner(offx + x * gridw,offy + y * gridh ,offx + x * gridw + 10,offy + y * gridh + 10,5,color);	
								}
								if(rightcell>0 && leftcell<=0 && topcell>0)
								{
									//we curve up and to the left
									//DrawRoundedCorner(offx + x * gridw,offy + y * gridh,offx + x * gridw + 10,offy + y * gridh + 10,3,color);
								}
								if(leftcell>0 && rightcell<=0 && bottomcell>0)
								{
									//we curve down and to the right
									//DrawRoundedCorner(offx + x * gridw,offy + y * gridh,offx + x * gridw + 10,offy + y * gridh + 10,7,color);
								}
								if(leftcell<=0 && rightcell>0 && bottomcell>0)
								{
									//we curve down and to the left
									//DrawRoundedCorner(offx + x * gridw,offy + y * gridh,offx + x * gridw + 10,offy + y * gridh + 10,1,color);
								}
							//}
						}
					}
				}
			}
		}
		
		//helper function.....
		//round corners....
		public static void DrawRoundedCorner(int x0,int y0,int x1,int y1,int dirn,uint color)
		{
			for(int x=x0;x<=x1;x++)
			{
				for(int y=y0;y<=y1;y++)
				{
					switch(dirn)
					{
						case 1: //top left filled in, bottom right not
							if(y-y0<=x-x0)
							{
								//x = x0, y has to equal y0 to be drawn///
								//x = x1, y has to equal y1 to be drawn/
								RenderList.drawrect(null,x,y,2,2,color,0);
							}
						break;
						
						case 3://bottom left filled in, top right not
							if((y1 - y)<=x-x0)
							{
								//x = x0, y has to equal y1 to be drawn
								//x = x1, y has to equal y0 to be drawn
								RenderList.drawrect(null,x,y,2,2,color,0);
							}

						break;
						
						case 5://bottom right filled in, top left not
							if((y - y1)<=x1 - x)
							{
								//when x = x1, y has to equal y1 to be drawn
								//when x = x0, y has to equal y0 to be drawn
								RenderList.drawrect(null,x,y,2,2,color,0);
							}
						
						break;
						
						case 7://top right filled in, bottom left not
							if((y - y0)<=x1 - x)
							{
								//when x = x1, y has to equal y0 to be drawn
								//when x = x0, y has to equal y1 to be drawn
								RenderList.drawrect(null,x,y,2,2,color,0);
							}
						break;
					}
				}
			}
		}
		
		public static void ApplyTerrain()//15oct2021
		{
			for(int i=0;i<maxprovince;i++)
			{
				provinceterrain[i] = PLAINS;
			}
			//FOREST
			provinceterrain[1] = FOREST;
			provinceterrain[9] = FOREST;
			provinceterrain[14] = FOREST;
			
			//MOUNTAINS
			provinceterrain[4] = MOUNTAINS;
			provinceterrain[5] = MOUNTAINS;
			provinceterrain[10] = MOUNTAINS;
			
			//BOTH
			provinceterrain[3] = FORESTMOUNTAINS;
			provinceterrain[12] = FORESTMOUNTAINS;
			
		}
		
		public static int rand()
		{
			//we have our own Random number system specifically for this process....
			int r = 0;
			CampaignMap.seed = ((89723453 * CampaignMap.seed + 42854321) % 1000000);
			r = CampaignMap.seed % 1000;
			if(r<0)
			{
				r*=-1;
				r%= 1000;
			}
			return r;
		}
		
		public static void SetBattleLocation(int p)//16oct2021
		{
			int count = 0;
			int index = 0;
			for(int x=0;x<CampaignMap.maxx;x++)
			{
				for(int y=0;y<CampaignMap.maxy;y++)
				{
					if(provincedata[x + y * CampaignMap.maxx]==p)
					{
						count++;
					}
				}
			}
			if(count>0)
			{
				index = 1 + (Functions.rand(0,10000) % count);
				for(int x=0;x<CampaignMap.maxx;x++)
				{
					for (int y=0;y<CampaignMap.maxy;y++)
					{
						if(provincedata[x + y * CampaignMap.maxx]==p)
						{
							index--;
							if(index<=0)
							{
								provincebattle[x + y * CampaignMap.maxx]=1;
								return;
							}
						}
					}
				}
			}
		}
		
		public static bool BattleAtXY(int x, int y)//16oct2021
		{
			if(x<0 || y<0 || x>=maxx || y>=maxy)
			{
				return false;
			}
			if(provincebattle[x + y * maxx]>0)
			{
				return true;
			}
			return false;
		}
		
		public static void CreateMap(int p)//15oct2021
		{
			//province = p;
			//Game.newtoast(""+CampaignMap.seed + " " + p);
			if(p==-1)
			{
				p = CampaignMap.rand() % maxprovince;
			}
			else
			{
				if(p<0 || p>=maxprovince)
				{
					return;
				}
				SetBattleLocation(p);//16oct2021
			}
			Map.treeimage = new int[Map.MAXX*Map.MAXY];
			Map.rockimage = new int[Map.MAXX*Map.MAXY];
			Map.wallimage = new int[Map.MAXX*Map.MAXY];
			for(int i=0;i<Map.treeimage.Length;i++)
			{
				Map.treeimage[i] = -1;
				Map.rockimage[i] = -1;
				Map.wallimage[i] = -1;
			}
			int minx = 0;
			int miny = 0;
			int maxx = 1 + Game.RESOLUTIONX / Map.GRIDW;
			int maxy = 1 + (9*(Game.RESOLUTIONX/16))  / Map.GRIDH;
			int width = maxx - minx;
			int height = maxy - miny;
			int n = CampaignMap.rand() % 3 + CampaignMap.rand() % 3 + CampaignMap.rand() % 4;//16oct2021
			for(int m=0;m<=n;m++)//16oct2021
			{
				for(int x=minx;x<=maxx;x++)
				{
					for(int y=miny;y<=maxy;y++)
					{
						if(x>=0 && y>=0 && x<Map.MAXX && y<Map.MAXY)
						{
							int i = x + Map.MAXX * y;
							int treepct = 40;
							int rockpct = 40;
							int innertreepct = 10;
							int innerrockpct = 10;
							int wallpct = 40;
							//only a few scattered trees......
							//and some rocks nearby.....
							int q = CampaignMap.rand();//Functions.rand(0,10000) % 1000;
							int r = CampaignMap.rand();
							int s = CampaignMap.rand();
							switch(provinceterrain[p])
							{
								case 0: //plains
								//Game.newtoast("Plains");
								//no change...
								break;
								case 1: //forest
								//Game.newtoast("Forest");
								treepct = 80;
								rockpct = 30;
								innertreepct = 20;
								innerrockpct = 0;
								wallpct = 16;
								break;
								case 2: //mountains
								//Game.newtoast("Crags");
								treepct = 20;
								rockpct = 100;
								innertreepct = 0;
								innerrockpct = 20;
								wallpct = 12;
								break;
								case 3: //both
								//Game.newtoast("Forests and Crags");
								treepct = 60;
								rockpct = 60;
								innertreepct = 10;
								innerrockpct = 10;
								wallpct = 10;
								break;
							}
							//remember there are approximately 50 x 30 cells...or 1500 cells on the map....
							//so 1% would be 15....
							//5% would be 75 cells.....
							//10% would be 150 cells.....
							//also we want to leave the central zone mostly clear
							//central 80% zone should be mostly empty.....
							//outer width 10% either side can be more dense.
							//front and rear 15% should be clear.....
							if(y<(3 * height)/9 || y>(height*7)/9)
							{
								//deployment areas...leave empty....
							}
							else
							{
								if(x<width/10 || x>=(width*9)/10)
								{
									//outer zones
									if(q<wallpct)
									{
										if(x % 4==0)
										{
											if(y % 4==0)
											{
												Map.wallimage[i] = Functions.rand(0,100) % 4;
											}
										}
									}
									if(r<treepct)
									{
										Map.treeimage[i] = Functions.rand(0,100) % 8;
									}
									if(s<rockpct)
									{
										Map.rockimage[i] = Functions.rand(0,100) % 16;
									}
									if(x<width/20 || x>=(width*19)/20)
									{
										if(r<treepct*2)
										{
											Map.treeimage[i] = Functions.rand(0,100) % 8;
										}
										if(s<rockpct*2)
										{
											Map.rockimage[i] = Functions.rand(0,100) % 16;
										}
									}
								}
								else
								{
									//inner zones
									if(m<=0)//16oct2021
									{
										if(r<innertreepct)
										{
											Map.treeimage[i] = Functions.rand(0,100) % 8;
										}
										if(s<innerrockpct)
										{
											Map.rockimage[i] = Functions.rand(0,100) % 16;
										}
									}
								}
							}
						}
					}
				}
			}
			//start------//20oct2021
			for(int m=0;m<=n*2;m++)//20oct2021
			{
				for(int x=minx;x<=maxx;x++)
				{
					for(int y=miny;y<=maxy;y++)
					{
						if(x>=0 && y>=0 && x<Map.MAXX && y<Map.MAXY)
						{
							if(y<(3 * height)/9 || y>(height*7)/9)
							{
								//deployment areas...leave empty....
								continue;
							}
							int j = x + Map.MAXX * y;
							int treepct = 60;
							int rockpct = 60;
							if(x>width/10 || x<=(width*9)/10)
							{
								treepct/=2;
								rockpct/=2;
							}
							int q = CampaignMap.rand();//Functions.rand(0,10000) % 1000;
							int r = CampaignMap.rand();
							int s = CampaignMap.rand();
							if(x % 3 == 0 && y % 3 == 0)
							{
								if(provinceterrain[p]==1 && q < treepct)//FOREST
								{
									Map.treeimage[j] = Functions.rand(0,100) % 8;
								}
								if(provinceterrain[p]==2 && r < rockpct)//MOUNTAINS
								{
									Map.rockimage[j] = Functions.rand(0,100) % 16;
								}
								if(provinceterrain[p]==3 && s < treepct)//BOTH
								{
									Map.treeimage[j] = Functions.rand(0,100) % 8;
									Map.rockimage[j] = Functions.rand(0,100) % 16;
								}
							}
						}
					}
				}
			}
			//end---------//20oct2021
			//start-------//20oct2021
			int hills = CampaignMap.rand();
			Map.hillson = 0;
			if(provinceterrain[p] > 1 && hills<800)
			{
				Map.hillson = 1;
			}
			if(hills<400)
			{
				Map.hillson = 1;
			}
			//end---------//20oct2021
		}
	
		public static void ApplyWeather()//14oct2021
		{
			for(int i=0;i<maxprovince;i++)
			{
				provinceweather[i] = Map.WEATHERNORMAL;
			}
			provinceweather[3] = Map.WEATHERCOLD;
			provinceweather[4] = Map.WEATHERCOLD;
			provinceweather[5] = Map.WEATHERCOLD;
			provinceweather[10] = Map.WEATHERCOLD;
			provinceweather[12] = Map.WEATHERCOLD;
			provinceweather[11] = Map.WEATHERHOT;
			provinceweather[14] = Map.WEATHERHOT;
			provinceweather[13] = Map.WEATHERHOT;
		}
		
		public static void GenerateTolerance()
		{
			int tolerance = 5;
			int maxtolerance = 25;
			for(int p=0;p<maxprovince;p++)
			{
				provincetolerance[p] = 5;
				bool found = false;
				tolerance = 5;
				while(found==false && tolerance<maxtolerance)
				{
					for(int x=0;x<maxx;x++)
					{
						for(int y=0;y<maxy;y++)
						{
							if(provincedata[x + y * maxx]>=0 && provincedata[x + y * maxx]<maxprovince)
							{
								if(provincedata[x + y * maxx]!=p)
								{
									continue;
								}
								//we are looking at province 'p'
								for(int xx=x-tolerance + 1;xx<=x+tolerance - 1;xx++)
								{
									for(int yy=y-tolerance + 1;yy<=y+tolerance - 1;yy++)
									{
										if(xx>=0 && yy>=0 && xx<maxx && yy<maxy)
										{
											if(provincedata[x + yy * maxx]>=0 && provincedata[x + yy * maxx]<maxprovince)
											{
												if(provincedata[x + yy * maxx]!=p)
												{
													found = true;
													break;
												}
											}
											if(provincedata[xx + y * maxx]>=0 && provincedata[xx + y * maxx]<maxprovince)
											{
												if(provincedata[xx + y * maxx]!=p)
												{
													found = true;
													break;
												}
											}
										}
										if(found)
										{
											break;
										}
									}
									if(found)
									{
										break;
									}
								}
							}
						}
					}
					if(!found)
					{
						tolerance++;
						provincetolerance[p] = tolerance + 2;
					}
				}
			}
			for(int p=0;p<maxprovince;p++)
			{
				
			}
		}
		
		public static bool EmptyProvincesExist()
		{
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==Game.MaxArmies)
				{
					return true;
				}
			}
			return false;
		}
		
		public static void ClearCampaign()
		{
			for(int i=0;i<maxprovince;i++)
			{
				provinceowner[i] = Game.MaxArmies;
				provincebattle[i] = 0;//21oct2021
				int index = Game.campaignmode;
				if(index>0)
				{
					index=1;
				}
				LocalStorage.setitem(index+"Territory_"+i,""+(Game.MaxArmies+1));
				LocalStorage.setitem(index+"TerritoryArmy_"+i,"18");
				LocalStorage.setitem(index+"TerritoryArmyStrength_"+i,"0");
				LocalStorage.setitem(index+"TerritoryHero_"+i,"0");//16oct2021
			}
			Research.ClearResearch();//21oct2021
		}
		
		public static int GetProvinceCentreX(int index)
		{
			int sumx = 0;
			int count = 0;
			for(int i=0;i<maxx*maxy;i++)
			{
				if(provincedata[i]==index)
				{
					sumx+= (i % maxx);
					count++;
				}
			}
			if(count>0)
			{
				return sumx / count;
			}
			return 0;
		}
		
		public static int GetProvinceCentreY(int index)
		{
			int sumx = 0;
			int count = 0;
			for(int i=0;i<maxx*maxy;i++)
			{
				if(provincedata[i]==index)
				{
					sumx+= ((i - (i % maxx))/maxx);
					count++;
				}
			}
			if(count>0)
			{
				return sumx / count;
			}
			return 0;
		}

		public static void AfterBattle(int owner)
		{
			int damage = 100 - Functions.rand(0, 50);
			int count = 0;
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==owner)
				{
					//AfterBattle(i,damage);
					count++;
				}
			}
			if(count>0)
			{
				damage/=count;
				for(int i=0;i<maxprovince;i++)
				{
					if(provinceowner[i]==owner)
					{
						AfterBattle(i,damage);
					}
				}
					
			}
		}
		
		public static int NumElements(int player)
		{
			int strength = 0;
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==player)
				{
					if(provincearmy[i]>=0 && provincearmy[i]<18)
					{
						strength += provincearmystrength[i] +  100 * ((provincearmy[i] - (provincearmy[i] % 6))/6);
						//0,100 or 200
					}
				}
			}
			//maximum 20 units....
			//20 units achieved with strength = 300 (full army) * 4 provinces....
			//therefore....take our strength, / 300 and that is the bonus on to of 8 that we get....
			if(player!=-1)
			{
				int armystrength = 6 + strength / 300;
				if(armystrength>20)
				{
					armystrength = 20;
				}
				return armystrength;
			}
			else//13oct2021
			{
				//if player==-1 then we are not playing a campaign battle
				Game.numfhero = 0;//13oct2021
				Game.numehero = 0;//13oct2021
			}
			return 8;
		}
		
		public static void AfterBattle(int province,int damage)
		{
			int i = province;
			int index = 1;
			if(i<0 || i>=maxprovince)
			{
				return;
			}
			provincearmystrength[i] -= damage;
			if(provincearmystrength[i]<0) //we've gone below a layer...from 3 armies to 2 from 2 to 1 from 1 to 0 etc....
			{
				provincearmy[i]-=6; //deduct 6 from the cell gui index....
				if(provincearmy[i]<0) //if we've fallen below the normal amount....then set it to 18 which is the 'non army' cell value....
				{
					provincearmy[i] = 18;
				}
				provincearmystrength[i] = 50; //midway between the two values......
			}
			//save the result
			LocalStorage.setitem(index+"TerritoryArmy_"+province,""+provincearmy[province]);
			LocalStorage.setitem(index+"TerritoryArmyStrength_"+province,""+provincearmystrength[province]);
		}
		
		public static void UnMarkAll()
		{
			for(int i=0;i<team.Length;i++)
			{
				team[i] = 0;
			}
		}
		
		public static void MarkTurn()
		{
			if(Game.campaignmode>=1 && Game.campaignmode<7)
			{
				team[Game.campaignmode - 1] = 1;
			}
		}
		
		public static void EndTurn()
		{
			//all armies increase their strength by 1 point every 4 turns.....
			Research.Ai();//21oct2021
			Research.DOUPDATE = 1;//21oct2021
			turn++;
			for(int i=0;i<6;i++)
			{
				team[i] = 0;
			}
			//correct province armies first off.....
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]>=0 && provinceowner[i]<6)
				{
					int armyindex = provinceowner[i];
					int army = provincearmy[i] % 6;
					if(army!=armyindex)//in case it is buggered....
					{
						provincearmy[i] = armyindex;
						provincearmystrength[i] = 0;
					}
				}
				else
				{
					provincearmy[i] = 18;
				}
			}
			for(int i=0;i<maxprovince;i++)
			{
				if(provincearmy[i]<18) //ie from 0 to 17
				{
					provincearmystrength[i]+=25;
					if(provincearmystrength[i]>=100)
					{
						if(provincearmy[i]+6<18)
						{
							provincearmystrength[i]=0;
						}
						provincearmy[i]+=6;
						if(provincearmy[i]>17)
						{
							provincearmy[i]-=6;
						}
						int province = i;
						int index = 1;
						//save the increment in strength
						LocalStorage.setitem(index+"TerritoryArmy_"+province,""+provincearmy[province]);
						LocalStorage.setitem(index+"TerritoryArmyStrength_"+province,""+provincearmystrength[province]);
					}
					else
					{
						int province = i;
						int index = 1;
						//save the increment in strength
						LocalStorage.setitem(index+"TerritoryArmy_"+province,""+provincearmy[province]);
						LocalStorage.setitem(index+"TerritoryArmyStrength_"+province,""+provincearmystrength[province]);
					}
				}
			}
			//Research.UpdateResearch();//20oct2021
		}
		
		public static bool IsMyNeighbour(int screenx,int screeny,int me)
		{
			if(Game.LETTERBOX)
			{
				screenx *= 3;
				screenx /= 4;
				screeny *= 3;
				screeny /= 4;
			}
			int mapx = screenx / gridw;
			int mapy = screeny / gridh;
			//check if out of bounds
			if(mapx<0 || mapy<0 || mapx >= maxx || mapy >= maxy)
			{
				return false;//map region is off the map .. not a valid province cell
			}
			//check if territory is valid
			if(provincedata[mapx + mapy * maxx]<0 || provincedata[mapx + mapy * maxx]>=maxprovince)
			{
				return false; //province is out of bounds...not a valid province cell
			}
			int curowner = provinceowner[provincedata[mapx + mapy * maxx]];
			int province = provincedata[mapx + mapy * maxx];
			//check if the territoriy is mine already
			if(curowner==me)
			{
				return false; //if we have clicked on our own province return false...not a neighbour
			}
			//look at neighbours....
			//int tolerance = 5;
			//if(provincetolerance[me]>tolerance)
			//{
			//	tolerance = provincetolerance[me];
			//}
			for(int x=0;x<maxx;x++)
			{
				for(int y=0;y<maxy;y++)
				{
					//if the cell is ocean ignore it
					if(provincedata[x + y * maxx]==-1)
					{
						//ocean - ignore ocean...for now....
						continue;
					}
					//if the cell is not the one we clicked on ignore it
					if(provinceowner[provincedata[x + y * maxx]]==me)
					{
						//if the x/y cell is one of our provinces......
						int ourprovince = provincedata[x + y * maxx];
						if(provincetolerance[ourprovince]<5)
						{
							provincetolerance[ourprovince] = 5;
						}
						//check to the left, top, right and bottom
						for(int i=5;i<=provincetolerance[ourprovince];i++)
						{
							int tolerance = i;
							if(x>tolerance)
							{
								if(provincedata[(x - tolerance) + (y) * maxx]==province)
								{
									return true;
								}
							}
							//same as for left/etc
							if(y>tolerance)
							{
								//neighbouring to the top....
								if(provincedata[(x) + (y - tolerance) * maxx]==province)
								{
									return true;
								}
							}
							if(x<maxx-tolerance)
							{
								//neighbouring to the right....
								if(provincedata[(x + tolerance) + (y) * maxx]==province)
								{
									return true;
								}
							}
							if(y<maxy-tolerance)
							{
								//neighbouring to the bottom....
								if(provincedata[(x) + (y + tolerance) * maxx]==province)
								{
									return true;
								}
							}
						}
					}
					if(provincedata[x + y * maxx]!=province)
					{
						//this is not the one we clicked on....so we want to ignore it.....
						continue;
					}
					if(provincetolerance[province]<5)
					{
						provincetolerance[province] = 5;
					}
					//check to the left, top, right and bottom
					for(int i=5;i<=provincetolerance[province];i++)
					{
						int tolerance = i;
						if(x>tolerance)
						{
							//neighbouring to the left....
							//if the left is ocean ignore it
							
							if(provincedata[(x - tolerance) + (y) * maxx]!=-1)
							{
								//not ocean
								//if the left is me - we want this.....
								if(provinceowner[provincedata[(x- tolerance) + (y)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
						//same as for left/etc
						if(y>tolerance)
						{
							//neighbouring to the top....
							if(provincedata[(x ) + (y - tolerance) * maxx]!=-1)
							{
								//not ocean
								if(provinceowner[provincedata[(x) + (y - tolerance)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
						if(x<maxx-tolerance)
						{
							//neighbouring to the right....
							if(provincedata[(x + tolerance) + (y) * maxx]!=-1)
							{
								//not ocean
								if(provinceowner[provincedata[(x+tolerance) + (y)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
						if(y<maxy-tolerance)
						{
							//neighbouring to the bottom....
							if(provincedata[(x ) + (y + tolerance) * maxx]!=-1)
							{
								//not ocean
								if(provinceowner[provincedata[(x) + (y + tolerance)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
					}
				}
			}
			return false;
		}
		
		
		public static int MyProvinceCount(int faction)
		{
			int pcount = 0;
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==faction)
				{
					pcount++;
				}
			}
			return pcount;
		}
		
		public static void GetSavedTerritoryData()
		{
			int index = Game.campaignmode;
			if(index>0)
			{
				index=1;
			}
			for(int i=0;i<maxprovince;i++)
			{
				try
				{
					provinceowner[i] = (Resources.readint(LocalStorage.getitem(index+"Territory_"+i))) - 1;
					if(provinceowner[i]<0)
					{
						provinceowner[i] = Game.MaxArmies;
					}
				}
				catch(Exception e)
				{
					provinceowner[i] = Game.MaxArmies;
					Game.WriteDebug(e.Message);
				}
				try
				{
					provincearmy[i] = (Resources.readint(LocalStorage.getitem(index+"TerritoryArmy_"+i)));
					if(provincearmy[i]<0)
					{
						provincearmy[i] = -1;
					}
					else
					{
						provincearmystrength[i] = (Resources.readint(LocalStorage.getitem(index+"TerritoryArmyStrength_"+i)));
					}
				}
				catch(Exception e)
				{
					provincearmy[i] = -1;
					provincearmystrength[i] = 0;
					Game.WriteDebug(e.Message);
				}
				try
				{
					provincehero[i] = (Resources.readint(LocalStorage.getitem(index+"TerritoryHero_"+i)));
				}
				catch(Exception e)
				{
					provincehero[i] = 0;
					Game.WriteDebug(e.Message);
				}
				//Game.WriteDebug("Province Owner:"+provinceowner[i]);
			}
		}
		
		public static void ChangeTerritoryOwner(int province)
		{
			if(province<0 || province>=maxprovince)
			{
				return;
			}
			int curowner = provinceowner[province];
			curowner++;
			curowner%=(Game.MaxArmies + 1);
			provinceowner[province] = curowner;
			if(curowner==Game.MaxArmies)
			{
				provincearmy[province] = 18;
			}
			else
			{
				provincearmy[province] = curowner;
			}
			provincearmystrength[province] = 0;
			provincehero[province] = 0;//13oct2021
			int index = Game.campaignmode;
			if(index>0)
			{
				index=1;
			}
			LocalStorage.setitem(index+"Territory_"+province,""+(curowner + 1));
			LocalStorage.setitem(index+"TerritoryArmy_"+province,""+provincearmy[province]);
			LocalStorage.setitem(index+"TerritoryArmyStrength_"+province,""+provincearmystrength[province]);
			LocalStorage.setitem(index+"TerritoryHero_"+province,""+(provincehero[province]));
		}
		
		public static void ChangeTerritoryOwner(int screenx,int screeny)
		{
			//screenx is offset back by the gui x position and same for y...
			//so technically this is the actual x/y position on the map....
			if(Game.LETTERBOX)
			{
				screenx *= 3;
				screenx /= 4;
				screeny *= 3;
				screeny /= 4;
			}
			int mapx = screenx / gridw;
			int mapy = screeny / gridh;
			//Game.WriteDebug("ChangeTerritoryOwner:Campaign Map:"+mapx+","+mapy);
			if(mapx<0 || mapy<0 || mapx >= maxx || mapy >= maxy)
			{
				return;
			}
			if(provincedata[mapx + mapy * maxx]<0 || provincedata[mapx + mapy * maxx]>=maxprovince)
			{
				return;
			}
			int curowner = provinceowner[provincedata[mapx + mapy * maxx]];
			int province = provincedata[mapx + mapy * maxx];
			curowner++;
			curowner%=(Game.MaxArmies + 1);
			provinceowner[provincedata[mapx + mapy * maxx]] = curowner;
			if(curowner==Game.MaxArmies)
			{
				provincearmy[province] = 18;
			}
			else
			{
				provincearmy[province] = curowner;
			}
			
			provincearmystrength[provincedata[mapx + mapy * maxx]] = 0;
			provincehero[province] = 0;//13oct2021
			int index = Game.campaignmode;
			if(index>0)
			{
				index=1;
			}
			LocalStorage.setitem(index+"Territory_"+provincedata[mapx + mapy * maxx],""+(curowner + 1));
			LocalStorage.setitem(index+"TerritoryArmy_"+provincedata[mapx + mapy * maxx],""+provincearmy[provincedata[mapx + mapy * maxx]]);
			LocalStorage.setitem(index+"TerritoryArmyStrength_"+provincedata[mapx + mapy * maxx],""+provincearmystrength[provincedata[mapx + mapy * maxx]]);
			LocalStorage.setitem(index+"TerritoryHero_"+province,""+(provincehero[province]));
			//Game.WriteDebug("Cur Owner:"+curowner);
		}
		
		public static int GetHero(int myplayer,int province,bool attacking)//13oct2021
		{
			int hero = 0;
			if(province<0 || province>=maxprovince)
			{
				return 0;
			}
			if(myplayer<0 || myplayer>=Game.MaxArmies)
			{
				return 0;
			}
			if(attacking)
			{
				for(int i=0;i<maxprovince;i++)
				{
					if(provinceowner[i]==myplayer && i!=province && provinceowner[i]!=provinceowner[province])
					{
						int screenx = GetProvinceCentreX(province);
						int screeny = GetProvinceCentreY(province);
						//are we neighbours?
						if(AreProvincesNeighbouring(screenx,screeny,i)) //x/y is the enemy province, i is our province...
						{
							hero += provincehero[i]; //our provincehero
						}
					}
				}
				return hero;
			}
			if(!attacking)
			{
				if(provinceowner[province]==myplayer)
				{
					return provincehero[province];
				}
			}
			return 0;
		}
		
		public static bool AreProvincesNeighbouring(int screenx,int screeny,int province2)//13oct2021
		{
			if(Game.LETTERBOX)
			{
				screenx *= 3;
				screenx /= 4;
				screeny *= 3;
				screeny /= 4;
			}
			int mapx = screenx / gridw;
			int mapy = screeny / gridh;
			//check if out of bounds
			if(mapx<0 || mapy<0 || mapx >= maxx || mapy >= maxy)
			{
				return false;//map region is off the map .. not a valid province cell
			}
			//check if territory is valid
			if(provincedata[mapx + mapy * maxx]<0 || provincedata[mapx + mapy * maxx]>=maxprovince)
			{
				return false; //province is out of bounds...not a valid province cell
			}
			if(province2<0 || province2>=maxprovince)
			{
				return false;
			}
			int curowner = provinceowner[provincedata[mapx + mapy * maxx]];
			int province = provincedata[mapx + mapy * maxx]; //province is the one we are comparing against.....the enemy held province...
			//check if the territoriy is mine already
			if(province==province2)
			{
				return false; 
			}
			//look at neighbours....
			//int tolerance = 5;
			//if(provincetolerance[me]>tolerance)
			//{
			//	tolerance = provincetolerance[me];
			//}
			int me = provinceowner[province2];
			
			for(int x=0;x<maxx;x++)
			{
				for(int y=0;y<maxy;y++)
				{
					//if the cell is ocean ignore it
					if(provincedata[x + y * maxx]==-1)
					{
						//ocean - ignore ocean...for now....
						continue;
					}
					if(provincedata[x + y * maxx]!=province2)
					{
						continue; //this is not the province we are testing against....
					}
					//if the cell is not the one we clicked on ignore it
					if(provinceowner[provincedata[x + y * maxx]]==me) //redundant but leave it in
					{
						//if the x/y cell is one of our provinces......
						int ourprovince = provincedata[x + y * maxx];
						if(provincetolerance[ourprovince]<5)
						{
							provincetolerance[ourprovince] = 5;
						}
						//check to the left, top, right and bottom
						for(int i=5;i<=provincetolerance[ourprovince];i++)
						{
							int tolerance = i;
							if(x>tolerance)
							{
								if(provincedata[(x - tolerance) + (y) * maxx]==province)
								{
									return true;
								}
							}
							//same as for left/etc
							if(y>tolerance)
							{
								//neighbouring to the top....
								if(provincedata[(x) + (y - tolerance) * maxx]==province)
								{
									return true;
								}
							}
							if(x<maxx-tolerance)
							{
								//neighbouring to the right....
								if(provincedata[(x + tolerance) + (y) * maxx]==province)
								{
									return true;
								}
							}
							if(y<maxy-tolerance)
							{
								//neighbouring to the bottom....
								if(provincedata[(x) + (y + tolerance) * maxx]==province)
								{
									return true;
								}
							}
						}
					}
					if(provincedata[x + y * maxx]!=province)
					{
						//this is not the one we clicked on....so we want to ignore it.....
						continue;
					}
					if(provincetolerance[province]<5)
					{
						provincetolerance[province] = 5;
					}
					//check to the left, top, right and bottom
					for(int i=5;i<=provincetolerance[province];i++)
					{
						int tolerance = i;
						if(x>tolerance)
						{
							//neighbouring to the left....
							//if the left is ocean ignore it
							
							if(provincedata[(x - tolerance) + (y) * maxx]!=-1)
							{
								//not ocean
								//if the left is me - we want this.....
								if(provinceowner[provincedata[(x- tolerance) + (y)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
						//same as for left/etc
						if(y>tolerance)
						{
							//neighbouring to the top....
							if(provincedata[(x ) + (y - tolerance) * maxx]!=-1)
							{
								//not ocean
								if(provinceowner[provincedata[(x) + (y - tolerance)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
						if(x<maxx-tolerance)
						{
							//neighbouring to the right....
							if(provincedata[(x + tolerance) + (y) * maxx]!=-1)
							{
								//not ocean
								if(provinceowner[provincedata[(x+tolerance) + (y)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
						if(y<maxy-tolerance)
						{
							//neighbouring to the bottom....
							if(provincedata[(x ) + (y + tolerance) * maxx]!=-1)
							{
								//not ocean
								if(provinceowner[provincedata[(x) + (y + tolerance)*maxx]]==me)
								{
									//this neighbouring province is me!
									//therefore return true
									return true;
								}
							}
						}
					}
				}
			}
			return false;
		}
		
		
		public static void SetHero(int province,int hero)//13oct2021
		{
			if(province>=0 && province<maxprovince)
			{
				if(hero>=0)
				{
					if(hero>1)
					{
						hero=1;
					}
					provincehero[province] = hero;
					LocalStorage.setitem("1TerritoryHero_"+province,""+(provincehero[province]));
				}
			}
		}
		
		public static void SetArmy(int province)
		{
			provincearmy[province]++;
			provincearmy[province] %=19;
			int index = Game.campaignmode;
			if(index>0)
			{
				index=1;
			}
			LocalStorage.setitem(index+"TerritoryArmy_"+province,""+provincearmy[province]);
			LocalStorage.setitem(index+"TerritoryArmyStrength_"+province,""+provincearmystrength[province]);
		}

		public static int GetArmy(int province)
		{
			if(province<0 || province>=maxprovince)
			{
				return -1;
			}
			return provincearmy[province];
		}
		
		public static bool CampaignOver()
		{
			int pcount = 0;
			int acount = 0;
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==Game.PlayerIndex)
				{
					pcount++;
				}
				if(provinceowner[i]!=Game.MaxArmies)
				{
					acount++;
				}
			}
			if(acount>0 && pcount==0)
			{
				return true;
			}
			for(int i=0;i<maxprovince;i++)
			{
				if(provinceowner[i]==Game.MaxArmies)
				{
					return false;
				}
				for(int j=0;j<maxprovince;j++)
				{
					if(provinceowner[i]!=provinceowner[j])
					{
						return false;
					}
				}
			}
			
			return true;
		}
		
		public static int GetTerritoryOwner(int p)
		{
			if(p<0 || p>=maxprovince)
			{
				return -1;
			}
			return provinceowner[p];
		}
		
		public static int GetTerritoryOwner(int screenx, int screeny)
		{
			if(Game.LETTERBOX)
			{
				screenx *= 3;
				screenx /= 4;
				screeny *= 3;
				screeny /= 4;
			}
		
			int mapx = screenx / gridw;
			int mapy = screeny / gridh;
			//Game.WriteDebug("GetTerritoryOwner:Campaign Map:"+mapx+","+mapy);
			if(mapx<0 || mapy<0 || mapx >= maxx || mapy >= maxy)
			{
				return -1;
			}
			if(provincedata[mapx + mapy * maxx]<0 || provincedata[mapx + mapy * maxx]>=maxprovince)
			{
				return -1;
			}
			int curowner = provinceowner[provincedata[mapx + mapy * maxx]];
			//Game.WriteDebug("Cur Owner:"+curowner);
			return curowner;
		}

		public static int GetTerritoryIndex(int screenx, int screeny)
		{
			if(Game.LETTERBOX)
			{
				screenx *= 3;
				screenx /= 4;
				screeny *= 3;
				screeny /= 4;
			}
		
			int mapx = screenx / gridw;
			int mapy = screeny / gridh;
			//Game.WriteDebug("GetTerritoryIndex:Campaign Map:"+mapx+","+mapy);
			if(mapx<0 || mapy<0 || mapx >= maxx || mapy >= maxy)
			{
				return -1;
			}
			//Game.WriteDebug("Index:Campaign Map:"+provincedata[mapx + mapy * maxx]);
			return provincedata[mapx + mapy * maxx];
		}	
		
		public static void ReadMapData(string file)
		{
			try
			{
				string[] data = System.IO.File.ReadAllLines(file);
				if(data!=null)
				{
					if(data.Length>0)
					{
						provinceowner = new int[data.Length];
						maxprovince = data.Length;
						for(int i=0;i<maxx*maxy;i++)
						{
							provincedata[i] = -1;
						}
						for(int i=0;i<data.Length;i++)
						{
							string txt = data[i].Split(":")[1];
							//Game.WriteDebug("Reading Map Data:"+txt);
							string[] coords = txt.Split(",");
							//Game.WriteDebug("Coords Length:"+coords.Length);
							for(int j=0;j<coords.Length;j++)
							{
								int coord = Resources.readint(coords[j]);
								provincedata[coord] = Resources.readint(data[i].Split(":")[0]) - 1;
								provinceowner[provincedata[coord]] = -1;
								//if(j==0)
								//{
									//Game.WriteDebug("Province Id:"+provincedata[coord]);
								//}
							}
						}
					}
				}
				GenerateTolerance();
				ApplyWeather();
				ApplyTerrain();
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error Reading Map Data");
				Game.WriteDebug(e.Message);
			}
		}
	}
	
///////////////////////////////////////////////////
///////////////////Class Definition////////////////

	class MapThread //29may2021
	{
		
		public static bool running = false;
		public static bool quit = false;
		public static int MAXDEPTH = 500;
		public static int sx = 0;
		public static int sy = 0;
		public static int fx = 0;
		public static int fy = 0;
		public static int osx = 0;
		public static int osy = 0;
		public static int ofx = 0;
		public static int ofy = 0;
		public static int[] pathmap = new int[Map.MAXX*Map.MAXY];
		public static int[] checks = new int[Map.MAXX*Map.MAXY];
		public static int[] checkf = new int[Map.MAXX*Map.MAXY];
		public static int i = 0;
		public static int s = 0;
		public static int f = 0;
		public static bool complete = false;
		///////////////////Method Definition///////////////
		public static void resetpathmap()
		{
			//not used
			//for(int i=0;i<pathmap.Length;i++)
			//{
			//	pathmap[i] = Map.PATHINIT;
			//}
			//pathmap = new int[MAXX*MAXY];
			Array.Clear(pathmap,0,pathmap.Length);
		}
		
		///////////////////Method Definition///////////////
		public static void init()
		{
			//call this as soon as the game battle mode is entered and we've started playing....
			if(running)
			{
				return;
			}
			if(Game.EDITOR)
			{
				return;
			}
			if(complete)
			{
				return;
			}
			running = true;
			sx = 0;
			sy = 0;
			fx = 0;
			fy = 0;
			Array.Clear(checks,0,checks.Length);
			Array.Clear(checkf,0,checkf.Length);
			Array.Clear(pathmap,0,pathmap.Length);
			Thread thread = new Thread(new ThreadStart(ThreadFunction));
			thread.Start();		
		}
///////////////////Method Definition///////////////
		public static void ThreadFunction()
		{
			while(!quit)
			{
				//continually process the Map to read/write pathfinding information...
				//should be safe to do so continuously as long as the Map.precalc array exists....
				osx = sx;
				osy = sy;
				ofx = fx;
				ofy = fy;
				i++;
				i%=2;
				if(i==0)
				{
					//every second iteration check between two 'unitmap' positions instead that have not yet been checked between....
					for(int j=0;j<Map.unitmap.Length;j++)
					{
						if(Map.unitmap[j]!=Map.VACANT && checks[j]==0)
						{
							sx = j % Map.MAXX;
							sy = (j - sx) / Map.MAXX;
							s++;
							s%=Unit.MAXUNITS;
							break;
						}
					}
					for(int j=Map.unitmap.Length - 1;j>=0;j--)
					{
						if(Map.unitmap[j]!=Map.VACANT && checkf[j]==0)
						{
							fx = j % Map.MAXX;
							fy = (j - sx) / Map.MAXX;
							f++;
							f%=Unit.MAXUNITS;
							break;
						}
					}
					checks[sx + sy * Map.MAXX] = 1;
					checkf[fx + fy * Map.MAXX] = 1;
					if(s==0)
					{
						Array.Clear(checks,0,checks.Length);
					}
					if(f==0)
					{
						Array.Clear(checkf,0,checkf.Length);
					}
				}
				if(Map.precalcedpaths!=null)
				{
					//do our pathfinding calculation....
					if(Map.precalcedpaths[sx,sy,fx,fy]==Map.NOTCHECKED)
					{
						Map.precalcedpaths[sx,sy,fx,fy] = seekpath2(sx,sy,fx,fy,0,0,0);
					}
				}
				if(sx>=Map.MAXX && sy>=Map.MAXY && fx>=Map.MAXX && fy>=Map.MAXY)
				{
					quit = true;
					complete = true;
					//also quit IF the game is exited......
				}
				if(Game.EDITOR)
				{
					quit = true;
				}
				sx = osx;
				sy = osy;
				fx = ofx;
				fy = ofy;
				fx++;
				fx%=Map.MAXX;
				if(fx==0)
				{
					fy++;
					fy%=Map.MAXY;
					if(fy==0)
					{
						sx++;
						sx%=Map.MAXX;
						if(sx==0)
						{
							sy++;
							sy%=Map.MAXY;
							if(sy==0)
							{
								quit=true;
							}
						}
					}
				}
			}
			running = false;
		}
		
///////////////////Method Definition///////////////		
		public static int seekpath2(int sx,int sy,int fx,int fy,int dirn,int depth,int id)
		{
			//path finding
			//optimise
			if(depth==0)
			{
				MapThread.resetpathmap();
			}
			if(depth > MAXDEPTH)
			{
				return -1;
			}
			if(sx==fx && sy==fy)
			{
				return depth;
			}
			if(!Map.passable(sx * Map.GRIDW,sy * Map.GRIDH))
			{
				return -1;
			}
			int pi = sx + sy * Map.MAXX;
			if(pi<0 || pi>=MapThread.pathmap.Length)
			{
				return -1;
			}
			if(depth==0)
			{
				MapThread.pathmap[pi] = Map.PATHINIT;
			}
			if(MapThread.pathmap[pi]==0)
			{
				//we haven't tested this square yet
				MapThread.pathmap[pi] = depth;
			}
			else
			{
				//we've already tested this square....
				if(depth < MapThread.pathmap[pi] || depth==0 || MapThread.pathmap[pi]==0)
				{
					MapThread.pathmap[pi] = depth;
				}
				else
				{
					return -1;
				}
			}
			int leftdir = -1;
			int rightdir = -1;
			int updir = -1;
			int downdir = -1;
			int mindepth = Map.PATHINIT;
			int direction = -1;
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx - 1) * Map.GRIDW,(sy) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				leftdir = seekpath2(sx - 1,sy,fx,fy,0,depth + 1,id);
			}
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx + 1) * Map.GRIDW,(sy) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				rightdir = seekpath2(sx + 1,sy,fx,fy,0,depth + 1,id);
			}
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx) * Map.GRIDW,(sy - 1) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				updir = seekpath2(sx,sy - 1,fx,fy,0,depth + 1,id);
			}
			if(Map.heightdiff(sx * Map.GRIDW,sy * Map.GRIDH,(sx) * Map.GRIDW,(sy + 1) * Map.GRIDH)<Unit.MAXWALKHEIGHTDIFF)
			{
				downdir = seekpath2(sx,sy + 1,fx,fy,0,depth + 1,id);
			}
			if(leftdir!=-1 && leftdir<mindepth)
			{
				mindepth = leftdir;
				direction = Unit.DIRN_LEFT;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" LEFT.");
			}
			if(rightdir!=-1 && rightdir<mindepth)
			{
				mindepth = rightdir;
				direction = Unit.DIRN_RIGHT;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" RIGHT.");
			}
			if(updir!=-1 && updir<mindepth)
			{
				mindepth = updir;
				direction = Unit.DIRN_UP;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" UP.");
			}
			if(downdir!=-1 && downdir<mindepth)
			{
				mindepth = downdir;
				direction = Unit.DIRN_DOWN;
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" DOWN.");
			}
			if(depth==0)
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" GO:"+direction);
				return direction;
			}
			else
			{
				//Game.WriteDebug("sx:"+sx+" sy:"+sy+" fx:"+fx+" fy:"+fy+" depth:"+depth+" MINDEPTH:"+mindepth);
				return mindepth;
			}
		}
	}
	
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Map
	{
	
	public static int hillson = 0;//20oct2021
	public static bool israining = false;//15oct2021
	public static bool overriderain = false;//18oct2021
	public static int raining = -4;//15oct2021
	public static int MAXRAIN = 400;
	public static int[] rainx = new int[MAXRAIN];//15oct2021
	public static int[] rainy = new int[MAXRAIN];//15oct2021
	public static int[] rainh = new int[MAXRAIN];//15oct2021
	
	public static void SetUpHills()//20oct2021
	{
		for(int i=0;i<Map.hillimage.Length;i++)
		{
			Map.hillimage[i] = 0;
		}
		if(Map.hillson>0)
		{
			if(Map.weather==Map.WEATHERNORMAL)
			{
				if(Game.missions[0].ghill!=null)
				{
					for(int i=0;i<Game.missions[0].ghill.Length;i++)
					{
						Map.hillimage[Game.missions[0].ghill[i]] = 1;
					}
				}
			}
			if(Map.weather==Map.WEATHERHOT)
			{
				if(Game.missions[0].dhill!=null)
				{
					for(int i=0;i<Game.missions[0].dhill.Length;i++)
					{
						Map.hillimage[Game.missions[0].dhill[i]] = 1;
					}
				}
				
			}
			if(Map.weather==Map.WEATHERCOLD)
			{
				if(Game.missions[0].shill!=null)
				{
					for(int i=0;i<Game.missions[0].shill.Length;i++)
					{
						Map.hillimage[Game.missions[0].shill[i]] = 1;
					}
				}
			}
			
		}
	}
	
	public static void drawrain(Game game)//15oct2021
	{
		if(!overriderain)//18oct2021
		{
			if(Map.weather==Map.WEATHERCOLD)
			{
				raining = -4;
				if(CampaignMap.seed % 100 > 90)
				{
					raining = 0;
				}
			}
			else
			{
				raining = 0;
				if(Map.weather==Map.WEATHERNORMAL)
				{
					if(CampaignMap.seed % 100 > 50)
					{
						raining = -3;
					}
				}
			}
		}
		if(raining==0)
		{
			israining = false;
			return;
		}
		israining = true;
		for(int i=0;i<MAXRAIN;i++)
		{
			if(rainh[i]<=0)
			{
				rainh[i] = 100 + Functions.rand(0,300);
				rainx[i] = Functions.rand(-200,Game.RESOLUTIONX + 200);
				rainy[i] = Functions.rand(0,Game.RESOLUTIONY) - 200;
			}
			else
			{
				rainh[i] += raining;
				rainx[i] = rainx[i] + raining / 2;
				rainy[i] = rainy[i] - (raining * 3) / 2;
				//RenderList.drawline(game,rainx[i],rainy[i],rainx[i] + 2,rainy[i] + 3,RenderList.getrgb(36,36,36),0);
				RenderList.drawrect(game,rainx[i],rainy[i],4,5,RenderList.getrgb(124,124,144),0);
			}
		}
	}
	
	public static int WEATHERNORMAL = 0;//7oct2021
	public static int WEATHERCOLD = 1;//7oct2021
	public static int WEATHERHOT = 2;//7oct2021
	public static int weather = WEATHERNORMAL;
	public static bool MINIMAPMODE = false;//18sep2021
	public static int DECOR = 9999;//18sep2021
	public static int levelseed = 0; //2apr2021
	public static int levelseed2 = 0;//2apr2021
	public static bool issnow = false;
	public static bool isdesert = false;
	public static bool isrgbbk = false;
	public static int isrgbbk_r = 0;
	public static int isrgbbk_g = 0;
	public static int isrgbbk_b = 0;
	public static int FADEOUT = 10;
	public static int MAXMUSIC=3;
	public static int[] musictrack;
	public static String[] musictrackfile;//25mar2021
	public static int[] musicduration;
	public static int musicplaying;
	public static int musicstartframe;
	public static int menumusic;
	public static int menumusicplaying;
	public static string menumusicfile = ""; //25mar2021
	public static bool OPENMAP = false;
	public static int[] deadcell = new int[10];	
	public static int VACANT = -1;
	public static int PATHINIT = 99999;
	public static int NOTCHECKED = -2;
	public static int MAXX = 100;
	public static int MAXY = 100;
	public static int GRIDW = 32;
	public static int GRIDH = 32;
	public static int indoor = 0;//23sep2021
	public static int DEFAULTGRIDW = 32;//10sep2021
	public static int DEFAULTGRIDH = 32;//10sep2021
	public static int[] unitmap; //id to unit in cell
	public static int[] tilefog; //15sep2021
	public static int[] unitcollisionmap;
	public static int[] flightmap;//4may2021 //id to unit in cell...for flyers....MAXX*MAXY*10 (10 should be sufficient)(3 dimensional array as 1 dimensional array)
	public static int[] flightlist;//4may2021
	public static int FLIGHTLEVELS = 2;//4may2021
	public static int FLIGHTLAYER = 999;//4may2021
	public static int[] pathmap;
	public static int[,,,] precalcedpaths;
	public static int[,,,] losmap;//15sep2021
	public static int precalcframestart;
	public static int precalcframestart2;
	public static bool ignoreunits;
	//
	public static int[] heightmap;
	public static int[] tileimage;
	public static int[] treeimage;
	public static int[] rockimage;
	public static int[] wallimage;
	public static int[] hillimage;//20oct2021
	public static bool dirtymap = true;
	public static int FIRETIME = 60 * 10;
	public static int[] firecell;
	public static int firecat;
	public static int fireframes;
	public static int hillgrass;//20oct2021
	public static int hillsnow;//20oct2021
	public static int hilldesert;//20oct2021
	public static int tilecat;
	public static int treecat;
	public static int grasstilecat;//7oct2021
	public static int grasstreecat;//7oct2021
	public static int snowtilecat;//7oct2021
	public static int snowtreecat;//7oct2021
	public static int deserttilecat;//7oct2021
	public static int deserttreecat;//7oct2021
	public static int treeframes;
	public static int missiontreeframes;//28mar2021
	public static int treeoffsety;
	public static int rockcat;
	public static int rockframes;
	public static int rockoffsety;
	public static int wallcat;
	public static int wallframes;
	public static int walloffsety;
	public static int tileframes;
	//start--------------//2mar2021
	public static int[] decorimage;
	public static int decorcat;
	public static int decorframes;
	public static int odecorframes; //15mar2021
	public static int decoroffsety;
	//end----------------//2mar2021
	public static int[] treepositions;
	public static int FOGMAXX = 24;
	public static int FOGMAXY = 24;
	public static int FOGW = 160;
	public static int FOGH = 160;
	public static float FOGSCALE = 1f;//18sep2021
	public static float FOGADD = -0.25f;
	public static bool[] fog;
	public static float[] fogalpha;
	//
	public static string pathfile = "";
	public static bool threadrunning = false;

	public static int TILELIGHTRADIUS = 8;//15sep2021
	public static int MAXTILEFOG = 300;//15sep2021

	public static int tmptilecat; 
	public static int tmptreecat;
	public static int tmprockcat;
	public static int tmpwallcat;
	public static int tmpdecorcat;
	public static int tmptreeoffsety; 
	public static int tmprockoffsety;
	public static int tmpwalloffsety;
	public static int tmpdecoroffsety;


///////////////////Method Definition///////////////
	public static bool TileVisible(int x,int y)
	{
		if(Config.TILEFOG==0)
		{
			return true;
		}
		int gx = x / GRIDW;
		int gy = y / GRIDH;
		if(gx<0 || gy<0 || gx>=MAXX || gy>=MAXY)
		{
			return true;
		}
		if(tilefog[gx + gy * MAXX]<=0)
		{
			return false;
		}
		return true;
	}
///////////////////Method Definition///////////////
	public static int TileFog(Game game,int x,int y)//15sep2021
	{
		if(Config.TILEFOG==0)
		{
			return 0;
		}
		if(x<0 || y<0 || x>=MAXX || y>=MAXY)
		{
			return 0;
		}
		//update tilefog.....
		if(tilefog[x + y * MAXX]>0)
		{
			tilefog[x + y * MAXX]--;
			int jx = x + (Game.frame % (TILELIGHTRADIUS*2)) - TILELIGHTRADIUS;
			int jy = y + ((Game.frame - (Game.frame % (TILELIGHTRADIUS*2)))/(TILELIGHTRADIUS*2)) - TILELIGHTRADIUS;
			if(Map.cellunit(jx,jy)!=-1)
			{
				int jid = Map.cellunit(jx,jy);
				if(Game.units[jid].hp>0 && Game.units[jid].faction==Game.PLAYERFACTION)
				{
					tilefog[x + y * MAXX] = MAXTILEFOG;
				}
			}
			return 0;
		}
		for(int ix=x-TILELIGHTRADIUS;ix<=x+TILELIGHTRADIUS;ix++)
		{
			if(ix<0 || ix>=MAXX)
			{
				continue;
			}
			for(int iy=y-TILELIGHTRADIUS;iy<=y+TILELIGHTRADIUS;iy++)
			{
				if(iy<0 || iy>=MAXY)
				{
					continue;
				}
				
				if(Map.cellunit(ix * GRIDW,iy * GRIDH)!=-1)
				{
					int id = Map.cellunit(ix * GRIDW,iy * GRIDH);
					if(Game.units[id].hp>0 && Game.units[id].faction==Game.PLAYERFACTION)
					{
						tilefog[x + y * MAXX]=MAXTILEFOG;
						return 0;
					}
				}
			}
		}
		return 1;
	}
	
///////////////////Method Definition///////////////
	public static void init() //13mar2021
	{
		//map initialisation used at startup and restartup
		musictrack = null; 
		musicduration = null; 
		musicplaying = 0;
		musicstartframe = 0;
		menumusic = 0;
		menumusicplaying = 0;
		OPENMAP = false;
		deadcell = new int[10];	
		unitmap = null; //id to unit in cell
		tilefog = null; //15sep2021
		flightmap = null;//id to unit in cell //4may2021
		flightlist = null;//4may2021
		unitcollisionmap = null;
		pathmap = null;
		precalcedpaths = null;
		losmap = null;//15sep2021
		heightmap = null;
		tileimage = null;
		treeimage = null;
		rockimage = null;
		wallimage = null;
		hillimage = null;//20oct2021
		firecell  = null;
		firecat = 0;
		fireframes = 0;
		tilecat = 0;
		treecat = 0;
		//7oct202 grass/desert/snow
		hilldesert = -1;//20oct2021
		hillgrass = -1;//20oct2021
		hillsnow = -1;//20oct2021
		grasstilecat = 0;
		snowtilecat = 0;
		deserttilecat = 0;
		grasstreecat = 0;
		deserttreecat = 0;
		snowtreecat = 0;
		treeframes = 0;
		treeoffsety = 0;
		rockcat = 0;
		rockframes = 0;
		rockoffsety = 0;
		wallcat = 0;
		wallframes = 0;
		walloffsety = 0;
		tileframes = 0;
		GRIDW = 32;//10sep2021
		GRIDH = 32;//10sep2021
		//DEFAULTGRIDH = 32;//10sep2021
		//DEFAULTGRIDW = 32;//10sep2021
		//start--------------//2mar2021
		decorimage = null;
		decorcat = 0;
		decorframes = 0;
		decoroffsety = 0;
		//end----------------//2mar2021
		treepositions = null;
		fog = null;
		fogalpha = null;
		//
		pathfile = "";
	}

///////////////////Method Definition///////////////
		public static void loadpath(int mission)
		{
			//not used
			if(!Config.USEPATHFILE)
			{
				return;
			}
			try
			{
				string file = Config.custommapfolder + "\\path"+mission+".txt";
				string[] data = System.IO.File.ReadAllLines(file);
				for(int i=0;i<data.Length;i++)
				{
					string[] dataline = data[i].Split(",");
					if(dataline.Length==5)
					{
						int x0 = 0;
						int y0 = 0;
						int x1 = 0;
						int y1 = 0;
						int dd = Map.NOTCHECKED;
						Int32.TryParse(dataline[0],out x0);
						Int32.TryParse(dataline[1],out y0);
						Int32.TryParse(dataline[2],out x1);
						Int32.TryParse(dataline[3],out y1);
						Int32.TryParse(dataline[4],out dd);
						if(dd!=Map.NOTCHECKED)
						{
							precalcedpaths[x0,y0,x1,y1] = dd;
						}
					}
				}
			}
			catch(Exception e)
			{
				string msg = e.Message;
			}
		}
		//

///////////////////Method Definition///////////////
		public static void savepath(int mission)
		{
			//not used
			if(!Config.USEPATHFILE)
			{
				return;
			}
			if(threadrunning)
			{
				return;
			}
			threadrunning = true;
			pathfile = Config.custommapfolder + "\\path"+mission+".txt";
			Thread thread = new Thread(new ThreadStart(ThreadFunction));
			thread.Start();	
		}
		//

///////////////////Method Definition///////////////
		private static void ThreadFunction()
		{
			//not used
			string txt = "";
			for(int x0=0;x0<MAXX;x0++)
			{
				for(int y0=0;y0<MAXY;y0++)
				{
					for(int x1=0;x1<MAXX;x1++)
					{
						for(int y1=0;y1<MAXY;y1++)
						{
							if(precalcedpaths[x0,y0,x1,y1]!=Map.NOTCHECKED && precalcedpaths[x0,y0,x1,y1]!=-1)
							{
								txt+=x0+","+y0+","+x1+","+y1+","+precalcedpaths[x0,y0,x1,y1]+Environment.NewLine;
								precalcedpaths[x0,y0,x1,y1] = Map.NOTCHECKED;
							}
						}
					}
				}
			}
			try
			{
				System.IO.File.WriteAllText(pathfile,txt);
				//Game.WriteDebug("Map Saved To:"+file);
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
			}
			threadrunning = false;
		}

///////////////////Method Definition///////////////
		public static void opencampaign(Game game)
		{
			//open the user campaign file
			try
			{
				System.Diagnostics.Process.Start("notepad.exe",Config.usercampaignfile);
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
			}
		}

///////////////////Method Definition///////////////
		public static void savemap(Game game)
		{
			//save the user custom map to a temporary file
			string file = Config.custommapfolder + "\\"+Config.custommapprefix+Game.frame+".txt";
			string txt = "";
			txt+="///////////////////////////////////////////////"+Environment.NewLine;
			txt+="//////KOG2 Level Editor Map 2021///////////////"+Environment.NewLine;
			txt+="///////////////////////////////////////////////"+Environment.NewLine;
			txt+="//change the mission name from custom map to something useful."+Environment.NewLine;
			txt+="mission=custom map"+Environment.NewLine;
			txt+="///////////////////"+Environment.NewLine;
			txt+="//Some editing by hand in the text file will likely be required to make this game ready."+Environment.NewLine;
			txt+="//If you haven't already, check the editor manual for details (English Only currently)"+Environment.NewLine;
			txt+="//But to make this level playable you have to copy the contents of this file onto the end of the relevant campaign00.txt file or usercampaign.txt file"+Environment.NewLine;
			txt+="///////////////////"+Environment.NewLine;
			txt+="//Description of Mission Here"+Environment.NewLine;
			txt+="description=Description Line 1"+Environment.NewLine;
			txt+="description=Description Line 2"+Environment.NewLine;
			txt+="description=Description Line 3(maximum)"+Environment.NewLine;
			txt+="//"+Environment.NewLine+"//"+Environment.NewLine+"//"+Environment.NewLine;
			txt+="//Leave this as default unless you know what it means. (it refers to the index position in the array of the mission, the first mission is index 0)."+Environment.NewLine;
			txt+="nextmissionid="+Game.nextmissionid+Environment.NewLine;
			txt+="failedmissionid="+Game.failedmissionid+Environment.NewLine;
			txt+="objective=[some objective here]"+Environment.NewLine;
			txt+="//add triggers by hand"+Environment.NewLine;
			txt+="Modify the corner position by hand."+Environment.NewLine;
			txt+="corner="+Game.CORNERX+","+Game.CORNERY+Environment.NewLine;
			txt+="///////////////////"+Environment.NewLine;
			txt+="//These features are special - use if you know what you are doing. Not set in editor.//"+Environment.NewLine;
			txt+="//lockcorner=0"+Environment.NewLine;
			txt+="//demo=0"+Environment.NewLine;
			txt+="//debrief=0"+Environment.NewLine;
			txt+="//nextmissionname=blank"+Environment.NewLine;
			txt+="//failedmissionname=blank"+Environment.NewLine;
			txt+="//fogoff=0"+Environment.NewLine;
			txt+="//neutralfog=0"+Environment.NewLine;
			txt+="//seed=123456"+Environment.NewLine;
			txt+="//unlocked=0"+Environment.NewLine;
			txt+="///////////////////"+Environment.NewLine;
			if(Game.skirmish)
			{
				txt+="//this will mean the level will not be treated as a campaign level."+Environment.NewLine;
				txt+="skirmish=1"+Environment.NewLine;
			}
			else
			{
				txt+="skirmish=0"+Environment.NewLine;
			}
			txt+="//Triggers are here"+Environment.NewLine;
			txt+="//any trigger=3 or trigger=4 (chatter) triggers will need translating to other languages."+Environment.NewLine;
			for(int i=0;i<Game.triggers.Length;i++)
			{
				if(Game.triggers[i].type==0)
				{
					continue;
				}
				txt+="trigger="+Game.triggers[i].type+","+Game.triggers[i].n+","+Game.triggers[i].comparator+","+Game.triggers[i].unitname.Replace(",","^")+","+Game.triggers[i].x+","+Game.triggers[i].y+","+Game.triggers[i].fx+","+Game.triggers[i].fy+Environment.NewLine;
			}
			txt+="Remember to Change This Next Line Accordingly"+Environment.NewLine;
			txt+="//Set ai=1 for an aggressive ai, otherwise leave as 0."+Environment.NewLine;
			txt+="ai=0"+Environment.NewLine;
			txt+="Trees, Rocks and Walls are here:"+Environment.NewLine;
			int count = 0;
			int index = 0;
			for(int i=0;i<Map.treeimage.Length;i++)
			{
				if(Map.treeimage[i]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				txt+="trees=";
				for(int i=0;i<Map.treeimage.Length;i++)
				{
					if(Map.treeimage[i]!=-1)
					{
						index++;
						if(index<count)
						{
							txt+=""+i+",";
						}
						else
						{
							txt+=""+i;
						}
					}
				}
			}
			txt+=Environment.NewLine;
			count=0;
			index=0;
			for(int i=0;i<Map.rockimage.Length;i++)
			{
				if(Map.rockimage[i]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				txt+="rocks=";
				for(int i=0;i<Map.rockimage.Length;i++)
				{
					if(Map.rockimage[i]!=-1)
					{
						index++;
						if(index<count)
						{
							txt+=""+i+",";
						}
						else
						{
							txt+=""+i;
						}
					}
				}
			}
			txt+=Environment.NewLine;
			count=0;
			index=0;
			for(int i=0;i<Map.wallimage.Length;i++)
			{
				if(Map.wallimage[i]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				txt+="walls=";
				for(int i=0;i<Map.wallimage.Length;i++)
				{
					if(Map.wallimage[i]!=-1)
					{
						index++;
						if(index<count)
						{
							txt+=""+i+",";
						}
						else
						{
							txt+=""+i;
						}
					}
				}
			}
			txt+=Environment.NewLine;
			//start--------------//2mar2021
			count=0; //7mar2021 bugfix
			index=0; //7mar2021 bugfix
			for(int i=0;i<Map.decorimage.Length;i++)
			{
				if(Map.decorimage[i]!=-1)
				{
					count++;
				}
			}
			if(count>0)
			{
				txt+="decor=";
				for(int i=0;i<Map.decorimage.Length;i++)
				{
					if(Map.decorimage[i]!=-1)
					{
						index++;
						if(index<count)
						{
							txt+=""+i+",";
						}
						else
						{
							txt+=""+i;
						}
					}
				}
			}
			txt+=Environment.NewLine;
			//end----------------//2mar2021
			//start-----------------//21mar2021
			//faction set here
			txt+="Factions Are Here (change them if they're wrong as they auto-detected):"+Environment.NewLine;
			int pfaction=-1;
			int efaction=-1;
			for(int i=0;i<Game.units.Length;i++)
			{
				if(Game.units[i].hp>0 && Game.units[i].faction<Unit.NULLFACTION)
				{
					if(pfaction==-1)
					{
						pfaction =  Game.units[i].faction;
					}
					if(pfaction!=-1 && Game.units[i].faction!=pfaction)
					{
						if(efaction==-1)
						{
							efaction = Game.units[i].faction;
						}
					}
				}
			}
			//start-----------------//22mar2021
			if(Game.EDITORPFACTION!=0)
			{
				pfaction = Game.EDITORPFACTION;
			}
			if(Game.EDITOREFACTION!=0)
			{
				efaction = Game.EDITOREFACTION;
			}
			//end-------------------//22mar2021
			if(pfaction!=-1)
			{
				txt+="playerfaction=" + pfaction + Environment.NewLine;
			}
			if(efaction!=-1)
			{
				txt+="enemyfaction=" + efaction + Environment.NewLine;
			}
			//end-------------------//21mar2021
			txt+="Units Are Here:"+Environment.NewLine;
			txt+="//You can specify a random x or y position by entering 'random' into the x or y coordinate"+Environment.NewLine;
			for(int i=0;i<Game.units.Length;i++)
			{
				if(Game.units[i].hp>0)
				{
					txt+="unit="+Game.units[i].name+","+Game.units[i].x+","+Game.units[i].y+Environment.NewLine;
				}
			}
			txt+="///////////////////////////////////////////////"+Environment.NewLine;
			txt+="End of Mission"+Environment.NewLine;
			txt+="///////////////////////////////////////////////"+Environment.NewLine;
			try
			{
				System.IO.File.WriteAllText(file,txt);
				Game.WriteDebug("Map Saved To:"+file);
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
			}
			if(OPENMAP)
			{
				try
				{
					System.Diagnostics.Process.Start(@Environment.GetFolderPath(Environment.SpecialFolder.Windows)+"\\notepad.exe",file);
				}
				catch(Exception e)
				{
					Game.WriteDebug(e.Message);
				}
			}
			OPENMAP = false;
		}

///////////////////Method Definition///////////////
		public static void marktreepos(Game game)
		{
			//mark trees on the minimap
			int count = 0;
			for(int i=0;i<treeimage.Length;i++)
			{
				if(treeimage[i]!=-1)
				{
					count++;
				}
			}
			for(int i=0;i<rockimage.Length;i++)
			{
				if(rockimage[i]!=-1)
				{
					count++;
				}
			}
			for(int i=0;i<wallimage.Length;i++)
			{
				if(wallimage[i]!=-1)
				{
					count++;
				}
			}
			treepositions = new int[count];
			count = 0;
			for(int i=0;i<treeimage.Length;i++)
			{
				if(treeimage[i]!=-1)
				{
					treepositions[count] = i;
					count++;
				}
			}
			for(int i=0;i<rockimage.Length;i++)
			{
				if(rockimage[i]!=-1)
				{
					treepositions[count] = i;
					count++;
				}
			}
			for(int i=0;i<wallimage.Length;i++)
			{
				if(wallimage[i]!=-1)
				{
					treepositions[count] = i;
					count++;
				}
			}
		}

///////////////////Method Definition///////////////
		public static void correct(Game game)
		{
			//correct the map array
			//so far I have never found an error with the map
			//but this should clean up any errors if and when they occur
			//2sep2021 removed due to testing flight mode.....should not reintroduce
			int errors = 0;
			for(int i=0;i<unitmap.Length;i++)
			{
				if(Config.DEBUG)
				{
					if(unitmap[i]!=VACANT)
					{
						int nid = unitmap[i];
						if(nid>=0 && nid<Game.units.Length)
						{
							int x = i % MAXX;
							int y = (i - x) / MAXX;
							int gx = Game.units[nid].x / GRIDW;
							int gy = Game.units[nid].y / GRIDH;
							if(gx!=x || gy!=y)
							{
								errors++;
							}
						}
						else
						{
							errors++;
						}
					}
				}
				unitmap[i] = VACANT;
			}
			for(int i=0;i<Game.units.Length;i++)
			{
				//if(Game.units[i].hp>0)//17sep2021
				if(Game.units[i].hp>0 && Game.units[i].flightlevel==-1)//17sep2021
				{
					int gx = Game.units[i].x / GRIDW;
					int gy = Game.units[i].y / GRIDH;
					if(gx>=0 && gx<MAXX)
					{
						if(gy>=0 && gy<MAXY)
						{
							unitmap[gx + gy * MAXX] = i;
						}
					}
				}
			}
			if(errors>Config.maxmaperrors)
			{
				Config.maxmaperrors = errors;
			}
		}

///////////////////Method Definition///////////////
		public static void updatemusic(Game game)
		{
			//handle music control
			if(Game.gamestate==Game.CAT_GAMESTATE_GAME)
			{
				if(menumusicplaying!=-1)
				{
					SDL_mixer.Mix_PauseMusic();
					menumusicplaying = -1;
				}
				bool startnewmusic = false;
				if(musicplaying==-1)
				{
					startnewmusic = true;
				}
				else
				{
					int v  = 0;
					if(Game.frame > musicstartframe + 60 * musicduration[musicplaying])
					{
						startnewmusic = true;
					}
					if(Game.frame/Map.FADEOUT < (musicstartframe/Map.FADEOUT) + Game.MUSICVOLUME)
					{
						v = (Game.frame - musicstartframe)/Map.FADEOUT;
						if(v<=0)
						{
							v = 1;
						}
						if(v>Game.MUSICVOLUME)
						{
							v = Game.MUSICVOLUME;
						}
					}
					if((Game.frame/Map.FADEOUT) > (musicstartframe + 60 * (musicduration[musicplaying] - 5))/Map.FADEOUT)
					{
						v = Game.MUSICVOLUME - (Game.frame - (musicstartframe + 60 * (musicduration[musicplaying] - 5)))/Map.FADEOUT;
						if(v<=0)
						{
							v = 1;
						}
						if(v>Game.MUSICVOLUME)
						{
							v = Game.MUSICVOLUME;
						}
					}
					if(v!=0){SDL_mixer.Mix_VolumeMusic(v);}
				}
				if(startnewmusic)
				{
					int nmusic = (int)(Functions.rand(0,1000) % musictrack.Length);
					if(nmusic==musicplaying)
					{
						nmusic++;
						nmusic%=musictrack.Length;
					}
					if(musictrack[nmusic]!=-1)
					{
						if(musicplaying!=-1)
						{
							SDL_mixer.Mix_PauseMusic();
						}
						musicplaying = nmusic;
						Audios.playmusic(Game.audios[musictrack[musicplaying]],Game.MUSICVOLUME,true);
						musicstartframe = Game.frame;
					}
				}
			}
			else
			{
				if(musicplaying!=-1)
				{
					SDL_mixer.Mix_PauseMusic();
					Map.musicplaying = -1;
					Map.musicstartframe = -1;
				}
				if(menumusicplaying==-1)
				{
					if(menumusic!=-1)
					{
						menumusicplaying = 0;
						Audios.playmusic(Game.audios[menumusic],Game.MUSICVOLUME,true);
					}
				}
				else
				{
				}
			}
		}

///////////////////Method Definition///////////////
		public Map()
		{
			//initialise the map object
				//for(int i=0;i<deadcell.Length;i++)
				//{
				//	deadcell[i] = -1;
				//}
				decorframes = 0;//15mar2021
				if(musictrack==null)
				{
					musictrack = new int[MAXMUSIC];
					musicduration = new int[MAXMUSIC];
					musicplaying = -1;
					musicstartframe = -1;
					for(int i=0;i<MAXMUSIC;i++)
					{
						musictrack[i] = -1;
						musicduration[i] = -1;
					}
				}
				//
				flightmap = new int[MAXX*MAXY*FLIGHTLEVELS];//4may2021
				flightlist = new int[0];//4may2021
				unitmap = new int[MAXX*MAXY];
				tilefog = new int[MAXX*MAXY];//15sep2021
				pathmap = new int[MAXX*MAXY];
				heightmap = new int[MAXX*MAXY];
				if(losmap==null)//15sep2021
				{
					losmap = new int[MAXX,MAXY,MAXX,MAXY];//15sep2021
				}
				if(precalcedpaths==null)
				{
					precalcedpaths = new int[MAXX,MAXY,MAXX,MAXY];
				}
				ignoreunits = false;
				if(Map.MINIMAPMODE==false)//18sep2021
				{
					if(!threadrunning)
					{
						for(int i1=0;i1<MAXX;i1++)
						{
							for(int i2=0;i2<MAXY;i2++)
							{
								for(int i3=0;i3<MAXX;i3++)
								{
									for(int i4=0;i4<MAXY;i4++)
									{
										precalcedpaths[i1,i2,i3,i4] = Map.NOTCHECKED;
									}
								}
							}
						}
					}
				}//18sep2021
				precalcframestart = 0;
				precalcframestart2 = 0;
				firecell = new int[MAXX*MAXY];
				fog = new bool[FOGMAXX*FOGMAXY];
				fogalpha = new float[FOGMAXX*FOGMAXY];
				for(int i=0;i<fog.Length;i++)
				{
					fog[i] = true;
					fogalpha[i] = 1f;
				}
				if(tileimage==null)
				{
					tileimage = new int[MAXX*MAXY];
					for(int i=0;i<tileimage.Length;i++)
					{
						tileimage[i] = -1;
						firecell[i] = -1;
					}
				}
				if(treeimage==null)
				{
					treeimage = new int[MAXX*MAXY];
					rockimage = new int[MAXX*MAXY];
					hillimage = new int[MAXX*MAXY];//20oct2021
					wallimage = new int[MAXX*MAXY];
					decorimage = new int[MAXX*MAXY]; //2mar2021
					for(int i=0;i<treeimage.Length;i++)
					{
						treeimage[i] = -1;
						rockimage[i] = -1;
						wallimage[i] = -1;
						decorimage[i] = -1; //2mar2021
						hillimage[i] = 0;//20oct2021
					}
				}
				for(int i=0;i<unitmap.Length;i++)
				{
					unitmap[i] = -1;
					tilefog[i] = 0;//15sep2021
				}
				for(int i=0;i<flightmap.Length;i++)//4may2021
				{
					flightmap[i] = -1;//4may2021
				}
				//
				unitcollisionmap = new int[MAXX*MAXY];
				for(int i=0;i<unitcollisionmap.Length;i++)
				{
					unitcollisionmap[i] = -1;
				}
				for(int i=0;i<pathmap.Length;i++)
				{
					pathmap[i] = -1;
				}
		}

///////////////////Method Definition///////////////
		public static void drawfires(Game game,int x, int y,int w, int h)
		{
			//draw flaming ground pieces
			int ww = 3; 
			for(int fx=x-w;fx<=x+w;fx+=ww)
			{
				int fy = y + Functions.rand(-4,4);
				int hh = h + Functions.rand(-3*h/4,0);
				int r = 255;
				int g = 255;
				int b = 255;
				for(int l=0;l<hh;l++)
				{
					g+= Functions.rand(-32,0);	
					b+= Functions.rand(-96,0);
					if(g<0)
					{
						g = 0;
					}
					if(b<0)
					{
						b = 0;
					}
					int xx = fx + Functions.rand(-w/4,w/4);
					int yy = fy - l;// + Functions.rand(-8,8);
					if(Functions.rand(0,1000+l*200)<500)
					{
						if(l<4)
						{
							RenderList.drawrect(game,xx,yy,5,5,RenderList.getrgb(r,g,b),0);
						}
						else
						{
							RenderList.drawrect(game,xx,yy,3,3,RenderList.getrgb(r,g,b),0);
						}
					}
				}
			}
		}
		//start--------------//2mar2021

///////////////////Method Definition///////////////
		public static void adddecor()
		{
			//not used
			for(int i=0;i<decorimage.Length;i++)
			{
				//if(treeimage[i]==-1 && rockimage[i]==-1 && wallimage[i]==-1)
				//{
					if(Functions.rand(0,1000)<5 && decorframes>0)
					{
						decorimage[i] = Functions.rand(0,1000) % decorframes;
						if(decorimage[i]<-1) //15mar2021 bugfix
						{
							decorimage[i] = -1;
						}
					}
				//}
			}
			if(Map.odecorframes>0) //15mar2021
			{
				Map.decorframes = Map.odecorframes;
			}
		}
		//end----------------//2mar2021

///////////////////Method Definition///////////////
		public static void generate(Game game)
		{
			//not used
			int q = 0;
			flightmap = new int[MAXX*MAXY*FLIGHTLEVELS];//4may2021
			for(int f=0;f<flightmap.Length;f++) //2sep2021
			{
				flightmap[f] = -1;
			}
			flightlist = new int[0];//4may2021
			unitmap = new int[MAXX*MAXY];
			tilefog = new int[MAXX*MAXY];
			pathmap = new int[MAXX*MAXY];
			tileimage = new int[MAXX*MAXY];
			firecell = new int[MAXX*MAXY];
			for(int i=0;i<tileimage.Length;i++)
			{
				tileimage[i] = Functions.rand(0,1000) % tileframes;
				if(Functions.rand(0,100)<80)
				{
					tileimage[i] = 0;
				}
			}
			for(int xx=0;xx<MAXX;xx++)
			{
				for(int yy=0;yy<MAXY;yy++)
				{
					if(Functions.rand(0,1000)<25 || (Game.skirmish==true && Functions.rand(0,1000)<150))
					{
						addbones(xx * GRIDW, yy * GRIDH);
					}
				}
			}
			treeimage = new int[MAXX*MAXY];
			rockimage = new int[MAXX*MAXY];
			hillimage = new int[MAXX*MAXY];//20oct2021
			wallimage = new int[MAXX*MAXY];
			decorimage = new int[MAXX*MAXY]; //2mar2021
			for(int i=0;i<treeimage.Length;i++)
			{
				treeimage[i] = -1;
				firecell[i] = -1;
				rockimage[i] = -1;
				wallimage[i] = -1;
				decorimage[i] = -1; //2mar2021
			}
			int walls = (int)Functions.rand(-10,40);
			if(walls>0)
			{
				for(int wall=0;wall<walls;wall++)
				{
					int wallx = (int)Functions.rand(10,90);
					int wally = (int)Functions.rand(10,90);
					int walldx = (int)Functions.rand(-1,1);
					int walldy = (int)Functions.rand(-1,1);
					if(walldx!=0)
					{
						walldy=0;
					}
					if(walldx==0 && walldy==0)
					{
						walldx=1;
					}
					int walll = (int)Functions.rand(3,8);
					for(int l=0;l<walll;l++)
					{
						int wx = wallx + walldx * l;
						int wy = wally + walldy * l;
						if(wx>=0 && wy>=0 && wx<Map.MAXX && wy<Map.MAXY)
						{
							wallimage[wx + wy * Map.MAXX] = 0;
						}
					}
				}
			}
			for(int i=0;i<treeimage.Length;i++)
			{
				if(Functions.rand(0,100)<8)
				{
					treeimage[i] = Functions.rand(0,1000) % treeframes;
				}
				if(Functions.rand(0,100)>80)
				{
					treeimage[i] = -1;
				}
				if(treeimage[i]!=-1)
				{
					q = Functions.rand(-150,30);
					for(int j=0;j<q;j++)
					{
						int x = i % MAXX;
						int y = (i - x) / MAXX;
						int nx = x + Functions.rand(-4,4);
						int ny = y + Functions.rand(-4,4);
						int k = nx + ny * MAXX;
						if(k>=0 && k<treeimage.Length)
						{
							treeimage[k] = Functions.rand(0,1000) % treeframes;
						}
					}
				}
				if(i % 5==1 || i % 5 == 3)
				{
					if(Functions.rand(0,100)<50)
					{
						treeimage[i] = -1;
					}
				}
				if(treeimage[i]!=-1)
				{
					if(Functions.rand(0,100)<7)
					{
						rockimage[i] = Functions.rand(0,1000) % rockframes;
					}
				}
			}
			q = Functions.rand(10,100);
			for(int j=0;j<q;j++)
			{
				int x = Functions.rand(0,MAXX);
				int y = Functions.rand(0,MAXY);
				int w = Functions.rand(4,12);
				int h = Functions.rand(4,12);
				for(int xx=x;xx<=x+w;xx++)
				{
					for(int yy=y;yy<=y+h;yy++)
					{
						int i = xx + yy * MAXX;
						if(i>=0 && i<treeimage.Length)
						{
							treeimage[i] = -1;
						}
					}
				}
			}
			//start--------------//2mar2021
			for(int i=0;i<treeimage.Length;i++)
			{
				if(treeimage[i]==-1 && rockimage[i]==-1 && wallimage[i]==-1)
				{
					if(Functions.rand(0,100)<5 && decorframes>0)
					{
						decorimage[i] = Functions.rand(0,1000) % decorframes;
					}
				}
			}
			//end----------------//2mar2021
			int treex = -1;
			int treey = -1;
			for(int i=0;i<unitmap.Length;i++)
			{
				unitmap[i] = -1;
				tilefog[i] = 0;//15sep2021
				treex = i % MAXX;
				treey = (i - treex) / MAXX;
				if(treex % 3<2 && treey % 3<2)
				{
					treeimage[i] = -1;
				}
				if(treex % 2==1 && treey % 2==1)
				{
					treeimage[i] = -1;
				}
			}
			if(Game.playingtutorial)
			{
				for(int i=0;i<unitmap.Length;i++)
				{
					treex = i % MAXX;
					treey = (i - treex) / MAXX;
					if(treex % 10<7 || treey % 10<7)
					{
						treeimage[i] = -1;
					}
				}
			}
			//
			unitcollisionmap = new int[MAXX*MAXY];
			for(int i=0;i<unitcollisionmap.Length;i++)
			{
				unitcollisionmap[i] = -1;
			}
			for(int i=0;i<pathmap.Length;i++)
			{
				pathmap[i] = -1;
			}
		}		

///////////////////Method Definition///////////////
		public static bool isonfire(int x,int y)
		{
			//checks whether the ground here is burning
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return false;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return false;
			}
			if(firecell[i]>0)
			{
				return true;
			}
			return false;
		}

///////////////////Method Definition///////////////
		public static void spreadfire(int x,int y,int time)
		{
			//attempt to spread a fire around the map that is burning
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return ;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return;
			}
			if(firecell[i]<=0)
			{
				firecell[i] = time;
			}
		}

///////////////////Method Definition///////////////
		public static void setonfire(int x, int y,bool permanent)
		{
			//set the ground on fire here
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return;
			}
			firecell[i] = Map.FIRETIME;
			if(permanent)
			{
				firecell[i] = Map.FIRETIME * 100000;
			}
		}

///////////////////Method Definition///////////////
		public static void pushmap(int x,int y,int dirn)
		{
			//not used
			pushmapdepth(x / GRIDW,y / GRIDH,4 * dirn,0);
			int radius = 20;
			x/=GRIDW;
			y/=GRIDH;
			for(int gx = x - radius;gx<=x + radius;gx++)
			{
				for(int gy = y - radius;gy<= y + radius;gy++)
				{
					if((gx-x)*(gx-x)+(gy-y)*(gy-y)>radius*radius)
					{
						continue;
					}
					float hh = (float)dirn;
					float factor = (float)((gx-x)*(gx-x)+(gy-y)*(gy-y))/(float)(radius*radius);
					hh *= (1f-factor);
					if(Functions.sign(hh)!=Functions.sign(dirn))
					{
						continue;
					}
					pushmapdepth(gx,gy,(int)hh,0);
				}
			}
		}

///////////////////Method Definition///////////////
		public static void pushmapdepth(int gx, int gy,int dirn,int depth)
		{
			//not used
			if(depth > 2)
			{
				return;
			}
			if(gx<0 || gy<0 || gx>=MAXX || gy>=MAXY)
			{
				return;
			}
			heightmap[gx + gy * MAXX]+=dirn;
		}

///////////////////Method Definition///////////////
		public static int heightdiff2(int curh,int nx,int ny)
		{
			//not used
			int gsx = nx / GRIDW;
			int gsy = ny / GRIDH;
			if(gsx<0 || gsy<0 || gsx>=MAXX || gsy>=MAXY)
			{
				return 0;
			}
			int si = gsx + gsy * MAXX;
			if(si<0 || si >= heightmap.Length)
			{
				return 0;
			}
			return (int)Functions.abs(heightmap[si] - curh);
		}

///////////////////Method Definition///////////////
		public static int getheight(int x,int y)
		{
			//not used
			int gsx = x / GRIDW;
			int gsy = y / GRIDH;
			if(gsx<0 || gsy<0 || gsx>=MAXX || gsy>=MAXY)
			{
				return 0;
			}
			int si = gsx + gsy * MAXX;
			if(si<0 || si >= heightmap.Length)
			{
				return 0;
			}
			return heightmap[si];
		}

///////////////////Method Definition///////////////
		public static int heightdiff(int sx,int sy, int fx, int fy)
		{
			//not used
			//an absolute value.....
			int gsx = sx / GRIDW;
			int gsy = sy / GRIDH;
			int gfx = fx / GRIDW;
			int gfy = fy / GRIDH;
			if(gsx<0 || gsy<0 || gsx>=MAXX || gsy>=MAXY || gfx<0 || gfy<0 || gfx>=MAXX || gfy>=MAXY)
			{
				return 0;
			}
			int si = gsx + gsy * MAXX;
			int fi = gfx + gfy * MAXX;
			if(si<0 || fi<0 || si >= heightmap.Length || fi>=heightmap.Length)
			{
				return 0;
			}
			return (int)Functions.abs(heightmap[si] - heightmap[fi]);
		}

///////////////////Method Definition///////////////
		public static bool ishill(int x,int y)//20oct2021
		{
			int gx = x / GRIDW;//21apr2021
			int gy = y / GRIDH; //21apr2021
			if(gx<0 || gy<0 || gx >= MAXX || gy>= MAXY)
			{
				return false;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return false;
			}
			if(hillimage[i]>0)
			{
				return true;
			}
			return false;
		}
		
///////////////////Method Definition///////////////
		public static bool passable(int x,int y)
		{
			//determine if the position on the map is walkable
			int gx = x / GRIDW;//21apr2021
			int gy = y / GRIDH; //21apr2021
			if(gx<0 || gy<0 || gx >= MAXX || gy>= MAXY)
			{
				return false;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return false;
			}
			if(treeimage[i]!=-1)
			{
				return false;
			}
			if(i>0) //21apr2021
			{
				if(treeimage[i-1]!=-1)
				{
					return false;
				}
			}
			if((i % MAXX) < MAXX - 1) //21apr2021
			{
				if(treeimage[i+1]!=-1)
				{
					return false;
				}
			}
			if(rockimage[i]!=-1)
			{
				return false;
			}
			if(wallimage[i]!=-1)
			{
				return false;
			}
			if(gx>0)
			{
				if(wallimage[i-1]!=-1)
				{
					return false;
				}
			}
			if(gx<MAXX-1)
			{
				if(wallimage[i+1]!=-1)
				{
					return false;
				}
			}
			//until we start putting obstacles in....
			return true;
		}

///////////////////Method Definition///////////////
		public static bool nearobstacle(int x,int y)
		{
			//determine if the position on the map is near an obstacle
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return false;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return false;
			}
			for(int gxx=gx-2;gxx<=gx+2;gxx++)
			{
				for(int gyy=gy-2;gyy<=gy+2;gyy++)
				{
					if(gxx>=0 && gyy>=0 && gxx<Map.MAXX && gyy<Map.MAXY)
					{
						i = gxx + gyy * MAXX;
						if(treeimage[i]!=-1)
						{
							return true;
						}
						if(rockimage[i]!=-1)
						{
							return true;							
						}
						if(wallimage[i]!=-1)
						{
							return true;
						}
					}
				}
			}
			return false;
		}

///////////////////Method Definition///////////////
		public static void planttree(int x,int y)//28mar2021
		{
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return;
			}
			if(cellunit(x,y)!=-1)
			{
				return;
			}
			int tmptreeframes = treeframes;
			if(missiontreeframes!=treeframes && missiontreeframes>0)
			{
				tmptreeframes = missiontreeframes;
			}
			if(tmptreeframes<=0)
			{
				return;
			}
			treeimage[i] = (int)Functions.abs(Functions.rand(0,1000)) % tmptreeframes;
			Array.Resize(ref Game.newtrees,Game.newtrees.Length + 1);//24apr2021
			Game.newtrees[Game.newtrees.Length -1] = i + 1;//treeimage[i] + 1;//24apr2021 //1 based index not 0 based index
		}
		
///////////////////Method Definition///////////////
		public static bool isfogged(int x,int y)
		{
			//check if the region is covered in fog
			int fogx = (int)((float)x / (float)Map.FOGW);
			int fogy = (int)((float)y / (float)Map.FOGH);
			int f = fogx + fogy * Map.FOGMAXX;
			if(f>=0 && f<Map.fog.Length)
			{
				return Map.fog[f];
			}
			return true;
		}

///////////////////Method Definition///////////////
		public static void fogclear(Game game,int id)
		{
			//clear fog from the map here
			//if(Game.units[id].faction==Game.PLAYERFACTION) //26Feb2021
			if(Game.units[id].faction==Game.PLAYERFACTION || (Game.neutralfog==1 && Game.units[id].faction==Unit.NULLFACTION) || Game.neutralfog==-1) //26Feb2021
			{
				int fogx = (int)((float)Game.units[id].x / (float)Map.FOGW);
				int fogy = (int)((float)Game.units[id].y / (float)Map.FOGH);
				for(int xx=fogx-1;xx<=fogx+2;xx++)
				{
					for(int yy=fogy-1;yy<=fogy+2;yy++)
					{
						int f = xx + yy * Map.FOGMAXX;		
						if(f>=0 && f<Map.fog.Length)
						{
							Map.fog[f] = false;
							Map.fogalpha[f]+= Map.FOGADD;
							if(Map.fogalpha[f]<-10)
							{
								Map.fogalpha[f]=-10;
							}
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void fogdraw(Game game)
		{
			//draw fog on the map
			if(Game.fogoff==1) //26Feb2021
			{//26Feb2021
				return;//26Feb2021
			}//26Feb2021
			for(int i=0;i<Map.fog.Length;i++)
			{
				int fogx = ((i % Map.FOGMAXX) * Map.FOGW) - Game.CORNERX;
				int fogy = Map.FOGH * (((i - (i % Map.FOGMAXX)) / Map.FOGMAXX)) - Game.CORNERY;
				if(Map.fogalpha[i]<-10)
				{
					Map.fogalpha[i] = -10f;
				}
				Map.fogalpha[i]+= 10f / (float)(60 * 10);
				if(Map.fogalpha[i]>1)
				{
					Map.fogalpha[i] = 1;
				}
				float alpha = Map.fogalpha[i];
				if(alpha<0)
				{
					alpha = 0;
				}
				if(alpha>1)
				{
					alpha = 1;
				}
				if(fogx>-150 && fogy>-150 && fogx<Game.RESOLUTIONX+150 && fogy<Game.RESOLUTIONY+150)
				{
					if(alpha==1)
					{
						//RenderList.drawimage(game,Game.images[Resources.FOG].texture,fogx,fogy,0,1.1f,1.1f,0,0,false,alpha,Resources.FOG);	//18sep2021
						RenderList.drawimage(game,Game.images[Resources.FOG].texture,fogx,fogy,0,Map.FOGSCALE*1.1f,Map.FOGSCALE*1.1f,0,0,false,alpha,Resources.FOG);	
					}
					else
					{
						if(alpha>0)
						{
							//RenderList.drawimage(game,Game.images[Resources.FOG].texture,fogx,fogy,0,1,1,0,0,false,alpha,Resources.FOG);	//18sep2021
							RenderList.drawimage(game,Game.images[Resources.FOG].texture,fogx,fogy,0,Map.FOGSCALE,Map.FOGSCALE,0,0,false,alpha,Resources.FOG);	
						}
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void drawminimap(Game game,int sx,int sy, int fx,int fy)
		{
			//not used
			for(int y=0;y<MAXY;y++)
			{
				for(int x=0;x<MAXX;x++)
				{
					int i = x + y * MAXX;
					int screenx = sx + (fx - sx) * x / MAXX;
					int screeny = sy + (fy - sy) * y / MAXY;
					float scalex = 1.1f*(float)(fx - sx) / (float)(MAXX * GRIDW);
					float scaley = 1.1f*(float)(fy - sy) / (float)(MAXY * GRIDH);
					if(i>=0 && i<tileimage.Length)
					{
						if(tileimage[i]!=-1)
						{
							RenderList.drawimage(game,Game.images[tilecat].texture,screenx,screeny,0,scalex,scaley,tileimage[i],0,false,1f,tilecat);	
						}
						if(rockimage[i]!=-1)
						{
							RenderList.drawimage(game,Game.images[rockcat].texture,screenx,screeny+(int)((float)Map.rockoffsety*scaley),0,scalex,scaley,rockimage[i],0,false,1f,rockcat);	
						}
						if(wallimage[i]!=-1)
						{
							RenderList.drawimage(game,Game.images[wallcat].texture,screenx,screeny+(int)((float)Map.walloffsety*scaley),0,scalex,scaley,wallimage[i],0,false,1f,wallcat);	
						}
						if(treeimage[i]!=-1)
						{
							RenderList.drawimage(game,Game.images[treecat].texture,screenx,screeny+(int)((float)Map.treeoffsety*scaley),0,scalex,scaley,treeimage[i],0,false,1f,treecat);	
						}		
					}
				}
			}
		}

///////////////////Method Definition///////////////
	public static void draw(Game game,int x,int y,int layer)
	{
		//4may2021 added flyers.......
		//main map drawing routine
		int gx = x / GRIDW;
		int gy = y / GRIDH;
		int offsetx = 0;//0GRIDW / 2; //28sep2021 - this is in order to make it look like the user doesn't get stuck against the gap of one cell between the left wall and their position
		if(gx<0 || gy<0)
		{
			return ;
		}
		int i = gx + gy * MAXX;
		if(i<0 || i>=tileimage.Length)
		{
			return;
		}
		//26oct2020 start
		if(Map.dirtymap)
		{	
			Map.dirtymap = false;
			issnow = false;
			isdesert = false;
			isrgbbk = false; //1nov2020
			tmptilecat = tilecat;
			tmptreecat = treecat;
			tmprockcat = rockcat;
			tmpwallcat = wallcat;
			tmpdecorcat = decorcat; //2mar2021
			tmptreeoffsety = treeoffsety;
			tmprockoffsety = rockoffsety;
			tmpwalloffsety = walloffsety;
			tmpdecoroffsety = decoroffsety; //2mar2021
			//if(Game.missions!=null) //&& Game.skirmish==false)//22mar2021
			//if(Game.missions!=null && Game.EDITOR==false) //22mar2021
			if(Game.missions!=null && (Game.EDITOR==false || (Game.EDITOR==true && Game.demomode==false))) //14apr2021
			{
				if(Game.missionid>=0 && Game.missionid<Game.missions.Length)
				{
					if(Game.missions[Game.missionid].demo==0 || Game.EDITOR==false)//19apr2021
					{
						if(Game.missions[Game.missionid].tilecat!=-1)
						{
							tmptilecat = Game.missions[Game.missionid].tilecat;
							issnow = Game.missions[Game.missionid].issnow;
							isdesert = Game.missions[Game.missionid].isdesert;
						}
						if(Game.missions[Game.missionid].treecat!=-1)
						{
							tmptreecat = Game.missions[Game.missionid].treecat;
							tmptreeoffsety = Game.missions[Game.missionid].treeoffsety;
						}
						if(Game.missions[Game.missionid].wallcat!=-1)
						{
							tmpwallcat = Game.missions[Game.missionid].wallcat;
							tmpwalloffsety = Game.missions[Game.missionid].walloffsety;
						}
						if(Game.missions[Game.missionid].rockcat!=-1)
						{
							tmprockcat = Game.missions[Game.missionid].rockcat;
							tmprockoffsety = Game.missions[Game.missionid].rockoffsety;
						}
						//start--------------//2mar2021
						if(Game.missions[Game.missionid].decorcat!=-1)
						{
							tmpdecorcat = Game.missions[Game.missionid].decorcat;
							tmpdecoroffsety = Game.missions[Game.missionid].decoroffsety;
						}
						//end----------------//2mar2021
						if(Game.missions[Game.missionid].overridergbbk)//1nov2020
						{
							isrgbbk_r = Game.missions[Game.missionid].overridergbbk_r;
							isrgbbk_g = Game.missions[Game.missionid].overridergbbk_g;
							isrgbbk_b = Game.missions[Game.missionid].overridergbbk_b;
							isrgbbk = true;//14apr2021
						}
					}//19apr2021
				}
			}
		}
		//26oct2020 end
		//start------------//18sep2021
		if(layer==Map.DECOR)//decor
		{
			if(decorimage[i]!=-1)
			{
				RenderList.drawimage(game,Game.images[tmpdecorcat].texture,offsetx + x-Game.CORNERX,heightmap[i] + y-Game.CORNERY + tmpdecoroffsety,0,1f,1f,decorimage[i],0,false,1f,tmpdecorcat);	
			}
		}
		//end--------------//18sep2021
		if(layer==-1)//20oct2021 changed this around to be -1 to 0
		{
			//if(tileimage[i]!=-1 && wallimage[i]==-1)//20sep2021 for Space Squad only....
			if(tileimage[i]!=-1)
			{
				//26oct2020
				//RenderList.drawimage(game,Game.images[tilecat].texture,x-Game.CORNERX,heightmap[i] + y-Game.CORNERY,0,1f,1f,tileimage[i],0,false,1f,tilecat);	
				RenderList.drawimage(game,Game.images[tmptilecat].texture,offsetx + x-Game.CORNERX,heightmap[i] + y-Game.CORNERY,0,1f,1f,tileimage[i],0,false,1f,tmptilecat);
				
			}
		}
		if(layer==0)//20oct2021
		{
			if(rockimage[i]!=-1)
			{
				//26oct2020
				//RenderList.drawimage(game,Game.images[rockcat].texture,x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+Map.rockoffsety,0,1f,1f,rockimage[i],0,false,1f,rockcat);	
				RenderList.drawimage(game,Game.images[tmprockcat].texture,offsetx +  x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+tmprockoffsety,0,1f,1f,rockimage[i],0,false,1f,tmprockcat);	
			}
			//start-----------//15sep2021
			if(Game.shadowleft!=-1 && Game.shadowright!=-1 && Map.indoor>0)//24sep2021
			{
				if(wallimage[i]==-1)
				{
					if(i<wallimage.Length - MAXX)
					{
						if(wallimage[i + 1]!=-1)
						{
							RenderList.drawimage(game,Game.images[Game.shadowright].texture,offsetx +  x-Game.CORNERX+Game.shadowoffx,heightmap[i] + y-Game.CORNERY,0,1f,1f,0,0,false,1f,Game.shadowright);	
						}
					}
					if(i>0)
					{
						if(wallimage[i - 1]!=-1)
						{
							RenderList.drawimage(game,Game.images[Game.shadowleft].texture,offsetx + x-Game.CORNERX-Game.shadowoffx,heightmap[i] + y-Game.CORNERY,0,1f,1f,0,0,false,1f,Game.shadowleft);	
						}
					}
				}
			}
			//end----------//15sep2021
			if(firecell[i]>0)
			{
				Map.drawfires(game,offsetx + x-Game.CORNERX,heightmap[i] + y-Game.CORNERY,Map.GRIDW/2,Map.GRIDH/2);
				if(!Game.paused && !Game.demomode)
				{
					firecell[i]--;
					bool spread = false;
					if((Game.frame % 60)==0 && firecell[i]>0 && Game.demomode==false && firecell[i]<=Map.FIRETIME && Map.israining==false)
					{	
						for(int gxx=gx-1;gxx<=gx+1;gxx++)
						{
							for(int gyy=gy-1;gyy<=gy+1;gyy++)
							{
								if(gxx>=0 && gyy>=0 && gxx<MAXX && gyy<MAXY)
								{
									if(firecell[gxx + gyy * MAXX]<=0)
									{
										if(Functions.rand(0,100)<10)
										{
											Map.spreadfire(gxx * GRIDW,gyy * GRIDH,3 * firecell[i] / 4);
											spread = true;
											break;
										}
									}
								}
							}
							if(spread)
							{
								break;
							}
						}
					}
				}
			}
		}
		if(layer==1)
		{
			if(wallimage[i]!=-1)
			{
				//26oct2020
				//RenderList.drawimage(game,Game.images[wallcat].texture,x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+Map.walloffsety,0,1f,1f,wallimage[i],0,false,1f,wallcat);	
				RenderList.drawimage(game,Game.images[tmpwallcat].texture,offsetx + x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+tmpwalloffsety,0,1f,1f,wallimage[i],0,false,1f,tmpwallcat);	
			}
			if(treeimage[i]!=-1)
			{
				//26oct2020
				//RenderList.drawimage(game,Game.images[treecat].texture,x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+Map.treeoffsety,0,1f,1f,treeimage[i],0,false,1f,treecat);	
				RenderList.drawimage(game,Game.images[tmptreecat].texture,offsetx + x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+tmptreeoffsety,0,1f,1f,treeimage[i],0,false,1f,tmptreecat);	
			}
			//start------------------//15sep2021
			if(Game.shadowup!=-1 && Map.indoor>0)//24sep2021
			{
				if(wallimage[i]!=-1)
				{
					if(i<wallimage.Length - MAXX)
					{
						if(wallimage[i+MAXX]==-1)
						{
							//above us is a wall, below is ground.....
							RenderList.drawimage(game,Game.images[Game.shadowup].texture,offsetx + x-Game.CORNERX,heightmap[i] + y-Game.CORNERY+Game.shadowoffy,0,1f,1f,0,0,false,1f,Game.shadowup);	
						}
					}
				}
			}
			//end--------------------//15sep2021
		}
	}

///////////////////Method Definition///////////////
	public static void precalc(Game game)
	{
		return;
	}

///////////////////Method Definition///////////////
		public static void updatepos(ref Game game)
		{
			bool onscreen = false;
			Game.onscreen = false;
			//Stopwatch utimer = new Stopwatch();
			//utimer.Start();
			//long time = utimer.ElapsedMilliseconds;
			if(Config.RUNNINGSPEED<90)
			{
				precalc(game);
			}
			//time = Math.Abs(utimer.ElapsedMilliseconds - time);
			//if(time > Config.maxmapupdatepostime)
			//{
			//	Config.maxmapupdatepostime = time;
			//}
			//utimer.Reset();
			for(int i=0;i<Map.fog.Length;i++)
			{
				Map.fog[i] = true;
				if(Game.EDITOR)
				{
					Map.fog[i] = false;
					Map.fogalpha[i] = 0f;
				}
			}
			//for(int i=0;i<Game.units.Length;i++)//26mar2021
			for(int i=0;i<=Unit.MAXINDEX;i++)//26mar2021
			{
				if(Game.units[i].faction==Game.PLAYERFACTION && Game.units[i].hp>0)
				{
					if(Game.units[i].x>Game.CORNERX && Game.units[i].y>Game.CORNERY && Game.units[i].x<Game.CORNERX+Game.RESOLUTIONX && Game.units[i].y<Game.CORNERY+Game.RESOLUTIONY)
					{
						onscreen = true;
						Game.onscreen = true;
						//break;
					}
				}
				Map.fogclear(game,i);
			}
			if(Game.mlclick && !Game.demomode && !Game.EDITOR)
			{
				if(Game.frame < Game.mlclickframe + 15)
				{
					if(!onscreen)
					{
						//double clicked and nothing on screen.....
						int count = 0;
						int min = 0;
						int corx = 0;
						int cory = 0;
						for(int x=0;x<Map.MAXX*Map.GRIDW;x+=Game.RESOLUTIONX/4)
						{
							for(int y=0;y<Map.MAXY*Map.GRIDH;y+=Game.RESOLUTIONY/4)
							{
								count = 0;
								int sx = x / Map.GRIDW;
								int sy = y / Map.GRIDH;
								int fx = (x + Game.RESOLUTIONX) / Map.GRIDW;
								int fy = (y + Game.RESOLUTIONY) / Map.GRIDH;
								for(int xx=sx;xx<fx;xx++)
								{
									for(int yy=sy;yy<fy;yy++)
									{
										if(Map.cellunit(xx*Map.GRIDW,yy*Map.GRIDH)!=-1)
										{
											if(Game.units[Map.cellunit(xx*Map.GRIDW,yy*Map.GRIDH)].faction==Game.PLAYERFACTION)
											{
												count++;
												if(count>min)
												{
													min = count;
													corx = x;
													cory = y;
												}
											}
										}
									}
								}
							}
						}
						Game.CORNERX = corx;
						Game.CORNERY = cory;
					}
				}
				Game.mlclickframe = Game.frame;
			}
			//if(!Game.paused && !Game.demomode)//1mar2021
			if(!Game.paused && !Game.demomode && Game.LOCKCORNER==0)//1mar2021
			{
				//21apr2012 changed mx to rmx etc
				if(Game.rmx<Game.CORNEREDGEDIST)
				{
					Game.CORNERX-=(int)(Game.CORNERSPEED/Game.zoom);
				}
				if(Game.rmy<Game.CORNEREDGEDIST)
				{
					Game.CORNERY-=(int)(Game.CORNERSPEED/Game.zoom);
				}
				if(Game.rmx>Game.RESOLUTIONX-Game.CORNEREDGEDIST)
				{
					Game.CORNERX+=(int)(Game.CORNERSPEED/Game.zoom);
				}
				if(Game.rmy>Game.RESOLUTIONY-Game.CORNEREDGEDIST)
				{
					Game.CORNERY+=(int)(Game.CORNERSPEED/Game.zoom);
				}
			}
			if(Game.CORNERX<0)
			{
				Game.CORNERX = 0;
			}
			if(Game.CORNERY<0)
			{
				Game.CORNERY = 0;
			}
			if(Game.CORNERX > Map.MAXX*Map.GRIDW - Game.RESOLUTIONX)
			{
				Game.CORNERX = Map.MAXX*Map.GRIDW - Game.RESOLUTIONX;
			}
			if(Game.CORNERY > Map.MAXY*Map.GRIDH - Game.RESOLUTIONY)
			{
				Game.CORNERY = Map.MAXY*Map.GRIDH - Game.RESOLUTIONY;
			}
		}

///////////////////Method Definition///////////////
		public static bool dobonesexist(int x,int y)
		{
			//check if dead men's bones exist on the map to be raised as skeletons or other summoned creatures
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			int i = -1;
			if(gx>=0 && gy>=0 && gx<MAXX && gy<MAXY)
			{
				i = gx + gy * MAXX;
				for(int j=0;j<deadcell.Length;j++)
				{
					if(tileimage[i]==deadcell[j] && deadcell[j]!=-1)
					{
						return true;
					}
				}
			}
			return false;
		}

///////////////////Method Definition///////////////
		public static void removebones(int x, int y)
		{
			//remove bones is used when we summon creatures, so that they raise from the grave effectively...a resource of sorts
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			int i = -1;
			if(gx>=0 && gy>=0 && gx<MAXX && gy<MAXY)
			{
				i = gx + gy * MAXX;
				tileimage[i] = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void addbones(int x, int y)
		{
			//add bones to the ground when a unit dies
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			int i = -1;
			if(gx>=0 && gy>=0 && gx<MAXX && gy<MAXY)
			{
				i = gx + gy * MAXX;
				int count = 0;
				for(int j=0;j<deadcell.Length;j++)
				{
					if(deadcell[j]!=-1)
					{
						count++;
					}
				}
				if(count>0)
				{
					count = 1 + ((int)Functions.rand(0,1000) % count);
					for(int j=0;j<deadcell.Length;j++)
					{
						if(deadcell[j]!=-1)
						{
							count--;
							if(count<=0)
							{
								tileimage[i] = deadcell[j];
								return;
							}
						}
					}					
				}
			}
		}

///////////////////Method Definition///////////////
		public static bool removeunit(int id,int x,int y)
		{
			//remove a unit from the map array
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return false;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return false;
			}
			if(unitmap[i]!=id)
			{
				return false;
			}
			unitmap[i] = -1;
			return true;
		}

///////////////////Method Definition///////////////
		public static bool insertunit(int id,int x, int y)
		{
			//insert a unit into the map array
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return false;
			}
			int i = gx + gy * MAXX;
			if(i<0 || i>=unitmap.Length)
			{
				return false;
			}
			if(unitmap[i]!=-1)
			{
				return false;
			}
			unitmap[i] = id;
			return true;
		}
		//start-------------//7mar2021

///////////////////Method Definition///////////////
		public static bool removeflyer(int id,int x,int y,int flightlevel)//4may2021
		{
			//remove a unit from the map array
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return false;
			}
			if(flightlevel<0 || flightlevel>=FLIGHTLEVELS)
			{
				return false;
			}
			int i = (flightlevel * MAXX * MAXY) + (gy * MAXX) + (gx);//gx + gy * MAXX;
			if(i<0 || i>=flightmap.Length)
			{
				return false;
			}
			if(flightmap[i]!=id)
			{
				return false;
			}
			flightmap[i] = -1;
			return true;
		}

///////////////////Method Definition///////////////
		public static int insertflyer(int id,int x, int y)//4may2021
		{
			//insert a unit into the map array
			int flightlevel = -1;
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return -1;
			}
			for(int f=0;f<FLIGHTLEVELS;f++)
			{
				int i = gx + gy * MAXX + f * MAXX * MAXY;
				if(i<0 || i>=flightmap.Length)
				{
					return -1;
				}
				if(flightmap[i]!=-1)
				{
					continue;
				}
				flightmap[i] = id;
				flightlevel = f;
				break;
			}
			return flightlevel;
		}
		
///////////////////Method Definition///////////////
		public static int cellflyer(int x,int y,int flightlevel)//4may2021
		{
			//indicate the unit id at the xy position in question
			//return -1 if no unit there
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return -1;
			}
			if(flightlevel<0 || flightlevel>=FLIGHTLEVELS)
			{
				return -1;
			}
			int i = gx + gy * MAXX + flightlevel * MAXX * MAXY;
			if(i<0)
			{
				return -1;
			}
			if(i>=flightmap.Length)
			{
				return -1;
			}
			return flightmap[i];
		}
		
		
///////////////////Method Definition///////////////
		public static int countfactionneighbours(Game game,int x,int y,int faction)
		{
			//return the number of units of a specific faction adjacent to this grid cell
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			int count = 0;
			if(gx<0 || gy<0)
			{
				return -1;
			}
			int i = gx + gy * MAXX;
			if(i<0)
			{
				return -1;
			}
			if(i>=unitmap.Length)
			{
				return -1;
			}
			for(int gxx=gx-1;gxx<=gx+1;gxx++)
			{
				for(int gyy=gy-1;gyy<=gy+1;gyy++)
				{
					int nid = cellunit(gxx * GRIDW,gyy * GRIDH);
					if(nid!=-1)
					{
						if(Game.units[nid].faction==faction)
						{
							count++;
						}
					}
				}
			}
			return count;
		}
		//end---------------//7mar2021

///////////////////Method Definition///////////////
		public static int cellunit(int x, int y)
		{
			//indicate the unit id at the xy position in question
			//return -1 if no unit there
			int gx = x / GRIDW;
			int gy = y / GRIDH;
			if(gx<0 || gy<0)
			{
				return -1;
			}
			int i = gx + gy * MAXX;
			if(i<0)
			{
				return -1;
			}
			if(i>=unitmap.Length)
			{
				return -1;
			}
			return unitmap[i];
		}

///////////////////Method Definition///////////////
		public static void resetpathmap()
		{
			//not used
			//for(int i=0;i<pathmap.Length;i++)
			//{
			//	pathmap[i] = Map.PATHINIT;
			//}
			//pathmap = new int[MAXX*MAXY];
			Array.Clear(pathmap,0,pathmap.Length);
		}
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
//18oct2021 added Spells
class Spells 
{
	public static void SpellAction(int player,int baseindex)
	{
		int index = baseindex;
		int j = 0;
		if(index<0)
		{
			index+=3;
		}
		switch(player)
		{
			case 0: //Red Elf
				switch(index)
				{
					case 0:
						//weather off
						//iconindex = 0;
						Map.raining = 0;
						Map.overriderain = true;
					break;
					case 1:
						//archers
						//iconindex = 1;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Red")>=0)
							{
								if(Game.units[i].firebullet>0)
								{
									//increase their bowfire damage by 2 points.....
									Game.units[i].damage+=2;
								}
							}
						}
					break;
					case 2:
						//spearmen
						//iconindex = 2;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Red")>=0)
							{
								if(Game.units[i].name.IndexOf("Spear")>=0)
								{
									Game.units[i].damage+=2;
									Game.units[i].damage2+=2;
								}
							}
						}
					break;
				}
			break;
			case 1: //Blue Elf
				switch(index)
				{
					case 0:
						//weather on
						//iconindex = 3;
						Map.raining = -3;
						Map.overriderain = true;
					break;
					case 1:
						//archers
						//iconindex = 4;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Blue")>=0)
							{
								if(Game.units[i].firebullet>0)
								{
									//increase their bowfire damage by 2 points.....
									Game.units[i].damage+=2;
								}
							}
						}
					break;
					case 2:
						//spearmen
						//iconindex = 5;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Blue")>=0)
							{
								if(Game.units[i].name.IndexOf("Spear")>=0)
								{
									Game.units[i].damage+=2;
									Game.units[i].damage2+=2;
								}
							}
						}
					break;
				}
			break;
			case 2: //Undead
				switch(index)
				{
					case 0:
						//sacrifice health, boost strength
						//iconindex = 6;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Skeleton")>=0)
							{
								Game.units[i].basehp *= 7;
								Game.units[i].basehp /= 10;
								Game.units[i].damage+=3;
								if(Game.units[i].walkspeed<3)
								{
									Game.units[i].walkspeed++;
								}
								Game.units[i].spellwalkspeed = Game.units[i].walkspeed;
							}
								
						}
					break;
					case 1:
						//sacrifice strength, boost health
						//iconindex = 7;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Skeleton")>=0)
							{
								Game.units[i].basehp *= 12;
								Game.units[i].basehp /= 10;
								Game.units[i].damage-=1;
							}
								
						}
					break;
					case 2:
						//terrify the enemy
						//iconindex = 8;
						j = 0;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Skeleton")<0)
							{
								j++;
								if(j % 3==0)
								{
									Game.units[i].brave = 0;
									Game.units[i].mob = 0;
									Game.units[i].leader = 0;
									Game.units[i].timid = 1;
								}
							}
						}
					break;
				}
			break;
			case 3: //Knights
				switch(index)
					{
						case 0:
							//seek blessing
							//iconindex = 9;
							j = 0;
							for(int i=0;i<Game.units.Length;i++)
							{
								if(Game.units[i].name.IndexOf("Realm")>=0)
								{
									j++;
									j%=10;
									switch(j)
									{
										case 0:
										Game.units[i].damage+=2;
										break;
										case 1:
										Game.units[i].leader = 1;
										break;
										case 2:
										Game.units[i].armour+=1;
										break;
										case 3:
										Game.units[i].craftsman=1;
										break;
										case 4:
										Game.units[i].regeneration = 3;
										break;
									}
								}	
							}
						break;
						case 1:
							//banish undead
							//iconindex = 10;
							j = 0;
							for(int i=0;i<Game.units.Length;i++)
							{
								if(Game.units[i].name.IndexOf("Skeleton")>=0)
								{
									j++;
									if(j % 6==0)
									{
										Game.units[i].hp = 0;
										Game.killed(null,i);
									}
								}
							}
						break;
						case 2:
							//banish mutants
							//iconindex = 11;
							j = 0;
							for(int i=0;i<Game.units.Length;i++)
							{
								if(Game.units[i].name.IndexOf("Fiend")>=0)
								{
									j++;
									if(j % 6==0)
									{
										Game.units[i].hp = 0;
										Game.killed(null,i);
									}
								}
							}
						break;
					}
			break;
			case 4: //Dark Elf
				switch(index)
				{
					case 0:
						//sacrifice goblins, increase strength
							j = 0;
							for(int i=0;i<Game.units.Length;i++)
							{
								if(Game.units[i].name.IndexOf("Goblin")>=0)
								{
									Game.units[i].hp = 0;
									Game.killed(null,i);
									j++;
								}
							}
							if(j>0)
							{
								for(int i=0;i<Game.units.Length;i++)
								{
									if(Game.units[i].name.IndexOf("Evil")>=0)
									{
										j--;
										if(j<=0)
										{
											break;
										}
										//otherwise....
										Game.units[i].damage+=2;
										Game.units[i].frenzy+=4;
										Game.units[i].highfirerate=2;
									}
								}	
								
							}
						//iconindex = 12;
					break;
					case 1:
						//sacrifice goblins, terrify enemy
						//iconindex = 13;
							j = 0;
							for(int i=0;i<Game.units.Length;i++)
							{
								if(Game.units[i].name.IndexOf("Goblin")>=0)
								{
									Game.units[i].hp = 0;
									Game.killed(null,i);
									j++;
								}
							}
							if(j>0)
							{
								for(int i=0;i<Game.units.Length;i++)
								{
									j--;
									if(j<=0)
									{
										break;
									}
									if(Game.units[i].name.IndexOf("Evil")<0)
									{
										Game.units[i].brave = 0;
										Game.units[i].mob = 0;
										Game.units[i].leader = 0;
										Game.units[i].timid = 1;
									}
								}
							}
							
					break;
					case 2:
						//drink spider blood, become berserk
						//iconindex = 14;
							j = 0;
							for(int i=0;i<Game.units.Length;i++)
							{
								if(Game.units[i].name.IndexOf("Spider")>=0)
								{
									j++;
								}
							}
							if(j>0)
							{
								for(int i=0;i<Game.units.Length;i++)
								{
									j--;
									if(j<=0)
									{
										break;
									}
									if(Game.units[i].name.IndexOf("Evil")>=0 && Game.units[i].name.IndexOf("Spider")<0)
									{
										Game.units[i].frenzy+=4;
									}
								}
							}
					break;
				}
			break;
			case 5: //Mutants
			switch(index)
				{
					case 0://19oct2021 replaced this....
						j = 0;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Fiend")<0 && Game.units[i].hp>0)
							{
								j++;
								if(j % 10==0)
								{
									Unit.LightningDeath(Game.units[i].x,Game.units[i].y,1);
								}
								if(Map.israining)
								{
									if(j % 10 == 5)
									{
										Unit.LightningDeath(Game.units[i].x,Game.units[i].y,1);
									}
								}
							}
						}
					break;
					case 1:
						//dark power
						//iconindex = 16;
						j = 0;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Fiend")>=0)
							{
								j++;
								switch(j%10)
								{
									case 0:
										Game.units[i].damage+=2;
									break;
									case 1:
										Game.units[i].armour+=2;
									break;
									case 2:
										Game.units[i].leader = 1;
									break;
									case 3:
										Game.units[i].frenzy+=3;
									break;
								}
							}
						}

					break;
					case 2:
						//melt armour
						//iconindex = 17;
						j = 0;
						for(int i=0;i<Game.units.Length;i++)
						{
							if(Game.units[i].name.IndexOf("Fiend")<0)
							{
								j++;
								switch(j%10)
								{
									case 0:
										Game.units[i].armour = 0;
									break;
									case 1:
										Game.units[i].armour = 4;
									break;
									case 2:
										Game.units[i].armour = 2;
									break;
									case 3:
										if(Game.units[i].armour>7)
										{
											Game.units[i].armour = 7;
										}
									break;
								}
							}
						}
					break;
				}
			break;
		}
		if(baseindex>=0) //otherwise this was a command from the network.....
		{
			if(NetworkUDP.Ready())
			{
				int[] args = new int[1];
				args[0] = index;
				NetworkUDP.communicate(NetworkUDP.SPELL,args);
			}
		}
		
	}

	public static int SpellPortrait(int player)
	{
		int index = 0;
		switch(player)
		{
			case 0://red
			index = 5; // Red Elves
			break;
			case 1://blue
			index = 7;// Blue Elves
			break;
			case 2://green
			index = 6; // Undead
			break;
			case 3://yellow
			index = 8; // Knights
			break;
			case 4://purple
			index = 11; // Dark Elves
			break;
			case 5://orange
			index = 16;// Mutants
			break;
		}
		return index;
	}
	
	public static int SpellIcon(int player,int index)
	{
		int iconindex = 0;
		switch(player)
		{
			case 0: //Red Elf
				switch(index)
				{
					case 0:
						//weather off
						iconindex = 8;
					break;
					case 1:
						//archers
						iconindex = 3;
					break;
					case 2:
						//spearmen
						iconindex = 10;
					break;
				}
			break;
			case 1: //Blue Elf
				switch(index)
				{
					case 0:
						//weather on
						iconindex = 8;
					break;
					case 1:
						//archers
						iconindex = 3;
					break;
					case 2:
						//spearmen
						iconindex = 10;
					break;
				}
			break;
			case 2: //Undead
				switch(index)
				{
					case 0:
						//sacrifice health, boost strength
						iconindex = 0;
					break;
					case 1:
						//sacrifice strength, boost health
						iconindex = 6;
					break;
					case 2:
						//terrify the enemy
						iconindex = 4;
					break;
				}
			break;
			case 3: //Knights
				switch(index)
					{
						case 0:
							//seek blessing
							iconindex = 3;
						break;
						case 1:
							//banish undead
							iconindex = 7;
						break;
						case 2:
							//banish mutants
							iconindex = 11;
						break;
					}
			break;
			case 4: //Dark Elf
				switch(index)
				{
					case 0:
						//sacrifice goblins, increase strength
						iconindex = 12;
					break;
					case 1:
						//sacrifice goblins, terrify enemy
						iconindex = 9;
					break;
					case 2:
						//drink spider blood, become berserk
						iconindex = 4;
					break;
				}
			break;
			case 5: //Mutants
			switch(index)
				{
					case 0:
						//summon greater demon
						iconindex = 4;
					break;
					case 1:
						//dark power
						iconindex = 14;
					break;
					case 2:
						//melt armour
						iconindex = 2;
					break;
				}
			break;
			
		}
		return iconindex;
	}
	
	public static string SpellText(int player,int index)
	{
		string desc = "";
		switch(player)
		{
			case 0:
				switch(index)
				{
					case 0:// Red Elf Spell 1
						desc = "Cause the Rain to Cease (if any)";
					break;
					case 1:// Red Elf Spell 2
						desc = "Improve Our Archer's Accuracy.";
					break;
					case 2:// Red Elf Spell 3
						desc = "Improve Our Spearmen's Effectiveness";
					break;
				}
			break;
			case 1:
			switch(index)
				{
					case 0:// Blue Elf Spell 1
						desc = "Cause the Rain to Start";
					break;
					case 1:// Blue Elf Spell 2
						desc = "Improve Our Archer's Accuracy";
					break;
					case 2:// Blue Elf Spell 3
						desc = "Improve Our Spearmen's Effectiveness";
					break;
				}
			break;
			case 2:
			switch(index)
				{
					case 0:// Undead Spell 1
						desc = "Boost Skeletal Strength and Speed, But Sacrifice Health";
					break;
					case 1:// Undead Spell 2
						desc = "Increase Skeletal Health, But Reduce Strength";
					break;
					case 2:// Undead Spell 3
						desc = "Attempt To Terrify the Enemy";
					break;
				}
			break;
			case 3:
			switch(index)
				{
					case 0:// Knights Spell 1
						desc = "Seek Blessings From The Gods";
					break;
					case 1:// Knights Spell 2
						desc = "Attempt To Banish Unliving (if any)";
					break;
					case 2:// Knights Spell 3
						desc = "Attempt To Banish Mutants(if any)";
					break;
				}
			break;
			case 4:
			switch(index)
				{
					case 0:// Dark Elf Spell 1
						desc = "Sacrifice Goblins and Receive Dark Blessings";
					break;
					case 1:// Dark Elf Spell 2
						desc = "Sacrifice Goblins and Instill Fear In The Enemy";
					break;
					case 2:// Dark Elf Spell 3
						desc = "Drink Spider Blood and Become Berserk";
					break;
				}
			break;
			case 5:
			switch(index)
				{
					case 0:// Mutants Spell 1
						desc = "Summon Lightning Storm";
					break;
					case 1:// Mutants Spell 2
						desc = "Attempt To Gain Dark Power";
					break;
					case 2:// Mutants Spell 3
						desc = "Attempt To Melt Enemy Armour";
					break;
				}
			break;
		}
		return desc;
	}
}	
	
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
class Gui
{
	
	public static int modal = 0;//21oct2021
	public static int TYPE_BUTTON = 1;
	public static int TYPE_PANEL = 2;
	public static int TYPE_LABEL = 3;
	public static int TYPE_IMAGE = 4;
	public static int TYPE_CODED = 5;
	public static int TYPE_MINIMAP = 6;
	public static int TYPE_CLOTHING = 9;
	
	public static bool ACTIVATED_CHARSHEET = false;
	public static bool ACTIVATED_FOUND = false;

	public static int IMG_ARMYICON = -1;
	public static int firstunit = 0;

	public static int province;//16oct2021
	
	public static string statustext = "";//16oct2021
	public static int statusx = 0;//16oct2021
	public static int statusy = Game.RESOLUTIONY - 50;//16oct2021
	
	public int type;
	public int missionindex;
	public string missionname;
	public int topindexzero; //24Feb2021
	public int gamestate;
	//public static string currentscreen;
	public string screenname;
	public int id;
	public int tmpimage;//30apr2021
	public int image;
	public int[] altimage;
	public int altimageindex;//11apr2021
	public string imagefile;
	public String[] altimagefile;
	public float scale;
	public int x;
	public int y;
	public int w;
	public int h;
	public bool mouseover;
	public int font;
	public int fontsize;
	public string fontfile;
	public string title;
	public string tooltip;
	//public string ID;
	//for buttons
	public string nextscreenname;
	public int nextgamestate;
	public int horizontal;//11mar2021
	public int vertical;//11mar2021
	/////////////////////////////////
	//Game Actions
	//
	public static int BACK = -1;
	public static int ACTION_ARMYINFO = 80200;//19oct2021
	public static int ACTION_ENEMYINFO = 80300;//19oct2021
	public static int ACTION_NONE = -2;//23sep2021
	public static int ACTION_CHOOSEHUMAN = 1;
	public static int ACTION_CHOOSEUNDEAD = 2;
	public static int ACTION_CHOOSENEWMAP = 4;
	public static int ACTION_NEWGAME = 5;
	public static int ACTION_LARGEMINIMAP = 6;
	public static int ACTION_MINIMAPSCANLINE = 7;//16sep2021
	public static int ACTION_MISSION = 10;
	public static int ACTION_EDITOR = 123;
	public static int ACTION_EXTERNAL = 124;
	public static int ACTION_PLAY = 20;//26mar2021
	public string command;
	public static int LINK_SELECTION_TEXT = 4;
	public static int LINK_BATTLESPELL = -2005;//18oct2021
	public static int LINK_UNIT_DETAIL = 88;
	public static int LINK_UNIT_DETAIL2 = -10011;//26sep2021
	public static int LINK_PLAYER_ICONS = 3001; //9mar2021
	public static int LINK_ENEMY_ICONS = 3002; //9mar2021
	public static int LINK_SPAWNER_ICON = 3003; //10mar2021
	public static int LINK_SELECTED_ICONS = 3004;//22mar2021
	public static int LINK_TECH_ICON = 3005;//2sep2021
	//start---------------//28mar2021
	public static int ACTION_SPELL_ICONS = 3010;
	public static int ACTION_SPELL_START = 3010;
	public static int ACTION_SPELL_END = 3026;
	public bool spellactive;//12apr2021
	//end-----------------//28mar2021
	public static int ACTION_NEXT = 89;
	public static int ACTION_PREV = 87;
	public static int ACTION_CONTINUE = 1234;
	//start-------------//9mar2021
	public static int ACTION_FORMATIONSTART = 2001;
	public static int ACTION_LINEH = 2001;
	public static int ACTION_LINEV = 2002;
	public static int ACTION_OPEN = 2003;
	public static int ACTION_CLOSE = 2004;
	public static int ACTION_RALLY = 2005;
	public static int ACTION_DEFEND = 2006;
	public static int ACTION_ENGAGE = 2007;
	public static int ACTION_FORMATIONEND = 2007;
	//end---------------//9mar2021
	public static int ACTION_LANGUAGESET = 5050; //13mar2021
	public static int ACTION_REPLAY = 7777;//2apr2021
	//start------------//18oct2021
	public static int ACTION_SPELL_PORTRAIT = 80015;
	public static int ACTION_SPELL_ONE = 80011;
	public static int ACTION_SPELL_TWO = 80012;
	public static int ACTION_SPELL_THREE = 80013;
	//end--------------//18oct2021
	public int action;
	public int mission;
	public static int GUILINK_VICTORY = 2;
	public static int GUILINK_DEFEAT = 3;
	public int triggerlink;
	public string link;
	public int index;
	public int leftjustify;//16oct2021
	public int[] factionindex; //16oct2021
	public int hidden;
	public int uindex;
	public bool backgroundrect;
	public int[] backgroundrectcoords;
	public int[] backgroundrectcolor;
	public static bool ALTMODE = false;
	public static int checksum = 0;
	public static int ochecksum = -1;
	//25sep2021
	//for shop
	public int goldcost;
	public int sold;
	public string[] saledesc;
	public int saletype;
	//////////////SALE STUFF
	public static int SALETYPE_DAMAGE = 1;
	public static int SALETYPE_ARMOUR = 2;
	public static int SALETYPE_HEALTH = 3;
	public static int SALETYPE_MANA = 4;
	public static int SALETYPE_FRENZY = 5;
	public static int SALETYPE_SHOCK = 6;
	public static int SALETYPE_FEARSOME = 7;
	public static int SALETYPE_REGENERATION = 8;
	public static int SALETYPE_FASTFIRE = 9;
	public static int SALETYPE_CRAFTSMAN = 10;
	public static int SALETYPE_STEALTH = 11;
	public static int SALETYPE_DAMAGEX = 12;
	

	public static void ToggleOff(int trig)//18oct2021
	{
		for(int tog=0;tog<Game.gui.Length;tog++)
		{
			if(Game.gui[tog].triggerlink!=trig)
			{
				continue;
			}
			if(Game.gui[tog].link==("toggleon") || Game.gui[tog].link==("toggleoff"))
			{
				if(Game.gui[tog].link==("toggleon"))
				{
					Game.gui[tog].link="toggleoff";
					Gui.modal = 0;//21oct2021
				}
				else
				{
					Game.gui[tog].link="toggleon";
					Gui.modal = Game.gui[tog].triggerlink;//21oct2021
				}
			}
		}
	}
		
///////////////////Method Definition///////////////
	public static void fillpopup(int i)//16oct2021
	{
		//start--------//18oct2021
		int j = 0;
		if(Game.gamestate==Game.CAT_GAMESTATE_GAME)
		{
			if(Game.gui[i].triggerlink==LINK_BATTLESPELL)
			{
				//battle spells.....
				if(Game.gui[i].action==ACTION_SPELL_PORTRAIT)
				{
					//change the portrait to the relevant one...
					Game.gui[i].index = Spells.SpellPortrait(Game.LocalPlayerIndex);
				}
				if(Game.gui[i].action==ACTION_SPELL_ONE)
				{
					if(Game.gui[i].title.IndexOf("{Spell Text 1}")>=0)
					{
						Game.gui[i].title = Game.gui[i].title.Replace("{Spell Text 1}",Spells.SpellText(Game.LocalPlayerIndex,0));
					}
					if(Game.gui[i].title.IndexOf("{ImageIndex}")>=0)
					{
						Game.gui[i].title = Game.gui[i].title.Replace("{ImageIndex}","");
						Game.gui[i].index = Spells.SpellIcon(Game.LocalPlayerIndex,0);
					}
				}
				if(Game.gui[i].action==ACTION_SPELL_TWO)
				{
					if(Game.gui[i].title.IndexOf("{Spell Text 2}")>=0)
					{
						Game.gui[i].title = Game.gui[i].title.Replace("{Spell Text 2}",Spells.SpellText(Game.LocalPlayerIndex,1));
						Game.gui[i].index = Spells.SpellIcon(Game.LocalPlayerIndex,1);
					}
					if(Game.gui[i].title.IndexOf("{ImageIndex}")>=0)
					{
						Game.gui[i].title = Game.gui[i].title.Replace("{ImageIndex}","");
						Game.gui[i].index = Spells.SpellIcon(Game.LocalPlayerIndex,1);
					}
				}
				if(Game.gui[i].action==ACTION_SPELL_THREE)
				{
					if(Game.gui[i].title.IndexOf("{Spell Text 3}")>=0)
					{
						Game.gui[i].title = Game.gui[i].title.Replace("{Spell Text 3}",Spells.SpellText(Game.LocalPlayerIndex,2));
						Game.gui[i].index = Spells.SpellIcon(Game.LocalPlayerIndex,2);
					}
					if(Game.gui[i].title.IndexOf("{ImageIndex}")>=0)
					{
						Game.gui[i].title = Game.gui[i].title.Replace("{ImageIndex}","");
						Game.gui[i].index = Spells.SpellIcon(Game.LocalPlayerIndex,2);
					}
				}
			}
		}
		//start-----------//21oct2021
		if(Game.gui[i].action>=Research.GUIPATH0 && Game.gui[i].action<=Research.GUIPATH2)
		{
			//we are in the campaign and we've hit a toggleoff panel popup
			//that has three buttons with these action values.....
			Game.gui[i].hidden = 0;
			int[] researchavail = Research.ListResearchIndexes(Game.PlayerIndex);
			int ii = Game.gui[i].action - Research.GUIPATH0;
			if(ii>=0 && ii<=2)
			{
				if(researchavail[ii]!=-1)
				{
					if(Research.iconindex[researchavail[ii]]!=-1)
					{
						Game.gui[i].index = Research.iconindex[researchavail[ii]];
					}
				}
				
			}	
			if(researchavail[0] == -1)
			{
				if(Game.gui[i].action==Research.GUIPATH0)
				{
					Game.gui[i].hidden = 1;
					Game.gui[i].title = "";
					Game.gui[i].index = -1;
				}
			}
			else
			{
				if(Game.gui[i].title.IndexOf(Research.GUIPOPUPTEXT)>=0 && Game.gui[i].action==Research.GUIPATH0)
				{
					Game.gui[i].title = Game.gui[i].title.Replace(Research.GUIPOPUPTEXT,Research.text[researchavail[0]]);
					Game.gui[i].title += "#" + "Time To Research:" + Research.turnsleft[researchavail[0]];
					if(Research.researching[researchavail[0]]>0)
					{
						Game.gui[i].title += "#" + "(Currently Researching)";
					}
					if(researchavail[3]>=0)
					{
						Game.gui[i].title += "#" + "Last Researched:" + Research.text[researchavail[3]].Split("#")[0];
					}
				}
			}
			if(researchavail[1] == -1)
			{
				if(Game.gui[i].action==Research.GUIPATH1)
				{
					Game.gui[i].hidden = 1;
					Game.gui[i].title = "";
					Game.gui[i].index = -1;
				}
			}
			else
			{
				if(Game.gui[i].title.IndexOf(Research.GUIPOPUPTEXT)>=0 && Game.gui[i].action==Research.GUIPATH1)
				{
					Game.gui[i].title = Game.gui[i].title.Replace(Research.GUIPOPUPTEXT,Research.text[researchavail[1]]);
					Game.gui[i].title += "#" + "Time To Research:" + Research.turnsleft[researchavail[1]];
					if(Research.researching[researchavail[1]]>0)
					{
						Game.gui[i].title += "#" + "(Currently Researching)";
					}
					if(researchavail[4]>=0)
					{
						Game.gui[i].title += "#" + "Last Researched:" + Research.text[researchavail[4]].Split("#")[0];;
					}
				}
			}
			if(researchavail[2] == -1)
			{
				if(Game.gui[i].action==Research.GUIPATH2)
				{
					Game.gui[i].hidden = 1;
					Game.gui[i].title = "";
					Game.gui[i].index = -1;
				}
			}
			else
			{
				if(Game.gui[i].title.IndexOf(Research.GUIPOPUPTEXT)>=0 && Game.gui[i].action==Research.GUIPATH2)
				{
					Game.gui[i].title = Game.gui[i].title.Replace(Research.GUIPOPUPTEXT,Research.text[researchavail[2]]);
					Game.gui[i].title += "#" + "Time To Research:" + Research.turnsleft[researchavail[2]];
					if(Research.researching[researchavail[2]]>0)
					{
						Game.gui[i].title += "#" + "(Currently Researching)";
					}
					if(researchavail[5]>=0)
					{
						Game.gui[i].title += "#" + "Last Researched:" + Research.text[researchavail[5]].Split("#")[0];;
					}
				}
			}
			
		}
		//end-------------//21oct2021
		//start-----------//19oct2021
		if(Game.gui[i].action>=ACTION_ARMYINFO && Game.gui[i].action<ACTION_ARMYINFO + 6)
		{
			int row = Game.FriendIndex;
			//row = 0 to 5
			//action - ACTION_ARMYINFO = 0-5
			Game.gui[i].index = (row * 6) + Game.gui[i].action - ACTION_ARMYINFO;
			if(Game.gui[i].title.IndexOf("{Friend Text}")>=0)
			{
				j = -1;
				for(int tid=0;tid<Game.templates.Length;tid++)
				{
					if(Game.templates[tid].name.IndexOf(Game.FriendArmy)>=0)
					{
						j++;
						if(j==Game.gui[i].action - ACTION_ARMYINFO)
						{
							Game.gui[i].title = "";
							for(int d=0;d<Game.templates[tid].description.Length;d++)
							{
								Game.gui[i].title+=Game.templates[tid].description[d] + "#";
							}
							break;
						}					
						
					}
				}
			}			
		}
		if(Game.gui[i].action>=ACTION_ENEMYINFO && Game.gui[i].action<ACTION_ENEMYINFO + 6)
		{
			int row = Game.EnemyIndex;
			//row = 0 to 5
			//action - ACTION_ARMYINFO = 0-5
			Game.gui[i].index = (row * 6) + Game.gui[i].action - ACTION_ENEMYINFO;
			if(Game.gui[i].title.IndexOf("{Enemy Text}")>=0)
			{
				j = -1;
				for(int tid=0;tid<Game.templates.Length;tid++)
				{
					if(Game.templates[tid].name.IndexOf(Game.EnemyArmy)>=0)
					{
						j++;
						if(j==Game.gui[i].action - ACTION_ENEMYINFO)
						{
							Game.gui[i].title = "";
							for(int d=0;d<Game.templates[tid].description.Length;d++)
							{
								Game.gui[i].title+=Game.templates[tid].description[d] + "#";
							}
							break;
						}					
						
					}
				}
			}
		}
		//end-----------//19oct2021
		
		//end---------//18oct2021
		//if(Gui.province>=0 && Gui.province<CampaignMap.maxprovince)//18oct2021
		if(Gui.province>=0 && Gui.province<CampaignMap.maxprovince && Game.gamestate==Game.CAMPAIGNSTATE)//18oct2021
		{
			/*
			{ProvinceArea}
			{ProvincePopulation}
			{ArmyStrength}
			{Weather}
			{Terrain}
			popup (mouseover province) *special
			{OwnerImage}
			*/
			int value = 0;
			if(Game.gui[i].title.IndexOf("{ProvinceArea}")>=0)
			{
				for(int x=0;x<CampaignMap.maxx;x++)
				{
					for(int y=0;y<CampaignMap.maxy;y++)
					{
						if(CampaignMap.provincedata[x + y * CampaignMap.maxx]==Gui.province)
						{
							value++;
						}
					}
				}
				Game.gui[i].title = Game.gui[i].title.Replace("{ProvinceArea}",""+value+" sq. units");
			}					
			if(Game.gui[i].title.IndexOf("{ProvincePopulation}")>=0)
			{
				for(int x=0;x<CampaignMap.maxx;x++)
				{
					for(int y=0;y<CampaignMap.maxy;y++)
					{
						if(CampaignMap.provincedata[x + y * CampaignMap.maxx]==Gui.province)
						{
							value += (CampaignMap.provincearmystrength[Gui.province] +  100 * (1 + (CampaignMap.provincearmy[Gui.province] - (CampaignMap.provincearmy[Gui.province] % 6))/6));
						}
					}
				}	
				Game.gui[i].title = Game.gui[i].title.Replace("{ProvincePopulation}",""+value);
			}					
			if(Game.gui[i].title.IndexOf("{ArmyStrength}")>=0)
			{
				value = (CampaignMap.provincearmystrength[Gui.province] +  100 * (1 + (CampaignMap.provincearmy[Gui.province] - (CampaignMap.provincearmy[Gui.province] % 6))/6));
				if(CampaignMap.GetArmy(Gui.province)<=0 || CampaignMap.GetArmy(Gui.province)>=18)
				{
					value = 75;
				}
				Game.gui[i].title = Game.gui[i].title.Replace("{ArmyStrength}",""+value);
			}					
			if(Game.gui[i].title.IndexOf("{Weather}")>=0)
			{
				string valuestr = "Temperate";
				if(CampaignMap.provinceweather[Gui.province]==Map.WEATHERHOT)
				{
					valuestr = "Very Hot and Dry";
				}
				if(CampaignMap.provinceweather[Gui.province]==Map.WEATHERCOLD)
				{
					valuestr = "Icy Cold and Wet";
				}
				Game.gui[i].title = Game.gui[i].title.Replace("{Weather}",""+valuestr);
			}					
			if(Game.gui[i].title.IndexOf("{Terrain}")>=0)
			{
				string valuestr = "Grassy Plains";
				if(CampaignMap.provinceterrain[Gui.province]==CampaignMap.FOREST)
				{
					valuestr = "Woodlands";
				}
				if(CampaignMap.provinceterrain[Gui.province]==CampaignMap.MOUNTAINS)
				{
					valuestr = "Crags and Mountains";
				}
				if(CampaignMap.provinceterrain[Gui.province]==CampaignMap.FORESTMOUNTAINS)
				{
					valuestr = "Wooded Hills and Mountains";
				}
				//if(CampaignMap.provinceterrain[Gui.province]==CampaignMap.URBAN)
				//{
					
				//}
				Game.gui[i].title = Game.gui[i].title.Replace("{Terrain}",""+valuestr);
			}
			if(Game.gui[i].title.IndexOf("{OwnerImage}")>=0)
			{
				string valuestr = "";
				switch(CampaignMap.provinceowner[Gui.province])
				{
					case 0://Red
					valuestr = "Sun Elves";
					break;
					case 1://Blue
					valuestr = "Moon Elves";
					break;
					case 2://Green
					valuestr = "Unliving";
					break;
					case 3://Yellow
					valuestr = "Feudal Humans";
					break;
					case 4://Purple
					valuestr = "Dark Elves";
					break;
					case 5://Orange
					valuestr = "Mutants";
					break;
				}
				Game.gui[i].title = Game.gui[i].title.Replace("{OwnerImage}",""+valuestr);
			}					
		}
	}

///////////////////Method Definition///////////////
	public Gui(Game game)
	{
		province = -1;
		factionindex = new int[Game.MaxArmies];//16oct2021
		goldcost = 0;//25sep2021
		sold = 0;
		saletype = 0;
		saledesc = new String[3];
		saledesc[0] = "";
		saledesc[1] = "";
		saledesc[2] = "";
		link = "";
		command = "";
		hidden = 0;
		triggerlink = 0;
		missionname = "";
		backgroundrect = false;
		backgroundrectcoords = new int[4];
		backgroundrectcolor = new int[3];
		missionindex = -1;
		topindexzero = 0;//24Feb2021
		horizontal = 6;//11mar2021
		vertical = 0;//11mar2021
		imagefile = "";
		screenname = "";
		fontfile = "";
		link = "";
		nextscreenname = "";
		tooltip = "";
		title = "";
		command = "";
				
	}

///////////////////Method Definition///////////////
	public void reset(Game game,int i)
	{
		command = "";
		id = i;
		sold = 0;
		goldcost = 0;
		saletype = 0;
		saledesc = new String[3];
		saledesc[0] = "";
		saledesc[1] = "";
		saledesc[2] = "";
		horizontal = 6;//11mar2021
		vertical = 0;//11mar2021
		mouseover = false;
		image = -1;
		tmpimage = -1;//30apr2021
		//altimage = -1;
		font = Resources.FONT;
		scale = 1f;
		altimage = new int[5];
		altimagefile = new String[5];
		altimageindex = -1;
		for(int k=0;k<5;k++)
		{
			altimage[k] = -1;
			altimagefile[k] = "";
		}
		imagefile = "";
	}

///////////////////Method Definition///////////////
	public static void matchcampaign(Game game) //28Feb2021
	{
		//if a mission is specified by name in the gui, then match it to an index number
		if(Game.gui==null || Game.missions==null)
		{
			return;
		}
		for(int i=0;i<Game.gui.Length;i++)
		{
			if(Game.gui==null)
			{
				////Log.w(Config.TAG,"Gui Array: is null");
				continue;
			}
			
			if(Game.gui[i]==null)
			{
				////Log.w(Config.TAG,"Gui i:"+i+" is null");
				continue;
			}
			if(Game.gui[i].missionname==null)
			{
				////Log.w(Config.TAG,"Gui Index:"+i+" has a null mission name");
				continue;
			}
			if(Game.gui[i].missionname!=(""))
			{
				for(int j=0;j<Game.missions.Length;j++)
				{
					if(Game.missions[j].name==(Game.gui[i].missionname))
					{
						Game.gui[i].missionindex = j;
						Game.gui[i].topindexzero = 1;
						break;
					}
				}
				if(Game.gui[i].missionindex>-1)
				{
					break;
				}
			}
		}
	}
///////////////////Method Definition///////////////
	public static void updatealtimages(Game game)//30apr2021
	{
		for(int i=0;i<Game.gui.Length;i++)
		{
			if(Game.gui[i].gamestate==Game.gamestate)
			{
				if(Game.gui[i].tmpimage!=-1)
				{
					int k = 0;
					for(int j=0;j<Game.gui[i].altimage.Length;j++)
					{
						if(Game.gui[i].altimage[j]!=-1)
						{
							k++;
						}
						if(Game.gui[i].altimage[j]==-1)
						{
							break;
						}
					}
					int m = ((int)Functions.abs(Functions.rand(0,1000))) % (k+1);
					if(m==0)
					{
						Game.gui[i].image = Game.gui[i].tmpimage;
					}
					else
					{
						Game.gui[i].image = Game.gui[i].altimage[m - 1];
					}
				}
			}
		}
	}
	
///////////////////Method Definition///////////////
	public static void updateall(Game game)
	{
		//update all gui stuff handling mouse interactions
		//if(Game.gamestate==Game.CAT_GAMESTATE_GAME)//16oct2021
		//{
			//if(Game.gamemode==Game.MODE_DEPLOY)//Deploy
			//{
				
			//}
		//}
		if(Functions.sign(Game.mwheel)<0)
		{
			Game.topmissionindex++;
			if(Game.topmissionindex>Game.missions.Length-8)
			{
				Game.topmissionindex=Game.missions.Length-8;
			}
		}
		if(Functions.sign(Game.mwheel)>0)
		{
			Game.topmissionindex--;
		}
		if(Game.topmissionindex<0)
		{
			Game.topmissionindex=0;
		}
		if(Game.gamestate!=Game.CAT_GAMESTATE_GAME)
		{
			Game.mwheel = 0;
		}
		bool scannedunits = false;
		//start-----------//23sep2021
		int pid = Unit.GetPlayer(null);
		int displaylimit = 0;
		int hhh = 0;
		if(pid!=-1)
		{
			displaylimit = Game.units[pid].guiattackdisplaylimit;
		}
		if(displaylimit>0)
		{
			for(int i=0;i<Game.gui.Length;i++)
			{
				if(Game.gui[i].gamestate==Game.gamestate)
				{
					if(Game.gui[i].command.IndexOf("attackaction")>=0)
					{
						Game.gui[i].hidden = 1;
						Game.gui[i].x-=Game.gui[i].horizontal;
						Game.gui[i].horizontal = 0;
					}
				}
			}
			for(int d=0;d<displaylimit;d++)
			{
				int maxgoldcost = 0;
				int targetguiid = -1;
				for(int i=0;i<Game.gui.Length;i++)
				{
					if(Game.gui[i].gamestate==Game.gamestate)
					{
						if(Game.gui[i].hidden>0)
						{
							if(Game.gui[i].command.IndexOf("attackaction")>=0)
							{
								int techid = Tech.GetTechIdFromAction(null, Game.gui[i].action);
								if(techid!=-1)
								{
									if(Tech.GoldCost(null, techid)>maxgoldcost && Tech.IsActionPurchased(null, Game.gui[i].action))
									{
										maxgoldcost = Tech.GoldCost(null, techid);
										targetguiid = i;
									}
								}
								if(Game.gui[i].action==Gui.ACTION_NONE)
								{
									Game.gui[i].action = Tech.ChooseTechForEmptySlot(null);
								}

							}
						}
					}
				}
				if(targetguiid!=-1)
				{
					Game.gui[targetguiid].hidden = 0;
					Game.gui[targetguiid].horizontal = hhh * (Game.gui[targetguiid].w + Game.gui[targetguiid].w / 8);
					Game.gui[targetguiid].x+=Game.gui[targetguiid].horizontal;
					Game.gui[targetguiid].image = Tech.GetImage(null,Game.gui[targetguiid].action);
					Game.gui[targetguiid].index = Tech.GetImageIndex(null,Game.gui[targetguiid].action);
					hhh++;
				}
			}
		}
		//end-------------//23sep2021
		//start-----------//26apr2021
		for(int i=0;i<Game.gui.Length;i++)
		{
			if(Game.gui[i].link=="gamespells" && Game.gamestate==Game.CAT_GAMESTATE_GAME)//18oct2021
			{
				if(Game.spellcast==3 || Game.RESOLVE>0)
				{
					Game.gui[i].hidden = 1;
				}
				else
				{
					Game.gui[i].hidden = 0;
				}
			}
			if(Game.gui[i].link=="gameovervictory" && Game.gamestate==Game.CAMPAIGNSTATE)//17oct2021
			{
				if(CampaignMap.Victory())
				{
					Game.gui[i].hidden = 0;
				}
				else
				{
					Game.gui[i].hidden = 1;
				}
			}
			if(Game.gui[i].link=="gameoverdefeat" && Game.gamestate==Game.CAMPAIGNSTATE)//17oct2021
			{
				if(CampaignMap.Defeat())
				{
					Game.gui[i].hidden = 0;
				}
				else
				{
					Game.gui[i].hidden = 1;
				}
			}
			if(Game.gui[i].action==80001 && Game.gamestate==Game.CAT_GAMESTATE_GAME)//16oct2021
			{
				if(Game.RESOLVE>0)
				{
					Game.gui[i].hidden = 0;
				}
				else
				{
					Game.gui[i].hidden = 1;
				}
			}
			if(Game.gui[i].link==("board") && Game.gamestate==Game.CAT_GAMESTATE_GAME)//14oct2021
			{
				//if(Game.RESOLVE>0)//18oct2021
				if(Game.RESOLVE>0 || Game.spellcast==1 || Game.spellcast==2)//18oct2021
				{
					Game.gui[i].hidden = 1;
				}
				else
				{
					Game.gui[i].hidden = 0;
				}
			}
			if(Game.gui[i].link==("gamecharacter") && Game.gamestate==Game.CAMPAIGNSTATE)//8oct2021
			{
				Game.gui[i].hidden = 1;
				int faction = 0;//16oct2021
				if(Game.campaignmode==Game.MaxArmies+1 || (Game.THINKING>0 && Game.campaignmode!=Game.MaxArmies+1))
				{
					
					faction = Game.oldcampaignmode - 1;//16oct2021
					if(faction>=0 || faction< Game.MaxArmies)//16oct2021
					{
						Game.gui[i].index = Game.gui[i].factionindex[faction];//Game.oldcampaignmode + 7;//16oct2021	
					}
					Game.gui[i].hidden = 0;
					
					if(Game.campaignmode!=Game.MaxArmies+1)
					{
						//Game.gui[i].index = Game.campaignmode + 7;//16oct2021
						faction = Game.campaignmode - 1;//16oct2021
						if(faction>=0 || faction< Game.MaxArmies)//16oct2021
						{
							Game.gui[i].index = Game.gui[i].factionindex[faction];//Game.oldcampaignmode + 7;//16oct2021	
						}
						if(Game.campaignmode==Game.PlayerIndex + 1)
						{
							//Game.gui[i].index = 2;
						}
					}
					else
					{
						//if(Game.oldcampaignmode==Game.PlayerIndex+1)
						//{
							//Game.gui[i].index = Game.EnemyIndex + 8;//16oct2021
						faction = Game.EnemyIndex;//16oct2021
						if(faction>=0 || faction< Game.MaxArmies)//16oct2021
						{
							Game.gui[i].index = Game.gui[i].factionindex[faction];//Game.oldcampaignmode + 7;//16oct2021	
						}
				
						//}
					}
					if(Game.gui[i].x>300)
					{
						if(Game.campaignmode==Game.MaxArmies+1)
						{
							Game.gui[i].title = "My Army Awaits You In Battle To Fight You For The Province";
						}
						else
						{
							Game.gui[i].title = "Thinking of my next move....";
							for(int j=0;j<Game.gui.Length;j++)
							{
								if(Game.gui[j].link==("gamebattle"))
								{
									if(Game.gui[j].hidden==0)
									{
										Game.gui[i].title = "My Army Awaits You In Battle To Fight You For The Province";
										break;
									}
								}
							}
						}
					}
				}
				if(Game.campaignmode==Game.PlayerIndex+1)
				{
					if(Game.campaignattackprovince!=-1)
					{
						//Game.aiscore = "Reset Attack Province to -1";
					}
					Game.campaignattackprovince = -1;
				}
				if(Game.campaignmode==Game.PlayerIndex+1 && Game.firsttouch==0)//hardcoded garbage
				{
					
					Game.gui[i].hidden = 0;
					//Game.gui[i].index = 2;//16oct2021
					faction = Game.PlayerIndex;//16oct2021
					if(faction>=0 || faction< Game.MaxArmies)//16oct2021
					{
						Game.gui[i].index = Game.gui[i].factionindex[faction];//Game.oldcampaignmode + 7;//16oct2021	
					}
					if(Game.gui[i].x>300)
					{
						Game.gui[i].title = "General - select a territory to invade.";
						if(Game.currentTimeMillis()>Game.guitime)
						{
							Game.firsttouch=1;
						}
					}
					if(Game.mlclick==true && Game.mx>700)
					{
						Game.firsttouch=1;
					}
					
				}
			}
			if(Game.gui[i].link==("gamestate"))
			{
				Game.gui[i].title = "GameState:"+Game.gamemode;
			}
			if(Game.gui[i].link==("pleasewait"))
			{
				Game.gui[i].title = "Please Wait - Moving Units";
				if(Game.gamemode==Game.MODE_MOVING)
				{
					Game.gui[i].hidden = 0;
				}
				else
				{
					Game.gui[i].hidden = 1;
				}
			}
			if(Game.gui[i].gamestate!=Game.oldgamestate)
			{
				if(Game.gui[i].link==("toggleon"))
				{
					Game.gui[i].link="toggleoff";
					Gui.modal = 0;//21oct2021
				}
				Game.guitime = Game.currentTimeMillis();
			}
			if(Game.gamemode==0)
			{
				if(Game.gui[i].link==("deployed"))
				{
					if(Game.spellcast!=1)//18oct2021
					{
						Game.gui[i].hidden = 0;
					}
					else//18oct2021
					{
						Game.gui[i].hidden = 1;
					}
				}
			}
			else
			{
				if(Game.gui[i].link==("deployed"))
				{
					Game.gui[i].hidden = 1;
				}
			}
			if(Game.gui[i].link==("qresolve"))
			{
				if(Game.RESOLVE==0)
				{
					if(Game.gamemode>Game.MODE_DEPLOY)
					{
						Game.gui[i].hidden = 0;
					}
					else
					{
						Game.gui[i].hidden = 1;
					}
				}
				else
				{
					Game.gui[i].hidden = 1;
				}
			}
			if(Game.gui[i].link=="popup")//16oct2021
			{
				Game.gui[i].hidden = 1;
			}
		}
		//end-------------//26apr2021
		for(int i=0;i<Game.gui.Length;i++)
		{
			if(Game.gui[i].nextgamestate==Game.CAT_GAMESTATE_REPLAY && (Config.ALLOWREPLAY==false || Config.NOREPLAY>0))//2apr2021
			{
				continue;
			}
			//start-------------//28mar2021
			if((Game.frame % 60)==22 && Game.gui[i].action>=ACTION_SPELL_START && Game.gui[i].action<=ACTION_SPELL_END && Game.gamestate==Game.gui[i].gamestate && Game.SPELLSACTIVE==true && scannedunits==false)
			{
				scannedunits = true;
				bool foundu = false;
				bool onlymagicusers = true;
				Game.SPELLCASTERLEVEL = 99;
				//for(int u=0;u<Game.units.Length;u++)//26mar2021
				for(int u=0;u<=Unit.MAXINDEX;u++)//26mar2021
				{
					if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0 && Game.units[u].walkspeed>0 && Game.units[u].selected!=Unit.SELECTIONNONE)
					{
						foundu = true;
						if(Game.units[u].spellcaster<=0)
						{
							onlymagicusers = false;
						}
						else
						{
							Game.SPELLCASTERLEVEL = ACTION_SPELL_END - ACTION_SPELL_START;
							Game.SPELLCASTERSELECTED = u;
						}
						break;
					}
				}
				if(foundu==true && Game.EDITOR==false && onlymagicusers==true)
				{
				}
				else
				{
					Game.SPELLCASTERSELECTED = -1;
				}
			}
			//end-----------------//28mar2021
			Game.gui[i].mouseover = false;
			if(Game.gui[i].gamestate == Game.gamestate)
			{
				if(Game.mx > Game.gui[i].x && Game.mx < Game.gui[i].x + Game.gui[i].w && Game.my > Game.gui[i].y && Game.my < Game.gui[i].y + Game.gui[i].h)
				{
					Game.gui[i].mouseover = true;
					if(Game.gui[i].triggerlink==LINK_SPAWNER_ICON && Game.SPAWNERSELECTED==false)
					{
						Game.gui[i].mouseover = false;
					}
					//start------------------//2sep2021
					if(Game.gui[i].triggerlink==LINK_TECH_ICON && Tech.TECHUNITSELECTED==false)
					{
						Game.gui[i].mouseover = false;
					}
					//end--------------------//2sep2021
					if(Game.gui[i].action>=ACTION_FORMATIONSTART && Game.gui[i].action<=ACTION_FORMATIONEND && (Game.NONSPAWNERSELECTED==false || Game.SPAWNERSELECTED==true))
					{
						Game.gui[i].mouseover = false;
					}
					if(Game.gui[i].triggerlink==LINK_SELECTED_ICONS) //22mar2021
					{
						Game.gui[i].mouseover = false;
					}
					if(Game.gui[i].action>=ACTION_SPELL_START && Game.gui[i].action<=ACTION_SPELL_END && (Game.SPELLCASTERSELECTED==-1 || Game.gui[i].spellactive==false))//28mar2021
					{
						Game.gui[i].mouseover = false;
						Game.gui[i].spellactive = false;//12apr2021
					}
					if(Game.EDITOR && Game.gui[i].action==Gui.BACK && Game.gui[i].link!=("toggleoff"))//25apr2021
					{
						Game.EDITMODE=Game.EDITMODE_TRIGGER;
					}
					//start------------//20apr2021
					if(Game.gui[i].link==("toggleoff"))
					{
						Game.gui[i].mouseover = false;
					}
					//end--------------//20apr2021
					if(Game.gui[i].hidden>0)//23sep2021
					{
						Game.gui[i].mouseover = false;//23sep2021
					}
					if(Gui.modal!=0)//21oct2021
					{
						if(Game.gui[i].triggerlink!=Gui.modal)
						{
							Game.gui[i].mouseover = false;
						}
					}
				}
				if(Game.gui[i].type==TYPE_CODED)
				{
					if(Game.gui[i].action==ACTION_LARGEMINIMAP)
					{
						Map.drawminimap(game,Game.gui[i].x,Game.gui[i].y,Game.gui[i].x + Game.gui[i].w,Game.gui[i].y + Game.gui[i].h);
					}
				}
				if(Game.gui[i].missionindex>=0)
				{
					if(Game.missions!=null)
					{
						//int mi = Game.gui[i].missionindex + Game.topmissionindex; //24Feb2021
						//topindexzero is equal to '1' when we are supposed to ignore topmissionindex, and zero otherwise.
						int mi = Game.gui[i].missionindex + (Game.topmissionindex * (1 - Game.gui[i].topindexzero)); //24Feb2021
						if(mi<Game.missions.Length) //17mar2021
						{
							//Game.gui[i].title = Game.missions[mi].name;//21mar2021
							Game.gui[i].title = Translation.TranslateWord(Game.missions[mi].name,false);//21mar2021
							//start-------------//12mar2021
							if(LocalStorage.getitem("mission"+mi)!=(""))
							{
								Game.gui[i].title+="("+Translation.TranslateWord("Complete",false)+")";
							}
							//end---------------//12mar2021
							//if(mi>Game.maxmission && Game.missions[mi].custom==false)//28Feb2021
							if(mi>Game.maxmission && Game.missions[mi].custom==false && Game.missions[mi].alwaysunlocked==0)//28Feb2021
							{
								Game.gui[i].title = Translation.TranslateWord("LOCKED",false);
							}
							if(Game.gui[i].title!=(Translation.TranslateWord("LOCKED",false)) && Game.mlclick==true && Game.gui[i].mouseover==true)
							{
								Game.ochosenmissionindex = Game.chosenmissionindex; //17sep2021
								Game.chosenmissionindex = mi;
							}
						}
						else //22mar2021
						{
							Game.gui[i].title = "";
							Game.topmissionindex--;
							if(Game.topmissionindex<0)
							{
								Game.topmissionindex = 0;
							}
						}
					}
				}
				//start--------------------//2apr2021
				if(Replay.PLAYBACK)
				{
					if(Game.gui[i].action==Gui.BACK)
					{
						continue;
					}
				}
				//end----------------------//2apr2021
				if(Game.numattacks>1)//8oct2021
				{
					Game.numattacks=1;
				}
				if(Game.gui[i].type==TYPE_IMAGE && Game.gui[i].link==("gameterritory"))
				{
					//fix the territory owner on the index;;;;
					int province = Game.gui[i].index % CampaignMap.maxprovince;
					int owner = CampaignMap.provinceowner[province];
					int index = province + owner * CampaignMap.maxprovince;
					Game.gui[i].index = index;
					if(Game.campaignmode==Game.PlayerIndex + 1)
					{
						//Gui.statustext = Translation.TranslateWord("Select a province to invade.",false);
					}
					if(Game.campaignmode==Game.MaxArmies+1)
					{
						//Gui.statustext = Translation.TranslateWord("Press 'Battle' to deploy the army.",false);	
					}
					//start--------------//16oct2021
					
					
					int px = Game.mx - Game.gui[i].x;
					int py = Game.my - Game.gui[i].y;
					if(CampaignMap.GetTerritoryIndex(px,py)==Game.gui[i].index % CampaignMap.maxprovince)
					{
						for(int j=0;j<Game.gui.Length;j++)
						{
							if(Game.gui[j].link=="popup" && Gui.modal==0)//16oct2021//21oct2021
							{
								//special gui item especially for provinces.....
								//x and y coordinates shift around based on where the mouse is......
								//the mouse is over a province....
								//and so we want to show the province info pop up
								//and due to the size of the display we want to reposition the x/y into 
								//the quadrant where the mouse isn't.
								Game.gui[j].hidden = 0;
								Gui.province = Game.gui[i].index % CampaignMap.maxprovince;
							}
						}
					}
					//end----------------//16oct2021
					
				}
				//21oct2021 added modal field...
				if(Game.gui[i].type==TYPE_IMAGE && Gui.modal==0 && (Game.mlclick==true || Game.campaignpcclick==true) && (Game.gui[i].link==("territory") || (Game.gui[i].link==("gameterritory") && Game.campaignmode!=Game.MaxArmies+1)))//6oct2021
				{
					//Game.WriteDebug("Map clicked");
					if(CampaignMap.CampaignOver() && Game.campaignmode!=0)
					{
						//Game.aiscore = "1";
						continue;
					}
					if(Game.campaignmode>=1 && Game.campaignmode<7 && Game.campaignmode!=Game.PlayerIndex + 1)
					{
						if(CampaignMap.team[Game.campaignmode-1]>0)
						{
							//Game.mlclick = false;
							Game.campaignpcclick=false;
							Game.campaignpcx=-1;
							Game.campaignpcy=-1;
							//Game.aiscore = "2";
							continue;
						}
					}
					
					////Log.i(Config.TAG,"Map Clicked");
					int tx = Game.mx - Game.gui[i].x;
					int ty = Game.my - Game.gui[i].y;
					if(Game.campaignpcclick==true && Game.campaignpcx!=-1 && Game.campaignmode!=Game.PlayerIndex+1)
					{
						tx = Game.campaignpcx;
						ty = Game.campaignpcy;
					}
					if(CampaignMap.GetTerritoryIndex(tx,ty)==Game.gui[i].index % CampaignMap.maxprovince)
					{
						int newindex = 0;
						CampaignMap.selectedprovince = Game.gui[i].index % CampaignMap.maxprovince;
						//Game.aiscore = "Selected Province:"+ CampaignMap.selectedprovince;
						////Log.i(Config.TAG,"newindex=0");
						if(Game.campaignmode>0)
						{
							//can we click here?
							//is it our neighbour?
							bool validcell = false;
							if(!CampaignMap.IsMyNeighbour(tx, ty, Game.campaignmode - 1))
							{
								//no it is not our neighbour......
								//this is only okay if there are empty provinces and we have none....
								if(CampaignMap.MyProvinceCount(Game.campaignmode - 1)==0)
								{
									if(CampaignMap.EmptyProvincesExist())
									{
										validcell = true;
									}
											
								}
							}
							else
							{
								validcell = true;
							}
							if(!validcell)
							{
								Game.mlclick = false;
								////Log.i(Config.TAG,"continuing");
								//Game.aiscore = "3";
								continue;
							}
							newindex = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince) + CampaignMap.GetTerritoryIndex(tx,ty);
							Game.campaignattackprovince = CampaignMap.selectedprovince;
							////Log.i(Config.TAG,"newindex="+newindex);
							int curowner = 0;
							if(Game.campaignmode==Game.PlayerIndex+1 && Game.numattacks>0)
							{
								////Log.i(Config.TAG,"numattacks > 0 and player playing");
								curowner = CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince);
								if(curowner!=Game.PlayerIndex)
								{
									////Log.i(Config.TAG,"Player touched a differently owned territory");
									Game.numattacks--;
									if(curowner==Game.MaxArmies)
									{
										CampaignMap.MarkTurn();
										////Log.i(Config.TAG,"empty province");
										//empty province...simply take it
										int its = 0;
										while(CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince)!=Game.PlayerIndex)
										{
											CampaignMap.ChangeTerritoryOwner(CampaignMap.selectedprovince);
											its++;
											if(its>10)
											{
												break;
											}
										}
										if(its>10)
										{
											Game.aiscore = "Error Loop:PlayerIndex";
										}
										newindex = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince) + CampaignMap.selectedprovince;
										////Log.i(Config.TAG,"newindex set to:"+newindex);
										if(Game.numattacks<=0)
										{
											////Log.i(Config.TAG,"rerolling dice 1");
											Game.campaignmode++;
											Game.campaignmode%=(Game.MaxArmies + 1);
											if(Game.campaignmode==Game.MaxArmies)
											{
												CampaignMap.EndTurn();
											}
											if(Game.campaignmode==0){Game.campaignmode++;}
											Game.firsttouch = 0;
											Game.guitime = Game.currentTimeMillis() + 3000;
											int da1 = 1 + (Functions.rand(0,100) % 6);
											if(da1>=4)
											{
												Game.numattacks++;
											}
											int da2 = 1 + (Functions.rand(0,100) % 6);
											if(da2>=4)
											{
												Game.numattacks++;
											}
											int da3 = 1 + (Functions.rand(0,100) % 6);
											if(da3>=4)
											{
												Game.numattacks++;
											}
											if(Game.numattacks<=0)
											{
												Game.numattacks = 1;
											}
											for(int j=0;j<Game.gui.Length;j++)
											{
												if(Game.gui[j].link==("rolldice"))
												{
													Game.gui[j].title = "Roll: "+da1+", "+da2+", "+da3;
												}
											}
										}
									}
									else
									{
										//enemy held province....ready for battle......
										////Log.i(Config.TAG,"curowner is not blank and is not us");
										for(int j=0;j<Game.gui.Length;j++)
										{
											if(Game.gui[j].link==("gamebattle"))
											{
												Game.gui[j].hidden = 0;
											}
										}
										CampaignMap.MarkTurn();
										Game.oldcampaignmode = Game.campaignmode;
										Game.campaignmode = Game.MaxArmies + 1;
										Game.campaignattackx = Game.mx - Game.gui[i].x;
										Game.campaignattacky = Game.my - Game.gui[i].y;
										//Game.aiscore = "We are attacking province:"+Game.campaignattackprovince;
										//load the enemy army.....
										//load the friendly army.....
										Game.EnemyIndex = curowner;
										Game.FriendIndex = Game.PlayerIndex;
										switch(Game.EnemyIndex)
										{
										case 0:
											Game.EnemyArmy = "Red";
											break;
										case 1:
											Game.EnemyArmy = "Blue";
											break;
										case 2: 
											Game.EnemyArmy = "Skeleton";
											break;
										case 3:
											Game.EnemyArmy = "Realm";
											break;
										case 4:
											Game.EnemyArmy = "Evil";
											break;
										case 5:
											Game.EnemyArmy = "Fiend";
											break;
										}
										//////Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
										switch(Game.FriendIndex)
										{
										case 0:
											Game.FriendArmy = "Red";
											break;
										case 1:
											Game.FriendArmy = "Blue";
											break;
										case 2: 
											Game.FriendArmy = "Skeleton";
											break;
										case 3:
											Game.FriendArmy = "Realm";
											break;
										case 4:
											Game.FriendArmy = "Evil";
											break;
										case 5:
											Game.FriendArmy = "Fiend";
											break;
										}
										////Log.i(Config.TAG,"loading 2 armies, unloading 2 armies");
										////Resources.//LoadNewArmy(Game.OldFriendArmy, Game.FriendArmy,Game.OldEnemyArmy,Game.EnemyArmy);
										for(int t=0;t<Game.templates.Length;t++)
										{
											if(Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
											{
												Game.templates[t].faction = 6;
											}
											if(Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
											{
												Game.templates[t].faction = 5;
											}
										}
										for(int g=0;g<Game.gui.Length;g++)
										{
											if(Game.gui[g].link==("enemy"))
											{
												Game.gui[g].index = Game.EnemyIndex;
											}
										}
									}
								}
							}
							else
							{
								//PC player.....
								//PC player will simply be clicking on random squares......
								//so can kind of treat exactly the same....
								//except the PlayerIndex of the PC player is the campaignmode-1,
								////Log.i(Config.TAG,"numattacks is either 0 or we are not the player turn");
								if(Game.numattacks==0)
								{
									int da1 = 1 + (Functions.rand(0,100) % 6);
									if(da1>=4)
									{
										Game.numattacks++;
									}
									int da2 = 1 + (Functions.rand(0,100) % 6);
									if(da2>=4)
									{
										Game.numattacks++;
									}
									int da3 = 1 + (Functions.rand(0,100) % 6);
									if(da3>=4)
									{
										Game.numattacks++;
									}
									if(Game.numattacks<=0)
									{
										Game.numattacks = 1;
									}
									for(int j=0;j<Game.gui.Length;j++)
									{
										if(Game.gui[j].link==("rolldice"))
										{
											Game.gui[j].title = "Roll: "+da1+", "+da2+", "+da3;
										}
									}
								}
								if(Game.campaignpcx!=-1 && Game.campaignpcy!=-1)
								{
									////Log.i(Config.TAG,"pc player has selected a square");
									if(Game.numattacks>0)
									{
										////Log.i(Config.TAG,"pc player has attacks");
										curowner = CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince);
										if(curowner!=Game.campaignmode - 1)
										{
											////Log.i(Config.TAG,"pc player is selecting a province held by someone else ");
											Game.numattacks--;
											if(curowner==Game.MaxArmies)
											{
												////Log.i(Config.TAG,"pc player is selecting an empty province");
												CampaignMap.MarkTurn();
												//empty province...simply take it
												int its = 0;
												if(Game.campaignmode<=0 || Game.campaignmode>=Game.MaxArmies+1)
												{
													Game.aiscore = "Error:"+Game.campaignmode;
													Game.campaignmode = Game.PlayerIndex + 1;
													CampaignMap.selectedprovince = -1;
													continue;
												}
												while(CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince)!=Game.campaignmode - 1)
												{
													CampaignMap.ChangeTerritoryOwner(CampaignMap.selectedprovince);
													its++;
													if(its>10)
													{
														break;
													}
												}
												if(its>10)
												{
													Game.aiscore = "Error:Loop:Campaign Mode:"+(Game.campaignmode -1);
													Game.campaignmode = Game.PlayerIndex + 1;//attempt to fix the error....
													CampaignMap.selectedprovince = 0;//attempt to fix the error
													return;//bugger
												}
												newindex = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince) + CampaignMap.selectedprovince;
												if(Game.numattacks<=0)
												{
													Game.campaignmode++;
													Game.campaignmode%=(Game.MaxArmies + 1);
													if(Game.campaignmode==Game.MaxArmies)
													{
														CampaignMap.EndTurn();
													}
													if(Game.campaignmode==0){Game.campaignmode++;}
													Game.firsttouch = 0;
													Game.guitime = Game.currentTimeMillis() + 3000;
													////Log.i(Config.TAG,"Moving to next player");
													Game.THINKING = 0;
													int da1 = 1 + (Functions.rand(0,100) % 6);
													if(da1>=4)
													{
														Game.numattacks++;
													}
													int da2 = 1 + (Functions.rand(0,100) % 6);
													if(da2>=4)
													{
														Game.numattacks++;
													}
													int da3 = 1 + (Functions.rand(0,100) % 6);
													if(da3>=4)
													{
														Game.numattacks++;
													}
													if(Game.numattacks<=0)
													{
														Game.numattacks=1;
													}
													for(int j=0;j<Game.gui.Length;j++)
													{
														if(Game.gui[j].link==("rolldice"))
														{
															Game.gui[j].title = "Roll: "+da1+", "+da2+", "+da3;
														}
													}
												}
											}
											else
											{
												if(CampaignMap.EmptyProvincesExist() && CampaignMap.MyProvinceCount(Game.campaignmode - 1)==0)
												{
													//not allowed to select (the pc player isn't anyway)
													Game.numattacks = 1;//
													continue;
												}
												//enemy held province....ready for battle......
												for(int j=0;j<Game.gui.Length;j++)
												{
													if(Game.gui[j].link==("gamebattle"))
													{
														Game.gui[j].hidden = 0;
													}
												}
												if(curowner==Game.PlayerIndex)
												{
													CampaignMap.MarkTurn();
													////Log.i(Config.TAG,"pc player is opting to fight against the human player");
													//fight a battle.....against the player.....
													Game.oldcampaignmode = Game.campaignmode;
													Game.campaignmode = Game.MaxArmies + 1;
													Game.campaignattackx = tx;
													Game.campaignattacky = ty;
													Game.campaignattackprovince = CampaignMap.selectedprovince;
													//Game.aiscore = "AI Player:"+(Game.oldcampaignmode-1)+" is attacking:"+CampaignMap.selectedprovince;
													//load the enemy army.....
													//load the friendly army.....
													Game.FriendIndex = curowner;
													Game.EnemyIndex = Game.oldcampaignmode - 1;
													switch(Game.EnemyIndex)
													{
													case 0:
														Game.EnemyArmy = "Red";
														break;
													case 1:
														Game.EnemyArmy = "Blue";
														break;
													case 2: 
														Game.EnemyArmy = "Skeleton";
														break;
													case 3:
														Game.EnemyArmy = "Realm";
														break;
													case 4:
														Game.EnemyArmy = "Evil";
														break;
													case 5:
														Game.EnemyArmy = "Fiend";
														break;
													}
													//////Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
													switch(Game.FriendIndex)
													{
													case 0:
														Game.FriendArmy = "Red";
														break;
													case 1:
														Game.FriendArmy = "Blue";
														break;
													case 2: 
														Game.FriendArmy = "Skeleton";
														break;
													case 3:
														Game.FriendArmy = "Realm";
														break;
													case 4:
														Game.FriendArmy = "Evil";
														break;
													case 5:
														Game.FriendArmy = "Fiend";
														break;
													}
													////Log.i(Config.TAG,"armies about to load");
													//Resources./(Game.OldFriendArmy, Game.FriendArmy,Game.OldEnemyArmy,Game.EnemyArmy);
													for(int t=0;t<Game.templates.Length;t++)
													{
														if(Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
														{
															Game.templates[t].faction = 6;
														}
														if(Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
														{
															Game.templates[t].faction = 5;
														}
													}
													for(int g=0;g<Game.gui.Length;g++)
													{
														if(Game.gui[g].link==("enemy"))
														{
															Game.gui[g].index = Game.EnemyIndex;
														}
													}
												}
												else
												{
													//simulate a battle between two PC players......
													Game.numattacks--;
													CampaignMap.MarkTurn();
													////Log.i(Config.TAG,"pc player is simulating a battle between itself and another pc player");
													int winprob = 50;
													int p1 = 0;
													int p2 = 0;
													for(int p=0;p<CampaignMap.maxprovince;p++)
													{
														if(CampaignMap.provinceowner[p]==Game.campaignmode - 1)
														{
															p1++;
														}
														if(CampaignMap.provinceowner[p]==CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince))
														{
															p2++;
														}
													}
													if(p1>p2)
													{
														winprob+=10;
													}
													if(p1<p2)
													{
														winprob-=10;
													}
													if(p1>p2*2)
													{
														winprob+=10;
													}
													if(p1*2<p2)
													{
														winprob-=10;
													}
													CampaignMap.SetBattleLocation(CampaignMap.selectedprovince);//16oct2021
													if(Functions.rand(0,100)<winprob)
													{
														while(CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince)!=Game.campaignmode - 1)
														{
															CampaignMap.ChangeTerritoryOwner(CampaignMap.selectedprovince);	
														}
														////Log.i(Config.TAG,"pc player won");
														CampaignMap.AfterBattle(Game.campaignmode - 1);
													}
													else
													{
														////Log.i(Config.TAG,"pc player lost");
														CampaignMap.AfterBattle(Game.campaignmode - 1);
														//13oct2021 territory owner gains a hero.....
														//because they successfully defended their province.....
														CampaignMap.SetHero(CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince),1);//13oct2021
														//Game.newtoast("Hero for province:"+CampaignMap.selectedprovince);
													}
													newindex = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(CampaignMap.selectedprovince) + CampaignMap.selectedprovince;
													if(Game.numattacks<=0)
													{
														Game.campaignmode++;
														Game.campaignmode%=(Game.MaxArmies + 1);
														if(Game.campaignmode==Game.MaxArmies)
														{
															CampaignMap.EndTurn();
														}
														if(Game.campaignmode==0){Game.campaignmode++;}
														
														Game.firsttouch = 0;
														Game.guitime = Game.currentTimeMillis() + 3000;
														Game.THINKING = 0;
														int da1 = 1 + (Functions.rand(0,100) % 6);
														if(da1>=4)
														{
															Game.numattacks++;
														}
														int da2 = 1 + (Functions.rand(0,100) % 6);
														if(da2>=4)
														{
															Game.numattacks++;
														}
														int da3 = 1 + (Functions.rand(0,100) % 6);
														if(da3>=4)
														{
															Game.numattacks++;
														}
														if(Game.numattacks<=0)
														{
															Game.numattacks = 1;
														}
														for(int j=0;j<Game.gui.Length;j++)
														{
															if(Game.gui[j].link==("rolldice"))
															{
																Game.gui[j].title = "Roll: "+da1+", "+da2+", "+da3;
															}
														}
													}
												}
											}
										}		
									}
								}
							}
						}
						else
						{
							if((NetworkUDP.Ready() && NetworkUDP.isserver) || !NetworkUDP.Ready())
							{
								CampaignMap.ChangeTerritoryOwner(Game.mx - Game.gui[i].x,Game.my - Game.gui[i].y);
								newindex = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(Game.mx - Game.gui[i].x,Game.my - Game.gui[i].y) + CampaignMap.GetTerritoryIndex(Game.mx - Game.gui[i].x,Game.my - Game.gui[i].y);
							}
							if(NetworkUDP.Ready())
							{
								if(NetworkUDP.isserver)
								{
									int xx = Game.mx - Game.gui[i].x;
									int yy = Game.my - Game.gui[i].y;
									int[] pos = new int[3];
									pos[0] = xx;
									pos[1] = yy;
									pos[2] = i;
									NetworkUDP.communicate(NetworkUDP.TOUCHCAMPAIGNMAP,pos);
								}
							}
						}
						if(NetworkUDP.Ready())
						{
							if(NetworkUDP.isserver)
							{
								Game.gui[i].index = newindex;
							}
						}
						else
						{
							Game.gui[i].index = newindex;
						}
						Game.mlclick = false;
						continue;
					}
				}
				
				//if(Game.gui[i].type==TYPE_BUTTON && Game.gui[i].mouseover==true && Game.mlclick==true)//2apr2021//20oct2021
				if((Game.gui[i].type==TYPE_BUTTON && Game.gui[i].mouseover==true && Game.mlclick==true) || (Game.trainai>0 && (Game.gui[i].action==70099 || (Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.gui[i].link=="board"))))//2apr2021//20oct2021
				//if(Game.gui[i].type==TYPE_BUTTON && Game.gui[i].mouseover==true && ((Game.mlclick==true && exitclick==false) || (exitclick==true && Game.mlclick==false)))//2apr2021
				{
					//start-------------------//20apr2021
					if(Game.gui[i].action==Gui.ACTION_NONE)
					{
						continue;
					}
					if(Game.gui[i].link==("armyicon"))
					{
						if(CampaignMap.selectedprovince!=-1)
						{
							if((NetworkUDP.Ready() && NetworkUDP.isserver) || !NetworkUDP.Ready())
							{
								CampaignMap.SetArmy(CampaignMap.selectedprovince);
							}
							if(NetworkUDP.Ready())
							{
								if(NetworkUDP.isserver)
								{
									int[] province = new int[1];
									province[0] = CampaignMap.selectedprovince;
									NetworkUDP.communicate(NetworkUDP.TOUCHCAMPAIGNICON, province);
								}
							}
						}
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						continue;
					}
					if(Game.gui[i].link=="gamespells")//18oct2021
					{
						//this is so we hide the spell casting button after a spell has been chosen
						//but allow it to remain available until that time.....
						//so spellcast = 2 gets set when a spell is cast
						//and when spellcast = 3 is set then this toggle|pause command button
						//gets hidden.....
						if(Game.spellcast<2)
						{
							Game.spellcast = 1 - Game.spellcast;//alternate between 0 and 1 when pressed....
							////determines if board is hidden or not...
						}
						if(Game.spellcast==2)
						{
							Game.spellcast = 3;
						}
					}
					if(Game.gui[i].link=="gameoverdefeat")//17oct2021
					{
						Game.chosenmissionindex = 2; // DEFEAT MISSION
						if(Game.chosenmissionindex!=-1)
						{
							Map.levelseed = Functions.seed;//2apr2021
							Program.resetgame(game);//2apr2021
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.CAMPAIGNSTATE = Game.gamestate;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Program.cleardeaths(game);
							Game.map = new Map();
							Program.setupmission(game,Game.chosenmissionindex,2);
							Map.adddecor();//2mar2021
							Map.marktreepos(game);
							Map.levelseed2 = Functions.seed;//2apr2021
							//remove all units....
							for(int nid=0;nid<Game.units.Length;nid++)
							{
								Game.units[nid].hp = 0;
								Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
								Game.units[nid].reset(null,nid);
							}
							//Map.removeallbones();
							Game.gamemode = 0;//DEPLOY
							Game.RESOLVE = 0;
							Game.PLAYERFACTION = 6;//7oct2021
							Game.SKIRMISHENEMYFACTION = 5;//7oct2021
							Game.numelements = CampaignMap.NumElements(Game.PlayerIndex);//Game.startingnumelements + CampaignMap.MyProvinceCount(Game.PlayerIndex)/4;//8oct2021
							Game.numenemyelements = CampaignMap.NumElements(Game.EnemyIndex);//Game.startingnumelements + CampaignMap.MyProvinceCount(Game.EnemyIndex)/4;//8oct2021
							Game.campaignmode = Game.oldcampaignmode;//Game.PlayerIndex + 1;//8oct2021 or Other PC Player Index + 1
							/////////////////////////////
							//start----------//13oct2021
							if(Game.campaignmode!=Game.PlayerIndex + 1)
							{
								//pc player launching attack
								Game.numfhero = 0;
								Game.numehero = CampaignMap.GetHero(Game.campaignmode - 1,Game.campaignattackprovince,true);
							}
							else
							{
								//human player launching attack
								Game.numfhero = 0;
								Game.numehero = CampaignMap.GetHero(CampaignMap.GetTerritoryOwner(Game.campaignattackprovince),Game.campaignattackprovince,false);
							}
							//13oct2021
							/////////////////////////////
							Game.vsai = 1 + Functions.rand(0,1000) % Unit.NUMAISCRIPTS;
							Game.vsai = Unit.GetSecondMostPowerfulAi();
							//Game.aiscore = "Player Turn:"+(Game.campaignmode-1);
							Game.attackingplayer = Game.campaignmode - 1;
							/////////
							//Add a bunch of panicking units...fleeing from whatever the enemy was........
							//and set the game mode to resolve=1//////
							Gui.SetUpDefeat();//17oct2021
							/////////
						}
						Game.mlclick = false;
						continue;
					}
					if(Game.gui[i].link=="gameovervictory")//17oct2021
					{
						Game.chosenmissionindex = 1; // VICTORY MISSION
						if(Game.chosenmissionindex!=-1)
						{
							Map.levelseed = Functions.seed;//2apr2021
							Program.resetgame(game);//2apr2021
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.CAMPAIGNSTATE = Game.gamestate;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Program.cleardeaths(game);
							Game.map = new Map();
							Program.setupmission(game,Game.chosenmissionindex,2);
							Map.adddecor();//2mar2021
							Map.marktreepos(game);
							Map.levelseed2 = Functions.seed;//2apr2021
							//remove all units....
							for(int nid=0;nid<Game.units.Length;nid++)
							{
								Game.units[nid].hp = 0;
								Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
								Game.units[nid].reset(null,nid);
							}
							//Map.removeallbones();
							Game.gamemode = 0;//DEPLOY
							Game.RESOLVE = 0;
							Game.PLAYERFACTION = 6;//7oct2021
							Game.SKIRMISHENEMYFACTION = 5;//7oct2021
							Game.numelements = CampaignMap.NumElements(Game.PlayerIndex);//Game.startingnumelements + CampaignMap.MyProvinceCount(Game.PlayerIndex)/4;//8oct2021
							Game.numenemyelements = CampaignMap.NumElements(Game.EnemyIndex);//Game.startingnumelements + CampaignMap.MyProvinceCount(Game.EnemyIndex)/4;//8oct2021
							Game.campaignmode = Game.oldcampaignmode;//Game.PlayerIndex + 1;//8oct2021 or Other PC Player Index + 1
							/////////////////////////////
							//start----------//13oct2021
							if(Game.campaignmode!=Game.PlayerIndex + 1)
							{
								//pc player launching attack
								Game.numfhero = CampaignMap.GetHero(Game.PlayerIndex,Game.campaignattackprovince,false);
								Game.numehero = CampaignMap.GetHero(Game.campaignmode - 1,Game.campaignattackprovince,true);
							}
							else
							{
								//human player launching attack
								Game.numfhero = CampaignMap.GetHero(Game.PlayerIndex,Game.campaignattackprovince,true);
								Game.numehero = CampaignMap.GetHero(CampaignMap.GetTerritoryOwner(Game.campaignattackprovince),Game.campaignattackprovince,false);
							}
							//13oct2021
							/////////////////////////////
							Game.vsai = 1 + Functions.rand(0,1000) % Unit.NUMAISCRIPTS;
							Game.vsai = Unit.GetSecondMostPowerfulAi();
							//Game.aiscore = "Player Turn:"+(Game.campaignmode-1);
							Game.attackingplayer = Game.campaignmode - 1;
							/////////
							//Add a bunch of panicking units...fleeing from whatever the enemy was........
							//and set the game mode to resolve=1//////
							Gui.SetUpVictory();//17oct2021
							/////////
						}
						Game.mlclick = false;
						continue;
					}
					
					if(Game.gui[i].link==("gamebattle"))//8oct2021
					{
						Game.chosenmissionindex = 0;
						if(Game.chosenmissionindex!=-1)
						{
							Map.levelseed = Functions.seed;//2apr2021
							Program.resetgame(game);//2apr2021
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.CAMPAIGNSTATE = Game.gamestate;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Program.cleardeaths(game);
							Game.map = new Map();
							Program.setupmission(game,Game.chosenmissionindex,2);
							Map.adddecor();//2mar2021
							Map.marktreepos(game);
							Map.levelseed2 = Functions.seed;//2apr2021
							//remove all units....
							for(int nid=0;nid<Game.units.Length;nid++)
							{
								Game.units[nid].hp = 0;
								Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
								Game.units[nid].reset(null,nid);
							}
							//Map.removeallbones();
							Game.gamemode = 0;//DEPLOY
							Game.RESOLVE = 0;
							Game.PLAYERFACTION = 6;//7oct2021
							Game.SKIRMISHENEMYFACTION = 5;//7oct2021
							Game.numelements = CampaignMap.NumElements(Game.PlayerIndex);//Game.startingnumelements + CampaignMap.MyProvinceCount(Game.PlayerIndex)/4;//8oct2021
							Game.numenemyelements = CampaignMap.NumElements(Game.EnemyIndex);//Game.startingnumelements + CampaignMap.MyProvinceCount(Game.EnemyIndex)/4;//8oct2021
							Game.campaignmode = Game.oldcampaignmode;//Game.PlayerIndex + 1;//8oct2021 or Other PC Player Index + 1
							/////////////////////////////
							//start----------//13oct2021
							
							if(Game.campaignmode!=Game.PlayerIndex + 1)
							{
								//pc player launching attack
								Game.numfhero = CampaignMap.GetHero(Game.PlayerIndex,Game.campaignattackprovince,false);
								Game.numehero = CampaignMap.GetHero(Game.campaignmode - 1,Game.campaignattackprovince,true);
							}
							else
							{
								//human player launching attack
								Game.numfhero = CampaignMap.GetHero(Game.PlayerIndex,Game.campaignattackprovince,true);
								Game.numehero = CampaignMap.GetHero(CampaignMap.GetTerritoryOwner(Game.campaignattackprovince),Game.campaignattackprovince,false);
							}
							
							//13oct2021
							/////////////////////////////
							Game.vsai = 1 + Functions.rand(0,1000) % Unit.NUMAISCRIPTS;
							Game.vsai = Unit.GetSecondMostPowerfulAi();
							//Game.aiscore = "Player Turn:"+(Game.campaignmode-1);
							Game.attackingplayer = Game.campaignmode - 1;
						}
						Game.mlclick = false;
						continue;
					}
					if(Game.gui[i].link==("takepicture"))//6oct2021
					{
						Game.takepicture = true;
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						continue;
					}
					if(Game.gui[i].link==("loadcampaign"))//6oct2021
					{
						CampaignMap.GetSavedTerritoryData();
						Research.LoadResearchForCampaign();//21oct2021
						for(int j=0;j<Game.gui.Length;j++)
						{
							if(Game.gui[j].link==("territory"))
							{
								for(int x=0;x<1600;x+=10)
								{
									for(int y=0;y<1200;y+=10)
									{
										if(CampaignMap.GetTerritoryIndex(x,y)==Game.gui[j].index % CampaignMap.maxprovince)
										{
											Game.gui[j].index = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(x,y) + CampaignMap.GetTerritoryIndex(x,y);	
										}
									}
								}
							}
						}
						if(NetworkUDP.Ready() && NetworkUDP.isserver)
						{
							NetworkUDP.communicate(NetworkUDP.SYNCCAMPAIGN, null);
						}
						//Game.gui[i].mouseover = false;
						//Game.mlclick = false;
						//continue;
					}
					if(Game.gui[i].link==("campaignmode"))//8oct2021
					{
						////Log.i(Config.TAG,"Campaign Mode Entered");
						Game.CAMPAIGNSTATE = Game.gui[i].nextgamestate;
						Game.campaignmode = Game.PlayerIndex + 1;
						Game.oldcampaignmode = Game.campaignmode;
						CampaignMap.GetSavedTerritoryData();
						Research.LoadResearchForCampaign();//21oct2021
						for(int j=0;j<Game.gui.Length;j++)
						{
							if(Game.gui[j].link==("gameterritory"))
							{
								for(int x=0;x<1600;x+=10)
								{
									for(int y=0;y<1200;y+=10)
									{
										if(CampaignMap.GetTerritoryIndex(x,y)==Game.gui[j].index % CampaignMap.maxprovince)
										{
											Game.gui[j].index = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(x,y) + CampaignMap.GetTerritoryIndex(x,y);	
										}
									}
								}
								
							}
						}
						if(Game.numattacks==0)
						{
							int da1 = 1 + (Functions.rand(0,100) % 6);
							if(da1>=4)
							{
								Game.numattacks++;
							}
							int da2 = 1 + (Functions.rand(0,100) % 6);
							if(da2>=4)
							{
								Game.numattacks++;
							}
							int da3 = 1 + (Functions.rand(0,100) % 6);
							if(da3>=4)
							{
								Game.numattacks++;
							}
							for(int j=0;j<Game.gui.Length;j++)
							{
								if(Game.gui[j].link==("rolldice"))
								{
									Game.gui[j].title = "Roll: "+da1+", "+da2+", "+da3;
								}
							}
							if(Game.numattacks<=0)
							{
								Game.numattacks = 1;
							}
						}
						//Game.gui[i].mouseover = false;
						//Game.mlclick = false;
						//continue;
						//Game.gui[i].mouseover = false;
						//Game.mlclick = false;
						//continue;
					}
					if(Game.gui[i].link==("rolldice"))//6oct2021
					{
						int d1 = Functions.rand(1,7);
						int d2 = Functions.rand(1,7);
						int d3 = Functions.rand(1,7);
						if(d1>6)
						{
							d1 = 6;
						}
						if(d2>6)
						{
							d2 = 6;
						}
						if(d3>6)
						{
							d3 = 6;
						}
						if(d1<1)
						{
							d1 = 1;
						}
						if(d2<1)
						{
							d2 = 1;
						}
						if(d3<1)
						{
							d3 = 1;
						}
						if(Game.campaignmode==1)
						{
							Game.numattacks = 0;
							if(d1>=4)
							{
								Game.numattacks++;
							}
							if(d2>=4)
							{
								Game.numattacks++;
							}
							if(d3>=4)
							{
								Game.numattacks++;
							}
						}
						Game.gui[i].title = "Roll: "+d1+", "+d2+", "+d3;
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						continue;
					}
					if(Game.gui[i].link==("qresolve"))
					{
						Game.gamemode = -1;
						Game.gui[i].hidden = 1;
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						Game.RESOLVE = 1;
						if(Game.vsai<=0)
						{
							NetworkUDP.communicate(NetworkUDP.PRESSRESOLVE,null);
						}
						for(int trig=0;trig<Game.triggers.Length;trig++)
						{
							if(Game.triggers[trig].unitname!=null)
							{
								if(Game.triggers[trig].unitname==("RANDOMEVENT"))
								{
									if(!NetworkUDP.Ready() || Game.vsai>0)
									{
										Trigger.RandomEvent(trig);
									}
									else
									{
										Game.triggers[trig].type=0;
									}
									
								}
							}
						}
						continue;
					}
					if(Game.gui[i].link==("deployed"))
					{
						Game.gamemode = 1;
						Game.gui[i].hidden = 1;
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						if(Game.campaignmode>0 || Game.vsai>0)
						{
							DoFinalAiChoices();
						}
						continue;
					}
					if(Game.gui[i].link==("board"))
					{
						//handle mouse click on the board......
						//basically.....yeah.....
						//simply move the pieces around....and so on......
						int boardx = (Game.mx) / 160;
						int boardy = (Game.my) / Game.BOARDY;
						
						if(Game.trainai>0 && Game.gamemode==0)//20oct2021
						{
							boardx = Functions.rand(0,Game.RESOLUTIONX) / 160;
							boardy = 7 + (CampaignMap.rand() % 2);
						}
						
						switch(Game.gamemode)
						{
						case 0://DEPLOY
							if(boardy<=1 && Game.campaignmode<=0 && Game.vsai<=0)//8oct2021
							{
								//red player
								for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
								{
									for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
									{
										int nid = Map.cellunit(x, y);
										if(nid!=-1)
										{
											if(Game.units[nid].boardy==boardy)//6oct2021
											{
												Game.units[nid].hp=0;
												Map.removeunit(nid, x, y);
												Game.units[nid].reset(null,nid);
											}
										}
									}
								}
								Game.templateindex++;
								Game.templateindex%=Game.templates.Length;
								while(Game.templates[Game.templateindex].name.IndexOf(Game.EnemyArmy)<0 || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
								{
									Game.templateindex++;
									Game.templateindex%=Game.templates.Length;
								}
								if(NetworkUDP.Ready() && Game.vsai<=0)
								{
									int[] command = new int[3];
									command[0] = Game.templateindex;
									command[1] = boardx;
									command[2] = boardy;
									NetworkUDP.communicate(NetworkUDP.CREATEUNIT,command);
									firstunit++;
								}
								int tcount = Game.templates[Game.templateindex].points;
								if(tcount>14)//21oct2021
								{
									tcount = 14;
								}
								Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
								for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
								{
									for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
									{
										int nid = Map.cellunit(x, y);
										if(nid==-1 && Map.passable(x, y))
										{
											for(int j=0;j<Game.units.Length;j++)
											{
												if(Game.units[j].hp<=0)
												{
													if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
													{
														tcount--;
													}
													break;
												}
											}
										}
										if(tcount<=0)
										{
											break;
										}
									
									}
									if(tcount<=0)
									{
										break;
									}
								}
								
							}
							if(boardy>=7)
							{
								//blue player
								//red player
								if(Game.numelements>0 || (Game.campaignmode==0 && Game.vsai<=0))
								{
									for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
									{
										for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
										{
											int nid = Map.cellunit(x, y);
											if(nid!=-1)
											{
												if(Game.units[nid].boardy==boardy)//6oct2021
												{
													Game.units[nid].hp=0;
													Map.removeunit(nid, x, y);
													Game.units[nid].reset(null,nid);
												}
											}
										}
									}
									Game.templateindex++;
									Game.templateindex%=Game.templates.Length;
									while(Game.templates[Game.templateindex].name.IndexOf(Game.FriendArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
									{
										Game.templateindex++;
										Game.templateindex%=Game.templates.Length;
									}
									Game.oldtemplateindex = Game.templateindex;
									if(NetworkUDP.Ready() && Game.vsai<=0)
									{
										int[] command = new int[3];
										command[0] = Game.templateindex;
										command[1] = boardx;
										command[2] = boardy;
										NetworkUDP.communicate(NetworkUDP.CREATEUNIT,command);
										firstunit++;
									}
									int tcount = Game.templates[Game.templateindex].points;
									if(tcount>14)//21oct2021
									{
										tcount = 14;
									}
									Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
									for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
									{
										for(int x=boardx*160;x<boardx*160+160;x+=Map.GRIDW/4)
										{
											int nid = Map.cellunit(x, y);
											if(nid==-1 && Map.passable(x, y))
											{
												for(int j=0;j<Game.units.Length;j++)
												{
													if(Game.units[j].hp<=0)
													{
														if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
														{
															tcount--;
														}
														break;
													}
												}
											}
											if(tcount<=0)
											{
												break;
											}
										
										}
										if(tcount<=0)
										{
											break;
										}
									}
								}
							}
							if((Game.campaignmode>0 || Game.vsai>0) && (Game.oldboardx!=boardx || Game.oldboardy != boardy))//8oct2021
							{
								Game.oldboardx = boardx;
								Game.oldboardy = boardy;
								//Game.numelements--;
								Game.numelements = CampaignMap.NumElements(Game.PlayerIndex);
								if(Game.vsai>0 && Game.campaignmode<=0)
								{
									Game.numelements = CampaignMap.NumElements(-1);
								}
								if(Game.numelements>20)
								{
									Game.numelements=20;
								}
								bool bfound = false;
								for(int bx=0;bx<10;bx++)
								{
									for(int by=0;by<9;by++)
									{
										bfound = false;
										for(int j=0;j<Game.units.Length;j++)
										{
											if(Game.templates[Game.units[j].templateid].name==null)
											{
												continue;
											}
											if(Game.units[j].hp>0 && (Game.templates[Game.units[j].templateid].name.IndexOf(Game.PlayerArmy)>=0) && Game.units[j].boardx==bx && Game.units[j].boardy==by)
											{
												bfound = true;
												break;
											}
										}
										if(bfound)
										{
											Game.numelements--;
										}
									}
								}
								Game.numenemyelements = CampaignMap.NumElements(Game.EnemyIndex);//Game.startingnumelements + (CampaignMap.MyProvinceCount(Game.EnemyIndex)/4);
								if(Game.vsai>0 && Game.campaignmode<=0)
								{
									Game.numenemyelements = CampaignMap.NumElements(-1);
								}
								if(Game.numelements>20)
								{
									Game.numelements=20;
								}
								bfound = false;
								for(int bx=0;bx<10;bx++)
								{
									for(int by=0;by<9;by++)
									{
										bfound = false;
										for(int j=0;j<Game.units.Length;j++)
										{
											if(Game.templates[Game.units[j].templateid].name==null)
											{
												continue;
											}
											if(Game.units[j].hp>0 && Game.templates[Game.units[j].templateid].name.IndexOf(Game.EnemyArmy)>=0 && Game.units[j].boardx==bx && Game.units[j].boardy==by)
											{
												bfound = true;
												break;
											}
										}
										if(bfound)
										{
											Game.numenemyelements--;
										}
									}
								}
								
								if(Game.numenemyelements>=0)
								{
									//place an enemy unit down....
									boardy = Functions.Rand(0, 100) % 2;
									boardx = Functions.Rand(0,100) % 10;
									for(int p=0;p<15;p++)
									{
										if(boardy<=1 && (Game.campaignmode>0 || Game.vsai>0))//8oct2021
										{
											//red player
											for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
											{
												for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
												{
													int nid = Map.cellunit(x, y);
													if(nid!=-1)
													{
														if(Game.units[nid].boardy==boardy)//6oct2021
														{
															Game.units[nid].hp=0;
															Map.removeunit(nid, x, y);
															Game.units[nid].reset(null,nid);
														}
													}
												}
											}
											int ecount = Functions.rand(5,15);
											for(int e=0;e<ecount;e++)
											{
												Game.templateindex++;
												Game.templateindex%=Game.templates.Length;
												while(Game.templates[Game.templateindex].name.IndexOf(Game.EnemyArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
												{
													Game.templateindex++;
													Game.templateindex%=Game.templates.Length;
												}
											}
											int tcount = Game.templates[Game.templateindex].points;
											if(tcount>14)//21oct2021
											{
												tcount = 14;
											}
											Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
											for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
											{
												for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
												{
													int nid = Map.cellunit(x, y);
													if(nid==-1 && Map.passable(x, y))
													{
														for(int j=0;j<Game.units.Length;j++)
														{
															if(Game.units[j].hp<=0)
															{
																if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
																{
																	tcount--;
																}
																break;
															}
														}
													}
													if(tcount<=0)
													{
														break;
													}
												
												}
												if(tcount<=0)
												{
													break;
												}
											}
											//AI choose unit to place....
											if(Unit.AiDeploy(Game.templateindex,boardx,boardy,p))
											{
												break;
											}
										}
									}
									Game.templateindex = Game.oldtemplateindex;
								}
								//then check.....
								
								if(Game.numelements<=0)
								{
									while(Game.numenemyelements>0)
									{
										Game.numenemyelements--;
										boardy = Functions.Rand(0, 100) % 2;
										boardx = Functions.Rand(0,100) % 10;
										for(int p=0;p<15;p++)
										{
											if(boardy<=1 && (Game.campaignmode>0 || Game.vsai>0))//8oct2021
											{
												//red player
												for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
												{
													for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
													{
														int nid = Map.cellunit(x, y);
														if(nid!=-1)
														{
															if(Game.units[nid].boardy==boardy)//6oct2021
															{
																Game.units[nid].hp=0;
																Map.removeunit(nid, x, y);
																Game.units[nid].reset(null,nid);
															}
														}
													}
												}
												Game.templateindex++;
												Game.templateindex%=Game.templates.Length;
												while(Game.templates[Game.templateindex].name.IndexOf(Game.EnemyArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
												{
													Game.templateindex++;
													Game.templateindex%=Game.templates.Length;
												}
												int tcount = Game.templates[Game.templateindex].points;
												if(tcount>14)//21oct2021
												{
													tcount = 14;
												}
												Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
												for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
												{
													for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
													{
														int nid = Map.cellunit(x, y);
														if(nid==-1 && Map.passable(x, y))
														{
															for(int j=0;j<Game.units.Length;j++)
															{
																if(Game.units[j].hp<=0)
																{
																	if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
																	{
																		tcount--;
																	}
																	break;
																}
															}
														}
														if(tcount<=0)
														{
															break;
														}
													
													}
													if(tcount<=0)
													{
														break;
													}
												}
												//AI choose unit to place....
												if(Game.templates[Game.templateindex].firebullet>0)
												{
													if(boardy==0)
													{
														if(Functions.rand(0, 100)<35)
														{
															break;
														}
													}
													if(boardy==1)
													{
														if(Functions.Rand(0, 100)<15)
														{
															break;
														}
													}
												}
												if(Game.templates[Game.templateindex].brave>0)
												{
													if(Functions.Rand(0, 100)<50)
													{
														break;
													}
												}
												if(Game.templates[Game.templateindex].leader>0)
												{
													if(boardy==0)
													{
														if(Functions.rand(0, 100)<25)
														{
															break;
														}
													}
													else
													{
														if(Functions.rand(0, 100)<15)
														{
															break;
														}
													}
												}
												if(Game.templates[Game.templateindex].walkspeed!=2)
												{
													if(boardx<3 || boardx>=7)
													{
														if(Functions.rand(0,100)<25)
														{
															break;
														}
													}
												}
												if(Game.templates[Game.templateindex].leader>0)
												{
													if(boardx>=3 || boardx<7)
													{
														if(Functions.rand(0,100)<15)
														{
															break;
														}
													}
												}
											}
										}
									}
									Game.gamemode = -1;
									Game.RESOLVE = 1;
									Game.oldboardx = -1;
									Game.oldboardy = -1;
									continue;
								}
							}
							break;
						case 1://ORDER
							
							//boardx and boardy....check the units in the square.....
							if(Game.firstcell==-1)
							{
								Game.CELLSIDE = -1;
								Game.ARCHERS = -1;
								Game.firstcell = boardx + boardy * 10;
								for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
								{
									for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
									{
										int nid = Map.cellunit(x,y);
										if(nid!=Map.VACANT)
										{
											if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
											{
												Game.CELLSIDE = Game.templates[Game.units[nid].templateid].faction;
												Game.ARCHERS = Functions.sign(Game.units[nid].firebullet);
												break;
											}
										}
									}
								}
								if(Game.CELLSIDE==-1)
								{
									Game.firstcell = -1;
								}
							}
							else
							{
								if(Game.secondcell==-1)
								{
									int firstx = Game.firstcell % 10;
									int firsty = (Game.firstcell - firstx)/10;
									int diffx = firstx - boardx;
									int diffy = firsty - boardy;
									int secondside = -1;
									if(diffx<0)
									{
										diffx *= -1;
									}
									if(diffy<0)
									{
										diffy *= -1;
									}
									if(diffx==0)
									{
										if(diffy==1)
										{
											//adjacent square...
											for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
											{
												for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
												{
													int nid = Map.cellunit(x,y);
													if(nid!=Map.VACANT)
													{
														if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
														{
															secondside = Game.templates[Game.units[nid].templateid].faction;
															break;
														}
													}
												}
											}
										}
										else
										{
											if(diffy==2 && Game.ARCHERS>0)
											{
												for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
												{
													for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
													{
														int nid = Map.cellunit(x,y);
														if(nid!=Map.VACANT)
														{
															if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
															{
																secondside = Game.templates[Game.units[nid].templateid].faction;
																break;
															}
														}
													}
												}
											}
											else
											{
												Game.firstcell = -1;
												Game.CELLSIDE = -1;
												secondside = -1;
											}
										}
									}
									else
									{
										if(diffy==0)
										{
											if(diffx==1)
											{
												//adjacent square...
												for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
												{
													for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
													{
														int nid = Map.cellunit(x,y);
														if(nid!=Map.VACANT)
														{
															if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
															{
																secondside = Game.templates[Game.units[nid].templateid].faction;
																break;
															}
														}
													}
												}

											}
											else
											{
												if(diffx==2 && Game.ARCHERS>0)
												{
													for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
													{
														for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
														{
															int nid = Map.cellunit(x,y);
															if(nid!=Map.VACANT)
															{
																if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
																{
																	secondside = Game.templates[Game.units[nid].templateid].faction;
																	break;
																}
															}
														}
													}
												}
												else
												{
													Game.firstcell = -1;
													Game.CELLSIDE = -1;
													secondside = -1;
												}
											}
										}
										else
										{
											if(diffx==1 && diffy==1 && Game.ARCHERS>0)
											{
												for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
												{
													for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
													{
														int nid = Map.cellunit(x,y);
														if(nid!=Map.VACANT)
														{
															if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
															{
																secondside = Game.templates[Game.units[nid].templateid].faction;
																break;
															}
														}
													}
												}
											}
											else
											{
												Game.firstcell = -1;
												Game.CELLSIDE = -1;
												secondside = -1;
											}
										}
									}
									if((secondside==-1 && Game.CELLSIDE!=-1) || (secondside==Game.CELLSIDE && Game.CELLSIDE!=-1))
									{
										//we can move there....no need to change faction values....
										for(int x=firstx*160;x<firstx*160 + 160;x+=Map.GRIDW/4)
										{
											for(int y=firsty*Game.BOARDY;y<firsty*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
											{
												int nid = Map.cellunit(x,y);
												if(nid!=Map.VACANT)
												{
													if(Game.units[nid].boardx == firstx && Game.units[nid].boardy==firsty)
													{
														int offx = (nid % 4) * 32 + 10;
														int offy = (((nid - (nid % 4))/4) % 2) * 32 + 5;
														Game.gamemode = Game.MODE_MOVING;
														Game.movingtime = Game.MOVINGLENGTH;
														Game.units[nid].tmptattempts = 0;
														Game.units[nid].tmptx = boardx*160 + offx;
														Game.units[nid].tmpty = boardy*Game.BOARDY + offy;
														Game.units[nid].tx = boardx*160 + offx;
														Game.units[nid].ty = boardy*Game.BOARDY + offy;
														Game.units[nid].boardx = boardx;
														Game.units[nid].boardy = boardy;
														Game.units[nid].boardi =  boardx + boardy * 10;
														break;
													}
												}
											}
										}
										
									}
									if(secondside!=Game.CELLSIDE && secondside!=-1 && Game.CELLSIDE!=-1)
									{
										//we can fight them....
										Game.gamemode = Game.MODE_BATTLE;
										Game.battletime = Game.BATTLELENGTH;
										for(int x=firstx*160;x<firstx*160 + 160;x+=Map.GRIDW/4)
										{
											for(int y=firsty*Game.BOARDY;y<firsty*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
											{
												int nid = Map.cellunit(x,y);
												if(nid!=Map.VACANT)
												{
													if(Game.units[nid].boardx == firstx && Game.units[nid].boardy==firsty)
													{
														Game.units[nid].faction = Game.templates[Game.units[nid].templateid].faction;
														break;
													}
												}
											}
										}
										for(int x=boardx*160;x<boardx*160 + 160;x+=Map.GRIDW/4)
										{
											for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
											{
												int nid = Map.cellunit(x,y);
												if(nid!=Map.VACANT)
												{
													if(Game.units[nid].boardx == boardx && Game.units[nid].boardy==boardy)
													{
														Game.units[nid].faction = Game.templates[Game.units[nid].templateid].faction;
														if(Game.ARCHERS==1 && Game.units[nid].firebullet<=0)
														{
															Game.units[nid].walkspeed=0;
														}
														break;
													}
												}
											}
										}
									}
								}
							}
							break;
						case 2://BATTLE
							break;
						}
					}
					if(Game.gui[i].command.IndexOf("toggle")>=0)
					{
						if(Game.gui[i].triggerlink==Game.gui_charactersheet || Game.gui[i].triggerlink==Game.gui_founditem)
						{
							Game.gui[i].hidden = 1;
						}
						bool first = false;
						for(int tog=0;tog<Game.gui.Length;tog++)
						{
							if(Game.gui[tog].triggerlink!=(Game.gui[i].triggerlink) || Game.gui[tog].gamestate!=Game.gui[i].gamestate)
							{
								continue;
							}
							if(Game.gui[tog].link==("toggleon") || Game.gui[tog].link==("toggleoff"))
							{
								if(Game.gui[tog].link==("toggleon"))
								{
									Game.gui[tog].link="toggleoff";
									Gui.modal = 0;//21oct2021
									if(Game.gui[tog].command.IndexOf("buy")>=0 && first==false)
									{
										first = true;
										ResetSingleStore(Game.gui[tog].triggerlink);
									}
									if(Game.gui[tog].triggerlink==Game.gui_charactersheet)
									{
										Gui.ACTIVATED_CHARSHEET = false;
										if(Game.gui[tog].hidden==0)
										{
											Game.gui[tog].hidden = 1;
										}
									}
									if(Game.gui[tog].triggerlink==Game.gui_founditem)
									{
										Gui.ACTIVATED_FOUND = false;
										if(Game.gui[tog].hidden==0)
										{
											Game.gui[tog].hidden = 1;
										}
									}
								}
								else
								{
									Game.gui[tog].link="toggleon";
									Gui.modal = Game.gui[tog].triggerlink;//21oct2021
									if(Game.gui[tog].triggerlink==Game.gui_charactersheet)
									{
										Gui.ACTIVATED_CHARSHEET = false;
										if(Game.gui[tog].hidden==1)
										{
											Game.gui[tog].hidden = 0;
										}
									}
									if(Game.gui[tog].triggerlink==Game.gui_founditem)
									{
										Gui.ACTIVATED_FOUND = false;
										if(Game.gui[tog].hidden==1)
										{
											Game.gui[tog].hidden = 0;
										}
									}
								}
							}
						}
					}
					
					if(Game.gui[i].command.IndexOf("pause")>=0)
					{
						Game.togglepause = !Game.togglepause;
					}
					//end---------------------//20apr2021
					//start---------------//23sep2021
					if(Game.gui[i].command.IndexOf("attackaction")>=0)
					{
						//a tech button is pressed that perform an attack action....
						if(Game.gui[i].action==ACTION_NONE)//25sep2021
						{
							//default attack mode........
							Unit.SelectNearestTarget(null,Unit.GetPlayer(null));//24sep2021//25sep2021
						}
						else//25sep2021
						{
							Tech.ActivateAttack(null,Game.gui[i].action);
						}
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						continue;
					}
					pid = Unit.GetPlayer(null);
					if(pid!=-1)
					{
						if(Game.gui[i].command.IndexOf("drinkhealthpotion")>=0)
						{
							Tech.DrinkPotion(null, pid, "health");
							Game.gui[i].mouseover = false;
							Game.mlclick = false;
							continue;
						}
						if(Game.gui[i].command.IndexOf("drinkmanapotion")>=0)
						{
							Tech.DrinkPotion(null, pid, "mana");
							Game.gui[i].mouseover = false;
							Game.mlclick = false;
							continue;
						}
						if(Game.gui[i].command.IndexOf("drinkbothpotion")>=0)
						{
							Tech.DrinkPotion(null, pid, "both");
							Game.gui[i].mouseover = false;
							Game.mlclick = false;
							continue;
						}
					}
					if(Game.gui[i].command.IndexOf("buyitem")>=0)
					{
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
					}
					if(Game.gui[i].command.IndexOf("buybutton")>=0)
					{
						Gui.Purchase(i);
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
					}
					
					if(Game.gui[i].command.IndexOf("buycost")>=0)
					{
					}
					
					if(Game.gui[i].command.IndexOf("buy")>=0)//finally stop processing all 'buy' related buttons....put at end of buy block
					{
						Game.gui[i].mouseover = false;
						Game.mlclick = false;
						continue;
					}
					//end-----------------//23sep2021
					//start---------------//26mar2021
					if(Game.gui[i].action==ACTION_PLAY && Game.chosenmissionindex==-1)
					{
						Game.gui[i].mouseover = false;//27mar2021 bugfix?
						Game.mlclick = false;//27mar2021 bugfix?
						continue;
					}
					//start--------//12apr2021
					if(Game.gui[i].action>=ACTION_SPELL_START && Game.gui[i].action<=ACTION_SPELL_END)
					{
						if(Game.gui[i].spellactive==false)
						{
							Game.gui[i].mouseover = false;//27mar2021 bugfix?
							Game.mlclick = false;//27mar2021 bugfix?
							continue;
						}
					}
					//end----------//12apr2021
					if(Functions.abs(Game.fmx - Game.smx)>10 || Functions.abs(Game.fmy - Game.smy)>10) //don't want to accidentally push buttons when sliding the mouse around....TEST THIS BEFORE RELEASE
					{
						//potentially put minimap frame check in here
						Game.gui[i].mouseover = false;//27mar2021 bugfix?
						Game.mlclick = false;//27mar2021 bugfix?
						
						continue;
					}
					//bug fix with this....27mar2021...
					//bug fix involved setting 'selectingtime' only when the mouse was in a drag box mode.....
					if(Game.selectingtime>0 && (Game.gamestate!=Game.gui[i].nextgamestate || Game.gui[i].action==Gui.BACK))
					{
						Game.gui[i].mouseover = false;//27mar2021 bugfix?
						Game.mlclick = false;//27mar2021 bugfix?
						Game.minimapframe = Game.frame - 1000;//27mar2021
						Unit.deselect(game);//27mar2021
						continue;
					}
					//end-----------------//26mar2021
					//check what the action should be.....
					//if(Game.gui[i].triggerlink != LINK_SPAWNER_ICON)//2sep2021
					if(Game.gui[i].triggerlink != LINK_SPAWNER_ICON && Game.gui[i].triggerlink != LINK_TECH_ICON)//2sep2021
					{
						Game.mlclick = false;
					}
					Audios.playsound(Game.audios[Resources.CLICK],Game.FXVOLUME);
					if(Game.gui[i].nextgamestate!=0)
					{
					//{
						//screen to show
						if(Game.gamestate!=Game.gui[i].nextgamestate)
						{
							//Gui.ALTMODE=!Gui.ALTMODE;//18apr2021
							//start---------------------//20apr2021
							for(int tog=0;tog<Game.gui.Length;tog++)
							{
								if(Game.gui[tog].gamestate!=Game.gui[i].gamestate)
								{
									continue;
								}
								if(Game.gui[tog].link==("toggleon") || Game.gui[tog].link==("toggleoff"))
								{
									Game.gui[tog].link = "toggleoff";
									Gui.modal = 0;//21oct2021
								}
							}
							//end-----------------------//20apr2021
						}
						if(Game.gamestate!=Game.CAT_GAMESTATE_GAME)//11apr2021
						{
							Game.gamestate = Game.gui[i].nextgamestate;
						}
						//start----------//5apr2021
						
						for(int g=0;g<Game.gui.Length;g++)
						{
							if(Game.gui[g].gamestate==Game.gamestate && Game.gui[g].triggerlink == Gui.LINK_UNIT_DETAIL && Game.gamestate!=Game.CAT_GAMESTATE_GAME && Config.bestiarychk==false)
							{
								Config.bestiarychk = true;
								break;
							}
						}
						
						//end-----------//5apr2021
					//}
					//else
					//{
						//something game specific...
						if(Game.gui[i].action==Gui.BACK)
						{
							Gui.firstunit = 0;//12oct2021
							//start---------------------//20apr2021
							for(int tog=0;tog<Game.gui.Length;tog++)
							{
								if(Game.gui[tog].gamestate!=Game.gui[i].gamestate)
								{
									continue;
								}
								if(Game.gui[tog].link==("toggleon") || Game.gui[tog].link==("toggleoff"))
								{
									Game.gui[tog].link = "toggleoff";
									Gui.modal = 0;//21oct2021
								}
							}
							//end-----------------------//20apr2021
							if(Game.EDITOR)
							{
								
								return;
							}
							else
							{
									if(Game.gamestate==Game.CAMPAIGNSTATE && Game.CAMPAIGNSTATE!=0)
									{
										Game.campaignmode = 0;
										Game.oldcampaignmode = 0;
										CampaignMap.UnMarkAll();
										if(Game.gui[i].link==("campaignmodereset"))
										{
											Game.campaignmode = 0;
											if(CampaignMap.CampaignOver())
											{
												CampaignMap.ClearCampaign();
											}
										}
									}
									if(Game.gamestate==Game.CAT_GAMESTATE_GAME && Game.EDITOR==false)
									{
										Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
										if(Game.gameovertime==0){Game.gameovertime = 3;}//7oct2021 reduced massively.....
										Replay.EndRecord(game);
										if(Game.vsai<=0)
										{
											NetworkUDP.communicate(NetworkUDP.PRESSEXIT,null);
										}
									}
									else
									{
										Blood.clearall(game); //29oct2020
										Bullet.clearall(game); //29oct2020
										Gibbet.clearall(game);//2apr2021
										Game.map = new Map();
										Program.setupbackdrop(game);
										Game.demomode = true;
										Game.PLAYERFACTION = Unit.HUMAN;
									}
									
							}
						}
					}
					if(Game.gui[i].action!=0)
					{
						switch(Game.gui[i].action)
						{
							//start--------------//13mar2021
							case 5050:
								//set the language to the link value
								if(Game.gui[i].link!=(""))
								{
									Translation.SetLanguage(Game.gui[i].link);
									Game.restart = true; //not tested // bugger lots of weird crashes......
								}
							break;
							//end----------------//13mar2021
							case 87: //PREV CREATURE
							for(int j=0;j<Game.gui.Length;j++)
							{
								if(Game.gui[j].gamestate==Game.gamestate && Game.gui[j].triggerlink == Gui.LINK_UNIT_DETAIL)
								{
									Game.gui[j].index = Unit.gettemplate(game,Game.gui[j].index,-1,0);
									Game.gui[j].uindex = 0;
								}
							}
							break;
							case 89: //NEXT CREATURE
							for(int j=0;j<Game.gui.Length;j++)
							{
								if(Game.gui[j].gamestate==Game.gamestate && Game.gui[j].triggerlink == Gui.LINK_UNIT_DETAIL)
								{
									Game.gui[j].index = Unit.gettemplate(game,Game.gui[j].index,1,0);
									Game.gui[j].uindex = 0;
								}
							}
							break;
							case 124: //MAP EDITOR HELP
							break;
							case 1234: //ACTION_CONTINUE
							if(Game.gamestate==Game.CAT_GAMESTATE_DEBRIEF)
							{
								Game.gamestate = Game.CAT_GAMESTATE_GAME;
							}
							else//DEBRIEF2
							{
								Game.gamestate = Game.CAT_GAMESTATE_MENU;
							}
							break;
							case 123: //MAP EDITOR
							Program.resetgame(game);
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Game.map = new Map();
							Program.setupeditor(game);
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.EDITOR = true;
							//start----------//5apr2021
							//end-----------//5apr2021
							Game.EDITORPFACTION = 0;
							Game.EDITOREFACTION = 0;
							break;
							case 1111: //was 5
							Functions.saveseed(Functions.seed);
							Program.resetgame(game);
							break;
							case 5: //was 1
							Functions.saveseed(Functions.seed); //added from above
							Program.resetgame(game); //added from above
							Program.cleardeaths(game);
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Game.map = new Map();
							Functions.restoreseed();
							Program.resetlevel(game);
							Program.skirmishmission(game);
							Map.adddecor();//2mar2021
							Map.marktreepos(game);
							break;
							case 98987://ice blast
								pid = Unit.GetPlayer(null);
								if(pid!=-1)
								{
									if(Game.units[pid].mana>10)
									{
										Game.units[pid].mana-=10;
										if(Game.units[pid].mana<0)
										{
											Game.units[pid].mana = 0;
										}
										for(int uj=0;uj<Game.units.Length;uj++)
										{
											if(Game.units[uj].hp>0 && Game.units[uj].walkspeed>0 && Game.units[uj].faction!=Game.PLAYERFACTION)
											{
												if(Functions.abs(Game.units[pid].x - Game.units[uj].x)<Map.GRIDW*4 && Functions.abs(Game.units[pid].y - Game.units[pid].y)<Map.GRIDH*4)
												{
													int actualdamage = Game.units[pid].damage - Game.units[uj].armour;
													if(actualdamage>10)
													{
														actualdamage = 10;
													}
													if(actualdamage>0)
													{
														Game.units[uj].hp-=actualdamage;//Game.units[pid].damage;
													}
													Bullet.createbullet(game,Game.units[pid].x,Game.units[pid].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.GOODSPELL);
													Bullet.createbullet(game,Game.units[pid].x,Game.units[pid].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.GOODSPELL);
													Bullet.createbullet(game,Game.units[pid].x,Game.units[pid].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.GOODSPELL);
													if(Game.units[uj].hp<=0)//20mar2021
													{
														Game.units[pid].xp+=Game.units[uj].xpvalue;//29sep2021 bug fix
														Game.killed(null,uj);
														Game.templates[Game.units[pid].templateid].kills++;
														Game.units[pid].checkxp(null);
													}
													break;
												}
											}
										}
										
									}
								}
								break;
							case 98988://fireball
								pid = Unit.GetPlayer(null);
								if(pid!=-1)
								{
									if(Game.units[pid].mana>10)
									{
										Game.units[pid].mana-=10;
										if(Game.units[pid].mana<0)
										{
											Game.units[pid].mana = 0;
										}
										for(int uj=0;uj<Game.units.Length;uj++)
										{
											if(Game.units[uj].hp>0 && Game.units[uj].walkspeed>0 && Game.units[uj].faction!=Game.PLAYERFACTION)
											{
												if(Functions.abs(Game.units[pid].x - Game.units[uj].x)<Map.GRIDW*4 && Functions.abs(Game.units[pid].y - Game.units[pid].y)<Map.GRIDH*4)
												{
													int actualdamage = Game.units[pid].damage + 3;
													if(actualdamage>7)
													{
														actualdamage = 7;
													}
													if(actualdamage<2)
													{
														actualdamage = 2;
													}
													if(actualdamage>0)
													{
														Game.units[uj].hp-=actualdamage;//Game.units[pid].damage;
													}
													Bullet.createbullet(game,Game.units[pid].x,Game.units[pid].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.REDSPELL);
													Bullet.createbullet(game,Game.units[pid].x,Game.units[pid].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.REDSPELL);
													Bullet.createbullet(game,Game.units[pid].x,Game.units[pid].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.REDSPELL);
													if(Game.units[uj].hp<=0)//20mar2021
													{
														Game.units[pid].xp+=Game.units[uj].xpvalue;//29sep2021 bugfix
														Game.killed(null,uj);
														Game.templates[Game.units[pid].templateid].kills++;
														Game.units[pid].checkxp(null);
													}
													break;
												}
											}
										}
										
									}
								}
								break;
							case 98984://26sep2021//shield 2
								pid = Unit.GetPlayer(null);
								if(pid!=-1)
								{
									if(Game.units[pid].mana>20)
									{
										Game.units[pid].mana-=20;
										Game.units[pid].bladebarrier = 35;
										if(Game.units[pid].mana<0)
										{
											Game.units[pid].mana = 0;
										}
									}	
								}	
								break;
							case 98985://26sep2021//delay 2
								pid = Unit.GetPlayer(null);
								if(pid!=-1)
								{
									if(Game.units[pid].mana>75)
									{
										Game.units[pid].mana-=75;
										Game.units[pid].charmperson = 50;
										if(Game.units[pid].mana<0)
										{
											Game.units[pid].mana = 0;
										}
									}
								}
								break;
							case 98986://26sep2021//weapon 2
								pid = Unit.GetPlayer(null);
								if(pid!=-1)
								{
									if(Game.units[pid].mana>75)
									{
										Game.units[pid].mana-=75;
										for(int uj=0;uj<Game.units.Length;uj++)
										{
											if(Game.units[uj].hp>0 && Game.units[uj].walkspeed>0 && Game.units[uj].faction!=Game.PLAYERFACTION)
											{
												if(Functions.abs(Game.units[pid].x - Game.units[uj].x)<Map.GRIDW*4 && Functions.abs(Game.units[pid].y - Game.units[pid].y)<Map.GRIDH*4)
												{
													Game.units[uj].hp/=2;
													Bullet.createbullet(game,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.GREENSPELL);
													Bullet.createbullet(game,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy - Game.RESOLUTIONY/2,Game.units[uj].x,Game.units[uj].y+Game.units[uj].offy,Bullet.GREENSPELL);
													if(Game.units[uj].hp<=0)//20mar2021
													{
														Game.units[pid].xp+=Game.units[uj].xpvalue;//29sep2021 bug fix
														Game.killed(null,uj);
														Game.templates[Game.units[pid].templateid].kills++;
														Game.units[pid].checkxp(null);
													}
													break;
												}
											}
										}
										if(Game.units[pid].mana<0)
										{
											Game.units[pid].mana = 0;
										}
									}
								}
								break;
							case 98983://26sep2021//cause fear
							pid = Unit.GetPlayer(null);
							if(pid!=-1)
							{
								if(Game.units[pid].mana>25)
								{
									Game.units[pid].mana-=25;
									Game.units[pid].holyaura = 35;
									if(Game.units[pid].mana<0)
									{
										Game.units[pid].mana = 0;
									}
								}
							}
							break;
							case 98982: //26sep2021 //force shield
							pid = Unit.GetPlayer(null);
							if(pid!=-1)
							{
								if(Game.units[pid].mana>10)
								{
									Game.units[pid].mana-=10;
									Game.units[pid].forceshield = 25;
									if(Game.units[pid].mana<0)
									{
										Game.units[pid].mana = 0;
									}
								}
							}
							break;
							case 98981: //26sep2021 //lightning...bugger hard coded bullshit///
							pid = Unit.GetPlayer(null);
							if(pid!=-1)
							{
								if(Game.units[pid].mana>=50)
								{
									int storms = 3 * 5;
									for(int x=Game.units[pid].x - Map.GRIDW * 4;x<=Game.units[pid].x + Map.GRIDW * 4;x+=Map.GRIDW)
									{
										for(int y=Game.units[pid].y - Map.GRIDH * 4;y<=Game.units[pid].y + Map.GRIDH * 4;y+=Map.GRIDH)
										{
											int nid = Map.cellunit(x,y);
											if(nid!=-1)
											{
												if(Game.units[nid].spelldefense>0)//01apr2021
												{
													continue;
												}
												if(Game.units[nid].faction!=Game.units[pid].faction && Game.units[nid].hp>0 && Game.units[nid].walkspeed>0 && Game.units[nid].faction!=Unit.NULLFACTION)
												{
													
													
														//do damage.....
														storms--;
														Game.units[nid].hp-=3 * 5;
														if(Game.units[nid].onscreen)
														{
															Functions.saveseed();//25apr2021
															if(Functions.rand(0,100)<25)
															{
																Game.units[nid].playvictimhitsound(game,nid);
															}
															Functions.restoreseed();//25apr2021
														}
														//if(Game.units[firetargeti].hp<=0) //20mar2021
														Functions.saveseed();//11apr2021
														int qqq = Functions.rand(0,1000);
														if(storms==3*5 - 1 || qqq<200)//11apr2021 qqq
														{
															Functions.restoreseed();//11apr2021
															Bullet.createbullet(null,Game.units[pid].x,Game.units[pid].y+Game.units[nid].offy,Game.units[nid].x,Game.units[nid].y+Game.units[nid].offy,Bullet.LIGHTNINGSPELL);
															Game.units[pid].mana-=50;
															if(Game.units[pid].mana<=0)
															{
																Game.units[pid].mana=0;
																storms = 0;
															}
														}
														else
														{
															Functions.restoreseed();//11apr2021
														}
														if(Game.units[nid].hp<=0)//20mar2021
														{
															Game.units[pid].xp+=Game.units[nid].xpvalue;//29sep2021 bugfix
															Game.killed(null,nid);
															Game.templates[Game.units[pid].templateid].kills++;
															Game.units[pid].checkxp(null);
														}						
													
												}
											}
											if(storms<=0)
											{
												break;
											}
										}
										if(storms<=0)
										{
											break;
										}
									}
								}
							}
							break;
							case 10101://previous color of clothing
								for(int tid=0;tid<Game.templates.Length;tid++)
								{
									if(Game.templates[tid].name==("Hero01"))
									{
										//Unit.NewColor(null,tid,1);
										break;
									}
								}
							break;
							case 10102://next color of clothing
								for(int tid=0;tid<Game.templates.Length;tid++)
								{
									if(Game.templates[tid].name==("Hero01"))
									{
										//Unit.NewColor(null,tid,-1);
										break;
									}
								}
							break;
							case 70000:
								Game.OldEnemyArmy = Game.EnemyArmy;
								Game.EnemyArmy = "Red";
								//Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
								//Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
								break;
							case 70001:
								Game.OldEnemyArmy = Game.EnemyArmy;
								Game.EnemyArmy = "Skeleton";
								//Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
								break;
							case 70002:
								Game.OldEnemyArmy = Game.EnemyArmy;
								Game.EnemyArmy = "Realm";
								//Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
								break;
							case 70003:
								Game.OldEnemyArmy = Game.EnemyArmy;
								Game.EnemyArmy = "Evil";
								//Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
								break;
							case 80001: //Battle Speed//16oct2021
								Game.battlespeed = 10;//16oct2021
								break;
							case 70004: //Next Friend
								Game.FriendIndex++;
								Game.FriendIndex%=Game.MaxArmies;
								if(Game.FriendIndex==Game.EnemyIndex)
								{
									Game.FriendIndex++;
								}
								Game.FriendIndex%=Game.MaxArmies;
								Game.OldFriendArmy = Game.FriendArmy;
								switch(Game.FriendIndex)
								{
								case 0:
									Game.FriendArmy = "Red";
									break;
								case 1:
									Game.FriendArmy = "Blue";
									break;
								case 2: 
									Game.FriendArmy = "Skeleton";
									break;
								case 3:
									Game.FriendArmy = "Realm";
									break;
								case 4:
									Game.FriendArmy = "Evil";
									break;
								case 5:
									Game.FriendArmy = "Fiend";
									break;
								}
								Game.PlayerArmy = Game.FriendArmy;//8oct2021
								Game.PlayerIndex = Game.FriendIndex;//8oct2021
								LocalStorage.setitem("PlayerArmy", Game.PlayerArmy);
								LocalStorage.setitem("PlayerIndex",""+Game.PlayerIndex);
								//Resources.//LoadNewArmy(Game.OldFriendArmy, Game.FriendArmy);
								for(int t=0;t<Game.templates.Length;t++)
								{
									if(Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
									{
										Game.templates[t].faction = 6;
									}
									if(Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
									{
										Game.templates[t].faction = 5;
									}
								}
								for(int g=0;g<Game.gui.Length;g++)
								{
									if(Game.gui[g].link==("friend"))
									{
										Game.gui[g].index = Game.FriendIndex;
									}
								}
								Game.campaignmode = 1;
								CampaignMap.ClearCampaign();
								Game.campaignmode = 0;
								break;
							case 70005: //Next Enemy
								Game.EnemyIndex++;
								Game.EnemyIndex%=Game.MaxArmies;
								if(Game.EnemyIndex==Game.FriendIndex)
								{
									Game.EnemyIndex++;
								}
								Game.EnemyIndex%=Game.MaxArmies;
								Game.OldEnemyArmy = Game.EnemyArmy;
								switch(Game.EnemyIndex)
								{
								case 0:
									Game.EnemyArmy = "Red";
									break;
								case 1:
									Game.EnemyArmy = "Blue";
									break;
								case 2: 
									Game.EnemyArmy = "Skeleton";
									break;
								case 3:
									Game.EnemyArmy = "Realm";
									break;
								case 4:
									Game.EnemyArmy = "Evil";
									break;
								case 5:
									Game.EnemyArmy = "Fiend";
									break;
								}
								//Resources.//LoadNewArmy(Game.OldEnemyArmy, Game.EnemyArmy);
								for(int t=0;t<Game.templates.Length;t++)
								{
									if(Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
									{
										Game.templates[t].faction = 6;
									}
									if(Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
									{
										Game.templates[t].faction = 5;
									}
								}
								for(int g=0;g<Game.gui.Length;g++)
								{
									if(Game.gui[g].link==("enemy"))
									{
										Game.gui[g].index = Game.EnemyIndex;
									}
								}
								break;
							case -99999:
								Program.quit = true;
								break;
							case 70098:
								Game.multiplayerip = "";
								NetworkUDP.TryMultiplayer();
								break;
							case 70099:
								Game.chosenmissionindex = 0;
								Game.campaignmode = 0;//8oct2021
								if(Game.chosenmissionindex!=-1)
								{
									Map.levelseed = Functions.seed;//2apr2021
									Program.resetgame(game);//2apr2021
									Game.PLAYERFACTION = Unit.HUMAN;
									Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
									Game.gamestate = Game.CAT_GAMESTATE_GAME;
									Program.cleardeaths(game);
									Game.map = new Map();
									Program.setupmission(game,Game.chosenmissionindex,2);
									Map.adddecor();//2mar2021
									Map.marktreepos(game);
									Map.levelseed2 = Functions.seed;//2apr2021
									//remove all units....
									for(int nid=0;nid<Game.units.Length;nid++)
									{
										Game.units[nid].hp = 0;
										Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
										Game.units[nid].reset(null,nid);
									}
									//Map.removeallbones();
									Game.gamemode = 0;//DEPLOY
									Game.RESOLVE = 0;
									Game.PLAYERFACTION = 6;//7oct2021
									Game.SKIRMISHENEMYFACTION = 5;//7oct2021
									Game.numelements = CampaignMap.NumElements(-1);
									Game.numenemyelements = CampaignMap.NumElements(-1);
									Game.vsai = 1 + Functions.rand(0,1000) % Unit.NUMAISCRIPTS;
									Game.vsai = Unit.GetSecondMostPowerfulAi();
								}	
								break;
								//start------------//18oct2021
							case 80011:
								Game.spellcast = 3;
								Spells.SpellAction(Game.LocalPlayerIndex,0);
								//toggleoff the spell screen
								ToggleOff(Game.gui[i].triggerlink);
								Game.togglepause = false;
								
							break;
							case 80012:
								Game.spellcast = 3;
								Spells.SpellAction(Game.LocalPlayerIndex,1);
								//toggleoff the spell screen
								ToggleOff(Game.gui[i].triggerlink);
								Game.togglepause = false;
							break;
							case 80013:
								Game.spellcast = 3;
								Spells.SpellAction(Game.LocalPlayerIndex,2);
								//toggleoff the spell screen
								ToggleOff(Game.gui[i].triggerlink);
								Game.togglepause = false;
							break;
							//end-------------//18oct2021
							//start-----------//20oct2021
							case 80400:
								Game.difficulty++;
								Game.difficulty%=3;
								switch(Game.difficulty)
								{
									case 0:
									Game.gui[i].title = "Normal";
									Game.newtoast("Normal Difficulty Setting");
									break;
									case 1:
									Game.gui[i].title = "Easiest";
									Game.newtoast("Easiest Difficulty Setting");
									break;
									case 2:
									Game.gui[i].title = "Easy";
									Game.newtoast("Easy Difficulty Setting");
									break;
								}
							break;
							//end-------------//20oct2021
							//start-----------//21oct2021
							case 80501://Research.GUIPATH0
								//if we pressed it - it must be available to us......
								Research.BeginResearch(Game.PlayerIndex,Research.PATH0);
							break;
							case 80502://Research.GUIPATH1
								//if we pressed it - it must be available to us......
								Research.BeginResearch(Game.PlayerIndex,Research.PATH1);
							break;
							case 80503://Research.GUIPATH2
								//if we pressed it - it must be available to us......
								Research.BeginResearch(Game.PlayerIndex,Research.PATH2);
							break;
							//end-------------//21oct2021
							case 20:
							Game.chosenmissionindex = 0;
							Game.campaignmode = 0;//8oct2021
							if(Game.chosenmissionindex!=-1)
							{
								Map.levelseed = Functions.seed;//2apr2021
								Program.resetgame(game);//2apr2021
								Game.PLAYERFACTION = Unit.HUMAN;
								Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
								Game.gamestate = Game.CAT_GAMESTATE_GAME;
								Program.cleardeaths(game);
								Game.map = new Map();
								if(NetworkUDP.isserver)
								{
									int[] armies = new int[2];
									armies[0] = Game.FriendIndex;
									armies[1] = Game.EnemyIndex;
									CampaignMap.seed = CampaignMap.rand() % 256;
									NetworkUDP.communicate(NetworkUDP.PLAY,armies);
								}
								Program.setupmission(game,Game.chosenmissionindex,2);
								if(!NetworkUDP.isserver)//20oct2021
								{
									Beacon.enabled = 0;	
								}
								Map.adddecor();//2mar2021
								Map.marktreepos(game);
								Map.levelseed2 = Functions.seed;//2apr2021
								//remove all units....
								for(int nid=0;nid<Game.units.Length;nid++)
								{
									Game.units[nid].hp = 0;
									Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
									Game.units[nid].reset(null,nid);
								}
								//Map.removeallbones();
								Game.gamemode = 0;//DEPLOY
								Game.numfhero = 0;//13oct2021
								Game.numehero = 0;//13oct2021
								Game.RESOLVE = 0;
								Game.PLAYERFACTION = 6;//7oct2021
								Game.SKIRMISHENEMYFACTION = 5;//7oct2021
								Game.vsai = 0;
							}
							break;
							case 4:
							Map.generate(game);
							Functions.saveseed(Functions.seed);
							Program.cleardeaths(game);
							break;
							case 2:
							Game.PLAYERFACTION = Unit.UNDEAD;
							Game.SKIRMISHENEMYFACTION = Unit.HUMAN;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Game.map = new Map();
							Functions.restoreseed();
							Program.resetlevel(game);
							Program.cleardeaths(game);
							Program.skirmishmission(game);
							Map.adddecor();//2mar2021
							Map.marktreepos(game);
							break;
							case 120: //fullscreen/windowed//17apr2021
								if(Game.FULLSCREEN>0)
								{
									Game.FULLSCREEN = 0;
									LocalStorage.setitem("fullscreen","0");
								}
								else
								{
									Game.FULLSCREEN = 1;
									LocalStorage.setitem("fullscreen","1");
								}
								Game.restart = true;
							break;
							case 121: //hi res/low res sprites//17apr2021
								Game.debugcount++;
								if(Game.debugcount==10)
								{
									Game.debugcheat=true;
									Audios.playsound(Game.audios[Game.snd_levelup], Game.FXVOLUME);
								}
								if(Config.hires>0)
								{
									Config.hires = 0;
									LocalStorage.setitem("hires","0");
								}
								else
								{
									Config.hires = 1;
									LocalStorage.setitem("hires","1");
								}
							break;
							case 12:
								if(Game.FXVOLUME>0)
								{
									Game.FXVOLUME = 0;
									LocalStorage.setitem("sfx","off"); //12mar2021
								}
								else
								{
									Game.FXVOLUME = Game.oFXVOLUME;
									LocalStorage.setitem("sfx","on"); //12mar2021
								}
							break;
							case 13:
								if(Game.MUSICVOLUME>0)
								{
									Game.MUSICVOLUME = 0;
									SDL_mixer.Mix_PauseMusic();
									Map.menumusicplaying = 0;
									LocalStorage.setitem("music","off");
									Game.musicdirty = true;
								}
								else
								{
									Game.MUSICVOLUME = Game.oMUSICVOLUME;
									Map.menumusicplaying = -1;
									LocalStorage.setitem("music","on");
									//start---------//25apr2021
									Game.musicdirty = true;
									if(Game.gamestate==Game.CAT_GAMESTATE_GAME)
									{
										SDL_mixer.Mix_ResumeMusic();
									}
									//end-----------//25apr2021
								}
							break;
							case 10: 
							Map.levelseed = Functions.seed; //2apr2021
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Game.map = new Map();
							Program.cleardeaths(game);
							Program.setupmission(game,Game.gui[i].mission,0);
							Map.adddecor();//2mar2021
							Map.marktreepos(game);
							Map.levelseed2 = Functions.seed; //2apr2021
							break;
							case 11:
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Program.cleardeaths(game);							
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Game.map = new Map();
							//Program.setupmission(game,-999);
							for(int t=0;t<Game.missions.Length;t++)
							{
								if(Game.missions[t].istutorial==1)
								{
									Program.setupmission(game,t,999);
									Map.adddecor();//2mar2021
									Map.marktreepos(game);
									break;
								}
							}
							break;
						}
						//start-------------//28mar2021
						if(Game.SPELLCASTERSELECTED!=-1)
						{
							if(Game.gui[i].action>=ACTION_SPELL_START && Game.gui[i].action<=ACTION_SPELL_END && Game.SPELLCASTERLEVEL!=99 && Game.gui[i].spellactive==true)
							{
								Unit.SpellCast(game,Game.gui[i].action,Game.PLAYERFACTION);
							}
						}
						//end---------------//28mar2021
						//start-------------//9mar2021
						//special set of ACTIONS......
						if(Game.frame % 60==27 && Game.gui[i].action>=ACTION_FORMATIONSTART && Game.gui[i].action<=ACTION_FORMATIONEND)
						{
							bool foundu = false;
							//for(int u=0;u<Game.units.Length;u++)//26mar2021
							for(int u=0;u<=Unit.MAXINDEX;u++)//26mar2021
							{
								if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0 && Game.units[u].walkspeed>0 && Game.units[u].selected!=Unit.SELECTIONNONE)
								{
									foundu = true;
									break;
								}
							}
							if(foundu && Game.EDITOR==false)
							{
								Game.gui[i].hidden = 0;
							}
							else
							{
								Game.gui[i].hidden = 1;
								Game.gui[i].mouseover = false;//24apr2021 to correct selection bug with spawners
							}
						}
						//if(Game.gui[i].hidden==0)//10mar2021
						if(Game.NONSPAWNERSELECTED==true && Game.SPAWNERSELECTED==false)
						{
							if(Game.gui[i].action==ACTION_LINEH)
							{
								Unit.Formation(game,ACTION_LINEH);
							}
							if(Game.gui[i].action==ACTION_LINEV)
							{
								Unit.Formation(game,ACTION_LINEV);
							}
							if(Game.gui[i].action==ACTION_OPEN)
							{
								Unit.Formation(game,ACTION_OPEN);
							}
							if(Game.gui[i].action==ACTION_CLOSE)
							{
								Unit.Formation(game,ACTION_CLOSE);
							}
							if(Game.gui[i].action==ACTION_RALLY)
							{
								Unit.Formation(game,ACTION_RALLY);
							}
							if(Game.gui[i].action==ACTION_DEFEND)
							{
								Unit.Formation(game,ACTION_DEFEND);
							}
							if(Game.gui[i].action==ACTION_ENGAGE)
							{
								Unit.Formation(game,ACTION_ENGAGE);
							}
						}
						//end---------------//9mar2021
					}
				}
			}
		}		
	}

///////////////////Method Definition///////////////
	public static void drawall(Game game)
	{
		//draw all gui stuff
		//start-----//9sep2021
		int pid = 0;
		bool drawnxonce = false;
		bool drawnbattleicons = false;//16oct2021
		bool drawnhatch = false;//21oct2021
		Gui.ochecksum = Gui.checksum;
		Gui.checksum = 0;
		int framecheck = 60;
		if(Config.RUNNINGSPEED>90)
		{
			framecheck = 80;
		}
		if(Config.RUNNINGSPEED>110)
		{
			framecheck = 90;
		}
		framecheck/=Config.FASTFRAMECHECK;//14sep2021
		//end-------//9sep2021
		int spellframe = 0;
		uint color = 0;
		int uid = -1;
		int toffy = 15;
		int toffx = 25;
		String[] uline = new String[4];
		int xcount = 0; //11mar2021
		int ycount = 0; //11mar2021
		int icount = 0; //11mar2021
		for(int i=0;i<Game.gui.Length;i++)
		{
			if(Game.gui[i].nextgamestate==Game.CAT_GAMESTATE_REPLAY && (Config.ALLOWREPLAY==false || Config.NOREPLAY>0))//2apr2021
			{
				continue;
			}
			//start--------------------//2apr2021
			if(Replay.PLAYBACK)
			{
				if(Game.gui[i].action==Gui.BACK)
				{
					continue;
				}
			}
			//end----------------------//2apr2021
			//start--------------------//2sep2021
			if(Game.gui[i].triggerlink == LINK_TECH_ICON && Game.EDITOR == false && Game.gui[i].gamestate==Game.oldgamestate && Tech.TECHUNITSELECTED==true && Config.USETECH == true)
			{
				Game.gui[i].mouseover = false;
				Game.gui[i].hidden = 1;
				if(Tech.TECHUNITIDSELECTED!=-1)
				{
					if(Game.units[Tech.TECHUNITIDSELECTED].techguilinkid == Game.gui[i].index)
					{
						int techid = -1;
						//tcount = 0;
						xcount = 0;
						ycount = 0;
						icount = 0;
						for(int t=0;t<Game.techs.Length;t++)
						{
							if(Game.techs[t].guilinkid==Game.gui[i].index && Game.techs[t].researched<=0)
							{
								//this is a tech we want to show the icon for to choose to research.....
								Game.gui[i].hidden = 0;
								RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].image);
								Gui.checksum++;
								if(Game.mx > Game.gui[i].x + xcount && Game.mx < Game.gui[i].x + Game.gui[i].w + xcount && Game.my > Game.gui[i].y + ycount && Game.my < Game.gui[i].y + Game.gui[i].h + ycount)
								{	
									Gui.checksum++;
									RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + xcount + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,1,false,0.25f,Game.gui[i].image);							
									//Game.gui[i].tooltip = Game.templates[tid].name; //13mar2021
									Game.gui[i].tooltip = Game.techs[t].tooltip;
									Gui.checksum++;
									RenderList.drawtext(game,Game.gui[i].x+ 3 * Game.gui[i].w / 4 + xcount,ycount + Game.gui[i].y + Game.gui[i].h / 2,Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);						
									Game.gui[i].mouseover = true;
									//WARNING - updating in DRAWING SECTION!
									if(Game.mlclick==true && Game.togglepause==false)
									{
										techid = t;
										if(icount>0)//15mar2021
										{
											Audios.playsound(Game.audios[Resources.CLICK],Game.FXVOLUME);//15mar2021
										}
									}
								}
								//draw the tech sprite
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.techs[t].img].texture,Game.gui[i].x + Game.gui[i].w/2 + xcount,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.7f,0.7f,Game.techs[t].imgframe,0,false,1f,Game.techs[t].img);
								if(Game.techs[t].timeleft>0)
								{
									Gui.checksum++;
									RenderList.drawrect(game,Game.gui[i].x + Game.gui[i].w/4 + xcount,ycount + Game.gui[i].y + Game.gui[i].h,Tech.PercentComplete(game,t),2,RenderList.getrgb(32,255,255),0);
									Gui.checksum++;
									RenderList.drawunfilledrect(game,Game.gui[i].x + Game.gui[i].w/4 + xcount,ycount + Game.gui[i].y + Game.gui[i].h,100,4,RenderList.getrgb(180,180,200),0);
								}
								//
								//tcount+=Game.gui[i].h;
								icount++;
								if(Game.gui[i].horizontal>0)
								{
									xcount+=Game.gui[i].w;
								}
								if(Game.gui[i].vertical>0)
								{
									ycount+=Game.gui[i].h;
								}
								if((icount >= Game.gui[i].horizontal && Game.gui[i].horizontal > 0) || (icount >= Game.gui[i].vertical && Game.gui[i].vertical > 0))
								{
									if(Game.gui[i].horizontal>0)
									{
										xcount = 0;
										ycount += Game.gui[i].h;
									}
									else
									{
										ycount = 0;
										xcount += Game.gui[i].w;
									}
									icount = 0;
								}
							}
						}
						if(techid!=-1)
						{
							//only allow 1 research at a time.....
							Tech.StartResearch(game,techid,Game.PLAYERFACTION);
						}
					}
				}
			}
			//end----------------------//2sep2021
			//start-------------//10mar2021
			//if(Game.gui[i].triggerlink == LINK_SPAWNER_ICON && Game.EDITOR==false && Game.gui[i].gamestate==Game.gamestate && Game.SPAWNERSELECTED==true && Game.NONSPAWNERSELECTED==false)//18apr2021
			if(Game.gui[i].triggerlink == LINK_SPAWNER_ICON && Game.EDITOR==false && Game.gui[i].gamestate==Game.oldgamestate && Game.SPAWNERSELECTED==true && Game.NONSPAWNERSELECTED==false)//18apr2021
			{
				Game.gui[i].mouseover = false;
				bool doneonce = false;
				int ttid = -1;
				Game.gui[i].hidden = 1;
				//for(int u=0;u<Game.units.Length;u++)//26mar2021
				icount = 0;//2sep2021
				for(int u=0;u<=Unit.MAXINDEX;u++)//26mar2021
				{
					if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0 && Game.units[u].walkspeed==0 && Game.units[u].selected!=Unit.SELECTIONNONE && Game.units[u].spawner!="")
					{
						if(!doneonce)
						{
							color = RenderList.getrgb(240,240,240);
							//tcount = 0;
							xcount = 0;
							ycount = 0;
							Game.gui[i].hidden = 0;
							for(int tid=0;tid<Game.templates.Length;tid++)
							{
								if(!Unit.SpawnerCanBuild(game,Game.units[u].spawnerconstraint,tid))//9sep2021
								{
									continue;
								}
								if(Game.templates[tid].faction==Game.PLAYERFACTION && (Game.templates[tid].bossmonster<=0 && Game.templates[tid].planar<=0 && Game.templates[tid].leader<=0) && Game.templates[tid].walkspeed>0)
								{
									if(Game.templates[tid].unresearchedbydefault>0)//2sep2021
									{
										if(!Tech.IsUnitEnabled(game,tid)) //2sep2021
										{
											continue;
										}
									}
									//draw this gui icon
									Gui.checksum++;
									RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].image);							
									if(Game.mx > Game.gui[i].x + xcount && Game.mx < Game.gui[i].x + Game.gui[i].w + xcount && Game.my > Game.gui[i].y + ycount && Game.my < Game.gui[i].y + Game.gui[i].h + ycount)
									{	
										Gui.checksum++;
										RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + xcount + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,1,false,0.25f,Game.gui[i].image);							
										//Game.gui[i].tooltip = Game.templates[tid].name; //13mar2021
										Game.gui[i].tooltip = Game.templates[tid].dname(); //13mar2021
										Gui.checksum++;
										RenderList.drawtext(game,Game.gui[i].x+ 3 * Game.gui[i].w / 4 + xcount,ycount + Game.gui[i].y + Game.gui[i].h / 2,Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);						
										Game.gui[i].mouseover = true;
										//WARNING - updating in DRAWING SECTION!
										//10mar2021 Warning - updating in DRAWING SECTION
										//if(Game.mlclick==true)// && ttid==-1)//22mar2021
										if(Game.mlclick==true && Game.togglepause==false)// && ttid==-1)//22mar2021
										{
											ttid = tid;
											if(icount>0)//15mar2021
											{
												Audios.playsound(Game.audios[Resources.CLICK],Game.FXVOLUME);//15mar2021
											}
										}
									}
									//draw the sprite idle frame start
									//9apr2021 hires stuff
									if(Game.templates[tid].cathires!=-1)
									{
										//half scale, double resolution....
										Gui.checksum++;
										RenderList.drawimage(game,Game.images[Game.templates[tid].cathires].texture,Game.gui[i].x + Game.gui[i].w/2 + xcount,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.35f,0.35f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cathires);
									}
									else
									{
										Gui.checksum++;
										RenderList.drawimage(game,Game.images[Game.templates[tid].cat].texture,Game.gui[i].x + Game.gui[i].w/2 + xcount,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.7f,0.7f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cat);
									}
									//
									//tcount+=Game.gui[i].h;
									icount++;
									if(Game.gui[i].horizontal>0)
									{
										xcount+=Game.gui[i].w;
									}
									if(Game.gui[i].vertical>0)
									{
										ycount+=Game.gui[i].h;
									}
									if((icount >= Game.gui[i].horizontal && Game.gui[i].horizontal > 0) || (icount >= Game.gui[i].vertical && Game.gui[i].vertical > 0))
									{
										if(Game.gui[i].horizontal>0)
										{
											xcount = 0;
											ycount += Game.gui[i].h;
										}
										else
										{
											ycount = 0;
											xcount += Game.gui[i].w;
										}
										icount = 0;
									}
								}
							}	
						}							
						doneonce = true;
						if(ttid!=-1)
						{
							String ospawner = Game.units[u].spawner;//9sep2021
							Game.units[u].spawner = Game.templates[ttid].name;
							Game.units[u].displayspawner = Game.templates[ttid].dname();//13mar2021
							Game.units[u].spawnertime = Unit.CalculateSpawnerTime(game,ttid);
							if(Game.units[u].framesleft==0 || ospawner!=Game.units[u].spawner)//9sep2021
							{
								Game.units[u].framesleft = framecheck * Game.units[u].spawnertime;//9sep2021
							}
							if(Game.units[u].spawnercount<10)
							{
								Game.units[u].spawnercount++;
							}
							if(Game.units[u].spawnercount<=0)
							{
								Game.units[u].spawnercount=1;
							}
						}
					}
				}
				break;
			}
			//end---------------//10mar2021
		}
		Game.showingselectedicons = false;//22mar2021
		for(int i=0;i<Game.gui.Length;i++)
		{
			//start--------------------//2apr2021
			if(Replay.PLAYBACK)
			{
				if(Game.gui[i].action==Gui.BACK)
				{
					continue;
				}
			}
			//end----------------------//2apr2021
			if(Game.gui[i].nextgamestate==Game.CAT_GAMESTATE_REPLAY && (Config.ALLOWREPLAY==false || Config.NOREPLAY>0))//2apr2021
			{
				continue;
			}
			spellframe = 0; //0 or 1 1 = greyed out.....0 = coloured....
			if(Game.gui[i].triggerlink == LINK_SPAWNER_ICON) //10mar2021
			{
				continue;
			}
			if(Game.gui[i].triggerlink == LINK_TECH_ICON)//2sep2021
			{
				continue;
			}
			if(Game.gui[i].action>=ACTION_FORMATIONSTART && Game.gui[i].action<=ACTION_FORMATIONEND)
			{
				if(Game.SPAWNERSELECTED==true || Game.NONSPAWNERSELECTED==false)
				{
					Game.gui[i].mouseover = false;//24apr2021
					continue;
				}
				if(Tech.TECHUNITSELECTED) //2sep2021
				{
					if(Tech.TECHUNITIDSELECTED!=-1)
					{
						if(Game.units[Tech.TECHUNITIDSELECTED].walkspeed<=0)
						{
							Game.gui[i].mouseover = false;
							continue;
						}
					}
				}
			}
			//start---------------//28mar2021
			if(Game.gui[i].action>=ACTION_SPELL_START && Game.gui[i].action<=ACTION_SPELL_END)
			{
				if(Game.SPELLCASTERSELECTED==-1 || Game.EDITOR==true)
				{
					Game.gui[i].mouseover = false;//4apr2021
					Game.gui[i].spellactive = false;//12apr2021
					continue;
				}
				if(Game.SPELLCASTERSELECTED!=-1)
				{
					int u = Game.SPELLCASTERSELECTED;
					Game.gui[i].spellactive = false;//12apr2021
					if(Game.units[u].hp>0 && Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].spellcaster>0 && Game.units[u].selected!=Unit.SELECTIONNONE)
					{
						bool foundm = false;
						for(int m=0;m<Game.units[u].magicarray.Length;m++)
						{
							if(Game.units[u].magicarray[m]==Game.gui[i].action)
							{
								foundm = true;
								spellframe = 0; //coloured
								Game.gui[i].spellactive = true;//12apr2021
								//start-----//3may2021
								if(Game.units[u].magicarray[m]==Unit.MAGICRELEASE)
								{
									//check units are inside
									if(!Unit.TransportingUnits(game,u))
									{
										foundm = true;
										spellframe = 1;
										Game.gui[i].spellactive = true;
									}
								}
								if(Game.units[u].magicarray[m]==Unit.MAGICTRANSFORM)
								{
									//check requirements....
									if(!Unit.CanTransform(game,u))
									{
										foundm = true;
										spellframe = 1; //greyed out
										Game.gui[i].spellactive = true;//12apr2021
									}
								}
								//end-------//3may2021
								break;
							}
							if(Game.units[u].magicarray[m]==-1 * Game.gui[i].action)
							{
								foundm = true;
								spellframe = 1; //greyed out
								Game.gui[i].spellactive = true;//12apr2021
								break;
							}
						}
						if(!foundm)
						{
							Game.gui[i].mouseover = false;//4apr2021
							Game.gui[i].spellactive = false;//12apr2021
							continue;
							//spellframe = 1;//greyed out...
						}
					}
					else
					{
						Game.gui[i].mouseover = false;//4apr2021
						Game.gui[i].spellactive = false;//12apr2021
						continue;
					}
				}
			}
			//end-----------------//28mar2021
			//start-----------------//22mar2021
			if(Game.gui[i].triggerlink==LINK_SELECTED_ICONS)
			{
				//if(Game.gui[i].gamestate==Game.gamestate && Game.EDITOR==false)//18apr2021
				if(Game.gui[i].gamestate==Game.oldgamestate && Game.EDITOR==false)//18apr2021
				{
					//tcount = 0;
					xcount = 0; //11mar2021
					ycount = 0; //11mar2021
					icount = 0; //11mar2021
					color = RenderList.getrgb(240,240,240);
					for(int tid=0;tid<Game.templates.Length;tid++)
					{
						if(Game.templates[tid].faction==Game.PLAYERFACTION && Game.gui[i].triggerlink==LINK_SELECTED_ICONS && Game.templates[tid].selectioncount>0 && Game.templates[tid].walkspeed>0)
						{
							//draw this gui icon
							Game.showingselectedicons = true;
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y +ycount + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].image);							
							//draw the sprite idle frame start
							//9apr2021 hires stuff
							if(Game.templates[tid].cathires!=-1)
							{
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.templates[tid].cathires].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.35f,0.35f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cathires);	
							}
							else
							{
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.templates[tid].cat].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.7f,0.7f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cat);
							}
							//draw text value with the number....
							//RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 2 + toffx - 1,toffy + ycount +  Game.gui[i].y + Game.gui[i].h / 2 - 1,""+Game.templates[tid].livecount,RenderList.getrgb(12,12,12),Game.fonts[Game.gui[i].font].font,true);//13mar2021
							Gui.checksum++;
							RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 2 + toffx - 1,toffy + ycount +  Game.gui[i].y + Game.gui[i].h / 2 - 1,""+Translation.TranslateNumber(Game.templates[tid].selectioncount),color,Game.fonts[Game.gui[i].font].font,true);						
							//
							//Game.gui[i].tooltip = Game.templates[tid].name + " - " + Game.templates[tid].livecount;//13mar2021
							Game.gui[i].tooltip = Game.templates[tid].dname() + " - " + Translation.TranslateNumber(Game.templates[tid].selectioncount);//13mar2021
							if((Game.mx > Game.gui[i].x + xcount && Game.mx < Game.gui[i].x + Game.gui[i].w + xcount && Game.my > Game.gui[i].y + ycount && Game.my < Game.gui[i].y + ycount + Game.gui[i].h))
							{
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y +ycount + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,1,false,0.25f,Game.gui[i].image);//22mar2021
								if(Game.gui[i].y > Game.RESOLUTIONY/2)
								{
									Gui.checksum++;
									RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 4,ycount + Game.gui[i].y + Game.gui[i].h / 2 - + ((60 * Game.gui[i].h) / 100),Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);							
								}
								else
								{
									Gui.checksum++;
									RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 4,ycount + Game.gui[i].y + Game.gui[i].h / 2 + ((60 * Game.gui[i].h) / 100),Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);						
								}
								Game.gui[i].mouseover = true;//22mar2021
								//WARNING - updating in DRAWING SECTION!
								//10mar2021 Warning - updating in DRAWING SECTION
								//if(Game.mlclick==true && Game.togglepause==false )//26mar2021 //22mar2021 (everything inside here)
								if(Game.mlclick==true && Game.togglepause==false && Functions.abs(Game.fmx - Game.smx)<10 && Functions.abs(Game.fmy - Game.smy)<10 && Game.selectingtime <= Game.WAITSELECTINGTIME/3) //26mar2021
								{
									Audios.playsound(Game.audios[Resources.CLICK],Game.FXVOLUME);//15mar2021
									//update selection to just be this sub group within the group.....
									//for(int u=0;u<Game.units.Length;u++)//26mar2021
									for(int u=0;u<=Unit.MAXINDEX;u++)//26mar2021
									{
										if(Game.units[u].selected!=Unit.SELECTIONNONE && Game.units[u].templateid!=tid)
										{
											Game.units[u].selected = Unit.SELECTIONNONE;
											Game.mlclick = false;
										}
									}
								}
							}
							//tcount+=Game.gui[i].w;
							icount++;
							if(Game.gui[i].horizontal>0)
							{
								xcount+=Game.gui[i].w;
							}
							if(Game.gui[i].vertical>0)
							{
								ycount+=Game.gui[i].h;
							}
							if((icount >= Game.gui[i].horizontal && Game.gui[i].horizontal > 0) || (icount >= Game.gui[i].vertical && Game.gui[i].vertical > 0))
							{
								if(Game.gui[i].horizontal>0)
								{
									xcount = 0;
									ycount += Game.gui[i].h;
								}
								else
								{
									ycount = 0;
									xcount += Game.gui[i].w;
								}
								icount = 0;
							}
						}
					}
				}
				continue;
			}
			//end-------------------//22mar2021
			//start-------------//9mar2021
			if(Game.gui[i].triggerlink>=LINK_PLAYER_ICONS && Game.gui[i].triggerlink<=LINK_ENEMY_ICONS)
			{
				//if(Game.gui[i].gamestate==Game.gamestate && Game.EDITOR==false)//18apr2021
				if(Game.gui[i].gamestate==Game.oldgamestate && Game.EDITOR==false)//18apr2021
				{
					xcount = 0; //11mar2021
					ycount = 0; //11mar2021
					icount = 0; //11mar2021
					color = RenderList.getrgb(240,240,240);
					for(int tid=0;tid<Game.templates.Length;tid++)
					{
						if(((Game.templates[tid].faction==Game.SKIRMISHENEMYFACTION && Game.gui[i].triggerlink==LINK_ENEMY_ICONS) || (Game.templates[tid].faction==Game.PLAYERFACTION && Game.gui[i].triggerlink==LINK_PLAYER_ICONS)) && Game.templates[tid].livecount>0 && Game.templates[tid].walkspeed>0)
						{
							//draw this gui icon
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y +ycount + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].image);							
							//draw the sprite idle frame start
							//9apr2021 cathires stuff
							if(Game.templates[tid].cathires!=-1)
							{
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.templates[tid].cathires].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.35f,0.35f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cathires);
							}
							else
							{
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.templates[tid].cat].texture,xcount + Game.gui[i].x + Game.gui[i].w/2,ycount + Game.gui[i].y + Game.gui[i].h/2,0,0.7f,0.7f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cat);
							}
							//draw text value with the number....
							//RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 2 + toffx - 1,toffy + ycount +  Game.gui[i].y + Game.gui[i].h / 2 - 1,""+Game.templates[tid].livecount,RenderList.getrgb(12,12,12),Game.fonts[Game.gui[i].font].font,true);//13mar2021
							Gui.checksum++;
							RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 2 + toffx - 1,toffy + ycount +  Game.gui[i].y + Game.gui[i].h / 2 - 1,""+Translation.TranslateNumber(Game.templates[tid].livecount),RenderList.getrgb(12,12,12),Game.fonts[Game.gui[i].font].font,true);						
							if(Game.templates[tid].livecountframe==0 || (Game.templates[tid].livecountframe>0 && Game.frame % 30<15))
							{
								//RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 2 + toffx,ycount + toffy + Game.gui[i].y + Game.gui[i].h / 2,""+Game.templates[tid].livecount,color,Game.fonts[Game.gui[i].font].font,true);//13mar2021
								Gui.checksum++;
								RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 2 + toffx,ycount + toffy + Game.gui[i].y + Game.gui[i].h / 2,""+Translation.TranslateNumber(Game.templates[tid].livecount),color,Game.fonts[Game.gui[i].font].font,true);//13mar2021
							}
							//
							//Game.gui[i].tooltip = Game.templates[tid].name + " - " + Game.templates[tid].livecount;//13mar2021
							Game.gui[i].tooltip = Game.templates[tid].dname() + " - " + Translation.TranslateNumber(Game.templates[tid].livecount);//13mar2021
							if((Game.mx > Game.gui[i].x + xcount && Game.mx < Game.gui[i].x + Game.gui[i].w + xcount && Game.my > Game.gui[i].y + ycount && Game.my < Game.gui[i].y + ycount + Game.gui[i].h))
							{	
								if(Game.gui[i].y > Game.RESOLUTIONY/2)
								{
									Gui.checksum++;
									RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 4,ycount + Game.gui[i].y + Game.gui[i].h / 2 - + ((60 * Game.gui[i].h) / 100),Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);							
								}
								else
								{
									Gui.checksum++;
									RenderList.drawtext(game,xcount + Game.gui[i].x+Game.gui[i].w / 4,ycount + Game.gui[i].y + Game.gui[i].h / 2 + ((60 * Game.gui[i].h) / 100),Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);						
								}
							}
							//tcount+=Game.gui[i].w;
							icount++;
							if(Game.gui[i].horizontal>0)
							{
								xcount+=Game.gui[i].w;
							}
							if(Game.gui[i].vertical>0)
							{
								ycount+=Game.gui[i].h;
							}
							if((icount >= Game.gui[i].horizontal && Game.gui[i].horizontal > 0) || (icount >= Game.gui[i].vertical && Game.gui[i].vertical > 0))
							{
								if(Game.gui[i].horizontal>0)
								{
									xcount = 0;
									ycount += Game.gui[i].h;
								}
								else
								{
									ycount = 0;
									xcount += Game.gui[i].w;
								}
								icount = 0;
							}
						}
					}
				}
				continue;
			}
			//end---------------//9mar2021
			if(Game.gui[i].triggerlink==Gui.LINK_SELECTION_TEXT)
			{
				//if(Game.gamestate==Game.gui[i].gamestate)//18apr2021
				if(Game.oldgamestate==Game.gui[i].gamestate)//18apr2021
				{
					bool found = false;
					String uname = "";
					//for(int j=0;j<Game.units.Length;j++)//26mar2021
					for(int j=0;j<=Unit.MAXINDEX;j++)//26mar2021
					{
						if(Game.units[j].hp>0 && Game.units[j].selected!=Unit.SELECTIONNONE)
						{
							if(uname==(""))
							{
								uname = Game.units[j].name;
							}
							found = true;
							uid = j;
							if(uname==(Game.units[j].name))
							{
								found = false;
								uid = -1;
								break;
							}
						}
					}
					//start------//15apr2021
					if(Game.mouseoverunitid!=-1 && found==false && uid==-1)
					{
						int j = Game.mouseoverunitid;
						if(Game.units[j].hp>0)
						{
							uid = j;
							found = true;
						}
					}
					//end--------//15apr2021
					if(found)
					{
						Game.gui[i].hidden = 0;
						if(Config.USETECH) //2sep2021
						{
							Game.units[uid].walkspeed+=Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.MV);
							Game.units[uid].damage+=Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.BA);
							Game.units[uid].armour+=Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.BD);
							Tech.TARGETUID = uid;
							Tech.ADDSUBTRACT = 1;
							Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.BZ);
				
						}
						uline = Unit.getunittext(game,uid);
						if(Config.USETECH) //2sep2021
						{
							Game.units[uid].walkspeed-=Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.MV);
							Game.units[uid].damage-=Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.BA);
							Game.units[uid].armour-=Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.BD);
							Tech.TARGETUID = uid;
							Tech.ADDSUBTRACT = -1;
							Tech.AddUnitUpgradeBuff(game,Game.units[uid].templateid,Tech.BZ);
						}
					}
					else
					{
						Game.gui[i].hidden = 1;
					}
				}
			}
			//
			if(Game.gui[i].hidden==1)
			{
				if((Game.gui[i].triggerlink==GUILINK_DEFEAT && Game.GAMEENDSTATE==Game.GAMEENDSTATE_DEFEAT) || (Game.gui[i].triggerlink==GUILINK_VICTORY && Game.GAMEENDSTATE==Game.GAMEENDSTATE_VICTORY))
				{
					//if(!Game.victorymessage)
					//{
						continue;
					//}
				}
				else
				{
					if(Game.EDITOR)
					{
						if(Game.gui[i].triggerlink==1)
						{
							if(Game.EDITMODE == Game.EDITMODE_TRIGGER)
							{
								if(TriggerHelper.field8index==3 || TriggerHelper.field8index==4)
								{
									if(TriggerHelper.constructorindex==15)
									{
										Game.gui[i].index = TriggerHelper.field15;
									}
									else
									{
										continue;
									}
								}
								else
								{
									continue;
								}
							}
							else
							{
								continue;
							}
						}
						else
						{
							continue;
						}
					}
					else
					{
						continue;
					}
				}
			}
			else
			{
				//if(Game.gui[i].triggerlink>0 && Game.gamestate!=Game.gui[i].gamestate)//18apr2021
				if(Game.gui[i].triggerlink>0 && Game.oldgamestate!=Game.gui[i].gamestate)//18apr2021
				{
					if(Game.gui[i].triggerlink!=Gui.LINK_UNIT_DETAIL)
					{
						Game.gui[i].hidden=1;
					}
				}
			}
			
			//if(Game.gui[i].link=="description" && Game.chosenmissionindex==-1)//18sep2021
			if((Game.gui[i].link==("description") || Game.gui[i].link==("showonlyformission")) && Game.chosenmissionindex==-1)//18sep2021
			{
				continue;
			}
			if(Game.gui[i].link==("description") && Game.chosenmissionindex!=-1)
			{
				if(Game.missions[Game.chosenmissionindex].description[0]==(""))
				{
					continue;
				}
			}
			//start---------------//26mar2021
			if(Game.chosenmissionindex==-1 && Game.gui[i].action==ACTION_PLAY)
			{
				continue;
			}
			if(Game.gui[i].action==ACTION_PLAY && Game.chosenmissionindex!=-1)
			{
				if(Game.missions[Game.chosenmissionindex].description[0]==(""))
				{
					continue;
				}
			}
			//end-----------------//26mar2021
			if(Game.gui[i].action==ACTION_EXTERNAL && Game.EDITOR==false)
			{
				continue;
			}
			//start-------------//9mar2021
			//if(Game.gui[i].action>=ACTION_FORMATIONSTART && Game.gui[i].action<=ACTION_FORMATIONEND && (Game.EDITOR==true || Game.SPAWNERSELECTED==true) && Game.NONSPAWNERSELECTED==false)//2sep2021
			if(Game.gui[i].action>=ACTION_FORMATIONSTART && Game.gui[i].action<=ACTION_FORMATIONEND && (Game.EDITOR==true || Game.SPAWNERSELECTED==true || Tech.TECHUNITSELECTED==true) && Game.NONSPAWNERSELECTED==false)//2sep2021
			{
				Game.gui[i].mouseover = false;//24apr2021
				continue;
			}
			//end---------------//9mar2021
			//start------------//17apr2021
			//if(Game.gui[i].gamestate==Game.gamestate)//18apr2021
			if(Game.gui[i].gamestate==Game.oldgamestate)//18apr2021
			{
				//if(Game.gui[i].link=="targeticon" || Game.gui[i].link=="clicker")//3may2021
				if(Game.gui[i].link==("targeticon") || Game.gui[i].link==("clicker") || Game.gui[i].link==("transporticon"))//3may2021
				{
					Game.gui[i].x = Game.mx;
					Game.gui[i].y = Game.my;
					Game.gui[i].w = Game.images[Game.gui[i].image].cwx;
					Game.gui[i].h = Game.images[Game.gui[i].image].chy;
					if(Game.gui[i].link==("clicker"))
					{
						Game.gui[i].x = Game.clickerx - Game.gui[i].w/2;
						Game.gui[i].y = Game.clickery - Game.gui[i].h/2;
						if(Game.clickerframe<0)
						{
							continue;
						}
						else
						{
							if(Game.clickerframe>=0)
							{
								Game.clickerframe++;
								if(Game.clickerframe>Game.images[Game.gui[i].image].cwn - 1)
								{
									Game.clickerframe = -1;
									Game.clickerrow = 0;
									continue;
								}
							}
							else
							{
								continue;
							}
						}
						Game.gui[i].index = Game.clickerframe + Game.images[Game.gui[i].image].cwn * Game.clickerrow;
					}
					if(Game.gui[i].link==("targeticon"))
					{
						if(Game.mouseoverunitid!=-1 && Game.anyselected==true)
						{
							int nid = Game.mouseoverunitid;
							if(Game.units[nid].faction==Game.SKIRMISHENEMYFACTION && Game.units[nid].hp>0)
							{
								//show us
								//20apr2021 added offx
								Game.gui[i].x = Game.units[nid].offx + Game.units[nid].x - Game.CORNERX - Game.gui[i].w/2;
								Game.gui[i].y = Game.units[nid].y - Game.CORNERY + Game.units[nid].offy - Game.gui[i].h/2;
								if(Game.mlclick || Game.mrclick)//24sep2021
								{
									Unit.SelectNearestTarget(null,Unit.GetPlayer(null));//24sep2021
								}
							}
							else
							{
								continue;
							}
						}
						else
						{
							continue;
						}
					}
					if(Game.gui[i].link==("transporticon"))//3may2021 (and contents)
					{
						if(Game.mouseoverunitid!=-1 && Game.anyselected==true)
						{
							int nid = Game.mouseoverunitid;
							if(Game.units[nid].faction==Game.PLAYERFACTION && Game.units[nid].hp>0 && Game.units[nid].transportcapacity>0)
							{
								Game.gui[i].x = Game.units[nid].offx + Game.units[nid].x - Game.CORNERX - Game.gui[i].w/2;
								Game.gui[i].y = Game.units[nid].y - Game.CORNERY + Game.units[nid].offy - Game.gui[i].h/2;
							}
							else
							{
								continue;
							}
						}
						else
						{
							continue;
						}
					}											
				}
			}
			//end--------------//17apr2021
			
			//if(Game.gui[i].gamestate == Game.gamestate)//18apr2021
			if(Game.gui[i].gamestate == Game.oldgamestate)//18apr2021
			{
				//these buttons belong to us......etc
				//start-------------------//20apr2021
				if(Game.gui[i].link==("toggleoff"))
				{
					continue;
				}
				//end-----------------------//20apr2021
				if(Game.gui[i].link==("indoor") && Map.indoor==0)//23sep2021
				{
					continue;
				}
				if(Game.gui[i].backgroundrect)
				{
					color = RenderList.getrgb(Game.gui[i].backgroundrectcolor[0],Game.gui[i].backgroundrectcolor[1],Game.gui[i].backgroundrectcolor[2]);
					Gui.checksum++;
					bool healthbar = false;//23sep2021
					bool manabar = false;//23sep2021
					if(Game.gui[i].link==("health"))
					{
						healthbar = true;
					}
					if(Game.gui[i].link==("mana"))
					{
						manabar = true;
					}
					if(manabar || healthbar)
					{
						int hh = 0;
						int vv = 0;
						int yy = 0;
						int value = 0;
						int vbase = 0;
						pid = Unit.GetPlayer(null);
						if(pid!=-1)
						{
							if(manabar)
							{
								value = Game.units[pid].mana;
								vbase = Game.units[pid].basemana;
								if(vbase<=0)
								{
									continue;
								}
								if(value>vbase)
								{
									value = vbase;
								}
							}
							else
							{
								value = Game.units[pid].hp;
								vbase = Game.units[pid].basehp;
								if(vbase<=0)
								{
									continue;
								}
								if(value>vbase)
								{
									value = vbase;
								}
							}
							if(pid!=-1)
							{
								if(Game.gui[i].horizontal>0)
								{
									hh = (Game.gui[i].backgroundrectcoords[2] * value) / vbase; 
									RenderList.drawrect(game,Game.gui[i].backgroundrectcoords[0],Game.gui[i].backgroundrectcoords[1],hh,Game.gui[i].backgroundrectcoords[3],color,0);//25sep2021
								}
								if(Game.gui[i].vertical>0)
								{
									vv = (Game.gui[i].backgroundrectcoords[3] * value) / vbase;
									yy = Game.gui[i].backgroundrectcoords[1] + Game.gui[i].backgroundrectcoords[3] - vv; 
									RenderList.drawrect(game,Game.gui[i].backgroundrectcoords[0],yy,Game.gui[i].backgroundrectcoords[2],vv,color,0);//25sep2021
								}
							}
						}
						//RenderList.drawrect(game,Game.gui[i].backgroundrectcoords[0],Game.gui[i].backgroundrectcoords[1] + yy,Game.gui[i].backgroundrectcoords[2]-hh,Game.gui[i].backgroundrectcoords[3]-vv,color,0);
					}
					else
					{
						RenderList.drawrect(game,Game.gui[i].backgroundrectcoords[0],Game.gui[i].backgroundrectcoords[1],Game.gui[i].backgroundrectcoords[2],Game.gui[i].backgroundrectcoords[3],color,0);
					}
				}
				if(Game.gui[i].link==("gameterritory"))//8oct2021
				{
					if(Game.gui[i].index % CampaignMap.maxprovince==Game.campaignattackprovince)
					{
						//blink.......
						if(Game.frame%20<10)
						{
							continue; //blink
						}
					}
				}
				//start----------//16oct2021
				string originaltitle = Game.gui[i].title;
				//start----------//21oct2021
				if(Game.gui[i].title==("Research"))
				{
					if(!Research.IsResearching(Game.PlayerIndex))
					{
						if(Game.frame % 20<10)
						{
							Game.gui[i].title = "Research*";
						}
					}
				}
				if(Game.gui[i].title==("Battle"))
				{
					if(Game.frame % 20<10)
					{
						Game.gui[i].title = "Battle*";
					}
				}
				if(Game.gui[i].title==("Spells"))
				{
					if(Game.frame % 20<10)
					{
						Game.gui[i].title = "Spells*";
					}
				}
				//end------------//21oct2021
				
				if(Game.gui[i].link=="popup")//16oct2021
				{
					if(Game.mx<Game.RESOLUTIONX/2)
					{
						Game.gui[i].x += Game.RESOLUTIONX/2 + 10;
					}
					else
					{
							Game.gui[i].x += 10;
					}
					Game.gui[i].y += Game.RESOLUTIONY/4;
					if(Game.my<Game.RESOLUTIONY/2)
					{
							//Game.gui[i].y += Game.RESOLUTIONY/2 + 10;
					}
					else
					{
						//Game.gui[i].y += 10;
					}
					Gui.fillpopup(i);
					
				}
				//special......
				//start------------//18oct2021
				if(Game.gui[i].triggerlink==LINK_BATTLESPELL)
				{
					Gui.fillpopup(i); //very special case......
				}
				//end--------------//18oct2021
				//start------------//19oct2021
				if(Game.gui[i].action>=ACTION_ARMYINFO && Game.gui[i].action<ACTION_ARMYINFO+6)
				{
					Gui.fillpopup(i);
				}
				if(Game.gui[i].action>=ACTION_ENEMYINFO && Game.gui[i].action<ACTION_ENEMYINFO+6)
				{
					Gui.fillpopup(i);
				}
				if(Game.gui[i].action>=Research.GUIPATH0 && Game.gui[i].action<=Research.GUIPATH2)//21oct2021
				{
					Gui.fillpopup(i);
				}
				//end--------------//19oct2021
				//end---------//16oct2021
				if(Game.gui[i].image!=-1 && (Game.gui[i].altimage[0]<0 || Gui.ALTMODE==false))
				{
					if(Game.gui[i].action>=ACTION_SPELL_START && Game.gui[i].action<=ACTION_SPELL_END)//28mar2021
					{
						if(spellframe==0) //coloured
						{
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y+Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].image);							
							if(Game.gui[i].mouseover && Game.gui[i].type!=TYPE_IMAGE)
							{
								Gui.checksum++;
								RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,1,false,0.25f,Game.gui[i].image);							
							}
						}
						else
						{
							//greyed....
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y+Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index + 1,0,false,1f,Game.gui[i].image);															
						}
					}
					else
					{
						Gui.checksum++;
						RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y+Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].image);							
						if(Game.gui[i].mouseover && Game.gui[i].type!=TYPE_IMAGE)
						{
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.gui[i].image].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,1,false,0.25f,Game.gui[i].image);							
						}
					}
				}
				if(Game.gui[i].altimage[0]>=0 && Gui.ALTMODE==true)
				{
					//int rnd = Game.gui[i].altimageindex;
					if(Game.gui[i].altimageindex==-1 || Game.gamestate!=Game.oldgamestate)
					{
						int rnd = (int)(Functions.abs(Functions.rand(0,10))) % 5;
						while(Game.gui[i].altimage[rnd]<0)
						{
							rnd++;
							rnd%=5;
						}
						Game.gui[i].altimageindex = rnd;
					}
					Gui.checksum++;
					RenderList.drawimage(game,Game.images[Game.gui[i].altimage[Game.gui[i].altimageindex]].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y+Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,0,false,1f,Game.gui[i].altimage[Game.gui[i].altimageindex]);
					if(Game.gui[i].mouseover && Game.gui[i].type!=TYPE_IMAGE)
					{
						Gui.checksum++;
						RenderList.drawimage(game,Game.images[Game.gui[i].altimage[Game.gui[i].altimageindex]].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y + Game.gui[i].h/2,0,Game.gui[i].scale,Game.gui[i].scale,Game.gui[i].index,1,false,0.25f,Game.gui[i].altimage[Game.gui[i].altimageindex]);
					}
				}
				if((Game.gui[i].link==("territory")) || Game.gui[i].link==("gameterritory"))//9oct2021
				{
					int province = Game.gui[i].index % CampaignMap.maxprovince;
					if(drawnhatch==false)//21oct2021//if(province==0)//16oct2021
					{
						//only do this for the first province.....
						drawnhatch = true;
						CampaignMap.DrawCells(Game.gui[i].x,Game.gui[i].y);
					}
					int armysize = CampaignMap.GetArmy(province);
					if(armysize<18 && armysize>=0)
					{
						if(IMG_ARMYICON==-1)
						{
							for(int j=0;j<Game.gui.Length;j++)
							{
								if(Game.gui[j].link==("armyicon"))
								{
									IMG_ARMYICON = Game.gui[j].image;
									break;
								}
							}
						}
						else
						{
							int armyx = Game.gui[i].x + (int)(Game.gui[i].w * CampaignMap.GetProvinceCentreX(province))/CampaignMap.maxx;
							int armyy = Game.gui[i].y + (int)(Game.gui[i].h * CampaignMap.GetProvinceCentreY(province))/CampaignMap.maxy;
							RenderList.drawimage(game,Game.images[IMG_ARMYICON].texture,armyx,armyy,0,2,2,armysize,0,false,1,IMG_ARMYICON);	
						}
					}
					//start----------//16oct2021
					if(Game.battleicon!=-1 && drawnbattleicons==false)
					{
						drawnbattleicons=true;
						for(int x=0;x<CampaignMap.maxx;x++)
						{
							for(int y=0;y<CampaignMap.maxy;y++)
							{
								if(CampaignMap.BattleAtXY(x,y))
								{
									RenderList.drawimage(game,Game.images[Game.battleicon].texture,Game.gui[i].x + (x * CampaignMap.gridw),(y * CampaignMap.gridh) ,0,2,2,0,0,false,1,Game.battleicon);	
								}
							}
						}					
					}
					//end-------------//16oct2021
				}
				if(Game.EDITOR)
				{
					if(TriggerHelper.field8index==3 || TriggerHelper.field8index==4)
					{
						if(TriggerHelper.constructorindex==15)
						{
							String[] message = TriggerHelper.constructor[9].Split("\\|");
							if(message.Length>0)
							{
								for(int j=0;j<message.Length;j++)
								{
									message[j] = message[j].Replace("^",",");
									Gui.checksum++;
									RenderList.drawtext(game,TriggerHelper.atlocation[0],TriggerHelper.atlocation[1] + j * (4+Game.fonts[Resources.FONT].ptsize),message[j],RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);
								}
							}
						}
					}
				}
				if(Game.campaignmode==Game.MaxArmies+1 && Game.gui[i].link==("gameterritory") && drawnxonce == false)
				{
					drawnxonce = true;
					int cx = CampaignMap.GetProvinceCentreX(Game.campaignattackprovince)+Game.gui[i].x;
					int cy = CampaignMap.GetProvinceCentreY(Game.campaignattackprovince)+Game.gui[i].y;
					RenderList.drawtext(game,cx,cy,"X",RenderList.getrgb(255,80,20),Game.fonts[Resources.LARGEFONT].font,true);					
				}
				//start------------//17apr2021
				if(Game.gui[i].action==120)
				{
					if(Game.FULLSCREEN==0)
					{
						Game.gui[i].title = Translation.TranslateWord("Windowed",false);
					}
					else
					{
						Game.gui[i].title = Translation.TranslateWord("Full Screen",false);
					}
				}
				if(Game.gui[i].action==121)
				{
					if(Config.hires==0)
					{
						Game.gui[i].title = Translation.TranslateWord("Low Quality",false);
					}
					else
					{
						Game.gui[i].title = Translation.TranslateWord("High Quality",false);
					}
				}
				//end--------------//17apr2021
				if(Game.gui[i].action==12)
				{
					if(Game.FXVOLUME>0)
					{
						Game.gui[i].title = Translation.TranslateWord("Sound On",false);
					}
					else
					{
						Game.gui[i].title = Translation.TranslateWord("Sound Off",false);
					}
				}
				if(Game.gui[i].action==13)
				{
					if(Game.MUSICVOLUME>0)
					{
						Game.gui[i].title = Translation.TranslateWord("Music On",false);
					}
					else
					{
						Game.gui[i].title = Translation.TranslateWord("Music Off",false);
					}
				}
				color = RenderList.getrgb(255,255,200);
				if(Game.gui[i].missionindex!=-1)
				{
					//int mi = Game.gui[i].missionindex + Game.topmissionindex; //24Feb2021
					int mi = Game.gui[i].missionindex + (Game.topmissionindex * (1 - Game.gui[i].topindexzero)); //24Feb2021
					if(mi==Game.chosenmissionindex)
					{
						//do nothing
					}
					else
					{
						color = RenderList.getrgb(128,128,100);
					}
				}
				//start---------------//23sep2021
				if(Game.gui[i].command.IndexOf("buybutton")>=0)//26sep2021 changed from buy cost to buy button
				{
					Game.gui[i].title = ""+Game.gui[i].goldcost;//Tech.GoldCostGui(null,Game.gui[i].action);
					if(Game.gui[i].sold==1)
					{
						Game.gui[i].title = "Sold Out!";
					}
				}
				if(Game.gui[i].command.IndexOf("buydescription")>=0)// && Game.gui[i].action!=ACTION_NONE)
				{
					int factor = 0;
					if(Game.LETTERBOX)
					{
						factor = Game.fonts[Resources.FONT].ptsize;
					}
					String[] txtdesc = Game.gui[i].saledesc;//Tech.GetDescription(null,Game.gui[i].action);
					for(int j=0;j<txtdesc.Length;j++)
					{
						if(txtdesc[j]!=(""))
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * (j-1),txtdesc[j],color,Game.fonts[Resources.FONT].font,false);
						}
					}
				}
				if(Game.gui[i].title!=(""))
				{
					//start-------//19oct2021
					if(Game.gui[i].title.IndexOf("#")>=0)
					{
						string[] txt = Game.gui[i].title.Split("#");
						if(txt!=null)
						{
							int y = 0;
							for(int j=0;j<txt.Length;j++)
							{
								if(Game.gui[i].leftjustify>0)
								{
									Gui.checksum++;
									RenderList.drawtext(game,Game.gui[i].x,4 + Game.gui[i].y + Game.gui[i].h / 2 - 1 + y,txt[j],RenderList.getrgb(25,25,25),Game.fonts[Game.gui[i].font].font,false);						
									Gui.checksum++;
									RenderList.drawtext(game,Game.gui[i].x,4 + Game.gui[i].y + Game.gui[i].h / 2 + y,txt[j],color,Game.fonts[Game.gui[i].font].font,false);						
								}
								else
								{
									Gui.checksum++;
									RenderList.drawtext(game,Game.gui[i].x+Game.gui[i].w / 2 - 1,4 + Game.gui[i].y + Game.gui[i].h / 2 - 1 + y,txt[j],RenderList.getrgb(25,25,25),Game.fonts[Game.gui[i].font].font,true);						
									Gui.checksum++;
									RenderList.drawtext(game,Game.gui[i].x+Game.gui[i].w / 2,4 + Game.gui[i].y + Game.gui[i].h / 2 + y,txt[j],color,Game.fonts[Game.gui[i].font].font,true);						
								}
								if(Game.LETTERBOX)
								{
									y += (6 + 2 * Game.fonts[Resources.FONT].ptsize);
								}
								else
								{
									y += (6 + Game.fonts[Resources.FONT].ptsize);
								}
							}
						}
					}					
					else
					{
					//end---------//19oct2021
						if(Game.gui[i].leftjustify>0)//16oct2021
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x,4 + Game.gui[i].y + Game.gui[i].h / 2 - 1,Game.gui[i].title,RenderList.getrgb(25,25,25),Game.fonts[Game.gui[i].font].font,false);						
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x,4 + Game.gui[i].y + Game.gui[i].h / 2,Game.gui[i].title,color,Game.fonts[Game.gui[i].font].font,false);						
						}
						else
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x+Game.gui[i].w / 2 - 1,4 + Game.gui[i].y + Game.gui[i].h / 2 - 1,Game.gui[i].title,RenderList.getrgb(25,25,25),Game.fonts[Game.gui[i].font].font,true);						
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x+Game.gui[i].w / 2,4 + Game.gui[i].y + Game.gui[i].h / 2,Game.gui[i].title,color,Game.fonts[Game.gui[i].font].font,true);						
						}
					}
				}
				//start----------//16oct2021
				Game.gui[i].title = originaltitle;
				if(Game.gui[i].link=="popup")//16oct2021
				{
					if(Game.mx<Game.RESOLUTIONX/2)
					{
						Game.gui[i].x -= Game.RESOLUTIONX/2 + 10;
					}
					else
					{
							Game.gui[i].x -= 10;
					}
					Game.gui[i].y -= Game.RESOLUTIONY/4;
					if(Game.my<Game.RESOLUTIONY/2)
					{
							//Game.gui[i].y -= Game.RESOLUTIONY/2 + 10;
					}
					else
					{
						//Game.gui[i].y -= 10;
					}
				}
				//end---------//16oct2021
				//start---------------------//17sep2021
				if(Game.gui[i].link==("Total Score:"))
				{
					color = RenderList.getrgb(255,255,200);
					if(Game.scoredirty)
					{
						int maxtotalscore = 0;
						int totalscore = 0;
						if(Game.missions!=null)
						{
							for(int ms=0;ms<Game.missions.Length;ms++)
							{
								if(Game.missions[ms].demo<=0)
								{
									String totalscorestr = LocalStorage.getitem("missionscore"+ms);
									if(totalscorestr==(""))
									{
										totalscorestr = "0";
									}
									int mscore = 0;
									//mscore = Integer.decode(totalscorestr);
									totalscore+=mscore;
									for(int tid=0;tid<Game.templates.Length;tid++)
									{
										if(Game.templates[tid].faction==Game.missions[ms].playerfaction && Game.templates[tid].walkspeed>0)
										{
											for(int v=0;v<Game.missions[ms].units.Length;v++)
											{
												if(v>=Unit.MAXUNITS)
												{
													continue;
												}
												if(Game.missions[ms].units[v].name==(Game.templates[tid].name))
												{
													maxtotalscore+=Game.templates[tid].points;
												}
											}
										}
									}		
								}							
							}
						}
						Game.totalscore = totalscore;
						Game.maxtotalscore = maxtotalscore;
						Game.scoredirty = false;
					}
					Gui.checksum++;
					RenderList.drawtext(game,Game.gui[i].x,Game.gui[i].y,Translation.TranslateWord(Game.gui[i].link,false)+" "+Game.totalscore+" out of "+Game.maxtotalscore,color,Game.fonts[Resources.FONT].font,false);
				}
				if(Game.gui[i].link==("Score:"))
				{
					if(Game.chosenmissionindex!=-1)
					{
						color = RenderList.getrgb(255,255,200);
						int missionscore = 0;
						String missionscorestr = LocalStorage.getitem("missionscore"+Game.chosenmissionindex);
						if(missionscorestr==(""))
						{
							missionscorestr = "0";
						}
						//missionscore = Integer.decode(missionscorestr);
						int maxscore = 0;
						for(int tid=0;tid<Game.templates.Length;tid++)
						{
							if(Game.templates[tid].faction==Game.missions[Game.chosenmissionindex].playerfaction && Game.templates[tid].walkspeed>0)
							{
								for(int v=0;v<Game.missions[Game.chosenmissionindex].units.Length;v++)
								{
									if(v>=Unit.MAXUNITS)
									{
										continue;
									}
									if(Game.missions[Game.chosenmissionindex].units[v].name==(Game.templates[tid].name))
									{
										maxscore+=Game.templates[tid].points;
									}
								}
							}
						}
						Gui.checksum++;
						RenderList.drawtext(game,Game.gui[i].x,Game.gui[i].y,Translation.TranslateWord(Game.gui[i].link,false)+" "+missionscore+" out of "+maxscore,color,Game.fonts[Resources.FONT].font,false);
					}
				}
				//end-----------------------//17sep2021
				//start---------------------//18sep2021
				if(Game.gui[i].link==("chosenmissionflavourtext"))
				{
					if(Game.chosenmissionindex!=-1)
					{
						color = RenderList.getrgb(255,255,200);
						if(Game.missions[Game.chosenmissionindex].flavourtext!="")
						{
							String[] flavourtext = Game.missions[Game.chosenmissionindex].flavourtext.Split("\\|");
							if(flavourtext!=null)
							{
								for(int ft=0;ft<flavourtext.Length;ft++)
								{
									Gui.checksum++;
									RenderList.drawtext(game,Game.gui[i].x,25 + Game.gui[i].y + ft * 25,flavourtext[ft],color,Game.fonts[Resources.FONT].font,false);
								}
							}
						}
					}
				}
				//end-----------------------//18sep2021
				//start---------------------//23sep2021
				if(Game.gui[i].link==("gold"))
				{
					if(Game.units!=null)
					{
						for(int u=0;u<Game.units.Length;u++)
						{
							if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].gold>-1 && Game.units[u].hp>0)
							{
								Game.gui[i].title = "" + Game.units[u].gold;
							}
						}
					}
				}
				pid = Unit.GetPlayer(null);
				if(pid!=-1)
				{
					if(Game.gui[i].link==("healthpotion"))
					{
						Game.gui[i].title = "" + Game.units[pid].healthpotions;
					}
					if(Game.gui[i].link==("manapotion"))
					{
						Game.gui[i].title = "" + Game.units[pid].manapotions;
					}
					if(Game.gui[i].link==("bothpotion"))
					{
						Game.gui[i].title = "" + Game.units[pid].bothpotions;
					}
				}
				//end-----------------------//23sep2021
				if(Game.gui[i].link==("description"))
				{
					if(Game.chosenmissionindex!=-1)
					{
						color = RenderList.getrgb(255,255,200);
						if(Game.missions[Game.chosenmissionindex].description[0]!=(""))
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x+20,Game.gui[i].y + 20 ,Game.missions[Game.chosenmissionindex].description[0],color,Game.fonts[Resources.FONT].font,false);
						}
						if(Game.missions[Game.chosenmissionindex].description[1]!=(""))
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x+20,Game.gui[i].y + 45 ,Game.missions[Game.chosenmissionindex].description[1],color,Game.fonts[Resources.FONT].font,false);
						}
						if(Game.missions[Game.chosenmissionindex].description[2]!=(""))
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x+20,Game.gui[i].y + 70 ,Game.missions[Game.chosenmissionindex].description[2],color,Game.fonts[Resources.FONT].font,false);
						}
						//start-------------//11mar2021
						color = RenderList.getrgb(255,255,200);
						int xxcount = -40;
						int yycount = 40;
						int ucount = 0;
						for(int tid=0;tid<Game.templates.Length;tid++)
						{
							ucount = 0;
							if(Game.templates[tid].faction==Game.missions[Game.chosenmissionindex].playerfaction && Game.templates[tid].walkspeed>0)
							{
								for(int v=0;v<Game.missions[Game.chosenmissionindex].units.Length;v++)
								{
									if(v>=Unit.MAXUNITS)
									{
										continue;
									}
									if(Game.missions[Game.chosenmissionindex].units[v].name==(Game.templates[tid].name))
									{
										ucount++;
									}
								}
							}
							if(ucount>0)
							{
								//draw the sprite idle frame start
								//9apr2021 cathires stuff
								//16sep2021 changed 50 + to 75 + on x coordinates
								if(Game.templates[tid].cathires!=-1)
								{
									Gui.checksum++;
									RenderList.drawimage(game,Game.images[Game.templates[tid].cathires].texture,75 + xxcount + Game.gui[i].x,100 + yycount + Game.gui[i].y,0,0.35f,0.35f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cathires);
								}
								else
								{
									Gui.checksum++;
									RenderList.drawimage(game,Game.images[Game.templates[tid].cat].texture,75 + xxcount + Game.gui[i].x,100 + yycount + Game.gui[i].y,0,0.7f,0.7f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cat);
								}
								//RenderList.drawtext(game,Game.gui[i].x+50 + xxcount,Game.gui[i].y + 70 + yycount ,""+ucount,color,Game.fonts[Resources.FONT].font,false);//13mar2021
								Gui.checksum++;
								RenderList.drawtext(game,Game.gui[i].x+75 + xxcount,Game.gui[i].y + 70 + yycount ,""+Translation.TranslateNumber(ucount),color,Game.fonts[Resources.FONT].font,false);//13mar2021
								xxcount+=70;
								if(xxcount > 370)
								{
									xxcount = -40;
									yycount+=70;
								}
							}
						}
						if(xxcount == -40)
						{
							yycount-=70;
						}
						xxcount = -40;
						yycount+=70;
						ucount=0;
						for(int tid=0;tid<Game.templates.Length;tid++)
						{
							ucount = 0;
							if(Game.templates[tid].faction==Game.missions[Game.chosenmissionindex].skirmishenemyfaction && Game.templates[tid].walkspeed>0)
							{
								for(int v=0;v<Game.missions[Game.chosenmissionindex].units.Length;v++)
								{
									if(v>=Unit.MAXUNITS)
									{
										continue;
									}
									if(Game.missions[Game.chosenmissionindex].units[v].name==(Game.templates[tid].name))
									{
										ucount++;
									}
								}
							}
							if(ucount>0)
							{
								//draw the sprite idle frame start
								//9apr2021 cathires stuff
								//16sep2021 changed 50 + to 75 + on x coordinates
								if(Game.templates[tid].cathires!=-1)
								{
									Gui.checksum++;
									RenderList.drawimage(game,Game.images[Game.templates[tid].cathires].texture,75 + xxcount + Game.gui[i].x,100 + yycount + Game.gui[i].y,0,0.35f,0.35f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cathires);
								}
								else
								{
									Gui.checksum++;
									RenderList.drawimage(game,Game.images[Game.templates[tid].cat].texture,75 + xxcount + Game.gui[i].x,100 + yycount + Game.gui[i].y,0,0.7f,0.7f,Game.templates[tid].animmodeidleframestart,0,false,1f,Game.templates[tid].cat);
								}
								//RenderList.drawtext(game,Game.gui[i].x+50 + xxcount,Game.gui[i].y + 70 + yycount ,""+ucount,color,Game.fonts[Resources.FONT].font,false);//13mar2021
								RenderList.drawtext(game,Game.gui[i].x+75 + xxcount,Game.gui[i].y + 70 + yycount ,""+Translation.TranslateNumber(ucount),color,Game.fonts[Resources.FONT].font,false);//13mar2021
								xxcount+=70;
								if(xxcount > 370)
								{
									xxcount = -40;
									yycount+=70;
								}
							}
						}
						//end---------------//11mar2021
					}
				}
				if(Game.gui[i].tooltip!=("") && Game.gui[i].mouseover==true)
				{
					Gui.checksum++;
					RenderList.drawtext(game,Game.gui[i].x+Game.gui[i].w / 4,Game.gui[i].y + Game.gui[i].h / 2 + ((20 * Game.gui[i].h) / 100),Game.gui[i].tooltip,RenderList.getrgb(182,182,182),Game.fonts[Resources.SMALLFONT].font,false);						
				}
				if(Game.gui[i].triggerlink==LINK_SELECTION_TEXT)
				{
					if(uid!=-1)
					{
						int uframe = Game.units[uid].animmodeidleframestart;
						int uyoff = (Game.gui[i].h / 2);
						int uxoff = (Game.gui[i].w / 4);
						uframe += (Game.frame / (Game.units[uid].animspeed*2)) % (1 + Game.units[uid].animmodeidleframeend - Game.units[uid].animmodeidleframestart);
						if(uframe > Game.units[uid].animmodeidleframeend)
						{
							uframe = Game.units[uid].animmodeidleframestart;
						}
						float ss = 0.8f * (70f/(float)Game.units[uid].ch);
						//9apr2021 cathires stuff
						if(Game.units[uid].cathires!=-1)
						{
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.units[uid].cathires].texture,Game.gui[i].x + uxoff,Game.gui[i].y + uyoff,0,ss/2,ss/2,uframe,0,false,1f,Game.units[uid].cathires);	
						}
						else
						{
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.units[uid].cat].texture,Game.gui[i].x + uxoff,Game.gui[i].y + uyoff,0,ss,ss,uframe,0,false,1f,Game.units[uid].cat);	
						}
						color = RenderList.getrgb(255,255,200);
						if(Game.units[uid].faction!=Game.PLAYERFACTION && Game.units[uid].faction!=Unit.NULLFACTION)
						{
							color = RenderList.getrgb(255,160,160);
						}
						for(int j=0;j<4;j++)
						{
							if(uline[j]!=(""))
							{
								//todo needs translation.....13mar2021
								Gui.checksum++;
								RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (4 + Game.fonts[Resources.SMALLFONT].ptsize) * (j-2),uline[j],color,Game.fonts[Resources.SMALLFONT].font,false);
							}
						}
					}
				}
				if(Game.gui[i].command.IndexOf("buyimage")>=0)
				{
				}
				//end-----------------//23sep2021
				//start---------------//26sep2021
				if(Game.gui[i].triggerlink==Gui.LINK_UNIT_DETAIL2 && Gui.ACTIVATED_CHARSHEET==true && Game.gui[i].type==Gui.TYPE_LABEL)
				{
					
				}
				//end-----------------//26sep2021
				if(Game.gui[i].triggerlink==Gui.LINK_UNIT_DETAIL)
				{
					int factor = 0;
					if(Game.LETTERBOX)
					{
						factor = Game.fonts[Resources.FONT].ptsize;
					}
					if(Game.gui[i].index!=-1)
					{
						uid = Game.gui[i].index;
						int uframe = Game.templates[uid].animmodeidleframestart;
						int udirn = Game.gui[i].uindex;
						int uyoff = (Game.gui[i].h / 2) ;
						int uxoff = (Game.gui[i].w / 8);
						uframe += (Game.frame / (Game.templates[uid].animspeed*2)) % (1 + Game.templates[uid].animmodeidleframeend - Game.templates[uid].animmodeidleframestart);
						int ssx = 1;
						if(uframe > Game.templates[uid].animmodeidleframeend)
						{
							uframe = Game.templates[uid].animmodeidleframestart;
						}
						Game.gui[i].uindex = udirn;
						//float ss = 2.0f * (70f/(float)Game.templates[uid].ch);//22mar2021
						float ss = 4.0f * (70f/(float)Game.templates[uid].ch);//22mar2021
						//RenderList.drawimage(game,Game.images[Game.templates[uid].cat].texture,Game.gui[i].x + uxoff,Game.gui[i].y + uyoff+Game.templates[uid].offy,0,ss*ssx,ss,uframe+udirn*Game.templates[uid].framesperdirn,0,false,1f,Game.templates[uid].cat);	//22mar2021
						//9apr2021 cathires stuff
						//20apr2021 added offx
						if(Game.templates[uid].cathires!=-1)
						{
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.templates[uid].cathires].texture,Game.gui[i].x + uxoff + Game.templates[uid].offx,Game.gui[i].y + uyoff+Game.templates[uid].offy + 50,0,ss*ssx/2,ss/2,uframe+udirn*Game.templates[uid].framesperdirn,0,false,1f,Game.templates[uid].cathires);	//22mar2021
						}
						else
						{
							Gui.checksum++;
							RenderList.drawimage(game,Game.images[Game.templates[uid].cat].texture,Game.gui[i].x + uxoff + Game.templates[uid].offx ,Game.gui[i].y + uyoff+Game.templates[uid].offy + 50,0,ss*ssx,ss,uframe+udirn*Game.templates[uid].framesperdirn,0,false,1f,Game.templates[uid].cat);	//22mar2021
						}
						color = RenderList.getrgb(255,255,200);
						if(Game.templates[uid].faction!=Game.PLAYERFACTION && Game.templates[uid].faction!=Unit.NULLFACTION)
						{
							//color = RenderList.getrgb(255,160,160);
						}
						int jj = 0;
						//RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (4 + Game.fonts[Resources.FONT].ptsize) * (jj-4),Game.templates[uid].name,color,Game.fonts[Resources.FONT].font,false); //13mar2021
						Gui.checksum++;
						RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * (jj-4),Game.templates[uid].dname(),color,Game.fonts[Resources.FONT].font,false); //13mar2021
						//String txt = "HP " + Game.templates[uid].basehp+ " MV "+Game.templates[uid].walkspeed + " ATT "+Game.templates[uid].damage + " DEF "+Game.templates[uid].armour;//13mar2021
						String txt = "HP " + Translation.TranslateNumber(Game.templates[uid].basehp)+ " MV "+Translation.TranslateNumber(Game.templates[uid].walkspeed) + " ATT "+Translation.TranslateNumber(Game.templates[uid].damage) + " DEF "+Translation.TranslateNumber(Game.templates[uid].armour);//13mar2021
						Gui.checksum++;
						RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * (jj-3),txt,color,Game.fonts[Resources.FONT].font,false);
						txt = Unit.gettemplatetext(game,uid)[0];
						for(int j=0;j<Game.templates[uid].description.Length;j++)
						{
							if(Game.templates[uid].description[j]!=(""))
							{
								Gui.checksum++;
								RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * (j-1),Game.templates[uid].description[j],color,Game.fonts[Resources.FONT].font,false);
							}
						}
						color = RenderList.getrgb(200,200,150);
						//16sep2021 modified to not show this on space squad
						if(Config.NOSHOWABILITY==0)//16sep2021
						{
							Gui.checksum++;
							RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * (Game.templates[uid].description.Length+1),txt,color,Game.fonts[Resources.FONT].font,false);
							if(Unit.gettemplatetext(game,uid)[1].Length>0)
							{
								Gui.checksum++;
								RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),uyoff + Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * (Game.templates[uid].description.Length+2),Unit.gettemplatetext(game,uid)[1],color,Game.fonts[Resources.FONT].font,false);
							}
						}
					}
					else
					{
						Game.gui[i].index = Unit.gettemplate(game,0,1,0);
						Gui.checksum++;
						RenderList.drawtext(game,Game.gui[i].x + ((2 * Game.gui[i].w)/5),Game.gui[i].y + (factor + 4 + Game.fonts[Resources.FONT].ptsize) * 1,""+Game.gui[i].index,color,Game.fonts[Resources.FONT].font,false);
					}
				}
				//start----------------//17sep2021
				if(Game.oldgamestate != Game.CAT_GAMESTATE_GAME && Game.oldgamestate != Game.CAT_GAMESTATE_REPLAY)
				{
					if(Game.gui[i].type==TYPE_MINIMAP)
					{
						if(Game.chosenmissionindex!=Game.ochosenmissionindex)
						{
							Game.ochosenmissionindex = Game.chosenmissionindex;
							if(Game.chosenmissionindex!=-1)
							{
								int ostate = Game.gamestate;
								Map.levelseed = Functions.seed;//2apr2021
								Map.MINIMAPMODE = true;//18sep2021
								Program.resetgame(game);//2apr2021
								Program.cleardeaths(game);
								Game.map = new Map();
								Program.setupmission(game,Game.chosenmissionindex,99);
								//Map.adddecor();//2mar2021
								//Map.marktreepos(game);
								Map.levelseed2 = Functions.seed;//2apr2021
								Game.gamestate = ostate;
								Map.MINIMAPMODE = false;//18sep2021
								//redrawminimap(i);
							}
							
						}
						if(Map.treepositions==null)
						{
							continue;
						}
						if(Game.units==null)
						{
							continue;
						}
						
					}
				}
				//end------------------//17sep2021
				if(Game.gui[i].type==TYPE_CLOTHING)
				{
					int animframe = (RenderList.renderframe/6) % 18;
					//if(Unit.ColorChangei>=0 && Unit.ColorChangei<Game.images.Length)
					//{
					//	RenderList.drawimage(game,Game.images[Unit.ColorChangei].texture,Game.gui[i].x + Game.gui[i].w/2,Game.gui[i].y + Game.gui[i].h/2 ,0,2,2,animframe,0,false,1f,Unit.ColorChangei);	//22mar2021	
					//}
				}
				if(Game.gui[i].type==TYPE_MINIMAP)
				{
					//20sep2021 attmpted to optimise a little....
					//really should just replace with a bitmap rather than all these rects....
						for(int j=0;j<Map.treepositions.Length - 3;j+=3)
						{
							int xx =  Map.treepositions[j] % Map.MAXX;
							int yy = (Map.treepositions[j] - xx) / Map.MAXX;
							if(yy % 3!=0)
							{
								continue;
							}
							uint grey = RenderList.getrgb(50,50,40);
							RenderList.drawrect(game,Game.gui[i].x + (xx)* Game.gui[i].w / Map.MAXX,Game.gui[i].y + (yy) * Game.gui[i].h / Map.MAXY,6,6,grey,0);
						}
					//for(int j=0;j<Game.units.Length;j++)//26mar2021
					if(Game.frame % 4<3)//20sep2021
					{
						for(int j=0;j<=Unit.MAXINDEX;j++)//26mar2021
						{
							if(Game.units[j].hp>0)
							{
								uint friend = RenderList.getrgb(96,255,96);
								uint enemy = RenderList.getrgb(255,96,96);
								if(Game.units[j].faction==Game.PLAYERFACTION)
								{
									RenderList.drawrect(game,Game.gui[i].x + (Game.units[j].x / Map.GRIDW)* Game.gui[i].w / Map.MAXX,Game.gui[i].y + (Game.units[j].y / Map.GRIDH) * Game.gui[i].h / Map.MAXY,2,2,friend,0);
								}
								else
								{
									if(Map.isfogged(Game.units[j].x,Game.units[j].y)==false)
									{
										RenderList.drawrect(game,Game.gui[i].x + (Game.units[j].x / Map.GRIDW)* Game.gui[i].w / Map.MAXX,Game.gui[i].y + (Game.units[j].y / Map.GRIDH) * Game.gui[i].h / Map.MAXY,2,2,enemy,0);
									}
								}
								//RenderList.drawunfilledrect(game,Game.gui[i].x + (Game.CORNERX / Map.GRIDW) * Game.gui[i].w / Map.MAXX,Game.gui[i].y + (Game.CORNERY / Map.GRIDH) * Game.gui[i].h / Map.MAXY,(Game.RESOLUTIONX / Map.GRIDW) * Game.gui[i].w / Map.MAXX,(Game.RESOLUTIONY / Map.GRIDH) * Game.gui[i].h / Map.MAXY,RenderList.getrgb(255,255,200),0);//16sep2021
								if(Game.units[j].ping>0)//16sep2021
								{
									uint ping = RenderList.getrgb(96,255,255);
									int size = 1 + ((Game.frame/10) % 12);
									RenderList.drawunfilledrect(game,Game.gui[i].x + (Game.units[j].x / Map.GRIDW)* Game.gui[i].w / Map.MAXX - size,Game.gui[i].y + (Game.units[j].y / Map.GRIDH) * Game.gui[i].h / Map.MAXY - size,2*size,2*size,ping,0);
								}								
							}
							else//17sep2021
							{
								if(Game.units[j].redping>0)
								{
									uint redping = RenderList.getrgb(255,96,64);
									int size = 1 + ((Game.frame/10) % 6);
									RenderList.drawunfilledrect(game,Game.gui[i].x + (Game.units[j].x / Map.GRIDW)* Game.gui[i].w / Map.MAXX - size,Game.gui[i].y + (Game.units[j].y / Map.GRIDH) * Game.gui[i].h / Map.MAXY - size,2*size,2*size,redping,0);
									Game.units[j].redping--;
								}
							}
						}
					}
					RenderList.drawunfilledrect(game,Game.gui[i].x + (Game.CORNERX / Map.GRIDW) * Game.gui[i].w / Map.MAXX,Game.gui[i].y + (Game.CORNERY / Map.GRIDH) * Game.gui[i].h / Map.MAXY,(Game.RESOLUTIONX / Map.GRIDW) * Game.gui[i].w / Map.MAXX,(Game.RESOLUTIONY / Map.GRIDH) * Game.gui[i].h / Map.MAXY,RenderList.getrgb(255,255,200),0);//16sep2021
					if(Game.gui[i].action==ACTION_MINIMAPSCANLINE)
					{
						//special effects.......
						uint scanline = RenderList.getrgb(160,160,192);
						int scany = (Game.frame/2) % (1 + Game.gui[i].h);
						RenderList.drawunfilledrect(game,Game.gui[i].x,Game.gui[i].y + scany,Game.gui[i].w,2 ,scanline,0);//16sep2021
					}
					//if(Game.gui[i].mouseover==true && Game.mldown==true)//11mar2021
					//if(Game.gui[i].mouseover==true && Game.mldown==true && Functions.abs(Game.fmx - Game.smx)<10 && Functions.abs(Game.fmy - Game.smy)<10)//11mar2021//28mar2021
					//start---------------//28mar2021
					bool specialmouseover = false;
					if(Game.smx > Game.gui[i].x && Game.smx < Game.gui[i].x + Game.gui[i].w && Game.smy > Game.gui[i].y && Game.smy < Game.gui[i].y + Game.gui[i].h)
					{
						if(Game.fmx > Game.gui[i].x && Game.fmx < Game.gui[i].x + Game.gui[i].w && Game.fmy > Game.gui[i].y && Game.fmy < Game.gui[i].y + Game.gui[i].h)
						{
							specialmouseover = true;
						}
					}
					//end-----------------//28mar2021
					if(Game.gui[i].mouseover==true && Game.mldown==true && ((Functions.abs(Game.fmx - Game.smx)<10 && Functions.abs(Game.fmy - Game.smy)<10) || specialmouseover==true))//28mar2021
					{
						if(!Replay.IsPlaying())//21apr2021
						{
							Game.CORNERX = Map.GRIDW * (Map.MAXX * (Game.mx - Game.gui[i].x) / Game.gui[i].w) - (Game.RESOLUTIONX / 2);
							Game.CORNERY = Map.GRIDH * (Map.MAXY * (Game.my - Game.gui[i].y) / Game.gui[i].h) - (Game.RESOLUTIONY / 2);
							Game.minimappressed = 60;
							Unit.deselectall(game);
						}
					}
					if(Game.gui[i].mouseover)
					{
						Game.minimapframe = Game.frame;
					}
					if(Game.gui[i].mouseover==true && Game.mrclick==true && Game.paused==false)
					{
						//issue an order....
						//20sep2021 removed this....
						//Unit.issueorder(game,Map.GRIDW * (Map.MAXX * (Game.mx - Game.gui[i].x) / Game.gui[i].w),Map.GRIDH * (Map.MAXY * (Game.my - Game.gui[i].y) / Game.gui[i].h));
					}
				}
			}
		}
		//start----------//16oct2021
		if(Gui.statustext!="")//not sure I like this feature for this game.....might leave it off....don't apply to Java version....
		{
			Gui.statusx = 0;
			Gui.statusy = Game.RESOLUTIONY - 50;
			RenderList.drawrect(game,Gui.statusx,Gui.statusy,Game.RESOLUTIONX,50,RenderList.getrgb(24,24,32),0);
			RenderList.drawtext(game,Gui.statusx + 25,Gui.statusy + 15,Gui.statustext,RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);
			Gui.statustext = "";
		}
		//end--------------//16oct2021
			
	}

	
	
	
	public static void Purchase(int i)
	{
		int pid = Unit.GetPlayer(null);
		if(pid!=-1)
		{
			if(Game.units[pid].gold>=Game.gui[i].goldcost && Game.gui[i].sold==0)
			{
				Game.gui[i].sold = 1;
				Game.units[pid].gold-=Game.gui[i].goldcost;
				Game.gui[i].title = "Sold!";
				switch(Game.gui[i].saletype)
				{
				case 0://NOT USED
					break;
				case 1://Add Damage
					Game.units[pid].damage++;
					if(Game.units[pid].damage2>0){Game.units[pid].damage2++;}
					break;
				case 2://Add Armour
					Game.units[pid].armour++;
					break;
				case 3://Add Health Potion
					Game.units[pid].hp = Game.units[pid].basehp;
					break;
				case 4://Add Mana Potion
					Game.units[pid].mana = Game.units[pid].basemana;
					break;
				case 5://Add Frenzy + 5 points
					Game.units[pid].frenzy=5;
					break;
				case 6://Add Shock
					Game.units[pid].shock=1;
					break;
				case 7://Add Fearsome
					Game.units[pid].fearsome=1;
					break;
				case 8://Add Regeneration
					Game.units[pid].regeneration=2;
					break;
				case 9://Add highfirerate
					Game.units[pid].highfirerate=2;
					break;
				case 10://Add Craftsman
					Game.units[pid].craftsman=1;
					break;
				case 11://Add Stealth
					Game.units[pid].stealth=1;
					break;
				case 12://Add damagex
					Game.units[pid].damagex=1;
					break;
					
				}
			}
		}
	}

	public static void ActivateFoundStore(int triggerlink)
	{
		for(int i=0;i<Game.gui.Length;i++)
		{
			if(Game.gui[i].triggerlink!=triggerlink)
			{
				continue;
			}
			if(Game.gui[i].command.IndexOf("toggle")>=0)
			{
				if(triggerlink==Game.gui_charactersheet || triggerlink==Game.gui_founditem)
				{
					Game.gui[i].hidden = 0;
				}
				for(int tog=0;tog<Game.gui.Length;tog++)
				{
					if(Game.gui[tog].triggerlink!=(Game.gui[i].triggerlink) || Game.gui[tog].gamestate!=Game.gui[i].gamestate)
					{
						continue;
					}
					if(Game.gui[tog].link==("toggleon") || Game.gui[tog].link==("toggleoff"))
					{
						if(Game.gui[tog].link==("toggleon"))
						{
							Game.gui[tog].link="toggleoff";
							Gui.modal = 0;//21oct2021
						}
						else
						{
							Game.gui[tog].link="toggleon";
							Gui.modal = Game.gui[tog].triggerlink;//21oct2021
							if(triggerlink==Gui.LINK_UNIT_DETAIL2)
							{
								Gui.ACTIVATED_CHARSHEET = true;
								if(Game.gui[tog].hidden==1)
								{
									Game.gui[tog].hidden = 0;
								}
							}
							if(triggerlink==Game.gui_founditem)
							{
								Gui.ACTIVATED_FOUND = true;
								if(Game.gui[tog].hidden==1)
								{
									Game.gui[tog].hidden = 0;
								}
							}
						}
					}
				}
			}
			if(Game.gui[i].command.IndexOf("pause")>=0)
			{
				Game.togglepause = !Game.togglepause;
			}
		}
	}
	
	public static void ResetSingleStore(int triggerlink)
	{
		
	}
	
	public static void ResetStores()
	{
		
		
	}

	public static void DoFinalAiChoices()
	{
		int boardx = 0;
		int boardy = 0;
		while(Game.numenemyelements>0)
		{
			Game.numenemyelements--;
			boardy = Functions.Rand(0, 100) % 2;
			boardx = Functions.Rand(0,100) % 10;
			for(int p=0;p<15;p++)
			{
				if(boardy<=1 && (Game.campaignmode>0 || Game.vsai>0))//8oct2021
				{
					//red player
					for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
					{
						for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid!=-1)
							{
								if(Game.units[nid].boardy==boardy)//6oct2021
								{
									Game.units[nid].hp=0;
									Map.removeunit(nid, x, y);
									Game.units[nid].reset(null,nid);
								}
							}
						}
					}
					Game.templateindex++;
					Game.templateindex%=Game.templates.Length;
					while(Game.templates[Game.templateindex].name.IndexOf(Game.EnemyArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
					{
						Game.templateindex++;
						Game.templateindex%=Game.templates.Length;
					}
					int tcount = Game.templates[Game.templateindex].points;
					Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
					if(tcount>14)//21oct2021
					{
						tcount = 14;
					}
					for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
					{
						for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid==-1 && Map.passable(x, y))
							{
								for(int j=0;j<Game.units.Length;j++)
								{
									if(Game.units[j].hp<=0)
									{
										if(Game.units[j].createunitatxy(null, j, Game.templates[Game.templateindex], x, y))
										{
											tcount--;
										}
										break;
									}
								}
							}
							if(tcount<=0)
							{
								break;
							}
						
						}
						if(tcount<=0)
						{
							break;
						}
					}
					//AI choose unit to place....
					if(Game.templates[Game.templateindex].firebullet>0)
					{
						if(boardy==0)
						{
							if(Functions.rand(0, 100)<35)
							{
								break;
							}
						}
						if(boardy==1)
						{
							if(Functions.Rand(0, 100)<15)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].brave>0)
					{
						if(Functions.Rand(0, 100)<50)
						{
							break;
						}
					}
					if(Game.templates[Game.templateindex].leader>0)
					{
						if(boardy==0)
						{
							if(Functions.rand(0, 100)<25)
							{
								break;
							}
						}
						else
						{
							if(Functions.rand(0, 100)<15)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].walkspeed!=2)
					{
						if(boardx<3 || boardx>=7)
						{
							if(Functions.rand(0,100)<25)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].leader>0)
					{
						if(boardx>=3 || boardx<7)
						{
							if(Functions.rand(0,100)<15)
							{
								break;
							}
						}
					}
				}
			}
		}
		Game.gamemode = -1;
		Game.RESOLVE = 1;
		Game.oldboardx = -1;
		Game.oldboardy = -1;		
	}
	
	
	public static void SetUpDefeat() //17oct2021
	{
		Game game = null;
		if(Game.numelements>4)
		{
			Game.numelements = 4;
		}
		if(Game.numenemyelements>10)
		{
			Game.numenemyelements = 10;
		}
		int boardy = 7;
		int boardx = 0;
		for(boardx = 3;boardx<=6;boardx++)
		{
			if(boardy>=7)
			{
				//blue player
				//red player
				if(Game.numelements>0 || (Game.campaignmode==0 && Game.vsai<=0))
				{
					for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
					{
						for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid!=-1)
							{
								if(Game.units[nid].boardy==boardy)//6oct2021
								{
									Game.units[nid].hp=0;
									Map.removeunit(nid, x, y);
									Game.units[nid].reset(null,nid);
								}
							}
						}
					}
					Game.templateindex++;
					Game.templateindex%=Game.templates.Length;
					while(Game.templates[Game.templateindex].name.IndexOf(Game.FriendArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
					{
						Game.templateindex++;
						Game.templateindex%=Game.templates.Length;
					}
					Game.oldtemplateindex = Game.templateindex;
					if(NetworkUDP.Ready() && Game.vsai<=0)
					{
						int[] command = new int[3];
						command[0] = Game.templateindex;
						command[1] = boardx;
						command[2] = boardy;
						NetworkUDP.communicate(NetworkUDP.CREATEUNIT,command);
						firstunit++;
					}
					int tcount = Game.templates[Game.templateindex].points;
					Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
					if(tcount>14)//21oct2021
					{
						tcount = 14;
					}
					for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
					{
						for(int x=boardx*160;x<boardx*160+160;x+=Map.GRIDW/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid==-1 && Map.passable(x, y))
							{
								for(int j=0;j<Game.units.Length;j++)
								{
									if(Game.units[j].hp<=0)
									{
										if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
										{
											tcount--;
										}
										break;
									}
								}
							}
							if(tcount<=0)
							{
								break;
							}
						
						}
						if(tcount<=0)
						{
							break;
						}
					}
				}
			}
		}
		for(int i=0;i<Game.units.Length;i++)
		{
			if(Game.units[i].hp>0)
			{
				Game.units[i].hp = 5;
				Game.units[i].retreat = true;
				Game.units[i].retreatframe = Game.frame + Unit.RETREATDEATH;
				Game.units[i].timid = 1;
				Game.units[i].brave = 0;
				Game.units[i].leader = 0;
				Game.units[i].mob = 0;
			}
		}
		//add enemy.....
		while(Game.numenemyelements>0)
		{
			Game.numenemyelements--;
			boardy = Functions.Rand(0, 100) % 2;
			boardx = Functions.Rand(0,100) % 10;
			for(int p=0;p<15;p++)
			{
				if(boardy<=1 && (Game.campaignmode>0 || Game.vsai>0))//8oct2021
				{
					//red player
					for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
					{
						for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid!=-1)
							{
								if(Game.units[nid].boardy==boardy)//6oct2021
								{
									Game.units[nid].hp=0;
									Map.removeunit(nid, x, y);
									Game.units[nid].reset(null,nid);
								}
							}
						}
					}
					Game.templateindex++;
					Game.templateindex%=Game.templates.Length;
					while(Game.templates[Game.templateindex].name.IndexOf(Game.EnemyArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
					{
						Game.templateindex++;
						Game.templateindex%=Game.templates.Length;
					}
					int tcount = Game.templates[Game.templateindex].points;
					Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
					if(tcount>14)//21oct2021
					{
						tcount = 14;
					}
					for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
					{
						for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid==-1 && Map.passable(x, y))
							{
								for(int j=0;j<Game.units.Length;j++)
								{
									if(Game.units[j].hp<=0)
									{
										if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
										{
											tcount--;
										}
										break;
									}
								}
							}
							if(tcount<=0)
							{
								break;
							}
						}
						if(tcount<=0)
						{
							break;
						}
					}
					//AI choose unit to place....
					if(Game.templates[Game.templateindex].firebullet>0)
					{
						if(boardy==0)
						{
							if(Functions.rand(0, 100)<35)
							{
								break;
							}
						}
						if(boardy==1)
						{
							if(Functions.Rand(0, 100)<15)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].brave>0)
					{
						if(Functions.Rand(0, 100)<50)
						{
							break;
						}
					}
					if(Game.templates[Game.templateindex].leader>0)
					{
						if(boardy==0)
						{
							if(Functions.rand(0, 100)<25)
							{
								break;
							}
						}
						else
						{
							if(Functions.rand(0, 100)<15)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].walkspeed!=2)
					{
						if(boardx<3 || boardx>=7)
						{
							if(Functions.rand(0,100)<25)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].leader>0)
					{
						if(boardx>=3 || boardx<7)
						{
							if(Functions.rand(0,100)<15)
							{
								break;
							}
						}
					}
				}
			}
		}
		Game.gamemode = -1;
		Game.RESOLVE = 1;
		Game.oldboardx = -1;
		Game.oldboardy = -1;
	}

	public static void SetUpVictory() //17oct2021
	{
		Game game = null;
		int boardx = 0;
		int boardy = 7;
		if(Game.numelements>6)
		{
			Game.numelements = 6;
		}
		for(boardx = 0;boardx<=9;boardx++)
		{
			if(boardy>=7)
			{
				//blue player
				//red player
				if(Game.numelements>0 || (Game.campaignmode==0 && Game.vsai<=0))
				{
					for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
					{
						for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid!=-1)
							{
								if(Game.units[nid].boardy==boardy)//6oct2021
								{
									Game.units[nid].hp=0;
									Map.removeunit(nid, x, y);
									Game.units[nid].reset(null,nid);
								}
							}
						}
					}
					Game.templateindex++;
					Game.templateindex%=Game.templates.Length;
					while(Game.templates[Game.templateindex].name.IndexOf(Game.FriendArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
					{
						Game.templateindex++;
						Game.templateindex%=Game.templates.Length;
					}
					Game.oldtemplateindex = Game.templateindex;
					if(NetworkUDP.Ready() && Game.vsai<=0)
					{
						int[] command = new int[3];
						command[0] = Game.templateindex;
						command[1] = boardx;
						command[2] = boardy;
						NetworkUDP.communicate(NetworkUDP.CREATEUNIT,command);
						firstunit++;
					}
					int tcount = Game.templates[Game.templateindex].points;
					Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
					if(tcount>14)//21oct2021
					{
						tcount = 14;
					}
					for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
					{
						for(int x=boardx*160;x<boardx*160+160;x+=Map.GRIDW/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid==-1 && Map.passable(x, y))
							{
								for(int j=0;j<Game.units.Length;j++)
								{
									if(Game.units[j].hp<=0)
									{
										if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
										{
											tcount--;
										}
										break;
									}
								}
							}
							if(tcount<=0)
							{
								break;
							}
						
						}
						if(tcount<=0)
						{
							break;
						}
					}
				}
			}
		}
		//add enemy.....
		if(Game.numenemyelements>5)
		{
			Game.numenemyelements = 5;
		}
		while(Game.numenemyelements>0)
		{
			Game.numenemyelements--;
			boardy = Functions.Rand(0, 100) % 2;
			boardx = Functions.Rand(0,100) % 10;
			for(int p=0;p<15;p++)
			{
				if(boardy<=1 && (Game.campaignmode>0 || Game.vsai>0))//8oct2021
				{
					//red player
					for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
					{
						for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid!=-1)
							{
								if(Game.units[nid].boardy==boardy)//6oct2021
								{
									Game.units[nid].hp=0;
									Map.removeunit(nid, x, y);
									Game.units[nid].reset(null,nid);
								}
							}
						}
					}
					Game.templateindex++;
					Game.templateindex%=Game.templates.Length;
					while(Game.templates[Game.templateindex].name.IndexOf(Game.EnemyArmy)<0  || Game.templates[Game.templateindex].name.IndexOf("hero")>=0)
					{
						Game.templateindex++;
						Game.templateindex%=Game.templates.Length;
					}
					int tcount = Game.templates[Game.templateindex].points;
					Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
					if(tcount>14)
					{
						tcount = 14;//21oct2021
					}
					for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
					{
						for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
						{
							int nid = Map.cellunit(x, y);
							if(nid==-1 && Map.passable(x, y))
							{
								for(int j=0;j<Game.units.Length;j++)
								{
									if(Game.units[j].hp<=0)
									{
										if(Game.units[j].createunitatxy(game, j, Game.templates[Game.templateindex], x, y))
										{
											tcount--;
										}
										break;
									}
								}
							}
							if(tcount<=0)
							{
								break;
							}
						}
						if(tcount<=0)
						{
							break;
						}
					}
					//AI choose unit to place....
					if(Game.templates[Game.templateindex].firebullet>0)
					{
						if(boardy==0)
						{
							if(Functions.rand(0, 100)<35)
							{
								break;
							}
						}
						if(boardy==1)
						{
							if(Functions.Rand(0, 100)<15)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].brave>0)
					{
						if(Functions.Rand(0, 100)<50)
						{
							break;
						}
					}
					if(Game.templates[Game.templateindex].leader>0)
					{
						if(boardy==0)
						{
							if(Functions.rand(0, 100)<25)
							{
								break;
							}
						}
						else
						{
							if(Functions.rand(0, 100)<15)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].walkspeed!=2)
					{
						if(boardx<3 || boardx>=7)
						{
							if(Functions.rand(0,100)<25)
							{
								break;
							}
						}
					}
					if(Game.templates[Game.templateindex].leader>0)
					{
						if(boardx>=3 || boardx<7)
						{
							if(Functions.rand(0,100)<15)
							{
								break;
							}
						}
					}
				}
			}
		}
		
		for(int i=0;i<Game.units.Length;i++)
		{
			if(Game.units[i].hp>0 && Game.templates[Game.units[i].templateid].name.IndexOf(Game.EnemyArmy)>=0)
			{
				Game.units[i].hp = 5;
				Game.units[i].retreat = true;
				Game.units[i].retreatframe = Game.frame + Unit.RETREATDEATH;
				Game.units[i].timid = 1;
				Game.units[i].brave = 0;
				Game.units[i].leader = 0;
				Game.units[i].mob = 0;
			}
		}
		Game.gamemode = -1;
		Game.RESOLVE = 1;
		Game.oldboardx = -1;
		Game.oldboardy = -1;
	}
	
	
	public static void redrawminimap(int j)
	{
	}
}
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Gibbet
	{
		public static int MAXGIBBET = 100 * Config.FACTOR * 10;
		public static int MAXINDEX = 0;
		public static float ACCELERATION = 0.25f;
		public static float GROUNDH = 65.0f;
		public static int GIBCOUNTER = 0;
		public static int GIBMOD = 8;
		public static float VX = 1.5f;
		public static float VY = 5f;
		public static float ELASTIC = -0.5f;
		public static float MINVY = 0.01f;
		public static int LIFE = 180;
		//
		public int img; //(array index into Game.images[img]
		public int imgindex; //0-99 (sub position within the cell)
		public int subx;
		public int suby;
		public int subw;
		public int subh;
		public float vx;
		public float vy;
		public float x;
		public float y;
		public float h;
		public float yy;
		public int scrx;
		public int scry;
		public int life;
		public float angle;
		
		///////////////////Method Definition///////////////
		public Gibbet()
		{
			img = -1;
			life = 0;
		}
		
		///////////////////Method Definition///////////////
		public static void clearall(Game game)
		{
			for(int i=0;i<MAXGIBBET;i++)
			{
				Game.gibbet[i].life = 0;
			}
			MAXINDEX = 0;
		}
		
		///////////////////Method Definition///////////////
		public static void makegibbets(Game game,int unitid)
		{
			Functions.saveseed(Functions.seed);
			int index = 0;
			for(int i=0;i<MAXGIBBET;i++)
			{
				if(Game.gibbet[i].life<=0)
				{
					if(i>MAXINDEX)
					{
						MAXINDEX = i;
					}
					Game.gibbet[i] = new Gibbet(game,Game.units[unitid].cat,index,Game.units[unitid].x,Game.units[unitid].y,Game.units[unitid].offy);
				}
				index++;
				if(index>=99)
				{
					break;
				}
			}
			Functions.restoreseed();
		}
		
		///////////////////Method Definition///////////////
		public Gibbet(Game game,int lpimg,int lpimgindex,int lpmapx,int lpmapy,int lpoffy)
		{
			img = lpimg;
			imgindex = lpimgindex;
			x = (float)lpmapx;
			y = (float)lpmapy;
			yy = 0;
			h = (float)lpoffy;
			angle = (float)Functions.rand(0,628)*0.01f;
			if(lpimg>=0 && lpimg<Game.images.Length)
			{
				int wx = Game.images[img].cwx / 10;
				int wy = Game.images[img].chy / 10;
				int ix = imgindex % 10;
				int iy = (imgindex - ix) / 10;
				subx = wx * ix;
				suby = wy * iy;
				subw = wx;
				subh = wy;
				life = LIFE;
				vx = (float)Functions.rand(-100,100) * 0.01f * VX;
				vy = (float)Functions.rand(-100,25) * 0.01f * VY;
				x+=subx - wx/2;
				y+=suby - wy/2;
				yy+=suby;
			}
			else
			{
				img = -1;
				life = 0;
			}
		}
		
		///////////////////Method Definition///////////////
		public static void updateall(Game game)
		{
			for(int i=0;i<=MAXINDEX;i++)
			{
				if(Game.gibbet[i].life>0)
				{
					Game.gibbet[i].life--;
					Game.gibbet[i].x+=Game.gibbet[i].vx * (float)(Config.delta)/100f;//18sep2021
					Game.gibbet[i].y+=Game.gibbet[i].vy * (float)(Config.delta)/100f;//18sep2021
					Game.gibbet[i].yy+=Game.gibbet[i].vy * (float)(Config.delta)/100f;//18sep2021
				
					Game.gibbet[i].vy+=ACCELERATION;
					Game.gibbet[i].scrx = (int)Game.gibbet[i].x - Game.CORNERX;
					Game.gibbet[i].scry = (int)Game.gibbet[i].y - Game.CORNERY + (int)Game.gibbet[i].h;
					Game.gibbet[i].angle+=(float)Functions.sign(Game.gibbet[i].vx)*0.05f;
					if(Game.gibbet[i].yy>GROUNDH)
					{
						Game.gibbet[i].vy *= ELASTIC;
					}
					if(Functions.abs(Game.gibbet[i].vy)<MINVY)
					{
						Game.gibbet[i].life = 0;
					}
					if(Game.gibbet[i].scrx < -100 || Game.gibbet[i].scry < -100 || Game.gibbet[i].scrx > Game.RESOLUTIONX + 100 || Game.gibbet[i].scry > Game.RESOLUTIONY + 100)
					{
						Game.gibbet[i].life = 0;
					}
				}
				
				if(Game.gibbet[i].life<=0 && i==MAXINDEX)
				{
					MAXINDEX--;
					if(MAXINDEX<0)
					{
						MAXINDEX = 0;
					}
				}
			}
		}
		
		///////////////////Method Definition///////////////
		public void draw(Game game)
		{
			RenderList.drawsubimage(game,Game.images[img].texture,scrx,scry,angle,0.7f,0.7f,0,0,false,1f,img,subx,suby,subw,subh);		
		}
		
		///////////////////Method Definition///////////////
		public static void drawall(Game game)
		{
			for(int i=0;i<=MAXINDEX;i++)
			{
				if(Game.gibbet[i].life>0 && Game.gibbet[i].scrx>=-100 && Game.gibbet[i].scry>=-100 && Game.gibbet[i].scrx<Game.RESOLUTIONX+100 && Game.gibbet[i].scry<Game.RESOLUTIONY+100)
				{
					Game.gibbet[i].draw(game);
				}
			}
		}
		
	}
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Blood
	{
		public static int BLOODSPAWNER = 1000;
		public static int MAXBLOOD = 800 * Config.FACTOR;
		public static int NUMBLOOD = 20;
		public static int bloodcount = 0;
		public static float ACCELERATION = -0.2f;
		public static int DUSTCLOUD = 100;
		public static int SPELL = 200;
		public static int FIRESPELL = 201;
		public static int DARKSPELL = 202;
		public static int GOODSPELL = 203;
		public static int GREENSPELL = 204;//15mar2021
		public static int REDSPELL = 205;//15mar2021
		public static int LIGHTNINGSPELL = 206;//28mar2021
		public static int WHIRLWINDSPELL = 207;//28mar2021
		public static int WHIRLWINDGRID = 5;//28mar2021
		public float cx;
		public float cy;
		public float x;
		public float y;
		public float h;
		public float vx;
		public float vy;
		public float vh;
		public int life;
		public int red;
		public int green;
		public int blue;
		public int sizex;
		public int sizey;
		public float angle;
		public int magic;//28mar2021
		public int ismagic;

///////////////////Method Definition///////////////
		public Blood(int sx,int sy)
		{
			x = (float)sx;
			y = (float)sy;
			cx = sx;
			cy = sy;
			life = 90;
			h = 1.8f;
			angle = (float) Functions.rand(0,400) / 60f;
			vh = 2f * (float)(Functions.rand(70,100)) / 100f;
			vx = -2f * (float)(Functions.rand(-50,50)) / 100f;
			vy = -2f * (float)(Functions.rand(-50,50)) / 100f;
			red = Functions.rand(192,255);
			green = Functions.rand(32,128);
			blue = Functions.rand(96,160);
			sizex = Functions.rand(1,5);
			sizey = Functions.rand(1,5);
			ismagic = 0;
		}

///////////////////Method Definition///////////////
		public Blood()
		{
			//all set to zero....
		}

///////////////////Method Definition///////////////
		public static void makeblood(Game game,int sx,int sy,int magic)
		{
			//make a blood or fiery or spell effect in game
			Functions.saveseed(Functions.seed);
			sy += Map.getheight(sx,sy);
			for(int j=0;j<Blood.NUMBLOOD;j++)
			{
				for(int i=0;i<Game.blood.Length;i++)
				{
					if(Game.blood[i].life<=0)
					{
						Game.blood[i].magic = magic;//28mar2021
						Game.blood[i].x = (float)sx;
						Game.blood[i].y = (float)sy;
						Game.blood[i].cx = (float)sx;
						Game.blood[i].cy = (float)sy;
						Game.blood[i].life = 120;
						if(magic==LIGHTNINGSPELL)
						{
							Game.blood[i].life = 1;//19oct2021 was 2
						}
						Game.blood[i].h = 1.8f;
						Game.blood[i].vh = 3f * (float)(Functions.rand(70,100)) / 100f;
						Game.blood[i].vx = -1.5f * (float)(Functions.rand(-50,50)) / 100f;
						Game.blood[i].vy = -1.5f * (float)(Functions.rand(-50,50)) / 100f;
						if(magic==WHIRLWINDSPELL)
						{
							Game.blood[i].life = 2;
							Game.blood[i].vh = 0;
							Game.blood[i].vx = 0;
							Game.blood[i].vy = 0;
						}
						Game.blood[i].red = Functions.rand(128,200);
						Game.blood[i].green = Functions.rand(16,96);
						Game.blood[i].blue = Functions.rand(32,128);
						Game.blood[i].sizex = Functions.rand(1,5);
						Game.blood[i].sizey = Functions.rand(1,5);	
						Game.blood[i].ismagic = magic;
						if(magic>0 && magic<BLOODSPAWNER)
						{
							Game.blood[i].red = Functions.rand(140,180);
							Game.blood[i].green = Functions.rand(100,140);
							Game.blood[i].blue = Functions.rand(80,120);
							Game.blood[i].h = 0.1f;
						}
						if(magic>=SPELL && magic<=SPELL+10)
						{
							Game.blood[i].life = 30;
							/*
							Game.blood[i].sizex/=2;
							Game.blood[i].sizey/=2;
							if(Game.blood[i].sizex<2)
							{
								Game.blood[i].sizex = 2;
							}
							if(Game.blood[i].sizey<2)
							{
								Game.blood[i].sizey = 2;
							}
							*/
							Game.blood[i].vh/=3;
							Game.blood[i].vx/=3;
							Game.blood[i].vy/=3;
							Game.blood[i].angle = (float) Functions.rand(0,400) / 60f;
							if(magic==FIRESPELL)
							{
								Game.blood[i].red = Functions.rand(180,250);
								Game.blood[i].green = Functions.rand(160,220);
								Game.blood[i].blue = Functions.rand(80,120);	
								Game.blood[i].sizex*=2;//16sep2021
							}
							if(magic==GOODSPELL)
							{
								Game.blood[i].red = Functions.rand(30,80);
								Game.blood[i].green = Functions.rand(120,220);
								Game.blood[i].blue = Functions.rand(180,240);
							}
							if(magic==DARKSPELL)
							{
								Game.blood[i].red = Functions.rand(180,250);
								Game.blood[i].green = Functions.rand(30,80);
								Game.blood[i].blue = Functions.rand(180,240);
							}
							//start-------//15mar2021
							if(magic==GREENSPELL)
							{
								Game.blood[i].red = Functions.rand(20,80);
								Game.blood[i].green = Functions.rand(180,250);
								Game.blood[i].blue = Functions.rand(80,160);	
							}
							if(magic==REDSPELL)
							{
								Game.blood[i].red = Functions.rand(180,250);
								Game.blood[i].green = Functions.rand(30,80);
								Game.blood[i].blue = Functions.rand(30,80);
							}
							//end---------//15mar2021
						}
						if(magic>BLOODSPAWNER)
						{
							Game.blood[i].h = 0.1f;
							if(magic-BLOODSPAWNER==Game.PLAYERFACTION)
							{
								Game.blood[i].red = Functions.rand(80,120);
								Game.blood[i].green = Functions.rand(180,240);
								Game.blood[i].blue = Functions.rand(80,120);
							}
							if(magic-BLOODSPAWNER==Game.SKIRMISHENEMYFACTION)
							{
								Game.blood[i].green = Functions.rand(80,120);
								Game.blood[i].red = Functions.rand(180,240);
								Game.blood[i].blue = Functions.rand(180,240);
							}
						}
						break;
					}
				}
				if(magic==LIGHTNINGSPELL)//28mar2021
				{
					break;
				}
				if(magic==WHIRLWINDSPELL)//28mar2021
				{
					break;
				}
				if(magic>=FIRESPELL)//12apr2021
				{
					if(Functions.rand(0,100)<33)
					{
						break;//12apr2021
					}
				}
			}
			Functions.restoreseed();
		}

///////////////////Method Definition///////////////
		public static void clearall(Game game) //29oct2020
		{
			//remove all the fx from the visuals of the game 
			for(int i=0;i<Game.blood.Length;i++)
			{
				Game.blood[i].life = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void updateall(Game game)
		{
			//update all the visual fx
			bloodcount=0;
			for(int i=0;i<Game.blood.Length;i++)
			{
				if(Game.blood[i].life>0)
				{
					bloodcount++;
					Game.blood[i].life--;
					Game.blood[i].x+=Game.blood[i].vx * (float)(Config.delta)/100f;//18sep2021
					Game.blood[i].y+=Game.blood[i].vy * (float)(Config.delta)/100f;//18sep2021
					Game.blood[i].h+=Game.blood[i].vh * (float)(Config.delta)/100f;//18sep2021
					Game.blood[i].vh+=Blood.ACCELERATION;
					if(Game.blood[i].h<0)
					{
						Game.blood[i].vh*=-0.5f;
						Game.blood[i].h=0;
						Game.blood[i].vx*=0.6f;
						Game.blood[i].vy*=0.6f;
					}
					//if(Functions.abs(Game.blood[i].vx)<0.1f && Functions.abs(Game.blood[i].vy)<0.1f)//28mar2021
					if(Functions.abs(Game.blood[i].vx)<0.1f && Functions.abs(Game.blood[i].vy)<0.1f && Game.blood[i].magic!=WHIRLWINDSPELL)//28mar2021
					{
						Game.blood[i].life=0;
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void drawall(Game game)
		{
			//draw all the visual fx
			if(bloodcount>MAXBLOOD)
			{
				bloodcount=MAXBLOOD;
			}
			for(int i=0;i<bloodcount;i++)
			{
				if(Game.blood[i].life>0)
				{
					//23mar2021 check if on screen if not then don't draw
					if(Game.blood[i].x-Game.CORNERX>=-100 && Game.blood[i].x-Game.CORNERX<Game.RESOLUTIONX+100 && Game.blood[i].y - Game.blood[i].h - Game.CORNERY>=-100 && Game.blood[i].y - Game.blood[i].h - Game.CORNERY<=Game.RESOLUTIONY+100)
					{
						if(Game.blood[i].magic==LIGHTNINGSPELL && Game.lightning!=-1)
						{
							int frame = (int)Functions.abs(Functions.rand(0,1000)) % (Game.images[Game.lightning].cwn * Game.images[Game.lightning].chn);
							RenderList.drawimage(game,Game.images[Game.lightning].texture,(int)Game.blood[i].x-Game.CORNERX,(int)(Game.blood[i].y - Game.blood[i].h)-Game.CORNERY - Game.images[Game.lightning].chy/2,0,1f,1f,frame,1,false,1f,Game.lightning);	
						}
						else
						{
							if(Game.blood[i].magic==WHIRLWINDSPELL && Game.whirlwind!=-1)
							{
								int frame = (int)Functions.abs((Game.frame/10)) % (Game.images[Game.whirlwind].cwn * Game.images[Game.whirlwind].chn);
								RenderList.drawimage(game,Game.images[Game.whirlwind].texture,(int)Game.blood[i].x-Game.CORNERX,(int)(Game.blood[i].y - Game.blood[i].h)-Game.CORNERY - Game.images[Game.whirlwind].chy/2,0,0.5f,0.5f,frame,0,false,1f,Game.whirlwind);		
							}
							else
							{
								if(Game.spellball!=-1 && Game.blood[i].magic>=FIRESPELL)//12apr2021
								{
									int frame = 0;
									switch(Game.blood[i].magic)
									{
										case 205:
										frame = Game.REDBALL;
										break;
										case 204:
										frame = Game.GREENBALL;
										break;
										case 203:
										frame = Game.BLUEBALL;
										break;
										case 201:
										frame = Game.ORANGEBALL;
										break;
										case 202:
										frame = Game.PURPLEBALL;
										break;
									}
									RenderList.drawimage(game,Game.images[Game.spellball].texture,(int)Game.blood[i].x-Game.CORNERX,(int)(Game.blood[i].y - Game.blood[i].h)-Game.CORNERY - Game.images[Game.spellball].chy/2,Game.blood[i].angle,0.7f+0.06f*(float)Game.blood[i].sizex,0.7f+0.06f*(float)Game.blood[i].sizex,frame,1,false,1f,Game.spellball);											
								}
								else
								{
									RenderList.drawrect(game,(int)Game.blood[i].x-Game.CORNERX,(int)(Game.blood[i].y - Game.blood[i].h) - Game.CORNERY,Game.blood[i].sizex,Game.blood[i].sizey,RenderList.getrgb(Game.blood[i].red,Game.blood[i].green,Game.blood[i].blue),0);	
								}
							}
						}
					}
				}
			}
		}
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Bullet
	{
		//for Archers
		public static int MAXBULLET = 200 * Config.FACTOR;
		public static int MAXINDEX = 0; //26mar2021
		public static float ACCELERATION = 0.05f;
		public float x;
		public float y;
		public float h; //height
		public int tx;
		public int ty;
		public float vx;
		public float vy;
		public float vh; //
		public int life;
		public static int nextfree = 0;
		public int flaming;
		public static int FIRESPELL = 201;
		public static int DARKSPELL = 202;
		public static int GOODSPELL = 203;
		//15mar2021 - added some more colours......
		public static int GREENSPELL = 204;
		public static int REDSPELL = 205;
		public static int LIGHTNINGSPELL = 206;//28mar2021
		public static int WHIRLWINDSPELL = 207;//28mar2021
		
///////////////////Method Definition///////////////
		public Bullet()
		{
			flaming = 0;
		}

///////////////////Method Definition///////////////
		public Bullet(int sx, int sy,int fx,int fy,int fiery)
		{
			flaming = fiery;
			x = sx;
			y = sy;
			h = 1.5f;
			float dist = 0.01f+(float)(Math.Sqrt((double)((sx-fx)*(sx-fx)+(sy-fy)*(sy-fy))));
			float dx = (float)(fx-sx)/dist;
			float dy = (float)(fy-sy)/dist;
			vx = 9f * dx;
			vy = 9f * dy;
			//vh = -5f;
			vh = -5f * (float)Functions.rand(80,200)/100f;
			life = 180;
			tx = fx;
			ty = fy;
		}

///////////////////Method Definition///////////////
		public static void createbullet(Game game,int sx,int sy, int fx, int fy,int fiery)
		{
			Functions.saveseed(Functions.seed);
			//create a bullet in the game
			if(nextfree<0 || nextfree>Game.bullets.Length-1)//28mar2021
			{
				nextfree=0;
				Functions.restoreseed();
				return;
			}
			if(Game.bullets[nextfree].life>0)
			{
				nextfree = -1;
				for(int i=0;i<MAXBULLET;i++)
				{
					if(Game.bullets[i].life<=0)
					{
						nextfree = i;
						break;
					}
				}
			}
			if(nextfree!=-1)
			{
				Game.bullets[nextfree] = new Bullet(sx,sy,fx,fy,fiery);
			}
			Functions.restoreseed();
		}

///////////////////Method Definition///////////////
		public static void clearall(Game game) //ml29oct2020
		{
			//clear all bullets from the game
			for(int i=0;i<Game.bullets.Length;i++)
			{
				Game.bullets[i].life = 0;
			}
		}

///////////////////Method Definition///////////////
		public static void updateall(Game game)
		{
			//update all bullets in the game
			//start---------------//26mar2021
			if(Game.bullets[MAXINDEX].life<=0 && MAXINDEX>0)
			{
				MAXINDEX--;
			}
			//end-----------------//26mar2021
			for(int i=0;i<Game.bullets.Length;i++)
			{
				Game.bullets[i].update(game);
				if(Game.bullets[i].life<=0)
				{
					nextfree = i;
				}
				else //26mar2021
				{
					if(i>MAXINDEX)
					{
						MAXINDEX = i;
					}
				}
			}
		}

///////////////////Method Definition///////////////
		public static void drawall(Game game)
		{
			//draw all bullets in the game
			//for(int i=0;i<Game.bullets.Length;i++)//26mar2021
			for(int i=0;i<=MAXINDEX;i++)	//26mar2021
			{
				Game.bullets[i].draw(game);
			}
		}

///////////////////Method Definition///////////////
		public void update(Game game)
		{
			//update all bullets in the game
			if(life<=0)
			{
				return;
			}
			x+=vx * (float)(Config.delta)/100f;//18sep2021
			y+=vy * (float)(Config.delta)/100f;//18sep2021
			h+=vh * (float)(Config.delta)/100f;//18sep2021
			vh+=ACCELERATION;
			life--;
			if(h>=0)
			{
				life = 0;
			}
			if(Functions.abs(tx-x)<Map.GRIDW && Functions.abs(ty-y)<Map.GRIDH)
			{
				life = 0;
			}
			if(Functions.abs(flaming)>=Blood.FIRESPELL)
			{
				Blood.makeblood(game,(int)x,(int)y,(int)Functions.abs(flaming));
			}
		}

///////////////////Method Definition///////////////
		public void draw(Game game)
		{
			//draw all bullets in the game
			if(life<=0)
			{
				return;
			}
			int scrfx = (int)x - Game.CORNERX;
			int scrfy = (int)y - Game.CORNERY;
			int scrsx = (int)(x-vx) - Game.CORNERX;
			int scrsy = (int)(y-vy) - Game.CORNERY;
			int scrsh = (int)(h-vh);
			int scrfh = (int)h;
			if(flaming==0)
			{
				//23mar2021 only draw if on screen....
				if(scrsx>=-100 && scrsx<Game.RESOLUTIONX+100 && scrsy+scrfh>=-100 && scrsy+scrfh<=Game.RESOLUTIONY+100)
				{
					//RenderList.drawline(game,scrsx,scrsy+scrfh,scrfx,scrfy + scrfh,RenderList.getrgb(12,12,12),0);//23mar2021
					RenderList.drawline(game,scrsx,scrsy+scrsh,scrfx,scrfy + scrfh,RenderList.getrgb(12,12,12),0);//23mar2021
				}
			}
			else
			{
				//drawfireball(game,scrsx,scrsy,scrfx,scrfy);
			}
		}

///////////////////Method Definition///////////////
		public void drawfireball(Game game,int sx0,int sy0,int fx0,int fy0)
		{
			int sy = sy0;
			int fy = fy0;
			int sx = sx0;
			int fx = fx0;
			if(fy<sy)
			{
				fy = sy0;
				sy = fy0;
				fx = sx0;
				sx = fx0;
			}
			int hh = Functions.rand(2,4);
			int r = 255;
			int g = 255;
			int b = 255;
			for(int j=0;j<3;j++)
			{
				for(int l=0;l<hh;l++)
				{
					if(flaming>0)
					{
						g+= Functions.rand(-32,0);	
						b+= Functions.rand(-96,0);
					}
					else
					{
						r+= Functions.rand(-32,0);	
						g+= Functions.rand(-96,0);
					}
					if(g<0)
					{
						g = 0;
					}
					if(b<0)
					{
						b = 0;
					}
					if(r<0)
					{
						r = 0;
					}
					int xadd = (l + 1) * (int)Functions.rand(- ((int)Functions.abs(fx-sx)+1),1 + (int)Functions.abs(fx-sx));
					int yadd = (l + 1) * (int)Functions.rand(- ((int)Functions.abs(fy-sy)+1),1 + (int)Functions.abs(fy-sy));
					if(Functions.abs(xadd)>4)
					{
						xadd = 4 * Functions.sign(xadd);
					}
					if(Functions.abs(yadd)>4)
					{
						yadd = 4 * Functions.sign(yadd);
					}
					if(Functions.rand(0,1000 + l * 200)<500)
					{
						if(flaming>1)
						{
							RenderList.drawrect(game,sx+xadd * 3,sy+yadd * 3,6 * 2,6 * 2,RenderList.getrgb(r,g,b),0);
						}
						RenderList.drawrect(game,sx+xadd,sy+yadd,6,6,RenderList.getrgb(r,g,b),0);
					}
				}
			}
		}
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class TriggerHelper
	{
		public static int TYPE_VICTORY = 1;
		public static int TYPE_IMMEDIATE_DEFEAT = 2;
		public static int TYPE_OR_DEFEAT = 18;
		public static int TYPE_IMMEDIATE_CHATTER = 3;
		public static int TYPE_CONDITIONAL_CHATTER = 4;
		//
		//
		public static int TYPE_NOCONDITION = 0;
		public static int TYPE_ACTIVATECHATTER = 5;
		public static int TYPE_DEATHCOUNT = 6;
		public static int TYPE_ACTIVATE = 10;
		//
		public static int TYPE_RETREAT = 7;
		public static int TYPE_FIRE = 8;
		public static int TYPE_SPAWNER = 9;
		public static int TYPE_HEALING = 11;
		public static int TYPE_MOVETO = 15;
		public static int TYPE_MAKEFRIEND = 12;
		public static int TYPE_MAKEENEMY = 13;
		public static int TYPE_MAKENEUTRAL = 14;
		public static int TYPE_SETAI = 17;
		public static int TYPE_CREATE = 20;//25mar2021
		public static int TYPE_REMOVE = 21;//25mar2021
		//
		public static int TYPE_LOOP = 16;
		public static string[] constructor = new string[17];
		public static int constructorindex = -1;
		public static string[] triggers = new string[40];
		public static int triggerindex = -1;
		public static int[] iflocation = new int[4];
		public static int[] atlocation = new int[4];
		public static int fieldindex = 0;
		public static int CONSTRUCTOR_IF = 0;
		public static int CONSTRUCTOR_N = 2;
		public static int CONSTRUCTOR_COMP = 1;
		public static int CONSTRUCTOR_UNIT = 3;
		public static int CONSTRUCTOR_X = 4;
		public static int CONSTRUCTOR_Y = 5;
		public static int CONSTRUCTOR_FX = 6;
		public static int CONSTRUCTOR_FY = 7;
		public static int CONSTRUCTOR_DO = 8;
		public static int CONSTRUCTOR_TO_UNIT = 9;
		public static int CONSTRUCTOR_AT_LOCATION = 10;
		public static int CONSTRUCTOR_REPEAT = 14;
		public static string CONSTRUCT_IFBRING = "-if bring";
		public static string CONSTRUCT_IFKILL = "-if kill";
		public static string CONSTRUCT_EXACTLY = "-exactly ";
		public static string CONSTRUCT_LESS = "-less than ";
		public static string CONSTRUCT_MORE = "-more than ";
		public static string CONSTRUCT_N = "-0 ";
		public static string CONSTRUCT_UNIT = "-unit ";
		public static string CONSTRUCT_TO = "-x,y,fx,fy ";
		public static string CONSTRUCT_THEN_DO = "-then do/say ";
		public static string CONSTRUCT_TO_UNIT = "-to unit/say ";
		public static string CONSTRUCT_AT_LOC = "-at location ";
		public static string CONSTRUCT_REPEAT = "-repeat ";

///////////////////Method Definition///////////////
		public static string CONSTRUCT_OK = "-Ok?(Left click to confirm right click to alter)";
		public static string[] field0 = {"-if bring","-if kill"};
		public static string[] field1 = {"-less than","-exactly","-more than"};
		public static int field2 = 0;
		public static int field1index = 0;
		public static int field3index = 0;
		public static int field9index = 0;
		public static int field8index = 0;
		public static int field14 = 0;
		public static int field15 = 0;
		public static string[] field8 = {"-victory ","-immediate defeat ","-'or' defeat ","-chatter ","-conditionalchatter ","-retreat ","-create fire ","-spawner alter ","-heal ","-move to ","-make friend ","-make enemy ","-make neutral ","-set ai ","-create ","-remove "};
		//in editor

///////////////////Method Definition///////////////
		public static void gettext(Game game)
		{
			//helper for the Trigger text 
			constructorindex = 9;
			constructor[9] = Game.edittriggerstring;
			if(Game.mlclick)
			{
				Game.EDITMODE = Game.EDITMODE_TRIGGER;
				constructor[10] = "x-300";
				constructor[11] = "y-780";
				atlocation[0] = 300;
				atlocation[1] = 780;
				constructor[12] = "fx-0";
				constructor[13] = "fy-0";
				constructor[14] = "0";
				constructorindex = 15;
				//constructorindex++;
				Game.edittriggerstring = "";
			}
			if(Game.mrclick)
			{
				Game.EDITMODE = Game.EDITMODE_TRIGGER;
				constructor[constructorindex]="";
				Game.edittriggerstring = "";
				constructorindex--;
			}
		}

///////////////////Method Definition///////////////
		public static string constructorstring(Game game,bool leftclick, bool rightclick,int wheeldirn)
		{
			//return a string containing the 'programming language text' for the trigger
			//display only - in the game a list of numbers are mostly used
			string value = "";
			if(wheeldirn!=0)
			{
				switch(constructorindex)
				{
					case 15:
					field15+=wheeldirn;
					//constructor[15]="-special:"+field15;//22mar2021
					constructor[15]=Translation.TranslateWord("-special:",false)+field15;//22mar2021
					string stxt = "";
					if(field8index==3 || field8index==4)
					{
						//stxt = "-talk to:";//22mar2021
						stxt = Translation.TranslateWord("-talk to:",false);//22mar2021
					}
					if(field8index==7)
					{
						//stxt = "-on(1)/off(-1):";//22mar2021
						stxt = Translation.TranslateWord("-on(1)/off(-1):",false);//22mar2021
					}
					constructor[15] = stxt+field15;
					break;
					case 0: //if
					fieldindex++;
					fieldindex%=2;
					//constructor[0] = field0[fieldindex];//22mar2021
					constructor[0] = Translation.TranslateWord(field0[fieldindex],false);//22mar2021
					break;
					case 1: //comp
					field1index+=(int)Functions.sign(wheeldirn);
					if(field1index<0)
					{
						field1index=field1.Length - 1;
					}
					field1index%=field1.Length;
					//constructor[1] = field1[field1index];//22mar2021
					constructor[1] = Translation.TranslateWord(field1[field1index],false);//22mar2021
					break;
					case 2: //n
					if(wheeldirn>0)
					{
						field2++;
					}
					else
					{
						field2--;
					}
					//constructor[2] = "-this many:"+field2;//22mar2021
					constructor[2] = Translation.TranslateWord("-this many:",false)+field2;//22mar2021
					break;
					case 3: //unit
					field3index+=wheeldirn;
					if(field3index<0)
					{
						field3index = Game.templates.Length - 1;
					}
					field3index%=Game.templates.Length;
					field3index=(int)Functions.abs(field3index);
					field3index%=Game.templates.Length;
					//constructor[3] = "-"+Game.templates[field3index].name+" to area:"; //22mar2021
					constructor[3] = "-"+Game.templates[field3index].dname()+Translation.TranslateWord(" to area:",false);//22mar2021
					break;
					case 8: //do
					field8index+=wheeldirn;
					if(field8index<0)
					{
						field8index = field8.Length - 1;
					}
					field8index%=field8.Length;
					field8index=(int)Functions.abs(field8index);
					if(field8index==4 && fieldindex==1)
					{
						field8index+=wheeldirn;
						field8index%=field8.Length;
						field8index=(int)Functions.abs(field8index);
					}
					field8index%=field8.Length;
					constructor[8] = field8[field8index];//22mar2021
					//constructor[8] = Translation.TranslateWord(field8[field8index],false);//22mar2021
					break;
					case 9: //to unit
					field9index+=wheeldirn;
					if(field9index<0)
					{
						field9index = Game.templates.Length - 1;
					}
					field9index%=Game.templates.Length;
					field9index=(int)Functions.abs(field9index);
					field9index%=Game.templates.Length;
					//constructor[9] = "-"+Game.templates[field9index].name+" in area:";//22mar2021
					constructor[9] = "-"+Game.templates[field9index].dname()+Translation.TranslateWord(" in area:",false);//22mar2021
					break;
					case 14: //loop
					field14+=wheeldirn;
					//constructor[14] = "-repeat this often:"+field14;//22mar2021
					constructor[14] = Translation.TranslateWord("-repeat this often:",false)+field14;//22mar2021
					break;
				}
			}
			if(constructorindex<=3)
			{
				for(int l=0;l<4;l++)
				{
					iflocation[l] = -1;
				}
			}
			if(constructorindex>=4 && constructorindex<=5)
			{
				constructor[4] = "-x" + Game.editgridx;
				constructor[5] = "-y" + Game.editgridy;
				iflocation[0] = Game.editgridx;
				iflocation[1] = Game.editgridy;
			}
			if(constructorindex>=6 && constructorindex<=7)
			{
				constructor[6] = "-fx" + Game.editgridx;
				constructor[7] = "-fy" + Game.editgridy;
				iflocation[2] = Game.editgridx;
				iflocation[3] = Game.editgridy;
			}
			if(constructorindex<=9)
			{
				for(int l=0;l<4;l++)
				{
					atlocation[l] = -1;
				}
			}
			if(constructorindex>=10 && constructorindex<=11)
			{
				constructor[10] = "-x" + Game.editgridx;
				constructor[11] = "-y" + Game.editgridy;
				atlocation[0] = Game.editgridx;
				atlocation[1] = Game.editgridy;
			}
			if(constructorindex>=12 && constructorindex<=13)
			{
				constructor[12] = "-fx" + Game.editgridx;
				constructor[13] = "-fy" + Game.editgridy;
				atlocation[2] = Game.editgridx;
				atlocation[3] = Game.editgridy;
			}
			int oindex = constructorindex;
			if(leftclick)
			{
				if(constructorindex>=0)
				{
					if(constructor[constructorindex]!="")
					{
						constructorindex++;
						if(constructorindex==9)
						{
							if(field8index>=0 && field8index<=2)
							{
								//constructor[9] = "(none)";//22mar2021
								constructor[9] = Translation.TranslateWord("(none)",false);//22mar2021
								constructor[10] = "x-0";
								constructor[11] = "y-0";
								constructor[12] = "fx-100";
								constructor[13] = "fy-100";
								constructor[14] = "0";
								constructor[15] = "0";
								constructorindex = 16;
							}
						}
						if(constructorindex==constructor.Length-1)
						{
							//constructor[constructorindex] = CONSTRUCT_OK;//22mar2021
							constructor[constructorindex] = Translation.TranslateWord(CONSTRUCT_OK,false);//22mar2021
						}
					}
				}
				else
				{
					constructorindex = 0;
					//constructor[0] = field0[0];//22mar2021
					constructor[0] = Translation.TranslateWord(field0[0],false);//22mar2021
				}
			}
			if(rightclick)
			{
				if(constructorindex>=0)
				{
					constructor[constructorindex]="";
				}
				else
				{
					//remove the last trigger....
					if(triggerindex>=0)
					{
						for(int i=0;i<Game.triggers.Length-1;i++)
						{
							if(Game.triggers[i + 1].type==0)
							{
								Trigger.cleartrigger(game,i);
								break;
							}
						}
						triggers[triggerindex] = "";
						triggerindex--;
					}
				}
				constructorindex--;
				if(constructorindex>8)
				{
					if(field8index>=0 && field8index<=2)
					{
						constructorindex=8;
					}
				}
			}
			if(constructorindex==9 && oindex!=constructorindex)
			{
				if(field8index==3 || field8index==4)
				{
					Game.EDITMODE=Game.EDITMODE_ENTERTEXT;
				}
			}
			if(constructorindex<0)
			{
				for(int i=0;i<constructor.Length;i++)
				{
					constructor[i] = "";
				}
				constructorindex=-1;
				//return "{CLICK TO BEGIN}";//22mar2021
				return Translation.TranslateWord("{CLICK TO BEGIN}",false);//22mar2021
			}
			if(constructorindex>=constructor.Length)
			{
				//create conditional trigger.....
				parseconstructor(game);
				triggerindex++;
				triggerindex%=triggers.Length;
				for(int i=0;i<constructor.Length;i++)
				{
					if(i<constructor.Length-1){triggers[triggerindex]+=constructor[i];}
					if(i==8)//22mar2021
					{
						value+=Translation.TranslateWord(constructor[i],false); //22mar2021
					}
					else
					{
						value+=constructor[i];
					}
					constructor[i] = "";
				}
				constructorindex=-1;
				return value;
			}
			value = "";
			for(int i=0;i<constructor.Length;i++)
			{
				if(i==8)//22mar2021
				{
					value+=Translation.TranslateWord(constructor[i],false);//22mar2021
				}
				else
				{
					value+=constructor[i];
				}
			}
			if(constructorindex>=0 && constructorindex<constructor.Length)
			{
				if(constructor[constructorindex] == "" || constructorindex<constructor.Length-1)
				{
					if(Game.frame % 60<30)
					{
						//value+="{SCROLL TO SELECT}";	//22mar2021
						value+=Translation.TranslateWord("{SCROLL TO SELECT}",false);	
					}
				}
			}
			if(constructorindex<0)
			{
				if(Game.frame % 60<30)
				{
					//value+="{CLICK TO BEGIN}";//22mar2021
					value+=Translation.TranslateWord("{CLICK TO BEGIN}",false);//22mar2021
				}
			}
			return value;
		}

///////////////////Method Definition///////////////
		public static void parseconstructor(Game game)
		{
			//convert the constructor string into the relevant trigger code
			int ctype = 0;
			int atype = 0;
			int cn = 0;
			int cc = 0;
			string cname = "";
			int[] cloc = {0,0,100,100};
			int[] anc = {0,0};
			string aname = "";
			int[] aloc = {0,0,100,100};
			int loops = 0;
			//if(constructor[CONSTRUCTOR_IF]==field0[0])//22mar2021
			if(constructor[CONSTRUCTOR_IF]==Translation.TranslateWord(field0[0],false))//22mar2021
			{
				ctype = 10; //or perhaps 5
			}
			else
			{
				ctype = 6;
			}
			cn = field2;
			cc = field1index-1;
			cname = Game.templates[field3index].name;
			Int32.TryParse(constructor[4].Substring(2),out cloc[0]);	
			Int32.TryParse(constructor[5].Substring(2),out cloc[1]);	
			Int32.TryParse(constructor[6].Substring(3),out cloc[2]);	
			Int32.TryParse(constructor[7].Substring(3),out cloc[3]);	
			aname = Game.templates[field9index].name;
			Int32.TryParse(constructor[10].Substring(2),out aloc[0]);	
			Int32.TryParse(constructor[11].Substring(2),out aloc[1]);	
			Int32.TryParse(constructor[12].Substring(3),out aloc[2]);	
			Int32.TryParse(constructor[13].Substring(3),out aloc[3]);	
			loops = field14;
			anc[0] = field15;
			switch(constructor[8])
			{
				case "-victory ":
				atype = 1;	
				for(int j=9;j<constructor.Length;j++)
				{
					constructor[j] = "";
				}
				break;
				case "-immediate defeat ":
				atype = 2;
				for(int j=9;j<constructor.Length;j++)
				{
					constructor[j] = "";
				}
				break;
				case "-'or' defeat ":
				atype = 18;
				for(int j=9;j<constructor.Length;j++)
				{
					constructor[j] = "";
				}
				break;
				case "-chatter ":
				atype = 3;
				for(int j=10;j<15;j++)
				{
					constructor[j] = "";
				}
				break;
				case "-conditionalchatter ":
				atype = 4;
				ctype = 5;
				for(int j=10;j<15;j++)
				{
					constructor[j] = "";
				}
				break;
				case "-retreat ":
				atype = 7;
				for(int j=9;j<constructor.Length;j++)
				{
					constructor[j] = "";
				}
				break;
				case "-create fire ":
				atype = 8;
				break;
				case "-spawner alter ":
				atype = 9;
				break;
				case "-heal ":
				atype = 11;
				break;
				case "-move to ":
				atype = 15;
				break;
				case "-make friend ":
				atype = 12;
				break;
				case "-make enemy ":
				atype = 13;
				break;
				case "-make neutral ":
				atype = 14;
				break;
				case "-set ai ":
				atype = 17;
				break;
				//start---------------//25mar2021
				case "-create ":
				atype = 20;
				break;
				case "-remove ":
				atype = 21;
				break;
				//end-----------------//25mar2021
			}
			conditionaltrigger(game,ctype,atype,cc, cn,cname,cloc,anc,aname,aloc,loops); //deliberately swapped cn and cc since got it wrong all the way through the next section
		}

///////////////////Method Definition///////////////
		public static void conditionaltrigger(Game game,int conditiontype,int actiontype,int conditionn, int conditioncomparator,string conditionunitname,int[] conditionlocation,int[] actionnc,string actionunitname,int[] actionlocation,int loops)
		{
			//specific type of trigger creation
			if(conditionlocation.Length!=4)
			{
				return;
			}
			if(actionnc.Length!=2)
			{
				return;
			}
			if(actionlocation.Length!=4)
			{
				return;
			}
			if(conditionunitname=="")
			{
				return;
			}
			if(actionunitname=="")
			{
				return;
			}
			if(loops<-1)
			{
				return;
			}
			int i = -1;
			for(int t=0;t<Game.triggers.Length;t++)
			{
				if(Game.triggers[t].type==0)
				{
					i = t;
					break;
				}
			}
			if(i==-1)
			{
				return;
			}
			conditionunitname.Replace(",","^");
			actionunitname.Replace(",","^");
			int initi = i;
			if(actiontype==3)
			{
				Game.triggers[i] = new Trigger(game,3,actionnc[0],1,constructor[9].Replace(",","^"), 300, 780, 0, 0);
			}
			switch(conditiontype)
			{
				case 0: //no condition
					Game.triggers[i] = new Trigger(game,actiontype,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
				break;
				case 5: //activate chatter only
					switch(actiontype)
					{
						case 4: //conditional chatter only
						Game.triggers[i] = new Trigger(game,5,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,4,actionnc[0],1,constructor[9].Replace(",","^"), 300, 780, 0, 0);
						break;
					}
				break;
				case 6: //death count
					switch(actiontype)
					{
						case 1://victory
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, actiontype, 0, 0, 0);
						break;
						case 2: //immediate defeat
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, actiontype, 0, 0, 0);
						break;
						case 18: //or defeat
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, actiontype, 0, 0, 0);
						break;
						case 7: //retreat
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, 7, 0, 0, 0);
						break;
						case 8: //fire
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,conditionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 9: //spawner
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 11: //healing
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 12: //make friend
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 13: //make enemy
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 14: //make neutral
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 15: //move to
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionlocation[1] * Map.GRIDW,actionlocation[0] * Map.GRIDH,actionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						break;
						case 17: //setai
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionnc[0],actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						//start---------------//25mar2021
						case 20: //create
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionnc[0],actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 21: //remove
						Game.triggers[i] = new Trigger(game,6,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionnc[0],actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						//end-----------------//25mar2021
					}
				break;
				case 10: //activate
					switch(actiontype)
					{
						case 1://victory
						Game.triggers[i] = new Trigger(game,1,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						break;
						case 2: //immediate defeat
						Game.triggers[i] = new Trigger(game,2,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						break;
						case 18: //or defeat
						Game.triggers[i] = new Trigger(game,18,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						break;
						case 7: //retreat
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 8: //fire
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,conditionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 9: //spawner
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 11: //healing
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 12: //make friend
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 13: //make enemy
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 14: //make neutral
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,0,0,actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 15: //move to
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionlocation[1] * Map.GRIDW,actionlocation[0] * Map.GRIDH,actionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						break;
						case 17: //setai
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionnc[0],actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						//start---------------//25mar2021
						case 20: //create
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionnc[0],actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						case 21: //remove
						Game.triggers[i] = new Trigger(game,10,conditionn,conditioncomparator,conditionunitname, conditionlocation[0], conditionlocation[1], conditionlocation[2], conditionlocation[3]);
						i++;
						Game.triggers[i] = new Trigger(game,actiontype,actionnc[0],actionnc[0],actionunitname, actionlocation[0], actionlocation[1], actionlocation[2], actionlocation[3]);
						break;
						//end-----------------//25mar2021
					}
				break;
			}
			if(i>initi)
			{
				if(loops!=0)
				{
					if(conditiontype==TYPE_ACTIVATE || conditiontype==TYPE_DEATHCOUNT)
					{
						i++;
						Game.triggers[i] = new Trigger(game,TYPE_LOOP,0,loops,conditionunitname, 0, 0, 0, 0);
					}
				}
			}
		}
		//Trigger(Game game,int typ,int comp,int m,string name, int xx, int yy, int ww, int hh)

///////////////////Method Definition///////////////
		public TriggerHelper()
		{
		}
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Trigger
	{
		public static int number; 
		public static int MAXTRIGGER = 1000;
		public static int TYPE_VICTORY = 1;
		public static int TYPE_DEFEAT = 2;
		public static int TYPE_CHATTER = 3;
		public static int TYPE_INACTIVECHATTER = 4;
		public static int TYPE_ACTIVATECHATTER = 5;
		public static int TYPE_DEATHCOUNT = 6;
		public static int TYPE_RETREAT = 7;
		public static int TYPE_FIRE = 8;
		public static int TYPE_SPAWNER = 9;
		public static int DEFAULTSPAWNERCOUNT = 25;
		public static int TYPE_ACTIVATE = 10;
		public static int TYPE_HEALING = 11;
		public static int TYPE_MAKEFRIEND = 12;
		public static int TYPE_MAKEENEMY = 13;
		public static int TYPE_MAKENEUTRAL = 14;		
		public static int TYPE_MOVETO = 15;
		public static int TYPE_LOOP = 16;
		public static int TYPE_SETAI = 17;
		public static int TYPE_OR_DEFEAT = 18;
		public static int TYPE_SETCORNER = 19; //1mar2021
		//25mar2021 CREATION,REMOVAL and ANY FRIEND,ENEMY OR ALL Not Implemented Yet.
		public static int TYPE_CREATE = 20;//25mar2021
		public static int TYPE_REMOVE = 21;//25mar2021
		public static int TYPE_CHATTERBACKGROUNDIMAGE = 22;//10sep2021
		public static int TYPE_CHATTERAUDIO = 23;//10sep2021
		public static int TYPE_EXITTOMISSION = 24;//12sep2021
		public static int TYPE_SHOWBUTTON = 25;//23sep2021
		public static int TYPE_HIDEBUTTON = 26;//23sep2021
		public static int TYPE_ADDITEMTOSTORE = 27;//23sep2021
		public static int TYPE_RESETSTORE = 28;//23sep2021
	
		public int img;//10sep2021
		public int audio;//10sep2021
		//
		public static string TYPE_FRIEND = "FRIEND";//25mar2021//7oct2021 removed star
		public static string TYPE_ENEMY = "ENEMY";//25mar2021//7oct2021
		public static string TYPE_ANY = "ANY";//25mar2021//7oct2021

		public int type;
		public static int EQUAL = 0;
		public static int LESSTHAN = -1;
		public static int MORETHAN = 1;
		public int comparator;
		public int n;
		public string unitname;
		public int x;
		public int y;
		public int fx;
		public int fy;
		public int timelimit;
		public bool completed;
		public int completetime;
		public bool failed;
		public bool repeat;
		public long time;//7oct2021

///////////////////Method Definition///////////////
		public Trigger()
		{
			completed = false;
			repeat = false;
			failed = false;
			completetime = 180;
		}

///////////////////Method Definition///////////////
		public static void cleartrigger(Game game,int i)
		{
			//initialise triggers
			Game.triggers[i].type = 0;
			Game.triggers[i].comparator = 0;
			Game.triggers[i].n = 0;
			Game.triggers[i].unitname = "";
			Game.triggers[i].x = 0;
			Game.triggers[i].y = 0;
			Game.triggers[i].fx = 0;
			Game.triggers[i].fy = 0;
			Game.triggers[i].img = -1;//10sep2021
			Game.triggers[i].audio = -1;//10sep2021
		}

///////////////////Method Definition///////////////
		public Trigger(Game game,int typ,int comp,int m,string name, int xx, int yy, int ww, int hh)
		{
			type = typ;
			if(type!=0)
			{
				number++;
			}
			n = m;
			comparator = comp;
			unitname = name;
			if(unitname!=null){unitname.Replace("^",",");}
			x = xx;
			y = yy;
			if(ww==-1)
			{
				ww = Map.MAXX;
			}
			if(hh==-1)
			{
				hh = Map.MAXY;
			}
			fx = ww;
			fy = hh;
			completetime = 60 * 10;
			img = -1;//10sep2021
			audio = -1;//10sep2021
			//Game.triggers[nexttrigger].timelimit = time;
			//Game.triggers[nexttrigger].repeat = rpt;
		}

///////////////////Method Definition///////////////
		public static void updateall(Game game)
		{
			//update the triggers in the game
			//for defeat ALL defeat triggers must be completed
			int dcount = 0;
			int vcount = 0;
			//for victory ALL victory triggers must be completed
			Game.paused = false;
			if(Game.RESOLVE<1)
			{
				return;
			}
			
			for(int i=0;i<Trigger.number;i++)
			{
				if(Game.triggers[i].type==TYPE_CHATTER)
				{
					Game.playerready = true;
					if(Game.triggers[i].completed==false)
					{
						Game.playerready=false;
					}
				}
			}
			for(int i=0;i<Trigger.number;i++)
			{
				if(Game.triggers[i].type==0)
				{
					continue;
				}
				if(Game.triggers[i].type==TYPE_OR_DEFEAT || Game.triggers[i].type==TYPE_DEFEAT)
				{
					dcount++;
				}
				if(Game.triggers[i].type==TYPE_VICTORY)
				{
					vcount++;
				}
				if(Game.triggers[i].type==TYPE_DEATHCOUNT || Game.triggers[i].type==TYPE_ACTIVATE)
				{
					if(Game.triggers[i].y==0 && Game.triggers[i].fy==0)
					{
						if(Game.triggers[i].x==TYPE_DEFEAT || Game.triggers[i].x==TYPE_OR_DEFEAT)
						{
							dcount++;
						}
						if(Game.triggers[i].x==TYPE_VICTORY)
						{
							vcount++;
						}
					}
				}
				if(Game.triggers[i].type==TYPE_INACTIVECHATTER)
				{
					continue;
				}
				if(Game.triggers[i].completed==false)
				{
					if(Game.triggers[i].type==TYPE_CHATTER)
					{
						//stay on screen until a click is pressed......
						string[] message = Game.triggers[i].unitname.Split("|");
						if(message.Length>0)
						{
							for(int j=0;j<message.Length;j++)
							{
								RenderList.drawtext(game,Game.triggers[i].x,Game.triggers[i].y + j * (4+Game.fonts[Resources.FONT].ptsize),message[j],RenderList.getrgb(255,255,200),Game.fonts[Resources.FONT].font,false);
							}
						}
						//Game.triggers[i].completetime--;
						int triggerlink = Game.triggers[i].n;
						int index = Game.triggers[i].comparator;
						//if(Game.mlclick==true || Game.mrclick==true)
						if(Game.currentTimeMillis()>Game.triggers[i].time)
						{
							if(Game.triggers[i].time==0)
							{
								Game.triggers[i].time = Game.currentTimeMillis() + 6000;
								//////Log.d(Config.TAG,"Game.Frame:"+Game.frame+".Trigger:"+Game.triggers[i].unitname);
								Game.paused = true;
							}
							else
							{
								Game.triggers[i].completed = true;
								Game.paused = false;
								if(Game.vsai>0)
								{
									int g5 = 0;
									int g6 = 0;
									for(int u=0;u<Game.units.Length;u++)
									{
										if(Game.units[u].hp>0)
										{
											if(Game.units[u].faction==5)
											{
												g5++;
											}
											if(Game.units[u].faction==6)
											{
												g6++;											
											}
										}
									}
									if(g5==0 || g6==0)//17oct2021
									{
										Game.winloss = 1;
									}
									if(g6==0 && g5>0)
									{
										//this ai won so make it better....
										try
										{
											//g5+=Integer.decode(LocalStorage.getitem("ai_"+Game.vsai));
											int g7 = 0;
											Int32.TryParse(LocalStorage.getitem("ai_"+Game.vsai),out g7);
											g5+=g7;
										}
										catch(Exception e)
										{
											Game.WriteDebug("Error:"+e.Message);
										}
										LocalStorage.setitem("ai_"+Game.vsai, ""+g5);
										if(Game.trainai>0)//20oct2021
										{
											Console.WriteLine("AI Won:Script ID:"+Game.vsai+ " Total Score: " + g5);
											Game.gamestate = Game.CAT_GAMESTATE_MENU;
										}
									}
									if(g6>0 && g5==0)
									{
										//this ai lost...so make it worse....
										try
										{
											int g7 = 0;
											Int32.TryParse(LocalStorage.getitem("ai_"+Game.vsai),out g7);
											g5+=g7;
										}
										catch(Exception e)
										{
											Game.WriteDebug("Error:"+e.Message);
										}
										LocalStorage.setitem("ai_"+Game.vsai, ""+(g5-g6));
										if(Game.trainai>0)//20oct2021
										{
											Console.WriteLine("AI Lost:Script ID:"+Game.vsai+ " Total Score: " + (g5 - g6));
											Game.gamestate = Game.CAT_GAMESTATE_MENU;
										}
									}
									//Game.aiscore = LocalStorage.getitem("ai_"+Game.vsai);
								}
								if(Game.campaignmode>0)//ugh...shouldn't be in here 8oct2021
								{
									int f5 = 0;
									int f6 = 0;
									for(int u=0;u<Game.units.Length;u++)
									{
										if(Game.units[u].hp>0)
										{
											if(Game.units[u].faction==5)
											{
												f5++;
											}
											if(Game.units[u].faction==6)
											{
												f6++;
											}
										}
									}
									if(Game.campaignattackprovince!=-1)
									{
										if(f5==0)
										{
											//player won campaign battle
											//give the player the territory....
											int its = 0;
											//Game.aiscore = "Player Won Territory";
											if(Game.attackingplayer==Game.PlayerIndex)
											{
												while(CampaignMap.GetTerritoryOwner(Game.campaignattackprovince)!=Game.attackingplayer)
												{
													CampaignMap.ChangeTerritoryOwner(Game.campaignattackprovince);
													its++;
													if(its>10)
													{
														//Game.aiscore = "Error 1";
														break;
													}
												}
											}
											else//13oct2021
											{
												//this means the attacking player was a pc player, and the human player successfully defended their territory.
												CampaignMap.SetHero(Game.campaignattackprovince,1);
												//Game.newtoast("Hero for province:"+Game.campaignattackprovince);
											}
											//deduct strength from all of our territories......
											//to reflect manpower used.......
											CampaignMap.AfterBattle(Game.PlayerIndex);
											
											//Game.aiscore = "Debugging:Triggers:Player Won";
										}
										if(f6==0)
										{
											//player lost campaign battle
											//give the enemy the territory....
											int its = 0;
											//Game.aiscore = "Player Lost Territory To Player:"+(Game.attackingplayer);
											if(Game.attackingplayer!=Game.PlayerIndex)
											{
												while(CampaignMap.GetTerritoryOwner(Game.campaignattackprovince)!=Game.attackingplayer)
												{
													its++;
													if(its>10)
													{
													//	Game.aiscore = "Error 2";
														break;
													}
													CampaignMap.ChangeTerritoryOwner(Game.campaignattackprovince);	
												}
												CampaignMap.AfterBattle(Game.attackingplayer);
												CampaignMap.SetHero(Game.campaignattackprovince,1);//13oct2021
												//Game.newtoast("Hero for province:"+Game.campaignattackprovince);
											}
											
											//Game.aiscore = "Debugging:Triggers:AI Won(Player Lost)";
											
										}
									}
									if(f5==0 || f6==0)
									{
										Game.campaignattackprovince = -1;
										Game.campaignattackx = -1;
										Game.campaignattacky = -1;
										Game.gamestate = Game.CAMPAIGNSTATE;
										Game.chosenmissionindex = 0;
										Game.skirmish = false;
										Program.cleardeaths(game);
										Game.numattacks--;
										for(int u=0;u<Game.units.Length;u++)
										{
											Map.removeunit(Game.units[u].id, Game.units[u].x, Game.units[u].y);
											Game.units[u].reset(null, u);
										}
										Game.campaignmode = Game.attackingplayer + 1; //just to fix things.....
										Game.campaignmode++;
										Game.campaignmode%=(Game.MaxArmies + 1);
										if(Game.campaignmode==Game.MaxArmies)
										{
											CampaignMap.EndTurn();
										}
										if(Game.campaignmode==0){Game.campaignmode++;}
										Game.numattacks = 1;
										Game.firsttouch = 0;
										Game.guitime = Game.currentTimeMillis();
										for(int j=0;j<Game.gui.Length;j++)
										{
											if(Game.gui[j].link==("gamebattle"))
											{
												Game.gui[j].hidden = 1;
											}
										}
										return;
									}
								}
							}
						}
						else
						{
							Game.paused = true;
						}
						if(triggerlink>0)
						{
							for(int j=0;j<Game.gui.Length;j++)
							{
								if(Game.gui[j].triggerlink==triggerlink)
								{
									Game.gui[j].hidden = 0;
									Game.gui[j].index = index;
									if(Game.triggers[i].completed)
									{
										Game.gui[j].hidden = 1;
									}
								}
							}
							//start-----------------//10sep2021
							if(i<Game.triggers.Length)
							{
								for(int aa=1;aa<=2;aa++)
								{
									if(i + aa >= Game.triggers.Length)
									{
										continue;
									}
									if(Game.triggers[i + aa].type!=TYPE_CHATTERAUDIO && Game.triggers[i + aa].type!=TYPE_CHATTERBACKGROUNDIMAGE)
									{
										break;
									}
									if(Game.triggers[i + aa].type==TYPE_CHATTERAUDIO)
									{
										if(Game.triggers[i + aa].audio==-1)
										{
											Game.triggers[i + aa].audio = Resources.LoadAudio(game,Game.triggers[i + aa].unitname,false);//
											if(Game.triggers[i + aa].audio!=-1)
											{
												Game.triggers[i + aa].x = Audios.playsound(Game.audios[Game.triggers[i + aa].audio],Game.FXVOLUME);
											}
											else
											{
												Game.triggers[i + aa].x = -1;
											}
										}
										if(Game.triggers[i].completed)
										{
											Audios.stopchannel(Game.triggers[i + aa].x);
											Audios.freeaudio(Game.audios[Game.triggers[i+aa].audio]);
										}
									}
									if(Game.triggers[i + aa].type==TYPE_CHATTERBACKGROUNDIMAGE)
									{
										if(Game.triggers[i + aa].img==-1)
										{
											//(Game game,string file,IntPtr renderer,int w,int h) //note the slight change.....added w and h as can't work out how to do it otherwise....
											Game.triggers[i + aa].img = Resources.LoadImage(game,Game.triggers[i + aa].unitname,Game.renderer,Game.triggers[i + aa].fx,Game.triggers[i + aa].fy);
										}
										for(int j=0;j<Game.gui.Length;j++)
										{
											if(Game.gui[j].triggerlink==Game.triggers[i + aa].n)
											{
												Game.gui[j].hidden = 0;
												Game.gui[j].index = 0;
												Game.gui[j].image = Game.triggers[i + aa].img;
												Game.gui[j].tmpimage = Game.triggers[i + aa].img;
												Game.gui[j].x = Game.triggers[i + aa].x;
												Game.gui[j].y = Game.triggers[i + aa].y;
												Game.gui[j].w = Game.triggers[i + aa].fx;
												Game.gui[j].h = Game.triggers[i + aa].fy;
												if(Game.triggers[i].completed)
												{
													Game.gui[j].hidden = 1;
												}
											}
										}
									}
								}
							}
							//end-------------------//10sep2021
						}
						return;
					}
					else
					{
						//check if this one is completed....
						if(Game.triggers[i].timelimit>0)
						{
							if(Game.frame % 60==0)
							{
								Game.triggers[i].timelimit--;
							}
						}
						if((Game.frame + i) % 120 != 0)	
						{
							continue;
						}
						int count = 0;
						if(Game.triggers[i].type==TYPE_DEATHCOUNT)
						{
							for(int d=0;d<Game.templates.Length;d++)
							{
								//not implemented yet...23mar2021
								//if(Game.templates[d].name==Game.triggers[i].unitname)//25mar2021
								if(Game.templates[d].name==Game.triggers[i].unitname || (Game.triggers[i].unitname==TYPE_ANY)|| (Game.triggers[i].unitname==TYPE_FRIEND && Game.templates[d].faction==Game.PLAYERFACTION) || (Game.triggers[i].unitname==TYPE_ENEMY && Game.templates[d].faction!=Game.PLAYERFACTION && Game.templates[d].faction!=Unit.NULLFACTION))//25mar2021
								{
									count+=Game.templates[d].deaths;
								}
							}						
						}
						else
						{
							for(int xx=Game.triggers[i].x;xx<=Game.triggers[i].fx;xx++)
							{
								for(int yy=Game.triggers[i].y;yy<=Game.triggers[i].fy;yy++)
								{
									int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
									if(nid!=-1)
									{
										//if(Game.units[nid].name==Game.triggers[i].unitname && Game.units[nid].hp>0)//25mar2021
										if((Game.units[nid].name==Game.triggers[i].unitname || (Game.triggers[i].unitname==TYPE_ANY) || (Game.triggers[i].unitname==TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[i].unitname==TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION)) && Game.units[nid].hp>0)//25mar2021
										{
											count++;
										}
									}
								}
							}
						}
						switch(Game.triggers[i].comparator)
						{
							case 0:
							if(count==Game.triggers[i].n)
							{
								Game.triggers[i].completed = true;
							}
							break;
							case -1:
							if(count<Game.triggers[i].n)
							{
								Game.triggers[i].completed = true;
							}
							break;
							case 1:
							if(count>Game.triggers[i].n)
							{
								Game.triggers[i].completed = true;
							}
							break;
						}
						if(Game.triggers[i].completed==true && (Game.triggers[i].type==TYPE_ACTIVATE || Game.triggers[i].type==TYPE_DEATHCOUNT))
						{
							int j = i + 1;
							if(j<Game.triggers.Length)
							{
								if(Game.triggers[j].type==TYPE_SETAI)
								{
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
											if(nid!=-1)
											{
												//if(Game.units[nid].name==Game.triggers[j].unitname && Game.units[nid].hp>0)//25mar2021
												if((Game.units[nid].name==Game.triggers[j].unitname || (Game.triggers[j].unitname==TYPE_ANY) || (Game.triggers[j].unitname==TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[j].unitname==TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION)) && Game.units[nid].hp>0)//25mar2021
												{
													Game.units[nid].ai = Game.triggers[j].n; // ai
													Game.triggers[j].completed = true;		
												}
											}
										}
									}
								}
								if(Game.triggers[i].type==TYPE_ACTIVATE)
								{
									if(Game.triggers[j].type==TYPE_RETREAT)
									{
										for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
										{
											for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
											{
												int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
												if(nid!=-1)
												{
													//if(Game.units[nid].name==Game.triggers[j].unitname && Game.units[nid].hp>0)//25mar2021
													if((Game.units[nid].name==Game.triggers[j].unitname || (Game.triggers[j].unitname==TYPE_ANY) || (Game.triggers[j].unitname==TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[j].unitname==TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION)) && Game.units[nid].hp>0)//25mar2021
													{
														Game.units[nid].retreat = true;
														if(Game.units[nid].retreatframe==0){Game.units[nid].retreatframe = Game.frame + Unit.RETREATDEATH;}
													}
												}
											}
										}
									}
								}
								if(Game.triggers[j].type==TYPE_MOVETO)
								{
									int countunits = 0;
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
											if(nid!=-1)
											{
												//if(Game.units[nid].name==Game.triggers[j].unitname && Game.units[nid].hp>0)//25mar2021
												if((Game.units[nid].name==Game.triggers[j].unitname || (Game.triggers[j].unitname==TYPE_ANY) || (Game.triggers[j].unitname==TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[j].unitname==TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION)) && Game.units[nid].hp>0)//25mar2021
												{
													countunits++;
													int noffx = 0;
													int noffy = 0;
													if(countunits>1)
													{
														noffx = (int)Functions.rand(-Map.GRIDW*3,Map.GRIDW*3);
														noffy = (int)Functions.rand(-Map.GRIDH*3,Map.GRIDH*3);
													}
													Game.units[nid].tx = Game.triggers[j].n + noffx; //x
													Game.units[nid].ty = Game.triggers[j].comparator + noffy;
													Game.units[nid].tmptx = Game.units[nid].tx;
													Game.units[nid].tmpty = Game.units[nid].ty;
													Game.units[nid].tmptattempts = 0;
													Game.units[nid].firetargeti = -1;
													Game.units[nid].orderframe = Unit.ORDERTIME;
													Game.triggers[j].completed = true;		
												}
											}
										}
									}
								}
								//start---------------//23sep2021
								if(Game.triggers[j].type==TYPE_RESETSTORE)
								{
									Game.triggers[j].completed = true;
									for(int g=0;g<Game.gui.Length;g++)
									{
										if(Game.gui[g].command.IndexOf("buy")>=0 && Game.gui[g].triggerlink==Game.triggers[j].n)
										{
											//Game.gui[g].action = Gui.ACTION_NONE;
										}
									}
								}
								if(Game.triggers[j].type==TYPE_ADDITEMTOSTORE)
								{
									Game.triggers[j].completed = true;
									for(int g=0;g<Game.gui.Length;g++)
									{
										if(Game.gui[g].command.IndexOf("buy")>=0)
										{
											if(Game.gui[g].command.IndexOf("buy")>=0 && Game.gui[g].triggerlink==Game.triggers[j].n)
											{
												//unitname = TechName or *TechClass, x = minimum cost or -1, y = maximum cost or -1
												Game.WriteDebug("Choosing Item - "+Game.triggers[j].unitname);
												Tech.ChooseItemForStore(game,g,Game.triggers[j].unitname,Game.triggers[j].x,Game.triggers[j].y);
											}
										}
									}
								}
								if(Game.triggers[j].type==TYPE_SHOWBUTTON)
								{
									//eg do this:
									/*
									 trigger=10,0,1,Hero,0,10,10,20
									 trigger=25,-200,-200,na,0,0,100,100
									 trigger=16,-1,-1,na,0,0,100,100
									 
									  and this will cause the gui button to show
									 */
									Game.triggers[j].completed = true;
									int triggerlink = Game.triggers[j].n;
									for(int g=0;g<Game.gui.Length;g++)
									{
										if(Game.gui[g].triggerlink==triggerlink && Game.gui[g].command.IndexOf("toggle")>=0)
										{
											if(Game.gui[g].type==Gui.TYPE_BUTTON)
											{
												Game.gui[g].hidden = 0;
											}
										}
									}
								}
								if(Game.triggers[j].type==TYPE_HIDEBUTTON)
								{
									//eg do this:
									/*
									 trigger=10,0,1,Hero,0,10,10,20
									 trigger=25,-200,-200,na,0,0,100,100
									 trigger=16,-1,-1,na,0,0,100,100
									 
									  and this will cause the gui button to hide
									 */
									Game.triggers[j].completed = true;
									int triggerlink = Game.triggers[j].n;
									for(int g=0;g<Game.gui.Length;g++)
									{
										if(Game.gui[g].triggerlink==triggerlink && Game.gui[g].command.IndexOf("toggle")>=0)
										{
											if(Game.gui[g].type==Gui.TYPE_BUTTON)
											{
												Game.gui[g].hidden = 1;
											}
										}
									}
								}
								//end-----------------//23sep2021

								//start---------------//12sep2021
								if(Game.triggers[j].type==TYPE_EXITTOMISSION)
								{
									//load a new map.....
									Game.triggers[j].completed = true;
									int missionindex = Mission.PickMission(game,Game.triggers[j].unitname,Game.triggers[j].n);
									if(missionindex!=-1)
									{
										Game.chosenmissionindex = missionindex;
										Program.resetgame(game);
										Game.gamestate = Game.CAT_GAMESTATE_GAME;
										Program.cleardeaths(game);
										Game.map = new Map();
										Program.setupmission(game,Game.chosenmissionindex,0);
										Map.adddecor();//2mar2021
										Map.marktreepos(game);
										Functions.seed = Map.levelseed2;
										return;
									}
								}
								//end-----------------//12sep2021
								//start---------------//25mar2021
								if(Game.triggers[j].type==TYPE_CREATE)
								{
									int countunits = 0;
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
											if(nid==-1 && xx>=0 && yy>=0 && xx<Map.MAXX && yy<Map.MAXY) //note the nid==-1
											{
												for(int tmp=0;tmp<Game.templates.Length;tmp++)
												{
													if(Game.templates[tmp].name==Game.triggers[j].unitname)
													{
														for(int u=0;u<Game.units.Length;u++)
														{
															//check that we don't exist
															if(Game.units[u].hp<=0 && Game.units[u].timedead>Unit.MAXDEADTIME)
															{
																//create one here....
																if(Game.units[u].createunitatxy(game,u,Game.templates[tmp],xx * Map.GRIDW,yy * Map.GRIDH))
																{
																	countunits++;
																	Game.triggers[j].completed = true;		
																}
																break;
															}
														}
														break;														
													}
												}
											}
											if(countunits>=Game.triggers[j].n && Game.triggers[j].n>0)
											{
												break;
											}
										}
										if(countunits>=Game.triggers[j].n && Game.triggers[j].n>0)
										{
											break;
										}
									}
								}				
								if(Game.triggers[j].type==TYPE_REMOVE)
								{
									int countunits = 0;
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
											if(nid!=-1)
											{
												if(Game.triggers[j].unitname == Game.units[nid].name || (Game.triggers[j].unitname == TYPE_ANY) || (Game.triggers[j].unitname == TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[j].unitname == TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION))
												{
													//upto	
													Game.units[nid].hp = 0;
													Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
													Game.triggers[j].completed = true;		
													countunits++;
												}
											}
											if(countunits>=Game.triggers[j].n && Game.triggers[j].n>0)
											{
												break;
											}
										}
										if(countunits>=Game.triggers[j].n && Game.triggers[j].n>0)
										{
											break;
										}
									}
								}				
								//end-----------------//25mar2021
								if(Game.triggers[j].type==TYPE_MAKEENEMY || Game.triggers[j].type==TYPE_MAKEFRIEND || Game.triggers[j].type==TYPE_MAKENEUTRAL)
								{
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
											if(nid!=-1)
											{
												//if(Game.units[nid].name==Game.triggers[j].unitname && Game.units[nid].hp>0)//25mar2021
												if((Game.units[nid].name==Game.triggers[j].unitname || (Game.triggers[j].unitname==TYPE_ANY) || (Game.triggers[j].unitname==TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[j].unitname==TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION)) && Game.units[nid].hp>0)//25mar2021
												{
													//temporarily halt hostilities between this and other
													//units
													Game.units[nid].firetargeti = -1;
													for(int k=0;k<Game.units.Length;k++)
													{
														if(Game.units[k].firetargeti==nid)
														{
															Game.units[k].firetargeti = -1;
														}
													}
													switch(Game.triggers[j].type)
													{
														case 12: // friend
														Game.units[nid].faction = Game.PLAYERFACTION;
														break;
														case 13: //enemy
														Game.units[nid].faction = Game.SKIRMISHENEMYFACTION;//Unit.UNDEAD;
														//26oct2020
														//commented out until we have some other factions in the games
														//
														//if(Game.triggers[j].comparator==Game.triggers[j].n && Game.triggers[j].comparator>0)
														//{
														//	Game.units[nid].faction = Game.triggers[j].comparator;
														//}
														break;
														case 14: //neutral
														Game.units[nid].faction = Unit.NULLFACTION;
														break;
													}
													Game.triggers[j].completed = true;		
												}
											}
										}
									}
								}
								//start--------------//1mar2021
								if(Game.triggers[j].type==TYPE_SETCORNER)
								{
									if(Game.triggers[j].n<100 && Game.triggers[j].comparator<100)
									{
										float nnn = (float)Game.triggers[j].n;
										if(nnn<Game.triggers[j].comparator)
										{
											nnn = (float)Game.triggers[j].comparator;
										}
										if(nnn<0)
										{
											nnn = 0f;
										}
										if(nnn>100)
										{
											nnn = 100f;
										}
										nnn/=100.0f;
										if((Game.frame % 4)==0)
										{
											Game.triggers[j].n++;
											Game.triggers[j].comparator++;
										}
										Game.CORNERX = Game.triggers[j].x + (int)((Game.triggers[j].fx - Game.triggers[j].x) * nnn);
										Game.CORNERY = Game.triggers[j].y + (int)((Game.triggers[j].fy - Game.triggers[j].y) * nnn);
									}
									else
									{
										Game.triggers[j].completed = true;
									}
									//Game.triggers[j].completed = true;
								}
								//end----------------//1mar2021
								if(Game.triggers[j].type==TYPE_HEALING)
								{
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											int nid = Map.cellunit(xx * Map.GRIDW,yy * Map.GRIDH);
											if(nid!=-1)
											{
												//if(Game.units[nid].name==Game.triggers[j].unitname && Game.units[nid].hp>0)//25mar2021
												if((Game.units[nid].name==Game.triggers[j].unitname || (Game.triggers[j].unitname==TYPE_ANY) || (Game.triggers[j].unitname==TYPE_FRIEND && Game.units[nid].faction==Game.PLAYERFACTION) || (Game.triggers[j].unitname==TYPE_ENEMY && Game.units[nid].faction!=Unit.NULLFACTION && Game.units[nid].faction!=Game.PLAYERFACTION)) && Game.units[nid].hp>0)//25mar2021
												{
													Game.units[nid].hp = Game.units[nid].basehp;
													Game.triggers[j].completed = true;
												}
											}
										}
									}
								}
								if(Game.triggers[j].type==TYPE_FIRE)
								{
									for(int xx=Game.triggers[j].x;xx<=Game.triggers[j].fx;xx++)
									{
										for(int yy=Game.triggers[j].y;yy<=Game.triggers[j].fy;yy++)
										{
											if(Functions.rand(0,100)<20)
											{
												Map.setonfire(xx*Map.GRIDW,yy*Map.GRIDH,true); //permanent fire
											}
											Game.triggers[j].completed = true;
										}
									}
								}
								if(Game.triggers[j].type==TYPE_SPAWNER)
								{
									//*ANY etc not implemented yet 25mar2021
									Game.triggers[j].completed = true;
									if(Game.triggers[j].comparator>0 || Game.triggers[j].n>0)
									{
										//turn on spawner
										for(int k=0;k<Game.units.Length;k++)
										{
											if(Game.units[k].spawner==Game.triggers[j].unitname && Game.units[k].spawnertime>0 && Game.units[k].x>Game.triggers[j].x * Map.GRIDW && Game.units[k].y>Game.triggers[j].y * Map.GRIDH && Game.units[k].x<Game.triggers[j].fx * Map.GRIDW && Game.units[k].y<Game.triggers[j].fy * Map.GRIDH)
											{
												Game.units[k].spawnercount = Trigger.DEFAULTSPAWNERCOUNT;
												Game.units[k].spawnertime = 3;
											}
										}
									}
									if(Game.triggers[j].comparator<0 || Game.triggers[j].n<0)
									{
										//turn off spawner
										for(int k=0;k<Game.units.Length;k++)
										{
											if(Game.units[k].spawner==Game.triggers[j].unitname && Game.units[k].spawnertime>0 && Game.units[k].x>Game.triggers[j].x * Map.GRIDW && Game.units[k].y>Game.triggers[j].y * Map.GRIDH && Game.units[k].x<Game.triggers[j].fx * Map.GRIDW && Game.units[k].y<Game.triggers[j].fy * Map.GRIDH)
											{
												Game.units[k].spawnercount = 0;
												Game.units[k].spawnertime = 3;
											}
										}
									}
								}
							}
						}
						if(Game.triggers[i].completed==true && Game.triggers[i].type==TYPE_DEATHCOUNT && Game.triggers[i].x==TYPE_RETREAT && Game.triggers[i].y==0 && Game.triggers[i].fy==0)
						{
							//make enemy soldiers flee away from their fire target instead......
							for(int j=0;j<Game.units.Length;j++)
							{
								if(Game.units[j].faction!=Game.PLAYERFACTION && Game.units[j].hp>0)
								{
									Game.units[j].retreat = true;
									if(Game.units[j].retreatframe==0){Game.units[j].retreatframe = Game.frame + Unit.RETREATDEATH;}
								}
							}
						}
						if(Game.triggers[i].completed==true && Game.triggers[i].type==TYPE_ACTIVATECHATTER)
						{
							//find the next group of inactive chatters before the next activate chatter and activate them.....
							//and it has to be after this one...
							//so the sequence of triggers is important.....
							for(int j=0;j<Game.triggers.Length;j++)
							{
								if(Game.triggers[j].type==TYPE_INACTIVECHATTER && j==i+1)
								{
									Game.triggers[j].type=TYPE_CHATTER;
								}
								if(Game.triggers[j].type==TYPE_ACTIVATECHATTER && j>i)
								{
									break;
								}
							}
						}
						if(Game.triggers[i].completed==true && Game.triggers[i].type==TYPE_DEATHCOUNT && Game.triggers[i].x==TYPE_ACTIVATECHATTER)
						{
							//find the next group of inactive chatters before the next activate chatter and activate them.....
							//and it has to be after this one...
							//so the sequence of triggers is important.....
							for(int j=0;j<Game.triggers.Length;j++)
							{
								if(Game.triggers[j].type==TYPE_INACTIVECHATTER && j==i+1)
								{
									Game.triggers[j].type=TYPE_CHATTER;
								}
								if(Game.triggers[j].type==TYPE_ACTIVATECHATTER && j>i)
								{
									break;
								}
							}
						}
					}
				}
				else
				{
				}
				if(Game.triggers[i].type==TYPE_LOOP)
				{
					//check the previous two triggers...
					if(Game.triggers[i].n!=0) //-1 equals indefinite loops...otherwise n times.
					{
						if(i>=2)
						{
							if(Game.triggers[i-2].type==TYPE_ACTIVATE || Game.triggers[i-2].type==TYPE_DEATHCOUNT)
							{
								Game.triggers[i-2].completed = false;
								Game.triggers[i-1].completed = false;
								Game.triggers[i].completed = false;
								Game.triggers[i].n--;
							}
						}
					}
				}
			}
			bool anychatter = false;
			for(int i=0;i<Game.triggers.Length;i++)
			{
				if(Game.triggers[i].type==TYPE_CHATTER && Game.triggers[i].completed==false)
				{
					anychatter=true;
					break;
				}
			}
			if(!anychatter && !Game.paused)
			{
				if(vcount>0)
				{
					for(int i=0;i<Game.triggers.Length;i++)
					{
						if(Game.triggers[i].type==TYPE_VICTORY && Game.triggers[i].completed==true)
						{
							vcount--;
						}
						if((Game.triggers[i].type==TYPE_DEATHCOUNT || Game.triggers[i].type==TYPE_ACTIVATE) && Game.triggers[i].completed==true && Game.triggers[i].x==TYPE_VICTORY && Game.triggers[i].y==0 && Game.triggers[i].fy==0)
						{
							vcount--;
						}
					}
					if(vcount<=0)
					{
						Game.GAMEENDSTATE = Game.GAMEENDSTATE_VICTORY;
						if(Game.gameovertime==0){Game.gameovertime = 180;}
					}
				}
				if(dcount>0)
				{
					for(int i=0;i<Game.triggers.Length;i++)
					{
						if(Game.triggers[i].type==TYPE_OR_DEFEAT && Game.triggers[i].completed==true)
						{
							dcount--;
							//Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
						}
						if((Game.triggers[i].type==TYPE_DEATHCOUNT || Game.triggers[i].type==TYPE_ACTIVATE) && Game.triggers[i].completed==true && Game.triggers[i].x==TYPE_OR_DEFEAT && Game.triggers[i].y==0 && Game.triggers[i].fy==0)
						{
							dcount--;
							//Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
						}
						if(Game.triggers[i].type==TYPE_DEFEAT && Game.triggers[i].completed==true)
						{
							dcount=0;
							Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
						}
						if((Game.triggers[i].type==TYPE_DEATHCOUNT || Game.triggers[i].type==TYPE_ACTIVATE) && Game.triggers[i].completed==true && Game.triggers[i].x==TYPE_DEFEAT && Game.triggers[i].y==0 && Game.triggers[i].fy==0)
						{
							dcount=0;
							Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
						}
					}
					if(dcount<=0)
					{
						Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
						if(Game.gameovertime==0){Game.gameovertime = 180;}
					}
				}
			}
		}		
		
		///////////////////Method Definition///////////////
		public static void RandomEvent(int i)//7oct2021
		{
			int randomnumber = Functions.rand(0,1000) % 100;
			//some random events.....
			if(Map.weather==Map.WEATHERNORMAL && randomnumber<85)
			{
				Game.triggers[i].type = 0;
			}
			if(Map.weather==Map.WEATHERCOLD && randomnumber<70)
			{
				Game.triggers[i].type = 0;
			}
			if(Map.weather==Map.WEATHERHOT && randomnumber<70)
			{
				Game.triggers[i].type = 0;
			}
			if(Game.triggers[i].type==0)
			{
				return;
			}
			randomnumber = Functions.rand(0,1000) % 6;
			if(Map.weather==Map.WEATHERNORMAL)
			{
				switch(randomnumber)
				{
				case 0:
					Game.triggers[i].unitname = "Event:Beloved Commander!|Sir - all your soldiers are inspired to serve you.|Bonus:All troops count as brave.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].brave = 1;
						}
					}
				break;
				case 1:
					Game.triggers[i].unitname = "Event:Fanatics!|Something the enemy army has said or done has|sent one of our units into a berserker rage.|Bonus:Extra Attack Bonus For Some Units.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Functions.rand(0,1000)<200)
							{
								Game.units[u].frenzy+=3;
							}
						}
					}
				break;
				case 2:
					Game.triggers[i].unitname = "Event:Magic Items!|One of your soldiers possesses a rare magical item.|Bonus:One Soldier In The Army Is Superhuman.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Functions.rand(0,1000)<200)
							{
								Game.units[u].scale *= 1.1f;
								Game.units[u].leader = 1;
								Game.units[u].damage*=3;
								Game.units[u].damage2*=3;
								Game.units[u].timid = 0;
								Game.units[u].damagex = 1;
								Game.units[u].basehp*=2;
								Game.units[u].hp*=2;
								break;
							}
						}
					}
				break;
				case 3:
					Game.triggers[i].unitname = "Event:Elite Veterans!|Some of your soldiers are elite veterans.|Bonus:Some Soldiers Are More Effective";
					int tcount = 10;
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Functions.rand(0,1000)<200)
							{
								Game.units[u].scale *= 1.1f;
								Game.units[u].damage+=2;
								if(Game.units[u].damage2>0)
								{
									Game.units[u].damage2+=2;
								}
								tcount--;
								if(tcount<=0)
								{
									break;
								}
							}
						}
					}
				break;
				case 4:
					Game.triggers[i].unitname = "Event:Despised Leader!|The General of This Army Is Despised By The Troops.|Penalty:No Units Count As Brave. Leaders Downgraded.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].brave = 0;
							if(Game.units[u].leader>0)
							{
								Game.units[u].leader = 0;
							}
						}
					}
				break;
				case 5:
					Game.triggers[i].unitname = "Event:No Food for Weeks!|The Army Has Marched for Weeks On Rations Only.|Penalty:Units Effectiveness Reduced.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].hp *= 8;
							Game.units[u].hp /= 10;
							Game.units[u].scale *= 0.9f;
						}
					}
					
				break;
				}
			}
			if(Map.weather==Map.WEATHERCOLD)
			{
				switch(randomnumber)
				{
				case 0:
					Game.triggers[i].unitname = "Event:Dark Rumours!|Rumours Have Gone Around That The Enemy Has Poisoned The Water Supply.|Penalty:Units Morale Downgraded.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].brave = 0;
						}
					}
					break;
				case 1:
					Game.triggers[i].unitname = "Event:It's So Cold!|None Of The Troops Want To Be Here. It's So Cold.|Penalty:Units Morale Severely Downgraded.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Game.units[u].brave==0)
							{
								Game.units[u].timid = 1;
							}
							Game.units[u].brave = 0;
							
						}
					}
					break;
				case 2:
					Game.triggers[i].unitname = "Event:Dark Magic!|Enemy Magic Has Turned Our Iron To Rust.|Penalty:Units Effectiveness Reduced";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].damage--;
							if(Game.units[u].damage2>0)
							{
								Game.units[u].damage--;
							}
						}
					}
					
					break;
				case 3:
					Game.triggers[i].unitname = "Event:Dark Fanatics!|Cultic Noises Came From The Enemy Camp Last Night.A Dark Ritual?|Enemy Bonus:Enemy Morale Boosted";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction!=Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Game.units[u].brave==0)
							{
								Game.units[u].brave=1;
							}
							Game.units[u].timid = 0;
						}
					}
					break;
				case 4:
					Game.triggers[i].unitname = "Event:He Walks Among Them!|A Dark Legend Walks Among The Enemy Ranks.|Enemy Bonus:One Enemy Is Superhuman.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction!=Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Functions.rand(0, 1000)<150)
							{
								Game.units[u].leader = 1;
								Game.units[u].damage*=3;
								Game.units[u].damage2*=3;
								Game.units[u].timid = 0;
								Game.units[u].damagex = 1;
								Game.units[u].basehp*=2;
								Game.units[u].hp*=2;
								Game.units[u].scale *= 1.1f;
								break;
							}
						}
					}
					break;
				case 5:
					Game.triggers[i].unitname = "Event:Gale Force Winds!|Bowfire is impossible in this weather.|Penalty:Neither Side May Fire Arrows Effectively.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].firebullet>0 && Game.units[u].hp>0)
						{
							Game.units[u].damage/=2;
							Game.units[u].damage2/=2;
						}
					}
					break;
				}
				
			}
			if(Map.weather==Map.WEATHERHOT)
			{
				switch(randomnumber)
				{
				case 0:
					Game.triggers[i].unitname = "Event:So Thirsty!|The Extreme Heat Has Left The Army Feeling Giddy.|Penalty:Units' Effectiveness Reduced.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].damage--;
							if(Game.units[u].damage2>0)
							{
								Game.units[u].damage2--;
							}
						}
					}

					break;
				case 1:
					Game.triggers[i].unitname = "Event:Long March!|The Long March Through The Desert Has Taken Its Toll.|Penalty:Units' Morale Degraded.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].brave=0;
						}
					}
					break;
				case 2:
					Game.triggers[i].unitname = "Event:Drunk Generals!|The Excellent Weather Has Promoted Irresponsible Behaviour.|Penalty:Leaders' Downgraded.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].leader = 0;
						}
					}
					break;
				case 3:
					Game.triggers[i].unitname = "Event:Assassins!|Our Leaders Were Attacked While They Slept By Assassins.|Penalty:Leaders' Wounded.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							if(Game.units[u].leader>0)
							{
								Game.units[u].hp/=2;
							}
						}
					}
					break;
				case 4:
					Game.triggers[i].unitname = "Event:Priestly Blessing!|A Wandering Prophet Has Blessed Our Whole Army.|Bonus:Morale Boosted.";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].brave = 1;
							Game.units[u].timid = 0;
							Game.units[u].mob = 1;
						}
					}
					break;
				case 5:
					Game.triggers[i].unitname = "Event:Divine Intervention!|Our Entire Army Feels Refreshed.|Bonus:Army Effectiveness Increased";
					for(int u=0;u<Game.units.Length;u++)
					{
						if(Game.units[u].faction==Game.PLAYERFACTION && Game.units[u].hp>0)
						{
							Game.units[u].damage+=2;
							if(Game.units[u].damage2>0)
							{
								Game.units[u].damage2+=2;
							}
							Game.units[u].armour+=2;
							if(Game.units[u].armour>10)
							{
								Game.units[u].armour = 10;
							}
							Game.units[u].brave = 1;
							Game.units[u].timid = 0;
							Game.units[u].mob = 1;
						}
					}
					
					break;
				}
			}
		}	

		
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Mission
	{
		//public int id;
		public int floorpattern;//16sep2021
		public int debrief;
		public int skirmish;
		public bool custom;
		public int ai;
		public int showkills;
		public int campfirex;
		public int campfirey;
		public int demo;
		public string flavourtext;//18sep2021
		//1nov2020
		public int gridw; //10sep2021
		public int gridh; //10sep2021
		public bool overridergbbk;//1nov2020
		public int overridergbbk_r;//1nov2020
		public int overridergbbk_g;//1nov2020
		public int overridergbbk_b;//1nov2020
		public string name;
		public int indoor;//23sep2021
		public int[] treeimage;
		public int[] rockimage;
		public int[] wallimage;
		public int[] ghill;//20oct2021
		public int[] shill; //20oct2021
		public int[] dhill; //20oct2021
		public int[] decorimage;//2mar2021
		public Unit[] units;
		public int cornerx;
		public int cornery;
		public Trigger[] triggers;
		public int mapgen;	
		public int seed;
		public int nextmissionid;
		public int failedmissionid;
		public string nextmissionname; //1mar2021
		public string failedmissionname; //1mar2021
		public int istutorial;
		public string[] objectives;
		public string[] description;
		//26oct2020 begin
		public bool issnow;
		public bool isdesert;
		public int tilecat;
		public int treecat;
		public int treeframes;
		public int treeoffsety;
		public int rockcat;
		public int rockframes;
		public int rockoffsety;
		public int wallcat;
		public int wallframes;
		public int walloffsety;
		public int tileframes;
		//26oct2020 end
		//start--------------//2mar2021
		public int decorcat;
		public int decorframes;
		public int decoroffsety;
		//end----------------//2mar2021
		public int neutralfog; //26Feb2021
		public int fogoff; //26Feb2021
		public int playerfaction; //28Feb2021
		public int skirmishenemyfaction; //28Feb2021
		public int alwaysunlocked ;//28Feb2021
		public int lockcorner; //1mar2021

///////////////////Method Definition///////////////
		public static int PickMission(Game game,string name,int index)//12sep2021
		{
				if(name!="")
				{
					for(int i=0;i<Game.missions.Length;i++)
					{
						if(Game.missions[i].name==name)
						{
							return i;
						}
					}
				}
				if(index!=-1)
				{
					if(Game.missions!=null)
					{
						if(index>=0 && index<Game.missions.Length)
						{
							return index;
						}
					}
				}
				return -1;
		}
		
///////////////////Method Definition///////////////
		public Mission()
		{
			flavourtext = "";
			lockcorner = 0; //1mar2021
			alwaysunlocked = 0;//28Feb2021
			nextmissionname = ""; //1mar2021
			failedmissionname = ""; //1mar2021
			//26oct2020 begin
			tilecat = -1;
			treecat = -1;
			rockcat = -1;
			wallcat = -1;
			decorcat = -1; //2mar2021
			isdesert = false;
			issnow = false;
			overridergbbk = false;
			//26oct2020 end
			debrief = 1;
			description = new string[3];
			description[0] = "";
			description[1] = "";
			description[2] = "";
			custom = false;
			campfirex = -1;
			campfirey = -1;
			demo = 0;
			istutorial = 0;
			ai = 0;
			failedmissionid = -1;
			triggers = new Trigger[Trigger.MAXTRIGGER];
			fogoff = 0; //26Feb2021
			neutralfog = 0; //26Feb2021
			playerfaction = Unit.HUMAN ;//28Feb2021 //default
			skirmishenemyfaction = Unit.UNDEAD ;//28Feb2021 //default
			//
			for(int i=0;i<triggers.Length;i++)
			{
				triggers[i] = new Trigger();
			}
			mapgen = 0;
			seed = Functions.seed;
		}

///////////////////Method Definition///////////////
		public void createtrigger(int typ,int m,int comp,string name,int xx,int yy,int ww,int hh)
		{
			//create a trigger from the mission file
			//and associate it with a mission 
			int id = -1;
			for(int i=0;i<triggers.Length;i++)
			{
				if(triggers[i].type==0)
				{
					id=i;
					break;
				}
			}
			triggers[id].type = typ;
			triggers[id].n = m;
			triggers[id].comparator = comp;
			triggers[id].unitname = name;
			triggers[id].x = xx;
			triggers[id].y = yy;
			if(ww==-1)
			{
				ww = Map.MAXX;
			}
			if(hh==-1)
			{
				hh = Map.MAXY;
			}
			triggers[id].fx = ww;
			triggers[id].fy = hh;
		}
	}

///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class LocalStorage //12mar2021
	{
		public static string filename;
		public static string[] data;

///////////////////Method Definition///////////////
		//public static void ClearLog()
		//{
		//	setitem("Log"," ");
		//}
///////////////////Method Definition///////////////
		//public static void WriteLog(string value)
		//{
		//	setitem("Log",getitem("Log") + "|" + value);
		//}
///////////////////Method Definition///////////////
		public static string getitem(string name)
		{
			//return the value of a name=value pair
			//from the localstorage.txt file
			if(filename=="")
			{
				return "";
			}
			if(data==null)
			{
				return "";
			}
			for(int i=0;i<data.Length;i++)
			{
				if(data[i].IndexOf("=")>0)
				{
					if(data[i].Substring(0,data[i].IndexOf("="))==name)
					{
						return Resources.readstring(data[i]);
					}
				}
			}
			return "";
		}

///////////////////Method Definition///////////////
		public static void setitem(string name,string value)
		{
			//set a value of a name=value pair
			//in the localstorage.txt file
			bool found = false;
			if(filename=="")
			{
				return;
			}
			if(data==null)
			{
				return;
			}
			for(int i=0;i<data.Length;i++)
			{
				if(data[i].IndexOf("=")>0)
				{
					if(data[i].Substring(0,data[i].IndexOf("="))==name)
					{
						found = true;
						data[i] = name+"="+value;
						break;
					}
				}
			}
			if(!found)
			{
				Array.Resize<string>(ref data,data.Length + 1);
				data[data.Length - 1] = name+"="+value;		
			}
		}

///////////////////Method Definition///////////////
		public static void init()
		{
			//setup the localstorage.txt file for use
			filename = "";
			data = null;
			try
			{
				filename = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData)+"\\"+Game.NETTITLE + "\\localstorage.txt";			
			}
			catch(Exception e)
			{
				Game.WriteDebug("Local Storage Error:"+e.Message);
				filename = "";
			}
			if(filename!="")
			{
				try
				{
					data = System.IO.File.ReadAllLines(filename);					
				}
				catch(Exception e)
				{
					Game.WriteDebug("Local Storage Error:"+e.Message);
					data = new string[0];
				}
			}
			//ClearLog();
		}

///////////////////Method Definition///////////////
		public static void finalise()
		{
			//save the localstorage.txt file to disk.
			//typically called once at exit of the game
			if(filename==null)
			{
				return;
			}		
			if(filename=="")
			{
				return;
			}
			string txt = "";
			if(data==null)
			{
				return;
			}
			for(int i=0;i<data.Length;i++)
			{
				txt+=data[i]+Environment.NewLine;
			}
			try
			{
				System.IO.File.WriteAllText(filename,txt);
			}
			catch(Exception e)
			{
				Game.WriteDebug("Local Storage Error:"+e.Message);
			}
		}
	}

///////////////////Class Definition////////////////
	class Replay
	{
		public static bool RECORD = false;
		public static bool PLAYBACK = false;
		public static int FRAME = 0;
		public static int KEYFRAME = 300;
		public static int CHECKSUMBROKEN = -1;
		public static int MAXLENGTH = 60 * 60 * 10; //10 minutes ought to be long enough for any replay......//11apr2021 commented out//6may2021 commented back in...
		//
		public int[] seed;
		public int[] mx;
		public int[] my;
		public int[] smx;
		public int[] smy;
		public int[] fmx;
		public int[] fmy;
		public bool[] mlclick;
		public bool[] mrclick;
		public bool[] mldown;
		public bool[] mrdown;
		public long[] runningspeed;
		public long[] sumu;
		public int[] CORNERX;
		public int[] CORNERY;
		public int[] frame;
		public int[] leftcontrolkey;
		public int[,] numberkeys;
		public int[,] numberkeysframe;
		//public int[,] newtrees;//24apr2021
		public bool[] togglepause;
		public int[] formation;
		public int[] checksum;
		public Units[] units; //21apr2021
		public int[] mouseoverunitid;
		public int[] ai_direction;//23apr2021
		//
		
		public static void Init(Game game)//done
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			ClearReplay(game);
			FRAME = 0;
			CHECKSUMBROKEN = -1;
			RECORD = true;
			PLAYBACK = false;
			Game.replay = new Replay[1];
			Game.replay[0] = new Replay(0);
			Game.replay[0].seed = new int[1];
			Game.replay[0].mx = new int[1];
			Game.replay[0].my = new int[1];
			Game.replay[0].smx = new int[1];
			Game.replay[0].smy = new int[1];
			Game.replay[0].fmx = new int[1];
			Game.replay[0].fmy = new int[1];
			Game.replay[0].mlclick = new bool[1];
			Game.replay[0].mrclick = new bool[1];
			Game.replay[0].mldown = new bool[1];
			Game.replay[0].mrdown = new bool[1];
			Game.replay[0].runningspeed = new long[1];
			Game.replay[0].sumu = new long[1];
			Game.replay[0].CORNERX = new int[1];
			Game.replay[0].CORNERY = new int[1];
			Game.replay[0].frame = new int[1];
			Game.replay[0].leftcontrolkey = new int[1];
			Game.replay[0].numberkeys = new int[1,10];
			Game.replay[0].numberkeysframe = new int[1,10];
			//Game.replay[0].newtrees = new int[1,1000];//24apr2021 //way too big an array but we will see it affects performance...
			Game.replay[0].togglepause = new bool[1];
			Game.replay[0].formation = new int[1];
			Game.replay[0].checksum = new int[1];
			Game.replay[0].units = new Units[1];//21apr2021
			Game.replay[0].mouseoverunitid  = new int[1];//21apr2021
			Game.replay[0].ai_direction  = new int[1];//23apr2021
		}
	
		public static void PrepareToPlay(Game game)//done
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			FRAME = 0;
			RECORD = false;
			PLAYBACK = true;
			Functions.seed = Map.levelseed;
			Program.resetgame(game);
			Game.gamestate = Game.CAT_GAMESTATE_GAME;
			Program.cleardeaths(game);
			Game.map = new Map();
			Game.chosenmissionindex = Game.previousmissionindex;
			if(Game.chosenmissionindex!=-1)
			{
				Program.setupmission(game,Game.chosenmissionindex,2);
				Map.adddecor();//2mar2021
				Map.marktreepos(game);
				Functions.seed = Map.levelseed2;
			}
		}
		
		public static void EndPlayBack(Game game)//done
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			FRAME = 0;
			RECORD = false;
			PLAYBACK = false;
			ClearReplay();
		}
	
		public static void EndRecord(Game game)//done
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			FRAME = 0;
			RECORD = false;
			PLAYBACK = false;
		}
	
		public static void StartRecordReplay(Game game,int max)
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			Array.Resize<Replay>(ref Game.replay,1);
			Game.replay[0] = new Replay(0);
		}
		
		public static void ClearReplay(Game game)
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			Array.Resize<Replay>(ref Game.replay,1);
			Game.replay[0] = new Replay(0);
			Game.replay[0].seed = new int[1];
			Game.replay[0].mx = new int[1];
			Game.replay[0].my = new int[1];
			Game.replay[0].smx = new int[1];
			Game.replay[0].smy = new int[1];
			Game.replay[0].fmx = new int[1];
			Game.replay[0].fmy = new int[1];
			Game.replay[0].mlclick = new bool[1];
			Game.replay[0].mrclick = new bool[1];
			Game.replay[0].mldown = new bool[1];
			Game.replay[0].mrdown = new bool[1];
			Game.replay[0].runningspeed = new long[1];
			Game.replay[0].sumu = new long[1];
			Game.replay[0].CORNERX = new int[1];
			Game.replay[0].CORNERY = new int[1];
			Game.replay[0].frame = new int[1];
			Game.replay[0].leftcontrolkey = new int[1];
			Game.replay[0].numberkeys = new int[1,10];
			//Game.replay[0].newtrees = new int[1,1000];//24apr2021 //way too big an array but we will see it affects performance...
			Game.replay[0].numberkeysframe = new int[1,10];
			Game.replay[0].togglepause = new bool[1];
			Game.replay[0].formation = new int[1];
			Game.replay[0].checksum = new int[1];
			Game.replay[0].units = new Units[1];//21apr2021
			Game.replay[0].mouseoverunitid  = new int[1];//21apr2021
			Game.replay[0].ai_direction  = new int[1];//23apr2021
		}
	
		public static void ClearReplay()
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			Array.Resize<Replay>(ref Game.replay,1);
			Game.replay[0] = new Replay(0);
			Game.replay[0].seed = new int[1];
			Game.replay[0].mx = new int[1];
			Game.replay[0].my = new int[1];
			Game.replay[0].smx = new int[1];
			Game.replay[0].smy = new int[1];
			Game.replay[0].fmx = new int[1];
			Game.replay[0].fmy = new int[1];
			Game.replay[0].mlclick = new bool[1];
			Game.replay[0].mrclick = new bool[1];
			Game.replay[0].mldown = new bool[1];
			Game.replay[0].mrdown = new bool[1];
			Game.replay[0].runningspeed = new long[1];
			Game.replay[0].sumu = new long[1];
			Game.replay[0].CORNERX = new int[1];
			Game.replay[0].CORNERY = new int[1];
			Game.replay[0].frame = new int[1];
			Game.replay[0].leftcontrolkey = new int[1];
			Game.replay[0].numberkeys = new int[1,10];
			//Game.replay[0].newtrees = new int[1,1000];//24apr2021 //way too big an array but we will see it affects performance...
			Game.replay[0].numberkeysframe = new int[1,10];
			Game.replay[0].togglepause = new bool[1];
			Game.replay[0].formation = new int[1];
			Game.replay[0].checksum = new int[1];
			Game.replay[0].units = new Units[1];//21apr2021
			Game.replay[0].mouseoverunitid  = new int[1];//21apr2021
			Game.replay[0].ai_direction  = new int[1];//23apr2021
		}
	
		public static void RecordReplay(Game game)
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			if(Game.replay==null)
			{
				Game.replay = new Replay[1];
				Game.replay[0] = new Replay(0);
				ClearReplay();
			}
			if(Game.replay[0]==null)
			{
				Game.replay = new Replay[1];
				ClearReplay();
			}
			if(Game.replay[0].mx==null)
			{
				Game.replay[0].mx = new int[1];
			}
			if(Game.togglepause) //this should work.....
			{
				return;
			}
			int f = Game.replay[0].mx.Length;
			int g = f + 1;
			if(f>MAXLENGTH)//11apr2021//6may2021
			{
				EndRecord(game);
				return;
			}
			Array.Resize(ref Game.replay[0].seed,g);
			Array.Resize(ref Game.replay[0].mx,g);
			Array.Resize(ref Game.replay[0].my,g);
			Array.Resize(ref Game.replay[0].smx,g);
			Array.Resize(ref Game.replay[0].smy,g);
			Array.Resize(ref Game.replay[0].fmx,g);
			Array.Resize(ref Game.replay[0].fmy,g);
			Array.Resize(ref Game.replay[0].mldown,g);
			Array.Resize(ref Game.replay[0].mrdown,g);
			Array.Resize(ref Game.replay[0].mlclick,g);
			Array.Resize(ref Game.replay[0].mrclick,g);
			Array.Resize(ref Game.replay[0].runningspeed,g);
			Array.Resize(ref Game.replay[0].sumu,g);
			Array.Resize(ref Game.replay[0].CORNERX,g);
			Array.Resize(ref Game.replay[0].CORNERY,g);
			Array.Resize(ref Game.replay[0].frame,g);
			Array.Resize(ref Game.replay[0].togglepause,g);
			Array.Resize(ref Game.replay[0].formation,g);
			Array.Resize(ref Game.replay[0].leftcontrolkey,g);
			Array.Resize(ref Game.replay[0].checksum,g);
			Array.Resize<Units>(ref Game.replay[0].units,g);//21apr2021
			Array.Resize(ref Game.replay[0].mouseoverunitid,g);
			Array.Resize(ref Game.replay[0].ai_direction,g);//23apr2021
			//
			//
			//because resizing multidimensional arrays doesn't work simply enough....
			int[,] tmp0 = new int[g,10];
			int[,] tmp1 = new int[g,10];
			//int[,] tmp2 = new int[g,1000]; //24apr2021
			if(f==1)
			{
				Game.replay[0].numberkeys = new int[1,10];
				Game.replay[0].numberkeysframe = new int[1,10];
				//Game.replay[0].newtrees = new int[1,1000];//24apr2021 //way too big an array but we will see it affects performance...
			}
			for(int e=0;e<f;e++)
			{
				for(int j=0;j<10;j++)
				{
					tmp0[e,j] = Game.replay[0].numberkeys[e,j];
					tmp1[e,j] = Game.replay[0].numberkeysframe[e,j];
				}
				//for(int j=0;j<1000;j++)//24apr2021
				//{
				//	tmp2[e,j] = Game.replay[0].newtrees[e,j];
				//}
			}
			Game.replay[0].numberkeys = tmp0;
			Game.replay[0].numberkeysframe = tmp1;
			//Game.replay[0].newtrees = tmp2;//24apr2021
			//
			//
			Game.replay[0].seed[f] = Functions.seed;
			Game.replay[0].frame[f] = Game.frame;
			Game.replay[0].togglepause[f] = Game.togglepause;
			Game.replay[0].mx[f] = Game.mx;
			Game.replay[0].my[f] = Game.my;
			Game.replay[0].smx[f] = Game.smx;
			Game.replay[0].smy[f] = Game.smy;
			Game.replay[0].fmx[f] = Game.fmx;
			Game.replay[0].fmy[f] = Game.fmy;
			Game.replay[0].mlclick[f] = Game.mlclick;
			Game.replay[0].mrclick[f] = Game.mrclick;
			Game.replay[0].mldown[f] = Game.mldown;
			Game.replay[0].mrdown[f] = Game.mrdown;
			Game.replay[0].runningspeed[f] = Config.runningspeed;
			Game.replay[0].sumu[f] = Config.sumu;
			Game.replay[0].CORNERX[f] = Game.CORNERX;
			Game.replay[0].CORNERY[f] = Game.CORNERY;
			Game.replay[0].leftcontrolkey[f] = Game.leftcontrolkey;
			Game.replay[0].formation[f] = Game.formation;
			Game.replay[0].checksum[f] = Game.checksum;
			Game.replay[0].mouseoverunitid[f] = Game.mouseoverunitid;
			Game.replay[0].ai_direction[f] = Game.ai_direction;//23apr2021
			for(int j=0;j<10;j++)
			{
				Game.replay[0].numberkeys[f,j] = Game.numberkeys[j];
				Game.replay[0].numberkeysframe[f,j] = Game.numberkeysframe[j];
			}
			//for(int j=0;j<Game.newtrees.Length;j++)//24apr2021
			//{
			//	if(j>999)
			//	{
			//		break;
			//	}
			//	Game.replay[0].newtrees[f,j] = Game.newtrees[j];
			//}
			//start----------//21apr2021
			if((f % KEYFRAME)==0)
			{
				Game.replay[0].units[f] = new Units(game);
				for(int u=0;u<Game.units.Length;u++)
				{
					Unit.COPYUNIT = true;
					Unit.copyunitstats(Game.units[u],ref Game.replay[0].units[f].unit[u]);
					Unit.COPYUNIT = false;
				}
				Map.correct(game);//21apr2021
			}
			//end------------//21apr2021
		}

		public static bool IsPlaying()//21apr2021
		{
			return PLAYBACK;
		}
		
		public static void PlayReplay(Game game,int f)
		{
			if(Config.NOREPLAY>0)//15sep2021
			{
				return;
			}
			if(f>=0 && f<Game.replay[0].mx.Length)
			{
				Functions.seed = Game.replay[0].seed[f];
				Game.RCORNERX = Game.replay[0].CORNERX[f];//21apr2021
				Game.RCORNERY = Game.replay[0].CORNERY[f];//21apr2021
				Game.mx = Game.replay[0].mx[f];
				Game.my = Game.replay[0].my[f];
				Game.smx = Game.replay[0].smx[f];
				Game.smy = Game.replay[0].smy[f];
				Game.fmx = Game.replay[0].fmx[f];
				Game.fmy = Game.replay[0].fmy[f];
				Game.mldown = Game.replay[0].mldown[f];
				Game.mrdown = Game.replay[0].mrdown[f];
				Game.mlclick = Game.replay[0].mlclick[f];
				Game.mrclick = Game.replay[0].mrclick[f];
				Config.runningspeed = Game.replay[0].runningspeed[f];
				Config.RUNNINGSPEED = Config.runningspeed;
				Config.sumu = Game.replay[0].sumu[f];
				Game.frame = Game.replay[0].frame[f];
				Game.mouseoverunitid = Game.replay[0].mouseoverunitid[f];//21apr2021
				Game.ai_direction = Game.replay[0].ai_direction[f];//21apr2021
				if(f < 30) //21apr2021
				{
					Game.CORNERX = Game.RCORNERX;
					Game.CORNERY = Game.RCORNERY;
				}
				Game.leftcontrolkey = Game.replay[0].leftcontrolkey[f];
				Game.togglepause = Game.replay[0].togglepause[f];
				for(int j=0;j<10;j++)
				{
					Game.numberkeys[j] = Game.replay[0].numberkeys[f,j];
					Game.numberkeysframe[j] = Game.replay[0].numberkeysframe[f,j];
				}
				//for(int j=0;j<1000;j++)//24apr2021
				//{
				//	if(Game.replay[0].newtrees[f,j]>0)
				//	{
				//		//planttree
				//		int treex = (Game.replay[0].newtrees[f,j] - 1) % Map.MAXX;
				//		int treey = (Game.replay[0].newtrees[f,j] - 1 - treex) / Map.MAXX;
				//		Map.planttree(treex * Map.GRIDW, treey * Map.GRIDH);
				//	}
				//}
				if(Game.replay[0].formation[f]!=0)
				{
					Unit.Formation(game,Game.replay[0].formation[f]);
				}
				if((f % KEYFRAME)==0)//21apr2021
				{
					if(Game.replay[0].units[f]!=null)
					{
						if(Game.replay[0].units[f].unit!=null)
						{
							if(Game.replay[0].units[f].unit.Length>0)
							{
								for(int u=0;u<Game.units.Length;u++)
								{
									Unit.COPYUNIT = true;
									Unit.copyunitstats(Game.replay[0].units[f].unit[u],ref Game.units[u]);
									Unit.COPYUNIT = false;
								}
							}
						}
					}
					Map.correct(game);//21apr2021
				}
				if(Game.checksum!=Game.replay[0].checksum[f] && f>2 && CHECKSUMBROKEN==-1)
				{
					CHECKSUMBROKEN = f;
				}
				if(Game.checksum==Game.replay[0].checksum[f]) //21apr2021
				{
					CHECKSUMBROKEN = -1;
				}
			}
			else
			{
				//exit to main menu.....
				//if the replay works we won't actually get here...instead we will get to the DEFEEAT or VICTORY screens,
				//with the same data.....that's how you'll know this didn't work....
				//Blood.clearall(game); //29oct2020
				//Bullet.clearall(game); //29oct2020
				//Gibbet.clearall(game);//2apr2021
				//Game.map = new Map();
				//Program.setupbackdrop(game);
				//Game.demomode = true;
				//Game.PLAYERFACTION = Unit.HUMAN;
				//Game.gamestate = 0;
				//Game.frame+=FRAME;
				////////////////////////////////////////////////
				//Given the replay feature is broken and doesn't seem fixable
				//I may as well give the player a reward for watching it!
				Game.GAMEENDSTATE = Game.GAMEENDSTATE_VICTORY;
				if(Game.gameovertime==0){Game.gameovertime = 180;}
			}
		}
	
		public Replay(int max)
		{
		}
	}

///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////Class Definition////////////////
	class Translation //13mar2021
	{
		public static string[] foreignnumbers; //13mar2021
		public static int MAXNUM = 10001;
		public static string filename = "";
		public static bool languageready = false;
		public static string[] foreignwords; //13mar2021
		public static string[] defaultwords; //13mar2021
		public static string[] sortedforeignwords; //28mar2021
		public static string[] sorteddefaultwords; //28mar2021
		public static bool sorted = false;//28mar2021
		public static int sortmax = 0;//28mar2021
		
///////////////////Method Definition///////////////
		public static void init(string nfilename)
		{
			//initialise the translation class
			foreignnumbers = new string[MAXNUM];
			for(int i=0;i<MAXNUM;i++)
			{
				foreignnumbers[i] = "" + i;
			}
			if(nfilename!="")
			{
				try
				{
					foreignnumbers = System.IO.File.ReadAllLines(nfilename);
					if(foreignnumbers==null)
					{
						filename = "";
						return;
					}
					if(foreignnumbers.Length!=MAXNUM)
					{
						filename = "";
						return;
					}
					filename = nfilename;
					languageready = true;
				}
				catch(Exception e)
				{
					Game.WriteDebug("Translation Error:"+e.Message);
					//LocalStorage.WriteLog("Translation Error:"+e.Message);
					filename = "";
				}
			}
		}

///////////////////Method Definition///////////////
		public static void SetLanguage(string code)
		{
			//set the language to be used by the game
			LocalStorage.setitem("language",code);
		}

///////////////////Method Definition///////////////
		public static string GetLanguage()
		{
			//get the language used by the game ui
			return LocalStorage.getitem("language");
		}

///////////////////Method Definition///////////////
		public static void CollectWords()
		{
			//get the word list ready for translations
			if(!languageready)
			{
				return;
			}
			if(Config.wordsfile=="")
			{
				return;
			}		
			try
			{
				string[] data = System.IO.File.ReadAllLines(Config.wordsfile);
				if(data.Length>0)
				{
					defaultwords = new string[data.Length];
					foreignwords = new string[data.Length];
					for(int i=0;i<data.Length;i++)
					{
						if(data[i].IndexOf("=")>0)
						{
							defaultwords[i] = data[i].Substring(0,data[i].IndexOf("="));
							foreignwords[i] = Resources.readstring(data[i]);
						}
					}						
					sort(); //28mar2021 //not implemented
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error In Translation:"+e.Message);
				//LocalStorage.WriteLog("Error In Translation:"+e.Message);
			}
		}

		
		private static void sort() //28mar2021
		{
			sorteddefaultwords = new string[defaultwords.Length];
			sortedforeignwords = new string[foreignwords.Length];
			bool[] sortedlist = new bool[defaultwords.Length];
			sorted = false;
			string biggestword = "";
			for(int i=0;i<defaultwords.Length;i++)
			{
				sorteddefaultwords[i] = "";
				sortedforeignwords[i] = "";
				sortedlist[i] = false;
			}
			while(!sorted)
			{
				//find the biggestword that has not been sorted
				int j = -1;
				biggestword = "";
				for(int i=0;i<defaultwords.Length;i++)
				{
					if(String.Compare(defaultwords[i],biggestword)>0 && sortedlist[i]==false && defaultwords[i]!="")
					{
						biggestword = defaultwords[i];
						j = i;
					}
				}
				//we now have the biggest unsorted word.....
				if(j!=-1)
				{
					//find the highest index value of sorteddefaultwords.....
					for(int k=sorteddefaultwords.Length-1;k>=0;k--)
					{
						if(sorteddefaultwords[k]=="" && sortedforeignwords[k]=="")
						{
							sorteddefaultwords[k] = defaultwords[j];
							sortedforeignwords[k] = foreignwords[j];
							sortedlist[j] = true;
							break;
						}
					}
				}
				else
				{
					sorted = true;
				}
				
			}
			if(sorted)
			{
				for(int i=0;i<defaultwords.Length;i++)
				{
					defaultwords[i] = sorteddefaultwords[i];
					foreignwords[i] = sortedforeignwords[i];
				}
			}
		}
		
///////////////////Method Definition///////////////
		public static string TranslateWord(string word,bool usesecond)
		{
			//translate a specific word into a value found in the word list for the current language
			if(!languageready)
			{
				return word; //17mar2021 // was ""
			}
			if(defaultwords==null || foreignwords==null)
			{
				return word; //17mar2021 // was ""
			}
			string value = "";
			bool found = false;
			if(sorted)//28mar2021 //binary search Order Log N is the search time.....
			{
				int min = 0;
				int max = defaultwords.Length - 1;
				int mid = (min + max) / 2;
				int omid = mid - 1;
				int atleasttwice = 0;
				int pmid = (min + max);
				while(value=="" && omid!=mid)
				{
					omid = mid;
					string txt = defaultwords[mid];
					int cmp = String.Compare(defaultwords[mid],word);
					if(cmp==0)
					{
						value = foreignwords[mid];
						break;
					}
					if((pmid)%2!=0)
					{
						if(mid + 1 <= max)
						{
							if(String.Compare(defaultwords[mid + 1],word)==0)
							{
								value = foreignwords[mid + 1];
								break;
							}
						}
					}
					pmid = min + max;
					if(cmp>0)
					{
						max = mid;
						mid = (min + max)/2;
						
					}
					if(cmp<0)
					{
						min = mid;
						mid = (min + max)/2;
					}
					
					if(omid==mid)
					{
						atleasttwice++;
						if(atleasttwice<2)
						{
							omid = mid - 1;
						}
					}
					
				}
			}
			else
			{
				for(int i=0;i<defaultwords.Length;i++)
				{
					if(defaultwords[i]==word)
					{
						value = foreignwords[i];
						if(!usesecond)
						{
							break;
						}
						if(found)
						{
							break;
						}
						found = true;
					}
				}
			}
			if(value=="")
			{
				value = word;
			}
			return value;
		}

///////////////////Method Definition///////////////
		public static string TranslateNumber(int n)
		{
			//in the event that some cultures use non Arabic numbers
			//this handles that
			if(!languageready)
			{
				return "" + n;
			}
			if(n<0 || n>=MAXNUM)
			{
				return "" + n;
			}
			if(n>=0 && n<foreignnumbers.Length)
			{
				return foreignnumbers[n];
			}
			else
			{
				return "" + n;
			}
		}

///////////////////Method Definition///////////////
		public static int CountNonAscii(string text)
		{
			//used in drawtext to make sure the scale of the text is right
			if(text==null)
			{
				return 1; //special case
			}
			int count = text.Length;
			char[] letters = text.ToCharArray();
			char[] ZERO = " ".ToCharArray();
			char[] ZZ = "~".ToCharArray();
			for(int i=0;i<letters.Length;i++)
			{
				if(char.ToUpper(letters[i])>=ZERO[0] && char.ToUpper(letters[i])<=ZZ[0])
				{
					count--;
				}
			}
			if(count<=0)
			{
				return 1;
			}
			return count;
		}

///////////////////Method Definition///////////////
		public static bool AllAscii(string text) //16mar2021 //another fix for Chinese Text....
		{
			//used in drawtext ot make sure the scale of the text is right
			if(text==null)
			{
				return false;
			}
			int count = text.Length;
			if(count<=0)
			{
				return false;
			}
			char[] letters = text.ToCharArray();
			char[] ZERO = " ".ToCharArray();
			char[] ZZ = "~".ToCharArray();
			for(int i=0;i<letters.Length;i++)
			{
				if(char.ToUpper(letters[i])<ZERO[0] || char.ToUpper(letters[i])>ZZ[0])
				{
					return false;
				}
			}
			return true;
		}
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	////////////////////////UDP Net Code

	public class DatagramPacket
	{
		
		public byte[] data;
		public int datalength;
		public int offset;
		public string device;
		public int port;
		public bool filled;
		
		public DatagramPacket()
		{
			filled = false;
		}
		
		public DatagramPacket(byte[] buffer,int o,int l)
		{
			data = buffer;
			filled = false;
			for(int i=0;i<l;i++)
			{
				if(i>=buffer.Length)
				{
					break;
				}
				data[i] = buffer[i];
			}
			offset = o;
			datalength = l;
		}
		
		public DatagramPacket(byte[] buffer,int l,string remote,int p)
		{
			data = new byte[l];
			filled = false;
			for(int i=0;i<l;i++)
			{
				if(i>=buffer.Length)
				{
					break;
				}
				data[i]=buffer[i];
			}
			datalength = l;
			device = remote;
			port = p;
		}
		
		public string getAddress()
		{
			return NetworkUDP.clientip;
		}
		
		public byte[] getData()
		{
			return data;
		}
	}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	
	public class DatagramSocket
	{
		//		
		public bool alive;
		private Socket s; //socket
		private EndPoint senderremote; //remote pc and port
		//
		//
		public DatagramSocket(int port)
		{
			//local pc
			alive = false;
			try
			{
				IPHostEntry hostentry = Dns.GetHostEntry(Dns.GetHostName()); //our local device is the first in the list
				int id = 0;
				for(int i=0;i<hostentry.AddressList.Length;i++)
				{
					//Game.WriteDebug("Our IP Address:"+hostentry.AddressList[i].MapToIPv4().ToString());
					if(hostentry.AddressList[i].MapToIPv4().ToString().IndexOf("192.168")>=0)
					{
						id = i;
					}
				}
				IPEndPoint endpoint = new IPEndPoint(hostentry.AddressList[id],port); //us is the first in the list
				s = new Socket(SocketType.Dgram,ProtocolType.Udp); //our socket
				//remote pc
				if(NetworkUDP.clientip==null)
				{
					//Game.WriteDebug("clientip = null");
					IPEndPoint sender = new IPEndPoint(IPAddress.Any,port); //the sender TO us
					senderremote = (EndPoint) sender; //the sender endpoint TO us
				}
				else
				{
					if(NetworkUDP.clientip=="")
					{
						//Game.WriteDebug("clientip = ''");
						IPEndPoint sender = new IPEndPoint(IPAddress.Any,port); //the sender TO us
						senderremote = (EndPoint) sender; //the sender endpoint TO us
					}
					else
					{
						//Game.WriteDebug("clientip = "+NetworkUDP.clientip);
						IPEndPoint sender = new IPEndPoint(IPAddress.Parse(NetworkUDP.clientip),port); //the sender TO us
						senderremote = (EndPoint) sender; //the sender endpoint TO us
					}
				}
				//bind to the endpoint....
				s.Bind(endpoint);//bind to our local socket port and address.
				alive = true;
				Game.newtoast("Attempting to Connect");
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error:"+e.Message);
			}
		}
		
		public void send(DatagramPacket pack)
		{
			if(s==null)
			{
				alive = false;
				//Game.WriteDebug("Socket is null");
				return;
			}
			try
			{
				IPEndPoint sender = new IPEndPoint(IPAddress.Parse(NetworkUDP.clientip),NetworkUDP.port); //the sender TO us
				senderremote = (EndPoint) sender; //the sender endpoint TO us
				s.SendTo(pack.data,pack.data.Length,SocketFlags.None,senderremote);
				//Game.newtoast("Sent to other pc:"+(int)pack.data[0]);
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error Writing to Socket:"+e.Message);
				Game.newtoast("Invalid IP Address Specified In File");
				try
				{
					s.Close();
					s = null;
					alive = false;
				}
				catch(Exception e2)
				{
					Game.WriteDebug("Error:"+e2.Message);
				}
			}
		}
		
		public void receive(DatagramPacket pack)
		{
			///debugging
			//return;
			if(s==null)
			{
				//Game.WriteDebug("Socket is null");
				alive = false;
				return;
			}
			try
			{
				//Game.WriteDebug("Waiting for data....");
				IPEndPoint sender = new IPEndPoint(IPAddress.Parse(NetworkUDP.clientip),NetworkUDP.port); //the sender TO us
				senderremote = (EndPoint) sender; //the sender endpoint TO us
				s.ReceiveFrom(pack.data, ref senderremote); //receive from sender remote set up earlier...
				//Game.WriteDebug("Data Received From Remote:First Entry:"+(int)pack.data[0]);
				//Game.WriteDebug("End Point Received From:"+senderremote.ToString());
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error Receiving Data From Remote:"+e.Message);
				NetworkUDP.EXITSIGNAL = 1;
				try
				{
					s.Close();
					s = null;
					alive = false;
				}
				catch(Exception e2)
				{
					Game.WriteDebug("Error:"+e2.Message);
				}
			}
		}
		
		public void close()
		{
			try
			{
				if(s!=null)
				{
					s.Close();	
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error:"+e.Message);
				s = null;
			}
			alive = false;
		}
	}

	public class InetAddress
	{
		public string ipaddress;
		
		public static string getByName(string name)
		{
			string address = name;
			if(address==null)
			{
				return null;
			}
			if(address=="")
			{
				return null;
			}
			return address;
		}
		
		public bool isReachable(long timeout)
		{
			return true;
		}
	}

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public class NetworkUDP 
	{
		public static string trytobeserver = "0";
		public static string ip = "";
		public static int ipthreadcount = 0;
		public static int maxoctet = 254;
		public static long lastsync = 0;
		public static bool isnetworked = false;
		public static int maxpacketlength = 8192;
		public static DatagramSocket socket;
		public static DatagramPacket sendpacket;
		public static DatagramPacket receivepacket;
		public static int port = 5555;
		public static int THREADRUNNING = 0;
		public static int thread1 = 0;
		public static int thread2 = 0;
		public static int EXITSIGNAL = 0;
		public static string remotedevice;
		public static string remoteserver;
		public static bool foundremote = false;
		public static bool DONOTRESTART = false;
		public static int SEEKCONNECTION = 1;
		public static int SENDDATA = 2;
		public static int CONNECTIONRECEIVED = 3;
		public static int CONNECTIONRECEIVEDFROMSERVER = 4;
		public static bool CONNECTIONACKNOWLEDGED = false;
		public static int DATA = 2;
		public static int gameframe = 0;
		public static bool readytocommunicate = false;
		public static int firsttime = 0;
		
		public static string baseip = "192.168.43.";
		
		public static bool isserver = false;
		
		//commands to send
		public static int CREATEUNIT = 1; //templateindex and boardx,boardy are sent to remote device
		public static int PRESSRESOLVE = 2;//resolve was pressed send to remote device
		public static int PRESSEXIT = 3;//exit was pressed send to remote device
		public static int MAPDESERT = 4;
		public static int MAPSNOW = 5;
		public static int MAPNORMAL = 6;
		public static int SYNC = 7;
		public static int PLAY = 8;
		public static int TOUCHCAMPAIGNMAP = 9;
		public static int TOUCHCAMPAIGNICON = 10;
		public static int SYNCCAMPAIGN = 11;
		public static int UPDATESPEED = 12;
		public static int SPELL = 13;//18oct2021
		public static int BEACON = 14;//19oct2021
	
		public static int otherpcspeed = 0;
		public static long lastspeedcheck = 0;
		public static int alteredgui = 0;//20oct2021
		
		public static bool receivedsomething = false;
		public static int pleasesend = 0;
		public static byte[] sendbuffer = new byte[maxpacketlength];
		
		//commands to receive.....
		public static int[] comms = new int[maxpacketlength]; //should be sufficient.....
		public static int commsindex = 0;
		public static int commsready = 0;

		public static string clientip = "";
		///////////////////////////////////
		///Override this in the GUI code
		//public static void handlecomms()
		//{
		//	for(int i=0;i<commsindex;i++)
			//{
			//				
			//}
			//commsindex = 0;
		//}

		public static void ThreadListening()
		{
			Game.WriteDebug("Listening");
			byte[] buffer = Buffer(DATA);
			receivepacket = new DatagramPacket(buffer,0,maxpacketlength);
			string remote = null;
			while(EXITSIGNAL == 0)
			{
				if(commsready==2)
				{
					continue;
				}
				try
				{
					if(EXITSIGNAL==1)
					{
						//THREADRUNNING = 0;
						break;
					}
					try
					{
						//Log.i(Config.TAG,"Receiving Packet");
						receivepacket = new DatagramPacket(buffer,0,maxpacketlength);
						
						socket.receive(receivepacket);//blocks until something arrives......
						if(firsttime==0 && socket.alive==true)
						{
							Game.newtoast("Connected to Multiplayer");
							firsttime=1;
							Game.WriteDebug("Received Something in Listener");
						}
						//Log.i(Config.TAG,"Packet Received");
						if(Game.multiplayerip!=(""))
						{
							//isserver = true;
							if(NetworkUDP.trytobeserver=="1")
							{
								isserver = true;
							}
							else
							{
								isserver = false;
							}
						}
						else
						{
							isserver = false;
						}
						try
						{
							if(isserver) 
							{
								//the client device
								remotedevice = receivepacket.getAddress();// the other computer
								//Game.WriteDebug("Other Device:"+remotedevice);
								remote = remotedevice;
								//Log.i(Config.TAG,"Remote Client Received From");
							}
							else
							{
								//the server device
								remoteserver = receivepacket.getAddress();// the other computer
								//Game.WriteDebug("Other device:"+remotedevice);
								//Log.i(Config.TAG,"Remote Server Received From");
								remote = remoteserver;
							}
							foundremote = true;
						}
						catch(Exception iaddr)
						{
							//do nothing....
							Game.WriteDebug("Error:"+iaddr.Message);
						}
					}
					catch (Exception eio) 
					{
						Game.WriteDebug("Error:"+eio.Message);
					}
					//gameframe = RenderList.renderframe;
					//if(Functions.abs(gameframe-oldframe)>500)
					//{
					//	//exit as the user is obviously not playing the game....
					//	THREADRUNNING = 0;
					//	//Log.i(Config.TAG,"EXITING THREAD RENDERFRAME TO DIFFERENT");
					//	break;
					//}
					//////////////////////
					if(remote!=null) //handle receipt.....
					{
						//for(int b=0;b<buffer.Length;b++)
						//{
						//	buffer[b] = 99;//flush the buffer first.....
						//}
						//if(!timedout)
						//{
						//Log.i(Config.TAG,"Remote Address:"+remote.getHostAddress());
						buffer = receivepacket.getData();
						//Game.WriteDebug("getData called");
						//}
						//Log.d(Config.TAG,"Network Traffic Received:"+(int)buffer[0]);
						if(isserver)//server does this...
						{
							//first thing we get back from client is a CONNECTIONRECEIVEDFROMSERVER
							if(buffer[0]==44 || buffer[0]==11)
							{
								//Game.WriteDebug("We got a 44 or 11");
								CONNECTIONACKNOWLEDGED = true;
								readytocommunicate = true;
								//Log.i(Config.TAG,"Server and Client Are Ready To Communicate");
							}
						}
						else
						{
							if(buffer[0]==11 || buffer[0]==44)
							{
								//Log.i(Config.TAG,"Connection Established");
								//Game.WriteDebug("We got a 44 or 1");
								readytocommunicate = true;//12oct2021
							}
						}
						if(readytocommunicate)
						{
							//I'm listening......
							if(buffer[0]==0)
							{
								//buffer value 
								//4,5,6,7 are CREATEUNIT,TEMPLATEINDEX,BOARDX,BOARDY, and so on every 3 values....
								//OR 4 = PRESS RESOLVE or 5,or 6 or 7...etc
								//and same for exit
								//Log.i(Config.TAG,"Reading Buffer");
								//for(int i=4;i<buffer.Length;i++)
								int i = 4;
								while(i<buffer.Length)
								{
									if(buffer[i]==0)
									{
										i++;
										continue;
									}
									//Game.WriteDebug("We got a command");
									if(buffer[i]==SYNCCAMPAIGN)
									{
										if(!isserver)
										{
											comms[commsindex]=SYNCCAMPAIGN;
											commsindex++;
											i++;
											for(int j=0;j<CampaignMap.maxprovince;j++)
											{
												comms[commsindex] = buffer[i];
												commsindex++;
												i++;
												comms[commsindex] = buffer[i];
												commsindex++;
												i++;
											}
										}
										continue;
									}
									if(buffer[i]==BEACON)//19oct2021
									{
										comms[commsindex] = BEACON;
										commsindex++;
										i++;
										comms[commsindex] = buffer[i] & 0xff; //x
										commsindex++;
										i++;
										comms[commsindex] = buffer[i] & 0xff; //y
										commsindex++;
										i++;
										comms[commsindex] = buffer[i] & 0xff; //faction
										commsindex++;
										i++;
										
										continue;
									}
									if(buffer[i]==SPELL)//18oct2021
									{
										comms[commsindex] = SPELL;
										commsindex++;
										i++;
										comms[commsindex] = buffer[i] & 0xff;
										commsindex++;
										i++;
										continue;
									}
									if(buffer[i]==UPDATESPEED)
									{
										comms[commsindex] = UPDATESPEED;
										commsindex++;
										i++;
										comms[commsindex] = buffer[i] & 0xff;//framerate
										commsindex++;
										i++;
										continue;
									}
									if(buffer[i]==TOUCHCAMPAIGNMAP)
									{
										if(!isserver)
										{
											comms[commsindex]=TOUCHCAMPAIGNMAP;
											commsindex++;
											//x
											comms[commsindex]=buffer[i + 1] & 0xff;
											commsindex++;
											comms[commsindex]=buffer[i + 2] & 0xff;
											commsindex++;
											//y
											comms[commsindex]=buffer[i + 3] & 0xff;
											commsindex++;
											comms[commsindex]=buffer[i + 4] & 0xff;
											commsindex++;
											//gui id
											comms[commsindex]=buffer[i + 5] & 0xff;
											commsindex++;
											comms[commsindex]=buffer[i + 6] & 0xff;
											commsindex++;
										}
										i+=7;
										continue;
									}
									if(buffer[i]==TOUCHCAMPAIGNICON)
									{
										if(!isserver)
										{
											comms[commsindex] = TOUCHCAMPAIGNICON;
											commsindex++;
											comms[commsindex] = (int)buffer[i + 1];
											commsindex++;
											
										}
										i+=2;
										if(i>=buffer.Length)
										{
											break;
										}
										continue;
									}
									if(buffer[i]==CREATEUNIT)
									{
										//Log.i(Config.TAG,"Creat Unit Command Received");
										comms[commsindex]=CREATEUNIT;
										comms[commsindex+1]=(int)buffer[i+1];
										comms[commsindex+2]=(int)buffer[i+2];
										comms[commsindex+3]=(int)buffer[i+3];
										commsindex+=4;
										i+=4;
										if(i>=buffer.Length)
										{
											break;
										}
										
										continue;
									}
									if(buffer[i]==PRESSRESOLVE)
									{
										//Log.i(Config.TAG,"Press Resolve Received");
										comms[commsindex]=PRESSRESOLVE;
										commsindex++;
										i++;
										continue;
									}
									if(buffer[i]==PLAY)
									{
										
										//Log.i(Config.TAG,"Press Play Received");
										int startoff = commsindex;
										comms[commsindex]=PLAY;
										commsindex++;
										i++;
										comms[commsindex]=(int)buffer[i] & 0xff;
										commsindex++;
										i++;
										comms[commsindex]=(int)buffer[i];
										commsindex++;
										i++;
										comms[commsindex]=(int)buffer[i];
										int endoff = commsindex;
										commsindex++;
										i++;
										if(isserver)//server should ignore these....
										{
											for(int c=startoff;c<=endoff;c++)
											{
												comms[c] = 0;
											}
											commsindex = startoff;
										}
										continue;
									}
									if(buffer[i]==PRESSEXIT)
									{
										//Log.i(Config.TAG,"Press Exit eEceived");
										comms[commsindex]=PRESSEXIT;
										commsindex++;
										i++;
										continue;
									}
									if(buffer[i]==MAPNORMAL || buffer[i]==MAPSNOW || buffer[i]==MAPDESERT)
									{
										//Log.i(Config.TAG,"Weather received");
										comms[commsindex]=(int)buffer[i];
										commsindex++;
										i++;
										continue;
									}
									if(buffer[i]==SYNC)
									{
										//Log.i(Config.TAG,"Sync Received");
										int off = 0;
										int startoff = commsindex;
										int endoff = commsindex;
										comms[commsindex]=(int)buffer[i];
										commsindex++;
										off++;
										int num0 = buffer[i+1] & 0xff;
										int num1 = buffer[i+2] & 0xff;
										int numunits = num0 + num1 * 256;
										comms[commsindex] = num0;
										commsindex++;
										off++;
										comms[commsindex] = num1;
										endoff = commsindex;
										commsindex++;
										off++;
										//Log.i(Config.TAG,"NumUnits:"+numunits);
										for(int j=0;j<numunits;j++)
										{
											comms[commsindex] = buffer[i+3+j*9] & 0xff;//id0
											commsindex++;
											comms[commsindex] = buffer[i+4+j*9] & 0xff;//id1
											commsindex++;
											comms[commsindex] = buffer[i+5+j*9] & 0xff;//x
											commsindex++;
											comms[commsindex] = buffer[i+6+j*9] & 0xff;//y
											commsindex++;
											comms[commsindex] = buffer[i+7+j*9] & 0xff;//fire0
											commsindex++;
											comms[commsindex] = buffer[i+8+j*9] & 0xff;//fire1
											commsindex++;
											comms[commsindex] = buffer[i+9+j*9] & 0xff;//retreat
											commsindex++;
											comms[commsindex] = buffer[i+10+j*9] & 0xff;//tx
											commsindex++;
											comms[commsindex] = buffer[i+11+j*9] & 0xff;//ty
											endoff = commsindex;
											commsindex++;
											off+=9;
										}
										i+=off;
										if(isserver)//server should ignore these.....
										{
											for(int c=startoff;c<=endoff;c++)
											{
												comms[c] = 0;
											}
											commsindex = startoff;
										}
										continue;
									}
								}
								
							}
							//if(!timedout)
							//{
								commsready = 2;
							//}
						}
					}
				}
				catch(Exception all)
				{
					Game.WriteDebug("Error:"+all.Message);
					//THREADRUNNING = 0;
					EXITSIGNAL = 1;
					//try
					//{
	//								socket.close();
					//}
					//catch(Exception ff)
					//{
	//								
					//}
					//socket = null;
					break;
				}
				//////////////////////
			}
			thread1 = 0;	
			Game.WriteDebug("Finished Listening");			
			if(thread2==0)
			{
				THREADRUNNING = 0;
			}
			
		}
		
		public static void ThreadSending()
		{
			Game.WriteDebug("Sending Thread");
			try
			{
				byte[] buffer = Buffer(SEEKCONNECTION);
				int oldframe = 0;
				//Log.i(Config.TAG,"Attempting To Connect");
				while(foundremote==false && isserver==true)
				{
					if(EXITSIGNAL==1)
					{
						foundremote = false;
						//THREADRUNNING = 0;
						//try
						//{
	//								//Log.i(Config.TAG,"Exiting. Closing Socket");
							//socket.close();
							//socket = null;
						//}
						//catch(Exception e)
						//{
	//								
						//}
						break;
					}
					if(Functions.abs(gameframe - oldframe)>500)
					{
						//THREADRUNNING = 0;
						EXITSIGNAL = 1;
						//Log.i(Config.TAG,"RenderList Too different. Exiting thread");
						break;
					}
					oldframe = gameframe;
					try
					{
						//ie the client...not us....
						remotedevice = InetAddress.getByName(ClientIP());
						
						if(remotedevice=="")
						{
							remotedevice = null;
						}
						else
						{
							//Game.WriteDebug("Client IP Set:"+remotedevice);
						}
						//Log.i(Config.TAG,"Client Found?");
					}
					catch (Exception e) 
					{
						remotedevice = null;
						Game.WriteDebug("Error:"+e.Message);
					}
					if(remotedevice!=null) 
					{
						//send to client a connection request from the server....
						//and keep sending for a minute until
						//it responds.....
						//Log.i(Config.TAG,"Sending Connection Request From Server");
						sendpacket = new DatagramPacket(buffer,maxpacketlength,remotedevice,port);
						try
						{
							//Game.WriteDebug("Sending packet to:"+remotedevice);
							socket.send(sendpacket);
							//Log.i(Config.TAG,"Connection Request Sent");
						}
						catch (Exception e) 
						{
							//do nothing....
							//Log.w(Config.TAG,"Connection Request Failed (error)");
							Game.WriteDebug("Error:"+e.Message);
						}
					}
					else
					{
						//only change since shower....
						//DONOTRESTART = true;
						//break;
					}
				}
				if(THREADRUNNING==0)
				{
				}
				else
				{
					if(foundremote==true || isserver==false)
					{
						string remote = null;
						while(EXITSIGNAL==0)
						{
							if(isserver)
							{
								remote = remotedevice;
							}
							else
							{
								remote = remoteserver;
							}
							try
							{
								//Thread.sleep(30);
								//SDL.SDL_Delay(30);
							}
							catch (Exception e) 
							{
								//do nothing
								Game.WriteDebug("Error:"+e.Message);
							}
							if(remote!=null)
							{
								if(readytocommunicate)
								{
									//allow calling of special protocols.....
									//other methods at top of NetworkUDP
									//class handle what goes on in here.....
									//////////////////////////////////////////////////////////
									//HANDLED IN OTHER METHOD.....
									//////////////////////////////////////////////////////////
									if(pleasesend>0)
									{
										sendpacket = new DatagramPacket(sendbuffer,maxpacketlength,remote,port);
										socket.send(sendpacket);
										pleasesend = 0;
										for(int i=0;i<sendbuffer.Length;i++)
										{
											sendbuffer[i] = 0;
										}
									}
								}
								if(isserver)
								{
									//server does this:
									remote = remotedevice;
								}
								else
								{
									//client does this:
									remote = remoteserver;
									//WE ARE A CLIENT SO WE NEED TO SEND TO THE SERVER A 'CONNECTION ESTABLISHED' 
									//UNTIL IT IS ACKNOWLEDGED
									if(!CONNECTIONACKNOWLEDGED)
									{
										//Log.i(Config.TAG,"Acknowleding Received From Server");
										buffer = Buffer(CONNECTIONRECEIVEDFROMSERVER);
										sendpacket = new DatagramPacket(buffer,maxpacketlength,remote,port);
										try 
										{
											//Game.WriteDebug("Sending packet to:"+remote);
											socket.send(sendpacket);
											CONNECTIONACKNOWLEDGED = true;
											readytocommunicate = true;
											//Log.i(Config.TAG,"Acknowledgement Sent");
										}
										catch(Exception e)
										{
											Game.WriteDebug("Error:"+e.Message);
										}
									}
								}
									
							}
						}
						if(EXITSIGNAL==1)
						{
							////Log.i(Config.TAG,"EXITSIGNAL SENT");
							foundremote = false;
							//THREADRUNNING = 0;
							//try
							//{
	//									socket.close();
								//socket = null;
							//}
							//catch(Exception e)
							//{
	//									
							//}
						}
					}
				}	
			}
			catch(Exception all)
			{
				Game.WriteDebug("Error:"+all.Message);
				//THREADRUNNING = 0;
				EXITSIGNAL = 1;
				//try
				//{
	//						socket.close();
				//}
				//catch(Exception gg)
				//{
	//						
				//}
				//socket = null;
			}
			thread2 = 0;
			Game.WriteDebug("Exiting Sending Thread");
			if(thread1==0)
			{
				THREADRUNNING = 0;
			}
		}
		
		public static void HandleComms()
		{
			if(commsready!=2)
			{
				return;
			}
			isnetworked = true;
			if(commsindex>=comms.Length)
			{
				commsindex = comms.Length - 1;
			}
			int c = 0;
			while(c<commsindex)
			{
				if(comms[c]==1)//templateindex.....etc...
				{
					int templateindex = comms[c+1];
					int boardx = comms[c+2];
					int boardy = comms[c+3];
					c+=4;
					if(boardy<=1)
					{
						//red player
						for(int x=boardx * 160;x<boardx * 160+160;x+=Map.GRIDW/4)
						{
							for(int y=boardy * Game.BOARDY;y<boardy * Game.BOARDY +Game.BOARDY;y+=Map.GRIDH/4)
							{
								int nid = Map.cellunit(x, y);
								if(nid!=-1)
								{
									if(Game.units[nid].boardy==boardy)//6oct2021
									{
										Game.units[nid].hp=0;
										Map.removeunit(nid, x, y);
										Game.units[nid].reset(null,nid);
									}
								}
							}
						}
						int tcount = Game.templates[templateindex].points;
						if(tcount>14)//21oct2021
						{
							tcount = 14;
						}
						Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
						for(int y=boardy * Game.BOARDY;y<boardy* Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
						{
							for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
							{
								int nid = Map.cellunit(x, y);
								if(nid==-1 && Map.passable(x, y))
								{
									for(int j=0;j<Game.units.Length;j++)
									{
										if(Game.units[j].hp<=0)
										{
											if(Game.units[j].createunitatxy(null, j, Game.templates[templateindex], x, y))
											{
												tcount--;
											}
											break;
										}
									}
								}
								if(tcount<=0)
								{
									break;
								}
							
							}
							if(tcount<=0)
							{
								break;
							}
						}
						
					}
					if(boardy>=7)
					{
						//blue player
						//red player
						for(int x=boardx * 160;x<boardx*160+160;x+=Map.GRIDW/4)
						{
							for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
							{
								int nid = Map.cellunit(x, y);
								if(nid!=-1)
								{
									if(Game.units[nid].boardy==boardy)//6oct2021
									{
										Game.units[nid].hp=0;
										Map.removeunit(nid, x, y);
										Game.units[nid].reset(null,nid);
									}
								}
							}
						}
						int tcount = Game.templates[templateindex].points;
						if(tcount>14)//21oct2021
						{
							tcount = 14;//
						}
						Unit.HASLEADER = Game.templates[Game.templateindex].hasleader;//21oct2021
						for(int y=boardy*Game.BOARDY;y<boardy*Game.BOARDY+Game.BOARDY;y+=Map.GRIDH/4)
						{
							for(int x=boardx*160;x<boardx*160+160;x+=Map.GRIDW/4)
							{
								int nid = Map.cellunit(x, y);
								if(nid==-1 && Map.passable(x, y))
								{
									for(int j=0;j<Game.units.Length;j++)
									{
										if(Game.units[j].hp<=0)
										{
											if(Game.units[j].createunitatxy(null, j, Game.templates[templateindex], x, y))
											{
												tcount--;
											}
											break;
										}
									}
								}
								if(tcount<=0)
								{
									break;
								}
							
							}
							if(tcount<=0)
							{
								break;
							}
						}
					}
					continue;
				}
				if(comms[c]==2)//resolve
				{
					if(Game.RESOLVE<1)
					{
						Game.RESOLVE = 1;
						Game.gamemode = -1;
					}
					c++;
					continue;
				}
				if(comms[c]==3)//exit
				{
					//NetworkUDP.Exit();
					Game.GAMEENDSTATE = Game.GAMEENDSTATE_DEFEAT;
					if(Game.gameovertime==0){Game.gameovertime = 3;}//7oct2021 reduced massively.....
					//Replay.EndRecord();
					c++;
					continue;
				}
				if(comms[c]==4)//desert
				{
					Map.weather = Map.WEATHERHOT;
					Map.tilecat = Map.deserttilecat;
					Map.treecat = Map.deserttreecat;
					Map.SetUpHills();//20oct2021
					c++;
					continue;
				}
				if(comms[c]==BEACON)//19oct2021
				{
					c++;
					int x = comms[c] * Map.GRIDW;
					c++;
					int y = comms[c] * Map.GRIDH;
					c++;
					int faction = comms[c];
					c++;
					Beacon.SEND = false;//20oct2021
					Beacon.PlaceBeacon(x,y,faction);
					continue;
				}
				if(comms[c]==SPELL)//18oct2021
				{
					c++;
					//other player casts a spell.......
					//-3 is the offset that tells the SpellAction function that this is from an external client...
					Spells.SpellAction(Game.LocalEnemyIndex,comms[c] - 3);
					c++;
					continue;
				}
				if(comms[c]==SYNCCAMPAIGN)
				{
					c++;
					int endoff = c;
					if(!isserver)
					{
						for(int i=0;i<CampaignMap.maxprovince;i++)
						{
							int owner = comms[c];
							c++;
							int armyindex = comms[c];
							c++;
							endoff = c;
							CampaignMap.provinceowner[i] = owner;
							CampaignMap.provincearmy[i] = armyindex;
							LocalStorage.setitem("0Territory_"+i, ""+(owner+1));
							LocalStorage.setitem("0TerritoryArmy_"+i,""+armyindex);
						}
						for(int g=0;g<Game.gui.Length;g++)
						{
							if(Game.gui[g].link==("territory"))
							{
								Game.gui[g].index = CampaignMap.maxprovince * CampaignMap.provinceowner[Game.gui[g].index % CampaignMap.maxprovince] + (Game.gui[g].index % CampaignMap.maxprovince);
							}
						}
						
					}
					c = endoff;
					continue;
				}
				if(comms[c]==UPDATESPEED)
				{
					c++;
					int speed = comms[c];
					c++;
					if(speed>0)
					{
						otherpcspeed = speed;
					}
					if(otherpcspeed>75)
					{
						otherpcspeed = 75;
					}
					if(otherpcspeed<1)
					{
						otherpcspeed = 1;
					}
					continue;
				}
			
				if(comms[c]==TOUCHCAMPAIGNMAP)
				{
					c++;
					if(!isserver)
					{
						//two shorts....
						int xnum0 = comms[c];
						c++;
						int xnum1 = comms[c];
						c++;
						int ynum0 = comms[c];
						c++;
						int ynum1 = comms[c];
						c++;
						int gui0 = comms[c];
						c++;
						int gui1 = comms[c];
						c++;
						int x = xnum0 + xnum1 * 256;
						int y = ynum0 + ynum1 * 256;
						int i = gui0 + gui1 * 256;
						CampaignMap.ChangeTerritoryOwner(x,y);
						Game.gui[i].index = CampaignMap.maxprovince * CampaignMap.GetTerritoryOwner(x,y) + CampaignMap.GetTerritoryIndex(x,y);
					}
					else
					{
						c+=6;
					}
					continue;
				}
				if(comms[c]==TOUCHCAMPAIGNICON)
				{
					c++;
					int province = comms[c];
					if(!isserver)
					{
						CampaignMap.SetArmy(province);
					}
					c++;
					continue;
				}
				if(comms[c]==8)//PLAY//Now this will really test whether or not the recycling system works well....for bitmaps...
				{
					//
					c++;
					if(!isserver)
					{
						Game.vsai = 0;
						Game.chosenmissionindex = 0;
						Game.campaignmode = 0;//8oct2021
						if(Game.chosenmissionindex!=-1)
						{
							Map.levelseed = Functions.seed;//2apr2021
							Program.resetgame(null);//2apr2021
							Game.PLAYERFACTION = Unit.HUMAN;
							Game.SKIRMISHENEMYFACTION = Unit.UNDEAD;
							Game.gamestate = Game.CAT_GAMESTATE_GAME;
							Program.cleardeaths(null);
							Game.map = new Map();
							CampaignMap.seed = comms[c];
							Program.setupmission(null,Game.chosenmissionindex,2);
							Map.adddecor();//2mar2021
							Map.marktreepos(null);
							Map.levelseed2 = Functions.seed;//2apr2021
							//remove all units....
							for(int nid=0;nid<Game.units.Length;nid++)
							{
								Game.units[nid].hp = 0;
								Map.removeunit(nid,Game.units[nid].x,Game.units[nid].y);
								Game.units[nid].reset(null,nid);
							}
							//Map.removeallbones();
							Game.gamemode = 0;//DEPLOY
							Game.RESOLVE = 0;
							Game.PLAYERFACTION = 6;//7oct2021
							Game.SKIRMISHENEMYFACTION = 5;//7oct2021
						}
						c++;
						Game.FriendIndex = comms[c];
						c++;
						Game.EnemyIndex = comms[c];
						c++;
						Game.OldEnemyArmy = Game.EnemyArmy;
						Game.OldFriendArmy = Game.FriendArmy;
						switch(Game.EnemyIndex)
						{
						case 0:
							Game.EnemyArmy = "Red";
							break;
						case 1:
							Game.EnemyArmy = "Blue";
							break;
						case 2: 
							Game.EnemyArmy = "Skeleton";
							break;
						case 3:
							Game.EnemyArmy = "Realm";
							break;
						case 4:
							Game.EnemyArmy = "Evil";
							break;
						case 5:
							Game.EnemyArmy = "Fiend";
							break;
						}
						switch(Game.FriendIndex)
						{
						case 0:
							Game.FriendArmy = "Red";
							break;
						case 1:
							Game.FriendArmy = "Blue";
							break;
						case 2: 
							Game.FriendArmy = "Skeleton";
							break;
						case 3:
							Game.FriendArmy = "Realm";
							break;
						case 4:
							Game.FriendArmy = "Evil";
							break;
						case 5:
							Game.FriendArmy = "Fiend";
							break;
						}
						//Resources.//LoadNewArmy(Game.OldFriendArmy, Game.FriendArmy,Game.OldEnemyArmy,Game.EnemyArmy);
						for(int t=0;t<Game.templates.Length;t++)
						{
							if(Game.templates[t].name!=null)
							{
								if(Game.templates[t].name.IndexOf(Game.FriendArmy)>=0)
								{
									
									Game.templates[t].faction = 6;
								}
								if(Game.templates[t].name.IndexOf(Game.EnemyArmy)>=0)
								{
									
									Game.templates[t].faction = 5;
								}
							}
						}
						if(NetworkUDP.isserver)//18oct2021
						{
							Game.LocalPlayerIndex = Game.FriendIndex;
							Game.LocalEnemyIndex = Game.EnemyIndex;
						}
						else
						{
							Game.LocalPlayerIndex = Game.EnemyIndex;
							Game.LocalEnemyIndex = Game.FriendIndex;
						}
						
						Game.PLAYERFACTION = 6;
						Game.SKIRMISHENEMYFACTION = 5;
						for(int g=0;g<Game.gui.Length;g++)
						{
							if(Game.gui[g].link==("friend"))
							{
								Game.gui[g].index = Game.FriendIndex;
							}
						}
						for(int g=0;g<Game.gui.Length;g++)
						{
							if(Game.gui[g].link==("enemy"))
							{
								Game.gui[g].index = Game.EnemyIndex;
							}
						}
					}
					else
					{
						c+=4;
					}
					continue;
				}
				if(comms[c]==5)//snow
				{
					Map.weather = Map.WEATHERCOLD;
					Map.tilecat = Map.snowtilecat;
					Map.treecat = Map.snowtreecat;
					Map.SetUpHills();//20oct2021
					c++;
					continue;
				}
				if(comms[c]==6)//normal weather
				{
					Map.weather = Map.WEATHERNORMAL;
					Map.tilecat = Map.grasstilecat;
					Map.treecat = Map.grasstreecat;
					Map.SetUpHills();//20oct2021
					c++;
					continue;
				}
				if(comms[c]==7)//SYNC command
				{
					c++;
					int numunits = 0;
					int num0 = comms[c];
					c++;
					int num1 = comms[c];
					c++;
					numunits = num0 + 256 * num1;
					//first of all set all the hp to DEAD for all units 
					for(int i=0;i<Game.units.Length;i++)
					{
						Game.units[i].pohp = Game.units[i].hp;
						Game.units[i].hp = 0;
						Map.removeunit(i, Game.units[i].x, Game.units[i].y);
					}
					//then bring back to life any that are NOT DEAD
					for(int off=0;off<numunits*9;off+=9)
					{
						int id0 = comms[c];
						c++;
						int id1 = comms[c];
						c++;
						int gridx = comms[c];
						c++;
						int gridy = comms[c];
						c++;
						int fire0 = comms[c];
						c++;
						int fire1 = comms[c];
						c++;
						int retreat = comms[c];
						c++;
						int tgridx = comms[c];
						c++;
						int tgridy = comms[c];
						c++;
						int id = id0 + id1 * 256;
						int firetargeti = -1;
						if(fire0==255 && fire1==255)
						{
							firetargeti = -1;
						}
						else
						{
							firetargeti = fire0 + fire1 * 256;
						}
						if(id >= 600) //max length of units array....//will not exist on client device
						{
							//this is a summoned creature......
							int actualid = id % 1000;
							int zombieorder = (id - actualid) / 1000;
							int zombieindex = 0;
							int zombietemplate = -1;
							for(int tid=0;tid<Game.templates.Length;tid++)
							{
								if(Game.templates[tid].zombie>0)
								{
									zombieindex++;
								}
								if(zombieindex>=zombieorder)
								{
									//this is the template we used.....
									zombietemplate = tid;
									break;
								}
							}
							id = actualid;
							if(zombietemplate!=-1)
							{
								Game.units[id].reset(null, actualid);
								Game.units[id].createunitatxy(null, actualid, Game.templates[zombietemplate], gridx * Map.GRIDW, gridy * Map.GRIDH);
							}
						}
						else
						{
							if(Game.units[id].pohp<=0)
							{
								//oops the client killed this unit...need to bring it back to life....
								//hence the 'originaltemplateid' is needed.....
								Game.units[id].reset(null, id);
								Game.units[id].createunitatxy(null, id, Game.templates[Game.units[id].originaltemplateid], gridx * Map.GRIDW, gridy * Map.GRIDH);
							}
						}
						Game.units[id].hp = Game.units[id].basehp;//10000;
						Game.units[id].firetargeti = firetargeti;
						Game.units[id].retreat = false;
						if(retreat>0)
						{
							Game.units[id].retreat = true;
							Game.units[id].retreatframe = Game.frame + Unit.RETREATDEATH;
						}
						int curx = Game.units[id].x / Map.GRIDW;
						int cury = Game.units[id].y / Map.GRIDH;
						if(curx!=gridx || cury!=gridy)
						{
							Game.units[id].x = gridx * Map.GRIDW;
							Game.units[id].y = gridy * Map.GRIDH;
						}
						int curtx = Game.units[id].tx / Map.GRIDW;
						int curty = Game.units[id].ty / Map.GRIDH;
						if(curtx!=tgridx || curty!=tgridy)
						{
							Game.units[id].tx = tgridx * Map.GRIDW;
							Game.units[id].ty = tgridy * Map.GRIDH;
							Game.units[id].tmptx = tgridx * Map.GRIDW;
							Game.units[id].tmpty = tgridy * Map.GRIDH;
							Game.units[id].tmptattempts = 0;
						}
						if(Game.units[id].name!=null)
						{
							if(Game.units[id].name.IndexOf(Game.FriendArmy)>=0)
							{
								Game.units[id].faction = 6;
								Game.templates[Game.units[id].templateid].faction = 6;
							}
							if(Game.units[id].name.IndexOf(Game.EnemyArmy)>=0)
							{
								Game.units[id].faction = 5;
								Game.templates[Game.units[id].templateid].faction = 5;
							}
						}
						Game.PLAYERFACTION = 6;
						Game.SKIRMISHENEMYFACTION = 5;
						Map.insertunit(id, Game.units[id].x, Game.units[id].y); //will fail if it was a zombie but no matter......
					}
					//
					continue;
				}
			}
			commsindex = 0;
			commsready = 0;
		}
		
		public static bool Ready()
		{
			if(alteredgui==0 && isserver==true)//20oct2021
			{
				for(int i=0;i<Game.gui.Length;i++)
				{
					if(Game.gui[i].title == "2 Player")
					{
						Game.gui[i].title = "Multiplayer";
						Game.gui[i].tooltip = "2 Player Battle over Network";
						alteredgui = 1;
						break;
					}
				}
			}
			return readytocommunicate;
		}
		
		public static void communicate(int command,int[] args)
		{
			if(!readytocommunicate)
			{
				return;
			}
			//Log.i(Config.TAG,"Communicating with Remote:TYPE:"+command);
			sendbuffer[pleasesend] = 0;
			sendbuffer[pleasesend+1] = 0;
			sendbuffer[pleasesend+2] = 0;
			sendbuffer[pleasesend+3] = 0;
			isnetworked = true;
			if(command==CREATEUNIT)
			{
				sendbuffer[pleasesend+4] = 1;
				sendbuffer[pleasesend+5] = (byte)args[0]; //templateindex
				sendbuffer[pleasesend+6] = (byte)args[1]; //boardx
				sendbuffer[pleasesend+7] = (byte)args[2]; //boardy
				pleasesend+=8;
			}
			if(command==UPDATESPEED)
			{
				sendbuffer[pleasesend+4] = (byte) UPDATESPEED;
				sendbuffer[pleasesend+5] = (byte) Game.FRAMERATE;
				pleasesend+=6;
			}
			if(command==BEACON)//19oct2021
			{
				sendbuffer[pleasesend+4] = (byte) BEACON;
				sendbuffer[pleasesend+5] = (byte) args[0];
				sendbuffer[pleasesend+6] = (byte) args[1];
				sendbuffer[pleasesend+7] = (byte) args[2];
				pleasesend+=8;
			}
			if(command==SPELL)//18oct2021
			{
				sendbuffer[pleasesend+4] = (byte) SPELL;
				sendbuffer[pleasesend+5] = (byte) args[0];
				pleasesend+=6;
			}
			if(command==SYNCCAMPAIGN)
			{
				sendbuffer[pleasesend+4] = (byte) SYNCCAMPAIGN;
				for(int i=0;i<CampaignMap.maxprovince;i++)
				{
					sendbuffer[pleasesend+5+i*2] = (byte) CampaignMap.provinceowner[i];
					if(CampaignMap.provincearmy[i]<0)
					{
						CampaignMap.provincearmy[i]=18;
					}
					sendbuffer[pleasesend+5+i*2+1] = (byte)CampaignMap.provincearmy[i];
				}
				pleasesend+=(5+CampaignMap.maxprovince*2);
			}
			if(command==TOUCHCAMPAIGNMAP)
			{
				sendbuffer[pleasesend+4] = (byte) TOUCHCAMPAIGNMAP;
				sendbuffer[pleasesend+5] = (byte) (args[0] % 256);
				sendbuffer[pleasesend+6] = (byte) ((args[0] - (args[0] % 256))/256);
				sendbuffer[pleasesend+7] = (byte) (args[1] % 256);
				sendbuffer[pleasesend+8] = (byte) ((args[1] - (args[1] % 256))/256);
				sendbuffer[pleasesend+9] = (byte) (args[2] % 256);
				sendbuffer[pleasesend+10] = (byte) ((args[2] - (args[2] % 256))/256);
				pleasesend+=11;
			}
			if(command==TOUCHCAMPAIGNICON)
			{
				sendbuffer[pleasesend+4] = (byte) TOUCHCAMPAIGNICON;
				sendbuffer[pleasesend+5] = (byte) args[0];
				pleasesend+=6;
			}
			if(command==PRESSEXIT)
			{
				sendbuffer[pleasesend+4] = 3;//exit command...
				pleasesend+=5;
			}
			if(command==PLAY)
			{
				sendbuffer[pleasesend+4] = 8;//PLAY command
				sendbuffer[pleasesend+5] = (byte)(CampaignMap.seed);
				sendbuffer[pleasesend+6] = (byte)args[0];
				sendbuffer[pleasesend+7] = (byte)args[1];
				pleasesend+=8;
			}
			if(command==PRESSRESOLVE)
			{
				sendbuffer[pleasesend+4] = 2;//resolve command...
				pleasesend+=5;
			}
			if(command==MAPDESERT)
			{
				sendbuffer[pleasesend+4] = 4;
				pleasesend+=5;
			}
			if(command==MAPSNOW)
			{
				sendbuffer[pleasesend+4] = 5;
				pleasesend+=5;
			}
			if(command==MAPNORMAL)
			{
				sendbuffer[pleasesend+4] = 6;
				pleasesend+=5;
			}
			if(command==SYNC)
			{
				//send the following through to the CLIENT from the SERVER
				//A COMMAND OF SYNC BYTE
				//A COUNT OF UNITS AS SHORT
				//{FOR EACH UNIT
				//ALL UNIT id as SHORT ONLY FOR UNITS WHERE HP>0
				//ALL UNIT GRIDX, GRIDY as (BYTE)
				//ALL UNIT FIRETARGETi AS SHORT
				//RETREAT AS 0/1
				//}
				//6 BYTES PER UNIT = approx 3600 bytes if ALL UNITS sent
				
				sendbuffer[pleasesend+4] = 7;
				int numunits = 0;
				for(int i=0;i<Game.units.Length;i++)
				{
					if(Game.units[i].hp>0 && Game.units[i].x<Game.RESOLUTIONX && Game.units[i].y<Game.RESOLUTIONY)
					{
						numunits++;
					}
				}
				int num0 = numunits % 256;
				int num1 = (numunits - (numunits % 256))/256;
				sendbuffer[pleasesend+5] = (byte)num0;
				sendbuffer[pleasesend+6] = (byte)num1;
				int off = 7;
				for(int i=0;i<Game.units.Length;i++)
				{
					if(Game.units[i].hp>0 && Game.units[i].x<Game.RESOLUTIONX && Game.units[i].y<Game.RESOLUTIONY)
					{
						//summoned units...
						int s = 0;
						//this assumes there is a maximum of 64 different zombie templates in the game (summonable creatures)
						//this is not an unreasonable assumption.......
						if(Game.units[i].wassummoned>0)
						{
							for(int t=0;t<Game.templates.Length;t++)
							{
								if(Game.templates[t].zombie>0)
								{
									s+=1000;
								}
								if(Game.units[i].templateid==t)
								{
									break;
								}
							}
						}
						Game.units[i].wassummoned = 0;
						//add 1000 * the template order of the zombie/summoned unit...
						//then make sure we reset wassummoned back to 0 so that we only summon it once.....
						sendbuffer[pleasesend+off] = (byte)((i+s) % 256);
						sendbuffer[pleasesend+off+1] = (byte)(((i+s) - ((i+s) % 256))/256);
						sendbuffer[pleasesend+off+2] = (byte)(Game.units[i].x / Map.GRIDW);
						sendbuffer[pleasesend+off+3] = (byte)(Game.units[i].y / Map.GRIDH);
						if(Game.GAMEENDSTATE==Game.GAMEENDSTATE_DEFEAT || Game.GAMEENDSTATE==Game.GAMEENDSTATE_VICTORY)
						{
							Game.units[i].firetargeti = -1;//hack
						}						
						if(Game.units[i].firetargeti!=-1)
						{
							sendbuffer[pleasesend+off+4] = (byte)(Game.units[i].firetargeti % 256);
							sendbuffer[pleasesend+off+5] = (byte)((Game.units[i].firetargeti - (Game.units[i].firetargeti % 256))/256);
						}
						else
						{
							sendbuffer[pleasesend+off+4] = (byte)255;
							sendbuffer[pleasesend+off+5] = (byte)255;
						}
						if(Game.units[i].retreat)
						{
							sendbuffer[pleasesend+off+6] = 1;
						}
						else
						{
							sendbuffer[pleasesend+off+6] = 0;
						}
						sendbuffer[pleasesend+off+7] = (byte)(Game.units[i].tx / Map.GRIDW);
						sendbuffer[pleasesend+off+8] = (byte)(Game.units[i].ty / Map.GRIDH);
						off+=9;
					}
				}
				pleasesend+=(off);
			}
			for(int i=pleasesend;i<sendbuffer.Length;i++)
			{
				sendbuffer[i] = 0;
			}
		}
		
		public static byte[] Buffer(int type)
		{
			byte[] buf = new byte[maxpacketlength];
			if(type==SEEKCONNECTION)
			{
				//header for SEEKCONNECTION packets
				buf[0] = 11;
				buf[1] = 11;
				buf[2] = 11;
				buf[3] = 11;
				
			}
			if(type==SENDDATA)
			{
				//header for SENDDATA packets
				buf[0] = 0;
				buf[1] = 0;
				buf[2] = 0;
				buf[3] = 0;
			}
			if(type==CONNECTIONRECEIVED)
			{
				//header for CONNECTION ESTABLISHED
				buf[0] = 33;
				buf[1] = 33;
				buf[2] = 33;
				buf[3] = 33;
			}
			if(type==CONNECTIONRECEIVEDFROMSERVER)
			{
				//header for CONNECTION ESTABLISHED
				buf[0] = 44;
				buf[1] = 44;
				buf[2] = 44;
				buf[3] = 44;
			}
			
			return buf;
		}
			
		public static bool ShouldIBeServer()
		{
			if(Game.multiplayerip==null)
			{
				return false;
			}
			if(Game.multiplayerip!="")
			{
				if(NetworkUDP.trytobeserver=="1")
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			else
			{
				return false;
			}
		}
		
		public static String ClientIP(String ip)
		{
			clientip = ip;
			return ip;
		}
		
		public static String ClientIP()//Assumes my phone is the server......not the tablet...for now..until I work out how to get the ip address of the other device.....
		{
			string ip = "";
			if(clientip!=(""))
			{
				try
				{
					string address = InetAddress.getByName(clientip);
					//if(address.isReachable(50))
					//{
						ip = clientip;
						//Log.i(Config.TAG,"Client IP IS (supplied by user):"+ip);
						return ip;
					//}
				}
				catch(Exception e)
				{
					Game.WriteDebug("Error:"+e.Message);
				}
			}
			else
			{
				ip = null;
			}
		   return ip;
		}
		
		public static void Exit()
		{
			//EXITSIGNAL = 1;
			//readytocommunicate = false;
		}
		
		public static void InitAsServer()
		{
			if(THREADRUNNING==0)
			{
				isserver = ShouldIBeServer();
				Init();
			}
		}
		
		public static void InitAsClient()
		{
			if(THREADRUNNING==0)
			{
				isserver = ShouldIBeServer();
				Init();
			}
		}
		
		public static void Init()
		{
			if(DONOTRESTART)
			{
				return;
			}
			if(thread1>0 || thread2>0)
			{
				return;
			}
			if(thread1==0 && thread2==0)
			{
				if(THREADRUNNING>0)
				{
					if(socket!=null)
					{
						try
						{
							socket.close();
						}
						catch(Exception e)
						{
							Game.WriteDebug("Error:"+e.Message);
						}
					}
				}
				THREADRUNNING = 0;
			}
			if(THREADRUNNING>0)
			{
				return;
			}
			try
			{
				for(int i=0;i<sendbuffer.Length;i++)
				{
					sendbuffer[i] = 0;
				}
				THREADRUNNING = 1;
				thread1 = 1;
				thread2 = 1;
				EXITSIGNAL = 0;
				CONNECTIONACKNOWLEDGED = false;
				readytocommunicate = false;
				commsindex = 0;
				//if(socket!=null)
				//{
	//				try
					//{
	//					socket.close();
					//}
					//catch(Exception e)
					//{
	//					
					//}
					//socket = null;
				//}
				//Log.i(Config.TAG,"Creating Socket");
				Game.WriteDebug("SocketCreation");
				socket = new DatagramSocket(port);
				//Log.i(Config.TAG,"Socket Created");
				foundremote = false;
				//Listening Thread
				Thread thread = new Thread(new ThreadStart(ThreadListening));
				thread.Start();
				Thread threadb = new Thread(new ThreadStart(ThreadSending));
				threadb.Start();
			}
			catch (Exception e3) 
			{
			//socket = null;
				Game.WriteDebug("Error:"+e3.Message);
			}
		}
		
		public static void WriteMultiplayerFile()//13oct2021
		{
			string file = "media/multiplayerip.txt";
			string txt = "";
			string[] data = null;
			try
			{
				data = System.IO.File.ReadAllLines(file);
			}
			catch(Exception e)
			{
				Game.WriteDebug("Error:"+e.Message);
			}
			if(data==null) //file does not exist...
			{
				try
				{
					txt = "RemoteIP=" + "{NONE}" + Environment.NewLine;
					txt+= "AmServer=" + "1" + Environment.NewLine;
					txt+= "MatchSlowest="+"0" + Environment.NewLine;
					txt+="//////////////////////////////////////////"+Environment.NewLine;
					txt+="Edit This File To Set Up Multiplayer Games"+Environment.NewLine;
					txt+="The RemoteIP should be the other PC/Phone's IP Address"+Environment.NewLine;
					txt+="AmServer should be either 0 or 1, and only one device should be a '1'"+Environment.NewLine;
					txt+="MatchSlowest should be 0, but in some cases setting it to 1 may help."+Environment.NewLine;
					txt+="If You Delete This File It Will Regenerate"+Environment.NewLine;
					txt+="The Order of The Parameters Above Is Important."+Environment.NewLine;
					txt+="It Should Go RemoteIP, AmServer then Match Slowest."+Environment.NewLine;
					txt+="//////////////////////////////////////////"+Environment.NewLine;
					System.IO.File.WriteAllText(file,txt);		
				}
				catch(Exception e)
				{
					Game.WriteDebug("Could Not Generate Multiplayer File");
					Game.WriteDebug("Error:"+e.Message);
				}
			}
		}
		
		public static bool ValidIP(string txt)//13oct2021
		{
			string ntxt = txt;
			try
			{
				string[] data = txt.Split(".");
				if(data==null)
				{
					return false;
				}
				if(data.Length!=4)
				{
					return false;
				}
				for(int i=0;i<4;i++)
				{
					int octet = -1;
					Int32.TryParse(data[i],out octet);
					if(octet<9 || octet>254)
					{
						return false;
					}
				}
				Game.WriteDebug("Valid IP Address:"+txt);
				return true;
				
			}
			catch(Exception e)
			{
				string error = e.Message;
			}
			return false;
		}
		
		public static void TryMultiplayer()//12oct2021
		{
			if(EXITSIGNAL==0)
			{
				EXITSIGNAL = 1;
				SDL.SDL_Delay(200);
			}
			EXITSIGNAL = 0;
			Game.multiplayerip = "";
			try
			{
				string[] data = System.IO.File.ReadAllLines("media/multiplayerip.txt");						
				if(data!=null)
				{
					string iptxt = Resources.readstring(data[0]);
					//validate ip address
					if(ValidIP(iptxt))
					{
						Game.multiplayerip = iptxt;
					}
					else
					{
						Game.newtoast("Cannot Connect To:"+iptxt);
					}
					NetworkUDP.trytobeserver = Resources.readstring(data[1]);
					Config.MATCHSLOWEST = Resources.readint(data[2]);
					if(ValidIP(iptxt))
					{
						Game.WriteDebug("Am I Server:"+NetworkUDP.trytobeserver);
						Game.WriteDebug("Match Slowest (better if 0):"+Config.MATCHSLOWEST);
					}
					
				}
			}
			catch(Exception e)
			{
				Game.WriteDebug(e.Message);
				Game.WriteDebug("Error Reading Multiplayer.txt File");
			}
			NetworkUDP.clientip = ClientIP(Game.multiplayerip);
			NetworkUDP.ip = ClientIP(Game.multiplayerip);
			NetworkUDP.InitAsServer();
		}
	}
	
	
	class Beacon//19oct2021
	{
		public int x;
		public int y;
		public int life;
		public int age;
		public int faction;
		public bool send;//20oct2021
		//
		public static bool SEND = true;
		public static int lastx = -1;
		public static int lasty = -1;
		public static int maxlife = 5;
		public static int maxbeacons = 20;
		public static int maxfactionbeacon = 10;
		public static int radius = Map.GRIDW * 20;
		public static Beacon[] beacons = new Beacon[20]; //each side gets the first 0-9 and the second 10-19
		public static int beaconimg = -1;
		//
		
		public static int enabled = 1;//20oct2021
		
		
		public static void Init()
		{
			for(int i=0;i<maxbeacons;i++)
			{
				beacons[i] = new Beacon();
			}
		}
		
		public Beacon()
		{
			x = -1;
			y = -1;
			life = -1;
			faction = -1;
			age = -1;
		}
	
		public static void ApplyBeaconPull(int u)
		{
			if(enabled==0)//20oct2021
			{
				return;
			}
			//u is a unit......
			float nearest = 10000;
			int j = -1;
			for(int i=0;i<maxbeacons;i++)
			{
				if(Game.units[u].faction!=beacons[i].faction)
				{
					continue;
				}
				if(beacons[i].life<=0)
				{
					continue;
				}
				float dist = Functions.abs(beacons[i].x * Map.GRIDW - Game.units[u].x) + Functions.abs(beacons[i].y * Map.GRIDH - Game.units[u].y);
				if(dist<radius && dist<nearest)
				{
					nearest = dist;
					j = i;
				}
			}
			if(j!=-1)
			{
				Game.units[u].defendx = beacons[j].x * Map.GRIDW;
				Game.units[u].defendy = beacons[j].y * Map.GRIDH;
				int offx = ((u % 4) - 2) * Map.GRIDW;
				int offy = ((((u - (u % 4))/4)%4) - 2) * Map.GRIDH;
				Game.units[u].defendx+=offx;
				Game.units[u].defendy+=offy;
				if(Game.units[u].defendx<0)
				{
					Game.units[u].defendx = 0;
				}
				if(Game.units[u].defendy<0)
				{
					Game.units[u].defendy = 0;
				}
				if(Game.units[u].defendx>(Map.MAXX - 1) * Map.GRIDW)
				{
					Game.units[u].defendx = (Map.MAXX - 1) * Map.GRIDW;
				}
				if(Game.units[u].defendy>(Map.MAXY - 1) * Map.GRIDH)
				{
					Game.units[u].defendy = (Map.MAXY - 1) * Map.GRIDH;
				}
				if(beacons[j].life>=maxlife-2)
				{
					Game.units[u].firetargeti = -1;
					Game.units[u].tx = Game.units[u].defendx;
					Game.units[u].ty = Game.units[u].defendy;
					Game.units[u].tmptx = Game.units[u].tx;
					Game.units[u].tmpty = Game.units[u].ty;
					Game.units[u].orderframe = 30;
					
				}
				Game.units[u].defendx = -1;
				Game.units[u].defendy = -1;
			}
			else
			{
				Game.units[u].defendx = -1;
				Game.units[u].defendy = -1;
			}
		}
	
		public static void DrawBeacons()
		{
			if(enabled==0)//20oct2021
			{
				return;
			}
			
			if(beaconimg!=-1)
			{
				for(int i=0;i<maxbeacons;i++)
				{
					if(beacons[i].life>0)
					{
						if(beacons[i].faction==6 && Game.LocalPlayerIndex==Game.FriendIndex)
						{
							beacons[i].draw();
						}
						if(beacons[i].faction==5 && Game.LocalPlayerIndex==Game.EnemyIndex)
						{
							beacons[i].draw();
						}
					}
				}
			}
		}
	
		public void draw()
		{
			int screenx = x * Map.GRIDW;
			int screeny = y * Map.GRIDH;
			float alpha = 1f;
			if(life < maxlife / 2) // last 50%
			{
				alpha = 0.8f;
			}
			if(life < maxlife / 4) // last 25%
			{
				alpha = 0.5f;
			}
			if(life < maxlife / 8) // last 12%
			{
				alpha = 0.3f;
			}
			if(life < maxlife / 20) // last 5%
			{
				alpha = 0.2f;
			}
			RenderList.drawimage(null,Game.images[beaconimg].texture,screenx,screeny,0,1,1,0,0,false,alpha,beaconimg);
		}
	
		public static void CheckEnabled()//20oct2021
		{
			
			enabled = 0;
		}
	
	
		public static void UpdateBeacons()
		{
			if(enabled==0)//20oct2021
			{
				return;
			}
			for(int i=0;i<maxbeacons;i++)
			{
				if(beacons[i].life==maxlife && beacons[i].send==true)//20oct2021
				{
					beacons[i].send = false;//20oct2021
					if(NetworkUDP.Ready())
					{
						//if we are multiplayer send a command......
						if(lastx!=(beacons[i].x - beacons[i].x % 4) || lasty!=(beacons[i].y - beacons[i].y % 4))
						{
							int[] args = new int[3];
							args[0] = beacons[i].x;
							args[1] = beacons[i].y;
							args[2] = beacons[i].faction;
							NetworkUDP.communicate(NetworkUDP.BEACON,args);
							lastx = beacons[i].x - beacons[i].x % 4;
							lasty = beacons[i].y - beacons[i].y % 4;
						}
					}
				}
				beacons[i].age++;
				beacons[i].life--;
				if(beacons[i].life<=0)
				{
					beacons[i].age = -1;
					beacons[i].faction = -1;
					beacons[i].x = -1;
					beacons[i].y = -1;
					beacons[i].life = -1;
				}
			}
		}
	
		public static void ClickBeacon()
		{
			if(enabled==0)//20oct2021
			{
				return;
			}
			
			if(Game.RESOLVE<1)
			{
				return;
			}
			if(Game.mlclick==false)
			{
				return;
			}
			int faction = -1;
			if(Game.LocalPlayerIndex==Game.FriendIndex)
			{
				faction = 6;
			}
			if(Game.LocalPlayerIndex==Game.EnemyIndex)
			{
				faction = 5;
			}
			if(faction!=-1)
			{
				PlaceBeacon(Game.mx,Game.my,faction);
			}		
		}
	
		public static void PlaceBeacon(int x, int y,int faction)
		{
			//x and y are screen positions.....
			int countf = 0;
			if(enabled==0)//20oct2021
			{
				return;
			}
			
			
			//adjust x to be on grid.....
			x/=Map.GRIDW;
			y/=Map.GRIDH;
			if(x<0)
			{
				x=0;
			}
			if(y<0)
			{
				y=0;
			}
			if(x>=Map.MAXX)
			{
				x = Map.MAXX;
			}
			if(y>=Map.MAXY)
			{
				y = Map.MAXY;
			}
			for(int i=0;i<maxbeacons;i++)
			{
				if(beacons[i].faction==faction)
				{
					countf++;
				}
			}
			if(countf>=maxfactionbeacon)
			{
				//replace oldest of theirs
				int oldest = 0;
				int j = -1;
				for(int i=0;i<maxbeacons;i++)
				{
					if(beacons[i].faction==faction && beacons[i].age > oldest)
					{
						oldest = beacons[i].age;
						j = i;
					}
				}
				if(j!=-1)
				{
					beacons[j].age = 0;
					beacons[j].x = x;
					beacons[j].y = y;
					beacons[j].faction = faction;
					beacons[j].life = maxlife;
					beacons[j].send = SEND;//20oct2021
				}
			}
			else
			{
				//place anywhere there is none...
				for(int i=0;i<maxbeacons;i++)
				{
					if(beacons[i].faction==-1)
					{
						beacons[i].age = 0;
						beacons[i].x = x;
						beacons[i].y = y;
						beacons[i].life = maxlife;
						beacons[i].faction = faction;
						beacons[i].send = SEND;//20oct2021
						break;
					}
				}
			}
			SEND = true;//20oct2021
		}
		
	}

	//21oct2021 new class
	class Research
	{
		//hardcoded research for the game.......
		public static int maxresearch = 450;

		public static int GUIPATH0 = 80501;
		public static int GUIPATH1 = 80502;
		public static int GUIPATH2 = 80503;
		public static string GUIPOPUPTEXT = "{Research Text}";
		
		public static int PATH0 = -1;
		public static int PATH1 = -1;
		public static int PATH2 = -1;
	
		public static int[] faction = new int[maxresearch];//0-5 at each index
		public static int[] path = new int[maxresearch];//0,1,2 at each index
		public static int[] rtype = new int[maxresearch];//0-5 at each index
		
		public static int RED = 0;
		public static int BLUE = 1;
		public static int UNDEAD = 2;
		public static int KNIGHTS = 3;
		public static int DARKELF = 4;
		public static int MUTANT = 5;
		
		public static int RESET = 0;
		
		//helpers...
		public static string SRED = "Red";
		public static string SBLUE = "Blue";
		public static string SUNDEAD = "Skeleton";
		public static string SKNIGHTS = "Realm";
		public static string SDARK = "Evil";
		public static string SMUTE = "Fiend";
		
		public static int DOUPDATE = 0;
		
		public static int CLEARED = 0;
		
		public static int[] initialturns = new int[maxresearch];//as below 
		public static int[] turnsleft = new int[maxresearch];//number of turns remaining to research this upgrade...
		public static int[] researching = new int[maxresearch];//0 or 1
		public static string[] text  = new string[maxresearch]; // # separated text string includes HEADER/NAME, Description, Effect
		public static int[] unitindex = new int[maxresearch]; //0-5
		public static int[] iconindex = new int[maxresearch];//0-15?
		public static int[] changed = new int[maxresearch];
		//

		public static bool IsResearching(int f)
		{
			for(int i=0;i<maxresearch;i++)
			{
				if(researching[i]==1 && faction[i]==f)
				{
					return true;
				}
			}
		
			return false;
		}
		
		public static void Ai()
		{
			//the AI selects research here......
			for(int i=0;i<Game.MaxArmies;i++)
			{
				if(i==Game.PlayerIndex)
				{
					continue;
				}
				int[] avail = ListResearchIndexes(i);
				if(avail!=null)
				{
					int count = 0;
					for(int j=0;j<avail.Length;j++)
					{
						if(avail[j]!=-1)
						{
							//should we research it?
							//we should be researching something...at all times....
							if(Functions.rand(0,1000)<250 * turnsleft[avail[j]]) // AI goes for the stuff with more turns remaining on them....
							{
								BeginResearch(i,avail[j]);
								count++;
							}
						}
					}
					if(count<=0)
					{
						for(int j=0;j<avail.Length;j++)
						{
							if(avail[j]!=-1)
							{
								BeginResearch(i,avail[j]);
								break;
							}
						}						
					}
				}
			}
			
			
			
		}
		
		public static void Enhance() //this is where the magic happens.....
		{
			for(int i=0;i<maxresearch;i++)
			{
				if(turnsleft[i]<=0)
				{
					if(unitindex[i]!=-1)
					{
						if(unitindex[i]>=0 && unitindex[i]<Game.templates.Length)
						{
							int t = unitindex[i];
							int f = faction[i];
							switch(path[i])
							{
								case 0: //offensive ability
									switch(rtype[i])
									{
										case 0:
											//Game.templates[t].damage++;//first level combat ability
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damage++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].walkspeed++;
											}
											if(f==DARKELF)
											{
												Game.templates[t].highfirerate++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage++;
											}
										break;
										case 1:
											//Game.templates[t].damage++;//second level combat ability
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damage+=2;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].regeneration+=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].damage++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage++;
											}
											
										break;
										case 2:
											//Game.templates[t].highfirerate++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damage+=3;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points+=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].frenzy+=3;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage+=3;
											}
										break;
										case 3:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].highfirerate++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].highfirerate++;
											}
											if(f==DARKELF)
											{
												Game.templates[t].damagex++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].walkspeed++;
											}
										break;
										case 4:
											//Game.templates[t].damagex++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damagex++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].damagex++;
											}
											if(f==DARKELF)
											{
												Game.templates[t].damage++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage+=2;
											}
										break;
									}
								break;
								case 1: //defensive ability
									switch(rtype[i])
									{
										case 0:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].armour++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].basehp+=25;
											}
											if(f==DARKELF)
											{
												Game.templates[t].armour+=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].regeneration+=5;
											}
										break;
										case 1:
											//Game.templates[t].basehp+=20;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].basehp+=25;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].armour+=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].basehp+=25;
											}
											if(f==MUTANT)
											{
												Game.templates[t].armour+=3;
											}
										break;
										case 2:
											//Game.templates[t].craftsman++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].armour+=2;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].craftsman++;
											}
											if(f==DARKELF)
											{
												Game.templates[t].dodge=4;
											}
											if(f==MUTANT)
											{
												Game.templates[t].basehp+=50;
											}
										break;
										case 3:
											//Game.templates[t].dodge = 4;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].dodge=4;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].armour++;
											}
											if(f==DARKELF)
											{
												Game.templates[t].armour++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].armour++;
											}
										break;
										case 4:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].armour++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].regeneration+=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].walkspeed++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].regeneration+=3;
											}
										break;
									}
								break;
								case 2: //unit economic ability
								switch(rtype[i])
									{
										case 0:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].points++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points+=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points++;
											}
										break;
										case 1:
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].hasleader++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points+=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points+=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points+=2;
											}
										break;
										case 2:
											//Game.templates[t].hasleader++;
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].brave++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].fearsome++;
											}
											if(f==DARKELF)
											{
												Game.templates[t].fearsome++;
											}
											if(f==MUTANT)
											{
												Game.templates[t].fearsome++;
											}
										break;
										case 3:
											//Game.templates[t].timid--;	
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].points+=2;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points+=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points+=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points+=2;
											}
										break;
										case 4:
											//Game.templates[t].brave++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].leader++;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points+=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points+=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points+=2;
											}
										break;
									}
								break;
							}
							/*
							switch(path[i])
							{
								case 0: //offensive ability
									switch(rtype[i])
									{
										case 0:
											Game.templates[t].damage++;//first level combat ability
										break;
										case 1:
											Game.templates[t].damage++;//second level combat ability
										break;
										case 2:
											Game.templates[t].highfirerate++;
										break;
										case 3:
											Game.templates[t].frenzy+=3;
										break;
										case 4:
											Game.templates[t].damagex++;
										break;
									}
								break;
								case 1: //defensive ability
									switch(rtype[i])
									{
										case 0:
											Game.templates[t].armour++;
										break;
										case 1:
											Game.templates[t].basehp+=20;
										break;
										case 2:
											Game.templates[t].craftsman++;
										break;
										case 3:
											Game.templates[t].dodge = 4;
										break;
										case 4:
											Game.templates[t].regeneration+=3;
											Game.templates[t].armour++;
										break;
									}
								break;
								case 2: //unit economic ability
								switch(rtype[i])
									{
										case 0:
											Game.templates[t].points++;
										break;
										case 1:
											Game.templates[t].points++;
										break;
										case 2:
											Game.templates[t].hasleader++;
										break;
										case 3:
											Game.templates[t].timid--;
											Game.templates[t].mob++;
										break;
										case 4:
											Game.templates[t].brave++;
										break;
									}
								break;
							}
							*/
						}
					}				
				}
			}
		}
		
		public static void Revert()
		{
			for(int i=0;i<maxresearch;i++)
			{
				if(turnsleft[i]<=0)
				{
					if(unitindex[i]!=-1)
					{
						if(unitindex[i]>=0 && unitindex[i]<Game.templates.Length)
						{
							int t = unitindex[i];
							int f = faction[i];
							switch(path[i])
							{
								case 0: //offensive ability
									switch(rtype[i])
									{
										case 0:
											//Game.templates[t].damage++;//first level combat ability
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damage--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].walkspeed--;
											}
											if(f==DARKELF)
											{
												Game.templates[t].highfirerate--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage--;
											}
										break;
										case 1:
											//Game.templates[t].damage++;//second level combat ability
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damage-=2;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].regeneration-=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].damage--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage--;
											}
											
										break;
										case 2:
											//Game.templates[t].highfirerate++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damage-=3;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points-=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].frenzy-=3;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage-=3;
											}
										break;
										case 3:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].highfirerate--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].highfirerate--;
											}
											if(f==DARKELF)
											{
												Game.templates[t].damagex--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].walkspeed--;
											}
										break;
										case 4:
											//Game.templates[t].damagex++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].damagex--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].damagex--;
											}
											if(f==DARKELF)
											{
												Game.templates[t].damage--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].damage-=2;
											}
										break;
									}
								break;
								case 1: //defensive ability
									switch(rtype[i])
									{
										case 0:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].armour--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].basehp-=25;
											}
											if(f==DARKELF)
											{
												Game.templates[t].armour-=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].regeneration-=5;
											}
										break;
										case 1:
											//Game.templates[t].basehp+=20;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].basehp-=25;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].armour-=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].basehp-=25;
											}
											if(f==MUTANT)
											{
												Game.templates[t].armour-=3;
											}
										break;
										case 2:
											//Game.templates[t].craftsman++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].armour-=2;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].craftsman--;
											}
											if(f==DARKELF)
											{
												Game.templates[t].dodge=0;
											}
											if(f==MUTANT)
											{
												Game.templates[t].basehp-=50;
											}
										break;
										case 3:
											//Game.templates[t].dodge = 4;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].dodge=0;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].armour--;
											}
											if(f==DARKELF)
											{
												Game.templates[t].armour--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].armour--;
											}
										break;
										case 4:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].armour--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].regeneration-=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].walkspeed--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].regeneration-=3;
											}
										break;
									}
								break;
								case 2: //unit economic ability
								switch(rtype[i])
									{
										case 0:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].points--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points-=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points--;
											}
										break;
										case 1:
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].hasleader--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points-=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points-=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points-=2;
											}
										break;
										case 2:
											//Game.templates[t].hasleader++;
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].brave--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].fearsome--;
											}
											if(f==DARKELF)
											{
												Game.templates[t].fearsome--;
											}
											if(f==MUTANT)
											{
												Game.templates[t].fearsome--;
											}
										break;
										case 3:
											//Game.templates[t].timid--;	
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].points-=2;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points-=2;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points-=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points-=2;
											}
										break;
										case 4:
											//Game.templates[t].brave++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												Game.templates[t].leader--;
											}
											if(f==UNDEAD)
											{
												Game.templates[t].points-=3;
											}
											if(f==DARKELF)
											{
												Game.templates[t].points-=2;
											}
											if(f==MUTANT)
											{
												Game.templates[t].points-=2;
											}
										break;
									}
								break;
							}
							/*
							switch(path[i])
							{
								case 0: //offensive ability
									switch(rtype[i])
									{
										case 0:
											Game.templates[t].damage--;//first level combat ability
										break;
										case 1:
											Game.templates[t].damage--;//second level combat ability
										break;
										case 2:
											Game.templates[t].highfirerate--;
										break;
										case 3:
											Game.templates[t].frenzy-=3;
										break;
										case 4:
											Game.templates[t].damagex--;
										break;
									}
								break;
								case 1: //defensive ability
									switch(rtype[i])
									{
										case 0:
											Game.templates[t].armour--;
										break;
										case 1:
											Game.templates[t].basehp-=20;
										break;
										case 2:
											Game.templates[t].craftsman--;
										break;
										case 3:
											Game.templates[t].dodge = 0;
										break;
										case 4:
											Game.templates[t].regeneration-=3;
											Game.templates[t].armour--;
										break;
									}
								break;
								case 2: //unit economic ability
								switch(rtype[i])
									{
										case 0:
											Game.templates[t].points--;
										break;
										case 1:
											Game.templates[t].points--;
										break;
										case 2:
											Game.templates[t].hasleader--;
										break;
										case 3:
											Game.templates[t].timid++;
											Game.templates[t].mob--;
										break;
										case 4:
											Game.templates[t].brave--;
										break;
									}
								break;
							}
							*/
						}
					}				
				}
			}
		}
		
		public static void SetItUp(int i)
		{
			///////////
			///////////
			//First Set The Template Index of The Research
			//////////
			int f = 0;
			int u = 0;
			for(int t=0;t<Game.templates.Length;t++)
			{
				f = -1;
				if(Game.templates[t].name!=null)
				{
					if(Game.templates[t].name.IndexOf(SRED)>=0)
					{
						f = 0;
					}
					if(Game.templates[t].name.IndexOf(SBLUE)>=0)
					{
						f = 1;
					}
					if(Game.templates[t].name.IndexOf(SUNDEAD)>=0)
					{
						f = 2;
					}
					if(Game.templates[t].name.IndexOf(SKNIGHTS)>=0)
					{
						f = 3;
					}
					if(Game.templates[t].name.IndexOf(SDARK)>=0)
					{
						f = 4;
					}
					if(Game.templates[t].name.IndexOf(SMUTE)>=0)
					{
						f = 5;
					}
					if(Game.templates[t].bossmonster<=0)
					{
						u++;
						u%=5;
					}
				}
				if(f>=0)
				{
					if(faction[i]==f)
					{
						if(unitindex[i]==u)
						{
							//yep we want this one.....
							unitindex[i] = t;//this game template.......
							switch(path[i])
							{
								case 0: //offensive ability
									switch(rtype[i])
									{
										case 0:
											//Game.templates[t].damage++;//first level combat ability
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Weapons#" + Game.templates[t].dname() + " gains +1 Damage.";
												iconindex[i] = 9;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//damage+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Unnatural Vigor#" + Game.templates[t].dname() + " gains +1 Speed";
												iconindex[i] = 3;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//walkspeed+1 up to 3
											}
											if(f==DARKELF)
											{
												text[i] = "#Martial Training#" + Game.templates[t].dname() + " gains +1 Attack Rate";
												iconindex[i] = 12;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//highfirerate+1
											}
											if(f==MUTANT)
											{
												text[i] = "#Dark Strength#" + Game.templates[t].dname() + " gains +1 Damage";
												iconindex[i] = 3;//icon for the image...
												//damage+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
											}
										break;
										case 1:
											//Game.templates[t].damage++;//second level combat ability
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Weapons#" + Game.templates[t].dname() + " gains +2 Damage.";
												iconindex[i] = 10;//icon for the image...
												//damage+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
											}
											if(f==UNDEAD)
											{
												text[i] = "#They Just Will Not Die#" + Game.templates[t].dname() + " gains +3 Regeneration";
												iconindex[i] = 4;//icon for the image...
												//regeneration+4
												initialturns[i] = 3;
												turnsleft[i] = 3;
											}
											if(f==DARKELF)
											{
												text[i] = "#Dark Blades#" + Game.templates[t].dname() + " gains +1 Damage";
												iconindex[i] = 9;//icon for the image...
												//damage + 1
												initialturns[i] = 1;
												turnsleft[i] = 1;
											}
											if(f==MUTANT)
											{
												text[i] = "#Dark Weapons#" + Game.templates[t].dname() + " gains +1 Damage";
												iconindex[i] = 9;//icon for the image...
												//damage+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
											}
											
										break;
										case 2:
											//Game.templates[t].highfirerate++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Weapons#" + Game.templates[t].dname() + " gains +3 Damage.";
												iconindex[i] = 11;//icon for the image...
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//damage+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Endless Hordes#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 5;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
											}
											if(f==DARKELF)
											{
												text[i] = "#Deadly Rage#" + Game.templates[t].dname() + " gains +3 Frenzy";
												iconindex[i] = 13;//icon for the image...
												//frenzy + 3
												initialturns[i] = 3;
												turnsleft[i] = 3;
											}
											if(f==MUTANT)
											{
												text[i] = "#Unnatural Strength#" + Game.templates[t].dname() + " gains +3 Damage";
												iconindex[i] = 14;//icon for the image...
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//damage+1
											}
										break;
										case 3:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Martial Training#" + Game.templates[t].dname() + " gains +1 Attack Speed.";
												iconindex[i] = 0;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//damage+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Unnatural Ability#" + Game.templates[t].dname() + " gains +1 Attack Speed";
												iconindex[i] = 3;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//highfirerate+1
											}
											if(f==DARKELF)
											{
												text[i] = "#Poison Weapons#" + Game.templates[t].dname() + " gains Armour Penetration";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
											}
											if(f==MUTANT)
											{
												text[i] = "#Unnatural Speed#" + Game.templates[t].dname() + " gains +1 Speed";
												iconindex[i] = 13;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//walkspeed + 1
											}
										break;
										case 4:
											//Game.templates[t].damagex++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Weapons Mastery#" + Game.templates[t].dname() + " gains Armour Penetration.";
												iconindex[i] = 0;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//damagex+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Soul Blades#" + Game.templates[t].dname() + " gains Armour Penetration.";
												iconindex[i] = 5;//icon for the image...
												//points + 2
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//damagex+1
											}
											if(f==DARKELF)
											{
												text[i] = "#Spiked Weapons#" + Game.templates[t].dname() + " gains +1 Damage";
												iconindex[i] = 13;//icon for the image...
												//damagex+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
											}
											if(f==MUTANT)
											{
												text[i] = "#Dark Weapons#" + Game.templates[t].dname() + " gains +2 Damage";
												iconindex[i] = 13;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//walkspeed + 1
											}
										break;
									}
								break;
								case 1: //defensive ability
									switch(rtype[i])
									{
										case 0:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Armour#" + Game.templates[t].dname() + " gains +1 Armour.";
												iconindex[i] = 6;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Unnatural Resilience#" + Game.templates[t].dname() + " gains +25 Health";
												iconindex[i] = 5;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Darkling Armour#" + Game.templates[t].dname() + " gains +2 Armour";
												iconindex[i] = 11;//icon for the image...
												//damagex+1
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Unnatural Healing#" + Game.templates[t].dname() + " gains +5 Regeneration";
												iconindex[i] = 14;//icon for the image...
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//walkspeed + 1
												//regeneration+5
											}
										break;
										case 1:
											//Game.templates[t].basehp+=20;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Fitness#" + Game.templates[t].dname() + " gains +25 Health";
												iconindex[i] = 2;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Tougher Bones#" + Game.templates[t].dname() + " gains +3 Armour";
												iconindex[i] = 4;//icon for the image...
												//points + 2
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Battle Hardened#" + Game.templates[t].dname() + " gains +25 Health";
												iconindex[i] = 14;//icon for the image...
												//damagex+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Iron Skin#" + Game.templates[t].dname() + " gains +3 Armour";
												iconindex[i] = 13;//icon for the image...
												initialturns[i] = 3;
												turnsleft[i] = 3;
												
												//armour+3
											}
										break;
										case 2:
											//Game.templates[t].craftsman++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Armour#" + Game.templates[t].dname() + " gains +2 Armour.";
												iconindex[i] = 7;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Unnatural Immunity#" + Game.templates[t].dname() + " gains Toughness";
												iconindex[i] = 4;//icon for the image...
												//points + 2
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//craftsman + 1
											}
											if(f==DARKELF)
											{
												text[i] = "#Lightning Reflexes#" + Game.templates[t].dname() + " gains Dodge";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Dark Vitality#" + Game.templates[t].dname() + " gains +50 Health";
												iconindex[i] = 14;//icon for the image...
												initialturns[i] = 3;
												turnsleft[i] = 3;
											}
										break;
										case 3:
											//Game.templates[t].dodge = 4;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Combat Reflexes#" + Game.templates[t].dname() + " gains Dodge.";
												iconindex[i] = 1;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Tougher Bones#" + Game.templates[t].dname() + " gains +1 Armour";
												iconindex[i] = 4;//icon for the image...
												//points + 2
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Dark Aura#" + Game.templates[t].dname() + " gains +1 Armour";
												iconindex[i] = 13;//icon for the image...
												//damagex+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Tougher Flesh#" + Game.templates[t].dname() + " gains +1 Armour";
												iconindex[i] = 13;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//walkspeed + 1
												//regeneration+5
											}
										break;
										case 4:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Extra Armour#" + Game.templates[t].dname() + " gains +1 Armour.";
												iconindex[i] = 7;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Magical Healing#" + Game.templates[t].dname() + " gains +3 Regeneration";
												iconindex[i] = 5;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Dark Speed#" + Game.templates[t].dname() + " gains +1 Speed";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Regeneration#" + Game.templates[t].dname() + " gains +3 Regeneration";
												iconindex[i] = 14;//icon for the image...
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//walkspeed + 1
												//regeneration+5
											}
										break;
									}
								break;
								case 2: //unit economic ability
								switch(rtype[i])
									{
										case 0:
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Economy#" + Game.templates[t].dname() + " Gains + 1 Units.";
												iconindex[i] = 2;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Endless Hordes#" + Game.templates[t].dname() + " gains +2 Units";
												iconindex[i] = 3;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Hordes#" + Game.templates[t].dname() + " gains +1 Units";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Massed Units#" + Game.templates[t].dname() + " gains +1 Units";
												iconindex[i] = 12;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//walkspeed + 1
												//regeneration+5
											}
										break;
										case 1:
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Leadership#" + Game.templates[t].dname() + " Gains Leaders.";
												iconindex[i] = 0;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Endless Hordes#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 3;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Strength in Numbers#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Massed Numbers#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 12;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//walkspeed + 1
												//regeneration+5
											}
										break;
										case 2:
											//Game.templates[t].hasleader++;
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Veteran Warriors#" + Game.templates[t].dname() + " Gains + 1 Bravery.";
												iconindex[i] = 2;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Greater Terror#" + Game.templates[t].dname() + " gains Fearsome";
												iconindex[i] = 3;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Horrifying Visage#" + Game.templates[t].dname() + " gains Fearsome";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#Hideous Shriek#" + Game.templates[t].dname() + " gains Fearsome";
												iconindex[i] = 12;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//walkspeed + 1
												//regeneration+5
											}
										break;
										case 3:
											//Game.templates[t].timid--;	
											//Game.templates[t].points++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Improved Economy#" + Game.templates[t].dname() + " Gains +2 Unit Size.";
												iconindex[i] = 1;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#More Hordes#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 3;//icon for the image...
												//points + 2
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#More and More#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#The Portal Opens#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 12;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//walkspeed + 1
												//regeneration+5
											}
										break;
										case 4:
											//Game.templates[t].brave++;
											if(f==RED || f==BLUE || f==KNIGHTS)
											{
												text[i] = "Elite Units#" + Game.templates[t].dname() + " Gains Leader Status.";
												iconindex[i] = 2;//icon for the image...
												initialturns[i] = 1;
												turnsleft[i] = 1;
												//armour+1
											}
											if(f==UNDEAD)
											{
												text[i] = "#Innumerable Hordes#" + Game.templates[t].dname() + " gains +3 Unit Size";
												iconindex[i] = 4;//icon for the image...
												//points + 2
												initialturns[i] = 3;
												turnsleft[i] = 3;
												//basehp+25
											}
											if(f==DARKELF)
											{
												text[i] = "#Endless Numbers#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 12;//icon for the image...
												//damagex+1
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//armour+2
											}
											if(f==MUTANT)
											{
												text[i] = "#So Many...#" + Game.templates[t].dname() + " gains +2 Unit Size";
												iconindex[i] = 12;//icon for the image...
												initialturns[i] = 2;
												turnsleft[i] = 2;
												//walkspeed + 1
												//regeneration+5
											}
										break;
									}
								break;
							}
						}
					}
				}
			}
			initialturns[i]+=2;
			turnsleft[i] = initialturns[i];
		}
		
		public static void Init()
		{
			int f = 0;
			int p = 0;
			int t = 0;
			int tl = 0;
			int u = 0;
			for(int i=0;i<maxresearch;i++)
			{
				//turnsleft[i] = initialturns[i];
				//researching[i] = 0;
				faction[i] = f;
				path[i] = p;//
				rtype[i] = t;//
				unitindex[i] = u; //ok
				u++;
				u%=5;
				tl = 1;
				if(i % 5==1 || i % 5 == 2)
				{
					tl = 2;
				}
				if(i % 5==3 || i % 5 == 4)
				{
					tl = 3;
				}
				initialturns[i] = tl;//ok
				turnsleft[i] = tl;//ok
				researching[i] = 0;	//ok
				iconindex[i] = -1;
				SetItUp(i);
				t++;
				t%=5;
				if(t==0)
				{
					p++;
					p%=3;
					if(p==0)
					{
						f++;
						f%=Game.MaxArmies;
					}
				}
				
				
			}
		}
		
		public static void Load()
		{
			Init();
		}		
		
		
		public static int[] ListResearchIndexes(int f)//ok
		{
			int count0 = 0;
			int count1 = 0;
			int count2 = 0;
			int g = -1;
			int j = -1;
			int k = -1;
			int m = -1;
			int n = -1;
			int p = -1;
			for(int i=0;i<maxresearch;i++)
			{
				if(faction[i]==f)
				{
					if(turnsleft[i]>0 && path[i]==0)
					{
						count0 = 1;
						if(g==-1)
						{
							g = i;
						}
					}
					if(turnsleft[i]>0 && path[i]==1)
					{
						count1 = 1;
						if(j==-1)
						{
							j = i;
						}
					}
					if(turnsleft[i]>0 && path[i]==2)
					{
						count2 = 1;
						if(k==-1)
						{
							k = i;
						}
					}
				}
			}
			for(int i=0;i<maxresearch;i++)
			{
				if(faction[i]==f)
				{
					if(turnsleft[i]<=0 && path[i]==0)
					{
						m = i;
					}
					if(turnsleft[i]<=0 && path[i]==1)
					{
						n = i;
					}
					if(turnsleft[i]<=0 && path[i]==2)
					{
						p = i;
					}
				}
			}
			
			if(count0 + count1 + count2 > 0)
			{
				int[] avail = new int[6];
				avail[0] = g;
				avail[1] = j;
				avail[2] = k;
				avail[3] = m;
				avail[4] = n;
				avail[5] = p;
				PATH0 = g;
				PATH1 = j;
				PATH2 = k;
				return avail;
				
			}
			int[] none = new int[6];
			none[0] = -1;
			none[1] = -1;
			none[2] = -1;
			none[3]=  m;
			none[4] = n;
			none[5] = p;
			PATH0 = -1;
			PATH1 = -1;
			PATH2 = -1;
			return none;
		}
				
		public static void BeginResearch(int f,int r)//ok
		{
			if(r==-1)
			{
				return;
			}
			for(int i=0;i<maxresearch;i++)
			{
				if(faction[i]==f)
				{
					if(researching[i]<2)
					{
						researching[i] = 0;
					}
				}
			}
			if(r>=0 && r<maxresearch)
			{
				researching[r] = 1;
				changed[r] = 1;
			}
			CLEARED = 0;
		}
		
		public static void UpdateResearch()//ok
		{
			//and save......
			if(DOUPDATE==0)
			{
				return;
			}
			for(int i=0;i<maxresearch;i++)
			{
				if(researching[i]==1)
				{
					turnsleft[i]--;
					if(turnsleft[i]<=0)
					{
						researching[i] = 2;
						changed[i] = 1;
						//if(faction[i]==Game.PlayerIndex)
						//{
							//Game.newtoast("Researched:"+text[i]);
						//}
					}
				}			
			}
			SaveResearchForCampaign();
			DOUPDATE = 0;
		}

		
		public static void ClearResearch()//ok
		{
			Init(); //reset to defaults.....
			RESET = 1;
			if(CLEARED==0)
			{
				for(int i=0;i<maxresearch;i++)
				{
					changed[i] = 1;
				}
				SaveResearchForCampaign();
			}
			CLEARED = 1;
		}
		
		public static void LoadResearchForCampaign()//ok
		{
			Init();
			if(RESET==0)
			{
				for(int i=0;i<maxresearch;i++)
				{
					try
					{
						//string data = LocalStorage.getitem("research_faction_"+i);
						//faction[i] = Resources.readint(data);
						//data = LocalStorage.getitem("research_path_"+i);
						//path[i] = Resources.readint(data);
						string data = LocalStorage.getitem("research_turns"+i);
						int rr = 0;
						if(data!="")
						{
							rr = 0;
							Int32.TryParse(data,out rr);
							turnsleft[i] = rr;
						}
						data = LocalStorage.getitem("research_researching"+i);
						if(data!="")
						{
							rr = 0;
							Int32.TryParse(data,out rr);
							researching[i] = rr;
						}
					}
					catch(Exception e)
					{
						Game.WriteDebug("Research Error:"+e.Message);
					}
				}	
			}			
		}
		
		public static void SaveResearchForCampaign()//ok
		{
			for(int i=0;i<maxresearch;i++)
			{
				if(changed[i]>0)
				{
					try
					{
						string data = ""+turnsleft[i];
						LocalStorage.setitem("research_turns"+i,data);
						data = ""+researching[i];
						LocalStorage.setitem("research_researching"+i,data);
						changed[i] = 0;
					}
					catch(Exception e)
					{
						Game.WriteDebug("Research Error:"+e.Message);
					}
				}
			}
		}
		
	}
	
}


///////////////////////////////////////////////////
//////////////////End of Program///////////////////

///////////////////////////////////////////////////
///////////////////////////////////////////////////
///////////////////////////////////////////////////
//////////////////Basic Code Tutorial Notes////////
/*
In this short section of comments I hope to describe the language features that are used in this program to highlight the fairly simple nature
of the concepts needed to put this game together and games like it in c#.

I have broken it down into the following sections.
1. Basic language features
2. C# Library functions that are slightly more complex.
3. SDL2 notes regarding the use of the c# wrapper in this program.

///////////////////////////////////////////////////
1. Basic Language Features

KOG2 uses the following core language features that are available in almost any programming language you can write
code in for desktop or mobile today.

Datatypes:
Integer, String, Floating Point Numbers

Arrays including simple access by element index and the slightly extended feature of being able to resize an array at runtime.

Loops:
For loops and while loops. Primarily for iterating through the many arrays in the program regarding for loops.

Conditionals:
if statements and switch statements

String functions and string parsing functions:
Extracting parts of strings (IndexOf) and also converting string text file data into relevant number types*

Classes including properties and methods.
In a sense the game could just as easily have been written in a procedural language that only uses struct or type
objects with globally accessible functions instead of object specific methods.

Static variables and methods.
Where either global constants or global variables are required I've used static variables.
I have not used ENUMs for constants out of habit, personal preference and flexibility - my constants are not truly constant sometimes.

///////////////////////////////////////////////////
2. C# Library Functions

The main c# library functions used a number of times throughout this program include:

Threading - when writing files to disk a simple second thread is started in which the file is written and then exited.

Reading and Writing basic text files - all game data files other than graphics and sound are in raw text format and use c#'s most simple
method for reading and writing text files into and out of a string array.

Cultural Library for converting text format floating point numbers into their appropriate floating point data type.  A bit of a gotcha moment
where on first release I had no idea that different users machines would read commas and full stops as entirely different meanings when reading decimal numbers from a text file. 

If you were to port this game to another language then these are the areas of code that would likely need to change the most.

///////////////////////////////////////////////////
3. SDL2 Notes

The graphics and sound engine I have written is simple enough that for most of the game there are 
very few calls to the SDL wrapper functions outside of a few key methods.

The majority of SDL2 Wrapper function calls occur in the render() method of the RenderList object and the audio methods.

It keeps the code quite simple by doing this.

However having an ability to read and understand what's going on in the SDL2 wrapper code files themselves will help
with any deeper modifications to the game that you may wish to make.

The window creation and initialisation routines is where many of the other raw calls to the SDL2 wrapper functions occur.


*/

